#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hjs $ $Date: 2000/09/18 23:35:35 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..

PRJNAME=api

TARGET=cssschedule
PACKAGE=com$/sun$/star$/schedule

# --- Settings -----------------------------------------------------
.INCLUDE :  $(PRJ)$/util$/makefile.pmk

# ------------------------------------------------------------------------

IDLFILES=\
	Duration.idl\
	ScheduleAccessRight.idl\
	ScheduleBusyState.idl\
	ScheduleConfiguration.idl\
	ScheduleConfigurations.idl\
	ScheduleController.idl\
	ScheduleCursor.idl\
	ScheduleCursorDescriptor.idl\
	ScheduleCursorType.idl\
	ScheduleDispatch.idl\
	ScheduleEvent.idl\
	ScheduleExportFilter.idl\
	ScheduleExportFilters.idl\
	ScheduleImportFilter.idl\
	ScheduleImportFilters.idl\
	ScheduleImportType.idl\
	ScheduleItem.idl\
	ScheduleItemMethod.idl\
	ScheduleItemReference.idl\
	ScheduleLink.idl\
	ScheduleLoader.idl\
	ScheduleManager.idl\
	ScheduleOwnerUidMode.idl\
	ScheduleParticipant.idl\
	ScheduleParticipantRole.idl\
	ScheduleParticipantState.idl\
	ScheduleProcessRecordEvent.idl\
	ScheduleProcessRecordType.idl\
	ScheduleProcessRecordVetoException.idl\
	SchedulePropertySet.idl\
	SchedulePropertySetList.idl\
	ScheduleProtocol.idl\
	ScheduleQuery.idl\
	ScheduleQueryOperator.idl\
	ScheduleQueryTerm.idl\
	ScheduleRecurrence.idl\
	ScheduleRecurrenceType.idl\
	ScheduleReference.idl\
	ScheduleReminder.idl\
	ScheduleReminderType.idl\
	ScheduleURLMapping.idl\
	ScheduleResource.idl\
	ScheduleResultSetChangedEvent.idl\
	ScheduleResultSetChangedEventType.idl\
	ScheduleSession.idl\
	ScheduleSortInfo.idl\
	ScheduleTask.idl\
	ScheduleTaskState.idl\
	ScheduleTimeZone.idl\
	ScheduleTimeZoneInfo.idl\
	ScheduleURLMapping.idl\
	ScheduleWeekDay.idl\
	XAssignable.idl\
	XCursorExport.idl\
	XCursorImport.idl\
	XIndexFactoryContainer.idl\
	XNameTranslator.idl\
	XScheduleBookmarkCursor.idl \
	XScheduleBusyTime.idl\
	XScheduleConfigurationsSupplier.idl\
	XScheduleConfigurationSupplier.idl\
	XScheduleCursor.idl\
	XScheduleCursorDescriptorFactory.idl\
	XScheduleCursorFactory.idl\
	XScheduleDefaultConfigurationUidSupplier.idl\
	XScheduleDirectCursor.idl\
	XScheduleExport.idl\
	XScheduleGrouping.idl\
	XScheduleImport.idl\
	XSchedulePrintContextSupplier.idl\
	XScheduleProcessRecordBroadcaster.idl\
	XScheduleProcessRecordListener.idl\
	XScheduleProtocolProvider.idl\
	XScheduleRecordSupplier.idl\
	XScheduleResultSetChangedBroadcaster.idl\
	XScheduleResultSetChangedListener.idl\
	XScheduleServersSupplier.idl\
	XScheduleSession.idl\
	XScheduleSessionFactory.idl\
	XScheduleSessionManager.idl\
	XScheduleSessionSupplier.idl\
	XScheduleUidAccess.idl\
	XScheduleUpdateCursor.idl \
	XScheduleWriteContainer.idl\
	XStringPropertyAccess.idl

# ------------------------------------------------------------------

.INCLUDE :  target.mk
.INCLUDE :  $(PRJ)$/util$/target.pmk
