/*************************************************************************
 *
 *  $RCSfile: chttpimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CHTTPIMP_CXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _TOOLS_INETDEF_HXX
#include <tools/inetdef.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX
#include <tools/inetmsg.hxx>
#endif
#ifndef _TOOLS_INETSTRM_HXX
#include <tools/inetstrm.hxx>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _WLDCRD_HXX
#include <tools/wldcrd.hxx>
#endif

#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _LCKBITEM_HXX
#include <svtools/lckbitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif
#ifndef _SVTOOLS_STRMADPT_HXX
#include <svtools/strmadpt.hxx>
#endif

#if (SUPD < 582)
#ifndef _SMART_COM_SUN_STAR_IO_XACTIVEDATASINK_HXX
#include <smart/com/sun/star/io/XActiveDataSink.hxx>
#endif
#else
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#endif /* SUPD */

#ifndef _INET_WRAPPER_HXX
#include <inet/wrapper.hxx>
#endif
#ifndef _INET_CONFIG_HXX
#include <inet/inetcfg.hxx>
#endif
#ifndef _INET_HTTPWRAP_HXX
#include <inet/httpwrap.hxx>
#endif
#ifndef _INETHTTP_HXX
#include <inet/inethttp.hxx>
#endif

#ifndef _CNTBASE_HXX
#include "cntbase.hxx"
#endif
#ifndef _CNTHTTPIMP_HXX
#include "chttpimp.hxx"
#endif
#ifndef _CNTHTTPDOG_HXX
#include "chttpdog.hxx"
#endif
#ifndef _CNTCOOK_HXX
#include "cntcook.hxx"
#endif
#ifndef _CNTINET_HXX
#include "cntinet.hxx"
#endif
#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTPOOL_HXX
#include "cntpool.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CNTVWITM_HXX
#include "cntvwitm.hxx"
#endif
#ifndef _DHDRITEM_HXX
#include "dhdritem.hxx"
#endif
#ifndef _CHAOS_INIMGR_HXX
#include <inimgr.hxx>
#endif
#ifndef _CHAOS_HTTPITEM_HXX
#include <httpitem.hxx>
#endif
#ifndef _CHAOS_STORITEM_HXX
#include <storitem.hxx>
#endif
#ifndef _CHAOS_STRMITEM_HXX
#include <strmitem.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#if (!(SUPD < 582))
using namespace com::sun::star::io;
using namespace com::sun::star::uno;
#endif /* SUPD */

#ifdef _USE_NAMESPACE
using namespace inet;
using namespace rtl;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

#ifdef _CHAOS_STORNODE_REF
SV_IMPL_REF(CntStorageNode);
#endif

CHTTPBOX_DIR_RANGES_IMPL(aBoxDirRanges_Impl);
CHTTPDOC_DIR_RANGES_IMPL(aDocDirRanges_Impl);

/*========================================================================
 *
 * CntHTTPRootNode_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPRootNode_Impl.
 */
CntHTTPRootNode_Impl::CntHTTPRootNode_Impl (CntNode *pParent)
	: m_pParent        (pParent),
	  m_pWatchDog      (new CntHTTPWatchDog),
	  m_pLock          (new NAMESPACE_VOS(OMutex)),
	  m_pWrapper       (NULL),
	  m_xConfig        (NULL),
	  m_aStartupTime   (Date(), Time()),
	  m_eConnMode      (CNT_CONN_MODE_ONLINE),
	  m_eVerifyMode    (CNTHTTP_VERIFY_ONCE),
	  m_nJobQueueLimit (CHTTPIMP_JOBQUEUE_MIN),
	  m_nSizeLimit     (CHTTPIMP_SIZELIMIT_DEFAULT),
	  m_bKeepExpired   (FALSE)
{
	m_aStartupTime.ConvertToUTC();
}

/*
 * ~CntHTTPRootNode_Impl.
 */
CntHTTPRootNode_Impl::~CntHTTPRootNode_Impl (void)
{
	delete m_pWatchDog;
	delete m_pLock;

	delete m_pWrapper;
	m_xConfig.unbind();
}

/*
 * GetBoxDirItemSet.
 */
CntStoreItemSet* CntHTTPRootNode_Impl::GetBoxDirItemSet (
	CntStorageNode *pBoxDir) const
{
	CntStoreItemSet *pBoxSet = NULL;
	if (pBoxDir)
	{
		pBoxSet = pBoxDir->openItemSet (
			aBoxDirRanges_Impl, S2U("HTTPBOXDATA"),
			STREAM_STD_READWRITE | STREAM_NOCREATE);
		if (pBoxSet == NULL)
		{
			// Mark new itemset hidden.
			UINT32 nAttrib = 0;
			pBoxDir->attrib (
				S2U("HTTPBOXDATA"),
				0, CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN,
				nAttrib);
			DBG_ASSERT(
				nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN,
				"GetBoxDirItemSet: Attrib() failed");

			// Open new itemset.
			pBoxSet = pBoxDir->openItemSet (
				aBoxDirRanges_Impl, S2U("HTTPBOXDATA"), STREAM_STD_READWRITE);
			DBG_ASSERT (pBoxSet, "GetBoxDirItemSet: OpenItemSet() failed");

			// Initialize new itemset.
			if (pBoxSet)
			{
				// Store default JobQueueLimit.
				const CntByteItem& rItem =
					((const CntByteItem&)
					 (pBoxSet->Get(WID_HTTP_CONNECTION_LIMIT)));
				pBoxSet->Put (rItem, rItem.Which());

				// Store default SizeLimit.
				pBoxSet->Put (CntUInt32Item (
					WID_SIZE_LIMIT, CHTTPIMP_SIZELIMIT_DEFAULT));

				// Store default KeepExired.
				pBoxSet->Put (CntBoolItem (
					WID_HTTP_KEEP_EXPIRED, FALSE));

				// Store default VerifyMode.
				pBoxSet->Put (CntHTTPVerifyModeItem (
					WID_HTTP_VERIFY_MODE, CNTHTTP_VERIFY_ONCE));

				// Store default NoCacheList.
				pBoxSet->Put (CntStringItem (
					WID_HTTP_NOCACHE_LIST, String()));
			}
		}
	}
	return pBoxSet;
}

/*
 * ShouldUseCache.
 */
BOOL CntHTTPRootNode_Impl::ShouldUseCache (
	const INetURLObject &rUrl, const INetHTTPMessage &rMsg) const
{
	// Check URL argument.
	INetProtocol eProto = rUrl.GetProtocol();
	if (eProto == INET_PROT_NOT_VALID)
		return FALSE;

	// Check EndPoint.
	String aEndPoint (rUrl.GetHost());
	if (aEndPoint.Len() == 0)
		return FALSE;

	// Check NoCacheList.
	if (m_aNoCacheList.Len())
	{
		// Setup EndPoint.
		USHORT nPort = rUrl.GetPort();
		if (nPort == 0)
		{
			if (eProto == INET_PROT_HTTPS)
				nPort = NAMESPACE_INET(eINET_HTTPS_PORT);
			else
				nPort = NAMESPACE_INET(eINET_HTTP_PORT);
		}
		aEndPoint += ':';
		aEndPoint += nPort;

		// Match NoCacheList.
		xub_StrLen i, n = m_aNoCacheList.GetTokenCount (';');
		for (i = 0; i < n; i++)
		{
			String aWildStr (m_aNoCacheList.GetToken (i, ';'));
			if (aWildStr.Search (':') == STRING_NOTFOUND)
				aWildStr.AppendAscii (":*");

			WildCard aWild (aWildStr);
			if (aWild.Matches (aEndPoint))
				return FALSE;
		}
	}

	// Check DocumentHeader.
	ULONG i, n = rMsg.GetHeaderCount();
	for (i = 0; i < n; i++)
	{
		String aName (rMsg.GetHeaderName(i));
		if (aName.CompareIgnoreCaseToAscii ("Cache-Control") == 0)
		{
			String aCacheControl (rMsg.GetHeaderValue(i));
			aCacheControl.EraseLeadingChars (' ');

			if (aCacheControl.CompareIgnoreCaseToAscii ("no-cache", 8) == 0)
				return FALSE;
			if (aCacheControl.CompareIgnoreCaseToAscii ("private", 7) == 0)
				return FALSE;

			continue;
		}

		if (aName.CompareIgnoreCaseToAscii ("Pragma") == 0)
		{
			String aPragma (rMsg.GetHeaderValue(i));
			aPragma.EraseLeadingChars (' ');

			if (aPragma.CompareIgnoreCaseToAscii ("no-cache", 8) == 0)
				return FALSE;

			continue;
		}
	}

	// Cacheable.
	return TRUE;
}

/*
 * SetConnMode.
 */
void CntHTTPRootNode_Impl::SetConnMode (CntConnMode eConnMode)
{
	if (m_eConnMode != eConnMode)
	{
		// Accept new connection mode.
		m_eConnMode = eConnMode;

		// Check for 'Session' begin.
		if (m_eConnMode == CNT_CONN_MODE_ONLINE)
		{
			// Starting a new 'Session'.
			DateTime aNow;
			aNow.ConvertToUTC();

			SetStartupTime (aNow);
			return;
		}

		// Check for 'Session' end.
		if ((m_eConnMode == CNT_CONN_MODE_OFFLINE) && (m_pWrapper != NULL))
		{
			DELETEZ (m_pWrapper);
			m_xConfig.unbind();
			return;
		}
	}
}

/*
 * Priority.
 */
USHORT CntHTTPRootNode_Impl::Priority (CntNodeJob *pJob)
{
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq->ISA (CntOpenModeItem))
		return ((const CntOpenModeItem*)pReq)->GetPriority();
	else
		return (USHORT)(-1);
}

/*
 * InsertJob.
 */
void CntHTTPRootNode_Impl::InsertJob (
	CntNodeJobList *pJobList, CntNodeJob *pJob, ULONG nIndex)
{
	ULONG nCount = pJobList->Count();
	if (nIndex < nCount)
	{
		for (USHORT nPrio = Priority(pJob); nIndex < nCount; nIndex++)
		{
			CntNodeJob *p = (CntNodeJob *)(pJobList->GetObject(nIndex));
			if (nPrio < Priority(p))
				break;
		}
	}
	pJobList->Insert (pJob, nIndex);
}

/*
 * MustEnqueueJob.
 * (EnqueueSequential).
 */
BOOL CntHTTPRootNode_Impl::MustEnqueueJob (
	CntNodeJobList *pJobList, CntNodeJob *pJob)
{
	for (ULONG i = pJobList->Count(); i > 0; i--)
	{
		CntNodeJob *p = (CntNodeJob *)(pJobList->GetObject(i - 1));
		if (p->GetSubject() == pJob->GetSubject())
		{
			InsertJob (pJobList, pJob, i);
			return TRUE;
		}
	}
	return FALSE;
}

/*
 * EnqueueJob.
 */
CntNodeJob* CntHTTPRootNode_Impl::EnqueueJob (
	CntNodeJobQueue *pJobQueue, CntNodeJob *pJob)
{
#ifdef DBG_UTIL_PRIVATE
	String aTrace ("ENQ: ");
	aTrace += ITEMSET_VALUE_STRING (pJob->GetSubject(), WID_REAL_URL);
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq->ISA(CntOpenModeItem))
	{
		aTrace += " (Prio: ";
		aTrace += ((const CntOpenModeItem*)pReq)->GetPriority();
		aTrace += ')';
	}
	_TRACE(aTrace);
#endif /* DBG_UTIL_PRIVATE */

	// Determine JobList count.
	ULONG n = pJobQueue->Count();
	while (n < CHTTPIMP_JOBQUEUE_MIN)
	{
		// Insert new JobList into JobQueue.
		pJobQueue->Insert (new CntNodeJobList, LIST_APPEND);
		n = pJobQueue->Count();
	}

	// Determine shortest JobList.
	ULONG i = 1;
	CntNodeJobList *pJobList =
		(CntNodeJobList *)(pJobQueue->GetObject(i++));

	if (MustEnqueueJob (pJobList, pJob))
		return NULL;

	while (i < n)
	{
		CntNodeJobList *pCurList =
			(CntNodeJobList *)(pJobQueue->GetObject(i++));

		if (MustEnqueueJob (pCurList, pJob))
			return NULL;

		if (pCurList->Count() < pJobList->Count())
			pJobList = pCurList;
	}

	if ((pJobList->Count() > 0) && (n < m_nJobQueueLimit))
	{
		// Insert new JobList into JobQueue.
		pJobList = new CntNodeJobList;
		pJobQueue->Insert (pJobList, LIST_APPEND);
	}

	// Insert Job into (shortest) JobList.
	InsertJob (pJobList, pJob, 1);
	if (pJobList->Count() == 1)
		return pJob;
	else
		return NULL;
}

/*
 * DequeueJob.
 */
CntNodeJob* CntHTTPRootNode_Impl::DequeueJob (
	CntNodeJobQueue *pJobQueue, CntNodeJob *pJob)
{
#ifdef DBG_UTIL_PRIVATE
	String aTrace ("DEQ: ");
	aTrace += ITEMSET_VALUE_STRING (pJob->GetSubject(), WID_REAL_URL);
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq->ISA(CntOpenModeItem))
	{
		aTrace += " (Prio: ";
		aTrace += ((const CntOpenModeItem*)pReq)->GetPriority();
		aTrace += ')';
	}
	_TRACE(aTrace);
#endif /* DBG_UTIL_PRIVATE */

	// Dequeue Job.
	CntNodeJobList *pJobList = NULL;

	ULONG i, n = pJobQueue->Count();
	for (i = 0; i < n; i++)
	{
		CntNodeJobList *pCurList =
			(CntNodeJobList *)(pJobQueue->GetObject(i));

		if (pCurList->Remove (pJob))
		{
			pJobList = pCurList;
			break;
		}
	}

	DBG_ASSERT (pJobList, "DequeueJob: Job not found");
	if (pJobList == NULL)
		return NULL;

	// Determine next pending Job.
	CntNodeJob *pNextJob = NULL;
	if (pJobList->Count() == 0)
	{
		// JobList empty. Check JobQueueLimit.
		if (pJobQueue->Count() <= m_nJobQueueLimit)
		{
			// Check for other pending job to insert.
			for (i = 1; i < n; i++)
			{
				CntNodeJobList *pCurList =
					(CntNodeJobList *)(pJobQueue->GetObject(i));
				if (pCurList->Count() > 1)
				{
					if (!(pCurList->GetObject(0)->GetSubject() ==
						  pCurList->GetObject(1)->GetSubject()    ))
					{
						pNextJob = pCurList->Remove(1);
						pJobList->Insert (pNextJob, LIST_APPEND);
						break;
					}
				}
			}
		}
		else
		{
			// Limit exceeded. Remove empty JobList.
			pJobList = pJobQueue->Remove (pJobList);
			DBG_ASSERT (pJobList, "DequeueJob: JobList not found");
			delete pJobList;
		}
	}
	else
	{
		// Obtain next pending Job.
		pNextJob = pJobList->GetObject(0);
	}

	// Determine highest priority pending job.
	if (pNextJob)
	{
		USHORT nNextPrio = Priority (pNextJob);

		n = pJobQueue->Count();
		for (i = 1; i < n; i++)
		{
			CntNodeJobList *pCurList =
				(CntNodeJobList *)(pJobQueue->GetObject(i));
			if ((pCurList != pJobList) && (pCurList->Count() > 1))
			{
				CntNodeJob *pCurJob = pCurList->GetObject(1);
				USHORT nCurPrio = Priority (pCurJob);
				if (nCurPrio < nNextPrio)
				{
					pCurList->Replace (pNextJob, 1UL);
					pJobList->Replace (pCurJob , 0UL);
					pNextJob  = pCurJob;
					nNextPrio = nCurPrio;
				}
			}
		}
	}

	// Check for no more pending Jobs.
	if ((pNextJob == NULL) && (m_pParent->JobCount() == 0))
	{
		// Activate WatchDog.
		m_pWatchDog->activate (
			pJob->GetCacheNode(), m_pLock,
			m_nSizeLimit, m_bKeepExpired);
	}

	// Return next pending Job.
	return pNextJob;
}

/*
 * GetConfig.
 */
sal_Bool CntHTTPRootNode_Impl::GetConfig (
	NAMESPACE_VOS(ORef)<INetConfig> &rxConfig)
{
	if (!m_xConfig.isValid())
	{
		NAMESPACE_INET(INetWrapper) *pWrapper;
		if (CNT_RNM()->getINetWrapper (pWrapper))
		{
			CntINetConfig::load (pWrapper, CNT_RNM()->GetIniManager());

			pWrapper->getINetConfig (m_xConfig);
			DBG_ASSERT (m_xConfig.isValid(), "getINetConfig() failed");

			if (m_pWrapper == NULL)
			{
				pWrapper->newINetHTTPWrapper (m_pWrapper);
				DBG_ASSERT (m_pWrapper, "newINetHTTPWrapper() failed");
			}
		}
	}
	rxConfig = m_xConfig;
	return rxConfig.isValid();
}

/*
 * GetWrapper.
 */
sal_Bool CntHTTPRootNode_Impl::GetWrapper (
	NAMESPACE_INET(INetHTTPWrapper) *&rpWrapper)
{
	if (m_pWrapper == NULL)
	{
		NAMESPACE_INET(INetWrapper) *pWrapper;
		if (CNT_RNM()->getINetWrapper (pWrapper))
		{
			pWrapper->newINetHTTPWrapper (m_pWrapper);
			DBG_ASSERT (m_pWrapper, "newINetHTTPWrapper() failed");

			if (!m_xConfig.isValid())
			{
				CntINetConfig::load (pWrapper, CNT_RNM()->GetIniManager());

				pWrapper->getINetConfig (m_xConfig);
				DBG_ASSERT (m_xConfig.isValid(), "getINetConfig() failed");
			}
		}
	}
	rpWrapper = m_pWrapper;
	return (!!rpWrapper);
}

/*
 * GetCookie.
 */
String CntHTTPRootNode_Impl::GetCookie (
	const INetURLObject &rURL,
	CntNodeJob          *pJob)
{
	CntHTTPCookieManagerRef xManager (ITEMSET_VALUE(
		m_pParent, CntHTTPCookieManagerItem, WID_HTTP_COOKIE_MANAGER));
	String aCookieField;

	if (xManager.Is())
	{
		CntHTTPJobCookiePolicy_Impl aCookiePolicy (pJob);
		List                        aCookieList;

		xManager->getCookie (
			aCookiePolicy, rURL.GetMainURL(), aCookieList);

		for (ULONG i = 0; i < aCookieList.Count(); i++)
		{
			CntHTTPCookie *pCookie =
				(CntHTTPCookie *)aCookieList.GetObject(i);

			if (aCookieField.Len())
				aCookieField.AppendAscii ("; ");

			if (pCookie->m_aName.Len())
			{
				aCookieField += pCookie->m_aName;
				aCookieField += sal_Unicode('=');
			}
			aCookieField += pCookie->m_aValue;
		}
	}
	return aCookieField;
}

/*
 * SetCookie.
 */
void CntHTTPRootNode_Impl::SetCookie (
	const INetURLObject &rURL,
	const INetMessage   &rMsg,
	CntNodeJob          *pJob)
{
	CntHTTPCookieManagerRef xManager (ITEMSET_VALUE(
		m_pParent, CntHTTPCookieManagerItem, WID_HTTP_COOKIE_MANAGER));
	if (!xManager.Is())
		return;

	USHORT nGeneralPolicy = xManager->getGeneralPolicy();
	if ((nGeneralPolicy & CNTHTTP_COOKIE_POLICY_BANNED) > 0)
		return;

	INetMessageHeaderIterator aCookieIter (rMsg, S2U("Set-Cookie"));
	if (!aCookieIter.GetValueCount())
		return;

	List aCookieList;
	for (ULONG i = 0; i < aCookieIter.GetValueCount(); i++)
	{
		CntHTTPCookie *pCookie = new CntHTTPCookie;
		pCookie->m_nPolicy = nGeneralPolicy;

		if (SetCookie (rURL, aCookieIter.GetValue(i), *pCookie))
			aCookieList.Insert (pCookie, LIST_APPEND);
		else
			delete pCookie;
	}

	if (aCookieList.Count())
	{
		CntHTTPJobCookiePolicy_Impl aCookiePolicy (pJob);
		xManager->setCookie (aCookiePolicy, rURL.GetMainURL(), aCookieList);

		CntHTTPCookieManagerItem aItem (WID_HTTP_COOKIE_MANAGER, xManager);
		m_pParent->Put (aItem, aItem.Which());

		String aCacheUrl (S2U (STG_PROTOCOL_CACHE));
		aCacheUrl.AppendAscii (CNTHTTP_ROOT_URL);

		CntStorageNode *pCache =
			(CntStorageNode *)(CNT_RNM()->Query (aCacheUrl, FALSE));
		if (pCache)
		{
			NAMESPACE_VOS(OGuard) aGuard (m_pLock);
			CntStoreItemSetRef xBoxSet (GetBoxDirItemSet (pCache));
			if (xBoxSet.Is())
				xBoxSet->Put (aItem, aItem.Which());
		}
	}
}

/*
 * SetCookie.
 */
BOOL CntHTTPRootNode_Impl::SetCookie (
	const INetURLObject &rURL,
	const String        &rCookieField,
	CntHTTPCookie       &rCookie)
{
	/*
	 * Reference: http://home.netscape.com/newsref/std/cookie_spec.html
	 * Syntax:    NAME=VALUE; expires=DATE; path=PATH; domain=DOMAIN; secure
	 */
	xub_StrLen i, n = rCookieField.GetTokenCount (';');
	for (i = 0; i < n; i++)
	{
		String aToken (rCookieField.GetToken (i, ';'));
		aToken.EraseLeadingChars (' ');
		aToken.EraseTrailingChars (' ');

		if (aToken.Len())
		{
			if (aToken.CompareIgnoreCaseToAscii ("domain=", 7) == 0)
			{
				String aDomain (aToken.GetToken (1, '='));
				xub_StrLen nDots = aDomain.GetTokenCount ('.') - 1;
				if (nDots < 2)
				{
					// Toplevel domain (e.g. '.com').
					return FALSE;
				}

				String aWildStr (sal_Unicode('*'));
				aWildStr += aDomain;

				WildCard aWild (aWildStr);
				if (!aWild.Matches (rURL.GetHost()))
					return FALSE;

				rCookie.m_aDomain = aDomain;
			}
			else if (aToken.CompareIgnoreCaseToAscii ("path=", 5) == 0)
			{
				rCookie.m_aPath = aToken.GetToken (1, '=');
			}
			else if (aToken.CompareIgnoreCaseToAscii ("expires=", 8) == 0)
			{
				String aExpires (aToken.GetToken (1, '='));
				INetRFC822Message::ParseDateField (
					aExpires, rCookie.m_aExpires);
			}
			else if (aToken.CompareIgnoreCaseToAscii ("secure", 6) == 0)
			{
				rCookie.m_nFlags |= CNTHTTP_COOKIE_FLAG_SECURE;
			}
			else
			{
				// [NAME=]VALUE.
				xub_StrLen k = aToken.Search ('=');
				if (k == STRING_NOTFOUND)
				{
					rCookie.m_aName.Erase();
					rCookie.m_aValue = aToken;
				}
				else
				{
					rCookie.m_aName  = aToken.Copy (0, k);
					rCookie.m_aValue = aToken.Copy (k + 1);
				}
			}
		}
	}

	if ((rCookie.m_aName.Len() == 0) && (rCookie.m_aValue.Len() == 0))
	{
		// NAME and VALUE must not be empty, both.
		return FALSE;
	}

	if (rCookie.m_aDomain.Len() == 0)
	{
		// Domain == Host.
		rCookie.m_aDomain = rURL.GetHost();
	}

	if (rCookie.m_aPath.Len() == 0)
	{
		/*
		 * Rule (from: cookie_spec.html):
		 *   If the path is not specified, it is assumed to be
		 *   the same path as the document being described by
		 *   the header which contains the cookie.
		 *
		 * Interpretation (MHU):
		 *   rURL.GetURLPath().
		 *
		 * Interpretation (other):
		 *   see below.
		 */
		INetURLObject aURL (rURL);
		aURL.CutLastName(); // Interpretation (other).

		rCookie.m_aPath = aURL.GetURLPath();
	}

	// Done.
	return TRUE;
}

/*========================================================================
 *
 * CntHTTPJobCookiePolicy_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPJobCookiePolicy_Impl.
 */
CntHTTPJobCookiePolicy_Impl::CntHTTPJobCookiePolicy_Impl (CntNodeJob *pJob)
	: m_xJob (pJob)
{
}

/*
 * ~CntHTTPJobCookiePolicy_Impl.
 */
CntHTTPJobCookiePolicy_Impl::~CntHTTPJobCookiePolicy_Impl (void)
{
	m_xJob.Clear();
}

/*
 * shouldAcceptCookie.
 */
BOOL CntHTTPJobCookiePolicy_Impl::shouldAcceptCookie (
	const String &rUrl,
	List         &rCookieList)
{
	if (rUrl.Len() && rCookieList.Count())
	{
		CntHTTPCookieRequest aCookieRequest (
			rUrl, rCookieList, CNTHTTP_COOKIE_REQUEST_RECV);

		CNT_RNM()->HandleError (
			ERRCODE_CHAOS_HTTP_COOKIE_REQUEST, m_xJob, NULL, &aCookieRequest);

		if (aCookieRequest.m_nRet != CNTHTTP_COOKIE_POLICY_ACCEPTED)
		{
			for (ULONG i = 0; i < rCookieList.Count(); i++)
			{
				CntHTTPCookie *pCookie =
					(CntHTTPCookie *)rCookieList.GetObject(i);
				if (pCookie->m_nPolicy != CNTHTTP_COOKIE_POLICY_INTERACTIVE)
					return TRUE;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*
 * shouldUseCookie.
 */
BOOL CntHTTPJobCookiePolicy_Impl::shouldUseCookie (
	const String &rUrl,
	List         &rCookieList)
{
	if (rUrl.Len() && rCookieList.Count())
	{
		CntHTTPCookieRequest aCookieRequest (
			rUrl, rCookieList, CNTHTTP_COOKIE_REQUEST_SEND);

		CNT_RNM()->HandleError (
			ERRCODE_CHAOS_HTTP_COOKIE_REQUEST, m_xJob, NULL, &aCookieRequest);

#if 0   /* EXP */
		ULONG i, n = rCookieList.Count();
		for (i = 0; i < n; i++)
		{
			CntHTTPCookie *pCookie =
				(CntHTTPCookie*)rCookieList.GetObject(i);
			if (!(pCookie->m_nPolicy == CNTHTTP_COOKIE_POLICY_INTERACTIVE))
			{
			}
		}
#endif  /* EXP */

		return (aCookieRequest.m_nRet == CNTHTTP_COOKIE_POLICY_ACCEPTED);
	}
	return TRUE;
}

/*========================================================================
 *
 * CntHTTPJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPJob_Impl.
 */
CntHTTPJob_Impl::CntHTTPJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: SfxListener (),
	  m_xJob      (pJob),
	  m_pParent   (pParent)
{
	if (m_xJob.Is())
	{
		AddRef();
		m_xJob->SetRequestData (this);
		StartListening (*m_xJob);
	}
}

/*
 * ~CntHTTPJob_Impl.
 */
CntHTTPJob_Impl::~CntHTTPJob_Impl (void)
{
	if (m_xJob.Is())
	{
		EndListening (*m_xJob);
		m_xJob->SetRequestData (NULL);
		m_xJob = NULL;
	}
}

/*
 * Broadcast.
 */
void CntHTTPJob_Impl::Broadcast (const SfxHint& rHint)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Broadcast (rHint);
	}
}

/*
 * Result.
 */
void CntHTTPJob_Impl::Result (CntNode *pResult, CntAction eAction)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Result (pResult, eAction);
	}
}

/*
 * Notify.
 */
void CntHTTPJob_Impl::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xJob))
	{
		if (m_xJob->IsCancelled() || m_xJob->IsDone())
		{
			// Our job is finished here.
			EndListening (*m_xJob);

			// Release ctor reference.
			ReleaseRef(); /* delete this; */
		}
	}
}

/*========================================================================
 *
 * CntHTTPRequestJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPRequestJob_Impl.
 */
CntHTTPRequestJob_Impl::CntHTTPRequestJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPJob_Impl (pJob, pParent),
	  m_xRequest      (NULL),
	  m_pReqMsg       (NULL),
	  m_pResMsg       (NULL),
	  m_eState        (STATE_NONE),
	  m_nHintId       (0)
{
}

/*
 * ~CntHTTPRequestJob_Impl.
 */
CntHTTPRequestJob_Impl::~CntHTTPRequestJob_Impl (void)
{
	m_xRequest.unbind();
	delete m_pReqMsg;
	delete m_pResMsg;
}

/*
 * setRequestURL.
 */
void CntHTTPRequestJob_Impl::setRequestURL (void)
{
	CntNodeRef xDocNode (GetJob()->GetSubject());
	if (xDocNode.Is())
	{
		m_aReqURL.SetURL (ITEMSET_VALUE_STRING (xDocNode, WID_REAL_URL));
		if (m_aReqURL.HasUserData())
		{
			xDocNode->Put (CntStringItem (
				WID_USERNAME, m_aReqURL.GetUser()));
			xDocNode->Put (CntStringItem (
				WID_PASSWORD, m_aReqURL.GetPass()));

			m_aReqURL.SetUserAndPass (String(), String());
		}
		m_aReqURI = m_aReqURL.GetMainURL();
	}
}

/*
 * setRedirectURL.
 */
void CntHTTPRequestJob_Impl::setRedirectURL (const String &rLocation)
{
	CntNodeRef xDocNode (GetJob()->GetSubject());
	if (xDocNode.Is())
	{
		// Construct new OwnURL.
		INetURLObject aLocURL;
		m_aReqURL.GetNewAbsURL (rLocation, &aLocURL);

		String aOwnUrl (S2U (CNTHTTP_ROOT_URL));
		aOwnUrl += sal_Unicode('#');
		aOwnUrl += aLocURL.GetMainURL();

		// Re-initialize document node.
		xDocNode->Put (CntStringItem (WID_OWN_URL, aOwnUrl));
		xDocNode->Initialize (xDocNode->GetParent(), aOwnUrl);

		// Re-initialize Request URI.
		setRequestURL();
	}
}

/*
 * prepareRequest.
 */
BOOL CntHTTPRequestJob_Impl::prepareRequest (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg) const
{
	// Host.
	String aHost (rReqUrl.GetHost());
	if (rReqUrl.HasPort())
	{
		USHORT nPort = rReqUrl.GetPort();
		if (nPort != NAMESPACE_INET(eINET_HTTP_PORT))
		{
			aHost += sal_Unicode(':');
			aHost += UniString::CreateFromInt32 (sal_Int32(nPort));
		}
	}
	rReqMsg.SetHost (aHost);

	// From.
	CntIniManager *pIniMgr = CNT_RNM()->GetIniManager();
	if (pIniMgr)
	{
		String aReveal (pIniMgr->getEntry (CNT_KEY_INET_REVEAL_MAILADDR));
		if (aReveal.ToInt32() > 0)
		{
			String aFrom (pIniMgr->getEntry (CNT_KEY_ADDRESS_EMAIL));
			if (aFrom.Len())
				rReqMsg.SetFrom (aFrom);
		}
	}

	// Referer.
	CntInterface *pClient = GetJob()->GetClient();
	if (pClient)
	{
		String aReferer (ITEMSET_VALUE_STRING (pClient, WID_HTTP_REFERER));
		if (aReferer.Len())
			rReqMsg.SetReferer (aReferer);
	}

	// UserAgent.
	NAMESPACE_VOS(ORef)<INetConfig> xConfig;
	if (GetParent()->GetConfig (xConfig))
	{
		rReqMsg.SetUserAgent (xConfig->getUserAgent());
		xConfig.unbind();
	}

	// Done.
	return TRUE;
}

/*
 * prepareResponse.
 */
BOOL CntHTTPRequestJob_Impl::prepareResponse (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg,
	INetHTTPMessage     &rResMsg) const
{
	// Authorization.
	CntNodeRef xDocNode (GetJob()->GetSubject());
	if (xDocNode.Is())
	{
		String aUsername (ITEMSET_VALUE_STRING (xDocNode, WID_USERNAME));
		String aPassword (ITEMSET_VALUE_STRING (xDocNode, WID_PASSWORD));

		if (aUsername.Len())
		{
			String aCredential;
			if (SetBasicAuthentication (aUsername, aPassword, aCredential))
				rReqMsg.SetAuthorization (aCredential);
		}
		else
		{
			String aDocUrl (OWN_URL (xDocNode));
			if (CNT_RNM()->GetLoginInfo (aDocUrl, aUsername, aPassword))
			{
				String aCredential;
				if (SetBasicAuthentication (aUsername, aPassword, aCredential))
					rReqMsg.SetAuthorization (aCredential);
			}
		}
		xDocNode.Clear();
	}

	// Cookie.
	String aCookieField (GetParent()->GetCookie (rReqUrl, GetJob()));
	if (GetJob()->IsCancelled() || GetJob()->IsDone())
		return FALSE;
	if (aCookieField.Len())
		rReqMsg.SetCookie (aCookieField);

	// Check and apply any ProxyPolicy and Authorization.
	ApplyProxyAuthorization (rReqUrl, rReqMsg);

	// Done.
	return TRUE;
}

/*
 * GetDocumentHeader.
 */
BOOL CntHTTPRequestJob_Impl::GetDocumentHeader (
	const String    &rReqURI,
	CntStorageNode  &rCache,
	CntDocHeaderRef &rxDocHdr) const
{
	// Obtain DocumentHead itemset.
	String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aHeadURL += rReqURI;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

	UINT32 nAttrib = 0;
	if (!(rCache.attrib (aHeadName, 0, 0, nAttrib) == ERRCODE_NONE))
		return FALSE;
	if (CHTTPIMP_IS_INVALID(nAttrib))
		return FALSE;

	CntStoreItemSetRef xDirSet (rCache.openItemSet (
		aDocDirRanges_Impl, aHeadName, STREAM_STD_READ));
	if (!xDirSet.Is())
		return FALSE;

	rxDocHdr = ITEMSET_VALUE(xDirSet, CntDocHeaderItem, WID_DOCUMENT_HEADER);
	return (rxDocHdr.Is());
}

/*
 * InvalidateDocument.
 */
BOOL CntHTTPRequestJob_Impl::InvalidateDocument (
	CntStorageNode& rCache, const String& rURL) const
{
	String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aHeadURL += rURL;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

	UINT32 nAttrib = 0;
	rCache.attrib (
		aHeadName,
		CNTDIRENTRY_ATTRIB_MARKED,
		CNTDIRENTRY_ATTRIB_MARKEDFORDELETE,
		nAttrib);
	return ((nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE) > 0);
}

/*
 * RenameDocument.
 */
void CntHTTPRequestJob_Impl::RenameDocument (
	CntStorageNode& rCache,
	const String&   rOldURL,
	const String&   rNewURL) const
{
	String aOldURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aOldURL += rOldURL;
	String aOldName (CHTTPIMP_SHORT_NAME(aOldURL));

	UINT32 nAttrib = 0;
	rCache.attrib (aOldName, 0, 0, nAttrib);
	if (nAttrib & CNTDIRENTRY_ATTRIB_MARKED)
		return;

	String aNewURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aNewURL += rNewURL;
	String aNewName (CHTTPIMP_SHORT_NAME(aNewURL));

	ErrCode eErrCode = rCache.rename (aOldName, aNewName);
	if (eErrCode == ERRCODE_IO_ALREADYEXISTS)
	{
		eErrCode = rCache.remove (aNewName);
		if (eErrCode != ERRCODE_NONE)
			return;

		eErrCode = rCache.rename (aOldName, aNewName);
	}
	if (eErrCode != ERRCODE_NONE)
		return;

	aOldURL.AssignAscii (CHTTPIMP_DOCUMENT_BODY_PREFIX);
	aOldURL += rOldURL;
	aOldName = CHTTPIMP_SHORT_NAME(aOldURL);

	aNewURL.AssignAscii (CHTTPIMP_DOCUMENT_BODY_PREFIX);
	aNewURL += rNewURL;
	aNewName = CHTTPIMP_SHORT_NAME(aNewURL);

	eErrCode = rCache.rename (aOldName, aNewName);
	if (eErrCode == ERRCODE_IO_ALREADYEXISTS)
	{
		eErrCode = rCache.remove (aNewName);
		if (eErrCode != ERRCODE_NONE)
			return;

		eErrCode = rCache.rename (aOldName, aNewName);
	}
}

/*
 * ReplaceDocument.
 */
void CntHTTPRequestJob_Impl::ReplaceDocument (
	CntStorageNode& rCache, const String& rDocUrl) const
{
	// Acquire cache access.
	NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

	// Check for already existing document.
	String aHeadUrl (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aHeadUrl += rDocUrl;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadUrl));

	UINT32  nAttrib  = 0;
	ErrCode eErrCode = rCache.attrib (aHeadName, 0, 0, nAttrib);
	if (eErrCode == ERRCODE_NONE)
	{
		// Move current document out of way.
		String aObsUrl (S2U (CHTTPIMP_OBSOLETE_PREFIX));
		aObsUrl += rDocUrl;

		InvalidateDocument (rCache, rDocUrl);
		RenameDocument (rCache, rDocUrl, aObsUrl);
		InvalidateDocument (rCache, aObsUrl);
	}

	// Rename response document.
	String aResUrl (S2U (CHTTPIMP_RESPONSE_PREFIX));
	aResUrl += rDocUrl;

	RenameDocument (rCache, aResUrl, rDocUrl);

	if (nAttrib)
	{
		// Restore document attributes.
		rCache.attrib (aHeadName, 0, nAttrib);
	}
}

/*
 * ApplyProxyAuthorization.
 */
void CntHTTPRequestJob_Impl::ApplyProxyAuthorization (
	const INetURLObject &rURL, INetHTTPMessage &rReqMsg) const
{
	// Obtain ProxyPolicy.
	NAMESPACE_VOS(ORef)<INetConfig> xConfig;
	if (!GetParent()->GetConfig (xConfig))
		return;

	NAMESPACE_VOS(ORef)<INetProxyPolicy>
		xProxyPolicy (xConfig->getProxyPolicy());
	if (!xProxyPolicy.isValid())
		return;

	// Query ProxyPolicy for applicable ProxyConfig.
	INetProxyConfig aProxyConfig;
	if (!xProxyPolicy->shouldUseProxy (rURL.GetMainURL(), aProxyConfig))
		return;

	// Obtain Proxy EndPoint.
	String aHost;
	USHORT nPort;

	switch (rURL.GetProtocol())
	{
		case INET_PROT_FTP:
			if (aProxyConfig.hasFtpProxy())
			{
				aHost = aProxyConfig.getFtpProxyName();
				nPort = aProxyConfig.getFtpProxyPort();
			}
			break;

		case INET_PROT_HTTP:
			if (aProxyConfig.hasHttpProxy())
			{
				aHost = aProxyConfig.getHttpProxyName();
				nPort = aProxyConfig.getHttpProxyPort();
			}
			break;

		case INET_PROT_HTTPS:
			if (aProxyConfig.hasSecureSocketProxy())
			{
				aHost = aProxyConfig.getSecureSocketProxyName();
				nPort = aProxyConfig.getSecureSocketProxyPort();
			}
			break;

		default:
			break;
	}

	// Check Proxy EndPoint.
	if (nPort == 0)
		nPort = eINET_HTTP_PORT;

	if (aHost.Len())
	{
		// Assemble Proxy URL.
		String aProxyUrl (S2U (CNTHTTP_ROOT_URL));
		aProxyUrl.AppendAscii ("#proxy://");
		aProxyUrl += aHost;
		aProxyUrl += ':';
		aProxyUrl += UniString::CreateFromInt32 (sal_Int32 (nPort));

		// Query for applicable ProxyAuthorization.
		String aUsername, aPassword;
		if (CNT_RNM()->GetLoginInfo (aProxyUrl, aUsername, aPassword))
		{
			// Apply ProxyAuthorization.
			String aCredential;
			if (SetBasicAuthentication (aUsername, aPassword, aCredential))
				rReqMsg.SetProxyAuthorization (aCredential);
		}
	}
}

/*
 * GetBasicAuthentication.
 */
BOOL CntHTTPRequestJob_Impl::GetBasicAuthentication (
	const String& rChallenge,
	String&       rRealm) const
{
	// Check arguments.
	rRealm.Erase();
	if (rChallenge.Len() == 0)
		return FALSE;

	// Check for 'Basic' authentication scheme.
	String aLower (rChallenge);
	aLower.ToLowerAscii();
	xub_StrLen nPos = aLower.SearchAscii ("basic realm=\"");
	if (nPos == STRING_NOTFOUND)
		return FALSE;

	// Extract Realm.
	rRealm = rChallenge.Copy (nPos + 13);
	rRealm.Erase (rRealm.Search ('"'));
	if (rRealm.Len() == 0)
		rRealm.Assign (sal_Unicode(' '));
	return TRUE;
}

/*
 * SetBasicAuthentication.
 */
BOOL CntHTTPRequestJob_Impl::SetBasicAuthentication (
	const String& rUsername,
	const String& rPassword,
	String&       rCredential) const
{
	// Check arguments.
	rCredential.Erase();

	rtl_TextEncoding eEncoding = gsl_getSystemTextEncoding();
	ByteString aUsername (rUsername, eEncoding);
	if (aUsername.Len() == 0)
		return FALSE;

	ByteString aPassword (rPassword, eEncoding);

	// Base64 encode Username and Password.
	xub_StrLen nClearLen = aUsername.Len() + 1 + aPassword.Len();
	SvMemoryStream aClearStrm (nClearLen);

	aClearStrm << (const sal_Char*)(aUsername.GetBuffer());
	aClearStrm << (sal_Char)(':');
	aClearStrm << (const sal_Char*)(aPassword.GetBuffer());
	aClearStrm.Seek (STREAM_SEEK_TO_BEGIN);

	xub_StrLen nCipherLen = ((nClearLen + 2) / 3) * 4;
	SvMemoryStream aCipherStrm (nCipherLen + 2);

	INetIStream::Encode64 (aClearStrm, aCipherStrm);
	aCipherStrm.Seek (STREAM_SEEK_TO_BEGIN);

	// Setup Credential.
	rCredential.AssignAscii ("Basic ");
	rCredential.AppendAscii (
		(const sal_Char*)(aCipherStrm.GetData()), nCipherLen);

	// Done.
	return TRUE;
}

/*
 * ExecuteCallback.
 */
sal_Bool CntHTTPRequestJob_Impl::ExecuteCallback (
	NAMESPACE_INET(INetHTTPRequest) *pRequest,
	sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData)
{
	// Check context.
	CntHTTPRequestJob_Impl *pThis = (CntHTTPRequestJob_Impl *)pData;
	DBG_ASSERT(
		pThis, "CntHTTPRequestJob_Impl::ExecuteCallback(): no pThis");
	if (pThis == NULL)
		return 0;

	// Handle callback reason.
	pThis->AddRef();
	pThis->ExecuteHandler (pRequest, nReplyCode, pReplyText);
	pThis->ReleaseRef();

	// Wait for next callback.
	return 1;
}

/*
 * ExecuteHandler.
 */
void CntHTTPRequestJob_Impl::ExecuteHandler (
	NAMESPACE_INET(INetHTTPRequest) *pRequest,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check request.
	DBG_ASSERT(
		(pRequest != NULL) && (m_xRequest == pRequest),
		"CntHTTPRequestJob_Impl::ExecuteHandler(): wrong Request");
	if ((pRequest == NULL) || (!(m_xRequest == pRequest)))
		return;

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntHTTPRequestJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check subject.
	CntNode *pSubject = pJob->GetSubject();
	DBG_ASSERT(
		pSubject, "CntHTTPRequestJob_Impl::ExecuteHandler(): no Subject");
	if (pSubject == NULL)
	{
		// Failure.
		Finished (STATE_ERROR);
		return;
	}

	// Check callback reason.
	if (nReplyCode <= 0)
	{
		// Implementation defined reply.
		switch (nReplyCode)
		{
			case request::REPLY_NETWORK_ERROR:
				Finished (STATE_ERROR);
				break;

			case request::REPLY_RESOLVER_ERROR:
				if (pRequest)
				{
					// Obtain connection endpoint.
					OUString   aHost;
					sal_uInt16 nPort;

					pRequest->getEndpoint (aHost, nPort);

					// Notify caller.
					ErrCode eErrCode = *new StringErrorInfo (
						ERRCODE_INET_NAME_RESOLVE, aHost);
					pJob->SetError (eErrCode);
				}
				Finished (STATE_ERROR);
				break;

			case request::REPLY_CONNECT_ERROR:
				if (pRequest)
				{
					// Obtain connection protocol.
					String aProtocol (S2U ("HTTP"));
					if (m_aReqURL.GetProtocol() == INET_PROT_HTTPS)
						aProtocol += sal_Unicode('S');

					// Obtain connection endpoint.
					OUString   aHost;
					sal_uInt16 nPort;

					pRequest->getEndpoint (aHost, nPort);

					String aEndpoint (aHost);
					aEndpoint += sal_Unicode(':');
					aEndpoint += UniString::CreateFromInt32 (nPort);

					// Notify caller.
					ErrCode eErrCode = *new TwoStringErrorInfo (
						ERRCODE_CHAOS_SERVER_CONNECT_FAILURE,
						aProtocol, aEndpoint);
					pJob->SetError (eErrCode);
				}
				Finished (STATE_ERROR);
				break;

			case request::REPLY_CONNECTION_TERMINATED:
			case request::REPLY_REQUEST_ERROR:
			case request::REPLY_RESPONSE_ERROR:
				Finished (STATE_ERROR);
				break;

			case request::REPLY_REQUEST_WAIT:
				if (m_pReqMsg && m_pReqMsg->GetDocumentLB())
				{
					// Deliver current request DocumentSize.
					ULONG nSize = m_xRequest->getRequestDocumentLength();
					pSubject->Put (CntUInt32Item (
						WID_DOCUMENT_SIZE, nSize));
				}
				break;

			case request::REPLY_REQUEST_DONE:
				if (m_pResMsg)
				{
					// Deliver (in-progress) response DocumentBody.
#if (SUPD < 582)
					XActiveDataSinkRef xSink;
					if (const CntOpenModeItem *pItem =
						    PTR_CAST(CntOpenModeItem, pJob->GetRequest()))
						xSink = XActiveDataSinkRef (pItem->getSink(),
													USR_QUERY);
					else if (const CntPostStreamItem *pItem =
							 PTR_CAST(CntPostStreamItem,
									  pJob->GetRequest()))
						xSink = XActiveDataSinkRef (pItem->getSink(),
													USR_QUERY);
					if (xSink.is())
					{
						xSink->setInputStream (XInputStreamRef (
							new SvLockBytesInputStream (
								m_pResMsg->GetDocumentLB())));
					}
#else
					Reference< XActiveDataSink > xSink;
					if (const CntOpenModeItem *pItem =
						    PTR_CAST(CntOpenModeItem, pJob->GetRequest()))
						xSink = Reference< XActiveDataSink > (
													pItem->getDataSink(),
													UNO_QUERY);
					else if (const CntPostStreamItem *pItem =
							     PTR_CAST(CntPostStreamItem,
										  pJob->GetRequest()))
						xSink = Reference< XActiveDataSink > (
													pItem->getDataSink(),
													UNO_QUERY);
					if (xSink.is())
					{
						xSink->setInputStream (Reference< XInputStream > (
							new SvLockBytesInputStream (
								m_pResMsg->GetDocumentLB())));
					}
#endif /* SUPD */
					pSubject->Put (SfxLockBytesItem (
						WID_DOCUMENT_BODY, m_pResMsg->GetDocumentLB()));
				}
				break;

			case request::REPLY_RESPONSE_WAIT:
				if (m_pResMsg)
				{
					ULONG nResMsgSize = m_pResMsg->GetDocumentSize();

					// Deliver current response DocumentSize.
					if (!m_nHintId)
					{
						if (m_xRequest->isResponseHeaderParsed())
						{
							// Obtain ContentLength.
							UniString aSize (m_pResMsg->GetContentLength());
							ULONG nSize = aSize.ToInt32();

							// Setup Progress.
							m_nHintId = CntStatusBarHint::CreateHintId();
							Broadcast (CntStatusBarHint (
								m_nHintId, 0, nSize, String()));
						}
					}
					else
					{
						// Update Progress.
						ULONG nDone = m_xRequest->getResponseDocumentLength();
						Broadcast (CntStatusBarHint (m_nHintId, nDone));
					}
					pSubject->Put (CntUInt32Item (
						WID_DOCUMENT_SIZE, nResMsgSize));
				}
				break;

			case request::REPLY_09: // DocumentBody only (HTTP/0.9).
				Finished();
				break;

			default: // Some progess code.
				break;
		}
	}
	else
	{
		// Protocol defined reply.
		switch (nReplyCode/100)
		{
			case 2: // Successful (2xx).
				Finished();
				break;

			case 3: // Multiple Choices (3xx).
				Finished();
				break;

			case 4: // Client Error (4xx).
				// Check for authentication requested from...
				if (nReplyCode == request::REPLY_UNAUTHORIZED)
				{
					// ...Origin.
					if (m_pReqMsg->GetAuthorization().Len())
					{
						// Previous authorization failed.
						CNT_RNM()->RemoveLoginInfo (OWN_URL (pSubject));
					}

					String aRealm;
					if (GetBasicAuthentication (
						m_pResMsg->GetWWWAuthenticate(), aRealm))
					{
						String aHost (m_pReqMsg->GetHost());
						String aUsername;
						String aPassword;

						if (!CNT_RNM()->GetLoginInfo (
							aHost, aRealm, aUsername, aPassword))
						{
							// Obtain document node.
							pSubject->Put (CntStringItem (
								WID_SERVERNAME, aHost));
							pSubject->Put (CntStringItem (
								WID_ACCOUNT, aRealm));

							// Setup status text.
							UniString aStatusStr (
								UniString::CreateFromInt32 (nReplyCode));
							aStatusStr.Append (sal_Unicode(' '));
							aStatusStr.AppendAscii (pReplyText);

							// Notify caller.
							pJob->SetError (
								ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE,
								&aStatusStr, pSubject);
							if (pJob->IsCancelled() || pJob->IsDone())
								return;

							// Obtain new Authorization.
							aUsername = ITEMSET_VALUE_STRING(
								pSubject, WID_USERNAME);
							aPassword = ITEMSET_VALUE_STRING(
								pSubject, WID_PASSWORD);
						}

						// Setup new Request/Response messages.
						String aCredential;
						if (SetBasicAuthentication (
							aUsername, aPassword, aCredential))
						{
							// Check for Cookies.
							GetParent()->SetCookie (m_aReqURL, *m_pResMsg);

							// Modify request message.
							m_pReqMsg->SetAuthorization (aCredential);

							// Invalidate current document.
							pSubject->Put (SfxLockBytesItem (
								WID_DOCUMENT_BODY, NULL));

							// Cleanup current request.
							m_xRequest.unbind();
							DELETEZ (m_pResMsg);

							// Next state.
							m_eState = STATE_REQUEST;
							GetRootNode()->RescheduleJob (pJob);
							return;
						}
					}
				}
				if (nReplyCode == request::REPLY_PROXY_UNAUTHORIZED)
				{
					// ...Proxy.
					OUString   aHost;
					sal_uInt16 nPort;

					m_xRequest->getEndpoint (aHost, nPort);

					UniString aEndpoint (aHost);
					aEndpoint += sal_Unicode(':');
					aEndpoint += UniString::CreateFromInt32 (nPort);

					String aProxyUrl (S2U (CNTHTTP_ROOT_URL));
					aProxyUrl.AppendAscii ("#proxy://");
					aProxyUrl.Append (aEndpoint);

					if (m_pReqMsg->GetProxyAuthorization().Len())
					{
						// Previous authorization failed.
						CNT_RNM()->RemoveLoginInfo (aProxyUrl);
					}

					String aRealm;
					if (GetBasicAuthentication (
						m_pResMsg->GetProxyAuthenticate(), aRealm))
					{
						String aUsername;
						String aPassword;

						if (!CNT_RNM()->GetLoginInfo (
							aHost, aRealm, aUsername, aPassword))
						{
							CntNodeRef xProxyNode (
								GetRootNode()->Query (aProxyUrl));

							xProxyNode->Put (CntStringItem (
								WID_SERVERNAME, aHost));
							xProxyNode->Put (CntStringItem (
								WID_ACCOUNT, aRealm));

							// Setup status text.
							UniString aStatusStr (
								UniString::CreateFromInt32 (nReplyCode));
							aStatusStr.Append (sal_Unicode(' '));
							aStatusStr.AppendAscii (pReplyText);

							// Notify caller.
							pJob->SetError (
								ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE,
								&aStatusStr, xProxyNode);
							if (pJob->IsCancelled() || pJob->IsDone())
								return;

							// Obtain new Authorization.
							aUsername = ITEMSET_VALUE_STRING(
								xProxyNode, WID_USERNAME);
							aPassword = ITEMSET_VALUE_STRING(
								xProxyNode, WID_PASSWORD);
						}

						// Setup new Request/Response messages.
						String aCredential;
						if (SetBasicAuthentication (
							aUsername, aPassword, aCredential))
						{
							// Check for Cookies.
							GetParent()->SetCookie (m_aReqURL, *m_pResMsg);

							// Modify request message.
							m_pReqMsg->SetProxyAuthorization (aCredential);

							// Invalidate current document.
							pSubject->Put (SfxLockBytesItem (
								WID_DOCUMENT_BODY, NULL));

							// Cleanup current request.
							m_xRequest.unbind();
							DELETEZ (m_pResMsg);

							// Next state.
							m_eState = STATE_REQUEST;
							GetRootNode()->RescheduleJob (pJob);
							return;
						}
					}
				}
				// Fall through to default.

			default: // Server Error (5xx).
				if (m_pResMsg)
				{
					// Setup status text.
					UniString aStatusStr (
						UniString::CreateFromInt32 (nReplyCode));
					aStatusStr.Append (sal_Unicode(' '));
					aStatusStr.AppendAscii (pReplyText);

					// Notify caller.
					ErrCode eErrCode = *(new StringErrorInfo (
						ERRCODE_CHAOS_SERVER_ERROR, aStatusStr));
					pJob->SetError (eErrCode);
					if (pJob->IsCancelled() || pJob->IsDone())
						return;

					// Setup DocumentHead itemset.
					SfxItemPool *pPool = CNT_POOL();
					if (pPool && m_pResMsg)
					{
						SfxItemSet aDirSet (*pPool, aDocDirRanges_Impl);

						// Store ContentType (or default).
						String aContentType (m_pResMsg->GetContentType());
						if (aContentType.Len() == 0)
						{
							aContentType.AssignAscii (
								CONTENT_TYPE_STR_X_CNT_HTTPFILE);
							m_pResMsg->SetContentType (aContentType);
						}
						aDirSet.Put (CntContentTypeItem (
							WID_CONTENT_TYPE, aContentType));

						// Store DocumentHeader.
						CntDocHeaderRef xHead (new CntDocHeader (*m_pResMsg));
						xHead->SetDocumentLB (NULL);
						aDirSet.Put (CntDocHeaderItem (
							WID_DOCUMENT_HEADER, xHead));

						// Store final DocumentSize.
						aDirSet.Put (CntUInt32Item (
							WID_DOCUMENT_SIZE, xHead->GetDocumentSize()));

						// Deliver DocumentHead itemset.
						pSubject->Put (aDirSet);
						if (pJob->IsCancelled() || pJob->IsDone())
							return;
					}

					// Acquire cache access.
					NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

					// Invalidate response document.
					String aURL (S2U (CHTTPIMP_RESPONSE_PREFIX));
					aURL += m_aReqURI;

					InvalidateDocument (*pJob->GetCacheNode(), aURL);
				}

				// Done.
				Finished();
				break;
		}
	}
}

/*
 * Finished.
 */
void CntHTTPRequestJob_Impl::Finished (State eState)
{
	USHORT nHintId = m_nHintId;
	if (nHintId)
	{
		m_nHintId = 0;
		Broadcast (CntStatusBarHint (nHintId));
	}

	CntNodeJob *pJob = GetJob();
	if (pJob)
	{
		if (eState == STATE_DONE)
			pJob->Done();
		else
			pJob->Cancel();
	}
}

/*
 * Notify.
 */
void CntHTTPRequestJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Job finished. Cleanup.
			EndListening (*pJob);

			m_xRequest.unbind();
			DELETEZ (m_pReqMsg);
			DELETEZ (m_pResMsg);

			USHORT nHintId = m_nHintId;
			if (nHintId)
			{
				m_nHintId = 0;
				Broadcast (CntStatusBarHint (nHintId));
			}

			// Check for abort.
			if (pJob->IsCancelled())
			{
				// Acquire cache access.
				NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

				// Obtain cache node.
				CntStorageNodeRef xCache (pJob->GetCacheNode());
				if (xCache.Is())
				{
					// Invalidate current document.
					String aUrl (S2U (CHTTPIMP_RESPONSE_PREFIX));
					aUrl += m_aReqURI;

					InvalidateDocument (*xCache, aUrl);
				}
			}
		}
	}
	CntHTTPJob_Impl::Notify (rBC, rHint);
}

