/*************************************************************************
 *
 *  $RCSfile: sonedemo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _USR_LSTCOMP_HXX //autogen
#include <usr/lstcont.hxx>
#endif
#ifndef _USR_SERVICES_HXX
#include <usr/services.hxx>
#endif

#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYCHANGELISTENER_HXX_
#include <smart/com/sun/star/beans/XPropertyChangeListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYSET_HXX_
#include <smart/com/sun/star/beans/XPropertySet.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_ACTION_HXX_
#include <smart/com/sun/star/chaos/Action.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_EXPORTURLINFO_HXX_
#include <smart/com/sun/star/chaos/ExportURLInfo.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_RULEOPERATOR_HXX_
#include <smart/com/sun/star/chaos/RuleOperator.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_RULETERM_HXX_
#include <smart/com/sun/star/chaos/RuleTerm.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_SEARCHCRITERIUM_HXX_
#include <smart/com/sun/star/chaos/SearchCriterium.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_SEARCHINFO_HXX_
#include <smart/com/sun/star/chaos/SearchInfo.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_SEARCHRECURSION_HXX_
#include <smart/com/sun/star/chaos/SearchRecursion.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XANCHOR_HXX_
#include <smart/com/sun/star/chaos/XAnchor.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XANCHOREVENTLISTENER_HXX_
#include <smart/com/sun/star/chaos/XAnchorEventListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XCOMMANDEXECUTOR_HXX_
#include <smart/com/sun/star/chaos/XCommandExecutor.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XDATACONTAINER_HXX_
#include <smart/com/sun/star/chaos/XDataContainer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XSTATUSCALLBACK_HXX_
#include <smart/com/sun/star/chaos/XStatusCallback.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XSYSTEM_HXX_
#include <smart/com/sun/star/chaos/XSystem.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CHAOS_XURLCONTENT_HXX_
#include <smart/com/sun/star/chaos/XURLContent.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_IOEXCEPTION_HXX_
#include <smart/com/sun/star/io/IOException.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LANG_XCOMPONENT_HXX_
#include <smart/com/sun/star/lang/XComponent.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_UTIL_DATE_HXX_
#include <smart/com/sun/star/util/Date.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SV_TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif
#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifndef _CASTMACS_HXX
#include <chaos/castmacs.hxx>
#endif
#ifndef _CNTSYS_HXX
#include <chaos/cntsys.hxx>
#endif

//=========================================================================

#define U2S( String ) 	OUStringToString( String, CHARSET_SYSTEM )
#define S2U( String ) 	StringToOUString( String, CHARSET_SYSTEM )
#define C2U( charptr ) 	S2U( String( charptr ) )

/*========================================================================
 *
 * CntDemoClient.
 *
 *=======================================================================*/

class CntDemoClient : public XAnchorEventListener,
					  public XPropertyChangeListener,
					  public XStatusCallback,
					  public UsrObject
{
	XInterfaceRef   m_xAnchor;
	MultiLineEdit*	m_pOutEdit;
	XCommandExecutorRef m_xMainExecutor;
	XInterfaceRef	m_xMainExecutorCommandID;

private:
	inline void setMainExecutor(const XCommandExecutorRef & rExecutor);

	String convertAction(INT32 nAction);

	void Output( const String& rText );

protected:
	CntDemoClient( XInterfaceRef& rAnchor, MultiLineEdit* pOutEdit );
	virtual ~CntDemoClient();

public:
	static CntDemoClient* create( CntDemoClient* pParent, const String& rURL,
	             				  MultiLineEdit* pOutEdit );

	void dispose();

	Sequence<UString>  getCommands();
	Sequence<Property> getProperties();

	UsrAny	getPropertyValue( const UString& rName );
	UString	getStringPropertyValue( const UString& rName );

	void setPropertyValue( const UString& rName, const UsrAny& rAnyvalue );
	void setStringPropertyValue( const UString& rName, const UString& rValue );

	void open();
	void sendMessage();
	void doImport(const String & rCommands);
	void doExport(const String & rCommands);
	void doSearch(const String & rCriteria);
	void doCancel();

	// UNO stuff...
	SMART_UNO_DECLARATION( CntDemoClient, UsrObject );
	virtual BOOL queryInterface( Uik aUIK, XInterfaceRef& rOut );

	// XEventListener methods.
    virtual void disposing( const EventObject& Source );

	// XPropertyChangeListener methods.
    virtual void propertyChange( const PropertyChangeEvent& evt );

	// XAnchorEventListener methods.
    virtual void anchorEvent( const AnchorEvent& evt );

	// XStatusCallback methods.
    virtual void started ( const StatusCallbackEvent& rEvt );
    virtual void done    ( const StatusCallbackEvent& rEvt );
    virtual void canceled( const StatusCallbackEvent& rEvt );
    virtual void error   ( const StatusCallbackEvent& rEvt, INT32 nError );
    virtual void result  ( const StatusCallbackEvent& evt,
						   INT32 nAction, const UString& rResult );
};

inline void CntDemoClient::setMainExecutor(const XCommandExecutorRef &
										    rExecutor)
{
	if (!m_xMainExecutor.is())
		m_xMainExecutor = rExecutor;
}

/*========================================================================
 *
 * CntDemoClientRef.
 *
 *=======================================================================*/

USR_DECLIMPL_OBJECT_REF( CntDemoClient );

/*========================================================================
 *
 * FileDataSource_Impl.
 *
 *=======================================================================*/

class FileDataSource_Impl: public UsrObject, public XPassiveDataSource
{
	ListenerContainer m_aListeners;
	XDataSinkRef m_xSink;
	String m_aFilePath;
	SvFileStream * m_pFileStream;
	BOOL m_bEOFBroadcasted;

	void broadcastEOF();

	BOOL broadcastError();

public:
	FileDataSource_Impl(): m_pFileStream(0), m_bEOFBroadcasted(FALSE) {}

	inline FileDataSource_Impl(const String & rTheFilePath);

	virtual ~FileDataSource_Impl() { delete m_pFileStream; }

	SMART_REFLECTION_DECLARATION(FileDataSource_Impl, UsrObject);

	virtual BOOL queryInterface(Uik aUIK, XInterfaceRef & rInterface);

	virtual Sequence<XIdlClassRef> getIdlClasses();

    virtual
	void addSourceControllerListener(const XStreamConnectionListenerRef &
									  rListener) THROWS(())
	{ m_aListeners.addListener(rListener); }

    virtual
	void removeSourceControllerListener(const XStreamConnectionListenerRef &
										 rListener) THROWS(())
	{ m_aListeners.removeListener(rListener); }

    virtual void open() THROWS(());

    virtual void close() THROWS(());

	virtual void setDataSink(const XDataSinkRef & rSink) THROWS(());

    virtual INT32 available() THROWS(());

    virtual void triggerSomeBytes(INT32 nMaxLength) THROWS(());

    virtual void skipBytes(INT32 nOffset) THROWS(());
};

inline FileDataSource_Impl::FileDataSource_Impl(const String & rTheFilePath):
	m_aFilePath(rTheFilePath),
	m_pFileStream(0),
	m_bEOFBroadcasted(FALSE)
{}

/*========================================================================
 *
 * FileDataSource_ImplRef.
 *
 *=======================================================================*/

USR_DECLIMPL_OBJECT_REF( FileDataSource_Impl );

/*========================================================================
 *
 * FileDataSink_Impl.
 *
 *=======================================================================*/

class FileDataSink_Impl: public UsrObject, public XDataSink
{
	String m_aFilePath;
	SvFileStream * m_pFileStream;

public:
	FileDataSink_Impl(): m_pFileStream(0) {}

	FileDataSink_Impl(const String & rTheFilePath):
		m_aFilePath(rTheFilePath), m_pFileStream(0) {}

	virtual ~FileDataSink_Impl() { delete m_pFileStream; }

	SMART_REFLECTION_DECLARATION(FileDataSink_Impl, UsrObject);

	virtual BOOL queryInterface(Uik aUIK, XInterfaceRef & rInterface);

	virtual Sequence<XIdlClassRef> getIdlClasses();

    virtual	void write(const Sequence<BYTE> & rBuffer) THROWS((IOException));

	virtual void flush() THROWS((IOException));
};

/*========================================================================
 *
 * FileDataSink_ImplRef.
 *
 *=======================================================================*/

USR_DECLIMPL_OBJECT_REF( FileDataSink_Impl );

/*========================================================================
 *
 * CntDemoClient implementation.
 *
 *=======================================================================*/

SMART_UNO_IMPLEMENTATION( CntDemoClient, UsrObject );

//-------------------------------------------------------------------------
CntDemoClient::CntDemoClient( XInterfaceRef& rAnchor,
							  MultiLineEdit* pOutEdit)
: m_xAnchor( rAnchor ),
  m_pOutEdit( pOutEdit )
{
}

//-------------------------------------------------------------------------
// virtual
CntDemoClient::~CntDemoClient()
{
}

//-------------------------------------------------------------------------
// static
CntDemoClient* CntDemoClient::create( CntDemoClient* pParent,
									  const String&  rURL,
									  MultiLineEdit* pOutEdit )
{
	if ( !rURL.Len() )
		return NULL;

	XMultiServiceFactoryRef xMgr( NAMESPACE_USR( getProcessServiceManager )() );
	if ( !xMgr.Is() )
		return NULL;

	XInterfaceRef xRef = xMgr->createInstance( L"com.sun.star.chaos.Anchor" );
	if ( !xRef.Is() )
		return NULL;

	XURLContentRef xURLContent;
	if ( !xRef->queryInterface( XURLContent::getSmartUik(), xURLContent ) )
		return NULL;

	if ( !xURLContent->initialize( XURLContentRef(), S2U( rURL ) ) )
	{
		String aText( pOutEdit->GetText() );
		aText += "Anchor initialization failed. Wrong URL given?\n";
		pOutEdit->SetText( aText );
		return NULL;
	}

	XPropertySetRef xPropSet;
	if ( !xRef->queryInterface( XPropertySet::getSmartUik(), xPropSet ) )
		return NULL;

	XAnchorRef xAnchor;
	if ( !xRef->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return NULL;

	CntDemoClient* pNew = new CntDemoClient( xRef, pOutEdit );

	// Register event listeners.
	xPropSet->addPropertyChangeListener( UString(), pNew );
    xAnchor->addAnchorEventListener( pNew );

	String aText( "Created Anchor: " );
	aText += U2S( xURLContent->getURL() );
	aText += '\n';
	pNew->Output( aText );

	return pNew;
}

//-------------------------------------------------------------------------
void CntDemoClient::dispose()
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XComponentRef xComponent;
	if ( !m_xAnchor->queryInterface( XComponent::getSmartUik(), xComponent ) )
		return;

	xComponent->dispose();
}

//-------------------------------------------------------------------------
Sequence<UString> CntDemoClient::getCommands()
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return Sequence<UString>( 0 );
	}

	XCommandExecutorRef xExecutor;
	if ( !m_xAnchor->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return Sequence<UString>( 0 );

	Sequence<UString> aCommandList = xExecutor->queryCommands();

	String aText( "Commands:\n" );
	ULONG nCount = aCommandList.getLen();
	for ( ULONG n = 0; n < nCount; ++n )
	{
		aText += '\t';
		aText += U2S( aCommandList.getArray()[ n ] );
		aText += '\n';
	}
	Output( aText );

	return aCommandList;
}

//-------------------------------------------------------------------------
Sequence<Property> CntDemoClient::getProperties()
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return Sequence<Property>( 0 );
	}

	XPropertySetRef xPropSet;
	if ( !m_xAnchor->queryInterface( XPropertySet::getSmartUik(), xPropSet ) )
		return Sequence<Property>( 0 );

    XPropertySetInfoRef xPropInfo = xPropSet->getPropertySetInfo();
	if ( !xPropInfo.Is() )
		return Sequence<Property>( 0 );

	Sequence<Property> aPropList = xPropInfo->getProperties();

	String aText( "Properties:\n" );
	ULONG nCount = aPropList.getLen();
	for ( ULONG n = 0; n < nCount; ++n )
	{
		aText += '\t';
		aText += U2S( aPropList.getArray()[ n ].Name );
		aText += '\n';
	}
	Output( aText );

	return aPropList;
}

//----------------------------------------------------------------------------
UsrAny CntDemoClient::getPropertyValue( const UString& rName )
{
	if ( !rName.len() )
		return UsrAny();

	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return UsrAny();
	}

	XPropertySetRef xPropSet;
	if ( !m_xAnchor->queryInterface( XPropertySet::getSmartUik(), xPropSet ) )
		return UsrAny();

    return xPropSet->getPropertyValue( rName );
}

//----------------------------------------------------------------------------
UString	CntDemoClient::getStringPropertyValue( const UString& rName )
{
/*
	// DateTime Test...
	UsrAny aAny = getPropertyValue( L"DateCreated" );
	if ( aAny.getReflection() == DateTime_getReflection() )
	{
		DateTime* pVal = (DateTime*)aAny.get();

		String aText( "DateCreated:\n\t" );
		aText += pVal->GetDay();
		aText += '.';
		aText += pVal->GetMonth();
		aText += '.';
		aText += pVal->GetYear();
		aText += ' ';
		aText += pVal->GetHour();
		aText += ':';
		aText += pVal->GetMin();
		aText += ':';
		aText += pVal->GetSec();
		aText += '\n';
		Output( aText );
	}
*/
/*
	// Sequence Test...
	UsrAny aAny = getPropertyValue( L"BrowserColumns" );
	if ( aAny.getReflection() == Sequence<UString>::getReflection() )
	{
		String aText( "BrowserColumns:\n\t" );

		Sequence<UString>* pSeq = (Sequence<UString>*)aAny.get();
		USHORT nCount = pSeq->getLen();
		for ( USHORT n = 0; n < nCount; ++n )
		{
			aText += " '";
			aText += U2S( pSeq->getArray()[ n ] );
			aText += "',";
		}

		aText += '\n';
		Output( aText );
	}
*/
	// String Test...
	UsrAny aAny = getPropertyValue( rName );
	if ( aAny.getReflection() == OUString_getReflection() )
	{
		UString aValue( aAny.getString() );

		String aText( U2S( rName ) );
		aText += ": '";
		aText += U2S( aValue );
		aText += "'\n";
		Output( aText );

		return aValue;
	}

	return UString();
}

//----------------------------------------------------------------------------
void CntDemoClient::setPropertyValue( const UString& rName,
									  const UsrAny& rAnyValue )
{
	if ( !rName.len() )
		return;

	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XPropertySetRef xPropSet;
	if ( !m_xAnchor->queryInterface( XPropertySet::getSmartUik(), xPropSet ) )
		return;

    xPropSet->setPropertyValue( rName, rAnyValue );
}

//----------------------------------------------------------------------------
void CntDemoClient::setStringPropertyValue( const UString& rName,
											const UString& rValue )
{
	setPropertyValue( rName, UsrAny( rValue ) );

	String aText( U2S( rName ) );
	aText += " set to '";
	aText += U2S( rValue );
	aText += "'\n";
	Output( aText );
}

//----------------------------------------------------------------------------
void CntDemoClient::open()
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XAnchorRef xAnchor;
	if ( !m_xAnchor->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return;

	XCommandExecutorRef xExecutor;
	if ( !m_xAnchor->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return;

	String aText( "Executing: 'open'...\n" );
	Output( aText );

	setMainExecutor(xExecutor);
	xExecutor->execute( L"open", UsrAny( (INT16)0 ), this );
}

//----------------------------------------------------------------------------
void CntDemoClient::sendMessage()
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XAnchorRef xAnchor;
	if ( !m_xAnchor->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return;

	XAnchorRef xMessage = xAnchor->create( L".chaos/message" );
	if ( !xMessage.Is() )
		return;

	XPropertySetRef xPropSet;
	if ( !xMessage->queryInterface( XPropertySet::getSmartUik(), xPropSet ) )
		return;

	// Set message receiver...

	UsrAny aTo( L"kso@stardivision.de" );
//	UsrAny aTo( L"mailto://sdmailout:smtp/kso@stardivision.de" );
    xPropSet->setPropertyValue( L"MessageTo", aTo );

	// Set message subject...

	UsrAny aSubject( L"StarONE - Testmail" );
    xPropSet->setPropertyValue( L"Title", aSubject );

	// Create data container via UNO service.

	XMultiServiceFactoryRef xMgr( NAMESPACE_USR( getProcessServiceManager )() );
	if ( !xMgr.Is() )
		return;

	XInterfaceRef xRef =
					xMgr->createInstance( L"com.sun.star.chaos.DataContainer" );
	if ( !xRef.Is() )
		return;

	XDataContainerRef xContainer;
	if ( !xRef->queryInterface( XDataContainer::getSmartUik(), xContainer ) )
		return;

	// Fill data container...

#if 0 /* SINGLE_PART */
	xContainer->setContentType( L"text/plain" );

#if 0 /* DATA_AS_SEQUENCE */
	String aText( "Das ist der Body. Er wurde generiert mit StarONE...\n"
				  "\n"
				  "Kai." );

	Sequence<Byte> aSeq( (const BYTE*)aText.GetStr(), aText.Len() );
	xContainer->setData( aSeq );
#else /* DATA_AS_FILE_URL */
	xContainer->setDataURL( L"file:///d|/text.txt" );
#endif

#else /* MULTI_PART */
	// Fill root container...

	xContainer->setContentType( L"multipart/mixed" );

	// Create child container...

	// Text part.
	xRef = xMgr->createInstance( L"com.sun.star.chaos.DataContainer" );
	if ( !xRef.Is() )
		return;

	XDataContainerRef xChildContainer;
	if ( !xRef->queryInterface(
							XDataContainer::getSmartUik(), xChildContainer ) )
		return;

	// Fill child container...

	xChildContainer->setContentType( L"text/pain" );
	xChildContainer->setDataURL( L"file:///d|/text.txt" );

	// Add child to root container...

	UsrAny aAny;
	aAny.set( &xChildContainer, XDataContainer_getReflection() );
	xContainer->insertByIndex( 0, aAny );

	// Create child container...

	xRef = xMgr->createInstance( L"com.sun.star.chaos.DataContainer" );
	if ( !xRef.Is() )
		return;

	// HTML part.
	if ( !xRef->queryInterface(
							XDataContainer::getSmartUik(), xChildContainer ) )
		return;

	// Fill child container...

	xChildContainer->setContentType( L"text/html" );
	xChildContainer->setDataURL( L"file:///d|/html.html" );

	// Add child to root container...

	aAny.set( &xChildContainer, XDataContainer_getReflection() );
	xContainer->insertByIndex( 1, aAny );
#endif

	// Set message body...

	UsrAny aBody( &xContainer, XDataContainer_getReflection() );
    xPropSet->setPropertyValue( L"MessageBody", aBody );

	// Insert message ( will send it )...

	XCommandExecutorRef xExecutor;
	if ( !xMessage->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return;

	setMainExecutor(xExecutor);
	xExecutor->execute( L"insert", UsrAny(), this );
}

//----------------------------------------------------------------------------
void CntDemoClient::doImport(const String & rCommands)
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XAnchorRef xAnchor;
	if ( !m_xAnchor->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return;

	XCommandExecutorRef xExecutor;
	setMainExecutor(xExecutor);
	if ( !m_xAnchor->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return;

	BOOL bURL = String("file:").Match(rCommands) == STRING_MATCH;

	String aText( "Executing: 'import " );
	if (bURL)
		aText += "URL=\"";
	else
		aText += "source=\"";
	aText += rCommands;
	aText += "\"'...\n";
	Output( aText );

	FileDataSource_ImplRef xMBXFile;
	UsrAny aAny;
	if (bURL)
		aAny.setString(S2U(rCommands));
	else
	{
		xMBXFile = new FileDataSource_Impl(rCommands);
		aAny.set(&xMBXFile, XPassiveDataSource_getReflection());
	}
	setMainExecutor(xExecutor);
	xExecutor->execute( L"import", aAny, this );
}

//----------------------------------------------------------------------------
void CntDemoClient::doExport(const String & rCommands)
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XAnchorRef xAnchor;
	if ( !m_xAnchor->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return;

	XCommandExecutorRef xExecutor;
	if ( !m_xAnchor->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return;

	BOOL bForceBodies;
	String aTarget(rCommands);
	if (aTarget.Len() && aTarget.GetChar(aTarget.Len() - 1) == '+')
	{
		bForceBodies = TRUE;
		aTarget.Erase(aTarget.Len() - 1);
	}
	else
		bForceBodies = FALSE;
	BOOL bURL = String("file:").Match(aTarget) == STRING_MATCH;

	String aText( "Executing: 'export " );
	if (bURL)
		aText += "URL=\"";
	else
		aText += "sink=\"";
	aText += aTarget;
	aText += "\",forceBodies=";
	if (bForceBodies)
		aText += "yes";
	else
		aText += "no";
	aText += "'...\n";
	Output( aText );

	ExportURLInfo aURLInfo;
	ExportSinkInfo aSinkInfo;
	UsrAny aAny;
	if (bURL)
	{
		aURLInfo.Target = S2U(aTarget);
		aURLInfo.ForceBodies = bForceBodies;
		aAny.set(&aURLInfo, ExportURLInfo_getReflection());
	}
	else
	{
		aSinkInfo.Target = new FileDataSink_Impl(aTarget);
		aSinkInfo.ForceBodies = bForceBodies;
		aAny.set(&aSinkInfo, ExportSinkInfo_getReflection());
	}
	setMainExecutor(xExecutor);
	xExecutor->execute( L"export", aAny, this );
}

//----------------------------------------------------------------------------
void CntDemoClient::doSearch(const String & rCriteria)
{
	if ( !m_xAnchor.Is() )
	{
		Output( "No Anchor.\n" );
		return;
	}

	XAnchorRef xAnchor;
	if ( !m_xAnchor->queryInterface( XAnchor::getSmartUik(), xAnchor ) )
		return;

	XCommandExecutorRef xExecutor;
	if ( !m_xAnchor->queryInterface(
								XCommandExecutor::getSmartUik(), xExecutor ) )
		return;

	// Argument Syntax:
	//
	//  args = rules "," recursion "," include-base "," folder-view ","
	//          doc-view "," indirect
	//  rules = "(" [rule ["," rule]] ")"
	//  rule = "(" [term ["," term]] ")"
	//  term = property predicate
	//  property = +(ALPHA / DIGIT)
	//  predicate = string-pred / date-pred / bool-pred / num-pred
	//  string-pred = ("##" / "!#" / ">=" / "<=" / "==" / "!=") DQUOTE
	//                 *(s-char / "\" CHAR) DQUOTE ["C"] ["R"]
	//  s-char = <any CHAR except DQUOTE or "\">
	//  date-pred = (">=" / "<=" / "==" / "!=") 2DIGIT "." 2DIGIT "." 4DIGIT
	//  bool-pred = "+" / "-"
	//  num-pred = (">=" / "<=" / "==" / "!=") +DIGIT
	//  recursion = "0" / "1" / "+"
	//  include-base = "-" / "+"
	//  folder-view = "-" / "+"
	//  doc-view = "-" / "+"
	//  indirect = "-" / "+"
	class SearchInfo aInfo;
	const char * pArgs = rCriteria.GetStr();
	BOOL bCriteriaDone = FALSE;
	if (*pArgs++ != '(')
		goto parsed;
	do
	{
		if (*pArgs++ != '(')
			goto parsed;
		SearchCriterium aCriterium;
		BOOL bTermsDone = FALSE;
		do
		{
			RuleTerm aTerm;
			const char * pStart = pArgs;
			while (*pArgs >= '0' && *pArgs <= '9'
				   || *pArgs >= 'A' && *pArgs <= 'Z'
				   || *pArgs >= 'a' && *pArgs <= 'z')
				++pArgs;
			if (pArgs == pStart)
				goto parsed;
			aTerm.Property = StringToOUString(String(pStart, pArgs - pStart),
											 CHARSET_SYSTEM);
			switch (*pArgs++)
			{
				case '#':
					if (*pArgs++ != '#')
						goto parsed;
					aTerm.Operator = RuleOperator_CONTAINS;
					break;

				case '!':
					switch (*pArgs++)
					{
						case '#':
							aTerm.Operator = RuleOperator_CONTAINSNOT;
							break;

						case '=':
							aTerm.Operator = RuleOperator_NOTEQUAL;
							break;

						default:
							goto parsed;
					}
					break;

				case '>':
					if (*pArgs++ != '=')
						goto parsed;
					aTerm.Operator = RuleOperator_GREATEREQUAL;
					break;

				case '<':
					if (*pArgs++ != '=')
						goto parsed;
					aTerm.Operator = RuleOperator_LESSEQUAL;
					break;

				case '=':
					if (*pArgs++ != '=')
						goto parsed;
					aTerm.Operator = RuleOperator_EQUAL;
					break;

				case '+':
					aTerm.Operator = RuleOperator_VALUE_TRUE;
					break;

				case '-':
					aTerm.Operator = RuleOperator_VALUE_FALSE;
					break;

				default:
					goto parsed;
			}
			if (aTerm.Operator == RuleOperator_VALUE_TRUE)
				aTerm.Operand.setBOOL(TRUE);
			else if (aTerm.Operator == RuleOperator_VALUE_FALSE)
				aTerm.Operand.setBOOL(FALSE);
			else if (*pArgs == '"')
			{
				++pArgs;
				String aString;
				BOOL bStringDone = FALSE;
				for (; !bStringDone; ++pArgs)
					switch (*pArgs)
					{
						case 0:
							goto parsed;

						case '"':
							bStringDone = TRUE;
							break;

						case '\\':
							if (!++pArgs)
								goto parsed;
							// fall through is ok
						default:
							aString += *pArgs;
							break;
					}
				aTerm.Operand.setString(StringToOUString(aString,
														CHARSET_SYSTEM));
				if (*pArgs == 'C')
				{
					aTerm.CaseSensitive = TRUE;
					++pArgs;
				}
				else
					aTerm.CaseSensitive = FALSE;
				if (*pArgs == 'R')
				{
					aTerm.RegularExpression = TRUE;
					++pArgs;
				}
				else
					aTerm.RegularExpression = FALSE;
			}
			else if (aTerm.Operator == RuleOperator_CONTAINS
					 || aTerm.Operator == RuleOperator_CONTAINSNOT)
				goto parsed;
			else
			{
				pStart = pArgs;
				while (*pArgs >= '0' && *pArgs <= '9')
					++pArgs;
				if (pArgs == pStart)
					goto parsed;
				if (pArgs - pStart == 2 && *pArgs == '.')
				{
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs++ != '.')
						goto parsed;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs++ != '.')
						goto parsed;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					if (*pArgs < '0' || *pArgs > '9')
						goto parsed;
					++pArgs;
					Date aDate(String(pStart, 2), String(pStart + 3, 2),
							   String(pStart + 6, 4));
					aTerm.Operand.set(&aDate, Date_getReflection());
				}
				else
					aTerm.Operand.setINT32(String(pStart, pArgs - pStart));
			}
			aCriterium.Terms.realloc(aCriterium.Terms.getLen() + 1);
			aCriterium.Terms.getArray()[aCriterium.Terms.getLen() - 1]
			 = aTerm;
			switch (*pArgs++)
			{
				case ',':
					break;

				case ')':
					bTermsDone = TRUE;
					break;

				default:
					goto parsed;
			}
		}
		while (!bTermsDone);
		aInfo.Criteria.realloc(aInfo.Criteria.getLen() + 1);
		aInfo.Criteria.getArray()[aInfo.Criteria.getLen() - 1] = aCriterium;
		switch (*pArgs++)
		{
			case ',':
				break;

			case ')':
				bCriteriaDone = TRUE;
				break;

			default:
				goto parsed;
		}
	}
	while (!bCriteriaDone);
	if (*pArgs++ != ',')
		goto parsed;
	switch (*pArgs++)
	{
		case '0':
			aInfo.Recursion = SearchRecursion_NONE;
			break;

		case '1':
			aInfo.Recursion = SearchRecursion_ONE_LEVEL;
			break;

		case '+':
			aInfo.Recursion = SearchRecursion_DEEP;
			break;

		default:
			goto parsed;
	}
	if (*pArgs++ != ',')
		goto parsed;
	switch (*pArgs++)
	{
		case '-':
			aInfo.IncludeBase = FALSE;
			break;

		case '+':
			aInfo.IncludeBase = TRUE;
			break;

		default:
			goto parsed;
	}
	if (*pArgs++ != ',')
		goto parsed;
	switch (*pArgs++)
	{
		case '-':
			aInfo.RespectFolderViewRestrictions = FALSE;
			break;

		case '+':
			aInfo.RespectFolderViewRestrictions = TRUE;
			break;

		default:
			goto parsed;
	}
	if (*pArgs++ != ',')
		goto parsed;
	switch (*pArgs++)
	{
		case '-':
			aInfo.RespectDocViewRestrictions = FALSE;
			break;

		case '+':
			aInfo.RespectDocViewRestrictions = TRUE;
			break;

		default:
			goto parsed;
	}
	if (*pArgs++ != ',')
		goto parsed;
	switch (*pArgs++)
	{
		case '-':
			aInfo.FollowIndirections = FALSE;
			break;

		case '+':
			aInfo.FollowIndirections = TRUE;
			break;

		default:
			goto parsed;
	}
 parsed:

	Output("Executing: 'search'...\n");
	setMainExecutor(xExecutor);
	xExecutor->execute(L"search", UsrAny(&aInfo, SearchInfo_getReflection()),
					   this);
}

//----------------------------------------------------------------------------
void CntDemoClient::doCancel()
{
	if (m_xMainExecutor.is() && m_xMainExecutorCommandID.is())
		m_xMainExecutor->cancel(m_xMainExecutorCommandID);
}

//----------------------------------------------------------------------------
// virtual
BOOL CntDemoClient::queryInterface( Uik aUIK, XInterfaceRef& rOut )
{
	if ( aUIK == XAnchorEventListener::getSmartUik() )
		rOut = (XAnchorEventListener*)this;
	else if( aUIK == XPropertyChangeListener::getSmartUik() )
		rOut = (XPropertyChangeListener*)this;
	else if( aUIK == XStatusCallback::getSmartUik() )
		rOut = (XStatusCallback*)this;
	else
		UsrObject::queryInterface( aUIK, rOut );

	return rOut.is();
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::disposing( const EventObject& Source )
{
	Output( "Got 'disposing'.\n" );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::propertyChange( const PropertyChangeEvent& evt )
{
	String aText( "Property changed: '" );
	aText += U2S( evt.PropertyName );
	aText += "'\n";
	Output( aText );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::anchorEvent( const AnchorEvent& evt )
{
	String aText( "AnchorEvent:\n" );
	aText += "\tURL: ";
	aText += U2S( evt.URL );
	aText += "\n\tEvent: ";
	aText += convertAction(evt.Action);
	aText += '\n';
	Output( aText );

	CntDemoClientRef xNew =
			CntDemoClient::create( NULL, U2S( evt.URL ), m_pOutEdit );
//	xNew->getStringPropertyValue( L"Title" );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::started( const StatusCallbackEvent& rEvt )
{
//  	if (STATIC_CAST(XInterface *, m_xMainExecutor)
//  		 == STATIC_CAST(XInterface *, rEvt.Source))
	if (m_xMainExecutor == rEvt.Source)
		m_xMainExecutorCommandID = rEvt.CommandId;
	String aText( "Command started: '" );
	aText += U2S( rEvt.Name );
	aText += "'\n";
	Output( aText );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::done( const StatusCallbackEvent& rEvt )
{
	if (m_xMainExecutor == rEvt.Source)
	{
		m_xMainExecutor = 0;
		m_xMainExecutorCommandID = 0;
	}
	String aText( "Command done: '" );
	aText += U2S( rEvt.Name );
	aText += "'\n";
	Output( aText );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::canceled( const StatusCallbackEvent& rEvt )
{
	if (m_xMainExecutor == rEvt.Source)
	{
		m_xMainExecutor = 0;
		m_xMainExecutorCommandID = 0;
	}
	String aText( "Command canceled: '" );
	aText += U2S( rEvt.Name );
	aText += "'\n";
	Output( aText );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::error( const StatusCallbackEvent& rEvt, INT32 nError )
{
	String aText( "Command notifies error: '" );
	aText += nError;
	aText += "'\n";
	Output( aText );
}

//-------------------------------------------------------------------------
//virtual
void CntDemoClient::result( const StatusCallbackEvent& rEvt,
						    INT32 nAction, const UString& rResult )
{
	String aText("Got ");
	aText += convertAction(nAction);
	aText += " result: ";
	aText += U2S(rResult);
	aText += '\n';
	Output(aText);
}

//-------------------------------------------------------------------------
String CntDemoClient::convertAction(INT32 nAction)
{
	switch (nAction)
	{
		case Action_INSERTED:
			return "INSERTED";

		case Action_REMOVED:
			return "REMOVED";

		case Action_DELETED:
			return "DELETED";

		case Action_EXCHANGED:
			return "EXCHANGED";

		case Action_SEARCH_MATCHED:
			return "SEARCH-MATCHED";

		default:
			return nAction;
	}
}

//-------------------------------------------------------------------------
void CntDemoClient::Output( const String& rText )
{
	if ( m_pOutEdit )
	{
		String aText( m_pOutEdit->GetText() );
		aText += rText;
		m_pOutEdit->SetText( aText );
	}
}

/*========================================================================
 *
 * FileDataSource_Impl implementation.
 *
 *=======================================================================*/

void FileDataSource_Impl::broadcastEOF()
{
	if (!m_bEOFBroadcasted)
	{
		m_bEOFBroadcasted = TRUE;

		StreamConnectionEvent aEvent;
		aEvent.Source = (UsrObject *) this;

		ListenerIterator aIterator(m_aListeners);
		while (aIterator.hasMoreElements())
		{
			XStreamConnectionListener * pListener
			 = (XStreamConnectionListener *) aIterator.next();
			if (pListener)
				pListener->connectionClosed(aEvent);
		}
	}
}

//----------------------------------------------------------------------------
BOOL FileDataSource_Impl::broadcastError()
{
	ErrCode nError = m_pFileStream->GetError();
	if (!nError)
		return FALSE;

	StreamConnectionEvent aEvent;
	aEvent.Source = (UsrObject *) this;
	aEvent.Exception.set(new IOException, IOException_getReflection());

	ListenerIterator aIterator(m_aListeners);
	while (aIterator.hasMoreElements())
	{
		XStreamConnectionListener * pListener
		 = (XStreamConnectionListener *) aIterator.next();
		if (pListener)
			pListener->errorOccured(aEvent);
	}
	return TRUE;
}

//----------------------------------------------------------------------------
SMART_REFLECTION_IMPLEMENTATION(FileDataSource_Impl, UsrObject,
								L"FileDataSource_Impl");

//----------------------------------------------------------------------------
// virtual
BOOL FileDataSource_Impl::queryInterface(Uik aUIK, XInterfaceRef & rInterface)
{
	if (aUIK == XPassiveDataSource::getSmartUik())
	{
		rInterface = (XPassiveDataSource *) this;
		return TRUE;
	}
	else if (aUIK == XDataSource::getSmartUik())
	{
		rInterface = (XDataSource *) this;
		return TRUE;
	}
	return UsrObject::queryInterface(aUIK, rInterface);
}

//----------------------------------------------------------------------------
// virtual
Sequence<XIdlClassRef> FileDataSource_Impl::getIdlClasses()
{
//	NAMESPACE_VOS(OGuard) aGuard(NAMESPACE_VOS(OMutex)::getGlobalMutex());

	static XIdlClassRef
	 xClass(createStandardClass(L"FileDataSource_Impl",
								UsrObject::getUsrObjectIdlClass(), 1,
								XPassiveDataSource_getReflection()));
	return Sequence<XIdlClassRef>(&xClass, 1);
}

//----------------------------------------------------------------------------
// virtual
void FileDataSource_Impl::open() THROWS((IOException))
{
	if (!m_pFileStream && m_aFilePath.Len())
	{
		m_pFileStream = new SvFileStream(m_aFilePath, STREAM_STD_READ);
		broadcastError();
	}
}

//----------------------------------------------------------------------------
// virtual
void FileDataSource_Impl::close() THROWS(())
{
	DELETEZ(m_pFileStream);
}

//----------------------------------------------------------------------------
// virtual
void FileDataSource_Impl::setDataSink(const XDataSinkRef & rTheSink)
	THROWS(())
{
	if (m_xSink.is())
		m_xSink->flush();
	m_xSink = rTheSink;
}

//----------------------------------------------------------------------------
// virtual
INT32 FileDataSource_Impl::available() THROWS(())
{
	if (!m_pFileStream)
		return 0;

	ULONG nPos = m_pFileStream->Tell();
	ULONG nEnd = m_pFileStream->Seek(STREAM_SEEK_TO_END);
	m_pFileStream->Seek(nPos);
	DBG_ASSERT(nPos <= nEnd, "FileDataSource_Impl::available(): Bad pos");
	if (broadcastError())
		return 0;

	if (nPos == nEnd)
		broadcastEOF();

	return INT32(min(nEnd - nPos, 0x7FFFFFFF));
}

//----------------------------------------------------------------------------
// virtual
void FileDataSource_Impl::triggerSomeBytes(INT32 nMaxLength) THROWS(())
{
	if (!m_pFileStream)
		return;

	if (broadcastError())
		return;

	if (m_pFileStream->IsEof())
	{
		broadcastEOF();
		return;
	}

	if (nMaxLength <= 0 || !m_xSink)
		return;

	Sequence<BYTE> aBuffer(nMaxLength);
	ULONG nRead = m_pFileStream->Read(aBuffer.getArray(), ULONG(nMaxLength));
	DBG_ASSERT(nRead <= ULONG(nMaxLength),
			   "FileDataSource_Impl::triggerSomeBytes(): Bad read");
	aBuffer.realloc(INT32(nRead));
	m_xSink->write(aBuffer);
	broadcastError();
}

//----------------------------------------------------------------------------
// virtual
void FileDataSource_Impl::skipBytes(INT32 nOffset) THROWS(())
{
	if (nOffset > 0 && m_pFileStream)
	{
		m_pFileStream->SeekRel(nOffset);
		broadcastError();
	}
}

/*========================================================================
 *
 * FileDataSink_Impl implementation.
 *
 *=======================================================================*/

SMART_REFLECTION_IMPLEMENTATION(FileDataSink_Impl, UsrObject,
								L"FileDataSink_Impl");

//----------------------------------------------------------------------------
// virtual
BOOL FileDataSink_Impl::queryInterface(Uik aUIK, XInterfaceRef & rInterface)
{
	if (aUIK == XDataSink::getSmartUik())
	{
		rInterface = (XDataSink *) this;
		return TRUE;
	}
	return UsrObject::queryInterface(aUIK, rInterface);
}

//----------------------------------------------------------------------------
// virtual
Sequence<XIdlClassRef> FileDataSink_Impl::getIdlClasses()
{
//	NAMESPACE_VOS(OGuard) aGuard(NAMESPACE_VOS(OMutex)::getGlobalMutex());

	static XIdlClassRef
	 xClass(createStandardClass(L"FileDataSink_Impl",
								UsrObject::getUsrObjectIdlClass(), 1,
								XDataSink_getReflection()));
	return Sequence<XIdlClassRef>(&xClass, 1);
}

//----------------------------------------------------------------------------
// virtual
void FileDataSink_Impl::write(const Sequence<BYTE> & rBuffer)
	THROWS((IOException))
{
	if (!m_pFileStream && m_aFilePath.Len())
		m_pFileStream = new SvFileStream(m_aFilePath, STREAM_STD_WRITE);
	if (m_pFileStream)
	{
		m_pFileStream->Write(rBuffer.getConstArray(), rBuffer.getLen());
		if (m_pFileStream->GetError())
			THROW(IOException());
	}
}

//----------------------------------------------------------------------------
// virtual
void FileDataSink_Impl::flush() THROWS((IOException))
{
	if (m_pFileStream)
	{
		m_pFileStream->Flush();
		if (m_pFileStream->GetError())
			THROW(IOException());
	}
}

/*========================================================================
 *
 * MyWin.
 *
 *=======================================================================*/

#define MYWIN_ITEMID_CLEAR    	1
#define MYWIN_ITEMID_CREATE   	2
#define MYWIN_ITEMID_RELEASE   	3
#define MYWIN_ITEMID_COMMANDS 	4
#define MYWIN_ITEMID_PROPS 		5
#define MYWIN_ITEMID_GET_PROP	6
#define MYWIN_ITEMID_SET_PROP	7
#define MYWIN_ITEMID_SET_OPEN	8
#define MYWIN_ITEMID_VIEWS		9
#define MYWIN_ITEMID_SET_SEND	10
#define MYWIN_ITEMID_IMPORT		11
#define MYWIN_ITEMID_EXPORT		12
#define MYWIN_ITEMID_SEARCH		13
#define MYWIN_ITEMID_CANCEL		14

//-------------------------------------------------------------------------
class MyWin : public WorkWindow
{
private:
	ToolBox*			m_pTool;
	Edit*				m_pCmdEdit;
	MultiLineEdit*		m_pOutEdit;
	CntDemoClientRef	m_xClient;
	XSystemRef			m_xSystem;

public:
	MyWin( Window *pParent, WinBits nWinStyle );
	virtual ~MyWin();

	void Resize( void );
	DECL_LINK ( ToolBarHandler, ToolBox* );
};

//-------------------------------------------------------------------------
MyWin::MyWin( Window *pParent, WinBits nWinStyle )
: WorkWindow( pParent, nWinStyle ),
  m_pTool( NULL ),
  m_pOutEdit( NULL )
{
	//////////////////////////////////////////////////////////////////////
	// Initialize CHAOS.
	//////////////////////////////////////////////////////////////////////

	XMultiServiceFactoryRef xMgr( NAMESPACE_USR( getProcessServiceManager )() );
	if ( xMgr.Is() )
	{
		XInterfaceRef xRef = xMgr->createInstance( L"com.sun.star.chaos.System");
		if ( xRef.Is() )
			xRef->queryInterface( XSystem::getSmartUik(), m_xSystem );
	}

	// ToolBox.
	m_pTool = new ToolBox( this, WB_SVLOOK | WB_BORDER );

	m_pTool->InsertItem ( MYWIN_ITEMID_CLEAR, "Clear" );
	m_pTool->SetHelpText( MYWIN_ITEMID_CLEAR, "Clear the Output Window" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_CREATE, "Create" );
	m_pTool->SetHelpText( MYWIN_ITEMID_CREATE, "Create a new anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_RELEASE, "Release" );
	m_pTool->SetHelpText( MYWIN_ITEMID_RELEASE, "Release current anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_VIEWS, 	"Views" );
	m_pTool->SetHelpText( MYWIN_ITEMID_VIEWS,
						  "Get Views known to the system" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_COMMANDS, "Commands" );
	m_pTool->SetHelpText( MYWIN_ITEMID_COMMANDS,
						  "Get Commands supported by anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_PROPS, "Properties" );
	m_pTool->SetHelpText( MYWIN_ITEMID_PROPS,
						  "Get Properties supported by anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_GET_PROP, "getProperty" );
	m_pTool->SetHelpText( MYWIN_ITEMID_GET_PROP,
						  "Get a Property from anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_SET_PROP, "setProperty" );
	m_pTool->SetHelpText( MYWIN_ITEMID_SET_PROP,
						  "Set a Property in anchor" );
	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_SET_OPEN, "Open" );
	m_pTool->SetHelpText( MYWIN_ITEMID_SET_OPEN, "Open the anchor" );

	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_SET_SEND, "Send eMail" );
	m_pTool->SetHelpText( MYWIN_ITEMID_SET_SEND, "Sends an eMail" );

	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_IMPORT, "Import" );
	m_pTool->SetHelpText( MYWIN_ITEMID_IMPORT, "Import from mbx format" );

	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_EXPORT, "Export" );
	m_pTool->SetHelpText( MYWIN_ITEMID_EXPORT, "Export to mbx format" );

	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_SEARCH, "Search" );
	m_pTool->SetHelpText( MYWIN_ITEMID_SEARCH, "Search the anchor" );

	m_pTool->InsertSeparator();
	m_pTool->InsertItem ( MYWIN_ITEMID_CANCEL, "Cancel" );
	m_pTool->SetHelpText( MYWIN_ITEMID_CANCEL, "Cancel the current command" );

	m_pTool->SetClickHdl( LINK( this, MyWin, ToolBarHandler ) );
	m_pTool->Show();

	// Edit.
	m_pCmdEdit = new Edit( this );
	m_pCmdEdit->SetReadOnly( FALSE );
	m_pCmdEdit->Show();

	// MultiLineEdit.
	m_pOutEdit = new MultiLineEdit( this, WB_HSCROLL | WB_VSCROLL | WB_BORDER );
	m_pOutEdit->SetReadOnly( TRUE );
	m_pOutEdit->Show();
}

//-------------------------------------------------------------------------
// virtual
MyWin::~MyWin()
{
	if ( m_xClient.Is() )
		m_xClient->dispose();

	delete m_pTool;
	delete m_pCmdEdit;
	delete m_pOutEdit;
}

//-------------------------------------------------------------------------
void MyWin::Resize()
{
	Size aWinSize = GetOutputSizePixel();
	int nWinW = aWinSize.Width();
	int nWinH = aWinSize.Height();
	int nBoxH = m_pTool->CalcWindowSizePixel().Height();

	m_pTool->SetPosSizePixel   (
		Point( 0, 0 ), Size ( nWinW, nBoxH ) );
	m_pCmdEdit->SetPosSizePixel(
		Point( 0, nBoxH ), Size( nWinW, nBoxH ) );
	m_pOutEdit->SetPosSizePixel(
		Point( 0, nBoxH + nBoxH ), Size ( nWinW, nWinH - ( nBoxH + nBoxH ) ) );
}

//-------------------------------------------------------------------------
IMPL_LINK( MyWin, ToolBarHandler, ToolBox*, pToolBox )
{
	USHORT nItemId  = pToolBox->GetCurItemId();
	String aCmdLine = m_pCmdEdit->GetText();

	switch( nItemId )
	{
		case MYWIN_ITEMID_CLEAR:
			m_pOutEdit->SetText( '\0' );
			break;

		case MYWIN_ITEMID_CREATE:
			if ( m_xClient.Is() )
				m_xClient->dispose();

			m_xClient = CntDemoClient::create( NULL, aCmdLine, m_pOutEdit );
			break;

		case MYWIN_ITEMID_RELEASE:
			if ( m_xClient.Is() )
				m_xClient->dispose();

			m_xClient = CntDemoClientRef();
			break;


		case MYWIN_ITEMID_COMMANDS:
			if ( m_xClient.Is() )
				m_xClient->getCommands();

			break;

		case MYWIN_ITEMID_PROPS:
			if ( m_xClient.Is() )
				m_xClient->getProperties();

			break;

		case MYWIN_ITEMID_GET_PROP:
			if ( m_xClient.Is() )
			{
				UString aName( L"Title" );

				m_xClient->getStringPropertyValue( aName );
			}
			break;

		case MYWIN_ITEMID_SET_PROP:
			if ( m_xClient.Is() )
			{
				UString aName ( L"Title" );
				UString aTitle( L"NewTitle" );

				m_xClient->setStringPropertyValue( aName, aTitle );
			}
			break;

		case MYWIN_ITEMID_SET_OPEN:
			if ( m_xClient.Is() )
				m_xClient->open();

			break;

		case MYWIN_ITEMID_SET_SEND:
		{
			if ( !m_xSystem.Is() )
				break;

			// All known views to OutBoxes.
			Sequence<UString> aViews =
						m_xSystem->queryViews( UString(), L".chaos/out-box" );

			String aText( m_pOutEdit->GetText() );
			ULONG nCount = aViews.getLen();

			if ( nCount )
			{
				aText += "Outboxes found:\n";
				for ( ULONG n = 0; n < nCount; ++n )
				{
					aText += '\t';
					aText += U2S( aViews.getArray()[ n ] );
					aText += '\n';
				}

				if ( m_xClient.Is() )
					m_xClient->dispose();

				m_xClient = CntDemoClient::create(
					NULL, U2S( aViews.getArray()[ 0 ] ), m_pOutEdit );

				m_xClient->sendMessage();
			}
			else
				aText += "No Outboxes found!\n";

			m_pOutEdit->SetText( aText );

			break;
		}

		case MYWIN_ITEMID_VIEWS:
		{
			if ( !m_xSystem.Is() )
				break;

			// All known views in all directories.
			Sequence<UString> aViews =
						m_xSystem->queryViews( UString(), UString() );

			String aText( m_pOutEdit->GetText() );
			aText += "Views:\n";
			ULONG nCount = aViews.getLen();
			for ( ULONG n = 0; n < nCount; ++n )
			{
				aText += '\t';
				aText += U2S( aViews.getArray()[ n ] );
				aText += '\n';
			}
			m_pOutEdit->SetText( aText );
			break;
		}

		case MYWIN_ITEMID_IMPORT:
			if (m_xClient.is())
				m_xClient->doImport(aCmdLine);
			break;

		case MYWIN_ITEMID_EXPORT:
			if (m_xClient.is())
				m_xClient->doExport(aCmdLine);
			break;

		case MYWIN_ITEMID_SEARCH:
			if (m_xClient.is())
				m_xClient->doSearch(aCmdLine);
			break;

		case MYWIN_ITEMID_CANCEL:
			if (m_xClient.is())
				m_xClient->doCancel();
			break;

		default: // Ignored.
			break;
	}

	return 0;
}

/*========================================================================
 *
 * MyApp.
 *
 *=======================================================================*/
class MyApp : public Application
{
public:
	virtual void Main();
};

MyApp aMyApp;

//-------------------------------------------------------------------------
// virtual
void MyApp::Main()
{
	Help::EnableBalloonHelp();

	//////////////////////////////////////////////////////////////////////
	// Create Manager for UNO services.
	//////////////////////////////////////////////////////////////////////

	createAndSetDefaultServiceManager();

	//////////////////////////////////////////////////////////////////////
	// Initialize CHAOS... ( will no longer be necessary in the future )
	//////////////////////////////////////////////////////////////////////

	CntSystem::Initialize();

	//////////////////////////////////////////////////////////////////////
	// Create Application Window...
	//////////////////////////////////////////////////////////////////////

	MyWin *pMyWin = new MyWin( NULL, WB_APP | WB_STDWORK );
	pMyWin->SetText( "CHAOS StarONE-API Demo/Test" );
	pMyWin->Show();

	//////////////////////////////////////////////////////////////////////
	// Go...
	//////////////////////////////////////////////////////////////////////

	EnterMultiThread( TRUE );
	Execute();
	EnterMultiThread( FALSE );

	//////////////////////////////////////////////////////////////////////
	// Destroy Application Window...
	//////////////////////////////////////////////////////////////////////

	delete pMyWin;

	//////////////////////////////////////////////////////////////////////
	// De-Initialize CHAOS... ( will no longer be necessary in the future )
	//////////////////////////////////////////////////////////////////////

	CntSystem::Deinitialize();
}

