/*************************************************************************
 *
 *  $RCSfile: extdisp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//#include <docobj.h>
//#include <wininet.h>
#if _MSC_VER < 1200
//#include <wtypes.h>
//#include "msdev6.inc/exmisc.hxx"
//#include "msdev6.inc/exdispid.h"
//#include "msdev6.inc/mshtmcid.h"
#else
#include <exdisp.h>
//#include <exdispid.h>
//#include <mshtmcid.h>
#endif

//  #ifdef UDK
  #include <osl/diagnose.h>
//  #else
//  #include <tools/debug.hxx>
//  #endif



//  #include "metric.hxx"
//#include <ie/iewebb.hxx>
#include <ie/ctrl.hxx>
#include "extdisp.hxx"

using namespace rtl;

ExternalDispatch::ExternalDispatch(const com::sun::star::uno::Reference<com::sun::star::lang::XMultiServiceFactory> & rMSF): m_multiServiceFactory( rMSF)
{
}

ExternalDispatch::~ExternalDispatch()
{
//  #ifdef UDK
	OSL_TRACE("External dispatch is being destroyed \n");
//  #else
//  	DBG_TRACE("External dispatch is being destroyed \n");
//  #endif
}

// Currently not supported. Take this as an example of how to use
// the OleBridgeSupplier.
// Creates a COM object that wraps an UNO object of type "name"
//BOOL ExternalDispatch::createBridge( UString& name, VARIANT* pvarResult)
//{
//	// No pvarResult means, in the script is no variable that takes the result
//	// of the function that call induced the call to Invoke.
//	if( ! pvarResult) return TRUE;
//
//	BOOL bretVal= FALSE;
//	XInterfaceRef xInstance;
//	if (m_multiServiceFactory.is()) // XServiceProvider
//	{
//		XInterfaceRef xInt = m_multiServiceFactory->createInstance(L"com.sun.star.bridge.OleBridgeSupplier");
//		XBridgeSupplierRef m_bridgeSupplier;
//		if (xInt.is())
//			xInt->queryInterface(XBridgeSupplier::getSmartUik(), m_bridgeSupplier);
//		xInstance = m_multiServiceFactory->createInstance(name);
//	
//		if (xInstance.is() && m_bridgeSupplier.is())
//		{
//			UsrAny usrAny(&xInstance, XInterface_getReflection());
//			UsrAny oleAny = m_bridgeSupplier->createBridge(usrAny,
//														   getMachineId(),
//														   getProcessId(),
//														   ModelDependent_UNO,
//														   ModelDependent_OLE);
//														
//
//			if (oleAny.getReflection() == UINT32_getReflection())
//			{
//				VARIANT* pVariant = (VARIANT*)oleAny.getUINT32();
//				::VariantCopy(pvarResult, pVariant);
//				::VariantClear( pVariant); // taken from Torstens implementation somewhere
//				::CoTaskMemFree(pVariant); // - " -
//				bretVal= TRUE;
//			}
//		}
//	}
//	return bretVal;
//}

// Wraps the XMultiServiceFactory that was passed in "exService_getFactory"
// and copies the object to param "pvarResult"
//BOOL ExternalDispatch::getBridgedFactory( VARIANT* pvarResult)
//{
//	// No pvarResult means, in the script is no variable that takes the result
//	// of the function that call induced the call to Invoke.
//	if( ! pvarResult) return TRUE;
//
//	BOOL bretVal= FALSE;
//	if (m_multiServiceFactory.is()) // XServiceProvider
//	{
//		XInterfaceRef xInt = m_multiServiceFactory->createInstance(L"com.sun.star.bridge.OleBridgeSupplier");
//		XBridgeSupplierRef m_bridgeSupplier;
//		if (xInt.is())
//			xInt->queryInterface(XBridgeSupplier::getSmartUik(), m_bridgeSupplier);
//	
//		if ( m_bridgeSupplier.is())
//		{
//			UsrAny usrAny(&m_multiServiceFactory, XInterface_getReflection());
//			UsrAny oleAny = m_bridgeSupplier->createBridge(usrAny,
//														   getMachineId(),
//														   getProcessId(),
//														   ModelDependent_UNO,
//														   ModelDependent_OLE);
//														
//
//			if (oleAny.getReflection() == UINT32_getReflection())
//			{
//				VARIANT* pVariant = (VARIANT*)oleAny.getUINT32();
//				::VariantCopy(pvarResult, pVariant);
//				::VariantClear( pVariant); // taken from Torstens implementation somewhere
//				::CoTaskMemFree(pVariant); // - " -
//				bretVal= TRUE;
//			}
//		}
//	}
//	return bretVal;
//}

//##################################################################################################
//#### IUnknown ####################################################################################
//##################################################################################################
//__________________________________________________________________________________________________
STDMETHODIMP ExternalDispatch::QueryInterface( THIS_ REFIID riid, LPVOID FAR * ppvObj )
{
	if (::IsEqualIID( riid, IID_IDispatch )		||
		::IsEqualIID( riid, IID_IUnknown )		)
	{
		AddRef();
		*ppvObj = (IDispatch *)this;
	}
	else
		*ppvObj = NULL;

	return *ppvObj ? S_OK : E_NOINTERFACE;
}
//__________________________________________________________________________________________________
STDMETHODIMP_(ULONG) ExternalDispatch::AddRef(VOID)
{
	OWeakObject::acquire();
	return OWeakObject::m_refCount;
}
//__________________________________________________________________________________________________
STDMETHODIMP_(ULONG) ExternalDispatch::Release(VOID)
{
	UINT32 nRef = OWeakObject::m_refCount;
	OWeakObject::release();
	return --nRef;
}

//##################################################################################################
//#### IDispatch ###################################################################################
//##################################################################################################
//__________________________________________________________________________________________________
STDMETHODIMP ExternalDispatch::GetIDsOfNames(
	REFIID riid, LPOLESTR FAR * rgszNames, UINT cNames, LCID lcid, DISPID FAR * rgdispid )
{
	DISPID id = 0;
	OUString sName;
	if(cNames != 1) return DISP_E_UNKNOWNNAME;

	sName= rgszNames[0];
	sName= sName.toLowerCase();

	if(  sName == L"desktop")
		id= 1;
	else if( sName == L"factory")
		id=2;
	else if(sName == L"oletestcontrol")
		id=3;

	rgdispid[0]= id;

	return id != 0 ? S_OK : DISP_E_UNKNOWNNAME;
}
//__________________________________________________________________________________________________
STDMETHODIMP ExternalDispatch::GetTypeInfoCount( UINT FAR * pctinfo )
{
	return E_NOTIMPL;
}
//__________________________________________________________________________________________________
STDMETHODIMP ExternalDispatch::GetTypeInfo( UINT itinfo, LCID lcid,
													ITypeInfo FAR * FAR * pptinfo )
{
	return E_NOTIMPL;
}
//__________________________________________________________________________________________________
STDMETHODIMP ExternalDispatch::Invoke(
	DISPID           dispidMember,
	REFIID           riid,
	LCID             lcid,
	WORD             wFlags,
	DISPPARAMS FAR * pdispparams,
	VARIANT    FAR * pvarResult,
	EXCEPINFO  FAR * pExcepInfo,
	UINT       FAR * puArgErr )
{
	
    switch (dispidMember)
	{
	case 1:		// sent when a new window should be created
//		if(! createBridge( UString(L"com.sun.star.frame.Desktop"), pvarResult))
//			return DISP_E_EXCEPTION;		
		break;
	case 2:
//		if( ! getBridgedFactory( pvarResult))
//			return DISP_E_EXCEPTION;
		break;
	case 3: // OleTest component
//		if(! createBridge( UString(L"oletest.OleTest"), pvarResult))
//			return DISP_E_EXCEPTION;
		break;
	default: break;
	}
	
	return S_OK;
}
// ####################################################################################################
IDispatch* ExternalDispatch::GetDispatch()
{
	DWORD off= (DWORD) static_cast<IDispatch*>( (ExternalDispatch*)8 )  -8 ;
	return (IDispatch*) ((DWORD)this + off);
}
//-----------------------------------------------------------------------------
//Uik getMachineId()
//{
//	static sal_Bool bInit = False;
//	static Uik    myMachineId;
//	
//	if (!bInit)
//	{
//		UNO_Uik unoMachineId = UNO_getMachineIdentifier();
//		uno2smart(myMachineId, unoMachineId);
//		
//		bInit = True;
//	}
//
//	return myMachineId;
//}	
//
//sal_Int32 getProcessId()
//{
//	static sal_Bool bInit = False;
//	static sal_Int32  myProcessId;
//	
//	if (!bInit)
//	{
//		Long unoProcessId = (Long)UNO_getProcessIdentifier();
//		uno2smart(myProcessId, unoProcessId);
//		
//		bInit = True;
//	}
//
//	return myProcessId;
//}	

