#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=ie
TARGET=olecontr
USE_DEFFILE=TRUE

# from cppumaker --------------------------------------------------
UNOUCRDEP=	$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=	$(SOLARBINDIR)$/applicat.rdb

UNOUCROUT=	$(OUT)$/inc
INCPRE+=	$(OUT)$/inc


# --- Settings -----------------------------------------------------
ENABLE_EXCEPTIONS=TRUE

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk


#----------------------------------------------------------------

.IF "$(GUI)" == "WNT"

UNOTYPES= \
	com.sun.star.frame.XFramesSupplier \
	com.sun.star.frame.XDispatchProviderInterceptor \
	com.sun.star.uno.TypeClass \
	com.sun.star.frame.FrameSearchFlag \
	com.sun.star.frame.XDispatchProviderInterception \
	com.sun.star.frame.XStorable \
	com.sun.star.frame.XModel \
	com.sun.star.frame.XFrameActionListener \
	com.sun.star.frame.XComponentLoader \
	com.sun.star.frame.XFrame \
	com.sun.star.frame.FrameActionEvent \
	com.sun.star.frame.FrameAction \
	com.sun.star.task.XStatusIndicatorFactory \
	com.sun.star.task.XStatusIndicatorSupplier \
	com.sun.star.task.XStatusIndicator \
	com.sun.star.view.XControlAccess \
	com.sun.star.view.XSelectionChangeListener \
	com.sun.star.view.DocumentZoomType \
	com.sun.star.view.XScreenCursor \
	com.sun.star.view.XViewSettingsSupplier \
	com.sun.star.view.XSelectionSupplier \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.lang.XUnoTunnel \
	com.sun.star.awt.XAdjustmentListener \
	com.sun.star.awt.XActionListener \
	com.sun.star.awt.XTextListener \
	com.sun.star.awt.XSpinListener \
	com.sun.star.awt.XItemListener \
	com.sun.star.awt.XVclContainerListener \
	com.sun.star.util.URL \
	com.sun.star.lang.XEventListener \
	com.sun.star.uno.XWeak \
	com.sun.star.uno.XAggregation

SLOFILES = \
	$(SLO)$/olecontr.obj	\
	$(SLO)$/himetric.obj

#SHL1TARGET= 	$(TARGET)$(UPD)$(DLLPOSTFIX)
#SHL1STDLIBS=\
#    $(SALLIB) 	\
#	$(CPPULIB)	\
#	$(CPPUHELPERLIB)	\
#	$(LIBCIMT) 	\
#	ole32.lib 	\
#	uuid.lib 	\
#	oleaut32.lib


#        $(USRLIB) 	\


#SHL1LIBS = $(SLB)$/$(TARGET).lib

#SHL1DEF=$(MISC)$/$(SHL1TARGET).def



.ENDIF
# ------------------------------------------------------------------

.INCLUDE :  target.mk
#.INCLUDE :  $(PRJ)$/util$/target.pmk


