#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:31:56 $
#
#   Copyright according the GNU Public License.
#
#*************************************************************************
PRJ=..

PRJNAME=officecfg
TARGET=data

.INCLUDE :  settings.mk
.INCLUDE :  $(PRJ)$/util$/makefile.pmk

# --- Targets ------------------------------------------------------

XMLCFGINSTANCE= \
	$(MISC)$/org.openoffice.Office.Calc.ins \
	$(MISC)$/org.openoffice.Office.Chart.ins \
	$(MISC)$/org.openoffice.Office.Common.ins \
	$(MISC)$/org.openoffice.Office.DataAccess.ins \
	$(MISC)$/org.openoffice.Office.Draw.ins \
	$(MISC)$/org.openoffice.Office.Impress.ins \
	$(MISC)$/org.openoffice.Office.Java.ins \
	$(MISC)$/org.openoffice.Office.Linguistic.ins \
	$(MISC)$/org.openoffice.Office.Math.ins \
	$(MISC)$/org.openoffice.Office.Writer.ins \
	$(MISC)$/org.openoffice.Office.WriterWeb.ins \
	$(MISC)$/org.openoffice.ucb.Hierarchy.ins \
	$(MISC)$/org.openoffice.Inet.ins \
	$(MISC)$/org.openoffice.Setup.ins \
	$(MISC)$/org.openoffice.UserProfile.ins

XMLCFGSCHEMA= \
	$(MISC)$/org.openoffice.Office.Calc.xsd \
	$(MISC)$/org.openoffice.Office.Chart.xsd \
	$(MISC)$/org.openoffice.Office.Common.xsd \
	$(MISC)$/org.openoffice.Office.DataAccess.xsd \
	$(MISC)$/org.openoffice.Office.Draw.xsd \
	$(MISC)$/org.openoffice.Office.Impress.xsd \
	$(MISC)$/org.openoffice.Office.Java.xsd \
	$(MISC)$/org.openoffice.Office.Linguistic.xsd \
	$(MISC)$/org.openoffice.Office.Math.xsd \
	$(MISC)$/org.openoffice.Office.Writer.xsd \
	$(MISC)$/org.openoffice.Office.WriterWeb.xsd \
	$(MISC)$/org.openoffice.ucb.Hierarchy.xsd \
	$(MISC)$/org.openoffice.Inet.xsd \
	$(MISC)$/org.openoffice.Setup.xsd \
	$(MISC)$/org.openoffice.UserProfile.xsd

XMLCFGTEMPLATE= \
	$(MISC)$/org.openoffice.Office.Calc.tpl \
	$(MISC)$/org.openoffice.Office.Chart.tpl \
	$(MISC)$/org.openoffice.Office.Common.tpl \
	$(MISC)$/org.openoffice.Office.DataAccess.tpl \
	$(MISC)$/org.openoffice.Office.Draw.tpl \
	$(MISC)$/org.openoffice.Office.Impress.tpl \
	$(MISC)$/org.openoffice.Office.Java.tpl \
	$(MISC)$/org.openoffice.Office.Linguistic.tpl \
	$(MISC)$/org.openoffice.Office.Math.tpl \
	$(MISC)$/org.openoffice.Office.Writer.tpl \
	$(MISC)$/org.openoffice.Office.WriterWeb.tpl \
	$(MISC)$/org.openoffice.ucb.Hierarchy.tpl \
	$(MISC)$/org.openoffice.Inet.tpl \
	$(MISC)$/org.openoffice.Setup.tpl \
	$(MISC)$/org.openoffice.UserProfile.tpl	

TEMPLATEMERGE=$(MISC)$/org.openoffice.Templates.ins 
	
all: \
	$(XMLCFGINSTANCE) \
	$(XMLCFGTEMPLATE) \
	$(XMLCFGSCHEMA) \
	$(TEMPLATEMERGE) \
	
.INCLUDE :  target.mk

.IF "$(TEMPLATEMERGE)" != ""
$(TEMPLATEMERGE) : $(XMLCFGTEMPLATE)
	perl $(PRJ)$/util$/template.gen $(MISC)$ $@
.ENDIF

