/*************************************************************************
 *
 *  $RCSfile: resid.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef PRECOMPILED
#include <segmentc.hxx>
#endif

#ifndef _TOOLS_SIMPLERESMGR_HXX_
#include <tools/simplerm.hxx>
#endif

#ifndef _OFF_APP_HXX
#include "app.hxx"
#endif

#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

//========================================================================

SEG_EOFGLOBALS()

//========================================================================

OffResId::OffResId( USHORT nId )
: 	ResId(nId, OFF_APP()->GetOffResManager())
{
}


//========================================================================
OfsStringRes::OfsStringRes(USHORT _nId)
	:m_sValue(OFF_APP()->GetOffSimpleResManager()->ReadString(_nId))
{
}


/*========================================================================

	$Log: resid.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:32:49  hr
	initial import
	
	Revision 1.6  2000/09/17 12:15:06  willem.vandorp
	OpenOffice header added.
	
	Revision 1.5  2000/08/30 11:03:14  willem.vandorp
	Header and footer replaced
	
	Revision 1.4  1999/12/20 10:08:09  fs
	#71018# OfsStringRes
	
	Revision 1.3  1999/06/09 13:41:52  MBA
	OFF_APP() verwenden
	

	  Rev 1.2   09 Jun 1999 15:41:52   MBA
   OFF_APP() verwenden

	  Rev 1.1   16 Oct 1996 11:54:04   OS
   Precompiled Header vollstaendig

	  Rev 1.0   24 Feb 1996 13:11:30   MI
   Initial revision.

========================================================================*/

#pragma SEG_EOFMODULE

