/*************************************************************************
 *
 *  $RCSfile: sbaw16.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: fs $ $Date: 2000/09/26 15:40:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef WIN
#include <svwin.h>
#endif


#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif

#ifndef _SBADLL_HXX
#include "sbadll.hxx"
#endif

#include <sbaobj.hxx>

#include "dbfileob.hxx"
#include "qryds.hxx"

//Unter Win16 gibt es Unresolves -> Dummy implementation
#if defined (WIN)

SbaDBObj::~SbaDBObj()
{
	DBG_ERROR("W16-Hack failed!");
}

TypeId SbaDBObj::Type() const
{
	DBG_ERROR("W16-Hack failed!");
	return 0L;
}

String SbaDBObj::ToURL() const
{
	DBG_ERROR("W16-Hack failed!");
	return String();
}

BOOL SbaDBObj::IsA( TypeId aSameOrSuperType ) const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

SbaDBDataObj::~SbaDBDataObj()
{
	DBG_ERROR("W16-Hack failed!");
}

BOOL SbaDBDataObj::Open()
{
	DBG_ERROR("W16-Hack failed!");
	return 0L;
}

TypeId SbaDBDataObj::Type() const
{
	DBG_ERROR("W16-Hack failed!");
	return 0L;
}

BOOL SbaDBDataObj::IsA( TypeId aSameOrSuperType ) const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

void SbaDBDataObj::ReInit(const String& rSQLStatement, DBDataOpen eOpen)
{
	DBG_ERROR("W16-Hack failed!");
}

BOOL SbaDBDataObj::Prepare()
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataObj::IsPrepared() const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataObj::IsOpen() const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataObj::Rename(const String& rNewName)
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataObj::IsModified() const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataObj::Drop()
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

void SbaDBDataObj::Close()
{
	DBG_ERROR("W16-Hack failed!");
}


//------------------------------------------------------------------------------
BOOL SbaFileDef::Open()
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

void SbaFileDef::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType )
{
	DBG_ERROR("W16-Hack failed!");
}

//------------------------------------------------------------------------------
BOOL SbaFileDef::Rename(const String& rNewName)
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

#pragma SEG_FUNCDEF(DBFILEOB_1a)
//------------------------------------------------------------------------------
BOOL SbaFileDef::Drop()
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

#pragma SEG_FUNCDEF(DBFILEOB_1b)
//------------------------------------------------------------------------------
void SbaFileDef::Close()
{
	DBG_ERROR("W16-Hack failed!");
}

#pragma SEG_FUNCDEF(DBFILEOB_1c)
//-------------------------------------------------------------------------
String SbaFileDef::ToURL() const
{
	String aString;
	DBG_ERROR("W16-Hack failed!");
	return aString;
}

#pragma SEG_FUNCDEF(DBFILEOB_1d)
//-------------------------------------------------------------------------
BOOL SbaFileDef::Save()
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}

BOOL SbaFileDef::IsOpen() const
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;

}
BOOL SbaFileDef::IsModified() const {return bIsNew;}

//-------------------------------------------------------------------------
BOOL SbaFileDef::Update(const String& rFile)
{
	DBG_ERROR("W16-Hack failed!");
	return FALSE;
}


void SbaFileDef::AddDoc(const DirEntry& rFile, BOOL bForUpdate)
{
	DBG_ERROR("W16-Hack failed!");

}

void SbaFileDef::UpdateDoc(SfxMedium* pMedium)
{
	DBG_ERROR("W16-Hack failed!");

}
void SbaFileDef::RemoveDoc()
{
	DBG_ERROR("W16-Hack failed!");

}

#endif

#if defined (ICC) || defined (SOLARIS)

SbaQueryDocSh::~SbaQueryDocSh()
{
	DBG_ERROR("ICC-Hack failed!");
}


BOOL SbaQueryDocSh::_SaveImpl()
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::GetState( SfxItemSet& )
{
	DBG_ERROR("ICC-Hack failed!");
}

SfxInterface* SbaQueryDocSh::GetInterface() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

#ifndef SOLARIS
BOOL SbaQueryDocSh::IsA(void*()) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#else
BOOL SbaQueryDocSh::IsA(TypeId) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#endif

TypeId SbaQueryDocSh::Type() const
{
	DBG_ERROR("ICC-Hack failed!");
	return TypeId();
}
void SbaDBDefDocShExt::SetDocTitle()
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::ConvertFrom( SfxMedium& )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataDefDocSh::Refresh()
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaDBDefDocShExt::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}

USHORT SbaDBDataDefDocSh::PrepareClose( unsigned char bUI, unsigned char bForBrowsing )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::Execute(SfxRequest&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::InitNew(SvStorage*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaQueryDocSh::ConvertFrom( SfxMedium& )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::Save(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaQueryDocSh::InitNew(SvStorage*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaDBDefDocShExt::SaveAs(const SbaDBDefRef&)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

#ifndef SOLARIS
BOOL SbaJoinDocShExt::SaveData(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaJoinDocShExt::LoadUI(SvStream&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaJoinDocShExt::CheckTabWinData(const SbaJoinTabWinData*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#endif

SbaJoinTabWinData* SbaQueryDocSh::CreateTabWinDataObj(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

#ifndef SOLARIS
BOOL SbaJoinDocShExt::LoadData(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaJoinDocShExt::SaveUI(SvStream&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaJoinDocShExt::ConvertFrom(SfxMedium&) {
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#endif

#ifndef SOLARIS
BOOL SbaJoinDocShExt::IsA(void*()) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#else
/*BOOL SbaJoinDocShExt::IsA(TypeId) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}*/
#endif

#ifndef SOLARIS
BOOL SbaJoinDocShExt::InitNew(SvStorage*) {
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

SbaJoinTabWinData* SbaJoinDocShExt::CreateTabWinDataObj(void) {
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

TypeId SbaJoinDocShExt::Type(void) const
{
	DBG_ERROR("ICC-Hack failed!");
	return TypeId();
}
#endif

BOOL SbaDBDefDocShExt::PrepareSaveAs(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

const UINT16 SbaQueryDocSh::QUERY_UI_TABWIN_TAG = 0;
const UINT16 SbaJoinDocShExt::SBA_JOIN_UI_TABWIN_TAG = 0;

#endif

#if defined (LINUX)
#ifdef DBG_UTIL
SbaTabFieldFormat::SbaTabFieldFormat(unsigned long)
{
	DBG_ERROR("ICC-Hack failed!");
}
#endif

SbaQueryDocSh::~SbaQueryDocSh()
{
	DBG_ERROR("ICC-Hack failed!");
}


BOOL SbaQueryDocSh::_SaveImpl()
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::GetState( SfxItemSet& )
{
	DBG_ERROR("ICC-Hack failed!");
}

SfxInterface* SbaQueryDocSh::GetInterface() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

BOOL SbaQueryDocSh::IsA(TypeId) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

TypeId SbaQueryDocSh::Type() const
{
	DBG_ERROR("ICC-Hack failed!");
	return TypeId();
}

SbaQueryDef* SbaQueryDocSh::GetQueryDef() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

SbaTableDef* SbaQueryDocSh::GetTableDef() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

void SbaDBDefDocShExt::SetDocTitle()
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::ConvertFrom( SfxMedium& )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaDBDataDefDocSh::Refresh()
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaDBDefDocShExt::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}

USHORT SbaDBDataDefDocSh::PrepareClose( unsigned char bUI, unsigned char bForBrowsing )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::Execute(SfxRequest&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::InitNew(SvStorage*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaQueryDocSh::ConvertFrom( SfxMedium& )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaQueryDocSh::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}

BOOL SbaDBDataDefDocSh::Save(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaQueryDocSh::InitNew(SvStorage*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaDBDefDocShExt::SaveAs(const SbaDBDefRef&)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaTabFieldFormatList::DeleteAll()
{
	DBG_ERROR("ICC-Hack failed!");
}

ULONG SbaTabFieldFormatList::GetTabFieldWidth( USHORT nIndex )
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

SbaJoinTabWinData* SbaQueryDocSh::CreateTabWinDataObj(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}
BOOL SbaDBDefDocShExt::PrepareSaveAs(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

const UINT16 SbaQueryDocSh::QUERY_UI_TABWIN_TAG = 0;
const UINT16 SbaJoinDocShExt::SBA_JOIN_UI_TABWIN_TAG = 0;

#endif

#if defined (MAC)
void SbaQueryDocSh::Execute(SfxRequest&)
{
	DBG_ERROR("ICC-Hack failed!");
}
void SbaQueryDocSh::GetState( SfxItemSet& )
{
	DBG_ERROR("ICC-Hack failed!");
}
BOOL SbaQueryDocSh::InitNew(SvStorage*)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
BOOL SbaQueryDocSh::_SaveImpl()
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
void SbaQueryDocSh::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}
BOOL SbaDBDataDefDocSh::Save(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
USHORT SbaDBDataDefDocSh::PrepareClose( unsigned char bUI, unsigned char bForBrowsing )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
BOOL SbaQueryDocSh::ConvertFrom( SfxMedium& )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
SfxInterface* SbaQueryDocSh::GetInterface() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}
SbaQueryDocSh::~SbaQueryDocSh()
{
	DBG_ERROR("ICC-Hack failed!");
}
BOOL SbaQueryDocSh::IsA(void * (*)()) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
TypeId SbaQueryDocSh::Type() const
{
	DBG_ERROR("ICC-Hack failed!");
	return TypeId();
}
BOOL SbaDBDefDocShExt::SaveAs(const SbaDBDefRef&)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
void SbaDBDefDocShExt::SetDocTitle()
{
	DBG_ERROR("ICC-Hack failed!");
}
void SbaDBDefDocShExt::Notify(SfxBroadcaster&, const SfxHint&)
{
	DBG_ERROR("ICC-Hack failed!");
}
#endif // MAC

#if defined(SOLARIS) && defined(GCC)
#ifdef DBG_UTIL
SbaTabFieldFormat::SbaTabFieldFormat(unsigned long)
{
	DBG_ERROR("ICC-Hack failed!");
}	
#endif
void SbaTabFieldFormatList::DeleteAll()
{
	DBG_ERROR("ICC-Hack failed!");
}

ULONG SbaTabFieldFormatList::GetTabFieldWidth( USHORT nIndex )
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}
SbaQueryDef* SbaQueryDocSh::GetQueryDef() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}

SbaTableDef* SbaQueryDocSh::GetTableDef() const
{
	DBG_ERROR("ICC-Hack failed!");
	return 0L;
}
#endif
