/*************************************************************************
 *
 *  $RCSfile: user.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma warning (once : 4237)
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFX_PASSWD_HXX
#include <sfx2/passwd.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASETABLEFACTORY_HPP_
#include <com/sun/star/data/XDatabaseTableFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XFASTPROPERTYSET_HPP_
#include <com/sun/star/beans/XFastPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEWORKSPACE_HPP_
#include <com/sun/star/data/XDatabaseWorkspace.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEENGINE_HPP_
#include <com/sun/star/data/XDatabaseEngine.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASENAMECONTAINER_HPP_
#include <com/sun/star/data/XDatabaseNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEFIELDDESCRIPTORFACTORY_HPP_
#include <com/sun/star/data/XDatabaseFieldDescriptorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEINDEXFACTORY_HPP_
#include <com/sun/star/data/XDatabaseIndexFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASERELATIONFACTORY_HPP_
#include <com/sun/star/data/XDatabaseRelationFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECURSOROPTION_HPP_
#include <com/sun/star/data/DatabaseCursorOption.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEUPDATECURSOR_HPP_
#include <com/sun/star/data/XDatabaseUpdateCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEQUERYFACTORY_HPP_
#include <com/sun/star/data/XDatabaseQueryFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDOCUMENTFACTORY_HPP_
#include <com/sun/star/data/XDatabaseDocumentFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXACCESS_HPP_
#include <com/sun/star/container/XIndexAccess.hpp>
#endif
#ifndef SBA_USER_HXX
#include "user.hxx"
#endif
#ifndef _SBA_USER_HRC
#include "user.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SFX_PASSWD_HXX
#include <sfx2/passwd.hxx>
#endif

#ifndef _SBA_INIWRAP_HXX
#include "iniwrap.hxx"
#endif

#ifndef _SFXFILEDLG_HXX
#include <sfx2/iodlg.hxx>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif
#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif
#ifndef SBA_ADANEWDB_HXX
#include "adanewdb.hxx"
#endif
#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

const sal_uInt16 COL_TABLE_NAME = 1;
const sal_uInt16 COL_SELECT		= 2;
const sal_uInt16 COL_INSERT		= 3;
const sal_uInt16 COL_DELETE		= 4;
const sal_uInt16 COL_UPDATE		= 5;
const sal_uInt16 COL_ALTER		= 6;
const sal_uInt16 COL_REF		= 7;
const sal_uInt16 COL_IND		= 8;

DBG_NAME(SbaTableRightCtrl);
//================================================================================
// SbaTableRightCtrl
//================================================================================
SbaTableRightCtrl::SbaTableRightCtrl( SbaUserAdmin* pParent,const ResId& _RsId,SdbDatabase * _pDb)
	:DbBrowseBox( pParent,_RsId, DBBF_NOROWPICTURE)
	,m_xTableCursor(NULL)
	,m_xPrivCursor(NULL)
	,m_xDb(_pDb)
	,m_pCheckCell( NULL )
	,m_pEdit( NULL )
	,m_nDeActivateEvent(0)
	,m_bEnable(sal_True)
{
	DBG_CTOR(SbaTableRightCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Spalten einfuegen
	sal_Int32 i=1;
	InsertDataColumn( i, String(SbaResId(SBA_STR_TABLE_NAME)	), 75);
	FreezeColumn(i++);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_SELECT)), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_INSERT)), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_DELETE)), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_UPDATE)), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_ALTER)	), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_REF)	), 75);
	InsertDataColumn( i++, String(SbaResId(SBA_STR_TABLE_IND)	), 75);

	while(--i)
		SetColumnWidth(i,GetAutoColumnWidth(i));
}

//------------------------------------------------------------------------
SbaTableRightCtrl::~SbaTableRightCtrl()
{
	if (m_nDeActivateEvent)
		Application::RemoveUserEvent(m_nDeActivateEvent);

	delete m_pCheckCell;
	delete m_pEdit;

	if(m_xTableCursor.Is() && m_xTableCursor->IsOpen())
		m_xTableCursor->Close();
	if(m_xPrivCursor.Is() && m_xPrivCursor->IsOpen())
		m_xPrivCursor->Close();

	DBG_DTOR(SbaTableRightCtrl,NULL);
}
//------------------------------------------------------------------------
void SbaTableRightCtrl::UpdateTables()
{
	RemoveRows();
	// create m_xTableCursor
	if(!m_xTableCursor.Is())
		m_xTableCursor = m_xDb->CreateCursor(SDB_SNAPSHOT);

	String aSql; aSql.AssignAscii("SELECT DEFUSERNAME,REFTABLENAME,PRIVILEGES,REFOWNER FROM DOMAIN.USR_USES_TAB WHERE REFOBJTYPE <> 'SYSTEM' AND DEFUSERNAME = '");
	(aSql += m_xDb->GetUser()).AppendAscii("' OR DEFUSERNAME = 'PUBLIC' AND PRIVILEGES = '%+%'");
	if(m_xTableCursor->IsOpen())
		m_xTableCursor->Close();
	if(m_xTableCursor->Open(aSql,sal_False))
	{
		if(!m_xTableCursor->IsRowCountFinal())
			m_xTableCursor->Last();
		m_xTableCursor->First();
		RowInserted(0, m_xTableCursor->RowCount());
	}

	if(!m_xPrivCursor.Is())
	{
		m_xPrivCursor = m_xDb->CreateCursor(SDB_SNAPSHOT);
		aSql.AssignAscii("SELECT REFTABLENAME,PRIVILEGES FROM DOMAIN.USR_USES_TAB WHERE REFOBJTYPE <> 'SYSTEM' AND DEFUSERNAME = ?");
		m_xPrivCursor->Prepare(aSql,sal_False);
	}
	(*m_xPrivCursor->GetParameterRow())[1]->setString(((SbaUserAdmin*)GetParent())->GetUser());
	m_bEnable = m_xDb->GetUser() != ((SbaUserAdmin*)GetParent())->GetUser();

	m_xPrivCursor->Open();
}
//------------------------------------------------------------------------
void SbaTableRightCtrl::Init()
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	DbBrowseBox::Init();

	//////////////////////////////////////////////////////////////////////
	// ComboBox instanzieren
	if(!m_pCheckCell)
	{
		m_pCheckCell	= new DbCheckBoxCtrl( &GetDataWindow() );
		m_pCheckCell->GetBox().EnableTriState(sal_False);

		m_pEdit			= new Edit( &GetDataWindow() );
		m_pEdit->SetReadOnly();
		m_pEdit->Enable(sal_False);
	}

	UpdateTables();
	//////////////////////////////////////////////////////////////////////
	// Browser Mode setzen
	BrowserMode nMode = BROWSER_COLUMNSELECTION | BROWSER_HLINESFULL | BROWSER_VLINESFULL |
						BROWSER_HIDECURSOR		| BROWSER_HIDESELECT;

	SetMode(nMode);
}

//------------------------------------------------------------------------------
void SbaTableRightCtrl::Resize()
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	DbBrowseBox::Resize();
}

//------------------------------------------------------------------------------
long SbaTableRightCtrl::PreNotify(NotifyEvent& rNEvt)
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	if (rNEvt.GetType() == EVENT_LOSEFOCUS)
		if (!HasChildPathFocus())
		{
			if (m_nDeActivateEvent)
				Application::RemoveUserEvent(m_nDeActivateEvent);
			m_nDeActivateEvent = Application::PostUserEvent(LINK(this, SbaTableRightCtrl, AsynchDeactivate));
		}
	if (rNEvt.GetType() == EVENT_GETFOCUS)
	{
		if (m_nDeActivateEvent)
			Application::RemoveUserEvent(m_nDeActivateEvent);
		m_nDeActivateEvent = Application::PostUserEvent(LINK(this, SbaTableRightCtrl, AsynchActivate));
	}
	return DbBrowseBox::PreNotify(rNEvt);
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableRightCtrl, AsynchActivate, void*, EMPTYARG)
{
	m_nDeActivateEvent = 0;
	ActivateCell();
	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableRightCtrl, AsynchDeactivate, void*, EMPTYARG)
{
	m_nDeActivateEvent = 0;
	DeactivateCell();
	return 0L;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableRightCtrl::IsTabAllowed(sal_Bool bForward) const
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	long nRow = GetCurRow();
	sal_uInt16 nCol = GetCurColumnId();

	if (bForward && (nCol == 2) && (nRow == GetRowCount() - 1))
		return sal_False;

	if (!bForward && (nCol == 1) && (nRow == 0))
		return sal_False;

	return DbBrowseBox::IsTabAllowed(bForward);
}
//------------------------------------------------------------------------------
#define GRANT_REVOKE_RIGHT(what)				\
	if(m_pCheckCell->GetBox().IsChecked())		\
		(((((aGrant.AssignAscii("GRANT ")).AppendAscii(what)).AppendAscii(" ON ")) += aTablename).AppendAscii(" TO ")) += aUser; \
	else										\
		(((((aGrant.AssignAscii("REVOKE ")).AppendAscii(what)).AppendAscii(" ON ")) += aTablename).AppendAscii(" FROM ")) += aUser; \

//------------------------------------------------------------------------------
sal_Bool SbaTableRightCtrl::SaveModified()
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);

	if(m_xTableCursor.Is() && !m_xTableCursor->MoveAbs(GetCurRow()+1))
		return sal_False;

	String aTablename = m_xDb->IdentifierQuotation((*m_xTableCursor->GetRow())[1]->toString());
	aTablename += '.';
	aTablename += m_xDb->IdentifierQuotation((*m_xTableCursor->GetRow())[2]->toString());

	String aGrant;
	String aUser(((SbaUserAdmin*)GetParent())->GetUser());
	switch( GetCurColumnId() )
	{
		case COL_INSERT:
			GRANT_REVOKE_RIGHT("INSERT");
			break;
		case COL_DELETE:
			GRANT_REVOKE_RIGHT("DELETE");
			break;
		case COL_UPDATE:
			GRANT_REVOKE_RIGHT("UPDATE");
			break;
		case COL_ALTER:
			GRANT_REVOKE_RIGHT("ALTER");
			break;
		case COL_SELECT:
			GRANT_REVOKE_RIGHT("SELECT");
			break;
		case COL_REF:
			GRANT_REVOKE_RIGHT("REFERENCES");
			break;
		case COL_IND:
			GRANT_REVOKE_RIGHT("INDEX");
			break;
	}

	sal_Bool bErg = m_xDb->ExecuteSQL(aGrant);
	if(Controller().Is())
		Controller()->ClearModified();
	if(!bErg)
		UpdateTables();
	else
		m_xPrivCursor->Open();
	return bErg;
}

//------------------------------------------------------------------------------
String SbaTableRightCtrl::GetCellText( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	m_xTableCursor->MoveAbs(nRow+1);
	String aTablename((*m_xTableCursor->GetRow())[2]->toString());
	if(COL_TABLE_NAME == nColId)
		return aTablename;

	// search the right table and look for the privileges
	String aPriv;
	m_xPrivCursor->First();
	while(m_xPrivCursor->IsInRange())
	{
		ODbRowRef xRow = m_xPrivCursor->GetRow();
		if((*xRow)[1]->toString().equals(aTablename))
		{
			aPriv = (const sal_Unicode*)(*xRow)[2]->toString();
			break;
		}
		m_xPrivCursor->Next();
	}

	xub_StrLen nPos = STRING_NOTFOUND;
	switch( nColId )
	{
		case COL_INSERT:
			nPos = aPriv.SearchAscii("INS");
			break;
		case COL_DELETE:
			nPos = aPriv.SearchAscii("DEL");
			break;
		case COL_UPDATE:
			nPos = aPriv.SearchAscii("UPD");
			break;
		case COL_ALTER:
			nPos = aPriv.SearchAscii("ALT");
			break;
		case COL_SELECT:
			nPos = aPriv.SearchAscii("SEL");
			break;
		case COL_REF:
			nPos = aPriv.SearchAscii("REF");
			break;
		case COL_IND:
			nPos = aPriv.SearchAscii("IND");
			break;
	}

	return String(nPos != STRING_NOTFOUND ? '1' : '0');
}

//------------------------------------------------------------------------------
void SbaTableRightCtrl::InitController( DbCellControllerRef& rController, long nRow, sal_uInt16 nColumnId )
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);

	DBG_ASSERT(m_xTableCursor.Is(),"No cursor GPF!");
	m_xTableCursor->MoveAbs(nRow+1);

	ODbRowRef xRow = m_xTableCursor->GetRow();
	String aTablename((*xRow)[2]->toString());

	// search the right table and look for the privileges
	String aPriv;
	m_xPrivCursor->First();
	while(m_xPrivCursor->IsInRange())
	{
		ODbRowRef xRow = m_xPrivCursor->GetRow();
		if((*xRow)[1]->toString().equals(aTablename))
		{
			aPriv = (const sal_Unicode*)(*xRow)[2]->toString();
			break;
		}
		m_xPrivCursor->Next();
	}


	sal_Int32 nPos = STRING_NOTFOUND;
	switch (nColumnId)
	{
		case COL_TABLE_NAME:
			m_pEdit->SetText(aTablename);
			return;
			break;
		case COL_INSERT:
			nPos = aPriv.SearchAscii("INS");
			break;
		case COL_DELETE:
			nPos = aPriv.SearchAscii("DEL");
			break;
		case COL_UPDATE:
			nPos = aPriv.SearchAscii("UPD");
			break;
		case COL_ALTER:
			nPos = aPriv.SearchAscii("ALT");
			break;
		case COL_SELECT:
			nPos = aPriv.SearchAscii("SEL");
			break;
		case COL_REF:
			nPos = aPriv.SearchAscii("REF");
			break;
		case COL_IND:
			nPos = aPriv.SearchAscii("IND");
			break;
	}
	m_pCheckCell->GetBox().Check(nPos != STRING_NOTFOUND);
//	m_pCheckCell->GetBox().SetReadOnly(m_xDb->GetUser() == (*xRow)[1]->toString());
}
//------------------------------------------------------------------------------
DbCellController* SbaTableRightCtrl::GetController( long nRow, sal_uInt16 nColumnId )
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
//	if(!m_xTableCursor->MoveAbs(nRow+1))
//		return NULL;

	switch( nColumnId )
	{
		case COL_TABLE_NAME:
			return NULL;//new DbEditCellController( m_pEdit );
			break;
		case COL_INSERT:
		case COL_DELETE:
		case COL_UPDATE:
		case COL_ALTER:
		case COL_SELECT:
		case COL_REF:
		case COL_IND:
			{
				if(!m_bEnable)
					return NULL;
				return new DbCheckBoxCellController( m_pCheckCell );
			}
			break;
		default:
			return NULL;
	}
}
//------------------------------------------------------------------------------
sal_Bool SbaTableRightCtrl::SeekRow( long nRow )
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	m_nDataPos = nRow;
	if(m_xTableCursor.Is())
	{
		if(!m_xTableCursor->MoveAbs(nRow+1))
			return sal_False;
	}

	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableRightCtrl::PaintCell( OutputDevice& rDev, const Rectangle& rRect, sal_uInt16 nColumnId ) const
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);

	String aText(((SbaTableRightCtrl*)this)->GetCellText( m_nDataPos, nColumnId ));
	if(nColumnId != COL_TABLE_NAME)
		PaintTristate(rDev, rRect, aText.EqualsAscii("1") ? STATE_CHECK : STATE_NOCHECK,m_bEnable);
	else
	{
		Point aPos( rRect.TopLeft() );
		Size aTextSize(GetDataWindow().GetTextWidth( aText ), GetDataWindow().GetTextHeight());

		if( aPos.X() < rRect.Right() || aPos.X() + aTextSize.Width() > rRect.Right() ||
			aPos.Y() < rRect.Top() || aPos.Y() + aTextSize.Height() > rRect.Bottom() )
			rDev.SetClipRegion( rRect );

		rDev.DrawText( aPos, aText );
	}

	if( rDev.IsClipRegion() )
		rDev.SetClipRegion();
}



//------------------------------------------------------------------------
void SbaTableRightCtrl::CellModified()
{
	DBG_CHKTHIS(SbaTableRightCtrl,NULL);
	DbBrowseBox::CellModified();
	SaveModified();
	((SbaUserAdmin*)GetParent())->NotifyCellChange();
}

//================================================================================
// SbaUserAdmin
//================================================================================
SbaUserAdmin::SbaUserAdmin(Window* pParent,SdbDatabase* pDatabase) : ModalDialog( pParent, SbaResId(DLG_USERADMIN) )
	,m_GB_USER(			this , SbaResId(GB_USER))
	,m_FT_USER(			this , SbaResId(FT_USER))
	,m_LB_USER(			this , SbaResId(LB_USER))
	,m_FT_MODUS(		this , SbaResId(FT_MODUS))
	,m_LB_MODUS(		this , SbaResId(LB_MODUS))
	,m_PB_NEWUSER(		this , SbaResId(PB_NEWUSER))
	,m_PB_CHANGEPWD(	this , SbaResId(PB_CHANGEPWD))
	,m_PB_DELETEUSER(	this , SbaResId(PB_DELETEUSER))
	,m_GB_TABLE_GRANTS( this , SbaResId(GB_TABLE_GRANTS))
	,m_TableCtrl(		this , SbaResId(CTRL_TABLE_GRANTS))
	,m_PB_OK(			this , SbaResId(PB_OK))
	,m_PB_HELP(			this , SbaResId(PB_HELP))
	,m_bSysDba(sal_False)
	,m_bDba(sal_False)
	,m_xDb(pDatabase)
{

	m_LB_USER.SetSelectHdl(LINK(this, SbaUserAdmin, ListDblClickHdl));
	m_LB_MODUS.SetSelectHdl(LINK(this, SbaUserAdmin, ListDblClickHdl));

	m_PB_OK.SetClickHdl(LINK(this, SbaUserAdmin, CloseHdl));
	m_PB_NEWUSER.SetClickHdl(LINK(this, SbaUserAdmin, UserHdl));
	m_PB_CHANGEPWD.SetClickHdl(LINK(this, SbaUserAdmin, UserHdl));
	m_PB_DELETEUSER.SetClickHdl(LINK(this, SbaUserAdmin, UserHdl));

	m_TableCtrl.SetDatabase(m_xDb);
	FillUserNames();
	FreeResource();
}
// -----------------------------------------------------------------------
SbaUserAdmin::~SbaUserAdmin()
{
}
// -----------------------------------------------------------------------
void SbaUserAdmin::FillUserNames()
{
	m_LB_USER.Clear();

	m_UserName = m_xDb->GetUser();
	if(!m_xUserCursor.Is())
	{
		m_xUserCursor = m_xDb->CreateCursor();
		String aSql; aSql.AssignAscii("SELECT * FROM DOMAIN.USERS ORDER BY USERNAME");
		m_xUserCursor->Prepare(aSql,sal_False);
	}
	if(m_xUserCursor->Open())
	{
		SdbColumnsRef xCols = m_xUserCursor->GetColumns();
		m_xUserCursor->First();
		sal_Bool bFirst = sal_False;
		while( m_xUserCursor->IsInRange() )
		{
			ODbRowRef xRow = m_xUserCursor->GetRow();
			String aUser((*xRow)[3]->toString());

			try
			{
				if(m_UserName == aUser)
				{
					if (((*xRow)[4]->toString().compareToAscii("SYSDBA") == 0) || (*xRow)[1]->toString().equals(m_UserName))
						m_bSysDba = sal_True;
					else if ((*xRow)[4]->toString().compareToAscii("DBA") == 0)
						m_bDba = sal_True;
				}
			}
			catch(...)
			{
			}
			
			m_LB_USER.InsertEntry(aUser);
			m_xUserCursor->Next();
		}

		m_LB_USER.SelectEntryPos(0);
		m_xUserCursor->MoveAbs(m_LB_USER.GetSelectEntryPos()+1);
		::rtl::OUString aType;
		try
		{
			if(!(*m_xUserCursor->GetRow())[5]->isNull())
				aType = (*m_xUserCursor->GetRow())[5]->toString();
		}
		catch(...)
		{
		}
		

		if(aType == ::rtl::OUString::createFromAscii("SINGLE"))
			m_LB_MODUS.SelectEntryPos(0);
		else
			m_LB_MODUS.SelectEntryPos(1);

		m_TableCtrl.Init();
	}
	if(!(m_bSysDba || m_bDba))
	{
		m_PB_NEWUSER.Enable(sal_False);
		m_PB_DELETEUSER.Enable(sal_False);
	}
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaUserAdmin, UserHdl, PushButton *, pButton )
{
	String aSql;
	if(pButton == &m_PB_NEWUSER)
	{
		SfxPasswordDialog aPwdDlg(this);
		aPwdDlg.ShowExtras(SHOWEXTRAS_ALL);
		if(aPwdDlg.Execute())
			((aSql.AssignAscii("CREATE USER ") += aPwdDlg.GetUser()).AppendAscii(" PASSWORD ") += aPwdDlg.GetPassword()).AppendAscii(" RESOURCE");
	}
	else if(pButton == &m_PB_CHANGEPWD)
	{
		const CommandParser* pOpts = m_xDb->GetOptionsParser();
		String aName(": ", RTL_TEXTENCODING_ASCII_US);
		if(m_bSysDba || m_bDba)
			aName += GetUser();
		else
			aName += pOpts->OptionString(String::CreateFromAscii("UID"));

		SfxPasswordDialog aPwdDlg(this,&aName);
		aPwdDlg.ShowExtras(SHOWEXTRAS_CONFIRM);
		if(aPwdDlg.Execute())
		{
			aSql.AssignAscii("ALTER PASSWORD ");
			if(m_bSysDba || m_bDba)
				((aSql += GetUser()) += ' ') += aPwdDlg.GetPassword();
			else
				(aSql += pOpts->OptionString(String::CreateFromAscii("PWD"))).AppendAscii(" TO ") += aPwdDlg.GetPassword();
		}
	}
	else 
	{// delete user
		if (GetUser().EqualsAscii("DOMAIN"))
		{
			SbaMsgBox(this,SbaResId(SBA_STAT_WARNING),String(SbaResId(SBA_STR_DOMAIN_USER))).Execute();
			return 0;
		}
		if(SbaExtQueryBox(this, SbaResId(QUERY_QRY_DELETEUSER),GetUser()).Execute() == RET_YES)
			aSql.AssignAscii("DROP USER ") += GetUser();
	}

	if(aSql.Len())
	{
		if(!m_xDb->ExecuteSQL(aSql))
			SBA_MOD()->ShowDbStatus(m_xDb->Status(),dbWriteError);
		else
			FillUserNames();
	}


	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaUserAdmin, CloseHdl, PushButton *, pButton )
{
	EndDialog(sal_True);
	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaUserAdmin, ListDblClickHdl, ListBox *, pListBox )
{
	if(pListBox == &m_LB_MODUS)
	{
		String aSql("ALTER USER ", RTL_TEXTENCODING_ASCII_US);
		aSql += GetUser();
		if(m_LB_MODUS.GetTopEntry() == 0)
			aSql.AppendAscii(" NOT EXCLUSIVE");
		else
			aSql.AppendAscii(" EXCLUSIVE");
		if(!m_xDb->ExecuteSQL(aSql))
			SBA_MOD()->ShowDbStatus(m_xDb->Status(),dbWriteError);
		else
			m_xUserCursor->Open();
	}
	else
	{
		m_xUserCursor->MoveAbs(m_LB_USER.GetSelectEntryPos()+1);
		if((*m_xUserCursor->GetRow())[5]->isNull() || (*m_xUserCursor->GetRow())[5]->toString() == ::rtl::OUString::createFromAscii("SINGLE"))
			m_LB_MODUS.SelectEntryPos(0);
		else
			m_LB_MODUS.SelectEntryPos(1);
		m_LB_MODUS.Enable(m_UserName == GetUser() || m_bSysDba || m_bDba);
		m_TableCtrl.UpdateTables();
		m_TableCtrl.DeactivateCell();
		m_TableCtrl.ActivateCell(m_TableCtrl.GetCurRow(),m_TableCtrl.GetCurColumnId());
	}
	return 0;
}

// -----------------------------------------------------------------------
void SbaUserAdmin::NotifyCellChange()
{
}
// -----------------------------------------------------------------------
String SbaUserAdmin::GetUser()
{
	return m_LB_USER.GetSelectEntry();
}
//========================================================================
// Convert oterro db in adabas db
//========================================================================
SbaConvertOterroAdabas::SbaConvertOterroAdabas(Window* pParent,const ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabase >& _rxDatabase) : ModalDialog( pParent, SbaResId(DLG_OTERRO_ADABAS_CONVERT) )
	,m_FT_EXPLAINATION(		this , ResId(FT_EXPLAINATION))
	,m_GB_EXPORT(			this , ResId(GB_EXPORT))
	,m_CB_QUERY(			this , ResId(CB_QUERY))
	,m_CB_REPORT(			this , ResId(CB_REPORT))
	,m_CB_FORM(				this , ResId(CB_FORM))
	,m_CB_TABLE(			this , ResId(CB_TABLE))
	,m_CB_RELATION(			this , ResId(CB_RELATION))
	,m_FT_FILE_TO_CONVERT(	this , ResId(FT_FILE_TO_CONVERT))
	,m_ET_FILE_TO_CONVERT(	this , ResId(ET_FILE_TO_CONVERT))
	,m_FT_DB_TITLE(			this , ResId(FT_DB_TITLE))
	,m_ET_DB_TITLE(			this , ResId(ET_DB_TITLE))
	,m_FT_DEST_FILE(		this , ResId(FT_DEST_FILE))
	,m_ET_DEST_FILE(		this , ResId(ET_DEST_FILE))
	,m_PB_DEST_FILE(		this , ResId(PB_DEST_FILE))
	,m_CB_DONT_SHOW_AGAIN(	this , ResId(CB_DONT_SHOW_AGAIN))
	,m_FL_1(				this , ResId(FL_1))
	,m_PB_OK(				this , ResId(PB_OK))
	,m_PB_HELP(				this , ResId(PB_HELP))
	,m_PB_CANCEL(			this , ResId(PB_CANCEL))
	,m_xDb(_rxDatabase)
	,m_pFileDlg(NULL)
{

	m_PB_DEST_FILE.SetClickHdl(			LINK(this, SbaConvertOterroAdabas, PushHdl));
	m_PB_OK.SetClickHdl(				LINK(this, SbaConvertOterroAdabas, CloseHdl));

	m_ET_FILE_TO_CONVERT.SetText(m_xDb->getName());

	m_ET_DB_TITLE.SetModifyHdl(			LINK(this,SbaConvertOterroAdabas,ModifyHdl));
	m_ET_DEST_FILE.SetModifyHdl(		LINK(this,SbaConvertOterroAdabas,ModifyHdl));

	m_ET_DB_TITLE.SetLoseFocusHdl(		LINK(this,SbaConvertOterroAdabas,LoseFocusHdl));
	m_ET_DEST_FILE.SetLoseFocusHdl(		LINK(this,SbaConvertOterroAdabas,LoseFocusHdl));

	m_CB_TABLE.SetToggleHdl(			LINK(this,SbaConvertOterroAdabas,ToggleHdl));
	m_CB_DONT_SHOW_AGAIN.SetToggleHdl(	LINK(this,SbaConvertOterroAdabas,ToggleHdl));

	m_PB_OK.Enable(sal_False);
	m_CB_RELATION.Enable(sal_False);

	FreeResource();
}
//------------------------------------------------------------------------
SbaConvertOterroAdabas::~SbaConvertOterroAdabas()
{
	delete m_pFileDlg;
}
// -----------------------------------------------------------------------
sal_Bool SbaConvertOterroAdabas::isOkAllowed() const
{
	return (m_ET_DB_TITLE.GetText().Len() && m_ET_DEST_FILE.GetText().Len()) || m_CB_DONT_SHOW_AGAIN.IsChecked();
}

// -----------------------------------------------------------------------
sal_Bool SbaConvertOterroAdabas::areRelationsAllowed() const
{
	return m_CB_TABLE.IsChecked() && !m_CB_DONT_SHOW_AGAIN.IsChecked();
}

// -----------------------------------------------------------------------
IMPL_LINK( SbaConvertOterroAdabas, LoseFocusHdl, Edit *, pEdit )
{
	if(m_ET_DB_TITLE.GetText().Len() && !m_ET_DEST_FILE.GetText().Len())
	{
		SbaIniWrap aIniWrap;
		DirEntry aUrl(aIniWrap.GetDefaultDatabasePath());
		aUrl += m_ET_DB_TITLE.GetText();
		m_ET_DEST_FILE.SetText(aUrl.GetFull());
	}
	else if(!m_ET_DB_TITLE.GetText().Len() && m_ET_DEST_FILE.GetText().Len())
	{
		DirEntry aUrl(m_ET_DEST_FILE.GetText());
		m_ET_DB_TITLE.SetText(aUrl.GetBase());
	}
	m_PB_OK.Enable( isOkAllowed() );
	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaConvertOterroAdabas, ModifyHdl, Edit *, pEdit )
{
	m_PB_OK.Enable( isOkAllowed() );
	return 0;
}
// -----------------------------------------------------------------------
sal_Bool SbaConvertOterroAdabas::ShowDialogAgain() const
{
	return !m_CB_DONT_SHOW_AGAIN.IsChecked();
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaConvertOterroAdabas, PushHdl, PushButton *, pButton )
{
	if(!m_pFileDlg)
	{
		WinBits	nBits(WB_3DLOOK | WB_STDMODAL | WB_SAVEAS);
		m_pFileDlg = new SfxFileDialog( this, nBits ); //	new FileDialog( this, nBits );
		SbaIniWrap aIniWrap;
		m_pFileDlg->SetStandardDir(aIniWrap.GetDefaultDatabasePath());
		m_pFileDlg->AddFilter(String::CreateFromAscii("StarOffice Base"), String::CreateFromAscii("*.sdb"));
	}
	if (m_pFileDlg->Execute())
	{
		INetURLObject aUrl(m_pFileDlg->GetPath());
		m_ET_DEST_FILE.SetText(aUrl.PathToFileName());
		LoseFocusHdl(&m_ET_DEST_FILE);
	}
	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaConvertOterroAdabas, ToggleHdl, CheckBox *, pCheckBox )
{
	if (&m_CB_DONT_SHOW_AGAIN == pCheckBox)
	{
//		sal_Bool bShowAgain = m_CB_DONT_SHOW_AGAIN.IsChecked();
//		m_GB_EXPORT.Enable( !bShowAgain );
//		m_CB_QUERY.Enable( !bShowAgain );
//		m_CB_REPORT.Enable( !bShowAgain );
//		m_CB_FORM.Enable( !bShowAgain );
//		m_CB_TABLE.Enable( !bShowAgain );
//		m_CB_RELATION.Enable( areRelationsAllowed() );
//
//		m_FT_FILE_TO_CONVERT.Enable( !bShowAgain );
//		m_ET_FILE_TO_CONVERT.Enable( !bShowAgain );
//		m_FT_DB_TITLE.Enable( !bShowAgain );
//		m_ET_DB_TITLE.Enable( !bShowAgain );
//		m_FT_DEST_FILE.Enable( !bShowAgain );
//		m_ET_DEST_FILE.Enable( !bShowAgain );
//		m_PB_DEST_FILE.Enable( !bShowAgain );

		m_PB_OK.Enable( isOkAllowed() );
	}
	else if (&m_CB_TABLE == pCheckBox)
		m_CB_RELATION.Enable( areRelationsAllowed() );

	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaConvertOterroAdabas, CloseHdl, PushButton *, pButton )
{
	if(m_CB_DONT_SHOW_AGAIN.IsChecked())
	{
		EndDialog(sal_True);
		return 0;
	}

	if(!(m_CB_QUERY.IsChecked() || m_CB_REPORT.IsChecked() || m_CB_FORM.IsChecked() ||
		 m_CB_TABLE.IsChecked() || m_CB_RELATION.IsChecked()))
	{
		String aTitle(m_GB_EXPORT.GetText());
		String aMsg(SbaResId(SBA_STR_CONVERT_OTERRO));
		SbaMsgBox(this,aTitle,aMsg).Execute();
		return 0;
	}

	String aTest; aTest.AssignAscii(getenv("DBCONFIG"));
	(aTest += DirEntry::GetAccessDelimiter()).AppendAscii("config") += DirEntry::GetAccessDelimiter();
	aTest += m_ET_DB_TITLE.GetText();
	DirEntry aDBName(aTest);
	if(aDBName.Exists())
	{
		SbaExtInfoBox(this, SbaResId(QUERY_QRY_DELETEDB),m_ET_DB_TITLE.GetText()).Execute();
		return 0;
	}

	SbaAdabasNewDbPage aDlg(this,m_ET_DB_TITLE.GetText());
	if(aDlg.Execute())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabase >  xDb;
		try
		{
			DirEntry aFile(m_ET_DEST_FILE.GetText());
			aFile.SetExtension(String::CreateFromAscii("sdb"));
			if(aFile.Exists())
				aFile.Kill();

			String aTitle(':');
			aTitle += m_ET_DB_TITLE.GetText();
			::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> seqConStr(7);
			::com::sun::star::beans::PropertyValue *pPropValue = seqConStr.getArray();
			pPropValue[0] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("TYPE"),0,::com::sun::star::uno::makeAny(::rtl::OUString::createFromAscii("ADABAS")),::com::sun::star::beans::PropertyState_DIRECT_VALUE);
			pPropValue[1] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("DSN"),0,::com::sun::star::uno::makeAny(::rtl::OUString(aTitle)),::com::sun::star::beans::PropertyState_DIRECT_VALUE);
			pPropValue[2] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("UID"),0,::com::sun::star::uno::makeAny(::rtl::OUString(aDlg.GetSysUser())),::com::sun::star::beans::PropertyState_DIRECT_VALUE);
			pPropValue[3] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("PWD"),0,::com::sun::star::uno::makeAny(::rtl::OUString(aDlg.GetSysPwd())),::com::sun::star::beans::PropertyState_DIRECT_VALUE);
			pPropValue[4] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("CTRLUSER"),0,::com::sun::star::uno::makeAny(::rtl::OUString(aDlg.GetCtrlUser())),::com::sun::star::beans::PropertyState_DIRECT_VALUE);
			pPropValue[5] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("CTRLPWD"),0,::com::sun::star::uno::makeAny(::rtl::OUString(aDlg.GetCtrlPwd())),::com::sun::star::beans::PropertyState_DIRECT_VALUE);

			pPropValue[6] = ::com::sun::star::beans::PropertyValue(::rtl::OUString::createFromAscii("askwhenemptypwd"),0,::com::sun::star::uno::makeAny(::rtl::OUString::createFromAscii("sal_False")),::com::sun::star::beans::PropertyState_DIRECT_VALUE);

			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseEngine >  xEngineRef(::utl::getProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.data.DatabaseEngine")),::com::sun::star::uno::UNO_QUERY);
			DBG_ASSERT(xEngineRef.is() , "SbaUserAdmin: No ::com::sun::star::data::Database engine! Prepare for GPF!");
			::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >  xWrkSpaces(xEngineRef->getWorkspaces(),::com::sun::star::uno::UNO_QUERY);

			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseWorkspace >  xWrkSpace(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xWrkSpaces->getByIndex(0).getValue(),::com::sun::star::uno::UNO_QUERY);

			xDb = xWrkSpace->create(m_ET_DEST_FILE.GetText(),m_ET_DB_TITLE.GetText(),seqConStr);
			if(!xDb.is())
				return 0;
		}
		catch(::com::sun::star::data::DatabaseException e)
		{
			SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),e.SQLState).Execute();
			return 0;
		}
		catch(...)
		{
			return 0;
		}
		

		::rtl::OUString aMessage;

		if(m_CB_TABLE.IsChecked())
		{
			try
			{
				::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseTableFactory >  xDestTables(::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseConnection > (xDb,::com::sun::star::uno::UNO_QUERY)->getTables(),::com::sun::star::uno::UNO_QUERY);
				::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcTables(::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseConnection > (m_xDb,::com::sun::star::uno::UNO_QUERY)->getTables());
				::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestNames(xDestTables,::com::sun::star::uno::UNO_QUERY);
				const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqUString = xSrcTables->getElementNames();
				const ::rtl::OUString *pArray = seqUString.getConstArray();
				const ::rtl::OUString *pEnd = pArray + seqUString.getLength();

				for(;pArray != pEnd; ++pArray)
				{
					try
					{
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseTable >  xTable( *(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSrcTables->getByName(*pArray).getValue(),::com::sun::star::uno::UNO_QUERY);
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseTable >  xNewTable( xDestTables->create() );
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xSet( xTable,::com::sun::star::uno::UNO_QUERY);
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xNewSet( xNewTable,::com::sun::star::uno::UNO_QUERY);

						xNewSet->setFastPropertyValue(PROP_PRIVILIGES,xSet->getFastPropertyValue(PROP_PRIVILIGES));
						xNewSet->setFastPropertyValue(PROP_FILTER,xSet->getFastPropertyValue(PROP_FILTER));
						xNewSet->setFastPropertyValue(PROP_SORT,xSet->getFastPropertyValue(PROP_SORT));

						// first create the fields for the new table
						::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xFields(xTable->getFields());
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseNameContainer >  xNewFields(xNewTable->getFields(),::com::sun::star::uno::UNO_QUERY);
						const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqFld = xFields->getElementNames();
						const ::rtl::OUString *pBegin = seqFld.getConstArray();
						const ::rtl::OUString *pEnd2 = pBegin + seqFld.getLength();
						for(;pBegin != pEnd2; ++pBegin)
						{
							::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldDescriptorFactory >  xDesc(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xFields->getByName(*pBegin).getValue(),::com::sun::star::uno::UNO_QUERY);
							::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xFld(xDesc,::com::sun::star::uno::UNO_QUERY);
							::com::sun::star::uno::Any aVal(xFld->getFastPropertyValue(PROP_ISVERSIONING));
							if(!::utl::getBOOL(aVal))
							{
								::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xProp = xDesc->create();
								// insert table fields into collection
								xNewFields->insertNewByName(*pBegin,::com::sun::star::uno::makeAny(xProp));
							}
						}


						// insert table into collection
						xDestNames->insertByName(*pArray,::com::sun::star::uno::makeAny(xNewTable));

						// insert indexes
						::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcInd = xTable->getIndexes();
						::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestInd = xNewTable->getIndexes();
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseIndexFactory >  xSrcIndxFactory(xSrcInd,::com::sun::star::uno::UNO_QUERY);
						const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqIdx = xSrcInd->getElementNames();
						const ::rtl::OUString *pBeginIdx = seqIdx.getConstArray();
						const ::rtl::OUString *pEndIdx = pBeginIdx + seqIdx.getLength();
						for(;pBeginIdx != pEndIdx; ++pBeginIdx)
						{
							try
							{
								::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldsSupplier >  xDesc(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSrcInd->getByName(*pBeginIdx).getValue(),::com::sun::star::uno::UNO_QUERY);
								::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xSet(xDesc,::com::sun::star::uno::UNO_QUERY);
								::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xIdx(xSrcIndxFactory->create(),::com::sun::star::uno::UNO_QUERY);
								xIdx->setFastPropertyValue(PROP_ISCLUSTERED,xSet->getFastPropertyValue(PROP_ISCLUSTERED));
								xIdx->setFastPropertyValue(PROP_ISUNIQUE,xSet->getFastPropertyValue(PROP_ISUNIQUE));

								::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xSrc = ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldsSupplier > (xSet,::com::sun::star::uno::UNO_QUERY)->getFields();
								::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseNameContainer >  xDest(::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldsSupplier > (xIdx,::com::sun::star::uno::UNO_QUERY)->getFields(),::com::sun::star::uno::UNO_QUERY);

								::com::sun::star::uno::Sequence< ::rtl::OUString> seqIdxFld(xSrc->getElementNames());
								const ::rtl::OUString *pBeginIdxFld = seqIdxFld.getConstArray();
								const ::rtl::OUString *pEndIdxFld = pBeginIdxFld + seqIdxFld.getLength();
								for(;pBeginIdxFld != pEndIdxFld; ++pBeginIdxFld)
								{
									::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldDescriptorFactory >  xIdxDesc(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSrc->getByName(*pBeginIdxFld).getValue(),::com::sun::star::uno::UNO_QUERY);
									::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xProp = xIdxDesc->create();
									// insert index fields into collection
									xDest->insertNewByName(*pBeginIdxFld,::com::sun::star::uno::makeAny(xProp));
								}
								// insert index into collection
								xDestInd->insertByName(*pBeginIdx,::com::sun::star::uno::makeAny(xIdx));
							}
							catch(::com::sun::star::data::DatabaseException e)
							{
								aMessage += ::rtl::OUString::createFromAscii("\n");
								aMessage += e.Message;
							}
							catch(...)
							{
							}
							
						}

						// create the relations
						if(m_CB_RELATION.IsChecked() && m_CB_RELATION.IsEnabled())
						{
							try
							{
								::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcDocs(::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseConnection > (m_xDb,::com::sun::star::uno::UNO_QUERY)->getRelations());
								::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseRelationFactory >  xDestDocs(::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseConnection > (xDb,::com::sun::star::uno::UNO_QUERY)->getRelations(),::com::sun::star::uno::UNO_QUERY);
								::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestNamed(xDestDocs,::com::sun::star::uno::UNO_QUERY);

								const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqNames = xSrcDocs->getElementNames();
								const ::rtl::OUString *pBegin = seqNames.getConstArray();
								const ::rtl::OUString *pEnd = pBegin + seqNames.getLength();

								for(;pBegin != pEnd; ++pBegin)
								{
									try
									{
										::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xSrc( *(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSrcDocs->getByName(*pBegin).getValue(),::com::sun::star::uno::UNO_QUERY);
										::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xOutput(xDestDocs->create(),::com::sun::star::uno::UNO_QUERY);

										xOutput->setFastPropertyValue(PROP_DELETERULE,xSrc->getFastPropertyValue(PROP_DELETERULE));
										xOutput->setFastPropertyValue(PROP_UPDATERULE,xSrc->getFastPropertyValue(PROP_UPDATERULE));
										xOutput->setFastPropertyValue(PROP_REFTABLENAME,xSrc->getFastPropertyValue(PROP_REFTABLENAME));
										xOutput->setFastPropertyValue(PROP_TABLENAME,xSrc->getFastPropertyValue(PROP_TABLENAME));

										// first create the fields for the new relation
										::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xFields = ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldsSupplier > (xSrc,::com::sun::star::uno::UNO_QUERY)->getFields();
										::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldsSupplier >  xNewFields(xOutput,::com::sun::star::uno::UNO_QUERY);
										::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseNameContainer >  xDestFields(xNewFields->getFields(),::com::sun::star::uno::UNO_QUERY);

										const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqFld = xFields->getElementNames();
										const ::rtl::OUString *pBegin2 = seqFld.getConstArray();
										const ::rtl::OUString *pEnd2 = pBegin2 + seqFld.getLength();
										for(;pBegin2 != pEnd2; ++pBegin2)
										{
											::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseFieldDescriptorFactory >  xDesc(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xFields->getByName(*pBegin2).getValue(),::com::sun::star::uno::UNO_QUERY);
											::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xProp = xDesc->create();
											xDestFields->insertNewByName(*pBegin2,::com::sun::star::uno::makeAny(xProp));
										}
										xDestNamed->insertByName(*pBegin,::com::sun::star::uno::makeAny(xOutput));
									}
									catch(...)
									{
									}
									
								}

							}
							catch(::com::sun::star::data::DatabaseException e)
							{
								aMessage += ::rtl::OUString::createFromAscii("\n");
								aMessage += e.Message;
							}
							catch(...)
							{
							}
							
						}
						// now insert the data
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseStatement >  xStmt = xTable->createStatement();
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseCursor >  xCurs = xStmt->executeQuery(::com::sun::star::data::DatabaseCursorType_FORWARD,::com::sun::star::data::DatabaseCursorOption::READONLY);

						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseStatement >  xNewStmt = xNewTable->createStatement();
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseUpdateCursor >  xInsertCurs(xNewStmt->executeQuery(::com::sun::star::data::DatabaseCursorType_SNAPSHOT,::com::sun::star::data::DatabaseCursorOption::INSERTONLY),::com::sun::star::uno::UNO_QUERY);

						while(xCurs->isValid())
						{
							try
							{
								::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xOldPropSet(xCurs->getRecord());
								xInsertCurs->addRecord();
								::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xNewPropSet(xInsertCurs->getRecord());

								const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> &seqFields = xNewPropSet->getPropertySetInfo()->getProperties();
								const ::com::sun::star::beans::Property *pBeginFld	= seqFields.getConstArray();
								const ::com::sun::star::beans::Property *pEndFld		= pBeginFld + seqFields.getLength();
								for(;pBeginFld != pEndFld; ++pBeginFld)
									xNewPropSet->setPropertyValue((*pBeginFld).Name,xOldPropSet->getPropertyValue((*pBeginFld).Name));

								xInsertCurs->updateRecord();
							}
							catch(::com::sun::star::data::DatabaseException e)
							{
								aMessage += ::rtl::OUString::createFromAscii("\n");
								aMessage += e.Message;
							}
							catch(...)
							{
							}
							
							xCurs->moveRelative(1);
						}
						::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > (xInsertCurs,::com::sun::star::uno::UNO_QUERY)->dispose();
						::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > (xNewStmt,::com::sun::star::uno::UNO_QUERY)->dispose();
						::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > (xCurs,::com::sun::star::uno::UNO_QUERY)->dispose();
						::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > (xStmt,::com::sun::star::uno::UNO_QUERY)->dispose();
					}
					catch(...)
					{
					}
					
				}

			}
			catch(::com::sun::star::data::DatabaseException e)
			{
				aMessage += ::rtl::OUString::createFromAscii("\n");
				aMessage += e.Message;
			}
			catch(...)
			{
			}
			
		}

		if(m_CB_QUERY.IsChecked())
		{
			try
			{
				::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseQueryFactory >  xDestName(xDb->getQueries(),::com::sun::star::uno::UNO_QUERY);
				::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcName(m_xDb->getQueries());
				::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestCol(xDestName,::com::sun::star::uno::UNO_QUERY);
				const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqUString = xSrcName->getElementNames();
				const ::rtl::OUString *pArray = seqUString.getConstArray();
				const ::rtl::OUString *pEnd = pArray + seqUString.getLength();

				for(;pArray != pEnd; ++pArray)
				{
					try
					{
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseQuery >  xQuery( *(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSrcName->getByName(*pArray).getValue(),::com::sun::star::uno::UNO_QUERY);
						::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseQuery >  xNewQuery( xDestName->create() );
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xSet( xQuery,::com::sun::star::uno::UNO_QUERY);
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xNewSet( xNewQuery,::com::sun::star::uno::UNO_QUERY);

						xNewSet->setFastPropertyValue(PROP_ISPASSTHROUGH,xSet->getFastPropertyValue(PROP_ISPASSTHROUGH));
						xNewSet->setFastPropertyValue(PROP_FILTER,xSet->getFastPropertyValue(PROP_FILTER));
						xNewSet->setFastPropertyValue(PROP_SORT,xSet->getFastPropertyValue(PROP_SORT));
						xNewSet->setFastPropertyValue(PROP_QUERY,xSet->getFastPropertyValue(PROP_QUERY));

						xDestCol->insertByName(*pArray,::com::sun::star::uno::makeAny(xNewQuery));
					}
					catch(::com::sun::star::data::DatabaseException e)
					{
						aMessage += ::rtl::OUString::createFromAscii("\n");
						aMessage += e.Message;
					}
					catch(...)
					{
					}
					
				}
			}
			catch(::com::sun::star::data::DatabaseException e)
			{
				aMessage += ::rtl::OUString::createFromAscii("\n");
				aMessage += e.Message;
			}
			catch(...)
			{
			}
			
		}


		if(m_CB_REPORT.IsChecked())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcDocs(m_xDb->getReports());
			::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestNamed(xDb->getReports(),::com::sun::star::uno::UNO_QUERY);
			::rtl::OUString aMsg(CopyDocuments(xSrcDocs,xDestNamed));
			if(aMsg.getLength())
			{
				aMessage += ::rtl::OUString::createFromAscii("\n");
				aMessage += aMsg;
			}
		}
		if(m_CB_FORM.IsChecked())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xSrcDocs(m_xDb->getForms());
			::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xDestNamed(xDb->getForms(),::com::sun::star::uno::UNO_QUERY);
			::rtl::OUString aMsg(CopyDocuments(xSrcDocs,xDestNamed));
			if(aMsg.getLength())
			{
				aMessage += ::rtl::OUString::createFromAscii("\n");
				aMessage += aMsg;
			}
		}

		::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > (xDb,::com::sun::star::uno::UNO_QUERY)->dispose();

		if(aMessage.getLength())
		{
			SbaMsgBox(this,SbaResId(SBA_STAT_WARNING),aMessage).Execute();
		}
		EndDialog(sal_True);
	}
	return 0;
}
//------------------------------------------------------------------------
::rtl::OUString SbaConvertOterroAdabas::CopyDocuments(::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & _xSrcDocs,::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & _xDestNamed)
{
	::rtl::OUString aMessage;
	try
	{
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDocumentFactory >  xDestDocs(_xDestNamed,::com::sun::star::uno::UNO_QUERY);

		const ::com::sun::star::uno::Sequence< ::rtl::OUString> &seqNames = _xSrcDocs->getElementNames();
		const ::rtl::OUString *pBegin = seqNames.getConstArray();
		const ::rtl::OUString *pEnd = pBegin + seqNames.getLength();

		for(;pBegin != pEnd; ++pBegin)
		{
			try
			{
				::com::sun::star::uno::Reference< ::com::sun::star::chaos::XDataStreamSupplier >  xSrcStream( *(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)_xSrcDocs->getByName(*pBegin).getValue(),::com::sun::star::uno::UNO_QUERY);
				::com::sun::star::uno::Reference< ::com::sun::star::chaos::XDataStreamSupplier >  xOutput = xDestDocs->create();
				::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream >  xInput = xSrcStream->getData();
				xOutput->setData(xSrcStream->getDataType(),xInput);
				_xDestNamed->insertByName(*pBegin,::com::sun::star::uno::makeAny(xOutput));
			}
			catch(::com::sun::star::data::DatabaseException e)
			{
				aMessage = aMessage + ::rtl::OUString::createFromAscii("\n") + e.Message;
			}
			catch(...)
			{
			}
			
		}
	}
	catch(::com::sun::star::data::DatabaseException e)
	{
		aMessage += ::rtl::OUString::createFromAscii("\n");
		aMessage += e.Message;
	}
	catch(...)
	{
	}
	
	return aMessage;
}


