/*************************************************************************
 *
 *  $RCSfile: sbaexpob.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: fs $ $Date: 2000/09/21 15:15:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEENGINE_HPP_
#include <com/sun/star/data/XDatabaseEngine.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _SBA_DATABASE_NAMES_PAGE_HXX_
#include "DatabaseNamesPage.hxx"
#endif
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _SBA_SBAUNOTL_HXX
#include "sbaunotl.hxx"
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _VOS_PROFILE_HXX_
#include <vos/profile.hxx>
#endif
#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif
#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBA_SBASTAT_HXX
#include "dbstat.hxx"
#endif
#ifndef _DBCONFIG_HXX
#include "dbconfig.hxx"
#endif
#ifndef _SBA_COPYTBL_HXX
#include "copytbl.hxx"
#endif
#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif
#ifndef _SBA_INIWRAP_HXX
#include "iniwrap.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifndef _SBA_UNODATBR_HXX_
#include "unodatbr.hxx"
#endif
#ifndef _SBA_EXTCTRLR_HXX
#include "exsrcbrw.hxx"
#endif

#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif

#ifndef _SVX_FLSTITEM_HXX //autogen
#include <svx/flstitem.hxx>
#endif

#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif

#ifndef _SFXIMGMGR_HXX //autogen
#include <sfx2/imgmgr.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SBA_SQLDLG_HXX
#include "sqldlg.hxx"
#endif

#ifndef _IODLG_HXX
#include <sfx2/iodlg.hxx>
#endif

#ifndef _SBA_SBADBENG_HXX
#include "sbadbeng.hxx"
#endif

#ifndef _SBA_ENVIRONMENT_HXX
#include "environment.hxx"
#endif

#ifndef _SBA_DATABASECONTEXT_HXX
#include "databasecontext.hxx"
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif

#ifndef _SOT_STORINFO_HXX //autogen
#include <sot/storinfo.hxx>
#endif

#ifndef __RSC //autogen
#include <tools/errinf.hxx>
#endif

#ifndef _EHDL_HXX //autogen
#include <svtools/ehdl.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SFXTBXMGR_HXX //autogen
#include <sfx2/tbxmgr.hxx>
#endif

#ifndef _SBAOBJ_HRC
#include "sbaobj.hrc"
#endif

#ifndef _VCL_STDTEXT_HXX
#include <vcl/stdtext.hxx>
#endif

#ifndef SBA_USER_HXX
#include "user.hxx"
#endif

#ifndef _SV_CONFIG_HXX
#include <vcl/config.hxx>
#endif

#ifndef _EXPLORER_HXX
#include <sfx2/explorer.hxx>
#endif

#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif

#ifndef _TOOLKIT_AWT_VCLXWINDOW_HXX_
#include <toolkit/awt/vclxwindow.hxx>
#endif

#define MAX_URL_FILE_LINE_LENGTH		2048


//==================================================================
// SbaObjectExt
//==================================================================

DBG_NAME(SbaObjectExt);
//------------------------------------------------------------------------------
SbaObjectExt::SbaObjectExt(SbaObject& rObj)
			 :rSbaObj(rObj)
			 ,m_pEngine(NULL)
			 ,m_pEnvironment(NULL)
			 ,m_pContext(NULL)
			 ,m_bTriedUnoInitialization(sal_False)
{
	DBG_CTOR(SbaObjectExt,NULL);
	::vos::OGuard aGuard(Application::GetSolarMutex());
	pFontList = new FontList(GetpApp()->GetDefaultDevice());
	pFontListItem =  new SvxFontListItem( pFontList, SID_ATTR_CHAR_FONTLIST );
}

//------------------------------------------------------------------------------
void SbaObjectExt::SetEngine()
{
	if (m_bTriedUnoInitialization)
		return;

	// try to access the database engine
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xServiceManager = ::utl::getProcessServiceFactory();
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseEngine >  xEng(xServiceManager->createInstance(::rtl::OUString::createFromAscii("com.sun.star.data.DatabaseEngine")), ::com::sun::star::uno::UNO_QUERY);
//obo
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel(xEng,::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		m_pEngine= (SbaXdbEngine*)xTunnel->getSomething(SbaXdbEngine::getUnoTunnelImplementationId());
	}
//	::utl::getImplementation(m_pEngine, (::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >) xEng);
//	else
//		ShowServiceNotAvailableError(GetpApp()->GetDefDialogParent(), "com.sun.star.data.DatabaseEngine", sal_True);

	if (m_pEngine)
		m_pEngine->acquire();

	// try to access the data environment
	::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment >  xEnv(xServiceManager->createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseEnvironment")), ::com::sun::star::uno::UNO_QUERY);
//obo
	xTunnel = ::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel>(xEnv,::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		m_pEnvironment= (OEnvironment*)xTunnel->getSomething(OEnvironment::getUnoTunnelImplementationId());
	}
//	::utl::getImplementation(m_pEnvironment, (::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >)xEnv);
//	else
//		ShowServiceNotAvailableError(GetpApp()->GetDefDialogParent(), "com.sun.star.sdb.DatabaseEnvironment", sal_True);

	if (m_pEnvironment)
		m_pEnvironment->acquire();

	// try to access the data context
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XNamingService >  xContext(xServiceManager->createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseAccessContext")), ::com::sun::star::uno::UNO_QUERY);
	 xTunnel = 	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel>(xContext,::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		m_pContext = (ODatabaseAccessContext*)xTunnel->getSomething(ODatabaseAccessContext:: getUnoTunnelImplementationId());
	}
	//	::utl::getImplementation(m_pContext, (::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >)xContext);
//	else
//		ShowServiceNotAvailableError(GetpApp()->GetDefDialogParent(), "com.sun.star.sdb.DatabaseAccessContext", sal_True);

	if (m_pContext)
		m_pContext->acquire();

	m_bTriedUnoInitialization = sal_True;
		// don't try again
}

//------------------------------------------------------------------------------
SbaObjectExt::~SbaObjectExt()
{
	DBG_DTOR(SbaObjectExt,NULL);

	SetEngine();
		// Sound's stupid to create the objects here if we want to destroy them afterwards.
		// But we not just release, but _dispose_ them, so it isn't senseless at all. If somebody has instantiated
		// one of this services we ensure that it is cleaned up now.

	if (m_pEngine)
	{
		m_pEngine->dispose();
		m_pEngine->release();
	}

	if (m_pContext)
	{
		m_pContext->dispose();
		m_pContext->release();
	}

	if (m_pEnvironment)
	{
		m_pEnvironment->dispose();
		m_pEnvironment->release();
	}

	delete pFontListItem;
	delete pFontList;
}

//------------------------------------------------------------------------------
SbaDBDatabaseItem* SbaObjectExt::CreateDatabaseItem( sal_uInt16 nWhich, SbaDatabase* pDatabase )
{
	return new SbaDBDatabaseItem( nWhich, pDatabase );
}

//------------------------------------------------------------------------------
SbaSqlDlg* SbaObjectExt::CreateSQLDlg( Window* pParent, SbaDatabase* pDatabase )
{
	return new SbaSqlDlg( pParent, pDatabase );
}

//------------------------------------------------------------------------------
SbaDBDef* SbaObjectExt::OpenDBDef( const XubString& rURL, sal_Bool bShowError, sal_Bool bNew )
{
	//////////////////////////////////////////////////////////////////////
	// Erzeugt DBObj aus ::com::sun::star::util::URL

	// ::com::sun::star::util::URL-Object
	INetURLObject aURLObj( rURL );
	aURLObj.SetSmartProtocol( INET_PROT_FILE );

	// Typ DBObjects
	DBObject eDBObjType;
	xub_StrLen nIndex(0);
	XubString aMark( aURLObj.GetMark() );
	XubString aMarkHeader = aMark.GetToken( 0, ';', nIndex);
	aMarkHeader += ';';

	if (aMarkHeader == String::CreateFromAscii(SDB_TABLEMARK_HEADER))
	{
		if (nIndex != STRING_NOTFOUND && aMark.GetChar(nIndex) == ';')
			eDBObjType = dbView;
		else
			eDBObjType = dbTable;
	}
	else if( aMarkHeader == String::CreateFromAscii(SDB_QUERYMARK_HEADER) )
		eDBObjType = dbQuery;
	else if( aMarkHeader == String::CreateFromAscii(SDB_FORMMARK_HEADER) )
		eDBObjType = dbForm;
	else if( aMarkHeader == String::CreateFromAscii(SDB_REPORTMARK_HEADER) )
		eDBObjType = dbReport;
	else if (aMarkHeader == String::CreateFromAscii(SDB_STATEMENTMARK_HEADER))
	{
		eDBObjType = dbQuery;
		// Statement isolieren
		aMark.Erase( 0, String::CreateFromAscii(SDB_STATEMENTMARK_HEADER).Len() );

		// ::com::sun::star::data::Database Object
		XubString aDatabaseName(aURLObj.PathToFileName());
		SbaDatabaseRef xDatabase(rSbaObj.GetDatabase(aDatabaseName));

		// Mit diesen Infos DBObj holen
		SbaDBDef* pDBDef = NULL;
		if (xDatabase.Is())
		{
			if (bNew)
				pDBDef = xDatabase->CreateDBDef(eDBObjType, aMark, sal_False );
			else
				pDBDef = xDatabase->OpenDBDef(eDBObjType, aMark, sal_False );
		}

		if ((pDBDef == NULL) && bShowError)
			SBA_MOD()->ShowDbStatus(xDatabase->Status(), dbWriteError);
		return pDBDef;
	}
	else
		return NULL;	// Kein bekannter Typ

	return OpenDBDef( rURL, eDBObjType, bShowError, bNew);
}

//------------------------------------------------------------------------------
SbaDBDef* SbaObjectExt::OpenDBDef(const XubString& rURL, DBObject eDBObjType, sal_Bool bShowError, sal_Bool bNew)
{
	//////////////////////////////////////////////////////////////////////
	// Erzeugt DBObj aus ::com::sun::star::util::URL und Typ
	// ::com::sun::star::util::URL-Object
	SbaDBDef* pDBDef = NULL;
	INetURLObject aURLObj( rURL );
	aURLObj.SetSmartProtocol( INET_PROT_FILE );

	// Name des DBObjects
	XubString aDBObjName( aURLObj.GetMark() );
	XubString aMarkHeader;
	switch( eDBObjType )
	{
		case dbTable:
			aMarkHeader = String::CreateFromAscii(SDB_TABLEMARK_HEADER);
			break;
		case dbView:
			aMarkHeader = String::CreateFromAscii(SDB_TABLEMARK_HEADER);
			aMarkHeader += ';';
			break;
		case dbQuery:
			aMarkHeader = String::CreateFromAscii(SDB_QUERYMARK_HEADER);
			break;
		case dbForm:
			aMarkHeader = String::CreateFromAscii(SDB_FORMMARK_HEADER);
			break;
		case dbReport:
			aMarkHeader = String::CreateFromAscii(SDB_REPORTMARK_HEADER);
			break;
		default:
			return NULL;
	}
	aDBObjName.Erase( 0, aMarkHeader.Len() );

	// ::com::sun::star::data::Database Object
	XubString aDatabaseName(aURLObj.PathToFileName());
	//SbaDatabase* pDatabase = rSbaObj.GetDatabase(aDatabaseName);
	SbaDatabaseRef xDatabase(rSbaObj.GetDatabase(aDatabaseName));

	// Mit diesen Infos DBObj holen
	if (bNew)
		pDBDef = xDatabase.Is() ? xDatabase->CreateDBDef(eDBObjType, aDBObjName, sal_False )
						 : NULL;
	else
		pDBDef = xDatabase.Is() ? xDatabase->OpenDBDef(eDBObjType, aDBObjName, sal_False )
						 : NULL;

	if ((pDBDef == NULL) && xDatabase.Is() && bShowError)
		SBA_MOD()->ShowDbStatus(xDatabase->Status(), dbReadError);

	return pDBDef;
}

//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::SetDatabaseEntry(const XubString& rFileName,
									sal_Bool bReadOnly,
									XubString& rTitle, XubString& rParams, SbaDatabase* pDatabase)
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	XubString aDatabaseName;
	SbaDBConfig aDBConfig(rFileName, bReadOnly, rTitle, rParams, pDatabase);

	if (aDBConfig.Config())
	{
		// Zuruegegeben wird nur der Name
		rTitle = aDBConfig.GetConnectionKey();	// Name der Datenbank
		rParams = aDBConfig.GetConnectionStr();
		return sal_True;
	}
	return sal_False;
}

//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::CreateUIComponent(
		const XubString& _rURL,
		const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > _rxParent,
		const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > _rxFactory,
		::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >& _rxCompWindow,
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XController>& _rxController)
{
	_rxController = NULL;
	_rxCompWindow = NULL;

	SbaXDataBrowserController* pCtrler = NULL;
	Window* pWindow = NULL;

	// get the implementation of the parent window (we need an vcl window)
	VCLXWindow*	pParentComponent = VCLXWindow::GetImplementation(_rxParent);
	Window* pParentWin = pParentComponent ? pParentComponent->GetWindow() : NULL;
	if (!pParentWin)
		return sal_False;

	if (_rURL.EqualsAscii(".component:DB/FormGridView"))
	{	// TODO : check this with an INetURLObject, too
		pCtrler = new SbaExternalSourceBrowser(_rxFactory);
	}
	else
	{
		INetURLObject aURLObj( _rURL );
		aURLObj.SetSmartProtocol( INET_PROT_FILE );

		// Datenbank vorher anziehen
		XubString aDatabaseName(aURLObj.PathToFileName());
		//SbaDatabase* pDatabase = rSbaObj.GetDatabase(aDatabaseName);
		SbaDatabaseRef xDatabase(rSbaObj.GetDatabase(aDatabaseName));

		SbaDBDef* pObj = OpenDBDef(_rURL);

		SbaQueryObj* pQueryObj = NULL;

		// AbfrageObject erzeugen
		SbaTableDef* pTab = PTR_CAST(SbaTableDef, pObj);
		if (pTab)
		{	// es ist eine Tabelle, die ich noch auf Locking testen muss
			if (pObj && pObj->IsLocked())
			{
				::vos::OGuard aGuard(Application::GetSolarMutex());
				XubString strMessage(SbaResId(RID_STR_OPENTABLE_TABLELOCKED));
				strMessage.SearchAndReplace(String::CreateFromAscii("$name$"), pObj->Name());
				SdbStatus aStatus;
				aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("01000"), strMessage, 0, String());
				SBA_MOD()->ShowDbStatus(aStatus, dbReadError);
				// (diesen Umweg ueber den Status gehe ich, damit ich hier nicht innerhalb der Core explizit eine ErrorBox hochreissen muss
				return NULL;
			}
			else if(!(pTab->GetTablePrivileges() & SDB_PR_READ))
			{
				::vos::OGuard aGuard(Application::GetSolarMutex());
				InfoBox(pParentWin,SbaResId(INFO_TABLE_NO_SELECT)).Execute();
				return NULL;

			}
			pQueryObj = (SbaQueryObj*)pTab->CreateDataObj();
		}

		SbaQueryDef* pQry = PTR_CAST(SbaQueryDef, pObj);
		if (pQry)
			pQueryObj = (SbaQueryObj*)pQry->CreateDataObj();


		SfxBindings& rBindings = SfxViewFrame::Current()->GetBindings();
			// TODO : this works if the component we're creating currently is plugged into a sub frame of the
			// current view frame (or this current view frmae itself)
			// we should try to make the SbaTableQueryBrowser independent from SfxBindings (replacing the
			// affected code with some XDispatch related stuff) to avoid this.

		if (pQueryObj)
		{
			rBindings.DENTERREGISTRATIONS();
			pCtrler = new SbaTableQueryBrowser(pQueryObj, _rxFactory, rBindings);
			rBindings.DLEAVEREGISTRATIONS();
		}
	}

	if (!pCtrler)
		return NULL;

	// acquire _before_ construction !
	_rxController = pCtrler;
	if (!pCtrler->Construct(pParentWin))
	{
		_rxController = NULL;		// this should delete pCtrler, too
		return sal_False;
	}

	_rxCompWindow = pCtrler->getContent()->GetWindowPeer();
	return sal_True;
}

//------------------------------------------------------------------------------
void SbaObjectExt::ShowDbStatus(const SdbStatus& rStatus, DBErrorContext eContext){
	rSbaObj.ShowDbStatus(rStatus, eContext);
}
//------------------------------------------------------------------------------
void SbaObjectExt::SetAddressBookEntry(const XubString& rFileName, const XubString& rTableName)
{
	rSbaObj.SetAddressBookEntry(rFileName, rTableName);
}

//------------------------------------------------------------------------------
void SbaObjectExt::BeginDBAction(){rSbaObj.BeginDBAction();}
void SbaObjectExt::CancelDBAction(){rSbaObj.CancelDBAction();}
void SbaObjectExt::EndDBAction(){rSbaObj.EndDBAction();}

//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::ExecuteUserSettings(SbaDatabase* pDatabase)
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	DBG_ASSERT(pDatabase->IsCapable(SDB_CAP_USERSETTINGS),"Only allowed when DB is Adabas!");
	return SbaUserAdmin(NULL,pDatabase).Execute();
}
//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::ExecuteBackup(SbaDatabase* pDatabase)
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	DBG_ASSERT(pDatabase->IsCapable(SDB_CAP_BACKUP),"Only allowed when SDB_CAP_BACKUP is supported!");
	// Datei auswhlen
	SfxFileDialog aFileDlg( NULL, WB_3DLOOK | WB_STDMODAL | WB_SAVEAS );

	XubString sTitle(SbaResId(RID_STR_BACKUP_DEST));
	sTitle += aFileDlg.GetText();
	aFileDlg.SetText(sTitle);

//	XubString sFilter("*.rb1");
//	sFilter += SbaResId(RID_STR_FILES);
//	aFileDlg.AddFilter(sFilter, "*.rb1");
//	aFileDlg.SetCurFilter(sFilter);

//	SbaIniWrap aIniWrap;
//	aFileDlg.SetStandardDir(aIniWrap.GetDefaultDatabasePath());

	if (aFileDlg.Execute())
	{
		INetURLObject aUrl(aFileDlg.GetPath());
		XubString aFileName(aUrl.PathToFileName());
		if(aFileName.Len() > 40)
		{
			InfoBox aInfo(NULL,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
			XubString aMsg(aInfo.GetMessText());
			aMsg.SearchAndReplace(String::CreateFromAscii("\'#\'"),String::CreateFromAscii("40"));
			aInfo.SetMessText(aMsg);
			aInfo.Execute();
			return sal_False;
		}
		//	aFileName.SearchAndReplace("|",":");
		return pDatabase->DoCmd(SDB_CAP_BACKUP,aFileName);
	}
	return sal_False;
}

//------------------------------------------------------------------------------
XubString SbaObjectExt::GetUrlFilename(const XubString& _rDbPath,const XubString& _rTitle) const
{
	DBG_ERROR("SbaObjectExt::GetUrlFilename : obsolet method !");
	return XubString();
/*
	SbaIniWrap	aIniWrap;
	XubString aDatabasePath = aIniWrap.GetDefaultDatabasePath();
	DirEntry aEntry(aDatabasePath);
	DirEntry aDBEntry(_rDbPath);
	if (!aDBEntry.GetExtension().Len())
		aDBEntry.SetExtension("sdb");

	aEntry += DirEntry('*');
	aEntry.SetExtension(INTERNETSHORTCUT_EXT);
	aEntry.ToAbs();

	INetURLObject aObj, aFileRef;
	aFileRef.SetSmartProtocol(INET_PROT_FILE);
	aFileRef.SetURL(aDBEntry.GetFull(), sal_False);

	// neue basis fuer URLObject setzen, damit Pfadangaben,
	// die relativ zum Datenbankpfad sind, akzeptiert werden
	sal_Bool bFound = sal_False;

	Dir aDir(aEntry, FSYS_KIND_FILE, FSYS_SORT_NAME, FSYS_SORT_END);
	XubString aURL,aTitle,sUrlFile;
	for (sal_uInt16 i=0 ; i < aDir.Count(); i++)
	{
		sUrlFile = aDir[i].GetFull();
		aTitle = SBA_MOD_EXT()->readFavoriteTitle(sUrlFile);

		aObj.SetURL(SBA_MOD_EXT()->readFavoriteTarget(sUrlFile), sal_True);
		if (aObj == aFileRef)
		{
			if (_rTitle.Compare(aTitle) == COMPARE_EQUAL)
			{
				bFound = sal_True;
				break;
			}
		}
	}
	if (bFound)
		return sUrlFile;
	return XubString();
*/
}
//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::ExecuteConvert(const XubString& rCon,sal_Bool _bTry)
{
	if(!getenv("DBCONFIG"))
		return sal_False;
	::vos::OGuard aGuard(Application::GetSolarMutex());
	try
	{
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseEngine >  xEngineRef(::utl::getProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.data.DatabaseEngine")),::com::sun::star::uno::UNO_QUERY);
		DBG_ASSERT(xEngineRef.is() , "SbaObjectExt: No ::com::sun::star::data::Database engine! Prepare for GPF!");
		::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >  xWrkSpaces(xEngineRef->getWorkspaces(),::com::sun::star::uno::UNO_QUERY);
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseWorkspace >  xWrkSpace;
		::cppu::extractInterface(xWrkSpace, xWrkSpaces->getByIndex(0));

		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabase >  xDb(xWrkSpace->open(rCon));
		if(xDb.is())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XFastPropertySet >  xSet(xDb,::com::sun::star::uno::UNO_QUERY);
			::com::sun::star::uno::Any aVal(xSet->getFastPropertyValue(PROP_TITLE));

			::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry >  xDatabaseRegistry;
			::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  xConversionFlag;
			SetEngine();
			if (m_pContext)
			{
				try
				{
					// the registry for the database data
					xDatabaseRegistry = m_pContext->getSubRegistry(getProgrammaticUrl(rCon));
					::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  xDatabaseRegRoot;
					// it's root
					if (xDatabaseRegistry.is() && xDatabaseRegistry->isValid())
						xDatabaseRegRoot = xDatabaseRegistry->getRootKey();
					if (xDatabaseRegRoot.is() && xDatabaseRegRoot->isValid())
					{
						// the sub key "ConvertDialog"
						xConversionFlag = xDatabaseRegRoot->openKey(::rtl::OUString::createFromAscii("ConvertDialog"));
						if (!xConversionFlag.is() && !xDatabaseRegRoot->isReadOnly())
							// create it
							xConversionFlag = xDatabaseRegRoot->createKey(::rtl::OUString::createFromAscii("ConvertDialog"));
					}
				}
				catch(...)
				{
				}
			}

			sal_Bool bDialog=sal_True;
			if(_bTry && xConversionFlag.is())
			{
				try
				{
					bDialog = (xConversionFlag->getLongValue() != 0);
				}
				catch(...)
				{
				}
			}

			SbaConvertOterroAdabas aDlg(NULL,xDb);
			if(bDialog && aDlg.Execute())
			{
				if (xConversionFlag.is())
				{
					try
					{
						xConversionFlag->setLongValue(aDlg.ShowDialogAgain());
					}
					catch(...)
					{
					}
				}
			}

			if (xConversionFlag.is())
				xConversionFlag->closeKey();
			if (xDatabaseRegistry.is())
				xDatabaseRegistry->close();
		}
	}
	catch(...)
	{
	}
	return sal_False;
}
//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::DoCompact(SbaDatabase* pDatabase)
{
	sal_Bool bResult(sal_False);
	if(pDatabase->IsCapable(SDB_CAP_COMPACT))
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		// Datei auswhlen
		SfxFileDialog* pFileDlg = new SfxFileDialog( NULL, WB_3DLOOK | WB_STDMODAL | WB_SAVEAS );

		XubString sTitle(SbaResId(RID_STR_REORGANIZETABLES_DESTINATION));
		sTitle += pFileDlg->GetText();
		pFileDlg->SetText(sTitle);

		XubString sFilter(String::CreateFromAscii("*.rb1"));
		sFilter += SbaResId(RID_STR_FILES);
		pFileDlg->AddFilter(sFilter, String::CreateFromAscii("*.rb1"));
		pFileDlg->SetCurFilter(sFilter);

		SbaIniWrap aIniWrap;
		pFileDlg->SetStandardDir(aIniWrap.GetDefaultDatabasePath());

		if (pFileDlg->Execute())
		{
			INetURLObject aUrl(pFileDlg->GetPath());
			XubString aFileName(aUrl.GetFull());
			aFileName.SearchAndReplace(String::CreateFromAscii("|"),
				String::CreateFromAscii(":"));
			XubString aOldFileName;
			const CommandParser* pParser = pDatabase->GetOptionsParser();
			if(pParser)
				aOldFileName = pParser->OptionString(String::CreateFromAscii("DSN"));

			if(!aFileName.EqualsIgnoreCaseAscii(aOldFileName))
			{
				aFileName.SearchAndReplace(String::CreateFromAscii(".rb1"),String());
				XubString aTmp(aUrl.GetName());
				aTmp.SearchAndReplace(String::CreateFromAscii(".rb1"),String());
				if(!(aTmp.Len() > 0 && aTmp.Len() < 9))
				{
					XubString aTmp(SbaResId(SBA_STR_DATABASENAME_LEN));
					SdbStatus aSta;
					aSta.Set(SDB_STAT_ERROR,String::CreateFromAscii("01000"),aTmp,0, String() );
					rSbaObj.ShowDbStatus(aSta,dbWriteError);
				}
				else
				{
					if(!pDatabase->DoCmd(SDB_CAP_COMPACT,aFileName))
						rSbaObj.ShowDbStatus(pDatabase->Status(),dbWriteError);
					else
						bResult = sal_True;

				}
			}
			else
			{
				XubString aTmp(SbaResId(SBA_STR_DATABASENAME_DUP));
				SdbStatus aSta;
				aSta.Set(SDB_STAT_ERROR,String::CreateFromAscii("01000"),aTmp,0, String() );
				rSbaObj.ShowDbStatus(aSta,dbWriteError);
			}
		}
		delete pFileDlg;
	}
	else if(pDatabase->IsCapable(SDB_CAP_COMPRESS))
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		if (QueryBox(NULL,SbaResId(QUERY_QBOX_COMPRESS)).Execute() == RET_YES)
		{
			pDatabase->DoCmd(SDB_CAP_COMPRESS,String());
			if(pDatabase->Status().IsError())
				rSbaObj.ShowDbStatus(pDatabase->Status(),dbWriteError);
			else
				bResult = sal_True;
		}
	}
	return bResult;
}
//------------------------------------------------------------------------------
sal_Bool SbaObjectExt::DoReorganize(const XubString& sDatabaseFile)
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	// die Quelldatei exklusiv oeffnen
	SvStorageRef xSource = new SvStorage(sDatabaseFile, STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYALL);
	if (xSource->GetErrorCode())
	{
		SfxErrorContext aContext(DB_REORG_OPEN_SOURCE_ERROR, NULL, SBA_RES_SBAOBJ_ERR_CONTEXTS, SBA_MOD()->GetResMgr());
		ErrorHandler::HandleError(xSource->GetErrorCode());
		return sal_False;
	}

	// die Zieldatei dito
	DirEntry aTempDest = DirEntry().TempName();
	SvStorageRef xDestination = new SvStorage(aTempDest.GetFull(), STREAM_READWRITE | STREAM_TRUNC | STREAM_SHARE_DENYNONE);
	if (xDestination->GetErrorCode())
	{
		SfxErrorContext aContext(DB_REORG_OPEN_TEMPDEST_ERROR, NULL, SBA_RES_SBAOBJ_ERR_CONTEXTS, SBA_MOD()->GetResMgr());
		ErrorHandler::HandleError(xDestination->GetErrorCode());
		return sal_False;
	}

	// alle Eintraege auf Root-Ebene des Source-Storage durchwandern und in das Ziel kopieren
	SvStorageInfoList aBaseLevelEntries;
	xSource->FillInfoList(&aBaseLevelEntries);
	for (sal_uInt16 i=0; i<aBaseLevelEntries.Count(); ++i)
	{
		SvStorageInfo& rCurrent = aBaseLevelEntries[i];
		XubString sCurrent = rCurrent.GetName();
		if (!xSource->CopyTo(sCurrent, xDestination, sCurrent))
		{
			SfxErrorContext aContext(DB_REORG_COPY_TO_TEMPDEST_ERROR, NULL, SBA_RES_SBAOBJ_ERR_CONTEXTS, SBA_MOD()->GetResMgr());
			ErrorHandler::HandleError(xSource->GetErrorCode());

			xDestination = NULL;
			aTempDest.Kill();
			return sal_False;
		}
	}

	xSource = NULL;
	xDestination = NULL;

	// die Source zu einem temporaeren Namen umbenennen
	DirEntry aSource(sDatabaseFile);
	XubString sTempSource = DirEntry().TempName().GetFull();
	FSysError aResult = aSource.MoveTo(sTempSource);
	if (aResult)
	{
		SfxErrorContext aContext(DB_REORG_REPLACE_TEMPSOURCE_ERROR, NULL, SBA_RES_SBAOBJ_ERR_CONTEXTS, SBA_MOD()->GetResMgr());
		ErrorHandler::HandleError(aResult);
		return sal_False;
	}

	// dann das temporaere Dest unter den eigentlichen Namen kopieren
	aResult = aTempDest.MoveTo(sDatabaseFile);
	if (aResult)
	{
		SfxErrorContext aContext(DB_REORG_REPLACE_TEMPSOURCE_ERROR, NULL, SBA_RES_SBAOBJ_ERR_CONTEXTS, SBA_MOD()->GetResMgr());
		ErrorHandler::HandleError(aResult);
#if _DEBUG || DBG_UTIL
		DBG_ASSERT(DirEntry(sTempSource).MoveTo(sDatabaseFile), "SbaObjectExt::DoReorganize : couldn't restore the original SDB file. This database may be lost !");
#else
		DirEntry(sTempSource).MoveTo(sDatabaseFile);
#endif
		aTempDest.Kill();
		return sal_False;
	}

	// und die jetzt uebrfluessige Source wech
	DirEntry(sTempSource).Kill();

	return sal_True;
}

//------------------------------------------------------------------------------
SbaDataExchObj* SbaObjectExt::CreateDataExchObj(sal_uInt16 nType, SbaDatabase* pDB, DBObject eKind,const XubString& rName)
{
	return SbaDBDef::CreateDataExchObj( nType, pDB, eKind, rName);
}

//------------------------------------------------------------------------------
SbaDatabase* SbaObjectExt::GetDatabaseNoOpen(const XubString& rName)
{
	return PTR_CAST(SbaDatabase, (*rSbaObj.pSDBEnv)->GetDatabaseNoOpen(rName));
}

//-------------------------------------------------------------------------
XubString SbaObjectExt::readFavoriteTitle(const XubString& _rUrlFile)
{
	DBG_ERROR("SbaObjectExt::readFavoriteTitle : obsolet method !");
	return XubString();
//	::VOS::OProfile aUrlFileReader;
//	aUrlFileReader.open(_rUrlFile, ::VOS::OProfile::TOption_ReadLock);
//
//	sal_Char cBuffer[MAX_URL_FILE_LINE_LENGTH];
//	cBuffer[0] = 0;
//	// get a default from the language independent section
//	aUrlFileReader.readString(INTERNETSHORTCUT_ID_TAG, INTERNETSHORTCUT_TITLE_TAG, cBuffer, MAX_URL_FILE_LINE_LENGTH, cBuffer);
//	XubString sTitle(cBuffer);
//
//	// check if the ::com::sun::star::util::URL file has a language dependent section
//	XubString sLangDepGroupName = INTERNETSHORTCUT_ID_TAG;
//	sLangDepGroupName += "-$(vlang)";
//	sLangDepGroupName = SFX_APP()->GetAppIniManager()->SubstPathVars(sLangDepGroupName);
//
//	aUrlFileReader.readString(sLangDepGroupName, INTERNETSHORTCUT_TITLE_TAG, cBuffer, MAX_URL_FILE_LINE_LENGTH, sTitle);
//		// the lang-indep. value is the default in case this group has no title entry
//	sTitle = XubString(cBuffer);
//
//	return sTitle.Convert(URLFILE_CHARSET, CHARSET_SYSTEM);
}

//-------------------------------------------------------------------------
void SbaObjectExt::writeFavoriteTitle(const XubString& _rUrlFile, const XubString& _rTitle)
{
	DBG_ERROR("SbaObjectExt::writeFavoriteTitle : obsolet method !");
//	DBG_ASSERT(_rTitle.Len(), "SbaObjectExt::writeFavoriteTitle : invalid argument !");
//	::VOS::OProfile aUrlFileReaderWriter;
//	aUrlFileReaderWriter.open(_rUrlFile, ::VOS::OProfile::TOption_WriteLock);
//
//	// calc the name of the language dependent section
//	XubString sGroupName = INTERNETSHORTCUT_ID_TAG;
//	sGroupName += "-$(vlang)";
//	sGroupName = SFX_APP()->GetAppIniManager()->SubstPathVars(sGroupName);
//
//	// write the key
//	XubString sTitle(_rTitle);
//	sTitle.Convert(CHARSET_SYSTEM, URLFILE_CHARSET);
//	aUrlFileReaderWriter.writeString(sGroupName, INTERNETSHORTCUT_TITLE_TAG, sTitle);
//
//	// if the language independent section does not contain a title, write it therein, too
//	sal_Char cBuffer[MAX_URL_FILE_LINE_LENGTH];
//	cBuffer[0] = 0;
//	aUrlFileReaderWriter.readString(INTERNETSHORTCUT_ID_TAG, INTERNETSHORTCUT_TITLE_TAG, cBuffer, MAX_URL_FILE_LINE_LENGTH, cBuffer);
//	XubString sIndepTitle(cBuffer);
//	if (!sIndepTitle.Len())
//		aUrlFileReaderWriter.writeString(INTERNETSHORTCUT_ID_TAG, INTERNETSHORTCUT_TITLE_TAG, sTitle);
}

//-------------------------------------------------------------------------
XubString SbaObjectExt::readFavoriteTarget(const XubString& _rUrlFile)
{
	DBG_ERROR("SbaObjectExt::readFavoriteTarget : obsolet method !");
	return XubString();
//	::VOS::OProfile aUrlFileReader;
//	aUrlFileReader.open(_rUrlFile, ::VOS::OProfile::TOption_ReadLock);
//
//	sal_Char cBuffer[MAX_URL_FILE_LINE_LENGTH];
//	cBuffer[0] = 0;
//	// assume no language dependencies for the "Location" part
//	aUrlFileReader.readString(INTERNETSHORTCUT_ID_TAG, INTERNETSHORTCUT_URL_TAG, cBuffer, MAX_URL_FILE_LINE_LENGTH, cBuffer);
//	XubString sReturn = SFX_APP()->GetAppIniManager()->SubstPathVars(XubString(cBuffer));
//
//	// as SubstPathVars may have produced "wrong" path separators use an INetURLObject object to normalize the path
//	INetURLObject aNormalizer(sReturn);
//	sReturn = aNormalizer.GetMainURL();
//
//	sReturn.Convert(URLFILE_CHARSET, CHARSET_SYSTEM);
//
//	return sReturn;
}

//-------------------------------------------------------------------------
void SbaObjectExt::writeFavoriteTarget(const XubString& _rUrlFile, const XubString& _rTargetLocation)
{
	DBG_ERROR("SbaObjectExt::writeFavoriteTarget : obsolet method !");
//	DBG_ASSERT(_rTargetLocation.Len(), "SbaObjectExt::writeFavoriteTarget : invalid argument !");
//
//	::VOS::OProfile aUrlFileReader;
//	aUrlFileReader.open(_rUrlFile, ::VOS::OProfile::TOption_WriteLock);
//
//	// the location key will always be written into the language independent section
//	XubString sTargetLocation(_rTargetLocation);
//	sTargetLocation.Convert(CHARSET_SYSTEM, URLFILE_CHARSET);
//	aUrlFileReader.writeString(INTERNETSHORTCUT_ID_TAG, INTERNETSHORTCUT_URL_TAG, sTargetLocation);
}

//-------------------------------------------------------------------------
SfxObjectFactory* SbaObjectExt::GetObjectDocumentFactory(
	const ::rtl::OUString& _rUrl,
	const ::rtl::OUString& _rFrameName,
	const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& _rArgs) const
{
	// get the object type ("db:...")
	INetURLObject aParser(_rUrl);
	if (!aParser.HasMark())
		return NULL;

	XubString sObjectType = aParser.GetMark();
	xub_StrLen nSepPos = sObjectType.Search(';');
	if (nSepPos == STRING_NOTFOUND)
	{	// the only URL type without a separating ';' : relation URLs
		// (no relation design anymore, no shells for this anymore)
		return NULL;
	}

	sObjectType = sObjectType.Copy(0, nSepPos);
	sObjectType += ';';

	// get the view id from the args
	sal_Int16 nViewId = -1;
	const ::com::sun::star::beans::PropertyValue* pArgs = _rArgs.getConstArray();
	for (sal_Int32 i=0; i<_rArgs.getLength(); ++i, ++pArgs)
	{
		if (!pArgs->Name.compareToAscii("ViewId"))
		{
			pArgs->Value >>= nViewId;
			break;
		}
	}

	if (sObjectType.EqualsAscii(SDB_TABLEMARK_HEADER))
	{	// tables
		if (SID_SBA_QRY_DESIGN == nViewId)
			// views have a table url and (initially) a query design view
			return &SbaQueryDocSh::Factory();

		DBG_ASSERT((SID_SBA_TBL_BROWSE == nViewId) || (-1 == nViewId), "SbaObjectExt::GetObjectDocumentFactory : unknown view id !");
		// browse view -> we have a component for this, don't use the factory
	}
	else if (sObjectType.EqualsAscii(SDB_QUERYMARK_HEADER))
	{	// queries
		if ((SID_SBA_QRY_DESIGN == nViewId) || (SID_SBA_QRY_SQL == nViewId))
			// design or sql view -> use factory
			return &SbaQueryDocSh::Factory();

		DBG_ASSERT((SID_SBA_QRY_BROWSE == nViewId) || (-1 == nViewId), "SbaObjectExt::GetObjectDocumentFactory : unknown view id !");
		// browse view -> we have a component for this, don't use the factory
	}
	else if (sObjectType.EqualsAscii(SDB_STATEMENTMARK_HEADER))
	{
		// only browse views for statements -> use the component, not the factory
		return NULL;
	}
	else
	{	// ????
		DBG_ERROR("SbaObjectExt::GetObjectDocumentFactory : invalid ::com::sun::star::util::URL !");
	}

	return NULL;
}

//-------------------------------------------------------------------------
SdbDatabaseGuard* SbaObjectExt::CreateDatabaseGuard(SdbDatabase* _pDB)
{
	return new SdbDatabaseGuard(_pDB);
}

//-------------------------------------------------------------------------
sal_Bool SbaObjectExt::IsThreadSafe(const XubString& _rSdbFile)
{
	// this function is a hack. 
	SbaDatabaseRef xDB = rSbaObj.LoadDatabase(_rSdbFile);
	if (!xDB.Is())
		return sal_False;

	// if the db is open (i.e. has a connection) we may rely on IsCapable
	if (xDB->IsOpen())
		return xDB->IsCapable(SDB_CAP_MULTITHREADACCESS);

	// check the type of the db
	CommandParser aOptionsParser(xDB->ConnectStr(),';','=',sal_True);
	XubString aTYPE = aOptionsParser.OptionString(String::CreateFromAscii("TYP"));

	if (aTYPE == String::CreateFromAscii("DAO"))
		return sal_False;
#ifdef OS2
	if (aTYPE == String::CreateFromAscii("JDBC"))
		return sal_False;
#endif
	return sal_True;
}

//------------------------------------------------------------------------------
XubString SbaObjectExt::ResolveDatabaseAlias(const XubString& _rTitle)
{
	XubString sReturn;
	SetEngine();
	if (m_pContext)
	{
		::com::sun::star::lang::Locale aAppLocale;
		XubString sLanguage, sCountry;
		ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
		aAppLocale.Language = sLanguage;
		aAppLocale.Country = sCountry;

		try
		{
			sReturn = m_pContext->lookupAlias(aAppLocale, _rTitle).getStr();
		}
		catch(::com::sun::star::container::NoSuchElementException& e)
		{
			e; // make compiler hapyy
		}
		catch(...)
		{
			DBG_ERROR("SbaObjectExt::ResolveDatabaseAlias : unexpected exception while calling lookupAlias !");
		}
	}
	return sReturn;
}

//------------------------------------------------------------------------------
XubString SbaObjectExt::GetDatabaseAlias(const XubString& _rURL)
{
	XubString sReturn;
	SetEngine();
	if (m_pContext)
	{
		::com::sun::star::lang::Locale aAppLocale;
		XubString sLanguage, sCountry;
		ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
		aAppLocale.Language = sLanguage;
		aAppLocale.Country = sCountry;

		::rtl::OUString sNormalized = getProgrammaticUrl(_rURL);
		try
		{
			sReturn = m_pContext->lookupProgrammatic(aAppLocale, sNormalized).getStr();
		}
		catch(::com::sun::star::container::NoSuchElementException& e)
		{
			e; // make compiler hapyy
		}
		catch(...)
		{
			DBG_ERROR("SbaObjectExt::ResolveDatabaseAlias : unexpected exception while calling lookupProgrammatic !");
		}
	}
	return sReturn;
}

//------------------------------------------------------------------------------
void SbaObjectExt::RebindDatabaseAlias(const XubString& _rOldURL, const XubString& _rNewURL)
{
	SetEngine();
	if (m_pContext)
	{
		::rtl::OUString sNormalizedOld = getProgrammaticUrl(_rOldURL);
		::rtl::OUString sNormalizedNew = getProgrammaticUrl(_rNewURL);
		try
		{
			m_pContext->rebindAliases(sNormalizedOld, sNormalizedNew);
		}
		catch(::com::sun::star::container::NoSuchElementException& e)
		{
			e; // make compiler hapyy
		}
		catch(...)
		{
			DBG_ERROR("SbaObjectExt::ResolveDatabaseAlias : unexpected exception while calling lookupProgrammatic !");
		}

		// and fot not to loose all the special informations we may have for the old ::com::sun::star::util::URL
		m_pContext->renameSubRegistry(sNormalizedOld, sNormalizedNew);
	}
}

//------------------------------------------------------------------------------
XubString SbaObjectExt::CreateDatabaseAlias(const XubString& _rURL, const XubString& _rTitle, sal_Bool _bAllowUIInteraction, sal_Bool _bUrgent)
{
	XubString sReturn;
	SetEngine();
	if (m_pContext)
	{
		// normalize the ::com::sun::star::util::URL so it is an "file://...."
		::rtl::OUString sNormalizedURL = getProgrammaticUrl(_rURL);

		// a locale for the application language
		::com::sun::star::lang::Locale aAppLocale;
		XubString sLanguage, sCountry;
		ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
		aAppLocale.Language = sLanguage;
		aAppLocale.Country = sCountry;

		sal_Bool bHadConflict = sal_False;
		::rtl::OUString sConflictMessage;
		try
		{
			m_pContext->bindAlias(sNormalizedURL, aAppLocale, _rTitle);
			sReturn = _rTitle;
		}
		catch(::com::sun::star::container::ElementExistException& e)
		{
			e; // make compiler happy
			sConflictMessage = e.Message;
			bHadConflict = sal_True;
		}
		catch(...)
		{
			DBG_ERROR("SbaObjectExt::CreateDatabaseAlias : could not register the object !");
		}

		if (bHadConflict && _bAllowUIInteraction)
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			NameConflictDialog aConflict(NULL, _rTitle, _rURL, _bUrgent);
			aConflict.setContext(m_pContext);
			aConflict.setLocale(aAppLocale);

			if (aConflict.Execute() == RET_OK)
			{
				sReturn = aConflict.getTitle();
			}
		}
	}

	return sReturn;
}

//------------------------------------------------------------------------------
void SbaObjectExt::DropDatabaseAlias(const XubString& _rURL, sal_Bool _bConfirm)
{
	SetEngine();
	if (m_pContext)
	{
		if (_bConfirm)
		{
			XubString sExistentAlias = GetDatabaseAlias(_rURL);
			if (!sExistentAlias.Len())
				// nothing to do
				return;

			::vos::OGuard aGuard(Application::GetSolarMutex());
			XubString sMessage(SbaResId(RID_STR_CONFIRM_DBNAME_DELETION));
			sMessage.SearchAndReplaceAll(String::CreateFromAscii("$url$"), getProgrammaticUrl(_rURL));
			sMessage.SearchAndReplaceAll(String::CreateFromAscii("$name$"), sExistentAlias);
			if (WarningBox(NULL, WB_YES_NO, sMessage).Execute() != RET_YES)
				return;
		}

		// normalize the ::com::sun::star::util::URL so it is an "file://...."
		::rtl::OUString sNormalizedURL = getProgrammaticUrl(_rURL);
		try
		{
			::com::sun::star::lang::Locale aAppLocale;
			XubString sLanguage, sCountry;
			ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
			aAppLocale.Language = sLanguage;
			aAppLocale.Country = sCountry;

			m_pContext->unbindAliases(sNormalizedURL);
		}
		catch(::com::sun::star::container::NoSuchElementException& e)
		{
			e; // make compiler happy
		}
		catch(...)
		{
			DBG_ERROR("SbaObjectExt::DropDatabaseAlias : could not revoke the object !");
		}
	}
}


