/*************************************************************************
 *
 *  $RCSfile: tblds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#define ITEMID_HORJUSTIFY		SBA_ATTR_ALIGN_HOR_JUSTIFY
//	#include <sdb/tools.hxx>

#ifndef _SBA_SBATABED_HXX
#include "sbatabed.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif

#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SBA_TBLDGNVS_HXX
#include "tbldgnvs.hxx"
#endif

#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE
#include <svtools/zforlist.hxx>
#endif

#ifndef _ZFORMAT_HXX //autogen
#include <svtools/zformat.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SBA_DATCONV_HXX_
#include "datconv.hxx"
#endif // _SBA_DATCONV_HXX_

#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif

#define SbaTableDocSh

#include "ofaslots.hxx"
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifdef UNX
#define _cdecl
#define _CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

String GetTypeString( sal_uInt16 nType )
{
	return String(SbaResId(STR_DBFIELDTYPES)).GetToken((xub_StrLen)nType);
}

DBG_NAME(SbaIndexInfo);
//========================================================================
// class SbaTabEdRow
//========================================================================
DBG_NAME(SbaTabEdRow);
//------------------------------------------------------------------------------
SbaTabEdRow::SbaTabEdRow() :
	 aFieldTypes( String(SbaResId(STR_DBFIELDTYPES)) )
	,pActFieldDescr( NULL )
	,nPos( -1 )
	,bReadOnly( sal_False )
	,bFirstNameModify( sal_True )
	,bFirstDescrModify( sal_True )
{
	DBG_CTOR(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Map mit Formaten fuellen
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(0), new SbaUnknownFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(1), new SbaTextFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(2), new SbaNumericFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(3), new SbaDateTimeFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(4), new SbaDateFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(5), new SbaTimeFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(6), new SbaBoolFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(7), new SbaCurrencyFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(8), new SbaMemoFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(9), new SbaCounterFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(10), new SbaImageFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(11), new SbaCharFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(12), new SbaDecimalFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(13), new SbaBinaryFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(14), new SbaVarBinaryFieldDescr );
	aFieldDescrMap.SetAt( aFieldTypes.GetToken(15), new SbaBigIntFieldDescr );

	//////////////////////////////////////////////////////////////////////
	// Defaultbeschreibung setzen
//	SetFieldType( aFieldTypes.GetToken(0) );
}

//------------------------------------------------------------------------------
SbaTabEdRow::SbaTabEdRow( const SbaTabEdRow& rRow, long nPosition ) :
	nPos( nPosition ),
	aFieldTypes(rRow.aFieldTypes),
	bReadOnly(rRow.IsReadOnly()),
	bFirstNameModify(rRow.IsFirstNameModify()),
	bFirstDescrModify(rRow.IsFirstDescrModify())
{
	DBG_CTOR(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Liste der Feldbeschreibungen
	SbaFieldDescrMap* pSrcDescrMap = (SbaFieldDescrMap*)&rRow.aFieldDescrMap;
	SbaFieldDescr* pSrcDescr = pSrcDescrMap->First();

	SbaFieldDescr* pDestDescr;
	String aKey;

	while( pSrcDescr )
	{
		pDestDescr = pSrcDescr->Clone();
		aKey = rRow.aFieldDescrMap.GetKey( pSrcDescr );
		aFieldDescrMap.SetAt( aKey, pDestDescr );

		pSrcDescr = pSrcDescrMap->Next();
	}

	//////////////////////////////////////////////////////////////////////
	// Aktueller Datensatz
	if( !rRow.pActFieldDescr )
		pActFieldDescr = NULL;
	else
	{
		aKey = pSrcDescrMap->GetKey( rRow.pActFieldDescr );
		pActFieldDescr = aFieldDescrMap.Lookup( aKey );
	}
}

//------------------------------------------------------------------------------
SbaTabEdRow::~SbaTabEdRow()
{
	DBG_DTOR(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Map loeschen
	SbaFieldDescr* pFieldDescr = aFieldDescrMap.First();
	while( pFieldDescr )
	{
		delete aFieldDescrMap.Remove( pFieldDescr );
		pFieldDescr = aFieldDescrMap.Next();
	}
}

//------------------------------------------------------------------------------
void SbaTabEdRow::SetPrimaryKey( sal_Bool bSet )
{
	DBG_CHKTHIS(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Setzt bei allen Feldbeschreibungen dieser Zeile den Primary Key
	SbaFieldDescr* pFieldDescr = aFieldDescrMap.First();
	while( pFieldDescr )
	{
		pFieldDescr->SetPrimaryKey( bSet );
		pFieldDescr = aFieldDescrMap.Next();
	}
}

//------------------------------------------------------------------------------
sal_Bool SbaTabEdRow::IsPrimaryKey() const
{
	DBG_CHKTHIS(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Prueft, ob eines der Felder einen Primary Key besitzt
	SbaFieldDescr* pFieldDescr = ((SbaTabEdRow*)this)->aFieldDescrMap.First();
	while( pFieldDescr )
	{
		if( pFieldDescr->IsPrimaryKey() )
			return sal_True;
		pFieldDescr = ((SbaTabEdRow*)this)->aFieldDescrMap.Next();
	}
	return sal_False;
}

//------------------------------------------------------------------------------
void SbaTabEdRow::SetFieldType( const String& rType )
{
	DBG_CHKTHIS(SbaTabEdRow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Vom aktuellen Eintrag die konstanten Werte holen
	String aOldName;
	String aOldDescription;
	sal_Bool bIsPrimaryKey = sal_False;
	if( pActFieldDescr )
	{
		bIsPrimaryKey = pActFieldDescr->IsPrimaryKey();
		aOldName = pActFieldDescr->GetName();
		aOldDescription = pActFieldDescr->GetDescription();
	}

	//////////////////////////////////////////////////////////////////////
	// Den aktuellen Eintrag umsetzen
	SetActFieldDescr( rType );
	if( !pActFieldDescr )
		return;

	//////////////////////////////////////////////////////////////////////
	// Die konstanten Werte in den neuen Eintrag schreiben
	pActFieldDescr->SetPrimaryKey(bIsPrimaryKey);
	pActFieldDescr->SetName( aOldName );
	pActFieldDescr->SetDescription( aOldDescription );
}

//------------------------------------------------------------------------------
void SbaTabEdRow::SetActFieldDescr( const String& rType )
{
	DBG_CHKTHIS(SbaTabEdRow,NULL);
	pActFieldDescr = aFieldDescrMap.Lookup(rType);
}


//========================================================================
// class SbaFieldDescr
//========================================================================
TYPEINIT0( SbaFieldDescr );
DBG_NAME(SbaFieldDescr);
//------------------------------------------------------------------------------
SbaFieldDescr::SbaFieldDescr() :
	bPrimaryKey(sal_False),
	nFormatKey(0),
	bAutoIncrement(sal_False),
	aHorJustify(SVX_HOR_JUSTIFY_STANDARD)
{
	DBG_CTOR(SbaFieldDescr,NULL);
}

//------------------------------------------------------------------------------
SbaFieldDescr::SbaFieldDescr( const SbaFieldDescr& rDescr ) :
	aName(rDescr.aName),
	aType(rDescr.aType),
	aDescription(rDescr.aDescription),
	bPrimaryKey(rDescr.bPrimaryKey),
	nFormatKey(rDescr.nFormatKey),
	bAutoIncrement(rDescr.bAutoIncrement),
	aHorJustify(rDescr.aHorJustify)
{
	DBG_CTOR(SbaFieldDescr,NULL);
}

//------------------------------------------------------------------------------
SbaFieldDescr::~SbaFieldDescr()
{
#ifdef DBG_UTIL
	bAutoIncrement = 99;
#endif
	DBG_DTOR(SbaFieldDescr,NULL);

}

//------------------------------------------------------------------------------
SbaFieldType SbaFieldDescr::GetFieldType() const
{
	DBG_CHKTHIS(SbaFieldDescr,NULL);
	String aFieldTypes( SbaResId(STR_DBFIELDTYPES) );
	xub_StrLen nTokenCount = aFieldTypes.GetTokenCount();
	for( xub_StrLen i=0; i<nTokenCount; i++ )
	{
		if (aType.EqualsIgnoreCaseAscii(aFieldTypes.GetToken(i)))
			return (SbaFieldType)(i);
	}

	return dbNone;
}


//------------------------------------------------------------------------------
SbaFieldDescr* SbaFieldDescr::Clone()
{
	DBG_CHKTHIS(SbaFieldDescr,NULL);
	return new SbaFieldDescr(*this);
}

//========================================================================
// class SbaExtFieldDescr
//========================================================================
TYPEINIT1( SbaExtFieldDescr, SbaFieldDescr );
DBG_NAME(SbaExtFieldDescr);
//------------------------------------------------------------------------------
SbaExtFieldDescr::SbaExtFieldDescr(sal_Bool bRequire)
	:bRequired(bRequire)
{
	DBG_CTOR(SbaExtFieldDescr,NULL);
}

//------------------------------------------------------------------------------
SbaExtFieldDescr::SbaExtFieldDescr( const SbaExtFieldDescr& rDescr ) :
	SbaFieldDescr( rDescr ),
	bRequired(rDescr.bRequired),
	aDefaultValue(rDescr.aDefaultValue)
{
	DBG_CTOR(SbaExtFieldDescr,NULL);
}

//------------------------------------------------------------------------------
SbaExtFieldDescr::~SbaExtFieldDescr()
{
	DBG_DTOR(SbaExtFieldDescr,NULL);
}


//------------------------------------------------------------------------------
SbaFieldDescr* SbaExtFieldDescr::Clone()
{
	DBG_CHKTHIS(SbaExtFieldDescr,NULL);
	return new SbaExtFieldDescr(*this);
}

//========================================================================
// class SbaUnknownFieldDescr
//========================================================================
TYPEINIT1( SbaUnknownFieldDescr, SbaFieldDescr );

//------------------------------------------------------------------------------
SbaUnknownFieldDescr::SbaUnknownFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_UNKNOWN );
}

//------------------------------------------------------------------------------
SbaUnknownFieldDescr::SbaUnknownFieldDescr( const SbaUnknownFieldDescr& rDescr ) :
	SbaFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaUnknownFieldDescr::~SbaUnknownFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaUnknownFieldDescr::Clone()
{
	return new SbaUnknownFieldDescr(*this);
}


//========================================================================
// class SbaTextFieldDescr
//========================================================================
TYPEINIT1( SbaTextFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaTextFieldDescr::SbaTextFieldDescr()
{
	aTextLen.AssignAscii( "50" );
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_TEXT );
}

//------------------------------------------------------------------------------
SbaTextFieldDescr::SbaTextFieldDescr( const SbaTextFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr ),
	aTextLen(rDescr.aTextLen)
{			 	
}

//------------------------------------------------------------------------------
SbaTextFieldDescr::~SbaTextFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaTextFieldDescr::Clone()
{
	return new SbaTextFieldDescr(*this);
}


//========================================================================
// class SbaNumericFieldDescr
//========================================================================
TYPEINIT1( SbaNumericFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaNumericFieldDescr::SbaNumericFieldDescr()
{
	aNumType.AssignAscii( "Integer" );
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_NUMERIC );
}

//------------------------------------------------------------------------------
SbaNumericFieldDescr::SbaNumericFieldDescr( const SbaNumericFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr ),
	aNumType(rDescr.aNumType)
{			 	
}

//------------------------------------------------------------------------------
SbaNumericFieldDescr::~SbaNumericFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaNumericFieldDescr::Clone()
{
	return new SbaNumericFieldDescr(*this);
}

//------------------------------------------------------------------------------
SbaNumericSize SbaNumericFieldDescr::GetNumericSize()
{
	if (aNumType.EqualsAscii("Byte"))
		return dbByte;
	if (aNumType.EqualsAscii("SmallInt"))
		return dbInteger;
	if (aNumType.EqualsAscii("Integer"))
		return dbLong;
	if (aNumType.EqualsAscii("Single"))
		return dbSingle;
	if (aNumType.EqualsAscii("Double"))
		return dbDouble;
	else
		return dbSizeNone;
}

//========================================================================
// class SbaDateTimeFieldDescr
//========================================================================
TYPEINIT1( SbaDateTimeFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaDateTimeFieldDescr::SbaDateTimeFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_DATETIME );
}

//------------------------------------------------------------------------------
SbaDateTimeFieldDescr::SbaDateTimeFieldDescr( const SbaDateTimeFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaDateTimeFieldDescr::~SbaDateTimeFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaDateTimeFieldDescr::Clone()
{
	return new SbaDateTimeFieldDescr(*this);
}


//========================================================================
// class SbaDateFieldDescr
//========================================================================
TYPEINIT1( SbaDateFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaDateFieldDescr::SbaDateFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_DATE );
}

//------------------------------------------------------------------------------
SbaDateFieldDescr::SbaDateFieldDescr( const SbaDateFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaDateFieldDescr::~SbaDateFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaDateFieldDescr::Clone()
{
	return new SbaDateFieldDescr(*this);
}

//========================================================================
// class SbaTimeFieldDescr
//========================================================================
TYPEINIT1( SbaTimeFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaTimeFieldDescr::SbaTimeFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_TIME );
}

//------------------------------------------------------------------------------
SbaTimeFieldDescr::SbaTimeFieldDescr( const SbaTimeFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaTimeFieldDescr::~SbaTimeFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaTimeFieldDescr::Clone()
{
	return new SbaTimeFieldDescr(*this);
}


//========================================================================
// class SbaCurrencyFieldDescr
//========================================================================
TYPEINIT1( SbaCurrencyFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaCurrencyFieldDescr::SbaCurrencyFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_CURRENCY );
}

//------------------------------------------------------------------------------
SbaCurrencyFieldDescr::SbaCurrencyFieldDescr( const SbaCurrencyFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaCurrencyFieldDescr::~SbaCurrencyFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaCurrencyFieldDescr::Clone()
{
	return new SbaCurrencyFieldDescr(*this);
}


//========================================================================
// class SbaMemoFieldDescr
//========================================================================
TYPEINIT1( SbaMemoFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaMemoFieldDescr::SbaMemoFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_MEMO );
}

//------------------------------------------------------------------------------
SbaMemoFieldDescr::SbaMemoFieldDescr( const SbaMemoFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaMemoFieldDescr::~SbaMemoFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaMemoFieldDescr::Clone()
{
	return new SbaMemoFieldDescr(*this);
}


//========================================================================
// class SbaBoolFieldDescr
//========================================================================
TYPEINIT1( SbaBoolFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaBoolFieldDescr::SbaBoolFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_BOOL );
}

//------------------------------------------------------------------------------
SbaBoolFieldDescr::SbaBoolFieldDescr( const SbaBoolFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaBoolFieldDescr::~SbaBoolFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaBoolFieldDescr::Clone()
{
	return new SbaBoolFieldDescr(*this);
}


//========================================================================
// class SbaCounterFieldDescr
//========================================================================
TYPEINIT1( SbaCounterFieldDescr, SbaFieldDescr );

//------------------------------------------------------------------------------
SbaCounterFieldDescr::SbaCounterFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_COUNTER);
}

//------------------------------------------------------------------------------
SbaCounterFieldDescr::SbaCounterFieldDescr( const SbaCounterFieldDescr& rDescr ) :
	SbaFieldDescr( rDescr )
{}

//------------------------------------------------------------------------------
SbaCounterFieldDescr::~SbaCounterFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaCounterFieldDescr::Clone()
{
	return new SbaCounterFieldDescr(*this);
}

//========================================================================
// class SbaImageFieldDescr
//========================================================================
TYPEINIT1( SbaImageFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaImageFieldDescr::SbaImageFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_IMAGE );
}

//------------------------------------------------------------------------------
SbaImageFieldDescr::SbaImageFieldDescr( const SbaImageFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaImageFieldDescr::~SbaImageFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaImageFieldDescr::Clone()
{
	return new SbaImageFieldDescr(*this);
}

//========================================================================
// class SbaCharFieldDescr
//========================================================================
TYPEINIT1( SbaCharFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaCharFieldDescr::SbaCharFieldDescr()
{
	aTextLen.AssignAscii( "50" );
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_CHAR );
}

//------------------------------------------------------------------------------
SbaCharFieldDescr::SbaCharFieldDescr( const SbaCharFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr ),
	aTextLen(rDescr.aTextLen)
{			 	
}

//------------------------------------------------------------------------------
SbaCharFieldDescr::~SbaCharFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaCharFieldDescr::Clone()
{
	return new SbaCharFieldDescr(*this);
}

//========================================================================
// class SbaDecimalFieldDescr
//========================================================================
TYPEINIT1( SbaDecimalFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaDecimalFieldDescr::SbaDecimalFieldDescr() : aLength('5'),aScale('0')
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_DECIMAL );
}

//------------------------------------------------------------------------------
SbaDecimalFieldDescr::SbaDecimalFieldDescr( const SbaDecimalFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr ),
	aLength(rDescr.aLength),
	aScale(rDescr.aScale)
{						 	
}

//------------------------------------------------------------------------------
SbaDecimalFieldDescr::~SbaDecimalFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaDecimalFieldDescr::Clone()
{
	return new SbaDecimalFieldDescr(*this);
}


//========================================================================
// class SbaBinaryFieldDescr
//========================================================================
TYPEINIT1( SbaBinaryFieldDescr, SbaFieldDescr );

//------------------------------------------------------------------------------
SbaBinaryFieldDescr::SbaBinaryFieldDescr()
{
	aLength.AssignAscii("16");
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_BINARY );
}

//------------------------------------------------------------------------------
SbaBinaryFieldDescr::SbaBinaryFieldDescr( const SbaBinaryFieldDescr& rDescr ) :
	SbaFieldDescr( rDescr )
{
	aLength = rDescr.aLength;
}

//------------------------------------------------------------------------------
SbaBinaryFieldDescr::~SbaBinaryFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaBinaryFieldDescr::Clone()
{
	return new SbaBinaryFieldDescr(*this);
}


//========================================================================
// class SbaVarBinaryFieldDescr
//========================================================================
TYPEINIT1( SbaVarBinaryFieldDescr, SbaFieldDescr );

//------------------------------------------------------------------------------
SbaVarBinaryFieldDescr::SbaVarBinaryFieldDescr()
{
	aLength.AssignAscii("16");
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_VARBINARY );
}

//------------------------------------------------------------------------------
SbaVarBinaryFieldDescr::SbaVarBinaryFieldDescr( const SbaVarBinaryFieldDescr& rDescr ) :
	SbaFieldDescr( rDescr )
{
	aLength = rDescr.aLength;
}

//------------------------------------------------------------------------------
SbaVarBinaryFieldDescr::~SbaVarBinaryFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaVarBinaryFieldDescr::Clone()
{
	return new SbaVarBinaryFieldDescr(*this);
}


//========================================================================
// class SbaBigIntFieldDescr
//========================================================================
TYPEINIT1( SbaBigIntFieldDescr, SbaExtFieldDescr );

//------------------------------------------------------------------------------
SbaBigIntFieldDescr::SbaBigIntFieldDescr()
{
	aType = String( SbaResId(STR_DBFIELDTYPES) ).GetToken( TYPE_BIGINT );
}

//------------------------------------------------------------------------------
SbaBigIntFieldDescr::SbaBigIntFieldDescr( const SbaBigIntFieldDescr& rDescr ) :
	SbaExtFieldDescr( rDescr )
{
}

//------------------------------------------------------------------------------
SbaBigIntFieldDescr::~SbaBigIntFieldDescr()
{
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaBigIntFieldDescr::Clone()
{
	return new SbaBigIntFieldDescr(*this);
}


//========================================================================
// class SbaTableDocSh
//=========================================================================
TYPEINIT1(SbaTableDocSh,SbaDBDataDefDocSh)
DBG_NAME(SbaTableDocSh);
//-------------------------------------------------------------------------
SFX_IMPL_SIMPLE_OBJECTFACTORY_LOD(SbaTableDocSh, Sba, SBA_MOD());


//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaTableDocSh, SbaDBDataDefDocSh, SbaResId(0))
{
}

//-------------------------------------------------------------------------
SbaTableDocSh::SbaTableDocSh(SfxObjectCreateMode eMode)
			  :SbaDBDataDefDocSh(eMode)
			  ,nInitialRows( 128 )
			  ,m_bRowVersionColumn(sal_False)
{
	DBG_CTOR(SbaTableDocSh,NULL);
}

//-------------------------------------------------------------------------
SbaTableDocSh::~SbaTableDocSh()
{
	DBG_DTOR(SbaTableDocSh,NULL);
	//////////////////////////////////////////////////////////////////////
	// Liste fuer Tabellenentwurf loeschen
	for( sal_uInt32 i=aTabEdRowList.Count(); i>0; i-- )
		delete aTabEdRowList.Remove( i-1 );
}

//-------------------------------------------------------------------------
sal_Bool SbaTableDocSh::InitNew(SvStorage *pStor)
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	if (!SbaDBDataDefDocSh::InitNew(pStor))
		return sal_False;

	if (xDBDef.Is() && xDBDef->IsNew())
		// Dokument-Daten auf UI-Daten umsetzen
		LoadData();

	return sal_True;
}

//-------------------------------------------------------------------------
sal_Bool SbaTableDocSh::ConvertFrom(SfxMedium& rMedium)
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	if( !SbaDBDataDefDocSh::ConvertFrom(rMedium) )
		return sal_False;

	// wenn ich in der Browse-Ansicht oeffne ...
	const SfxUInt16Item* pitemViewID = PTR_CAST(SfxUInt16Item, GetMedium()->GetItemSet()->GetItem(SID_VIEW_ID));
	if (!pitemViewID || (pitemViewID->GetValue() == SID_SBA_TBL_BROWSE))
	{	// (bei normalem Oeffnen ueber Doppelklick ist kein SID_VIEW_ID-Item drin)
		// ... muss ich testen, ob die Tabelle nicht eventuell gelockt ist
		SbaDBDefRef xDefinition = GetDBDef();
		if (xDefinition.Is() && xDefinition->IsLocked())
		{
			String strMessage(SbaResId(RID_STR_OPENTABLE_TABLELOCKED));
			strMessage.SearchAndReplaceAscii("$name$", xDefinition->Name());
			ErrorBox(NULL, WB_OK, strMessage).Execute();
			return sal_False;
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Dokument-Daten auf UI-Daten umsetzen
	LoadData();
	FinishedLoading( SFX_LOADED_ALL );
	return sal_True;
}

//-------------------------------------------------------------------------
sal_Bool SbaTableDocSh::Refresh()
{
	if (!SbaDBDataDefDocSh::Refresh())
		return sal_False;

	// load my data from the definition object
	LoadData();

	return sal_True;
}

//-------------------------------------------------------------------------
void SbaTableDocSh::LoadData()
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	//////////////////////////////////////////////////////////////////////
	// Wenn Datenstruktur bereits vorhanden, Struktur leeren
	while( aTabEdRowList.Count() )
		delete aTabEdRowList.Remove( aTabEdRowList.First() );

	//////////////////////////////////////////////////////////////////////
	// Datenstruktur mit Daten aus DatenDefinitionsObjekt fuellen
	SbaDBDataDefRef aDef = PTR_CAST(SbaDBDataDef,GetDBDef());
	const SbaColumnList& rColumnList = aDef->GetOriginalColumns();
	SbaTabEdRow* pTabEdRow;
	SbaFieldDescr* pActFieldDescr;
	String aType;
	sal_uInt32 nColCount = rColumnList.Count();
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = GetDatabase()->GetMetaData();

	//////////////////////////////////////////////////////////////////////
	// ReadOnly-Flag
	// Bei Drop darf keine Zeile editierbar sein.
	// Bei Add duerfen nur die leeren Zeilen editierbar sein.
	// Bei Add und Drop koennen alle Zeilen editiert werden.

	sal_Bool bReadOldRow = !aDef->IsNew() && !((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) &&
		(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN));

	for( sal_uInt32 i=0; i<nColCount; i++ )
	{
		SbaColumn* pColumn = rColumnList.GetObject(i);
		SFX_ITEMSET_GET(*pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True);
		SFX_ITEMSET_GET(*pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
		SFX_ITEMSET_GET(*pColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, sal_True);
		SFX_ITEMSET_GET(*pColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, sal_True);
		SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
		SFX_ITEMSET_GET(*pColumn, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, sal_True);
		SFX_ITEMSET_GET(*pColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True);
		SFX_ITEMSET_GET(*pColumn, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, sal_True);
		SFX_ITEMSET_GET(*pColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, sal_True);
		SFX_ITEMSET_GET(*pColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, sal_True);
		SFX_ITEMSET_GET(*pColumn, pHorJustify, SvxHorJustifyItem, SBA_ATTR_ALIGN_HOR_JUSTIFY, sal_True);
		SFX_ITEMSET_GET(*pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);

		SbaFieldType aFieldType = pType->GetType();
		pTabEdRow = new SbaTabEdRow();
		pTabEdRow->SetReadOnly(bReadOldRow);
		//////////////////////////////////////////////////////////////////////
		// Allgemeine Daten
		String aType = GetType(aFieldType);
		pTabEdRow->SetActFieldDescr( aType );
		pActFieldDescr = pTabEdRow->GetActFieldDescr();
		pActFieldDescr->SetName(pName->GetValue());
		pActFieldDescr->SetFormatKey(pFormat->GetValue());
		pActFieldDescr->SetPrimaryKey(pPrimary->GetValue());
		pActFieldDescr->SetDescription(pComment->GetValue());
		pActFieldDescr->SetAutoIncrement(pAutoIncrement->GetValue());
		pActFieldDescr->SetHorJustify((SvxCellHorJustify)pHorJustify->GetValue());

		//////////////////////////////////////////////////////////////////////
		// Spezielle Daten
		if( pActFieldDescr->ISA(SbaExtFieldDescr) )
		{
			((SbaExtFieldDescr*)pActFieldDescr)->SetRequired(pRequired->GetValue());
			((SbaExtFieldDescr*)pActFieldDescr)->SetDefault(pDefault->GetValue());
		}

		switch( pActFieldDescr->GetFieldType() )
		{
		case dbText:
			((SbaTextFieldDescr*)pActFieldDescr )->SetTextLen( GetLength(pLength->GetValue()) );
			break;

		case dbNumeric:
			( (SbaNumericFieldDescr*)pActFieldDescr )->SetNumType(aDef->SizeString((SbaNumericSize)pLength->GetValue()) );
			break;

		case dbChar:
			((SbaCharFieldDescr*)pActFieldDescr )->SetTextLen( GetLength(pLength->GetValue()) );
			break;

		case dbDecimal:
			{
				SbaDecimalFieldDescr* pDecFieldDescr = (SbaDecimalFieldDescr*)pActFieldDescr;
				pDecFieldDescr->SetLength( GetLength(pLength->GetValue()) );
				pDecFieldDescr->SetScale( String::CreateFromInt32(pScale->GetValue()) );
			}
			break;
		case dbBinary:
			((SbaBinaryFieldDescr*)pActFieldDescr )->SetLength( GetLength(pLength->GetValue()) );
			break;

		case dbVarBinary:
			((SbaVarBinaryFieldDescr*)pActFieldDescr )->SetLength( GetLength(pLength->GetValue()) );
			break;
		}

		//////////////////////////////////////////////////////////////////////
		// Neues Objekt in Liste einfuegen
		if(pFlags->GetValue() & SDB_FLAGS_VERSIONING)
		{
			m_bRowVersionColumn = sal_True;
			delete pTabEdRow;
		}
		else
			aTabEdRowList.Insert( pTabEdRow, LIST_APPEND );
	}
	//////////////////////////////////////////////////////////////////////
	// Leere Zeilen fuellen

	sal_Bool bReadRow = !aDef->IsNew() && !(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN);
	for(i=nColCount; i<nInitialRows; i++ )
	{
		pTabEdRow = new SbaTabEdRow();
		pTabEdRow->SetReadOnly(bReadRow);
		aTabEdRowList.Insert( pTabEdRow, LIST_APPEND );
	}

	// da sich die FieldDescriptions geaendert haben und meine UI eventuell noch Referenzen darauf hat ...
	SbaDBDataDefViewSh* pViewSh = GetCurView();
	if (pViewSh && pViewSh->ISA(SbaTableDesignViewSh))
	{
		((SbaTableDesignViewSh*)pViewSh)->GetDesignWin()->GetEditorCtrl()->DisplayData(0);
		((SbaTableDesignViewSh*)pViewSh)->GetDesignWin()->GetTabDescWin()->Init();
	}
}

//------------------------------------------------------------------------------
sal_uInt16 SbaTableDocSh::PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing )
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	sal_Bool bRes = SbaDBDataDefDocSh::PrepareClose( bUI, bForBrowsing );
	if (!bRes && bUI)
	{
		SfxViewFrame *pFrame = SfxObjectShell::Current() == this
			? SfxViewFrame::Current() : SfxViewFrame::GetFirst( this );
		while ( pFrame && (pFrame->GetFrameType() & SFXFRAME_SERVER ) )
			pFrame = SfxViewFrame::GetNext( *pFrame, this );

		if ( pFrame )
		{
			SfxViewShell* pView = pFrame->GetViewShell();
			if (pView)
				pView->GetWindow()->Invalidate();	// invalidate da eine neue zeile eingefuegt wurde
		}
	}
	return bRes;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableDocSh::HasPrimaryKey()
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	SbaFieldDescr* pActFieldDescr;

	for (sal_uInt16 i = 0; i < aTabEdRowList.Count(); i++)
	{
		pActFieldDescr = aTabEdRowList.GetObject(i)->GetActFieldDescr();
		if(pActFieldDescr && pActFieldDescr->IsPrimaryKey() )
			return sal_True;
	}

	return sal_False;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableDocSh::HasFieldName( const String& rFieldName )
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	SbaFieldDescr* pActFieldDescr;

	for (sal_uInt16 i = 0; i < aTabEdRowList.Count(); i++)
	{
		pActFieldDescr = aTabEdRowList.GetObject(i)->GetActFieldDescr();
		if (pActFieldDescr && pActFieldDescr->GetName().Equals(rFieldName))
			return sal_True;
	}

	return sal_False;
}

//------------------------------------------------------------------------------
String SbaTableDocSh::GenerateUniqueName( const String& rBaseName )
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	String aUniqueName;

	for( sal_uInt16 i=0; i<99; i++ )
	{
		aUniqueName = rBaseName;
		if( i>0 )
			aUniqueName += String(i);
		if( !HasFieldName(aUniqueName) )
			return aUniqueName;
	}

	return String();
}

//------------------------------------------------------------------------------
sal_Bool SbaTableDocSh::CheckDefConsistency()
{
	// dem Formatter die richtige Interpretation von Datums-Formaten angewoehnen
	SvNumberFormatter* pFormatter = GetDBDef()->GetDatabase()->GetFormatter();
	pFormatter->SetEvalDateFormat(NF_EVALDATEFORMAT_FORMAT);

	SbaDbDataConverter aConverter(pFormatter);

	// ich werde die gueltigen Spalten mitzaehlen
	sal_uInt16 nCols = 0;
	sal_Bool bCase = (GetDatabase()->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	// Ueberpruefung der Default-Werte
	for (sal_uInt16 i = 0; i < aTabEdRowList.Count(); ++i)
	{
		SbaFieldDescr* pFieldDescr = aTabEdRowList.GetObject(i)->GetActFieldDescr();
		if (pFieldDescr && (pFieldDescr->GetName().Len() != 0))
		{
			sal_uInt16 nErrorRes = sal_uInt16(-1);
			sal_uInt16 nFieldPos = sal_uInt16(-1);
			// first check for duplicate names
			for (sal_uInt16 j = i+1 ; j < aTabEdRowList.Count(); ++j)
			{
				SbaFieldDescr* pCompareDesc = aTabEdRowList.GetObject(j)->GetActFieldDescr();
				if (pCompareDesc && 
					(bCase ? (pCompareDesc->GetName().Equals(pFieldDescr->GetName())) : SbaDBObj::EqualNamesInsensitive(pCompareDesc->GetName(), pFieldDescr->GetName())))
				{
					nErrorRes = RID_STR_DUPLICATE_NAME;
					nFieldPos = FIELD_NAME;
					break;
				}
			}

			++nCols;

			// Bedingungen, unter denen ich eine FieldDescription als ungueltig betrachte :
			// 1) Es handelt sich um ein Feld mit Laengenbeschraenkung und der Default-Wert ist zu lang.
			// 2) Fuer ein numerisches (oder Dezimal- oder Datums- oder Zeit- oder Datum/Zeit- oder Waehrungs-) Feld
			//	wurde ein String angegeben, der nicht entsprechend interpretierbar ist (also zum Beispiel Buchstaben)
			// Bedingungen, unter denen ich eine Warnung ausgebe :
			// 3) Es handelt sich um ein numerisches Feld, bei dem die Formatierung mit der angegebenen Einstellung einen
			//	anderen Wert ergibt.
			// 4) Das eingestellte Format passt eigentlich nicht zum Feldtyp. Beispiel : Fuer ein Datumsfeld wurde ein Waehrungs-
			//	format eingestellt.
			// 5) Es wurde ein Prozentformat fuer ein ganzzahliges numerisches Feld eingestellt, das macht nicht viel Sinn, da
			//	eine 1 schon 100% entspricht, man also nur ganzzahlige Vielfache von 100% eingeben koennte

			// das Design-Window werde ich ein paar mal fragen muessen
			SbaTableDesignWin* pMainWin = NULL;
			SbaDBDataDefViewSh* pViewSh = GetCurView();
			if (pViewSh && pViewSh->ISA(SbaTableDesignViewSh))
				pMainWin = ((SbaTableDesignViewSh*)pViewSh)->GetDesignWin();

			// fuer 4)
			sal_Bool bInvalidFormatCategory(sal_False);
			// und 5)
			sal_Bool bSenselessPercentFormat(sal_False);
			short nFmtCat = pMainWin ? pMainWin->GetDescWin()->GetFormatCategory(pFieldDescr) : -1;

			// fuer 1)
			sal_Bool bNeedCheckLength = sal_False;
			int nLength;

			// fuer einen Teil von 2)
			SbaNumericSize aNumSize = dbSizeNone;

			if (sal_uInt16(-1) == nErrorRes)
			{	// if this fails there already was an error
				switch (pFieldDescr->GetFieldType())
				{
					case dbMemo:
					case dbImage:
					case dbNULL:
					case dbNone:
					case dbCounter:
						continue;	// hier gibt es keinen Default-Wert

					case dbText:
						nLength = GetLength(((SbaTextFieldDescr*)pFieldDescr)->GetTextLen());
						bNeedCheckLength = sal_True;
						break;

					case dbChar:
						nLength = GetLength(((SbaCharFieldDescr*)pFieldDescr)->GetTextLen());
						bNeedCheckLength = sal_True;
						break;

					case dbDecimal:
					case dbNumeric:
						if (pFieldDescr->IsAutoIncrement())
							continue;	// auch AutoIncs haben kein Default

						aNumSize = ((SbaNumericFieldDescr*)pFieldDescr)->GetNumericSize();

						switch (nFmtCat)
						{
							case CAT_PERCENT:
								bSenselessPercentFormat = (aNumSize == dbLong) || (aNumSize == dbInteger) || (aNumSize == dbByte);
								// kein BREAK
							case CAT_NUMBER:
							case CAT_SCIENTIFIC:
							case CAT_FRACTION:
								// sind sinnvoll fuer den gewuenschten Feldtyp
								break;
							default:
								bInvalidFormatCategory = sal_True;
						}
						goto Check;

					case dbDateTime:
					case dbDate:
					case dbTime:
						if ((nFmtCat != CAT_DATE) && (nFmtCat != CAT_TIME))
							bInvalidFormatCategory = sal_True;
						goto Check;

					case dbCurrency:
						if (nFmtCat != CAT_CURRENCY)
							bInvalidFormatCategory = sal_True;

					Check:
					{
						// eine Warnung, wenn der Feld- und der Formatierungstyp unvertraeglich sind
						// oder eine eventuell nicht sinnvolle Prozent-Formatierung gewaehlt wurde
						sal_Int32 nWarningRes = bInvalidFormatCategory ? RID_STR_ILLEGAL_FORMAT_CATEGORY
							: bSenselessPercentFormat ? RID_STR_SENSELESS_PERCENT_FORMAT : 0;
						if (nWarningRes)
						{
							String strMessage = String(SbaResId(nWarningRes));
							strMessage.SearchAndReplaceAscii("$column$", pFieldDescr->GetName());
							if (WarningBox(NULL, WB_YES_NO_CANCEL, strMessage).Execute() != RET_YES)
							{
								if (pMainWin)
								{
									pMainWin->GetEditorCtrl()->DisplayData(i, sal_False);
									pMainWin->GetDescWin()->ActivatePropertyField(FIELD_PROPERTY_FORMAT);
								}
								return sal_False;
							}
						}

						// der zu checkende Default
						String strDefault = ((SbaExtFieldDescr*)pFieldDescr)->GetDefault();

						// testen, ob der String ueberhaupt dem Format entspricht
						ODbVariantRef xVar = new ODbVariant;

						if (aConverter.String2Var(strDefault, pFieldDescr->GetFieldType(), pFieldDescr->GetFormatKey(),
							aNumSize, *xVar))
						{
							// testen, ob es vielleicht nur durch den Formatierer gegangen ist, weil der es falsch interpretiert hat
							// (er erlaubt zum Beispiel fuer ein numerisches Feld den Wert 3.4, fasst das irgendwie als Datum auf
							// und konvertiert dieses dann in ein double, was fuer ihn auch ein gueltiges Ergebnis ergibt)
							Color* pDummy;
							String strFormatted = aConverter.Var2String(*xVar, pFieldDescr->GetFieldType(), pFieldDescr->GetFormatKey(),
								&pDummy);

							if (!strDefault.Equals(strFormatted))
							{
								// eine Warnung und den Benutzer entscheiden lassen
								String strMessage = String(SbaResId(RID_STR_DEFVALUE_ADAPTED));
								strMessage.SearchAndReplaceAscii("$column$", pFieldDescr->GetName());
								strMessage.SearchAndReplaceAscii("$olddefault$", strDefault);
								strMessage.SearchAndReplaceAscii("$newdefault$", strFormatted);
								if (WarningBox(NULL, WB_YES_NO_CANCEL, strMessage).Execute() != RET_YES)
								{
									if (pMainWin)
									{
										pMainWin->GetEditorCtrl()->DisplayData(i, sal_False);
										pMainWin->GetDescWin()->ActivatePropertyField(FIELD_PROPERTY_DEFAULT);
									}
									return sal_False;
								}

								// er hat es akzeptiert -> den entsrechenden Wert setzen und die UI updaten
								((SbaExtFieldDescr*)pFieldDescr)->SetDefault(strFormatted);
								if (pMainWin)
								{
									SbaTableEditorCtrl* pEditor = pMainWin->GetEditorCtrl();
									if (pEditor->GetCurRow() == i)
										pEditor->DisplayData(i);
								}
							}
						}
						else
						{
							// irgendwas ging schief ...
							nErrorRes = RID_STR_ILLEGAL_DEFVALUE_FORMAT;	// der String fuer die Fehlermeldung
							nFieldPos = FIELD_PROPERTY_DEFAULT;
						}
					}
				}

				// ein ::com::sun::star::chaos::Error, wenn der Default-Wert die falsche Laenge hat
				if (bNeedCheckLength && pFieldDescr->ISA(SbaExtFieldDescr))
				{
					String strDefault = ((SbaExtFieldDescr*)pFieldDescr)->GetDefault();
					if (strDefault.Len() > nLength)
					{
						nErrorRes = RID_STR_ILLEGAL_DEFVALUE_LENGTH;
						nFieldPos = FIELD_PROPERTY_DEFAULT;
					}
				}
			}

			// wenn es einen Fehler gab ...
			if (nErrorRes != sal_uInt16(-1))
			{
				// ... Meldung ...
				String strMessage = String(SbaResId(nErrorRes));
				strMessage.SearchAndReplaceAscii("$column$", pFieldDescr->GetName());
				ErrorBox(NULL, WB_OK, strMessage).Execute();

				// ... entsprechendes Control aktivieren ...
				if (pMainWin)
				{
					pMainWin->GetEditorCtrl()->DisplayData(i, sal_False);
					if (nFieldPos >= FIELD_FIRST_VIRTUAL_COLUMN)
						pMainWin->GetDescWin()->ActivatePropertyField(nFieldPos);
					else
						pMainWin->GetEditorCtrl()->GoToColumnId(nFieldPos);
				}

				// ... und wech
				return sal_False;
			}
		}
	}

	// mindestens eine Spalte ?
	if (!nCols)
	{
		ErrorBox(NULL, SbaResId(ERR_SBA_EMPTY_TABLE_DESIGN)).Execute();
		return sal_False;
	}

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableDocSh::_SaveImpl()
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	SbaTableDefRef xDef = (SbaTableDef*)GetDBDef();
	// Definition muss existieren und geoeffnet sein
	// Fehlermeldung fehlt
	if (!xDef.Is() || !xDef->IsOpen())
		return sal_False;

	if (xDef->IsUsed())
	{
		String strMessage(SbaResId(RID_STR_CANT_SAVE_TABLE_USED));
		ErrorBox(NULL, WB_OK, strMessage).Execute();
		return sal_False;
	}

	if(!xDef->IsNew() && !xDef->GetTable()->IsView())
	{
		String aTmpStr(SbaResId(STR_QUERY_TABLE_MODIFIED));
		aTmpStr.SearchAndReplace('#',xDef->GetTable()->Name());
		SbaMsgBox aBox( GetpApp()->GetDefDialogParent(),String(SbaResId(STR_TABLE_CHANGE)), aTmpStr, WB_YES_NO | WB_DEF_NO, SbaMsgBox::Query);
		if( aBox.Execute() != RET_YES )
			return sal_False;
	}

	//////////////////////////////////////////////////////////////////////
	// Daten-Ueberpruefung
	if (!CheckDefConsistency())
		return sal_False;

	//////////////////////////////////////////////////////////////////////
	// Daten in neue Struktur schreiben
	SbaFieldDescr* pActFieldDescr;
	String aType;
	SbaFieldType aFieldType;
	sal_Bool bRequired(sal_False);
	sal_uInt32 nLength(0);
	sal_uInt16 nScale(0);
	String aDefault;

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(xDef->GetDatabase()->GetMetaData());
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	sal_Bool bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE;
	if(xDef->IsNew() && bPKeyAllowed && !HasPrimaryKey())
	{
		SbaMsgBox aBox( GetpApp()->GetDefDialogParent(), String(SbaResId(STR_ERR_NO_PRIM_KEY_HEAD)),
				String(SbaResId(STR_ERR_NO_PRIM_KEY)), WB_YES_NO_CANCEL | WB_DEF_YES, SbaMsgBox::Query);

		sal_Int16 nReturn = aBox.Execute();

		if (nReturn == RET_YES)
		{
			SbaTabEdRow* pNewRow = new SbaTabEdRow();
			String aFieldTypes( SbaResId(STR_DBFIELDTYPES) );

			pNewRow->SetFieldType( aFieldTypes.GetToken(TYPE_NUMERIC) );
			SbaFieldDescr* pActFieldDescr = pNewRow->GetActFieldDescr();

			SdbTypeInfo *pInfo=NULL;
			if(pInfo = xDef->GetDatabase()->IsTypeAvailable(dbNumeric,3))
				pActFieldDescr->SetAutoIncrement(pInfo->bAutoIncrement);

			if (pActFieldDescr->ISA(SbaExtFieldDescr))	// das sollte der Normalfall sein
				// -> auf sal_True setzen, da das hier ein Primaerschluessel sein soll
				((SbaExtFieldDescr*)pActFieldDescr)->SetRequired(sal_True);

			pActFieldDescr->SetName( GenerateUniqueName(String::CreateFromAscii("ID")) );
			pActFieldDescr->SetPrimaryKey( sal_True );
			aTabEdRowList.Insert( pNewRow, (sal_uInt32)0 );

			SbaDBDataDefViewSh* pViewSh = GetCurView();
			if (pViewSh && pViewSh->ISA(SbaTableDesignViewSh))
				((SbaTableDesignViewSh*)pViewSh)->GetDesignWin()->GetEditorCtrl()->DisplayData(0);

		}
		else if (nReturn != RET_NO)
			return sal_False;
	}


	//////////////////////////////////////////////////////////////////////
	// Columns kopieren
	SbaColumnList& rCols = xDef->GetColumns();
	rCols.Clear();

	for (sal_uInt16 i = 0; i < aTabEdRowList.Count(); i++)
	{
		pActFieldDescr = aTabEdRowList.GetObject(i)->GetActFieldDescr();

		//////////////////////////////////////////////////////////////////////
		// Leere Felder werden nicht uebernommen
		if (pActFieldDescr && (pActFieldDescr->GetName().Len() != 0))
		{
			bRequired = sal_False;
			nLength = nScale = 0;
			aDefault.Erase();
			//////////////////////////////////////////////////////////////
			// Nur bei ExtFieldDescr kann Required-Flag ausgelesen werden, sonst sal_True
			if( pActFieldDescr->ISA(SbaExtFieldDescr) )
			{
				bRequired = ((SbaExtFieldDescr*)pActFieldDescr)->IsRequired();
				aDefault = ((SbaExtFieldDescr*)pActFieldDescr)->GetDefault();
			}

			//////////////////////////////////////////////////////////////////////
			// Spezielle Daten
			aFieldType = pActFieldDescr->GetFieldType();
			switch( aFieldType )
			{
			case dbText:
				nLength = GetLength( ((SbaTextFieldDescr*)pActFieldDescr)->GetTextLen() );
				break;

			case dbNumeric:
				nLength = (sal_uInt32)((SbaNumericFieldDescr*)pActFieldDescr)->GetNumericSize();
				break;

			case dbChar:
				nLength = GetLength( ((SbaCharFieldDescr*)pActFieldDescr)->GetTextLen() );
				break;

			case dbDecimal:
			{
				SbaDecimalFieldDescr* pDecFieldDescr = (SbaDecimalFieldDescr*)pActFieldDescr;
				nLength = GetLength( pDecFieldDescr->GetLength() );
				nScale = pDecFieldDescr->GetScale().ToInt32();
				break;
			}

			case dbBinary:
				nLength = GetLength( ((SbaBinaryFieldDescr*)pActFieldDescr)->GetLength() );
				break;

			case dbVarBinary:
				nLength = GetLength( ((SbaVarBinaryFieldDescr*)pActFieldDescr)->GetLength() );
				break;

			case dbCounter:
				bRequired = sal_True;
				break;
			}

			if(pActFieldDescr->IsAutoIncrement())
				bRequired = sal_True;

			//////////////////////////////////////////////////////////////////////
			// Neue Zeile einfuegen
			SbaColumn* pColumn = xDef->CreateColumn(pActFieldDescr->GetName(),
								   aFieldType,
								   nLength,
								   nScale,
								   bRequired,
								   pActFieldDescr->GetFormatKey(),			// Formatkey fehlt noch
								   i + 1,		// Position beginnt bei 1
								   aDefault );

			if (pActFieldDescr->IsPrimaryKey())
				pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_True));
			pColumn->Put(SfxStringItem(SBA_DEF_FLTCOMMENT, pActFieldDescr->GetDescription()));
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, pActFieldDescr->IsAutoIncrement()));
			pColumn->Put(SvxHorJustifyItem(pActFieldDescr->GetHorJustify(), SBA_ATTR_ALIGN_HOR_JUSTIFY));

			rCols.InsertAt(pActFieldDescr->GetName(), pColumn);
		}
	}

	SdbTypeInfo* pInfo = xDef->GetDatabase()->GetRowVersionTypeInfo();
	if(m_bRowVersionColumn && pInfo) // now I have a row version column
	{
		String aName(rCols.ShortenFieldName(String::CreateFromAscii("SYS_ROWVER"),xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN)));
		SbaColumn* pColumn = xDef->CreateColumn(aName,
								   xDef->GetDatabase()->GetFieldType(pInfo->eType,pInfo->nPrecision),
								   pInfo->nPrecision,
								   pInfo->nScale,
								   !pInfo->bNullable,
								   0,			// Formatkey fehlt noch
								   rCols.Count() + 1,		// Position beginnt bei 1
								   String() );
		sal_uInt16 nFlags = 0;
		switch (pInfo->eSearchType)
		{
			case Search_Like_Only  : nFlags |= SDB_FLAGS_SEARCH_LIKE; break;
			case Search_Except_Like: nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE; break;
			case Search_All: nFlags |= SDB_FLAGS_SEARCH_ALL; break;
		}

		nFlags |= SDB_FLAGS_VERSIONING;

		pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSEARCH, nFlags));
		pColumn->Put(SfxBoolItem(SBA_DEF_FLTHIDE, sal_True));

		rCols.InsertAt(aName,pColumn);
	}

	SbaDBDataDefViewSh* pViewSh = GetCurView();
	String aTabProp(((SbaTableDesignViewSh*)pViewSh)->GetDesignWin()->GetTabDescWin()->GetTableDesc());
	if(aTabProp.Len())
	{
		SfxStringItem aPropItem	(*PTR_CAST(SfxStringItem,&xDef->GetObjAttrs()->Get( SBA_DEF_TABLEPROP )));
		aPropItem.SetValue(aTabProp);
		xDef->GetObjAttrs()->Put(aPropItem);
		xDef->PutObjAttrs(*xDef->GetObjAttrs());
	}

	DBG_ASSERT(xDef->IsModified(), "Tabelle nicht modifiziert");
	sal_Bool bRes = xDef->Update();
	if (xDef->Status().IsError() && xDef->IsOpen())
		SBA_MOD()->ShowDbStatus(xDef->Status(), dbWriteError);
	else if(xDef->Status().IsError() && !xDef->IsOpen())
	{
		for( sal_uInt32 i=0; i<aTabEdRowList.Count(); i++ )
			delete aTabEdRowList.GetObject( i);
		aTabEdRowList.Clear();
	}

	//////////////////////////////////////////////////////////////////////
	// Anzeige mit neuen Daten updaten
	if (bRes)
		LoadData();

	return bRes;
}

//------------------------------------------------------------------------------
SbaFieldType SbaTableDocSh::GetType( const String& rType )
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	if( rType.Equals(GetTypeString(TYPE_UNKNOWN)))
		return dbNone;
	if( rType.Equals(GetTypeString(TYPE_TEXT)) )
		return dbText;
	if( rType.Equals(GetTypeString(TYPE_NUMERIC)) )
		return dbNumeric;
	if( rType.Equals(GetTypeString(TYPE_DATETIME)) )
		return dbDateTime;
	if( rType.Equals(GetTypeString(TYPE_DATE)) )
		return dbDate;
	if( rType.Equals(GetTypeString(TYPE_TIME)) )
		return dbTime;
	if( rType.Equals(GetTypeString(TYPE_BOOL)) )
		return dbBool;
	if( rType.Equals(GetTypeString(TYPE_CURRENCY)) )
		return dbCurrency;
	if( rType.Equals(GetTypeString(TYPE_MEMO)) )
		return dbMemo;
	if( rType.Equals(GetTypeString(TYPE_COUNTER)) )
		return dbCounter;
	if( rType.Equals(GetTypeString(TYPE_IMAGE)) )
		return dbImage;
	if( rType.Equals(GetTypeString(TYPE_CHAR)) )
		return dbChar;
	if( rType.Equals(GetTypeString(TYPE_DECIMAL)) )
		return dbDecimal;
	if( rType.Equals(GetTypeString(TYPE_BINARY)) )
		return dbBinary;
	if( rType.Equals(GetTypeString(TYPE_VARBINARY)) )
		return dbVarBinary;

	return dbNone;
}

//------------------------------------------------------------------------------
String SbaTableDocSh::GetType( SbaFieldType eType )
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	String sReturn;
	if( eType == dbNone )
		sReturn = GetTypeString( TYPE_UNKNOWN );
	else if( eType == dbText )
		sReturn = GetTypeString( TYPE_TEXT );
	else if( eType == dbNumeric )
		sReturn = GetTypeString( TYPE_NUMERIC );
	else if( eType == dbDateTime )
		sReturn = GetTypeString( TYPE_DATETIME );
	else if( eType == dbDate )
		sReturn = GetTypeString( TYPE_DATE );
	else if( eType == dbTime )
		sReturn = GetTypeString( TYPE_TIME );
	else if( eType == dbBool )
		sReturn = GetTypeString( TYPE_BOOL );
	else if( eType == dbCurrency )
		sReturn = GetTypeString( TYPE_CURRENCY );
	else if( eType == dbMemo )
		sReturn = GetTypeString( TYPE_MEMO );
	else if( eType == dbCounter )
		sReturn = GetTypeString( TYPE_COUNTER );
	else if( eType == dbImage )
		sReturn = GetTypeString( TYPE_IMAGE );
	else if( eType == dbChar )
		sReturn = GetTypeString( TYPE_CHAR );
	else if( eType == dbDecimal )
		sReturn = GetTypeString( TYPE_DECIMAL );
	else if( eType == dbBinary )
		sReturn = GetTypeString( TYPE_BINARY );
	else if( eType == dbVarBinary )
		sReturn = GetTypeString( TYPE_VARBINARY );
	else
		DBG_ASSERT(0,"Unbekannter Typ!");

	return sReturn;
}

//------------------------------------------------------------------------------
void SbaTableDocSh::GetState(SfxItemSet &rSet)
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	SfxWhichIter aIter(rSet);
	for (sal_uInt16 nSID = aIter.FirstWhich(); nSID; nSID = aIter.NextWhich())
	{
		switch ( nSID )
		{
			case SID_RELOAD:
				if (GetDBDef()->IsNew())
					rSet.DisableItem(nSID);
				break;
			case SID_ATTR_YEAR2000:
				GetYear2000(rSet);
				break;
			case SID_SAVEASDOC:
				rSet.DisableItem(nSID);
				break;
			case SID_SAVEDOC:
			{
				// we delegate the slot to our one and only view
				for ( SfxViewFrame* pFrm = SfxViewFrame::GetFirst( this, TYPE(SfxViewFrame));
					  pFrm;
					  pFrm = SfxViewFrame::GetNext( *pFrm, this ) )
				{
					if (pFrm->GetViewShell())
					{
						DBG_ASSERT(pFrm->GetViewShell()->ISA(SbaTableViewSh), "SbaTableDocSh::Execute : invalid view shell !");
						((SbaTableViewSh*)pFrm->GetViewShell())->GetState(rSet);
						break;
					}
				}
			}
			break;
		}
	}
}

//------------------------------------------------------------------------------
void SbaTableDocSh::Execute(SfxRequest& rReq)
{
	DBG_CHKTHIS(SbaTableDocSh,NULL);
	switch (rReq.GetSlot())
	{
		case SID_ATTR_YEAR2000:
			SetYear2000(*rReq.GetArgs());
			rReq.Done();
			break;

		case SID_SAVEDOC:
		{
			// we delegate the slot to our one and only view
			for ( SfxViewFrame* pFrm = SfxViewFrame::GetFirst( this, TYPE(SfxViewFrame));
				  pFrm;
				  pFrm = SfxViewFrame::GetNext( *pFrm, this ) )
			{
				if (pFrm->GetViewShell())
				{
					DBG_ASSERT(pFrm->GetViewShell()->ISA(SbaTableViewSh), "SbaTableDocSh::Execute : invalid view shell !");
					((SbaTableViewSh*)pFrm->GetViewShell())->Execute(rReq);
					break;
				}
			}
		}
		break;

		case SID_SAVEASDOC:
			if (PrepareSaveAs())
			{
				SetModified( sal_False );
				SFX_BINDINGS().Invalidate(SID_SAVEDOC);
			}
			else
			{
				SfxBoolItem aReturn(0,sal_False);
				rReq.SetReturnValue(aReturn);
			}
			rReq.Done();
	}
}




