/*************************************************************************
 *
 *  $RCSfile: excchrta.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop

#include "scitems.hxx"

// awt
#ifndef _COM_SUN_STAR_AWT_FONTSLANT_HPP_
#include <com/sun/star/awt/FontSlant.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTUNDERLINE_HPP_
#include <com/sun/star/awt/FontUnderline.hpp>
#endif
// beans
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
// chart
#ifndef _COM_SUN_STAR_CHART_CHARTAXISASSIGN_HPP_
#include <com/sun/star/chart/ChartAxisAssign.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTAXISMARKS_HPP_
#include <com/sun/star/chart/ChartAxisMarks.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATAROWSOURCE_HPP_
#include <com/sun/star/chart/ChartDataRowSource.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTLEGENDPOSITION_HPP_
#include <com/sun/star/chart/ChartLegendPosition.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSOLIDTYPE_HPP_
#include <com/sun/star/chart/ChartSolidType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSYMBOLTYPE_HPP_
#include <com/sun/star/chart/ChartSymbolType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_X3DDISPLAY_HPP_
#include <com/sun/star/chart/X3DDisplay.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISXSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisXSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISZSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisZSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XCHARTDOCUMENT_HPP_
#include <com/sun/star/chart/XChartDocument.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XDIAGRAM_HPP_
#include <com/sun/star/chart/XDiagram.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISYSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisYSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_FILLSTYLE_HPP_
#include <com/sun/star/drawing/FillStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINESTYLE_HPP_
#include <com/sun/star/drawing/LineStyle.hpp>
#endif
// drawing
#ifndef _COM_SUN_STAR_LANG_XSHAPE_HPP_
#include <com/sun/star/drawing/XShape.hpp>
#endif
// frame
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
// lang
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
// text
#ifndef _COM_SUN_STAR_TEXT_XTEXT_HPP_
#include <com/sun/star/text/XText.hpp>
#endif
// uno
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
// util
#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATS_HPP_
#include <com/sun/star/util/XNumberFormats.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

#include <so3/ipobj.hxx>
#include <sch/schdll.hxx>
#include <svtools/zformat.hxx>
#include <svx/colritem.hxx>
#include <toolkit/unohlp.hxx>

#include "imp_op.hxx"
#include "excimp8.hxx"
#include "excchart.hxx"
#include <document.hxx>

#ifndef _XCEPTION_HXX_ //autogen wg. TRY
#include <vos/xception.hxx>
#endif
#ifndef _VOS_NO_NAMESPACE
using namespace vos;
#endif

using namespace com::sun::star;

//------------------------------------------------------------------------

#define SC_STDCHARTCOLORS	56

static BYTE aStdFillColor[SC_STDCHARTCOLORS] =
{ 16, 17, 18, 19, 20, 21, 22, 23,				// zuerst die Flaechenfarben
  24, 25, 26, 27, 28, 29, 30, 31,				// dann die Linienfarben
  32, 33, 34, 35, 36, 37, 38, 39,				// den Rest einfach durchgezaehlt
  40, 41, 42, 43, 44, 45, 46, 47,
  48, 49, 50, 51, 52, 53, 54, 55,
   0,  1,  2,  3,  4,  5,  6,  7,
   8,  9, 10, 11, 12, 13, 14, 15 };

static BYTE aStdLineColor[SC_STDCHARTCOLORS] =
{ 24, 25, 26, 27, 28, 29, 30, 31,				// zuerst die Linienfarben
  32, 33, 34, 35, 36, 37, 38, 39,				// dann die "sonstigen" Farben
  40, 41, 42, 43, 44, 45, 46, 47,
  48, 49, 50, 51, 52, 53, 54,					// 55 taucht nicht auf
   0,  1,  2,  3,  4,  5,  6,  7,
   8,  9, 10, 11, 12, 13, 14, 15,
  16, 17, 18, 19, 20, 21, 22, 23,				// zuletzt die Flaechenfarben
  55 };											// (Excel schraffiert die 56. schon)

//------------------------------------------------------------------------

void lcl_SetPropVal( uno::Reference< beans::XPropertySet > xProp, const rtl::OUString& rName, const uno::Any& rAny )
{
	TRY
	{
		xProp->setPropertyValue( rName, rAny );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}

void lcl_SetPropString( uno::Reference< beans::XPropertySet > xProp, const rtl::OUString& rName, const String& rText )
{
	rtl::OUString sOUText( rText );
	TRY
	{
		xProp->setPropertyValue( rName, uno::Any( &sOUText, getCppuType( &sOUText ) ) );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}

template< class T > void lcl_SetPropVal( uno::Reference< beans::XPropertySet > xProp, const rtl::OUString& rName, T value )
{
	TRY
	{
		xProp->setPropertyValue( rName, uno::Any( &value, getCppuType( &value ) ) );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}


sal_Int32 lcl_LineWidth( INT16 nExcelWeight )
{
	switch( nExcelWeight )
	{
		case EXC_CHART_LINEF_SINGLE:	return 35;
		case EXC_CHART_LINEF_DOUBLE:	return 70;
		case EXC_CHART_LINEF_TRIPLE:	return 105;
	}
	return 0;
}

drawing::LineStyle lcl_LineStyle( UINT16 nPattern )
{
	switch( nPattern )
	{
		case EXC_CHART_LINEF_SOLID:		return drawing::LineStyle_SOLID;
		case EXC_CHART_LINEF_NONE:		return drawing::LineStyle_NONE;
	}
	return drawing::LineStyle_DASH;
}


void lcl_SetLineFormat( uno::Reference< beans::XPropertySet > xProp, const ExcChart_Lineformat& rLineFormat )
{
	if( !rLineFormat.bAuto )
	{
		sal_Int32			nLineWidth	= lcl_LineWidth( rLineFormat.nWeight );
		drawing::LineStyle	eLineStyle	= lcl_LineStyle( rLineFormat.nPattern );
		lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINECOLOR ) ), (sal_Int32) rLineFormat.nLineColor );
		lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINESTYLE ) ), eLineStyle );
		lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINEWIDTH ) ), nLineWidth );

	}
}

void lcl_SetStandardLine( uno::Reference< beans::XPropertySet > xProp, UINT32 nRowNum, ColorBuffer* pColorBuf )
{
	//	Excel standard colors (keep line style)
	TRY
	{
		if ( nRowNum < SC_STDCHARTCOLORS && xProp.is() && pColorBuf )
		{
			//	wenn Linienfarbe schwarz war (Umrandung von Flaechen), nicht aendern
			uno::Any aColAny( xProp->getPropertyValue( rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINECOLOR ) ) ) );
			sal_Int32 i;
			if ( (aColAny >>= i) && (i != 0) )
			{
				USHORT nIndex = aStdLineColor[nRowNum];
				if ( nIndex < ColorBuffer::GetAnz() )
				{
					const SvxColorItem* pItem =
									pColorBuf->GetColor( nIndex + ColorBuffer::GetIndCorrect() );
					if (pItem)
						lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINECOLOR ) ),
										(sal_Int32) pItem->GetValue().GetColor() );
				}
			}
		}
	}
	CATCH_ALL()
	{
	}
	END_CATCH
}

void lcl_SetAreaFormat( uno::Reference< beans::XPropertySet > xProp, const ExcChart_Areaformat& rAreaFormat )
{
	if( !xProp.is() ) return;

	drawing::FillStyle eStyle = drawing::FillStyle_NONE;
	ColorData nFillColor = COL_BLACK;
	if ( rAreaFormat.nPattern != EXC_CHART_AREAF_NONE )
	{
		eStyle = drawing::FillStyle_SOLID;
		if ( rAreaFormat.nPattern == EXC_CHART_AREAF_SOLID )
			nFillColor = rAreaFormat.nForeColor;
		else
			//!	create Svx-Pattern, if !=SOLID
			nFillColor = rAreaFormat.nBackColor;
	}
	uno::Any aAny;
	aAny <<= eStyle;
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLSTYLE ) ), aAny );
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLCOLOR ) ), (sal_Int32) nFillColor );
}

void lcl_SetStandardFill( uno::Reference< beans::XPropertySet > xProp, UINT32 nRowNum, ColorBuffer* pColorBuf )
{
	//	Excel standard colors (solid style)
	if( nRowNum < SC_STDCHARTCOLORS && xProp.is() && pColorBuf )
	{
		USHORT nIndex = aStdFillColor[nRowNum];
		if( nIndex < ColorBuffer::GetAnz() )
		{
			const SvxColorItem* pItem = pColorBuf->GetColor( nIndex + ColorBuffer::GetIndCorrect() );
			if( pItem )
				lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLCOLOR ) ), (sal_Int32) pItem->GetValue().GetColor() );
		}
	}
}

void lcl_FontAttribs( const ScExcFont* pExcFont, uno::Reference< beans::XPropertySet > xProp )
{
	if( !pExcFont || !xProp.is() ) return;

	const SvxFontItem& rFontItem = ((ScExcFont*)pExcFont)->GetFontItem();
	const SvxFontHeightItem& rHeightItem = ((ScExcFont*)pExcFont)->GetHeightItem();

	FontWeight eFontWeight;
	USHORT nWeight = pExcFont->nWeight;
	if( !nWeight )									eFontWeight = WEIGHT_DONTKNOW;
	else if( nWeight <= EXC_FONTWGHT_THIN )			eFontWeight = WEIGHT_THIN;
	else if( nWeight <= EXC_FONTWGHT_ULTRALIGHT )	eFontWeight = WEIGHT_ULTRALIGHT;
	else if( nWeight <= EXC_FONTWGHT_LIGHT )		eFontWeight = WEIGHT_LIGHT;
	else if( nWeight <= EXC_FONTWGHT_SEMILIGHT )	eFontWeight = WEIGHT_SEMILIGHT;
	else if( nWeight <= EXC_FONTWGHT_NORMAL )		eFontWeight = WEIGHT_NORMAL;
	else if( nWeight <= EXC_FONTWGHT_MEDIUM )		eFontWeight = WEIGHT_MEDIUM;
	else if( nWeight <= EXC_FONTWGHT_SEMIBOLD )		eFontWeight = WEIGHT_SEMIBOLD;
	else if( nWeight <= EXC_FONTWGHT_BOLD )			eFontWeight = WEIGHT_BOLD;
	else if( nWeight <= EXC_FONTWGHT_ULTRABOLD )	eFontWeight = WEIGHT_ULTRABOLD;
	else											eFontWeight = WEIGHT_BLACK;

	short nNewUnderline = awt::FontUnderline::NONE;
	switch ( pExcFont->eUnderline )
	{
		case ExcUndNone:		nNewUnderline = awt::FontUnderline::NONE;	break;
		case ExcUndSingleAcc:
		case ExcUndSingle:		nNewUnderline = awt::FontUnderline::SINGLE; break;
		case ExcUndDoubleAcc:
		case ExcUndDouble:		nNewUnderline = awt::FontUnderline::DOUBLE; break;
	}

	// font name
	lcl_SetPropString( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARFONTNAME ) ), rFontItem.GetFamilyName() );
	// font weight to enum to float
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARWEIGHT ) ), VCLUnoHelper::ConvertFontWeight( eFontWeight ) );
	// font underline
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARUNDERL ) ), (sal_Int16) nNewUnderline );
	// font height
	double fPoint = rHeightItem.GetHeight() / EXC_FONTHGHT_COEFF;
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARHEIGHT ) ), fPoint );
	// italic
	awt::FontSlant eSlant = pExcFont->bItalic ? awt::FontSlant_ITALIC : awt::FontSlant_NONE;
	uno::Any aAny;
	aAny <<= eSlant;
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARPOSTURE ) ), aAny );
	// shadow
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARSHADOWED ) ), (sal_Bool) pExcFont->bShadow );
	// outline
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCONTOURED ) ), (sal_Bool) pExcFont->bOutline );
	// strikeout
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCROSSEDOUT ) ), (sal_Bool) pExcFont->bStrikeout );
}

void lcl_SetTextData( ExcChart_Text* pTextData, uno::Reference< drawing::XShape > xTextShape )
{
	if( !pTextData || !xTextShape.is() ) return;
	TRY
	{
		uno::Reference< text::XText > xText( xTextShape, uno::UNO_QUERY );
		if( pTextData->pString && xText.is() )
			xText->setString( *pTextData->pString );

		uno::Reference< beans::XPropertySet > xTextProp( xTextShape, uno::UNO_QUERY );
		if ( xTextProp.is() )
		{
			//	#68011# set string as property if XText is not available
			//!	remove xText...
			if ( pTextData->pString && !xText.is() )
				lcl_SetPropString( xTextProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STRING ) ), *pTextData->pString );

			if ( !pTextData->bAutoColor )
				lcl_SetPropVal( xTextProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCOLOR ) ), (sal_Int32) pTextData->nTextColor );
			lcl_FontAttribs( pTextData->pFont, xTextProp );

			if( pTextData->pLine )
				lcl_SetLineFormat( xTextProp, *pTextData->pLine );
			if( pTextData->pArea )
				lcl_SetAreaFormat( xTextProp, *pTextData->pArea );
		}
	}
	CATCH_ALL()
	{
	}
	END_CATCH
}

sal_Int32 lcl_TickPosToAxisMarks( UINT8 nTick )
{
	sal_Int32 nRet = chart::ChartAxisMarks::NONE;
	if( nTick & EXC_CHART_TICK_INSIDE )
		nRet |= chart::ChartAxisMarks::INNER;
	if( nTick & EXC_CHART_TICK_OUTSIDE )
		nRet |= chart::ChartAxisMarks::OUTER;
	return nRet;
}

void lcl_AxisTickFormat( uno::Reference< beans::XPropertySet > xAxis, const TICK& rTick )
{
	if( !rTick.bAutoColor )
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCOLOR ) ), (sal_Int32) rTick.nTextColor );
	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MARKS ) ), lcl_TickPosToAxisMarks( rTick.nMajor ) );
	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HELPMARKS ) ), lcl_TickPosToAxisMarks( rTick.nMinor ) );

	//	TICK_Pos Einstellungen kann das Chart nicht?

#if 0
	//!	beim Setzen der Rotation verteilt das Chart seine Bestandteile nicht neu
	//!	darum erstmal abgeklemmt

	if( rTick.nRot )
	{
		sal_Int32 nRotation = rTick.nRot * 100;
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTROTATION ) ), nRotation );
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTBREAK ), sal_False );
	}
#endif
}

void lcl_AxisValueFormat( uno::Reference< beans::XPropertySet > xAxis,
							const VALUERANGE& rValRange, BOOL bManualOrigin )
{
	if( !(bManualOrigin && rValRange.bAutoCross && rValRange.bAutoMin && rValRange.bAutoMax) )
	{
		//	Bei Bar-Charts (bManualOrigin) Origin nicht auf automatisch stellen,
		//	bis die automatische Skalierung der von Excel aehnlicher wird.
		//	Bei manueller Skalierung muss aber auch der Origin uebernommen werden,
		//	damit die Skalierung ueberhaupt wirkt.

		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOORIG ) ), (sal_Bool) rValRange.bAutoCross );
		if( !rValRange.bAutoCross )
			lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ORIGIN ) ), rValRange.fCross );
	}

	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMIN ) ), (sal_Bool) rValRange.bAutoMin );
	if( !rValRange.bAutoMin )
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MIN ) ), rValRange.fMin );

	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMAX ) ), (sal_Bool) rValRange.bAutoMax );
	if( !rValRange.bAutoMax )
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MAX ) ), rValRange.fMax );

	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTMAIN ) ), (sal_Bool) rValRange.bAutoMajor );
	if( !rValRange.bAutoMajor )
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPMAIN ) ), rValRange.fMajorInc );

	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTHELP ) ), (sal_Bool) rValRange.bAutoMinor );
	if( rValRange.bAutoMinor )
		lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPHELP ) ), rValRange.fMinorInc );

	//!	gibt Probleme:
	lcl_SetPropVal( xAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LOG ) ), (sal_Bool) rValRange.bLogScale );
}

sal_Int32 lcl_UnoNumFmt( ULONG nSrcNum, SvNumberFormatter* pSrcFormatter,
						uno::Reference< util::XNumberFormats > xDestFormatter )
{
	sal_Int32 nRet = 0;
	if( pSrcFormatter && xDestFormatter.is() )
	{
		const SvNumberformat* pFormatEntry = pSrcFormatter->GetEntry( nSrcNum );
		if( pFormatEntry )
		{
			//!	Standard-Formate erkennen und direkt uebernehmen!

			String aFormatStr = pFormatEntry->GetFormatstring();
			rtl::OUString aFormatCode = aFormatStr;

			lang::Locale aLocale;		// empty -> LANGUAGE_SYSTEM
			INT32 nNewKey = xDestFormatter->queryKey( aFormatCode, aLocale, TRUE );
			if( nNewKey != -1 )
				nRet = nNewKey;				// schon vorhanden
			else							// versuchen einzufuegen
				nRet = xDestFormatter->addNew( aFormatCode, aLocale );
		}
	}
	return nRet;
}

void lcl_SetMarkerFormat( uno::Reference< beans::XPropertySet > xProp, const ExcChart_MarkerFormat& rMForm )
{
	if (xProp.is())
	{
		Color aForeColor( rMForm.nForeColor );
		Color aBackColor( rMForm.nBackColor );
		sal_Int32 nSymbolType;
		switch ( rMForm.nMarkerType )
		{
			case 0:		nSymbolType = chart::ChartSymbolType::NONE;		break;
			case 1:		nSymbolType = chart::ChartSymbolType::SYMBOL0;	break;
			case 2:		nSymbolType = chart::ChartSymbolType::SYMBOL1;	break;
			case 3:		nSymbolType = chart::ChartSymbolType::SYMBOL3;	break;
			case 4:		nSymbolType = chart::ChartSymbolType::SYMBOL2;	break;
			case 5:		nSymbolType = chart::ChartSymbolType::SYMBOL4;	break;
			case 6:		nSymbolType = chart::ChartSymbolType::AUTO;		break;
			case 7:		nSymbolType = chart::ChartSymbolType::SYMBOL5;	break;
			case 8:		nSymbolType = chart::ChartSymbolType::SYMBOL6;	break;
			case 9:		nSymbolType = chart::ChartSymbolType::SYMBOL7;	break;
			default:	nSymbolType = chart::ChartSymbolType::SYMBOL1;
		}
		lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SYMBOLTYPE ) ), nSymbolType );
	}
}


void lcl_SetStandardMarker( uno::Reference< beans::XPropertySet > xProp, UINT32 nRowNum, ColorBuffer* pColorBuf )
{
//	if ( nRowNum < SC_STDCHARTCOLORS && xProp.is() && pColorBuf )
//	{
//	}
}


void lcl_Set3DDataFormat( uno::Reference< beans::XPropertySet > xProp, ExcChart_3DDataFormat& rFormat )
{
	sal_Int32 nType;
	if( rFormat.nBase == EXC_CHART_DATAF_RECT )
	{
		if( rFormat.nTop == EXC_CHART_DATAF_STRAIGHT )
			nType = chart::ChartSolidType::RECTANGULAR_SOLID;
		else
			nType = chart::ChartSolidType::PYRAMID;
	}
	else
	{
		if ( rFormat.nTop == EXC_CHART_DATAF_STRAIGHT )
			nType = chart::ChartSolidType::CYLINDER;
		else
			nType = chart::ChartSolidType::CONE;
	}
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SOLIDTYPE ) ), nType );
}


void lcl_SetStandard3DData( uno::Reference< beans::XPropertySet > xProp )
{
	lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SOLIDTYPE ) ),
					(sal_Int32) chart::ChartSolidType::RECTANGULAR_SOLID );
}


void lcl_SetDataRowProperties( uno::Reference< chart::XDiagram > xDiagram, ExcChart_SeriesList& rSerList,
		const ExcChart& rExcChart, ColorBuffer* pColorBuf, const UINT16 nOffs )
{
	//!	rExcChart und die Abfrage kann raus, wenn getDataRow/getDataPoint
	//!	bei ungueltigen Werten NULL zurueckgibt

	const ExcChart_LinkedData* pSourceData = rExcChart.GetSourceData();
	if ( xDiagram.is() && pSourceData )
	{
		//	umschliessenden Range zusammensuchen
		ScRange aSourceRange;
		ScRangeListRef xRanges = pSourceData->GetRangeList();
		if ( xRanges.Is() && xRanges->Count() )
		{
			aSourceRange = *xRanges->GetObject(0);
			ULONG nCount = xRanges->Count();
			for (ULONG i=1; i<nCount; i++)
			{
				ScRange aRange = *xRanges->GetObject(i);
				if (aRange.aStart.Tab() == aSourceRange.aStart.Tab())
				{
					if (aRange.aStart.Col() < aSourceRange.aStart.Col())
						aSourceRange.aStart.SetCol(aRange.aStart.Col());
					if (aRange.aStart.Row() < aSourceRange.aStart.Row())
						aSourceRange.aStart.SetRow(aRange.aStart.Row());
					if (aRange.aEnd.Col() > aSourceRange.aEnd.Col())
						aSourceRange.aEnd.SetCol(aRange.aEnd.Col());
					if (aRange.aEnd.Row() > aSourceRange.aEnd.Row())
						aSourceRange.aEnd.SetRow(aRange.aEnd.Row());
				}
			}
		}
		USHORT nSourceColCount = aSourceRange.aEnd.Col() - aSourceRange.aStart.Col() + 1;
		USHORT nSourceRowCount = aSourceRange.aEnd.Row() - aSourceRange.aStart.Row() + 1;
		if (pSourceData->GetDir())
		{
			USHORT nTemp = nSourceColCount;
			nSourceColCount = nSourceRowCount;
			nSourceRowCount = nTemp;
		}
		if (rExcChart.bHasSeriesNames)
			--nSourceColCount;					// ColCount = Anzahl Punkte pro Series
		if (rExcChart.bHasCategoryNames)
			--nSourceRowCount;					// RowCount = Anzahl Series (DataRows)

		for( ExcChart_Series* pSer = (ExcChart_Series*) rSerList.First(); pSer; pSer = (ExcChart_Series*) rSerList.Next() )
		{
			UINT32 nRowNum = pSer->nSer;
			if( nRowNum < nSourceRowCount )
			{
				const ExcChart_Point* pRow = pSer->pAll;
				if( pRow )
				{
					// attributes of data rows
					TRY
					{
						uno::Reference< beans::XPropertySet > xDataRow =
										xDiagram->getDataRowProperties( nRowNum + nOffs );

						if( xDataRow.is() )
						{
							if( pRow->pArea )
								lcl_SetAreaFormat( xDataRow, *pRow->pArea );
							else
								lcl_SetStandardFill( xDataRow, nRowNum, pColorBuf );

							if( pRow->pLine )
								lcl_SetLineFormat( xDataRow, *pRow->pLine );
							else
								lcl_SetStandardLine( xDataRow, nRowNum, pColorBuf );

							if( pRow->pMarker )
								lcl_SetMarkerFormat( xDataRow, *pRow->pMarker );
							else
								lcl_SetStandardMarker( xDataRow, nRowNum, pColorBuf );

							if( pRow->p3DData )
								lcl_Set3DDataFormat( xDataRow, *pRow->p3DData );
							else
								lcl_SetStandard3DData( xDataRow );
						}
					}
					CATCH_ALL()
					{
					}
					END_CATCH;
				}

				// attributes of single data points
				ExcChart_PointList* pDataPoints = pSer->pSpec;
				if( pDataPoints )
				{
					for( const ExcChart_Point* pPoint = pDataPoints->First(); pPoint; pPoint = pDataPoints->Next() )
					{
						UINT32 nColNum = pPoint->nPointNum;
						if( nColNum < nSourceColCount )
						{
							TRY
							{
								uno::Reference< beans::XPropertySet > xDataPoint =
									xDiagram->getDataPointProperties( nColNum, nRowNum + nOffs );
								if( xDataPoint.is() )
								{
									if( pPoint->pArea )
										lcl_SetAreaFormat( xDataPoint, *pPoint->pArea );
									if( pPoint->pLine )
										lcl_SetLineFormat( xDataPoint, *pPoint->pLine );
									if( pPoint->pMarker )
										lcl_SetMarkerFormat( xDataPoint, *pPoint->pMarker );
									if( pPoint->p3DData )
										lcl_Set3DDataFormat( xDataPoint, *pPoint->p3DData );
								}
							}
							CATCH_ALL()
							{
							}
							END_CATCH;
						}
					}
				}
			}
		}
	}
}

void ExcChart::Apply( uno::Reference< lang::XComponent > xComponent, const Rectangle& rAnchor ) const
{
	if( !xComponent.is() ) return;

	uno::Reference< frame::XModel > xModel( xComponent, uno::UNO_QUERY );

	xModel->lockControllers();		// nicht immer neu aufbauen
	ApplyExt( xComponent );			// vor getDiagram

	uno::Reference< chart::XChartDocument >	xChartDoc( xComponent, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet >	xDocProp( xChartDoc, uno::UNO_QUERY );
	if( !xModel.is() || !xChartDoc.is() || !xDocProp.is() ) return;

	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	if( !xDiagram.is() ) return;

	uno::Reference< chart::XAxisXSupplier >	 	xDiaXSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::XTwoAxisYSupplier >	xDiaYSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::XAxisZSupplier >		xDiaZSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::X3DDisplay >			xDiagr3D( xDiagram, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet >		xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiaXSup.is() || !xDiaYSup.is() || !xDiaZSup.is() || !xDiagr3D.is() || !xDiaProp.is() )
		return;

	rtl::OUString aChartType = xDiagram->getDiagramType();	// in ApplyExt gesetzt

	// Basis-Gedoens

#if 0
	//!	Dies ist Position und Groesse der Chart-Flaeche ohne Achsenbeschriftungen.
	//!	Pos/Size am Diagram sind aber inklusive der Achsenbeschriftungen/Titel.

	Size aTotalSize = rAnchor.GetSize();
	Point aPos( ( nAxisX * aTotalSize.Width() ) / 4000,
				( nAxisY * aTotalSize.Height() ) / 4000 );
	Size aSize( ( nAxisDX * aTotalSize.Width() ) / 4000,
				( nAxisDY * aTotalSize.Height() ) / 4000 );

	if( aPos.X() < SC_CHART_MINDIST )	aPos.X() = SC_CHART_MINDIST;
	if( aPos.Y() < SC_CHART_MINDIST )	aPos.Y() = SC_CHART_MINDIST;

	if( aPos.X() + aSize.Width() >= aTotalSize.Width() - SC_CHART_MINDIST )
		aSize.Width() = aTotalSize.Width() - aPos.X() - SC_CHART_MINDIST;
	if( aPos.Y() + aSize.Height() >= aTotalSize.Height() - SC_CHART_MINDIST )
		aSize.Height() = aTotalSize.Height() - aPos.Y() - SC_CHART_MINDIST;

	xDiagram->setPosition( aPos );
	xDiagram->setSize( aSize );
#endif

	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DIM3D ) ), (sal_Bool)(p3D != NULL) );
	if( p3D )
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DEEP ) ), (sal_Bool)(!p3D->bCluster) );
		// Rotation stellt das Chart noch nicht zur Verfuegung!!!

	sal_Int32 nSymbolType = bDataPointMarker ? chart::ChartSymbolType::AUTO : chart::ChartSymbolType::NONE;
	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SYMBOLTYPE ) ), nSymbolType );

	uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getYAxis();
	if ( xYAxis.is() && pPrimAP && pPrimAP->pValueAxis )
	{
		AXIS& rAxis = *pPrimAP->pValueAxis;
		if( rAxis.nNumForm != INVALIDNUMFORMAT )
		{
			uno::Reference< util::XNumberFormatsSupplier > xNumFormSup( xYAxis, uno::UNO_QUERY );
			uno::Reference< util::XNumberFormats > xNumForms = xNumFormSup->getNumberFormats();
			sal_Int32 nChartNum = lcl_UnoNumFmt( rAxis.nNumForm, pExcRoot->pFormTable, xNumForms );
			lcl_SetPropVal( xYAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), nChartNum );
		}

		//	bei Saeulen/Balkendiagrammen kommt unser Chart nicht gut mit automatischem
		//	Origin zurecht -> dann nur hart gesetzte Werte uebernehmen

		BOOL bManualOrigin = ( aChartType == rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_BAR ) ) );
		if( rAxis.pValueRange )
			lcl_AxisValueFormat( xYAxis, *rAxis.pValueRange, bManualOrigin );

		if( rAxis.pAxisLine )
			lcl_SetLineFormat( xYAxis, *rAxis.pAxisLine );
		if( rAxis.pTick )
			lcl_AxisTickFormat( xYAxis, *rAxis.pTick );

		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISTIT ) ), (sal_Bool)(rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// create object
			xModel->lockControllers();
			lcl_SetTextData( rAxis.pTitle, xDiaYSup->getYAxisTitle() );
		}
	}

	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXIS ) ), (sal_Bool) bPrimaryAndSecondary );
	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXISDESCR ) ), (sal_Bool) bPrimaryAndSecondary );
	if( bPrimaryAndSecondary && pSeries )
	{
  		for( const ExcChart_Series*	pSer = pSeries->First(); pSer; pSer = pSeries->Next() )
		{
			if( pSer->bSecondary )
			{
				TRY
				{
					uno::Reference< beans::XPropertySet > xDataRow =
						xDiagram->getDataRowProperties( pSer->nSer + GetDataRowOffset() );
					if( xDataRow.is() )
						lcl_SetPropVal( xDataRow, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AXIS ) ),
									(sal_Int32) chart::ChartAxisAssign::SECONDARY_Y );
				}
				CATCH_ALL()
				{
				}
				END_CATCH;
			}
		}
		uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getSecondaryYAxis();
		if( xYAxis.is() && pSecAP && pSecAP->pValueAxis )
		{
			AXIS& rAxis = *pSecAP->pValueAxis;
			if( rAxis.nNumForm != INVALIDNUMFORMAT )
			{
				uno::Reference< util::XNumberFormatsSupplier > xNumFormSup( xYAxis, uno::UNO_QUERY );
				uno::Reference< util::XNumberFormats > xNumForms = xNumFormSup->getNumberFormats();
				sal_Int32 nChartNum = lcl_UnoNumFmt( rAxis.nNumForm, pExcRoot->pFormTable, xNumForms );
				lcl_SetPropVal( xYAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), nChartNum );
			}

			//	bei Saeulen/Balkendiagrammen kommt unser Chart nicht gut mit automatischem
			//	Origin zurecht -> dann nur hart gesetzte Werte uebernehmen

			BOOL bManualOrigin = (aChartType == rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_BAR ) ));
			if( rAxis.pValueRange )
				lcl_AxisValueFormat( xYAxis, *rAxis.pValueRange, bManualOrigin );

			if( rAxis.pAxisLine )
				lcl_SetLineFormat( xYAxis, *rAxis.pAxisLine );
			if( rAxis.pTick )
				lcl_AxisTickFormat( xYAxis, *rAxis.pTick );
		}
	}

	uno::Reference< beans::XPropertySet > xXAxis = xDiaXSup->getXAxis();
	if( xXAxis.is() && pPrimAP && pPrimAP->pCatAxis )
	{
		// value range / number format for XY charts
		AXIS& rAxis = *pPrimAP->pCatAxis;
		if( rAxis.nNumForm != INVALIDNUMFORMAT )
		{
			uno::Reference< util::XNumberFormatsSupplier > xNumFormSup( xXAxis, uno::UNO_QUERY );
			uno::Reference< util::XNumberFormats > xNumForms = xNumFormSup->getNumberFormats();
			sal_Int32 nChartNum = lcl_UnoNumFmt( rAxis.nNumForm, pExcRoot->pFormTable, xNumForms );
			lcl_SetPropVal( xXAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), nChartNum );
		}

		if( rAxis.pValueRange )
			lcl_AxisValueFormat( xXAxis, *rAxis.pValueRange, FALSE );

		if( rAxis.pAxisLine )
			lcl_SetLineFormat( xXAxis, *rAxis.pAxisLine );
		if( rAxis.pWallLine )
			lcl_SetLineFormat( xDiagr3D->getWall(), *rAxis.pWallLine );
		if( rAxis.pWallArea )
			lcl_SetAreaFormat( xDiagr3D->getWall(), *rAxis.pWallArea );

		if( rAxis.pTick )
			lcl_AxisTickFormat( xXAxis, *rAxis.pTick );

		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISTIT ) ), (sal_Bool)(rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// create object
			xModel->lockControllers();
			lcl_SetTextData( rAxis.pTitle, xDiaXSup->getXAxisTitle() );
		}
	}

	uno::Reference< beans::XPropertySet > xZAxis = xDiaZSup->getZAxis();
	if( xZAxis.is() && pPrimAP && pPrimAP->pSeriesAxis )
	{
		AXIS& rAxis = *pPrimAP->pSeriesAxis;
		if( rAxis.pAxisLine )
			lcl_SetLineFormat( xZAxis, *rAxis.pAxisLine );
		if( rAxis.pTick )
			lcl_AxisTickFormat( xZAxis, *rAxis.pTick );

		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISTIT ) ), (sal_Bool)(rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// Objekt wirklich anlegen
			xModel->lockControllers();
			lcl_SetTextData( rAxis.pTitle, xDiaZSup->getZAxisTitle() );
		}
	}

	lcl_SetPropVal( xDocProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASLEGEND ) ), (sal_Bool)(pLegend != NULL) );
	if( pLegend )
	{
		uno::Reference< drawing::XShape > xLegendShape = xChartDoc->getLegend();
		uno::Reference< beans::XPropertySet > xLegendProp( xLegendShape, uno::UNO_QUERY );
		if( xLegendShape.is() && xLegendProp.is() )
		{
			chart::ChartLegendPosition eChartPos = chart::ChartLegendPosition_NONE;
			switch ( pLegend->nType )
			{
				case EXC_CHART_LEGEND_BOTTOM:	eChartPos = chart::ChartLegendPosition_BOTTOM;	break;
				case EXC_CHART_LEGEND_TOP:		eChartPos = chart::ChartLegendPosition_TOP;		break;
				case EXC_CHART_LEGEND_RIGHT:	eChartPos = chart::ChartLegendPosition_RIGHT;	break;
				case EXC_CHART_LEGEND_LEFT:		eChartPos = chart::ChartLegendPosition_LEFT;	break;
			}

			uno::Any aAny;
			aAny <<= eChartPos;
			lcl_SetPropVal( xLegendProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ALIGNMENT ) ), aAny );

			if( !pLegend->bDocked && (!pLegend->bAutoPosX || !pLegend->bAutoPosY) )
			{
				awt::Point aPos = xLegendShape->getPosition();
				const awt::Size& rSize = xLegendShape->getSize();
				Size aTotalSize = rAnchor.GetSize();

				if( !pLegend->bAutoPosX )
				{
					aPos.X = ( pLegend->nPosX * aTotalSize.Width() ) / 4000;
					if( aPos.X + rSize.Width >= aTotalSize.Width() - SC_CHART_MINDIST )
						aPos.X = aTotalSize.Width() - rSize.Width - SC_CHART_MINDIST;
					if( aPos.X < SC_CHART_MINDIST )
						aPos.X = SC_CHART_MINDIST;
				}
				if( !pLegend->bAutoPosY )
				{
					aPos.Y = ( pLegend->nPosY * aTotalSize.Height() ) / 4000;
					if( aPos.Y + rSize.Height >= aTotalSize.Height() - SC_CHART_MINDIST )
						aPos.Y = aTotalSize.Height() - rSize.Height - SC_CHART_MINDIST;
					if( aPos.Y < SC_CHART_MINDIST )
						aPos.Y = SC_CHART_MINDIST;
				}

				xLegendShape->setPosition( aPos );
			}
		}
	}

	lcl_SetPropVal( xDocProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASMAINTIT ) ), (sal_Bool)(pChartTitle != NULL) );
	if( pChartTitle )
		lcl_SetTextData( pChartTitle, xChartDoc->getTitle() );

	uno::Reference< beans::XPropertySet > xArea = xChartDoc->getArea();
	if( xArea.is() )
	{
		drawing::LineStyle eStyle = drawing::LineStyle_SOLID;
		uno::Any aAny;
		aAny <<= eStyle;
		lcl_SetPropVal( xArea, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINESTYLE ) ), aAny );
	}

	if( pSourceData )
	{
		chart::ChartDataRowSource eSource = pSourceData->GetDir() ?
			chart::ChartDataRowSource_COLUMNS : chart::ChartDataRowSource_ROWS;
		uno::Any aAny;
		aAny <<= eSource;
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ROWSOURCE ) ), aAny );
	}

	if( pSeries )
	{
		//	DataRowProperties erst nach SwitchData, damit die DataRows existieren
		//	Torte ist in Excel eine Series mit mehreren Punkten, in StarChart mehrere DataRows.
		//!	Die StarChart-DataRow Einstellungen muessten aus Excel DataPoint gesetzt werden.
		//!	Momentan GPF't das Chart aber, wenn hier bei Torten-Charts auf DataRowProperty
		//!	groesser 1 zugegriffen wird...

		if( aChartType != rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_PIE ) ) )
			lcl_SetDataRowProperties( xDiagram, *pSeries, *this, pExcRoot->pColor, GetDataRowOffset() );
	}

	Date* pDate = pExcRoot->pDoc->GetFormatTable()->GetNullDate();
	if( pDate )
	{
		uno::Reference< util::XNumberFormatsSupplier > xNumFormSup( xXAxis, uno::UNO_QUERY );
		if( xNumFormSup.is() )
		{
			util::Date aDate( pDate->GetDay(), pDate->GetMonth(), pDate->GetYear() );
			uno::Reference< beans::XPropertySet > xProp = xNumFormSup->getNumberFormatSettings();
			uno::Any aAny;
			aAny <<= aDate;
			lcl_SetPropVal( xProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NULLDATE ) ), aAny );
		}
	}

	ApplyExtPost( xComponent );

	xModel->unlockControllers();
}

void lcl_SetChartType( uno::Reference< lang::XComponent > xComponent, const rtl::OUString& rType )
{
	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	uno::Reference< lang::XMultiServiceFactory > xFactory( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() || !xFactory.is() ) return;
	uno::Reference< uno::XInterface > xInstance = xFactory->createInstance( rType );
	uno::Reference< chart::XDiagram > xNewDiagram( xInstance, uno::UNO_QUERY );
	if( !xInstance.is() || !xNewDiagram.is() ) return;
	xChartDoc->setDiagram( xNewDiagram );
}

void ExcChartBar::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_BAR ) ) );	// vor getDiagram

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< chart::XTwoAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaYSup.is() || !xDiaProp.is() ) return;

	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VERTICAL ) ), (sal_Bool) bHorizontal );
	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), (sal_Bool) bStacked );
	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), (sal_Bool) bCatAsPercent );

	//!	CHART_PROP_STACKCONN (Saeulen verbunden)

	//	GapWidth / Overlap haengt an der Y-Achse:
	uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getYAxis();
	if( xYAxis.is() )
	{
		lcl_SetPropVal( xYAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_GAPWIDTH ) ), (sal_Int32) nSpaceBeetwCat );
		lcl_SetPropVal( xYAxis, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_OVERLAP ) ), (sal_Int32) nSpaceBeetwBar );
	}

	uno::Reference< beans::XPropertySet > xSecondary = xDiaYSup->getSecondaryYAxis();
	if( xSecondary.is() )
	{
		//	eigene Werte fuer 2. Y-Achse aus Excel lesen
		lcl_SetPropVal( xSecondary, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_GAPWIDTH ) ), (sal_Int32) nSpaceBeetwCat );
		lcl_SetPropVal( xSecondary, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_OVERLAP ) ), (sal_Int32) nSpaceBeetwBar );
	}
}


void ExcChartLine::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;

	if( bAreaChart )
		lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_AREA ) ) );
	else if( bStock )
		lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_STOCK ) ) );
	else
		lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_LINE ) ) );	// vor getDiagram

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaProp.is() ) return;

	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), (sal_Bool) bStacked );
	lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), (sal_Bool) bCatAsPercent );
}


void ExcChartLine::ApplyExtPost( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() || bAreaChart ) return;

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaProp.is() ) return;

	if( bStock )
	{
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_UPDOWN ) ), (sal_Bool)(pUpBar || pDownBar) );
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VOLUME ) ), (sal_Bool) bPrimaryAndSecondary );
	}
	else
	{
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), (sal_Bool) bStacked );
		lcl_SetPropVal( xDiaProp, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), (sal_Bool) bCatAsPercent );
	}
}


void ExcChartPie::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;

	if( nHoleSize == 0 )
		lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_PIE ) ) );
	else
		lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_DONUT ) ) );
}


void ExcChartRadar::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_NET ) ) );	// vor getDiagram
}


void ExcChartSurface::ApplyExt( uno::Reference< lang::XComponent > ) const
{
	//	koenn' wa nich?
}

void ExcChartScatter::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_XY ) ) );	// vor getDiagram
}

