/*************************************************************************
 *
 *  $RCSfile: dataobj2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:44:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX ***
//#define _LINK_HXX ***
//#define _ERRCODE_HXX ***
//#define _GEN_HXX ***
//#define _FRACT_HXX ***
//#define _STRING_HXX ***
//#define _MTF_HXX ***
//#define _CONTNR_HXX ***
//#define _LIST_HXX ***
//#define _TABLE_HXX ***
#define _DYNARY_HXX
//#define _UNQIDX_HXX ***
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX ***
//#define _DEBUG_HXX ***
//#define _DATE_HXX ***
//#define _TIME_HXX ***
//#define _DATETIME_HXX ***
//#define _INTN_HXX ***
//#define _WLDCRD_HXX ***
//#define _FSYS_HXX ***
//#define _STREAM_HXX ***
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX

//svtools
#define _SCRWIN_HXX
#define _RULER_HXX
#define _TABBAR_HXX
//#define _VALUESET_HXX
#define _STDMENU_HXX
//#define _STDCTRL_HXX
//#define _CTRLBOX_HXX
#define _CTRLTOOL_HXX
#define _EXTATTR_HXX
#define _FRM3D_HXX
#define _EXTATTR_HXX

//SVTOOLS
//#define _SVTREELIST_HXX ***
#define _FILTER_HXX
//#define _SVLBOXITM_HXX ***
//#define _SVTREEBOX_HXX ***
#define _SVICNVW_HXX
#define _SVTABBX_HXX


//SV
#define _CLIP_HXX
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX ***
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX ***
//#define _MDIAPP_HXX ***
//#define _TIMER_HXX ***
//#define _METRIC_HXX ***
//#define _REGION_HXX ***
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX ***
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX ***
//#define _TOOLBOX_HXX
//#define _STATUS_HXX ***
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
#define _FILDLG_HXX
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX




#define _BASE_DLGS_HXX
#define _BIGINT_HXX
#define _CACHESTR_HXX
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _CTRLTOOL_HXX
#define _DLGCFG_HXX
#define _DYNARR_HXX
#define _EXTATTR_HXX
//#define _FILDLG_HXX
#define _FONTDLG_HXX
#define _FRM3D_HXX
#define _INTRO_HXX
#define _ISETBWR_HXX
#define _NO_SVRTF_PARSER_HXX
#define _MACRODLG_HXX
#define _MODALDLG_HXX
#define _MOREBUTTON_HXX
#define _OUTLINER_HXX

#define _SFX_DOCFILT_HXX
#define _SFX_PRNMON_HXX
#define _SFX_RESMGR_HXX
#define _SFX_TEMPLDLG_HXX
#define _SFXAPPWIN_HXX
#define _SFXBASIC_HXX
#define _SFXCTRLITEM
#define _SFXDLGCFG_HXX
#define _SFXDISPATCH_HXX
#define _SFXDOCFILE_HXX
#define _SFXDOCMAN_HXX
#define _SFXDOCMGR_HXX
#define _SFXDOCTDLG_HXX
#define _SFXFILEDLG_HXX
#define _SFXIMGMGR_HXX
#define _SFXIPFRM_HXX
#define _SFX_MACRO_HXX
#define _SFXMNUITEM_HXX
#define _SFXMNUMGR_HXX
#define _SFXMULTISEL_HXX
//#define _SFXMSG_HXX ***
#define _SFXMSGDESCR_HXX
#define _SFXMSGPOOL_HXX
#define _SFX_MINFITEM_HXX
#define _SFXOBJFACE_HXX
#define _SFXOBJFAC_HXX
#define _SFX_SAVEOPT_HXX
#define _SFXSTBITEM_HXX
#define _SFXSTBMGR_HXX
#define _SFXTBXCTRL_HXX
#define _SFXTBXMGR_HXX

#define _SVBOXITM_HXX
#define _SVCONTNR_HXX
//#define _SVDATTR_HXX ***
#define _SVDXOUT_HXX
#define _SVDEC_HXX
#define _SVDIO_HXX
//#define _SVDLAYER_HXX
#define _SVDRAG_HXX
#define _SVINCVW_HXX
#define _SV_MULTISEL_HXX
#define _SVRTV_HXX
#define _SVTABBX_HXX
//#define _SVTREEBOX_HXX
//#define _SVTREELIST_HXX

#define _SVX_DAILDLL_HXX
#define _SVX_HYPHEN_HXX
#define _SVX_IMPGRF_HXX
#define _SVX_OPTITEMS_HXX
#define _SVX_OPTGERL_HXX
#define _SVX_OPTSAVE_HXX
#define _SVX_OPTSPELL_HXX
#define _SVX_OPTPATH_HXX
#define _SVX_OPTLINGU_HXX
#define _SVX_RULER_HXX
#define _SVX_RULRITEM_HXX
#define _SVX_SPLWRAP_HXX
#define _SVX_SPLDLG_HXX
#define _SVX_THESDLG_HXX

#define _SIDLL_HXX
#define _SI_NOITEMS_HXX
#define _SI_NOCONTROL_HXX
#define _SI_NOOTHERFORMS_HXX
#define _SI_NOSBXCONTROLS_HXX
#define _VCBRW_HXX
#define _VCTRLS_HXX
#define _VCONT_HXX

//inet
#define _INETINDP_HXX
#define _INETIMP_HXX
#define _INETWRAP_HXX
#define _INETKEEP_HXX
#define _PLUGMGR_HXX
//#define _URLOBJ_HXX

#define _SVX_DAILDLL_HXX
#define _SVX_HYPHEN_HXX
#define _SVX_IMPGRF_HXX
#define _SVX_OPTITEMS_HXX
#define _SVX_OPTGERL_HXX
#define _SVX_OPTSAVE_HXX
#define _SVX_OPTSPELL_HXX
#define _SVX_OPTPATH_HXX
#define _SVX_OPTLINGU_HXX
#define _SVX_RULER_HXX
#define _SVX_RULRITEM_HXX
#define _SVX_SPLWRAP_HXX
#define _SVX_SPLDLG_HXX
#define _SVX_THESDLG_HXX

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS  ***



#define SFX_NOCLOOKS

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

#include "drwlayer.hxx"

#ifndef PCH
#include <segmentc.hxx>
#endif

// INCLUDE ---------------------------------------------------------------

#ifndef ITEMID_SIZE
#define ITEMID_SIZE	0
#endif
#include <svx/sizeitem.hxx>
#include <svx/paperinf.hxx>
#include <svx/svdxcgv.hxx>


#include "scitems.hxx"
#include "dataobj.hxx"
#include "docsh.hxx"
#include "viewdata.hxx"
#include "stlpool.hxx"

SEG_EOFGLOBALS()

#pragma SEG_FUNCDEF(dataobj2_01)

void ScDataObject::GetCalcData( SvData* pData )
{
	if ( !aDocShellRef.Is() )
	{
			// die neue DocShell muss sofort einer Ref zugewiesen werden,
			// sonst geht DoInitNew schief:

		ScDocShell* pDocSh = new ScDocShell;
		aDocShellRef = pDocSh;

		pDocSh->DoInitNew(NULL);

		ScDocument* pDestDoc = pDocSh->GetDocument();
		ScMarkData aDestMark;
		aDestMark.SelectTable( 0, TRUE );

		if (pDoc)
		{
			String aTabName;
			pDoc->GetName( aBlock.aStart.Tab(), aTabName );
			pDestDoc->RenameTab( 0, aTabName, FALSE );			// kein UpdateRef, weil leer

			//	neu ab 320c: in der DocShell an der Quell-Position, nicht immer A1
			//	(wegen Bereichsnamen)
			//	aber immer Tabelle1 -> Bereichsnamen mit absoluten Tabellen ???

			//	Kopieren immer mit bCutMode = TRUE, damit Tabellen-Referenzen
			//	angepasst werden

			pDestDoc->CopyStdStylesFrom( pDoc );

			USHORT nStartX = aBlock.aStart.Col();
			USHORT nStartY = aBlock.aStart.Row();
			USHORT nEndX = aBlock.aEnd.Col();
			USHORT nEndY = aBlock.aEnd.Row();
			ScRange aDestRange( nStartX,nStartY,0, nEndX,nEndY,0 );
			if (pDoc->IsClipboard())
			{
				BOOL bWasCut = pDoc->IsCutMode();
				if (!bWasCut)
					pDoc->SetClipArea( aDestRange, TRUE );			// Cut
				pDestDoc->CopyFromClip( aDestRange, aDestMark, IDF_ALL, NULL, pDoc, FALSE );
				pDoc->SetClipArea( aDestRange, bWasCut );

				StripRefs( pDoc, nStartX,nStartY, nEndX,nEndY, pDestDoc, 0,0 );
			}
			else
			{
				ScDocument* pClipDoc = new ScDocument( SCDOCMODE_CLIP );

				ScMarkData aSourceMark;
				aSourceMark.SelectTable( aBlock.aStart.Tab(), TRUE );
				pDoc->CopyToClip( nStartX, nStartY, nEndX, nEndY, FALSE, pClipDoc,
									FALSE, &aSourceMark );

				StripRefs( pClipDoc, nStartX, nStartY, nEndX, nEndY );

				pClipDoc->SetClipArea( aDestRange, TRUE );		// Cut
				pDestDoc->CopyFromClip( aDestRange, aDestMark, IDF_ALL, NULL, pClipDoc, FALSE );
				delete pClipDoc;
			}

			//	#38083# Merge-Flags wiederherstellen (nur bei Drag&Drop noetig?)
			ScRange aMergeRange = aDestRange;
			pDestDoc->ExtendMerge( aMergeRange, TRUE );

			pDoc->CopyDdeLinks( pDestDoc );			// Werte von DDE-Links kopieren

					// Hoehen / Breiten
			USHORT nCol;
			USHORT nRow;
			for (nCol=nStartX; nCol<=nEndX; nCol++)
				if ( pDoc->GetColFlags( nCol, aBlock.aStart.Tab() ) & CR_HIDDEN )
					pDestDoc->ShowCol( nCol, 0, FALSE );
				else
					pDestDoc->SetColWidth( nCol, 0,
						pDoc->GetColWidth( nCol, aBlock.aStart.Tab() ) );
			for (nRow=nStartY; nRow<=nEndY; nRow++)
				if ( pDoc->GetRowFlags( nRow, aBlock.aStart.Tab() ) & CR_HIDDEN )
					pDestDoc->ShowRow( nRow, 0, FALSE );
				else
					pDestDoc->SetRowHeight( nRow, 0,
						pDoc->GetRowHeight( nRow, aBlock.aStart.Tab() ) );

					// Seitenformat (wegen Gitter etc.)
					//	und Seitengroesse als Maximum fuer Ole-Objekt

			Size aPaperSize = SvxPaperInfo::GetPaperSize( SVX_PAPER_A4 );		// Twips
			ScStyleSheetPool* pStylePool = pDoc->GetStyleSheetPool();
			String aStyleName = pDoc->GetPageStyle( aBlock.aStart.Tab() );
			SfxStyleSheetBase* pStyleSheet = pStylePool->Find( aStyleName, SFX_STYLE_FAMILY_PAGE );
			if (pStyleSheet)
			{
				const SfxItemSet& rSourceSet = pStyleSheet->GetItemSet();
				aPaperSize = ((const SvxSizeItem&) rSourceSet.Get(ATTR_PAGE_SIZE)).GetSize();

				//	CopyStyleFrom kopiert SetItems mit richtigem Pool
				ScStyleSheetPool* pDestPool = pDestDoc->GetStyleSheetPool();
				pDestPool->CopyStyleFrom( pStylePool, aStyleName, SFX_STYLE_FAMILY_PAGE );
			}

			ScViewData aViewData( pDocSh, NULL );
			aViewData.SetScreen( nStartX,nStartY, nEndX,nEndY );
			aViewData.SetCurX( nStartX );
			aViewData.SetCurY( nStartY );

			pDestDoc->SetViewOptions( pDoc->GetViewOptions() );

			//		Groesse
			//! beim Kopieren der Groessen

			long nPosX = 0;
			long nPosY = 0;

			for (nCol=0; nCol<nStartX; nCol++)
				nPosX += pDestDoc->GetColWidth( nCol, 0 );
			for (nRow=0; nRow<nStartY; nRow++)
				nPosY += pDestDoc->FastGetRowHeight( nRow, 0 );
			nPosX = (long) ( nPosX * HMM_PER_TWIPS );
			nPosY = (long) ( nPosY * HMM_PER_TWIPS );


			aPaperSize.Width()  *= 2;		// Ole-Objekt wird auf doppelte
			aPaperSize.Height() *= 2;		// Seitengroesse begrenzt

			long nSizeX = 0;
			long nSizeY = 0;
			for (nCol=nStartX; nCol<=nEndX; nCol++)
			{
				long nAdd = pDestDoc->GetColWidth( nCol, 0 );
				if ( nSizeX+nAdd > aPaperSize.Width() && nSizeX )	// maximal Seitengroesse
					break;
				nSizeX += nAdd;
			}
			for (nRow=nStartY; nRow<=nEndY; nRow++)
			{
				long nAdd = pDestDoc->FastGetRowHeight( nRow, 0 );
				if ( nSizeY+nAdd > aPaperSize.Height() && nSizeY )	// maximal Seitengroesse
					break;
				nSizeY += nAdd;
			}
			nSizeX = (long) ( nSizeX * HMM_PER_TWIPS );
			nSizeY = (long) ( nSizeY * HMM_PER_TWIPS );


//			pDocSh->SetVisAreaSize( Size(nSizeX,nSizeY) );

			Rectangle aNewArea( Point(nPosX,nPosY), Size(nSizeX,nSizeY) );
			pDocSh->SvInPlaceObject::SetVisArea( aNewArea );
			pDocSh->SetVisArea( aNewArea );

			pDocSh->UpdateOle(&aViewData, TRUE);
		}
		else									// aus Draw-Model
		{
/*			pDestDoc->MakeTable( 0 );
			pDestDoc->SelectTable( 0, TRUE );
*/
			pDestDoc->InitDrawLayer( pDocSh );

			SdrExchangeView aView(pDrawModel);
			Point aPos;
			SdrPageView* pPv = aView.ShowPagePgNum(0,aPos);
			DBG_ASSERT(pPv,"pPv nicht da...");
			aView.MarkAll(pPv);
			Rectangle aArea = aView.GetAllMarkedRect();
			Size aSrcSize = aArea.GetSize();

			SdrExchangeView aDestView(pDestDoc->GetDrawLayer());
			aDestView.ShowPagePgNum(0,aPos);
			aDestView.Paste( *pDrawModel, Point(aSrcSize.Width()/2,aSrcSize.Height()/2) );

			Point aTmpPoint;
			Rectangle aDestArea( aTmpPoint,aSrcSize );
			pDocSh->SetVisArea( aDestArea );

			ScViewOptions aViewOpt( pDestDoc->GetViewOptions() );
			aViewOpt.SetOption( VOPT_GRID, FALSE );
			pDestDoc->SetViewOptions( aViewOpt );

			ScViewData aViewData( pDocSh, NULL );
			aViewData.SetTabNo( 0 );
			aViewData.SetScreen( aDestArea );
			aViewData.SetCurX( 0 );
			aViewData.SetCurY( 0 );
			pDocSh->UpdateOle(&aViewData, TRUE);
		}
	}
}

/*------------------------------------------------------------------------

	$Log: dataobj2.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:44:53  hr
	initial import
	
	Revision 1.36  2000/09/17 14:08:53  willem.vandorp
	OpenOffice header added.
	
	Revision 1.35  2000/08/31 16:38:17  willem.vandorp
	Header and footer replaced
	
	Revision 1.34  1998/04/20 18:22:10  NN
	#49415# GetCalcData: Seitenformat per CopyStyleFrom
	

	  Rev 1.33   20 Apr 1998 20:22:10   NN
   #49415# GetCalcData: Seitenformat per CopyStyleFrom

	  Rev 1.32   05 Dec 1997 20:07:18   ANK
   Includes geaendert

	  Rev 1.31   13 Oct 1997 12:23:12   NN
   sizeitem.hxx statt frmitems.hxx

	  Rev 1.30   05 Aug 1997 21:25:42   HJS
   includes

	  Rev 1.29   29 Apr 1997 10:28:44   MH
   add: header

	  Rev 1.28   14 Apr 1997 13:01:08   HJS
   includes

	  Rev 1.27   07 Apr 1997 13:06:28   TRI
   includes

	  Rev 1.26   25 Mar 1997 16:24:30   NN
   #38083# ExtendMerge bei GetCalcData

	  Rev 1.25   24 Oct 1996 18:31:04   NN
   #32735# CopyStdStylesFrom bei GetCalcData

	  Rev 1.24   22 Aug 1996 14:10:12   NN
   #30572# CopyToClip immer mit bAllTabs oder MarkData

	  Rev 1.23   19 Aug 1996 21:26:40   NN
   Markierungen werden nicht mehr am Dokument gehalten

	  Rev 1.22   15 Aug 1996 14:31:24   NN
   CopyFromClip immer mit DestRange

	  Rev 1.21   31 Jul 1996 18:41:04   NN
   Dde-Links in Ole-Objekt kopieren

	  Rev 1.20   29 Jul 1996 20:58:14   NN
   Block als ScRange

	  Rev 1.19   21 Jun 1996 08:39:32   TRI
   scitems.hxx included

	  Rev 1.18   20 Jun 1996 15:35:24   NN
   #28826# Ole-Objekt aus Clipboard auf doppelte Seitengroesse begrenzt

	  Rev 1.17   14 Jun 1996 15:07:12   HJS
   defines entfernt

	  Rev 1.16   03 Jun 1996 15:40:34   NN
   #27070# Ole an alter Position im Dokument, aBlockStart Pos. im Doc

	  Rev 1.15   11 Apr 1996 15:54:06   NN
   #25777# StripRefs in GetCalcData

	  Rev 1.14   10 Apr 1996 16:11:10   sdo
   GCC

	  Rev 1.13   20 Mar 1996 13:42:30   NF
   CLOOKS

	  Rev 1.12   29 Feb 1996 18:47:38   NF
   CLOOKS

	  Rev 1.11   23 Feb 1996 12:13:18   NF
   CLOOKS

	  Rev 1.10   20 Feb 1996 12:40:36   NN
   DocShell muss sofort einer Ref zugewiesen werden, sonst knallts

	  Rev 1.9   16 Feb 1996 18:26:44   NF
   CLOOKS

	  Rev 1.8   09 Feb 1996 18:28:52   NF
   CLOOOOOOOOOOOOOKS

	  Rev 1.7   02 Feb 1996 16:48:14   NN
   #24711# Tabellennamen aus Clipboard uebernehmen

	  Rev 1.6   15 Dec 1995 14:09:00   NN
   Daten in DocShell immer auf Tabelle 0 kopieren (23495)

	  Rev 1.5   12 Dec 1995 18:38:50   NN
   View-Optionen kopieren

	  Rev 1.4   30 Nov 1995 17:25:06   NF
   clooks

	  Rev 1.3   28 Nov 1995 21:13:56   MO
   CLOOKs

	  Rev 1.2   17 Nov 1995 15:44:46   NN
   UpdateOle mit bSnapSize=TRUE

	  Rev 1.1   16 Nov 1995 20:39:54   MO
   pragma

	  Rev 1.0   16 Nov 1995 20:39:24   MO
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


