#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:46:22 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

# wx mktyplib nur unter Windows aufrufbar!
# VMB.386 und WXSRVR.EXE muessen geladen sein! (n:\mscwini\bin)

PRJ=..

PRJNAME=sch
TARGET=schslots
IDLEXPORT=schnew

# --- Settings -----------------------------------------------------

# SVIDLINC=$(PRJ)$/source\ui\inc

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

IDLNAME=$(TARGET)
SIDHRCNAME=SCHSLOTS.HRC
CINTERNAME=schinter

# --- Files --------------------------------------------------------

SVIDLDEPEND= \
		$(SOLARINCXDIR)$/svxslots.ilb \
		schnew.idl \
		app.idl \
		chviewsh.idl \
		docshell.idl \
		$(IDLNAME).hrc \
		$(INC)$/app.hrc


# --- Targets -------------------------------------------------------

.IF "$(depend)" != ""

# CFILES=   $(CINTERNAME).c

OBJFILES=   $(OBJ)$/$(CINTERNAME).obj

.ELSE

ALL: \
	ALLTAR \
	$(BIN)$/$(IDLNAME).tlb

.ENDIF

LIB1TARGET = $(LB)$/$(CINTERNAME).lib
LIB1FILES = $(OBJ)$/$(CINTERNAME).obj

.INCLUDE :  target.mk

.IF "$(GUIBASE)"=="WIN"
# && "$(VCL)"==""

$(BIN)$/$(IDLNAME).tlb: \
		$(INCCOM)$/$(IDLNAME).hxx
.IF "$(GUIBASE)"=="WIN"
	rscpp -I.;$(SVIDLINC);$(INC) -DSOLAR_VERSION=$(solar_version) $(MISC)$/$(IDLNAME).odl $(MISC)$/$(IDLNAME).odx
.IF "$(GUI)"=="WIN"
	wx /w mktyplib /nocpp /o $(MISC)$/$(IDLNAME).err /tlb $(BIN)$/$(IDLNAME).tlb $(MISC)$/$(IDLNAME).odx
.ELSE
	mktyplib /win32 /nocpp /o $(MISC)$/$(IDLNAME).err /tlb $(BIN)$/$(IDLNAME).tlb $(MISC)$/$(IDLNAME).odx
.ENDIF
	+type $(MISC)$/$(IDLNAME).err
.ELSE
	@echo nix
.ENDIF

.ENDIF

