/*************************************************************************
 *
 *  $RCSfile: pairs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifndef _SFXDEFS_HXX //autogen
#include <sfx2/sfxdefs.hxx>
#endif
#ifndef _XDEF_HXX //autogen
#include <svx/xdef.hxx>
#endif
#ifndef _SVDDEF_HXX //autogen
#include <svx/svddef.hxx>
#endif
#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif

#ifndef _SFXMODULE_HXX //autogen
#include <sfx2/module.hxx>
#endif
#ifndef _TOOLS_RESMGR_HXX //autogen
#include <tools/resmgr.hxx>
#endif



#include "schattr.hxx"
#include "app.hrc" // z.Z. fuer SID_TEXTBREAK


const USHORT nTitleWhichPairs[] =
{                                                    //ca.:
	SCHATTR_TEXT_ORIENT, SCHATTR_TEXT_ORIENT,       // 1
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,      //
	XATTR_LINE_FIRST, XATTR_LINE_LAST,              // 1000
	XATTR_FILL_FIRST, XATTR_FILL_LAST,              // 1020
	SDRATTR_SHADOW_FIRST, SDRATTR_SHADOW_LAST,      // 1060
	EE_ITEMS_START, EE_ITEMS_END,                   // 4000
	0
};
/*
const USHORT nXAxisWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SID_ATTR_NUMBERFORMAT_VALUE, SID_ATTR_NUMBERFORMAT_VALUE, //10.585
	SCHATTR_X_AXIS_START, SCHATTR_X_AXIS_END,
	SCHATTR_AXISTYPE, SCHATTR_AXISTYPE,
	SCHATTR_TEXT_START, SCHATTR_TEXT_END,
	SID_TEXTBREAK, SID_TEXTBREAK,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	SCHATTR_TEXT_OVERLAP, SCHATTR_TEXT_OVERLAP,
	SCHATTR_AXIS_START,SCHATTR_AXIS_END,
	0
};

const USHORT nYAxisWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SID_ATTR_NUMBERFORMAT_VALUE, SID_ATTR_NUMBERFORMAT_VALUE,
	SCHATTR_Y_AXIS_START, SCHATTR_Y_AXIS_END,
	SCHATTR_AXISTYPE, SCHATTR_AXISTYPE,
	SCHATTR_TEXT_START, SCHATTR_TEXT_END,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	SCHATTR_TEXT_OVERLAP, SCHATTR_TEXT_OVERLAP,
	SCHATTR_AXIS_START,SCHATTR_AXIS_END,
	0

};

const USHORT nZAxisWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SID_ATTR_NUMBERFORMAT_VALUE, SID_ATTR_NUMBERFORMAT_VALUE,
	SCHATTR_Z_AXIS_START, SCHATTR_Z_AXIS_END,
	SCHATTR_AXISTYPE, SCHATTR_AXISTYPE,
	SCHATTR_TEXT_START, SCHATTR_TEXT_END,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	SCHATTR_TEXT_OVERLAP, SCHATTR_TEXT_OVERLAP,
	SCHATTR_AXIS_START,SCHATTR_AXIS_END,
	0
};

*/
const USHORT nAxisWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SID_ATTR_NUMBERFORMAT_VALUE, SID_ATTR_NUMBERFORMAT_VALUE,
	SCHATTR_AXISTYPE, SCHATTR_AXISTYPE,
	SCHATTR_TEXT_START, SCHATTR_TEXT_END,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	SCHATTR_TEXT_OVERLAP, SCHATTR_TEXT_OVERLAP,
	SCHATTR_AXIS_START, SCHATTR_AXIS_END,
	SID_TEXTBREAK, SID_TEXTBREAK,
	0
};
const USHORT nAllAxisWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SCHATTR_TEXT_ORIENT, SCHATTR_TEXT_ORIENT,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	SCHATTR_TEXT_OVERLAP, SCHATTR_TEXT_OVERLAP,
	SCHATTR_AXIS_SHOWDESCR, SCHATTR_AXIS_SHOWDESCR,
	SID_TEXTBREAK, SID_TEXTBREAK,
	0
};

const USHORT nGridWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
		0
};

const USHORT nChartWhichPairs[] =
{
	SCHATTR_STYLE_START,SCHATTR_STYLE_END,
	0
};
const USHORT nDiagramAreaWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	XATTR_FILL_FIRST, XATTR_FILL_LAST,
	0
};
const USHORT nAreaAndChartWhichPairs[] = //Diese Pairs umfassen Chart und Area-Whichpairs!!!
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	XATTR_FILL_FIRST, XATTR_FILL_LAST,
	SCHATTR_STYLE_START,SCHATTR_STYLE_END,
	0
};
const USHORT nLegendWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	XATTR_FILL_FIRST, XATTR_FILL_LAST,
	SDRATTR_SHADOW_FIRST, SDRATTR_SHADOW_LAST,
	EE_ITEMS_START, EE_ITEMS_END,
	SCHATTR_LEGEND_START, SCHATTR_LEGEND_END,
	0
};

#define CHART_ROW_WHICHPAIRS 	\
	XATTR_LINE_FIRST, XATTR_LINE_LAST,\
	XATTR_FILL_FIRST, XATTR_FILL_LAST,\
	EE_ITEMS_START, EE_ITEMS_END,\
	SCHATTR_DATADESCR_START, SCHATTR_DATADESCR_END,\
    SCHATTR_DUMMY0, SCHATTR_DUMMY0,\
    SCHATTR_DUMMY1, SCHATTR_DUMMY1,\
    SCHATTR_STAT_START, SCHATTR_STAT_END,\
    SCHATTR_STYLE_START,SCHATTR_STYLE_END,\
	SCHATTR_AXIS,SCHATTR_AXIS,\
	SCHATTR_SYMBOL_BRUSH,SCHATTR_SYMBOL_BRUSH,\
	SCHATTR_SYMBOL_SIZE,SCHATTR_SYMBOL_SIZE,\
	SID_ATTR_3D_START,/*SID_ATTR_3D_DOUBLE_SIDED-1,\
	SID_ATTR_3D_DOUBLE_SIDED+1,*/SID_ATTR_3D_END

const USHORT nRowWhichPairs[] =
{
	CHART_ROW_WHICHPAIRS,0
};

const USHORT nAreaWhichPairs[] =
{
	XATTR_LINE_FIRST, XATTR_LINE_LAST,
	XATTR_FILL_FIRST, XATTR_FILL_LAST,
	SDRATTR_SHADOW_FIRST, SDRATTR_SHADOW_LAST,
	0
};

const USHORT nTextWhichPairs[] =
{
	EE_ITEMS_START, EE_ITEMS_END,
	SCHATTR_TEXT_ORIENT, SCHATTR_TEXT_ORIENT,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	0
};

const USHORT nTextOrientWhichPairs[] =
{
	EE_ITEMS_START, EE_ITEMS_END,
	SCHATTR_TEXT_ORIENT, SCHATTR_TEXT_ORIENT,
	SCHATTR_TEXT_DEGREES,SCHATTR_TEXT_DEGREES,
	0
};

const USHORT nStatWhichPairs[]=
{
	SCHATTR_STAT_START, SCHATTR_STAT_END,
		0
};



