/*************************************************************************
 *
 *  $RCSfile: unonames.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_UNONAMES_HXX
#define _SCH_UNONAMES_HXX

#define UNONAME_CHARTLEGENDALIGN			"Alignment"
#define UNONAME_TEXT_ORDER					"ArrangeOrder"
#define UNONAME_AXIS_AUTO_MAX				"AutoMax"
#define UNONAME_AXIS_AUTO_MIN				"AutoMin"
#define UNONAME_AXIS_AUTO_ORIGIN			"AutoOrigin"
#define UNONAME_AXIS_AUTO_STEP_HELP			"AutoStepHelp"
#define UNONAME_AXIS_AUTO_STEP_MAIN			"AutoStepMain"
#define UNONAME_AXIS						"Axis"
#define UNONAME_STYLE_BASETYPE				"BaseType"
#define UNONAME_CATEGORIES_RANGE_ADDRESS	"CategoriesRangeAddress"
#define UNONAME_STAT_CONSTPLUS				"ConstantErrorHigh"
#define UNONAME_STAT_CONSTMINUS				"ConstantErrorLow"
#define UNONAME_DATACAPTION					"DataCaption"
#define UNONAME_ERROR_PROPS					"DataErrorProperties"
#define UNONAME_AVERAGE_PROPS				"DataMeanValueProperties"
#define UNONAME_REGRESSION_PROPS			"DataRegressionProperties"
#define UNONAME_DATAROWSOURCE				"DataRowSource"
#define UNONAME_STYLE_DEEP					"Deep"
#define UNONAME_STYLE_3D					"Dim3D"
#define UNONAME_DISPLAY_LABELS				"DisplayLabels"
#define UNONAME_STAT_KIND_ERROR				"ErrorCategory"
#define UNONAME_STAT_INDICATE				"ErrorIndicator"
#define UNONAME_STAT_BIGERROR				"ErrorMargin"
#define UNONAME_GAPWIDTH					"GapWidth"
#define UNONAME_DIAGRAM_GAPWIDTH			"GapWidth"
#define UNONAME_HASLEGEND					"HasLegend"
#define UNONAME_TITLE_SHOW_MAIN				"HasMainTitle"
#define UNONAME_AXISGRID_SHOW_2X_AXIS		"HasSecondaryXAxis"
#define UNONAME_AXISGRID_SHOW_2X_DESCR		"HasSecondaryXAxisDescription"
#define UNONAME_AXISGRID_SHOW_2Y_AXIS		"HasSecondaryYAxis"
#define UNONAME_AXISGRID_SHOW_2Y_DESCR		"HasSecondaryYAxisDescription"
#define UNONAME_TITLE_SHOW_SUB				"HasSubTitle"
#define UNONAME_AXISGRID_SHOW_X_AXIS		"HasXAxis"
#define UNONAME_AXISGRID_SHOW_X_DESCR		"HasXAxisDescription"
#define UNONAME_AXISGRID_SHOW_X_MAIN		"HasXAxisGrid"
#define UNONAME_AXISGRID_SHOW_X_HELP		"HasXAxisHelpGrid"
#define UNONAME_TITLE_SHOW_X_AXIS			"HasXAxisTitle"
#define UNONAME_AXISGRID_SHOW_Y_AXIS		"HasYAxis"
#define UNONAME_AXISGRID_SHOW_Y_DESCR		"HasYAxisDescription"
#define UNONAME_AXISGRID_SHOW_Y_MAIN		"HasYAxisGrid"
#define UNONAME_AXISGRID_SHOW_Y_HELP		"HasYAxisHelpGrid"
#define UNONAME_TITLE_SHOW_Y_AXIS			"HasYAxisTitle"
#define UNONAME_AXISGRID_SHOW_Z_AXIS		"HasZAxis"
#define UNONAME_AXISGRID_SHOW_Z_DESCR		"HasZAxisDescription"
#define UNONAME_AXISGRID_SHOW_Z_MAIN		"HasZAxisGrid"
#define UNONAME_AXISGRID_SHOW_Z_HELP		"HasZAxisHelpGrid"
#define UNONAME_TITLE_SHOW_Z_AXIS			"HasZAxisTitle"
#define UNONAME_AXIS_HELPTICKS				"HelpMarks"
#define UNONAME_STYLE_LINES					"Lines"
#define UNONAME_AXIS_LOGARITHM				"Logarithmic"
#define UNONAME_MAINTITLE_ADDRESS			"MainTitleAddress"
#define UNONAME_AXIS_TICKS					"Marks"
#define UNONAME_AXIS_MAX					"Max"
#define UNONAME_STAT_AVERAGE				"MeanValue"
#define UNONAME_AXIS_MIN					"Min"
#define UNONAME_NUMBERFORMAT				"NumberFormat"
#define UNONAME_NUM_OF_LINES_FOR_BAR		"NumberOfLines"
#define UNONAME_AXIS_ORIGIN					"Origin"
#define UNONAME_OVERLAP						"Overlap"
#define UNONAME_DIAGRAM_OVERLAP				"Overlap"
#define UNONAME_STYLE_PERCENT				"Percent"
#define UNONAME_STAT_PERCENT				"PercentageError"
#define UNONAME_STAT_REGRESSTYPE			"RegressionCurves"
#define UNONAME_PIE_SEGMENT_OFFSET			"SegmentOffset"
#define UNONAME_SERIES_ADDRESSES			"SeriesAddresses"
#define UNONAME_STYLE_SHAPE					"SolidType"
#define UNONAME_STYLE_SPLINES				"SplineType"
#define UNONAME_STYLE_STACKED				"Stacked"
#define UNONAME_STACKBARWIDTH				"StackedBarWidth"
#define UNONAME_STACKCONNECTORS				"StackedBarsConnected"
#define UNONAME_AXIS_STEP_HELP				"StepHelp"
#define UNONAME_AXIS_STEP_MAIN				"StepMain"
#define UNONAME_TEXT_STRING					"String"
#define UNONAME_SUBTITLE_ADDRESS			"SubTitleAddress"
#define UNONAME_SYMBOL_BRUSH				"SymbolBrush"
#define UNONAME_STYLE_SYMBOL				"SymbolType"
#define UNONAME_TEXTBREAK					"TextBreak"
#define UNONAME_TEXT_OVERLAP				"TextCanOverlap"
#define UNONAME_TEXT_DEGREES				"TextRotation"
#define UNONAME_STOCK_UPDOWN				"UpDown"
#define UNONAME_STYLE_VERTICAL				"Vertical"
#define UNONAME_STOCK_VOLUME				"Volume"

#define SCH_X_STR_CHTYPE_NAMESPACE			"com.sun.star.chart."
#define SCH_X_STR_CHTYPE_LINE   			"LineDiagram"
#define SCH_X_STR_CHTYPE_AREA   			"AreaDiagram"
#define SCH_X_STR_CHTYPE_BAR    			"BarDiagram"
#define SCH_X_STR_CHTYPE_PIE    			"PieDiagram"
#define SCH_X_STR_CHTYPE_DONUT  			"DonutDiagram"
#define SCH_X_STR_CHTYPE_XY     			"XYDiagram"
#define SCH_X_STR_CHTYPE_NET    			"NetDiagram"
#define SCH_X_STR_CHTYPE_STOCK  			"StockDiagram"

#define SCH_ASCII_TO_OU( s )  ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( s ) )

#endif	// _SCH_UNONAMES_HXX

