/*************************************************************************
 *
 *  $RCSfile: oterimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// Implib-Definitionen fuer OTER-DLL/shared library:
// AUTOMATISCH GENERIERT - NICHT EDITIEREN!
#ifndef IMPLIB_oterimp_HXX
#define IMPLIB_oterimp_HXX


#include <tools/solar.h>
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

BOOL LoadLibrary_OTER(String &_rPath);
BOOL FreeLibrary_OTER();

typedef RETCODE  (SQL_API  *TOSQLAllocConnect) (HENV henv , HDBC FAR * phdbc);
extern TOSQLAllocConnect pOtSQLAllocConnect;
#define OSQLAllocConnect(a,b) (*pOtSQLAllocConnect)(a,b)

typedef RETCODE  (SQL_API  *TOSQLAllocEnv) (HENV FAR * phenv);
extern TOSQLAllocEnv pOtSQLAllocEnv;
#define OSQLAllocEnv(a) (*pOtSQLAllocEnv)(a)

typedef RETCODE  (SQL_API  *TOSQLAllocStmt) (HDBC hdbc , HSTMT FAR * phstmt);
extern TOSQLAllocStmt pOtSQLAllocStmt;
#define OSQLAllocStmt(a,b) (*pOtSQLAllocStmt)(a,b)

typedef RETCODE  (SQL_API  *TOSQLBindCol) (HSTMT hstmt , UWORD icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TOSQLBindCol pOtSQLBindCol;
#define OSQLBindCol(a,b,c,d,e,f) (*pOtSQLBindCol)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TOSQLCancel) (HSTMT hstmt);
extern TOSQLCancel pOtSQLCancel;
#define OSQLCancel(a) (*pOtSQLCancel)(a)

typedef RETCODE  (SQL_API  *TOSQLColAttributes) (HSTMT hstmt , UWORD icol , UWORD fDescType , PTR rgbDesc , SWORD cbDescMax , SWORD FAR * pcbDesc , SDWORD FAR * pfDesc);
extern TOSQLColAttributes pOtSQLColAttributes;
#define OSQLColAttributes(a,b,c,d,e,f,g) (*pOtSQLColAttributes)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TOSQLConnect) (HDBC hdbc , UCHAR FAR * szDSN , SWORD cbDSN , UCHAR FAR * szUID , SWORD cbUID , UCHAR FAR * szAuthStr , SWORD cbAuthStr);
extern TOSQLConnect pOtSQLConnect;
#define OSQLConnect(a,b,c,d,e,f,g) (*pOtSQLConnect)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TOSQLDescribeCol) (HSTMT hstmt , UWORD icol , UCHAR FAR * szColName , SWORD cbColNameMax , SWORD FAR * pcbColName , SWORD FAR * pfSqlType , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TOSQLDescribeCol pOtSQLDescribeCol;
#define OSQLDescribeCol(a,b,c,d,e,f,g,h,i) (*pOtSQLDescribeCol)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLDisconnect) (HDBC hdbc);
extern TOSQLDisconnect pOtSQLDisconnect;
#define OSQLDisconnect(a) (*pOtSQLDisconnect)(a)

typedef RETCODE  (SQL_API  *TOSQLError) (HENV henv , HDBC hdbc , HSTMT hstmt , UCHAR FAR * szSqlState , SDWORD FAR * pfNativeError , UCHAR FAR * szErrorMsg , SWORD cbErrorMsgMax , SWORD FAR * pcbErrorMsg);
extern TOSQLError pOtSQLError;
#define OSQLError(a,b,c,d,e,f,g,h) (*pOtSQLError)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TOSQLExecDirect) (HSTMT hstmt , UCHAR FAR * szSqlStr , SDWORD cbSqlStr);
extern TOSQLExecDirect pOtSQLExecDirect;
#define OSQLExecDirect(a,b,c) (*pOtSQLExecDirect)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLExecute) (HSTMT hstmt);
extern TOSQLExecute pOtSQLExecute;
#define OSQLExecute(a) (*pOtSQLExecute)(a)

typedef RETCODE  (SQL_API  *TOSQLFetch) (HSTMT hstmt);
extern TOSQLFetch pOtSQLFetch;
#define OSQLFetch(a) (*pOtSQLFetch)(a)

typedef RETCODE  (SQL_API  *TOSQLFreeConnect) (HDBC hdbc);
extern TOSQLFreeConnect pOtSQLFreeConnect;
#define OSQLFreeConnect(a) (*pOtSQLFreeConnect)(a)

typedef RETCODE  (SQL_API  *TOSQLFreeEnv) (HENV henv);
extern TOSQLFreeEnv pOtSQLFreeEnv;
#define OSQLFreeEnv(a) (*pOtSQLFreeEnv)(a)

typedef RETCODE  (SQL_API  *TOSQLFreeStmt) (HSTMT hstmt , UWORD fOption);
extern TOSQLFreeStmt pOtSQLFreeStmt;
#define OSQLFreeStmt(a,b) (*pOtSQLFreeStmt)(a,b)

typedef RETCODE  (SQL_API  *TOSQLGetCursorName) (HSTMT hstmt , UCHAR FAR * szCursor , SWORD cbCursorMax , SWORD FAR * pcbCursor);
extern TOSQLGetCursorName pOtSQLGetCursorName;
#define OSQLGetCursorName(a,b,c,d) (*pOtSQLGetCursorName)(a,b,c,d)

typedef RETCODE  (SQL_API  *TOSQLNumResultCols) (HSTMT hstmt , SWORD FAR * pccol);
extern TOSQLNumResultCols pOtSQLNumResultCols;
#define OSQLNumResultCols(a,b) (*pOtSQLNumResultCols)(a,b)

typedef RETCODE  (SQL_API  *TOSQLPrepare) (HSTMT hstmt , UCHAR FAR * szSqlStr , SDWORD cbSqlStr);
extern TOSQLPrepare pOtSQLPrepare;
#define OSQLPrepare(a,b,c) (*pOtSQLPrepare)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLRowCount) (HSTMT hstmt , SDWORD FAR * pcrow);
extern TOSQLRowCount pOtSQLRowCount;
#define OSQLRowCount(a,b) (*pOtSQLRowCount)(a,b)

typedef RETCODE  (SQL_API  *TOSQLSetCursorName) (HSTMT hstmt , UCHAR FAR * szCursor , SWORD cbCursor);
extern TOSQLSetCursorName pOtSQLSetCursorName;
#define OSQLSetCursorName(a,b,c) (*pOtSQLSetCursorName)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLTransact) (HENV henv , HDBC hdbc , UWORD fType);
extern TOSQLTransact pOtSQLTransact;
#define OSQLTransact(a,b,c) (*pOtSQLTransact)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLColumns) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TOSQLColumns pOtSQLColumns;
#define OSQLColumns(a,b,c,d,e,f,g,h,i) (*pOtSQLColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLDriverConnect) (HDBC hdbc , HWND hwnd , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut , UWORD fDriverCompletion);
extern TOSQLDriverConnect pOtSQLDriverConnect;
#define OSQLDriverConnect(a,b,c,d,e,f,g,h) (*pOtSQLDriverConnect)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TOSQLGetConnectOption) (HDBC hdbc , UWORD fOption , PTR pvParam);
extern TOSQLGetConnectOption pOtSQLGetConnectOption;
#define OSQLGetConnectOption(a,b,c) (*pOtSQLGetConnectOption)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLGetData) (HSTMT hstmt , UWORD icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TOSQLGetData pOtSQLGetData;
#define OSQLGetData(a,b,c,d,e,f) (*pOtSQLGetData)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TOSQLGetFunctions) (HDBC hdbc , UWORD fFunction , UWORD FAR * pfExists);
extern TOSQLGetFunctions pOtSQLGetFunctions;
#define OSQLGetFunctions(a,b,c) (*pOtSQLGetFunctions)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLGetInfo) (HDBC hdbc , UWORD fInfoType , PTR rgbInfoValue , SWORD cbInfoValueMax , SWORD FAR * pcbInfoValue);
extern TOSQLGetInfo pOtSQLGetInfo;
#define OSQLGetInfo(a,b,c,d,e) (*pOtSQLGetInfo)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TOSQLGetStmtOption) (HSTMT hstmt , UWORD fOption , PTR pvParam);
extern TOSQLGetStmtOption pOtSQLGetStmtOption;
#define OSQLGetStmtOption(a,b,c) (*pOtSQLGetStmtOption)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLGetTypeInfo) (HSTMT hstmt , SWORD fSqlType);
extern TOSQLGetTypeInfo pOtSQLGetTypeInfo;
#define OSQLGetTypeInfo(a,b) (*pOtSQLGetTypeInfo)(a,b)

typedef RETCODE  (SQL_API  *TOSQLParamData) (HSTMT hstmt , PTR FAR * prgbValue);
extern TOSQLParamData pOtSQLParamData;
#define OSQLParamData(a,b) (*pOtSQLParamData)(a,b)

typedef RETCODE  (SQL_API  *TOSQLPutData) (HSTMT hstmt , PTR rgbValue , SDWORD cbValue);
extern TOSQLPutData pOtSQLPutData;
#define OSQLPutData(a,b,c) (*pOtSQLPutData)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLSetConnectOption) (HDBC hdbc , UWORD fOption , UDWORD vParam);
extern TOSQLSetConnectOption pOtSQLSetConnectOption;
#define OSQLSetConnectOption(a,b,c) (*pOtSQLSetConnectOption)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLSetStmtOption) (HSTMT hstmt , UWORD fOption , UDWORD vParam);
extern TOSQLSetStmtOption pOtSQLSetStmtOption;
#define OSQLSetStmtOption(a,b,c) (*pOtSQLSetStmtOption)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLSpecialColumns) (HSTMT hstmt , UWORD fColType , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UWORD fScope , UWORD fNullable);
extern TOSQLSpecialColumns pOtSQLSpecialColumns;
#define OSQLSpecialColumns(a,b,c,d,e,f,g,h,i,j) (*pOtSQLSpecialColumns)(a,b,c,d,e,f,g,h,i,j)

typedef RETCODE  (SQL_API  *TOSQLStatistics) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UWORD fUnique , UWORD fAccuracy);
extern TOSQLStatistics pOtSQLStatistics;
#define OSQLStatistics(a,b,c,d,e,f,g,h,i) (*pOtSQLStatistics)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLTables) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szTableType , SWORD cbTableType);
extern TOSQLTables pOtSQLTables;
#define OSQLTables(a,b,c,d,e,f,g,h,i) (*pOtSQLTables)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLBrowseConnect) (HDBC hdbc , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut);
extern TOSQLBrowseConnect pOtSQLBrowseConnect;
#define OSQLBrowseConnect(a,b,c,d,e,f) (*pOtSQLBrowseConnect)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TOSQLColumnPrivileges) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TOSQLColumnPrivileges pOtSQLColumnPrivileges;
#define OSQLColumnPrivileges(a,b,c,d,e,f,g,h,i) (*pOtSQLColumnPrivileges)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLDataSources) (HENV henv , UWORD fDirection , UCHAR FAR * szDSN , SWORD cbDSNMax , SWORD FAR * pcbDSN , UCHAR FAR * szDescription , SWORD cbDescriptionMax , SWORD FAR * pcbDescription);
extern TOSQLDataSources pOtSQLDataSources;
#define OSQLDataSources(a,b,c,d,e,f,g,h) (*pOtSQLDataSources)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TOSQLDescribeParam) (HSTMT hstmt , UWORD ipar , SWORD FAR * pfSqlType , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TOSQLDescribeParam pOtSQLDescribeParam;
#define OSQLDescribeParam(a,b,c,d,e,f) (*pOtSQLDescribeParam)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TOSQLExtendedFetch) (HSTMT hstmt , UWORD fFetchType , SDWORD irow , UDWORD FAR * pcrow , UWORD FAR * rgfRowStatus);
extern TOSQLExtendedFetch pOtSQLExtendedFetch;
#define OSQLExtendedFetch(a,b,c,d,e) (*pOtSQLExtendedFetch)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TOSQLForeignKeys) (HSTMT hstmt , UCHAR FAR * szPkTableQualifier , SWORD cbPkTableQualifier , UCHAR FAR * szPkTableOwner , SWORD cbPkTableOwner , UCHAR FAR * szPkTableName , SWORD cbPkTableName , UCHAR FAR * szFkTableQualifier , SWORD cbFkTableQualifier , UCHAR FAR * szFkTableOwner , SWORD cbFkTableOwner , UCHAR FAR * szFkTableName , SWORD cbFkTableName);
extern TOSQLForeignKeys pOtSQLForeignKeys;
#define OSQLForeignKeys(a,b,c,d,e,f,g,h,i,j,k,l,m) (*pOtSQLForeignKeys)(a,b,c,d,e,f,g,h,i,j,k,l,m)

typedef RETCODE  (SQL_API  *TOSQLMoreResults) (HSTMT hstmt);
extern TOSQLMoreResults pOtSQLMoreResults;
#define OSQLMoreResults(a) (*pOtSQLMoreResults)(a)

typedef RETCODE  (SQL_API  *TOSQLNativeSql) (HDBC hdbc , UCHAR FAR * szSqlStrIn , SDWORD cbSqlStrIn , UCHAR FAR * szSqlStr , SDWORD cbSqlStrMax , SDWORD FAR * pcbSqlStr);
extern TOSQLNativeSql pOtSQLNativeSql;
#define OSQLNativeSql(a,b,c,d,e,f) (*pOtSQLNativeSql)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TOSQLNumParams) (HSTMT hstmt , SWORD FAR * pcpar);
extern TOSQLNumParams pOtSQLNumParams;
#define OSQLNumParams(a,b) (*pOtSQLNumParams)(a,b)

typedef RETCODE  (SQL_API  *TOSQLParamOptions) (HSTMT hstmt , UDWORD crow , UDWORD FAR * pirow);
extern TOSQLParamOptions pOtSQLParamOptions;
#define OSQLParamOptions(a,b,c) (*pOtSQLParamOptions)(a,b,c)

typedef RETCODE  (SQL_API  *TOSQLPrimaryKeys) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TOSQLPrimaryKeys pOtSQLPrimaryKeys;
#define OSQLPrimaryKeys(a,b,c,d,e,f,g) (*pOtSQLPrimaryKeys)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TOSQLProcedureColumns) (HSTMT hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TOSQLProcedureColumns pOtSQLProcedureColumns;
#define OSQLProcedureColumns(a,b,c,d,e,f,g,h,i) (*pOtSQLProcedureColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TOSQLProcedures) (HSTMT hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName);
extern TOSQLProcedures pOtSQLProcedures;
#define OSQLProcedures(a,b,c,d,e,f,g) (*pOtSQLProcedures)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TOSQLSetPos) (HSTMT hstmt , UWORD irow , UWORD fOption , UWORD fLock);
extern TOSQLSetPos pOtSQLSetPos;
#define OSQLSetPos(a,b,c,d) (*pOtSQLSetPos)(a,b,c,d)

typedef RETCODE  (SQL_API  *TOSQLTablePrivileges) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TOSQLTablePrivileges pOtSQLTablePrivileges;
#define OSQLTablePrivileges(a,b,c,d,e,f,g) (*pOtSQLTablePrivileges)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TOSQLDrivers) (HENV henv , UWORD fDirection , UCHAR FAR * szDriverDesc , SWORD cbDriverDescMax , SWORD FAR * pcbDriverDesc , UCHAR FAR * szDriverAttributes , SWORD cbDrvrAttrMax , SWORD FAR * pcbDrvrAttr);
extern TOSQLDrivers pOtSQLDrivers;
#define OSQLDrivers(a,b,c,d,e,f,g,h) (*pOtSQLDrivers)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TOSQLBindParameter) (HSTMT hstmt , UWORD ipar , SWORD fParamType , SWORD fCType , SWORD fSqlType , UDWORD cbColDef , SWORD ibScale , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TOSQLBindParameter pOtSQLBindParameter;
#define OSQLBindParameter(a,b,c,d,e,f,g,h,i,j) (*pOtSQLBindParameter)(a,b,c,d,e,f,g,h,i,j)

#endif



