/*************************************************************************
 *
 *  $RCSfile: ja_lg_ob.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <jni.h>

#ifndef _SDB_JA_LG_OB_HXX
#include <ja_lg_ob.hxx>
#endif

#ifndef _SDB_JA_LG_PG_HXX
#include <ja_lg_pg.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
/*#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HPP_
#include <com/sun/star/loader/CannotActivateFactoryException.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_CANNOTREGISTERIMPLEMENTATIONEXCEPTION_HPP_
#include <com/sun/star/registry/CannotRegisterImplementationException.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XIMPLEMENTATIONREGISTRATION_HPP_
#include <com/sun/star/registry/XImplementationRegistration.hpp>
#endif*/

#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include <com/sun/star/uno/Exception.hpp>
#endif
#ifndef _COM_SUN_STAR_JAVA_XJAVATHREADREGISTER_11_HPP_
#include <com/sun/star/java/XJavaThreadRegister_11.hpp>
#endif
#ifndef _COM_SUN_STAR_JAVA_XJAVAVM_HPP_
#include <com/sun/star/java/XJavaVM.hpp>
#endif

#include <vos/module.hxx>
#include <vos/process.hxx>
#include <vos/mutex.hxx>
#include <vos/dynload.hxx>

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
//#ifndef __UNO_API_H__
//#include <uno/api.h>
//#endif
#ifndef _RTL_PROCESS_H_
#include <rtl/process.h>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

namespace staruno = com::sun::star::uno;
namespace starjava = com::sun::star::java;

JavaVM * pJVM;
::staruno::Reference< ::starjava::XJavaThreadRegister_11 > xRG11Ref;
BOOL        bJRE_Error = FALSE;
JavaVM_ *   pJRE_javaVM = NULL;

int SDB_JRE_InitJava()
{
	int result = 0;
    JNIEnv * pEnv = NULL;

    try 
	{
		::staruno::Reference< ::starjava::XJavaVM > xVM(utl::getProcessServiceFactory()
			->createInstance(rtl::OUString::createFromAscii("com.sun.star.java.JavaVirtualMachine")), ::staruno::UNO_QUERY);

		if (!xVM.is()) 
			throw ::staruno::Exception(); // -2;		

		staruno::Sequence<sal_Int8> processID(16);
		rtl_getGlobalProcessId( (sal_uInt8*) processID.getArray() ); 
        
		::staruno::Any uaJVM = xVM->getJavaVM( processID );
		
		if (!uaJVM.hasValue())		
			throw ::staruno::Exception(); // -5
		else
		{
			sal_Int32 nValue;
			uaJVM >>= nValue;
			pJVM = (JavaVM *)nValue;
		}

		xRG11Ref = ::staruno::Reference< ::starjava::XJavaThreadRegister_11 >(xVM, ::staruno::UNO_QUERY);
		if (xRG11Ref.is())
			xRG11Ref->registerThread();

  		pJVM->AttachCurrentThread(reinterpret_cast<void**>(&pEnv), NULL);

		/**
		 * Ist zur Zeit nicht funktionsfaehig, wegen Solaris Deadlock.
		 */
//      initStreamObserver(pEnv);
//      if(pEnv->ExceptionOccurred())
//      {
//          pEnv->ExceptionDescribe();
//          pEnv->ExceptionClear();
//      }

	}
	catch (::staruno::Exception e) 
	{
		if (pEnv && pEnv->ExceptionOccurred())
		{
			pEnv->ExceptionDescribe();
			pEnv->ExceptionClear();
		}

		result = -1;
	}

	if(pEnv) 
	{
		if(xRG11Ref.is())
			xRG11Ref->revokeThread();
		
		if(!xRG11Ref.is() || !xRG11Ref->isThreadAttached())
			pJVM->DetachCurrentThread();
	}

    return result;
}


SDBThreadAttach::SDBThreadAttach() : bDetach(FALSE), pEnv(NULL)
{
	attachThread(pEnv);
}

SDBThreadAttach::~SDBThreadAttach() 
{
	detachThread();
}

void SDBThreadAttach::attachThread(JNIEnv * &pEnv) 
{
	xInit();

	if(xRG11Ref.is())
	{
		xRG11Ref->registerThread();
		pJVM->AttachCurrentThread(reinterpret_cast<void**>(&pEnv), NULL);
	}
}

void SDBThreadAttach::detachThread() 
{
	xInit();

	if(xRG11Ref.is())
	{
		xRG11Ref->revokeThread();
		if(!xRG11Ref->isThreadAttached())
			pJVM->DetachCurrentThread();
	}
}

void SDBThreadAttach::xInit() 
{
	StartJava();
}

BOOL SDBThreadAttach::IsJavaErrorOccured()
{
	return bJRE_Error;
}

void SDBThreadAttach::setError()
{
	bJRE_Error = TRUE;
}

static BOOL bStarted = FALSE;
ErrCode SDBThreadAttach::StartJava()
{
	static BOOL bRecFlag = FALSE;
	static int err = 0;
	if( !bStarted )
	{
		vos::OGuard aGuard( vos::OMutex::getGlobalMutex() );
		if( !bStarted && !bRecFlag)
		{
			bRecFlag = TRUE;
			//	Application::EnterMultiThread();
			// bStarted = TRUE must set after the VM is complete initialized
			err = SDB_JRE_InitJava();
			if(err)
				setError();
			bStarted = TRUE;
		}
	}
//	return bJRE_Error ? -1 : 0;
	return err;
}

// statische Variablen der Klasse:
jclass java_lang_Object::theClass = 0;
ULONG java_lang_Object::nObjCount = 0;

jclass java_lang_Object::getMyClass()
{
	if( !theClass )
	{
//		JNIEnv * pEnv = SDBThreadAttach::GetEnv();
		SDBThreadAttach t;

		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/lang/Object" );
		theClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
	}
	return theClass;
}
DBG_NAME(java_lang_Object);
// der eigentliche Konstruktor
java_lang_Object::java_lang_Object()
	: object( 0 )
{
	DBG_CTOR(java_lang_Object,NULL);
	SDBThreadAttach t;
	if( !t.pEnv )
		return;

	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "()V";
	jclass tempClass;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempClass = (jclass)t.pEnv->NewObjectA( getMyClass(), mID, NULL );
	saveRef( t.pEnv, tempClass );
	t.pEnv->DeleteLocalRef( tempClass );
}

// der protected-Konstruktor fuer abgeleitete Klassen
java_lang_Object::java_lang_Object( JNIEnv * pXEnv, jobject myObj )
	: object( NULL )
{
	DBG_CTOR(java_lang_Object,NULL);
	SDBThreadAttach t;
	if( t.pEnv && myObj )
		object = t.pEnv->NewGlobalRef( myObj );
}

java_lang_Object::~java_lang_Object()
{
	DBG_DTOR(java_lang_Object,NULL);
	if( object )
	{
		SDBThreadAttach t;
		if( t.pEnv )
			t.pEnv->DeleteGlobalRef( object );
	}
}

// der protected-Konstruktor fuer abgeleitete Klassen
void java_lang_Object::saveRef( JNIEnv * pXEnv, jobject myObj )
{
	DBG_ASSERT( myObj, "object in c++ -> Java Wrapper" )
	SDBThreadAttach t;
	if( t.pEnv && myObj )
		object = t.pEnv->NewGlobalRef( myObj );
}


java_lang_Class * java_lang_Object::getClass()
{
	jobject out;
	SDBThreadAttach t;
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/Class;";
		char * cMethodName = "getClass";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
		{
			out = t.pEnv->CallObjectMethodA( object, mID, NULL );
			return new java_lang_Class( t.pEnv, out );
		} //mID
	} //pEnv
	return NULL;
}

String java_lang_Object::toString()
{
	jstring out(0);
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "toString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
		{
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(TRUE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				//	jsize len = t.pEnv->GetStringLength(out);
				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				if(bCopy)
					t.pEnv->ReleaseStringChars(out,pChar);
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //pEnv
	return 	aStr;
}

