/*************************************************************************
 *
 *  $RCSfile: ja_ma_pg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// Ersterstellung:
//	OJ 11.05.1998
//
// Letzte Aenderung:
//
// Beschreibung:
//	Beinhaltet die aus java.math.* generierten Wrapperklassen
//
// WARNING: Do not edit this file - it is machine generated


#ifndef _SDB_JA_MA_PG_HXX
#include <ja_ma_pg.hxx>
#endif

//**************************************************************
//************ Class: java.math.BigDecimal
//**************************************************************

jclass java_math_BigDecimal::theClass = 0;

java_math_BigDecimal::~java_math_BigDecimal()
{}

jclass java_math_BigDecimal::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/math/BigDecimal" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_math_BigDecimal::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

double java_math_BigDecimal::doubleValue()
{
	jdouble out;
	SDBThreadAttach t;
	if( t.pEnv ){
		jvalue args[1];
		// temporaere Variable initialisieren
		char * cSignature = "()D";
		char * cMethodName = "doubleValue";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallDoubleMethodA( object, mID, args );
		} //mID
	} //t.pEnv
	return out;
}

java_math_BigDecimal::java_math_BigDecimal( double _par0 ): java_lang_Number( NULL, (jobject)NULL ){
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[1];
		// Parameter konvertieren
		args[0].d = _par0;
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(D)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}

