/*************************************************************************
 *
 *  $RCSfile: jav_cxx.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_MDIAPP_HXX //autogen
#include <vcl/mdiapp.hxx>
#endif

#ifndef _TOOLS_RC_HXX //autogen
#include <tools/rc.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX //autogen
#include <tools/resmgr.hxx>
#endif

#ifndef SOLAR_HRC
#include <svtools/solar.hrc>
#endif

#include <ja_lg_ob.hxx>
#include "ja_lg_pg.hxx"
#include "ja_sq_pg.hxx"
#include "jdbcconn.hxx"
#include "jdbccurs.hxx"


class TestApp: public Application
{
	Font	aFont;
protected:
	virtual void Main();

public:
	TestApp();
};

//==================================================================

TestApp::TestApp() :aFont("MS Sans Serif",Size(0,8))
{}

TestApp aApp;

void TestApp::Main(){

	ResMgr* pResMgr = ResMgr::CreateResMgr(String("dem") + String(SOLARUPD));
	Resource::SetResManager(pResMgr);
	EnableSVLook();

	SetAppFont(aFont);
/*
	java_lang_Class::forName("sun.jdbc.odbc.JdbcOdbcDriver");
	java_sql_Connection *con = java_sql_DriverManager::getConnection("jdbc:odbc:test","","");
	java_sql_DatabaseMetaData *pMd = con->getMetaData();
	java_sql_ResultSet *pRs = pMd->getCatalogs();
	SvStringsDtor *pList = new SvStringsDtor(2);
	String *tt = new String("TABLE");
	String *t2 = new String("SYSTEM TABLE");
	pList->Insert(tt,0);
	pList->Insert(t2,1);
	while(pRs->next()){
		String catName;
		catName = pRs->getString("TABLE_CAT");
		java_sql_ResultSet *pRs1 = pMd->getTables(catName,"","%",pList);
		while(pRs1->next()){
			String cat = pRs1->getString("TABLE_CAT");
			cat = pRs1->getString("TABLE_SCHEM");
			cat = pRs1->getString("TABLE_NAME");
			cat = pRs1->getString("TABLE_TYPE");
		}
		delete pRs1;

	}
	delete pRs;
	con->close();
	delete pMd;
	delete con;
*/
	String t("TYP=JDBC;DSN=TEST;USER=");
	SdbConnectionRef pCon = SdbEnvironmentRef()->OpenConnection(t);
}
