#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:51:05 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..

PRJNAME=setup2
TARGET=jvmscan
LIBTARGET=NO

#statisch uebersetzen
DYNAMIC_CRT=

# --- Settings -----------------------------------------------------

.INCLUDE : svpre.mk
.INCLUDE : settings.mk
.INCLUDE : sv.mk

# --- link unix executable as static as you can ------------------

.IF "$(OS)"=="LINUX"
LINKFLAGS=-Bstatic -melf_i386 -z nodefs /nw386/dev/s/solenv/unxlngi/usr/lib/crti.o
STDLIBCUIMT=-lgcc -lm -lc -lgcc /nw386/dev/s/solenv/unxlngi/lib/gcc-lib/i586-pc-linux-gnu/egcs-2.91.57/crtend.o /nw386/dev/s/solenv/unxlngi/usr/lib/crtn.o
.ENDIF

.IF "$(OS)"=="NETBSD"
STDLIBCUIST=
_SYSLIBS=
LINKFLAGSAPPCUI=-static
.ENDIF

.IF "$(OS)"=="SOLARIS"
LINKFLAGS=-w
LINKFLAGSAPPCUI=-Bstatic 
STDLIBCUIMT=-Bdynamic -ldl -Bstatic
.ENDIF

# --- Files --------------------------------------------------------


SLOFILES= 		$(SLO)$/jvmscan.obj

LIB1TARGET=		$(SLB)$/$(TARGET).lib
LIB1OBJFILES=   $(SLOFILES)

OBJFILES= 		$(OBJ)$/jvmscan.obj

LIB1TARGET=		$(SLB)$/$(TARGET).lib
LIB1OBJFILES=   $(SLOFILES)

LIB2TARGET=		$(LB)$/$(TARGET).lib
LIB2OBJFILES=	$(OBJFILES)


# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk


