/*************************************************************************
 *
 *  $RCSfile: clsids.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SO_CLSIDS_HXX
#define _SO_CLSIDS_HXX



/*
 * Desktop
 */

/* 4.0 */

#define SO3_DESKTOP_CLASSID_40 \
	0xa49a6202, 0x4398, 0x11d0, 0xa2, 0x8a, \
	0x0, 0xa0, 0x24, 0x3d, 0x35, 0xbd

/* 5.0 */

#define SO3_DESKTOP_CLASSID_50 \
	0x1c50dce1, 0x85dc, 0x11d1, 0xaa, 0xb4, \
	0x0, 0x60, 0x97, 0xda, 0x56, 0x1a

/* aktuell */

#define SO3_DESKTOP_CLASSID SO3_DESKTOP_CLASSID_50

/*
 * StarWriter
 */

/* 3.0 */

#define SO3_SW_CLASSID_30 \
	0xDC5C7E40L, 0xB35C, 0x101B, 0x99, 0x61, 0x04, \
	0x02, 0x1C, 0x00, 0x70, 0x02

/* 4.0 */

#define SO3_SW_CLASSID_40 \
	0x8b04e9b0,  0x420e, 0x11d0, 0xa4, 0x5e, 0x0, \
	0xa0, 0x24, 0x9d, 0x57, 0xb1


/* 5.0 */

#define SO3_SW_CLASSID_50 \
	0xc20cf9d1, 0x85ae, 0x11d1, 0xaa, 0xb4, 0x0, \
	0x60, 0x97, 0xda, 0x56, 0x1a

/* aktuell */

#define SO3_SW_CLASSID SO3_SW_CLASSID_50

/*
 * StarWriter/Web
 */

/* 4.0 */

#define SO3_SWWEB_CLASSID_40 \
	0xf0caa840, 0x7821, 0x11d0, 0xa4, 0xa7, 0x0, \
	0xa0, 0x24, 0x9d, 0x57, 0xb1


/* 5.0 */

#define SO3_SWWEB_CLASSID_50 \
	0xc20cf9d2, 0x85ae, 0x11d1, 0xaa, 0xb4, 0x0, \
	0x60, 0x97, 0xda, 0x56, 0x1a


/* aktuell */

#define SO3_SWWEB_CLASSID SO3_SWWEB_CLASSID_50


/*
 * Globaldokument
 */

/* 4.0 */

#define SO3_SWGLOB_CLASSID_40 \
	0x340ac970, 0xe30d, 0x11d0, 0xa5, 0x3f, 0x0, \
	0xa0, 0x24, 0x9d, 0x57, 0xb1

/* 5.0 */
#define SO3_SWGLOB_CLASSID_50 \
	0xc20cf9d3, 0x85ae, 0x11d1, 0xaa, 0xb4, 0x0, \
	0x60, 0x97, 0xda, 0x56, 0x1a


/* aktuell */

#define SO3_SWGLOB_CLASSID SO3_SWGLOB_CLASSID_50



//---------------------------------------------------

/*
 * StarCalc
 */

/* 3.0 */

#define SO3_SC_CLASSID_30 \
	0x3F543FA0L, 0xB6A6, 0x101B, 0x99, 0x61, 0x04, \
	0x02, 0x1C, 0x00, 0x70, 0x02


/* 4.0 */

#define SO3_SC_CLASSID_40 \
	0x6361d441L, 0x4235, 0x11d0, 0x89, 0xcb, 0x00, \
	0x80, 0x29, 0xe4, 0xb0, 0xb1


/* 5.0 */

#define SO3_SC_CLASSID_50 \
	0xc6a5b861L, 0x85d6, 0x11d1, 0x89, 0xcb, 0x00, \
	0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SC_CLASSID SO3_SC_CLASSID_50



/****************************************************
* StarImpress
****************************************************/

/* 3.0 */

#define SO3_SIMPRESS_CLASSID_30 \
    0xAF10AAE0L, 0xB36D, 0x101B, 0x99, 0x61, 0x04, \
    0x02, 0x1C, 0x00, 0x70, 0x02


/* 4.0 */

#define SO3_SIMPRESS_CLASSID_40 \
    0x12d3cc0L, 0x4216, 0x11d0, 0x89, 0xcb, 0x0, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* 5.0 */

#define SO3_SIMPRESS_CLASSID_50 \
    0x565c7221L, 0x85bc, 0x11d1, 0x89, 0xd0, 0x0, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SIMPRESS_CLASSID  SO3_SIMPRESS_CLASSID_50



/****************************************************
* StarDraw
****************************************************/

/* 5.0 */

#define SO3_SDRAW_CLASSID_50 \
    0x2e8905a0L, 0x85bd, 0x11d1, 0x89, 0xd0, 0x0, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SDRAW_CLASSID  SO3_SDRAW_CLASSID_50



/****************************************************
* StarChart
****************************************************/

/* 3.0 */

#define SO3_SCH_CLASSID_30 \
    0xFB9C99E0L, 0x2C6D, 0x101C, 0x8E, 0x2C, 0x00, \
    0x00, 0x1B, 0x4C, 0xC7, 0x11


/* 4.0 */

#define SO3_SCH_CLASSID_40 \
    0x2b3b7e0L, 0x4225, 0x11d0, 0x89, 0xca, 0x00, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* 5.0 */

#define SO3_SCH_CLASSID_50 \
    0xbf884321L, 0x85dd, 0x11d1, 0x89, 0xd0, 0x00, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SCH_CLASSID  SO3_SCH_CLASSID_50



/****************************************************
* StarImage
****************************************************/

/* 3.0 */

#define SO3_SIM_CLASSID_30 \
    0xEA60C941L, 0x2C6C, 0x101C, 0x8E, 0x2C, 0x00, \
    0x00, 0x1B, 0x4C, 0xC7, 0x11


/* 4.0 */

#define SO3_SIM_CLASSID_40 \
    0x447BB8A0L, 0x41FB, 0x11D0, 0x89, 0xCA, 0x00, \
    0x80, 0x29, 0xE4, 0xB0, 0xB1


/* 5.0 */

#define SO3_SIM_CLASSID_50 \
    0x65c68d00L, 0x85de, 0x11d1, 0x89, 0xd0, 0x00, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SIM_CLASSID  SO3_SIM_CLASSID_50



/***************************************************
* StarMath
***************************************************/

/* 3.0 */

#define SO3_SM_CLASSID_30 \
    0xD4590460L, 0x35FD, 0x101C, 0xB1, 0x2A, 0x04, \
    0x02, 0x1C, 0x00, 0x70, 0x02


/* 4.0 */

#define SO3_SM_CLASSID_40 \
    0x2b3b7e1L, 0x4225, 0x11d0, 0x89, 0xca, 0x00, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* 5.0 */

#define SO3_SM_CLASSID_50 \
    0xffb5e640L, 0x85de, 0x11d1, 0x89, 0xd0, 0x00, \
    0x80, 0x29, 0xe4, 0xb0, 0xb1


/* aktuell */

#define SO3_SM_CLASSID  SO3_SM_CLASSID_50



#endif

