# mk file fuer macosp
ASM=
AFLAGS=

SOLAR_JAVA=TRUE
JAVAFLAGSDEBUG=-g

LINKOUTPUT_FILTER=

# _PTHREADS is needed for the stl
CDEFS+=-DSTLPORT_VERSION=321 -D_USE_NAMESPACE=1

.IF "$(SOLAR_JAVA)"!=""
JAVADEF=-DSOLAR_JAVA
JAVA_RUNTIME=-lJNI
.ENDIF 

# Special macros for this file only
MPW=$(SOLARENV)$/$(OUTPATH)$/bin$/execMPWcmd
UNIX2MACPATH=$(SOLARENV)$/$(OUTPATH)$/bin$/unix2macpath
MW_TOOLS=$(MW_HOME)$/CodeWarrior\ MPW$/MPW$/Tools

CC=$(MPW) $(shell $(UNIX2MACPATH) $(MW_TOOLS)$/MWCPPC)
cc=$(MPW) $(shell $(UNIX2MACPATH) $(MW_TOOLS)$/MWCPPC)
CFLAGS=-w off -maxerrors 4 -nosyspath -convertpaths -EOL -nomapcr \
  -relax_pointers \
  $(foreach,i,$(shell $(UNIX2MACPATH) $(INCLUDE:s/-I//)) -I"$i")
CFLAGSCC=

CFLAGSEXCEPTIONS=-Cpp_exceptions on
CFLAGS_NO_EXCEPTIONS=-Cpp_exceptions off

CFLAGSCXX=-dialect cplus -wchar_t on

CFLAGSOBJGUIST=
CFLAGSOBJCUIST=
CFLAGSOBJGUIMT=
CFLAGSOBJCUIMT=
CFLAGSSLOGUIMT=
CFLAGSSLOCUIMT=
CFLAGSPROF=
CFLAGSDEBUG=-g
CFLAGSDBGUTIL=
CFLAGSOPT=-O2
CFLAGSNOOPT=
CFLAGSOUTOBJ=-o

LINK=$(MPW) $(shell $(UNIX2MACPATH) $(MW_TOOLS)$/MWLinkPPC)
LINKFLAGS=-msg noparams -export all
LINKFLAGSAPPGUI=-application -size on -sizemax 2000 -sizemin 500 -lMSL\ AppRuntime.Lib -lMSL\ C.PPC.DLL -lMSL\ RuntimePPC++.DLL
LINKFLAGSSHLGUI=-sharedlibrary -lMSL\ ShLibRuntime.Lib -lMSL\ C.PPC.DLL -lMSL\ RuntimePPC++.DLL
LINKFLAGSAPPCUI=-application -size on -sizemax 2000 -sizemin 500 -lMSL\ AppRuntime.Lib -lMSL\ C.PPC.DLL -lMSL\ RuntimePPC++.DLL
LINKFLAGSSHLCUI=-sharedlibrary -lMSL\ ShLibRuntime.Lib -lMSL\ C.PPC.DLL -lMSL\ RuntimePPC++.DLL
LINKFLAGSTACK=
LINKFLAGSPROF=
LINKFLAGSDEBUG=-g
LINKFLAGSOPT=

LINKVERSIONMAPFLAG=

# Reihenfolge der libs NICHT egal!

STDOBJGUI=
STDSLOGUI=
STDOBJCUI=
STDSLOCUI=

STDLIBGUIST=-lInterfaceLib -lMathLib
STDLIBCUIST=-lInterfaceLib -lMathLib
STDLIBGUIMT=-lInterfaceLib -lMathLib -lThreadsLib
STDLIBCUIMT=-lInterfaceLib -lMathLib -lThreadsLib
STDSHLGUIMT=-lInterfaceLib -lMathLib -lThreadsLib
STDSHLCUIMT=-lInterfaceLib -lMathLib -lThreadsLib

LIBMGR=$(MPW) $(shell $(UNIX2MACPATH) $(MW_TOOLS)$/MWLinkPPC)
LIBFLAGS=-library

IMPLIB=
IMPLIBFLAGS=

MAPSYM=
MAPSYMFLAGS=

RC=irc
RCFLAGS=-fo$@ $(RCFILES)
RCLINK=
RCLINKFLAGS=
RCSETVERSION=

DLLPOSTFIX=mp
DLLPRE=lib
DLLPOST=.lib
