/*************************************************************************
#*
#*    MOTIF.H
#*
#*    Beschreibung
#*        Lademodul fuer Motif 1.1 Header Dateien
#*        mit der Umdefinierung der Ueberschneidungen von StarView und Windows
#*        Ueberschneidung: MOT_MotifName
#*
#*    Ersterstellung
#*        Autor: RK
#*        Datum: 25.04.91
#*
#*    Stand
#*        XX in Arbeit
#*        __ fertiggestellt
#*        __ abgenommen
#*        __ freigegeben
#*
#*    Copyright (c) 1991 - 1991, Star Division
#*
*************************************************************************/

#ifndef _PREX_H
#define _PREX_H

#define Window		MOT_Window
#define BYTE		MOT_BYTE
#define INT8		MOT_INT8
#define BOOL		MOT_BOOL
#define Font		MOT_Font
#define Cursor		MOT_Cursor
#define String		MOT_String
#define KeyCode		MOT_KeyCode
#define Region		MOT_Region
#define Icon		MOT_Icon
#define class   	MOT_class
#define new     	MOT_new
#define Time		MOT_Time
#define Region		MOT_Region
#define Boolean     XLIB_Boolean

/* fuer Network Audio System */
#define Sound MOT_Sound

/*** fuer Xprinter ***/
typedef unsigned long int ulong;
#define Printer XpPrinter
#define Orientation XpOrientation
/* #define FontInfo	XP_FontInfo */

#if defined( MTF12 ) || defined( ALPHA )
#define XLIB_ILLEGAL_ACCESS 
#endif   
#if defined( RS6000 ) || defined( ALPHA )
struct _XDisplay;
#endif   

#if defined __cplusplus && ! defined LINUX
extern "C" {
#endif

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#undef  DestroyAll
#define DestroyAll		MOT_DestroyAll
#define MOT_DestroyAll	0
#undef  String
#define String		MOT_String
#include <X11/IntrinsicP.h>
#undef  XtInheritTranslations
#define XtInheritTranslations  ((MOT_String) (&_XtInheritTranslations))
#undef  KeyCode
#define KeyCode		MOT_KeyCode //undef in intrinsics

#define __Ol_OlXlibExt_h__

#endif


