/*************************************************************************
#*
#*    $Workfile:$
#*
#*    VersionInfo
#*
#*    Ersterstellung    MH 10.5.98
#*    Letzte Aenderung  $Author: hr $ $Date: 2000/09/20 14:43:27 $
#*    $Revision: 1.1.1.1 $
#*
#*    $Logfile:$
#*
#*    Copyright (c) 1989 - 1998, STAR DIVISION
#*
#*************************************************************************

      Source Code Control System - Header

      $Header: /cvs/oo/tools/solenv/src/version.cxx,v 1.1.1.1 2000/09/20 14:43:27 hr Exp $

      Source Code Control System - Update

      $Log: version.cxx,v $
      Revision 1.1.1.1  2000/09/20 14:43:27  hr
      initial import

      Revision 1.1  2000/05/22 07:22:14  mh
      add: Version Info for executables


*************************************************************************/

extern "C" {
#if 0
#include <stdio.h>
#include <string.h>
#else
#ifdef WNT
char *  __cdecl strcpy(char *, const char *);
#endif
#if defined( OS2 ) || defined( UNX )
char * strcpy(char*, const char* );
#endif
#endif

#include <_version.h>


struct VersionInfo
{
	char	aTime[20];
	char	aDate[20];
	char	aUpd[5];
	char	aMinor;
	char	aBuild[5];
#if SUPD>564
	char	aInpath[20];
#endif
};


#ifdef WNT
__declspec(dllexport) VersionInfo *GetVersionInfo();
#endif
#ifdef OS2
VersionInfo *GetVersionInfo();
#endif

#ifdef WNT
__declspec(dllexport) VersionInfo *GetVersionInfo()
#endif
#if defined( OS2 ) || defined( UNX )
VersionInfo *GetVersionInfo()
#endif
{
#ifdef C50
	VersionInfo *pInfo = std::new VersionInfo;
#else
	VersionInfo *pInfo = new VersionInfo;
#endif
	(void) strcpy(pInfo->aUpd, _UPD);
	(void) strcpy(pInfo->aDate, __DATE__);
	(void) strcpy(pInfo->aTime, __TIME__);
	pInfo->aMinor = _LAST_MINOR;
	(void) strcpy(pInfo->aBuild, _BUILD );
#if SUPD>564
	(void) strcpy(pInfo->aInpath, _INPATH );
#endif
	return pInfo;
}

#if 0
int main( int argc, char **argv )
{
	VersionInfo *pInfo = GetVersionInfo();
	fprintf( stderr, "Date : %s\n", pInfo->aDate);
	fprintf( stderr, "Time : %s\n", pInfo->aTime);
	fprintf( stderr, "UPD : %s\n", pInfo->aUpd);
	delete pInfo;
	return 0;
}
#endif

}
