/*************************************************************************
 *
 *  $RCSfile: propbrw2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_SVXIDS_HRC
#include "svxids.hrc"
#endif

#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
#ifndef _SVX_PROPBRW_HRC
#include "propbrw.hrc"
#endif
#ifndef _SVX_PROPBRW_HXX
#include "propbrw.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _SVX_FMMODEL_HXX
#include "fmmodel.hxx"
#endif
#include <stdlib.h>
#include <stdio.h>
#include <wchar.h>
#ifndef _SVDPAGV_HXX
#include "svdpagv.hxx"
#endif

#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_COLRDLG_HXX //autogen
#include <svtools/colrdlg.hxx>
#endif

#ifndef _SV_COLOR_HXX
#include <vcl/color.hxx>
#endif

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif


#ifndef _COM_SUN_STAR_SDDB_XTABLESSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XTablesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XQUERIESSUPPLIER_HPP_
#include <com/sun/star/sdb/XQueriesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDDB_XCOLUMNSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XROWSET_HPP_
#include <com/sun/star/sdbc/XRowSet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XPREPAREDSTATEMENT_HPP_
#include <com/sun/star/sdbc/XPreparedStatement.hpp>
#endif

#ifndef _COM_SUN_STAR_SCRIPT_XEVENTATTACHERMANAGER_HPP_
#include <com/sun/star/script/XEventAttacherManager.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_LISTSOURCETYPE_HPP_
#include <com/sun/star/form/ListSourceType.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLCLASS_HPP_
#include <com/sun/star/reflection/XIdlClass.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLMETHOD_HPP_
#include <com/sun/star/reflection/XIdlMethod.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_SCRIPTEVENT_HPP_
#include <com/sun/star/script/ScriptEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_SCRIPTEVENTDESCRIPTOR_HPP_
#include <com/sun/star/script/ScriptEventDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTWEIGHT_HPP_
#include <com/sun/star/awt/FontWeight.hpp>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _IODLG_HXX //autogen
#include <sfx2/iodlg.hxx>
#endif

#ifndef _SVX_FMSHELL_HXX
#include "fmshell.hxx"
#endif

#ifndef _SVX_DIALMGR_HXX //autogen
#include "dialmgr.hxx"
#endif

#ifndef _SVX_FMOBJ_HXX
#include "fmobj.hxx"
#endif

#ifndef _SFX_OBJITEM_HXX //autogen
#include <sfx2/objitem.hxx>
#endif

#ifndef _SVX_FMPAGE_HXX
#include "fmpage.hxx"
#endif

#define ITEMID_MACRO SID_ATTR_MACROITEM
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif

#ifndef _MACROPG_HXX //autogen
#include <sfx2/macropg.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif

//Fuer Font-Dialog {
#define ITEMID_FONT 			SID_ATTR_CHAR_FONT
#define ITEMID_POSTURE			SID_ATTR_CHAR_POSTURE
#define ITEMID_WEIGHT			SID_ATTR_CHAR_WEIGHT
#define ITEMID_SHADOWED 		SID_ATTR_CHAR_SHADOWED
#define ITEMID_WORDLINEMODE 	SID_ATTR_CHAR_WORDLINEMODE
#define ITEMID_CONTOUR			SID_ATTR_CHAR_CONTOUR
#define ITEMID_CROSSEDOUT		SID_ATTR_CHAR_STRIKEOUT
#define ITEMID_UNDERLINE		SID_ATTR_CHAR_UNDERLINE
#define ITEMID_FONTHEIGHT		SID_ATTR_CHAR_FONTHEIGHT
#define ITEMID_PROPSIZE 		SID_ATTR_CHAR_PROPSIZE
#define ITEMID_COLOR			SID_ATTR_CHAR_COLOR
#define ITEMID_KERNING			SID_ATTR_CHAR_KERNING
#define ITEMID_CASEMAP			SID_ATTR_CHAR_CASEMAP
#define ITEMID_LANGUAGE 		SID_ATTR_CHAR_LANGUAGE
#define ITEMID_ESCAPEMENT		SID_ATTR_CHAR_ESCAPEMENT
#define ITEMID_FONTLIST 		SID_ATTR_CHAR_FONTLIST
#define ITEMID_AUTOKERN 		SID_ATTR_CHAR_AUTOKERN
#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_BLINK			SID_ATTR_FLASH
#define ITEMID_BRUSH			SID_ATTR_BRUSH

#include <fontitem.hxx>
#include <postitem.hxx>
#include <udlnitem.hxx>
#include <crsditem.hxx>
#include <cntritem.hxx>
#include <langitem.hxx>
#include <wghtitem.hxx>
#include <fhgtitem.hxx>
#include <shdditem.hxx>
#include <escpitem.hxx>
#include <prszitem.hxx>
#include <wrlmitem.hxx>
#include <cmapitem.hxx>
#include <kernitem.hxx>
#include <blnkitem.hxx>
#include <flstitem.hxx>
#include <akrnitem.hxx>
#include <brshitem.hxx>
#include <colritem.hxx>
//	#include <toolkit/unoiface.hxx>

#ifndef _SVX_CHARDLG_HXX //autogen
#include <chardlg.hxx>
#endif

#include "dlgutil.hxx"

// } Fuer Font-Dialog

#include "fmprop.hxx"
#include "fmprop.hrc"

#include <unotools/dbtools.hxx>
#include <unotools/uno3.hxx>
#include <unotools/processfactory.hxx>
#include <cppuhelper/extract.hxx>
#include <toolkit/helper/vclunohelper.hxx>

//------------------------------------------------------------------------
void FmPropController::SetFields( SvxPropData& rProperty )
{
try
{
	rProperty.eKind = KOC_COMBOBOX;
	::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XPreparedStatement >  xStatement;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSet(xForm, ::com::sun::star::uno::UNO_QUERY);
	if (!xSet.is())
		return;

	::rtl::OUString aObjectName	= ::utl::getString(xSet->getPropertyValue(FM_PROP_COMMAND));
	::rtl::OUString aDatabaseName	= ::utl::getString(xSet->getPropertyValue(FM_PROP_DATASOURCE));
	sal_Int32 nObjectType 	= ::utl::getINT32(xSet->getPropertyValue(FM_PROP_COMMANDTYPE));

	// Festellen des Feldes
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xFields;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xField;
	try
	{
		::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection >   xConnection = ::utl::calcConnection(::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > (xForm, ::com::sun::star::uno::UNO_QUERY),::utl::getProcessServiceFactory());
		if (!xConnection.is())
			return;

		switch (nObjectType)
		{
			case 0:
			{
				::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XTablesSupplier >  xSupplyTables(xConnection, ::com::sun::star::uno::UNO_QUERY);
				::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier >  xSupplyColumns(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSupplyTables->getTables()->getByName(aObjectName).getValue(), ::com::sun::star::uno::UNO_QUERY);
				xFields = xSupplyColumns->getColumns();
			}
			break;
			case 1:
			{
				::com::sun::star::uno::Reference< ::com::sun::star::sdb::XQueriesSupplier >  xSupplyQueries(xConnection, ::com::sun::star::uno::UNO_QUERY);
				::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier >  xSupplyColumns(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)xSupplyQueries->getQueries()->getByName(aObjectName).getValue(), ::com::sun::star::uno::UNO_QUERY);
				xFields  = xSupplyColumns->getColumns();
			}
			break;
			default:
			{
				xStatement = xConnection->prepareStatement(aObjectName);
				// not interested in any results
				::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > (xStatement,::com::sun::star::uno::UNO_QUERY)->setPropertyValue( ::rtl::OUString::createFromAscii("MaxRows"),::com::sun::star::uno::makeAny(sal_Int32(0)));
				::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XColumnsSupplier >  xSupplyCols(xStatement->executeQuery(), ::com::sun::star::uno::UNO_QUERY);
				if (xSupplyCols.is())
					xFields = xSupplyCols->getColumns();
			}
		}
	}
	catch(...)
	{
	}


	if (!xFields.is())
		return;

	::com::sun::star::uno::Sequence< ::rtl::OUString> aFields(xFields->getElementNames());
	const ::rtl::OUString* pFields = aFields.getConstArray();
	for( sal_Int32 i=0; i<aFields.getLength(); i++,++pFields )
		rProperty.theValues.push_back(*pFields);
}
catch(...)
{
	DBG_ERROR("FmPropController::SetFields : catched an exception !")
}


}


//------------------------------------------------------------------------
void FmPropController::SetTables( SvxPropData& rProperty )
{
try
{
	rProperty.eKind = KOC_COMBOBOX;
	::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet >  xRowSet(xForm, ::com::sun::star::uno::UNO_QUERY);
	if (!xRowSet.is())
		return;
	::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XTablesSupplier >  xTables;
	try
	{
		xTables = ::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XTablesSupplier > (::utl::calcConnection(xRowSet,::utl::getProcessServiceFactory()),::com::sun::star::uno::UNO_QUERY);
	}
	catch(...)
	{
		return;
	}

	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xAccess;
	if (xTables.is())
		xAccess = xTables->getTables();
	if (!xAccess.is())
		return;

	::com::sun::star::uno::Sequence< ::rtl::OUString> aTableNameSeq = xAccess->getElementNames();
	sal_uInt32 nCount = aTableNameSeq.getLength();
	const ::rtl::OUString* pTableNames = aTableNameSeq.getConstArray();
	//	const ::rtl::OUString* pTableName;

	for( sal_uInt32 i=0; i<nCount; i++ ,++pTableNames)
	{
		//	pTableName = &pTableNames[i];
		//	::rtl::OUString* pNewString = new ::rtl::OUString( *pTableNames );
		rProperty.theValues.push_back( *pTableNames);
	}
}

catch(...)
{
	DBG_ERROR("FmPropController::SetTables : catched an exception !")
}


}

//------------------------------------------------------------------------
void FmPropController::SetQueries( SvxPropData& rProperty )
{
try
{
	rProperty.eKind = KOC_COMBOBOX;

	::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet >  xRowSet(xForm, ::com::sun::star::uno::UNO_QUERY);
	if (!xRowSet.is())
		return;

	::com::sun::star::uno::Reference< ::com::sun::star::sdb::XQueriesSupplier >  xSupplyQueries;
	try
	{
		xSupplyQueries = ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XQueriesSupplier > (::utl::calcConnection(xRowSet,::utl::getProcessServiceFactory()),::com::sun::star::uno::UNO_QUERY);
	}
	catch(...)
	{
		return;
	}

	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameAccess >  xAccess;
	if (xSupplyQueries.is())
		xAccess = xSupplyQueries->getQueries();


	if (!xAccess.is())
		return;

	::com::sun::star::uno::Sequence< ::rtl::OUString> aQueryNameSeq = xAccess->getElementNames();
	sal_uInt32 nCount = aQueryNameSeq.getLength();
	const ::rtl::OUString* pQueryNames = aQueryNameSeq.getConstArray();
	//	const ::rtl::OUString* pQueryName;

	for( sal_uInt32 i=0; i<nCount; i++,++pQueryNames )
	{
		//	pQueryName = &pQueryNames[i];
		//	::rtl::OUString* pNewString = new ::rtl::OUString( *pQueryNames);
		rProperty.theValues.push_back( *pQueryNames );
	}
}
catch(...)
{
	DBG_ERROR("FmPropController::SetQueries : catched an exception !")
}


}

//------------------------------------------------------------------------
void FmPropController::SetCursorSource(sal_Bool bInit)
{
try
{
	if( !bHasCursorSource ) return;

	if(pPropBox->GetCurPage()!=nDataPage)
	{
		pPropBox->SetPage( nDataPage ); //Richtige Seite Einstellen
	}
	////////////////////////////////////////////////////////////
	// Auslesen des CursorSourceTypes
	UniString sCommandType = GetPropertyValue(FM_PROP_COMMANDTYPE);
	UniString sCommand = GetPropertyValue(FM_PROP_COMMAND);

	////////////////////////////////////////////////////////////
	// Setzen der UI-Daten
	SvxPropData aProperty;
	aProperty.eKind = KOC_MEDIT;

	UniString fCommandName = FM_PROP_COMMAND;
	aProperty.aName = fCommandName;
//	aProperty.aName = (UniString)FM_PROP_COMMAND;
	aProperty.aTitle = FmPropertyInfoService::getPropertyTranslation(FM_ATTR_COMMAND);
	aProperty.pControl = NULL;
	aProperty.bHasVisibleXButton = sal_False;
	aProperty.bIsHyperLink = sal_False;
	aProperty.bIsLocked = sal_False;

	aProperty.nHelpId=PROP_HELPID(FM_ATTR_COMMAND);
	if (bInit)
		aProperty.aValue = sCommand;
	else
		aProperty.aValue = UniString();

	////////////////////////////////////////////////////////////
	// Enums setzen
	UniString aTypeEntries( SVX_RES(RID_STR_COMMAND_TYPE) );
	if (sCommandType == aTypeEntries.GetToken(0))
		SetTables(aProperty);
	else if (sCommandType == aTypeEntries.GetToken(1))
		SetQueries(aProperty);

	if( !IsUIDisconnected() )
		pPropBox->ChangeEntry( aProperty, pPropBox->GetPropertyPos(aProperty.aName) );
	Commit(	aProperty.aName, aProperty.aValue, NULL );

	////////////////////////////////////////////////////////////
	// Array wieder loeschen
	aProperty.theValues.clear();
}
catch(...)
{
	DBG_ERROR("FmPropController::SetCursorSource : catched an exception !")
}


}

//------------------------------------------------------------------------
void FmPropController::SetListSource(sal_Bool bInit)
{
try
{
	if( !bHasListSource ) return;

	if(pPropBox->GetCurPage()!=nDataPage)
	{
		pPropBox->SetPage( nDataPage ); //Richtige Seite Einstellen
	}
	////////////////////////////////////////////////////////////
	// Auslesen des ListSourceTypes

	::com::sun::star::uno::Any aListSourceTypeAny;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  aPropSet(xUnoAccess->queryAdapter(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>*)0)), ::com::sun::star::uno::UNO_QUERY);


	::rtl::OUString aStrVal;

	if(aPropSet.is())
	{
		aListSourceTypeAny = aPropSet->getPropertyValue(FM_PROP_LISTSOURCETYPE );
	}


	sal_Int32 nListSourceType;
	::cppu::enum2int(nListSourceType,aListSourceTypeAny);

	::rtl::OUString aListSource = GetPropertyValue( FM_PROP_LISTSOURCE );

	////////////////////////////////////////////////////////////
	// Setzen der UI-Daten
	SvxPropData aProperty;
	aProperty.eKind = KOC_MEDIT;
	UniString fPropName = FM_PROP_LISTSOURCE;
	aProperty.aName = fPropName;
//	aProperty.aName = (UniString)FM_PROP_LISTSOURCE;
	aProperty.aTitle = FmPropertyInfoService::getPropertyTranslation(FM_ATTR_LISTSOURCE);
	aProperty.pControl = NULL;
	aProperty.bHasVisibleXButton = sal_False;
	aProperty.bIsHyperLink = sal_False;
	aProperty.bIsLocked = sal_False;
	aProperty.nHelpId=PROP_HELPID(FM_ATTR_LISTSOURCE);



	if (bInit)
		aProperty.aValue = (const sal_Unicode*)aListSource;
	else
		aProperty.aValue = String();

	////////////////////////////////////////////////////////////
	// Enums setzen
	switch( nListSourceType )
	{
	case ::com::sun::star::form::ListSourceType_VALUELIST:
		aProperty.eKind = KOC_LEDIT;
		break;

	case ::com::sun::star::form::ListSourceType_TABLEFIELDS:
	case ::com::sun::star::form::ListSourceType_TABLE:
		SetTables( aProperty );
		break;
	case ::com::sun::star::form::ListSourceType_QUERY:
		SetQueries( aProperty );
		break;
	}

	////////////////////////////////////////////////////////////
	// Eintrag umsetzen
	sal_uInt16 nCurPage = pPropBox->GetCurPage();
	pPropBox->SetPage( nDataPage );
	pPropBox->ChangeEntry( aProperty, pPropBox->GetPropertyPos(aProperty.aName) );
	Commit(	aProperty.aName, aProperty.aValue, NULL );

	pPropBox->SetPage( nCurPage );

	////////////////////////////////////////////////////////////
	// Array wieder loeschen
	aProperty.theValues.clear();
}
catch(...)
{
	DBG_ERROR("FmPropController::SetListSource : catched an exception !")
}


}

//------------------------------------------------------------------------
Font FmPropController::AnyToFont( const ::com::sun::star::uno::Any& rFontAttribsAny, const ::com::sun::star::uno::Any& rFontSizeAny,
								  const ::com::sun::star::uno::Any& rFontTypeAny )
{
	Font aFont;
/*
	Font_Attribs* pFontAttribs = (Font_Attribs*)rFontAttribsAny.get();
	Font_Size* pFontSize = (Font_Size*)rFontSizeAny.get();
	Font_Type* pFontType = (Font_Type*)rFontTypeAny.get();

	if( !pFontAttribs || !pFontSize || !pFontType )
	{
		Edit aEdit( GetpApp()->GetAppWindow() );
		return aEdit.GetFont();
	}

	aFont.SetName( S(pFontType->Name) );
	aFont.SetStyleName( S(pFontType->StyleName));
	aFont.SetFamily( pFontType->Family );
	aFont.SetCharSet( pFontType->FontCharSet );
	aFont.SetPitch( pFontType->Pitch );

	::com::sun::star::awt::Size aFontSize  = pFontSize->FontSize;
		 aFontSize.Height() *= 10;
		 aFontSize.Width() *= 10;

	aFont.SetSize( aFontSize);
	aFont.SetWidthType( pFontSize->WidthType );

	aFont.SetWeight( pFontAttribs->Weight );
	aFont.SetItalic( pFontAttribs->Italic );
	aFont.SetUnderline( pFontAttribs->Underline );
	aFont.SetStrikeout( pFontAttribs->Strikeout );
	aFont.SetOrientation( pFontAttribs->Orientation );
	aFont.SetKerning( pFontAttribs->Kerning );
	aFont.SetWordLineMode( pFontAttribs->WordLineMode );
*/
	return aFont;
}

//------------------------------------------------------------------------
void FmPropController::FontToAny( const Font& rFont, ::com::sun::star::uno::Any& rFontAttribsAny, ::com::sun::star::uno::Any& rFontSizeAny,
								  ::com::sun::star::uno::Any& rFontTypeAny )
{
/*
	Font_Attribs aFontAttribs;
	Font_Size aFontSize;
	Font_Type aFontType;

	aFontType.Name = U(rFont.GetName());
	aFontType.StyleName = U(rFont.GetStyleName());
	aFontType.Family = rFont.GetFamily();
	aFontType.FontCharSet = rFont.GetCharSet();
	aFontType.Pitch = rFont.GetPitch();

	aFontSize.FontSize = rFont.GetSize();
	aFontSize.FontSize.Height() /= 10;
	aFontSize.FontSize.Width() /= 10;

	aFontSize.WidthType = rFont.GetWidthType();

	aFontAttribs.Weight = rFont.GetWeight();
	aFontAttribs.Italic = rFont.GetItalic();
	aFontAttribs.Underline = rFont.GetUnderline();
	aFontAttribs.Strikeout = rFont.GetStrikeout();
	aFontAttribs.Orientation = rFont.GetOrientation();
	aFontAttribs.Kerning = rFont.IsKerning();
	aFontAttribs.WordLineMode = rFont.IsWordLineMode();

	rFontAttribsAny.set( &aFontAttribs, ::getCppuType((const Font_Attribs*)0) );
	rFontSizeAny.set( &aFontSize, ::getCppuType((const Font_Size*)0) );
	rFontTypeAny.set( &aFontType, ::getCppuType((const Font_Type*)0) );
*/
}

static sal_uInt16 pPropFontRgs[] =
{
	SID_ATTR_CHAR_FONT,SID_ATTR_CHAR_WEIGHT,
	SID_ATTR_CHAR_STRIKEOUT, SID_ATTR_CHAR_FONTHEIGHT,
	SID_ATTR_CHAR_COLOR,SID_ATTR_CHAR_COLOR,
	0
};

//------------------------------------------------------------------------
void FmPropController::ChangeFontProperty( const ::rtl::OUString& rName )
{
	SfxItemSet aSet( SFX_APP()->GetPool(), pPropFontRgs);

try
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  aPropSet(xUnoAccess->queryAdapter(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>*)0)), ::com::sun::star::uno::UNO_QUERY);


	::rtl::OUString aFontName				= ::utl::getString(aPropSet->getPropertyValue( FM_PROP_FONT_NAME     ));
	::rtl::OUString aFontStyleName			= ::utl::getString(aPropSet->getPropertyValue( FM_PROP_FONT_STYLENAME));
	sal_Int16	nFontFamily					= ::utl::getINT16(aPropSet->getPropertyValue( FM_PROP_FONT_FAMILY   ));
	sal_Int16	nFontCharset				= ::utl::getINT16(aPropSet->getPropertyValue( FM_PROP_FONT_CHARSET  ));
	float	nFontHeight						= ::utl::getFloat(aPropSet->getPropertyValue( FM_PROP_FONT_HEIGHT   ));
	float	nFontWeight						= ::utl::getFloat(aPropSet->getPropertyValue( FM_PROP_FONT_WEIGHT   ));
	sal_Int16	nFontSlant					= ::utl::getINT16(aPropSet->getPropertyValue( FM_PROP_FONT_SLANT    ));
	sal_Int16	nFontUnderline				= ::utl::getINT16(aPropSet->getPropertyValue( FM_PROP_FONT_UNDERLINE));
	sal_Int16	nFontStrikeout				= ::utl::getINT16(aPropSet->getPropertyValue( FM_PROP_FONT_STRIKEOUT));
	::com::sun::star::uno::Any	aColor32	= aPropSet->getPropertyValue( FM_PROP_TEXTCOLOR);

	SvxFontItem aFontItem((FontFamily)nFontFamily, aFontName,aFontStyleName,
				PITCH_DONTKNOW,nFontCharset,SID_ATTR_CHAR_FONT);

	nFontHeight = OutputDevice::LogicToLogic(Size(0, nFontHeight), MAP_POINT, MAP_TWIP).Height();
//	float fSize = (float)nFontHeight;
//	nFontHeight= CalcToUnit( fSize,aSet.GetPool()->GetMetric( SID_ATTR_CHAR_FONTHEIGHT ) );

	SvxFontHeightItem aSvxFontHeightItem( nFontHeight,100,SID_ATTR_CHAR_FONTHEIGHT);

	FontWeight		eWeight=VCLUnoHelper::ConvertFontWeight(nFontWeight);
	FontItalic		eItalic=(FontItalic)nFontSlant;
	FontUnderline	eUnderline=(FontUnderline)nFontUnderline;
	FontStrikeout	eStrikeout=(FontStrikeout)nFontStrikeout;

	SvxPostureItem		aPostureItem(eItalic,SID_ATTR_CHAR_POSTURE);
	SvxWeightItem		aWeightItem(eWeight,SID_ATTR_CHAR_WEIGHT);

	SvxUnderlineItem 	aUnderlineItem(eUnderline,SID_ATTR_CHAR_UNDERLINE);
	SvxCrossedOutItem	aCrossedOutItem(eStrikeout,SID_ATTR_CHAR_STRIKEOUT );

	sal_Int32	nColor32 = 0;
	if(aColor32.getValueType() != ::getVoidCppuType())
	{
		nColor32=::utl::getINT32(aColor32);
	}

	SvxColorItem aSvxColorItem(nColor32,SID_ATTR_CHAR_COLOR);

	aSet.Put(aFontItem, SID_ATTR_CHAR_FONT);
	aSet.Put(aSvxFontHeightItem,SID_ATTR_CHAR_FONTHEIGHT);
	aSet.Put(aWeightItem, SID_ATTR_CHAR_WEIGHT );
	aSet.Put(aPostureItem, SID_ATTR_CHAR_POSTURE);
	aSet.Put(aUnderlineItem,SID_ATTR_CHAR_UNDERLINE );
	aSet.Put(aCrossedOutItem,SID_ATTR_CHAR_STRIKEOUT );
	aSet.Put(aSvxColorItem, SID_ATTR_CHAR_COLOR);

	if(xPropertyState.is())
	{
		if (xPropertyState->getPropertyState(FM_PROP_FONT_NAME)== ::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE)
			aSet.InvalidateItem(SID_ATTR_CHAR_FONT);
		if (xPropertyState->getPropertyState(FM_PROP_FONT_HEIGHT)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE)
			aSet.InvalidateItem(SID_ATTR_CHAR_FONTHEIGHT);
		if ((xPropertyState->getPropertyState(FM_PROP_FONT_WEIGHT)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE) || (::com::sun::star::awt::FontWeight::DONTKNOW == nFontWeight))
			aSet.InvalidateItem(SID_ATTR_CHAR_WEIGHT );
		if ((xPropertyState->getPropertyState(FM_PROP_FONT_SLANT)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE) || (::com::sun::star::awt::FontSlant_DONTKNOW == nFontSlant))
			aSet.InvalidateItem(SID_ATTR_CHAR_POSTURE);
		if ((xPropertyState->getPropertyState(FM_PROP_FONT_UNDERLINE)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE) || (::com::sun::star::awt::FontUnderline::DONTKNOW == nFontUnderline))
			aSet.InvalidateItem(SID_ATTR_CHAR_UNDERLINE );
		if ((xPropertyState->getPropertyState(FM_PROP_FONT_STRIKEOUT)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE) || (::com::sun::star::awt::FontStrikeout::DONTKNOW == nFontStrikeout))
			aSet.InvalidateItem(SID_ATTR_CHAR_STRIKEOUT );
		if (xPropertyState->getPropertyState(FM_PROP_TEXTCOLOR)==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE)
			aSet.InvalidateItem(SID_ATTR_CHAR_COLOR );
	}
}

catch(...)
{
	DBG_ERROR("FmPropController::ChangeFontProperty : catched an exception (1) !")
	return;
}


	FontList aFontList(Application::GetDefaultDevice());
	SvxFontListItem aFontListItem( &aFontList, SID_ATTR_CHAR_FONTLIST );

	SfxSingleTabDialog* pDlg
		= new SfxSingleTabDialog( GetpApp()->GetAppWindow(),
									aSet, RID_SVXDLG_FMFONT, sal_False );

	SfxTabPage* pPage = SvxCharStdPage::Create( pDlg, aSet);
	((SvxCharStdPage*)pPage)->SetFontList( aFontListItem);
	pDlg->SetTabPage( pPage );

try
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  a2PropSet(xUnoAccess->queryAdapter(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>*)0)), ::com::sun::star::uno::UNO_QUERY);


	if ( pDlg->Execute() == RET_OK )
	{
		const SfxItemSet* pOut = pDlg->GetOutputItemSet();

		if(pOut != NULL)
		{
			SfxItemState eState = pOut->GetItemState( SID_ATTR_CHAR_FONT );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxFontItem&			rFontItem=
					(const SvxFontItem&)		pOut->Get(SID_ATTR_CHAR_FONT );

				pPropBox->SetPropertyValue( String::CreateFromAscii("Font"), rFontItem.GetFamilyName());

				a2PropSet->setPropertyValue( FM_PROP_FONT_NAME     , ::com::sun::star::uno::makeAny(::rtl::OUString(rFontItem.GetFamilyName())));
				a2PropSet->setPropertyValue( FM_PROP_FONT_STYLENAME, ::com::sun::star::uno::makeAny(::rtl::OUString(rFontItem.GetStyleName())));
				a2PropSet->setPropertyValue( FM_PROP_FONT_FAMILY   , ::com::sun::star::uno::makeAny((sal_Int16)rFontItem.GetFamily()));
				a2PropSet->setPropertyValue( FM_PROP_FONT_CHARSET  , ::com::sun::star::uno::makeAny((sal_Int16)rFontItem.GetCharSet()));
			}

			eState = pOut->GetItemState( SID_ATTR_CHAR_FONTHEIGHT );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxFontHeightItem&	rSvxFontHeightItem=
					(const SvxFontHeightItem&)	pOut->Get(SID_ATTR_CHAR_FONTHEIGHT);

//				float nHeight = CalcToPoint( rSvxFontHeightItem.GetHeight(),
//						pOut->GetPool()->GetMetric( SID_ATTR_CHAR_FONTHEIGHT ), 1);

				float nHeight = OutputDevice::LogicToLogic(Size(0, rSvxFontHeightItem.GetHeight()), MAP_TWIP, MAP_POINT).Height();
				a2PropSet->setPropertyValue( FM_PROP_FONT_HEIGHT,::com::sun::star::uno::makeAny(nHeight));

			}

			eState = pOut->GetItemState( SID_ATTR_CHAR_WEIGHT );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxWeightItem&		rWeightItem=
					(const SvxWeightItem&)		pOut->Get(SID_ATTR_CHAR_WEIGHT );
				float nWeight = VCLUnoHelper::ConvertFontWeight( rWeightItem.GetWeight());

				a2PropSet->setPropertyValue( FM_PROP_FONT_WEIGHT,::com::sun::star::uno::makeAny(nWeight));
			}

			eState = pOut->GetItemState( SID_ATTR_CHAR_POSTURE );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxPostureItem&		rPostureItem=
					(const SvxPostureItem&)		pOut->Get(SID_ATTR_CHAR_POSTURE);
				sal_Int32 eSlant = rPostureItem.GetPosture();
				a2PropSet->setPropertyValue( FM_PROP_FONT_SLANT, ::com::sun::star::uno::makeAny(eSlant));
			}

			eState = pOut->GetItemState( SID_ATTR_CHAR_UNDERLINE );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxUnderlineItem&		rUnderlineItem=
					(const SvxUnderlineItem&)	pOut->Get(SID_ATTR_CHAR_UNDERLINE );
				sal_Int16 nUnderline = rUnderlineItem.GetUnderline();
				a2PropSet->setPropertyValue( FM_PROP_FONT_UNDERLINE,::com::sun::star::uno::makeAny(nUnderline));
			}

			eState = pOut->GetItemState( SID_ATTR_CHAR_STRIKEOUT );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxCrossedOutItem&	rCrossedOutItem=
					(const SvxCrossedOutItem&)	pOut->Get(SID_ATTR_CHAR_STRIKEOUT );
				sal_Int16 nStrikeout = rCrossedOutItem.GetStrikeout();
				a2PropSet->setPropertyValue( FM_PROP_FONT_STRIKEOUT,::com::sun::star::uno::makeAny(nStrikeout));
			}


			eState = pOut->GetItemState( SID_ATTR_CHAR_COLOR );

			if ( eState == SFX_ITEM_SET)
			{
				const SvxColorItem&		rColorItem=
					(const SvxColorItem&)		pOut->Get(SID_ATTR_CHAR_COLOR );
				sal_Int32 nColor= rColorItem.GetValue().GetColor();
				a2PropSet->setPropertyValue( FM_PROP_TEXTCOLOR,::com::sun::star::uno::makeAny(nColor));
			}

		}
	}
}
catch(...)
{
	DBG_ERROR("FmPropController::ChangeFontProperty : catched an exception (2) !")
	return;
}


	delete pDlg;
}

#define THE_EVENT 1

void FmPropController::ChangeEventProperty( const ::rtl::OUString& _Name )
{
	SfxMacroAssignDlg* pMacroDlg = NULL;
	UniString rName(_Name.getStr());

	if(rName.GetTokenCount()==0)
		return;

	::rtl::OUString theListenerClassName = rName.GetToken( 0);
	::rtl::OUString theMethName = rName.GetToken(1);

//#####################
	::std::vector< ::rtl::OUString> aNameArray;

try
{

	::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >  xIndexAcc(xParentObjInter, ::com::sun::star::uno::UNO_QUERY);

	sal_Int32 nObjIdx=-1;

	if (aUnoObj.getValueTypeClass() == ::com::sun::star::uno::TypeClass_INTERFACE)

	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSet((*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aUnoObj.getValue()), ::com::sun::star::uno::UNO_QUERY);

		if(xIndexAcc.is())
		{
			sal_Int32 nCount=xIndexAcc->getCount();

			::com::sun::star::uno::Any aWuerg;
			for(sal_Int32 i=0;i<nCount;i++)
			{
				aWuerg = xIndexAcc->getByIndex(i);
				::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xTestSet((*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aWuerg.getValue()), ::com::sun::star::uno::UNO_QUERY);
				if(( ::com::sun::star::beans::XPropertySet *)xTestSet.get() == ( ::com::sun::star::beans::XPropertySet *)xSet.get())
				{
					nObjIdx=i;
					break;
				}
			}
		}
	}

	sal_uInt32 nScrEvts=0;

	::com::sun::star::uno::Sequence< ::com::sun::star::script::ScriptEventDescriptor > aSeqScrEvts;
	if(nObjIdx>=0 && xEvManager.is())
	{
		 aSeqScrEvts = xEvManager->getScriptEvents(nObjIdx);
		 nScrEvts = aSeqScrEvts.getLength();
	}

	sal_Bool  bRemoveFlag=sal_True;

	sal_uInt32 nLength = aListenerSeq.getLength();

	const ::com::sun::star::uno::Type * pListeners = aListenerSeq.getConstArray();

	const ::com::sun::star::script::ScriptEventDescriptor* pEvDes = aSeqScrEvts.getConstArray();


	SvxMacroTableDtor aTable;

	sal_uInt16 nIndex=0;
	sal_uInt32 i;

	UniString aListener;
	::rtl::OUString aListenerClassName;
	::com::sun::star::uno::Sequence< ::rtl::OUString> aMethSeq;

	for(i = 0 ; i < nLength ; i++ ,++pListeners)
	{
		// Namen besorgen
		aListener = (*pListeners).getTypeName().getStr();
		sal_Int32 nTokenCount = aListener.GetTokenCount('.');

		if(nTokenCount>0)
			aListenerClassName= aListener.GetToken(nTokenCount-1, '.' );
		else
			aListenerClassName= aListener;

		if(aListenerClassName.len()>0)
		{
			// Methoden der Listener ausgeben
			aMethSeq = getEventMethods( (*pListeners) );
			const ::rtl::OUString * pMethods = aMethSeq.getConstArray();
			sal_uInt32 nMethCount = aMethSeq.getLength();

			for( sal_uInt32 j = 0 ; j < nMethCount ; j++,++pMethods )
			{

				EvtUiDesc *pEvtUiDesc = GetEvtTranslation(*pMethods);

				// be sure that the event method isn't mentioned twice
				if (pEvtUiDesc != NULL)
				{
					if (theListenerClassName == aListenerClassName && theMethName == (*pMethods))
					{
						nIndex=aNameArray.size();
					}


					for(sal_uInt32 nI=0; nI<nScrEvts;nI++)
					{
						const ::com::sun::star::script::ScriptEventDescriptor& rEvDe = pEvDes[nI];

						if(rEvDe.ListenerType == aListenerClassName && rEvDe.EventMethod == (*pMethods))
						{
							SvxMacro* pMacro=NULL;

							const ::com::sun::star::script::ScriptEventDescriptor& rTheEvDe = pEvDes[nI];
							if(rTheEvDe.ScriptCode.len()>0 && rTheEvDe.ScriptType.len()>0)
							{
								pMacro = new SvxMacro(rTheEvDe.ScriptCode,rTheEvDe.ScriptType);
								aTable.Insert(aNameArray.size(),pMacro);
							}
							else
							{
								aTable.Insert(aNameArray.size(),NULL);
							}
						}
					}
					aNameArray.push_back(pEvtUiDesc->aTrans);
				}
			}
		}
	}

	SvxMacroItem aMacroItem;

	aMacroItem.SetMacroTable(aTable);

	SfxItemSet aSet( SFX_APP()->GetPool(), SID_ATTR_MACROITEM, SID_ATTR_MACROITEM );
	aSet.Put(aMacroItem, SID_ATTR_MACROITEM);
	pMacroDlg = new SfxMacroAssignDlg(
		GetpApp()->GetAppWindow(), aSet );
	SfxMacroTabPage* pMacroTabPage = (SfxMacroTabPage*)pMacroDlg->GetTabPage();

	for( sal_uInt32 j = 0 ; j < aNameArray.size(); j++ )
	{
		pMacroTabPage->AddEvent( aNameArray[j], j);
	}

	if(nIndex<aNameArray.size())
		pMacroTabPage->SelectEvent( aNameArray[nIndex], nIndex);

	if ( pMacroDlg->Execute() == RET_OK )
	{
		if(pShell!=NULL)
		{
			FmFormModel*pFormModel=pShell->GetFormModel();

			if(pFormModel!=NULL && pFormModel->GetObjectShell()!=NULL)
			{
				pFormModel->GetObjectShell()->SetModified(sal_True);
			}
			else
			{
				DBG_ERROR("Kein FormModel => kein Modified");
			}
		}


		const SvxMacroTableDtor& aTab=pMacroTabPage->GetMacroTbl();

		if(nObjIdx>=0 && xEvManager.is())
				xEvManager->revokeScriptEvents(nObjIdx);


		sal_uInt16 nEventCount=aTab.Count();
		sal_uInt16 nEventIndex=0;

		::com::sun::star::uno::Sequence< ::com::sun::star::script::ScriptEventDescriptor > aSeqScriptEvts(nEventCount);

		::com::sun::star::script::ScriptEventDescriptor *pSeqScriptEvts=aSeqScriptEvts.getArray();
		nIndex=0;

		UniString aListenerClassName,aName,aListener;
		//	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlMethod > > aMethSeq;
		
		pListeners = aListenerSeq.getConstArray();

		::rtl::OUString aMacStr;
		for(i = 0 ; i < nLength ; i++,++pListeners )
		{
			// Methode ansprechen
			//	const ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass > & (*pListeners) = pListeners[i];

			// Namen besorgen
			aListener = (*pListeners).getTypeName().getStr();
			sal_Int32 nTokenCount=aListener.GetTokenCount('.');

			if(nTokenCount>0)
				aListenerClassName = aListener.GetToken(nTokenCount-1, '.' );
			else
				aListenerClassName = aListener;

			if (aListenerClassName.Len() != 0)
			{
				// Methoden der Listener ausgeben
				aMethSeq = getEventMethods( (*pListeners) );

				const ::rtl::OUString* pMethods = aMethSeq.getConstArray();
				sal_uInt32 nMethCount = aMethSeq.getLength();

				for( sal_uInt32 j = 0 ; j < nMethCount ; j++,++pMethods )
				{
					//	::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlMethod >  xMethod = pMethods[ j ];

					//	aMethName=xMethod->getName();

					EvtUiDesc *pEvtUiDesc=GetEvtTranslation(*pMethods);

					if(pEvtUiDesc != NULL)
					{
						(aName = aListenerClassName) += ';';

						aName += (*pMethods).getStr();

						SvxMacro *pMacro=aTab.Get(nIndex++);
						if(pMacro!=NULL)
						{
							aMacStr = UniString(pMacro->GetMacName());
							if(nEventIndex<nEventCount)
							{
								pSeqScriptEvts[nEventIndex].ListenerType = aListenerClassName;
								pSeqScriptEvts[nEventIndex].EventMethod  = *pMethods;
								pSeqScriptEvts[nEventIndex].ScriptType   = pMacro->GetLanguage();
								pSeqScriptEvts[nEventIndex].ScriptCode   = aMacStr;
							}
							nEventIndex++;
						}
						else
							aMacStr = ::rtl::OUString();
						pPropBox->SetPropertyValue( aName, aMacStr);

					}
				}
			}
		}

		if(nObjIdx>=0 && xEvManager.is())
			xEvManager->registerScriptEvents(nObjIdx,aSeqScriptEvts);
	}
}
catch(...)
{
	DBG_ERROR("FmPropController::ChangeEventProperty : catched an exception !")
}


	if(pMacroDlg) 
		delete pMacroDlg;
}

//------------------------------------------------------------------------
::com::sun::star::beans::Property FmPropController::GetProperty( const ::rtl::OUString& rName )
{
	const ::com::sun::star::beans::Property* pProps = aPropSeq.getConstArray();
	for( sal_uInt32 i=0; i<aPropSeq.getLength(); i++,++pProps )
	{
		if( (*pProps).Name == rName )
			return (*pProps);
	}

	return ::com::sun::star::beans::Property();
}

