/*************************************************************************
 *
 *  $RCSfile: fmservs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_FMSERVS_HXX
#define _SVX_FMSERVS_HXX

#ifndef _FM_STATIC_HXX_
#include "fmstatic.hxx"
#endif
// alle serviceNamen
DECLARE_CONSTASCII_USTRING(FM_NUMBER_FORMATTER);

DECLARE_CONSTASCII_USTRING(VCL_CONTROL_EDIT);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_LISTBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_COMBOBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_GROUPBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_COMMANDBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_CHECKBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_IMAGEBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_FILECONTROL);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_DATEFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_FORMATTEDFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROL_IMAGECONTROL);

DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_EDIT);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_LISTBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_COMBOBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_GROUPBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_COMMANDBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_CHECKBOX);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_IMAGEBUTTON);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_FILECONTROL);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_DATEFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_FORMATTEDFIELD);
DECLARE_CONSTASCII_USTRING(VCL_CONTROLMODEL_IMAGECONTROL);

DECLARE_CONSTASCII_USTRING(AWT_CONTROL_TEXTFIELD);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_FORM);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_EDIT);		// alter service name (5.0)
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_TEXTFIELD);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_LISTBOX);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_COMBOBOX);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_GROUPBOX);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_COMMANDBUTTON);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_CHECKBOX);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_GRID);		// alter service name (5.0)
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_GRIDCONTROL);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_IMAGEBUTTON);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_FILECONTROL);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_DATEFIELD);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_FORMATTEDFIELD);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_HIDDEN);	// alter service name (5.0)
DECLARE_CONSTASCII_USTRING(FM_COMPONENT_HIDDENCONTROL);

DECLARE_CONSTASCII_USTRING(FM_COMPONENT_IMAGECONTROL);

DECLARE_CONSTASCII_USTRING(FM_CONTROL_LISTBOX);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_COMBOBOX);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_GROUPBOX);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_CHECKBOX);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_COMMANDBUTTON);

DECLARE_CONSTASCII_USTRING(FM_CONTROL_GRID);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_GRIDCONTROL);

DECLARE_CONSTASCII_USTRING(FM_CONTROL_IMAGEBUTTON);

DECLARE_CONSTASCII_USTRING(FM_CONTROL_EDIT);	  // alt
DECLARE_CONSTASCII_USTRING(FM_CONTROL_TEXTFIELD);

DECLARE_CONSTASCII_USTRING(FM_CONTROL_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_DATEFIELD);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_FILECONTROL);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_IMAGECONTROL);
DECLARE_CONSTASCII_USTRING(FM_CONTROL_FORMATTEDFIELD);

DECLARE_CONSTASCII_USTRING(FM_FORM_CONTROLLER);
DECLARE_CONSTASCII_USTRING(SRV_SDB_ROWSET);
DECLARE_CONSTASCII_USTRING(SRV_SDB_CONNECTION);
DECLARE_CONSTASCII_USTRING(SRV_SDBC_STATEMENT);
DECLARE_CONSTASCII_USTRING(SRV_SDB_DATABASE_ENVIRONMENT);
DECLARE_CONSTASCII_USTRING(SRV_SDB_DATABASE_ACCESS_CONNECTION);
DECLARE_CONSTASCII_USTRING(SRV_SDB_DATABASE_ACCESS_CONTEXT);



DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_FORM);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_TEXTFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_LISTBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_COMBOBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_GROUPBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_COMMANDBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_CHECKBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_GRIDCONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_IMAGEBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_FILECONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_DATEFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_HIDDENCONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_IMAGECONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_COMPONENT_FORMATTEDFIELD);

DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_TEXTFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_LISTBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_COMBOBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_RADIOBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_GROUPBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_FIXEDTEXT);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_COMMANDBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_CHECKBOX);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_GRIDCONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_IMAGEBUTTON);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_TIMEFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_DATEFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_NUMERICFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_CURRENCYFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_PATTERNFIELD);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_IMAGECONTROL);
DECLARE_CONSTASCII_USTRING(FM_SUN_CONTROL_FORMATTEDFIELD);

// alle Reflections
// Components
//Reflection*			FmXDatabaseForm_getReflection();
//Reflection*			FmXGridControlModel_getReflection();
//Reflection *		FmXEditModel_getReflection();
//Reflection*			FmXTextModel_getReflection();
//Reflection*			FmXCheckBoxModel_getReflection();
//Reflection*			FmXRadioButtonModel_getReflection();
//Reflection*			FmXImageButtonModel_getReflection();
//Reflection*			FmXComboBoxModel_getReflection();
//Reflection*			FmXGroupBoxModel_getReflection();
//Reflection*			FmXButtonModel_getReflection();
//Reflection*			FmXListBoxModel_getReflection();
//Reflection*			FmXFileControlModel_getReflection();
//Reflection*			FmXDateModel_getReflection();
//Reflection*			FmXTimeModel_getReflection();
//Reflection*			FmXNumericModel_getReflection();
//Reflection*			FmXCurrencyModel_getReflection();
//Reflection*			FmXPatternModel_getReflection();
//Reflection*			FmXHiddenModel_getReflection();
//Reflection*			FmXImageControlModel_getReflection();

// Controls
//Reflection*			FmXGridControl_getReflection();
//Reflection *		FmXEditControl_getReflection();
//Reflection*			FmXImageButtonControl_getReflection();
//Reflection*			FmXRadioButtonControl_getReflection();
//Reflection*			FmXComboBoxControl_getReflection();
//Reflection*			FmXCheckBoxControl_getReflection();
//Reflection*			FmXGroupBoxControl_getReflection();
//Reflection*			FmXButtonControl_getReflection();
//Reflection*			FmXListBoxControl_getReflection();
//Reflection*			FmXDateControl_getReflection();
//Reflection*			FmXTimeControl_getReflection();
//Reflection*			FmXNumericControl_getReflection();
//Reflection*			FmXCurrencyControl_getReflection();
//Reflection*			FmXPatternControl_getReflection();
//Reflection*			FmXFileControlControl_getReflection();
//Reflection*			FmXImageControlControl_getReflection();

// Peers
//	Reflection*			FmXGridPeer_getReflection();

// other internal objects
//	Reflection*			FmXFilterControl_getReflection();
//	Reflection*			FmXFilterCell_getReflection();

void ImplSmartRegisterUnoServices();



#endif // _SVX_FMSERVS_HXX

