/*************************************************************************
 *
 *  $RCSfile: ui_pch.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _UI_PCH_HXX
#define _UI_PCH_HXX

#define _STD_VAR_ARRAYS

#define _SVSTDARR_BOOLS
#define _SVSTDARR_ULONGS
#define _SVSTDARR_USHORTS
#define _SVSTDARR_LONGS
#define _SVSTDARR_SHORTS
#define _SVSTDARR_STRINGS
#define _SVSTDARR_STRINGSDTOR
#define _SVSTDARR_STRINGSSORT
#define _SVSTDARR_STRINGSSORTDTOR
#define _SVSTDARR_STRINGSISORT
#define _SVSTDARR_STRINGSISORTDTOR

#include "uiparam.hxx"			//Damit "unsere" Paramter fuer Common-Dialoge dabei sind
#include "hintids.hxx"          //Damit "unsere" Attribute angezogen werden.


#include <tools/solar.h>
#include <tools/string.hxx>
#include <osl/interlck.h>
#include <osl/types.h>
#include <sal/types.h>
#include <sal/config.h>
#include <rtl/textenc.h>
#include <rtl/textcvt.h>
#include <tools/ref.hxx>
#include <tools/link.hxx>
#include <tools/rtti.hxx>
#include <tools/list.hxx>
#include <tools/contnr.hxx>
#include <tools/resid.hxx>
#include <tools/gen.hxx>
#include <vcl/sv.h>
#include <vcl/rc.hxx>
#include <tools/rc.hxx>
#include <tools/lang.hxx>
#include <tools/resmgr.hxx>
#include <vcl/resid.hxx>
#include <vcl/color.hxx>
#include <vcl/region.hxx>
#include <vcl/mapmod.hxx>
#include <tools/fract.hxx>
#include <vcl/mapunit.hxx>
#include <vcl/bitmap.hxx>
#include <vcl/vclenum.hxx>
#include <swtypes.hxx>
#include <horiornt.hxx>
#include <sot/sotref.hxx>
#include <tools/time.hxx>
#include <tools/globname.hxx>
#include <vcl/accel.hxx>
#include <vcl/keycod.hxx>
#include <vcl/keycodes.hxx>
#include <vcl/wall.hxx>
#include <tools/date.hxx>
#include <svtools/solar.hrc>
#include <sfx2/sfxsids.hrc>
#include <svtools/cntwids.hrc>
#include <sot/sotdata.hxx>
#include <vcl/outdev.hxx>
#include <sot/factory.hxx>
#include <vcl/font.hxx>
#include <vcl/settings.hxx>
#include <tools/intn.hxx>
#include <sot/object.hxx>
#include <tools/ownlist.hxx>
#include <tools/debug.hxx>
#include <svtools/svarray.hxx>
#include <vcl/pointr.hxx>
#include <vcl/ptrstyle.hxx>
#include <vcl/wintypes.hxx>
#include <vcl/inputctx.hxx>
#include <vcl/event.hxx>
#include <sot/dtrans.hxx>
#include <vcl/cmdevt.hxx>
#include <vcl/window.hxx>
#include <svtools/hint.hxx>
#include <svtools/poolitem.hxx>
#include <vcl/timer.hxx>
#include <tools/errcode.hxx>
#include <vcl/ctrl.hxx>
#include <vcl/bitmapex.hxx>
#include <vcl/alpha.hxx>
#include <sfx2/sfx.hrc>
#include <svtools/memberid.hrc>
#include <vcl/menu.hxx>
#include <vos/refernce.hxx>
#include <vos/types.hxx>
#include <vos/object.hxx>
#include <tools/errinf.hxx>
#include <tools/stream.hxx>
#include <vcl/edit.hxx>
#include <vcl/combobox.h>
#include <tools/unqidx.hxx>
#include <errhdl.hxx>
#include <svtools/itemset.hxx>
#include <svtools/sbxdef.hxx>
#include <svtools/brdcst.hxx>
#include <vcl/combobox.hxx>
#include <hintids.hxx>
#include <vcl/timer.hxx>
#include <vcl/spinfld.hxx>
#include <sfx2/shell.hxx>
#include <vcl/fldunit.hxx>
#include <vcl/font.hxx>
#include <vcl/field.hxx>
#include <rcid.hrc>
#include <svtools/itempool.hxx>
#include <vcl/syswin.hxx>
#include <vcl/image.hxx>
#include <calbck.hxx>
#include <tools/table.hxx>
#include <swatrset.hxx>
#include <tools/mempool.hxx>
#include <svtools/lstner.hxx>
#include <svx/svxids.hrc>
#include <format.hxx>
#include <vos/xception.hxx>
#include <osl/mutex.h>
#include <toxe.hxx>
#include <shellid.hxx>
#include <vcl/resid.hxx>
#include <tools/unqid.hxx>
#include <swrect.hxx>
#include <ndarr.hxx>
#include <bparr.hxx>
#include <ndtyp.hxx>
#include <itabenum.hxx>
#include <flyenum.hxx>
#include <tools/shl.hxx>
#include <vcl/window.hxx>
#include <bkmrke.hxx>
#include <orntenum.hxx>
#include <svx/svxenum.hxx>
#include <svx/swafopt.hxx>
#include <crstate.hxx>
#include <fmtcol.hxx>
#include <tblenum.hxx>
#include <ring.hxx>
#include <index.hxx>
#include <node.hxx>
#include <so3/so2ref.hxx>
#include <so3/so2dll.hxx>
#include <tools/pstm.hxx>
#include <so3/factory.hxx>
#include <svtools/wordsel.hxx>
#include <viewsh.hxx>
#include <cshtyp.hxx>
#include <pam.hxx>
#include <ndindex.hxx>
#include <so3/iface.hxx>
#include <fesh.hxx>
#include <editsh.hxx>
#include <crsrsh.hxx>
#include <viscrs.hxx>
#include <vcl/cursor.hxx>
#include <swcrsr.hxx>
#include <tblsel.hxx>
#include <swtable.hxx>
#include <so3/so2ref.hxx>
#include <swregion.hxx>
#include <sortopt.hxx>
#include <wrtsh.hxx>
#include <swurl.hxx>
#include <vcl/event.hxx>
#include <svtools/intitem.hxx>
#include <so3/advise.hxx>
#include <so3/dtrans.hxx>
#include <so3/protocol.hxx>
#include <sfx2/imgdef.hxx>
#include <sfx2/module.hxx>
#include <vos/thread.hxx>
#include <osl/thread.h>
#include <vos/runnable.hxx>
#include <vcl/apptypes.hxx>
#include <vcl/symbol.hxx>
#include <svtools/svstdarr.hxx>
#include <vcl/svapp.hxx>
#include <sfx2/viewfac.hxx>
#include <sfx2/viewsh.hxx>
#include <sfx2/clientsh.hxx>
#include <so3/ipclient.hxx>
#include <so3/client.hxx>
#include <svx/zoomitem.hxx>
#include <view.hxx>
#include <cmdid.h>
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTOR_HPP_
#include <com/sun/star/frame/XDispatchProviderInterceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTATUSLISTENER_HPP_
#include <com/sun/star/frame/XStatusListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTION_HPP_
#include <com/sun/star/frame/XDispatchProviderInterception.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FEATURESTATEEVENT_HPP_
#include <com/sun/star/frame/FeatureStateEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_DISPATCHDESCRIPTOR_HPP_
#include <com/sun/star/frame/DispatchDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMEACTIONLISTENER_HPP_
#include <com/sun/star/frame/XFrameActionListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
#include <com/sun/star/frame/XComponentLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMEACTIONEVENT_HPP_
#include <com/sun/star/frame/FrameActionEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMEACTION_HPP_
#include <com/sun/star/frame/FrameAction.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORFACTORY_HPP_
#include <com/sun/star/task/XStatusIndicatorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORSUPPLIER_HPP_
#include <com/sun/star/task/XStatusIndicatorSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XBROWSEHISTORYREGISTRY_HPP_
#include <com/sun/star/frame/XBrowseHistoryRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_BUFFERSIZEEXCEEDEDEXCEPTION_HPP_
#include <com/sun/star/io/BufferSizeExceededException.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_NOTCONNECTEDEXCEPTION_HPP_
#include <com/sun/star/io/NotConnectedException.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_IOEXCEPTION_HPP_
#include <com/sun/star/io/IOException.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_UNEXPECTEDEOFEXCEPTION_HPP_
#include <com/sun/star/io/UnexpectedEOFException.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_WRONGFORMATEXCEPTION_HPP_
#include <com/sun/star/io/WrongFormatException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_SERVICENOTREGISTEREDEXCEPTION_HPP_
#include <com/sun/star/lang/ServiceNotRegisteredException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_NULLPOINTEREXCEPTION_HPP_
#include <com/sun/star/lang/NullPointerException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_CLASSNOTFOUNDEXCEPTION_HPP_
#include <com/sun/star/lang/ClassNotFoundException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_NOSUCHMETHODEXCEPTION_HPP_
#include <com/sun/star/lang/NoSuchMethodException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_SECURITYEXCEPTION_HPP_
#include <com/sun/star/lang/SecurityException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_NOSUCHFIELDEXCEPTION_HPP_
#include <com/sun/star/lang/NoSuchFieldException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_ARRAYINDEXOUTOFBOUNDSEXCEPTION_HPP_
#include <com/sun/star/lang/ArrayIndexOutOfBoundsException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_ILLEGALACCESSEXCEPTION_HPP_
#include <com/sun/star/lang/IllegalAccessException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_INDEXOUTOFBOUNDSEXCEPTION_HPP_
#include <com/sun/star/lang/IndexOutOfBoundsException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP_
#include <com/sun/star/lang/IllegalArgumentException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_NOSUPPORTEXCEPTION_HPP_
#include <com/sun/star/lang/NoSupportException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP_
#include <com/sun/star/lang/WrappedTargetException.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_PARAMINFO_HPP_
#include <com/sun/star/reflection/ParamInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLARRAY_HPP_
#include <com/sun/star/reflection/XIdlArray.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/reflection/XTypeProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_FIELDACCESSMODE_HPP_
#include <com/sun/star/reflection/FieldAccessMode.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLCLASS_HPP_
#include <com/sun/star/reflection/XIdlClass.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLFIELD_HPP_
#include <com/sun/star/reflection/XIdlField.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_PARAMMODE_HPP_
#include <com/sun/star/reflection/ParamMode.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_METHODMODE_HPP_
#include <com/sun/star/reflection/MethodMode.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLMEMBER_HPP_
#include <com/sun/star/reflection/XIdlMember.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLREFLECTION_HPP_
#include <com/sun/star/reflection/XIdlReflection.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLMETHOD_HPP_
#include <com/sun/star/reflection/XIdlMethod.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_INVOCATIONTARGETEXCEPTION_HPP_
#include <com/sun/star/reflection/InvocationTargetException.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_TYPECLASS_HPP_
#include <com/sun/star/uno/TypeClass.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUES_HPP_
#include <com/sun/star/beans/PropertyValues.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATE_HPP_
#include <com/sun/star/beans/PropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XMULTIPROPERTYSET_HPP_
#include <com/sun/star/beans/XMultiPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XFASTPROPERTYSET_HPP_
#include <com/sun/star/beans/XFastPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XVETOABLECHANGELISTENER_HPP_
#include <com/sun/star/beans/XVetoableChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATE_HPP_
#include <com/sun/star/beans/XPropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATECHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertyStateChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTIESCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertiesChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertyChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYACCESS_HPP_
#include <com/sun/star/beans/XPropertyAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYCONTAINER_HPP_
#include <com/sun/star/beans/XPropertyContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATECHANGEEVENT_HPP_
#include <com/sun/star/beans/PropertyStateChangeEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYCHANGEEVENT_HPP_
#include <com/sun/star/beans/PropertyChangeEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_UNKNOWNPROPERTYEXCEPTION_HPP_
#include <com/sun/star/beans/UnknownPropertyException.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_INTROSPECTIONEXCEPTION_HPP_
#include <com/sun/star/beans/IntrospectionException.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYEXISTEXCEPTION_HPP_
#include <com/sun/star/beans/PropertyExistException.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_ILLEGALTYPEEXCEPTION_HPP_
#include <com/sun/star/beans/IllegalTypeException.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVETOEXCEPTION_HPP_
#include <com/sun/star/beans/PropertyVetoException.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP_
#include <com/sun/star/uno/RuntimeException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XHIERARCHICALNAMEACCESS_HPP_
#include <com/sun/star/container/XHierarchicalNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTENTENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XContentEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATION_HPP_
#include <com/sun/star/container/XEnumeration.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XELEMENTACCESS_HPP_
#include <com/sun/star/container/XElementAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXACCESS_HPP_
#include <com/sun/star/container/XIndexAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINER_HPP_
#include <com/sun/star/container/XContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEREPLACE_HPP_
#include <com/sun/star/container/XNameReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINERLISTENER_HPP_
#include <com/sun/star/container/XContainerListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_CONTAINEREVENT_HPP_
#include <com/sun/star/container/ContainerEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXREPLACE_HPP_
#include <com/sun/star/container/XIndexReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XEVENTLISTENER_HPP_
#include <com/sun/star/lang/XEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_EVENTOBJECT_HPP_
#include <com/sun/star/lang/EventObject.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XALLLISTENERADAPTERSERVICE_HPP_
#include <com/sun/star/script/XAllListenerAdapterService.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XALLLISTENER_HPP_
#include <com/sun/star/script/XAllListener.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_ALLEVENTOBJECT_HPP_
#include <com/sun/star/script/AllEventObject.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCOMPONENTENUMERATION_HPP_
#include <com/sun/star/container/XComponentEnumeration.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCOMPONENTENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XComponentEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_LISTENEREXISTEXCEPTION_HPP_
#include <com/sun/star/lang/ListenerExistException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_ELEMENTEXISTEXCEPTION_HPP_
#include <com/sun/star/container/ElementExistException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_INVALIDLISTENEREXCEPTION_HPP_
#include <com/sun/star/lang/InvalidListenerException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_NOSUCHELEMENTEXCEPTION_HPP_
#include <com/sun/star/container/NoSuchElementException.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XTOPWINDOW_HPP_
#include <com/sun/star/awt/XTopWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_RECTANGLE_HPP_
#include <com/sun/star/awt/Rectangle.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POINT_HPP_
#include <com/sun/star/awt/Point.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_SELECTION_HPP_
#include <com/sun/star/awt/Selection.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_SIZE_HPP_
#include <com/sun/star/awt/Size.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_WINDOWDESCRIPTOR_HPP_
#include <com/sun/star/awt/WindowDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_INVALIDATESTYLE_HPP_
#include <com/sun/star/awt/InvalidateStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XTOOLKIT_HPP_
#include <com/sun/star/awt/XToolkit.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XWINDOWPEER_HPP_
#include <com/sun/star/awt/XWindowPeer.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_WINDOWCLASS_HPP_
#include <com/sun/star/awt/WindowClass.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XSYSTEMDEPENDENTWINDOWPEER_HPP_
#include <com/sun/star/awt/XSystemDependentWindowPeer.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_WINDOWATTRIBUTE_HPP_
#include <com/sun/star/awt/WindowAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XPOINTER_HPP_
#include <com/sun/star/awt/XPointer.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_SYSTEMPOINTER_HPP_
#include <com/sun/star/awt/SystemPointer.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include <com/sun/star/uno/Exception.hpp>
#endif
#include <vcl/fixed.hxx>
#include <svtools/smplhint.hxx>
#include <svtools/iniman.hxx>
#include <sfx2/app.hxx>
#include <vcl/lstbox.h>
#include <vcl/group.hxx>
#include <vcl/lstbox.hxx>
#include <vcl/button.hxx>
#include <rsc/rscsfx.hxx>
#include <sfx2/sfxdefs.hxx>
#include <vcl/dialog.hxx>
#include <swdll.hxx>
#include <vcl/dialog.hxx>
#include <vcl/mapmod.hxx>
#include <sfx2/msg.hxx>
#include <sfx2/viewfrm.hxx>
#include <sfx2/frame.hxx>
#include <vcl/edit.hxx>
#include <svtools/eitem.hxx>
#include <sfx2/objface.hxx>
#include <so3/so2defs.hxx>
#include <tools/datetime.hxx>
#include <sot/storage.hxx>
#include <svtools/ownlist.hxx>
#include <so3/pseudo.hxx>
#include <vcl/color.hxx>
#include <so3/persist.hxx>
#include <vcl/button.hxx>
#include <svtools/stritem.hxx>
#include <vcl/floatwin.hxx>
#include <so3/ipobj.hxx>
#include <so3/embobj.hxx>
#include <sfx2/objsh.hxx>
#include <docsh.hxx>
#include <sfx2/interno.hxx>
#include <sfx2/ipfrm.hxx>
#include <sfx2/docfac.hxx>
#include <vcl/gdimtf.hxx>
#include <sfx2/basedlgs.hxx>
#include <tools/wldcrd.hxx>
#include <globals.hrc>
#include <swmodule.hxx>
#include <vcl/btndlg.hxx>
#include <sfx2/cfgitem.hxx>
#include <svtools/confitem.hxx>
#include <vcl/image.hxx>
#include <vcl/wintypes.hxx>
#include <sfx2/bindings.hxx>
#include <sot/exchange.hxx>
#include <sfx2/minarray.hxx>
#include <sfx2/tabdlg.hxx>
#include <vcl/tabdlg.hxx>
#include <vcl/tabctrl.hxx>
#include <vcl/tabpage.hxx>
#include <authratr.hxx>
#include <numrule.hxx>
#include <error.h>
#include <vcl/msgbox.hxx>
#include <vcl/jobset.hxx>
#include <vcl/prntypes.hxx>
#include <sfx2/request.hxx>
#include <vcl/virdev.hxx>
#include <frmfmt.hxx>
#include <vcl/pointr.hxx>
#include <viewopt.hxx>
#include <vcl/combobox.hxx>
#include <basesh.hxx>
#include <sfx2/dispatch.hxx>
#include <vcl/ctrl.hxx>
#include <uitool.hxx>
#include <helpid.h>
#include <swevent.hxx>
#include <svx/dialogs.hrc>
#include <vcl/wrkwin.hxx>
#include <uiparam.hxx>
#include <svx/stddlg.hxx>
#include <vcl/animate.hxx>
#include <vcl/graph.h>
#include <vcl/gfxlink.hxx>
#include <frmatr.hxx>
#include <fldbas.hxx>
#include <svtools/sbxvar.hxx>
#include <svtools/sbxcore.hxx>
#include <offmgr/app.hxx>
#include <vcl/print.hxx>
#include <pagedesc.hxx>
#include <svtools/stdctrl.hxx>
#include <edtwin.hxx>
#include <vcl/system.hxx>
#include <svtools/sbxobj.hxx>
#include <svtools/svmedit.hxx>
#include <so3/binding.hxx>
#include <vcl/field.hxx>
#include <vcl/svapp.hxx>
#include <redlenum.hxx>
#include <vcl/virdev.hxx>
#include <svtools/svtreebx.hxx>
#include <svtools/svlbox.hxx>
#include <vcl/seleng.hxx>
#include <vcl/accel.hxx>
#include <svtools/treelist.hxx>
#include <vcl/sv.h>
#include <svtools/svlbitm.hxx>
#include <vcl/print.hxx>
#include <vcl/lstbox.hxx>
#include <vcl/floatwin.hxx>
#include <vcl/fixed.hxx>
#include <so3/svstor.hxx>
#include <sfx2/inimgr.hxx>
#include <svx/htmlmode.hxx>
#include <doc.hxx>
#include <svx/srchitem.hxx>
#include <sfx2/srchitem.hxx>
#include <vcl/toolbox.hxx>
#include <vcl/dockwin.hxx>
#include <svx/svdtypes.hxx>
#include <vcl/imagebtn.hxx>
#include <tools/urlobj.hxx>
#include <sfx2/childwin.hxx>
#include <sfx2/chalign.hxx>
#include <itemdef.hxx>
#include <swslots.hxx>
#include <vcl/graph.hxx>
#include <swundo.hxx>
#include <vcl/menu.hxx>
#include <fmtfsize.hxx>
#include <vcl/metric.hxx>
#include <svx/svdsob.hxx>
#include <svx/xpoly.hxx>
#include <sfx2/ctrlitem.hxx>
#include <svx/svdmodel.hxx>
#include <vcl/bitmap.hxx>

#endif
