/*************************************************************************
 *
 *  $RCSfile: wizenum.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _WIZENUM_HXX
#define _WIZENUM_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

class String;

#define EINHEIT 10 /* 1/10mm */

#ifdef VCL
  #define NEWLINE "\012"
#elif defined( UNX )
  #define NEWLINE "\012"
#elif defined( MAC )
  #define NEWLINE "\015"
#else
  #define NEWLINE "\015\012"
#endif

enum PageAlign {
		ALIGN_Null, ALIGN_LiOb, ALIGN_MiOb, ALIGN_ReOb,
		ALIGN_LiUn, ALIGN_ReUn, ALIGN_Mitt, ALIGN_ReMg,
		ALIGN_LiMg
	};

USHORT CountLines(const String& rStr);
String GetLine( const String& rStr, USHORT Num ); // Num=0 ist die erste Zeile

/*************************************************************************

	  Source Code Control System - Update

	  $Log: wizenum.hxx,v $
	  Revision 1.1.1.1  2000/09/18 17:14:51  hr
	  initial import
	
	  Revision 1.8  2000/09/18 16:06:22  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.7  2000/09/09 13:02:54  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.6  2000/04/19 11:18:59  os
	  UNICODE
	
	  Revision 1.5  1997/10/28 14:49:40  OM
	  CR fuer VCL korrigiert


	  Rev 1.4   28 Oct 1997 15:49:40   OM
   CR fuer VCL korrigiert

	  Rev 1.3   02 Sep 1997 12:07:20   MA
   inlcudes

	  Rev 1.2   29 Oct 1996 15:00:28   MA
   includes

	  Rev 1.1   19 Jun 1996 12:28:32   OM
   Umstellung auf 323

	  Rev 1.0   29 Jul 1995 23:36:36   JP
   alte Funktionalitaet wiederbeleben - Teil1

*************************************************************************/
	// #ifndef _...
#endif

