/*************************************************************************
 *
 *  $RCSfile: wizfusz.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WIZFUSZ_HXX
#define _WIZFUSZ_HXX

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#include "wizmulti.hxx"

class MetricField;

class WizardFuszDlg
{
	SwWizardDialog* pWizDlg;
	WizardFusz*   pFusz;
	BOOL bAbstand;
public:
	FixedText*     pF_Text_FusTit;
	CheckBox*      pF_CBox_FussAn;
	CheckBox*      pF_CBox_TrennL;
	FixedText*     pF_Text_VonUnt;
	MetricField*   pF_MFld_VonUnt;
	FixedText*     pF_Text_ZumTxt;
	MetricField*   pF_MFld_ZumTxt;
	MultiLineEdit* pF_MEdt_FusZei;
	GroupBox*      pF_GBox_FusZei;
public:
	WizardFuszDlg(SwWizardDialog* pDlgWin, BOOL bAbst=FALSE);
	~WizardFuszDlg();
	void Fill(MultiOne& WinArr);
	void SetPtr(WizardFusz* pFzl=NULL);
	void SetEventHandler();

	void ToUI();
	DECL_LINK( ClckHdl, CheckBox * );
	DECL_LINK( MetrHdl, MetricField * );
	DECL_LINK( EditHdl, MultiLineEdit * );

	void SetDisable();
};


#endif  //_WIZFUSZ_HXX
