#*************************************************************************
#*
#*    $Workfile:   MAKEFILE.MK  $
#*
#*    Ersterstellung      CL 23.11.93
#*    Letzte Aenderung   $Author: hr $   $Date: 2000/09/18 17:04:03 $
#*    $Revision: 1.1.1.1 $
#*
#*    $Logfile:   T:/unzip/util/makefile.mkv  $
#*
#*    Copyright (c) 1990 - 1993, STAR DIVISION
#*
#*************************************************************************

PRJ=..
PRJNAME=unzip
TARGET=svunzip
TARGETTYPE=CUI

# --- Allgemein -----------------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk

HXX1TARGET= svunzip
HXX1EXT=    h
HXX1FILES=  $(INC)$/svunzip.h
HXX1EXCL=   -E:*include*

LIB2TARGET= $(SLB)$/svunzip.lib
LIB2ARCHIV=$(LB)$/libsvunzip.a
LIB2FILES=  \
			$(SLB)$/unzip.lib

LIB1TARGET= $(LB)$/svunzip.lib
LIB1FILES=  \
			$(LB)$/unzip.lib

.IF "$(GUI)"=="UNX"
SHL1TARGET=zip$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= i$(TARGET)
.IF "$(OS)"=="MACOSX"
# Mac OS X can't compile these object files directly into a shared library,
# so we need to link using the archive instead.
SHL1OBJS=$(LIB2ARCHIV)
.ELSE
SHL1LIBS=$(LIB2TARGET)
.ENDIF
SHL1DEF=    $(MISC)$/$(SHL1TARGET).def
.ENDIF

DEF1NAME    =$(SHL1TARGET)
DEF1DEPN    =$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =svunzip


#.IF "$(GUI)"=="WNT"
#APP1TARGET= $(EXE)$/unzip
#APP1OBJS  = \
#			$(OBJ)$/_unzip.obj
#APP1STDLIBS=$(LB)$/unzip.lib
#.ENDIF

# --- Targets -------------------------------------------------------------

.INCLUDE :  target.mk

$(MISC)$/$(SHL1TARGET).flt:
    @echo ------------------------------
    @echo Making: $@
    @echo WEP>$@
    @echo LIBMAIN>>$@
    @echo LibMain>>$@


