'SBLLINK:MethodInfo=dbChgSQL0
'SBLLINK:MethodInfo=dbChgSQL_ParseOrder0
'SBLLINK:MethodInfo=GetNextOrderPart0
'SBLLINK:MethodInfo=dbChgSQL_InitListBoxes0
'SBLLINK:MethodInfo=dbChgSQL_PreviewOnPaint0
'SBLLINK:MethodInfo=dbChgSQL_cmdSort1OnClick0
'SBLLINK:MethodInfo=dbChgSQL_cmdSort2OnClick0
'SBLLINK:MethodInfo=dbChgSQL_cmdSort3OnClick0
'SBLLINK:MethodInfo=dbChgSQL_cmdSort4OnClick0
'SBLLINK:MethodInfo=dbChgSQL_ChangeCaption0
'SBLLINK:MethodInfo=dbChgSQL_cmbSort1OnSelect0
'SBLLINK:MethodInfo=dbChgSQL_cmbSort2OnSelect0
'SBLLINK:MethodInfo=dbChgSQL_cmbSort3OnSelect0
'SBLLINK:MethodInfo=dbChgSQL_cmbSort4OnSelect0
'SBLLINK:MethodInfo=dbChgSQL_cmdCancel0
'SBLLINK:MethodInfo=dbChgSQL_cmdOk0
Option Explicit

Global dbChgSQL_OrigSQLExpr$

'language vars begin
Dim dbChgSQL_MainName$
Dim dbChgSQL_ErrorCannotStart$
Dim dbChgSQL_Error$
Dim dbChgSQL_DLG_NoFieldSelected$
Dim dbChgSQL_ErrorCannotTableOrQuery$
'language vars end

Sub dbChgSQL()

On Error Goto dbChgSQL_ErrorOccured

	Call chgsql_LoadLanguage()

	If ( "" <> Form_Field_GetQueryName$() ) Then ' never!
		Beep()
		MsgBox( dbChgSQL_ErrorCannotStart$, 64, dbChgSQL_MainName$ )
		Exit Sub
	End If
	
	Application.LoadLibrary( "Tools" )

	Call CloseDBConnections()
	
	DlgChgSQL.Load()
	
	'	Get SQL Expr.
	dbChgSQL_OrigSQLExpr$ = UCase( Form_Field_GetSQLStatement$() )

	Call dbChgSQL_InitListBoxes()

	Call dbChgSQL_ParseOrder()

	DlgChgSQL.Show()
	
	Exit Sub
dbChgSQL_ErrorOccured:
	MsgBox( dbChgSQL_Error$, 16, dbChgSQL_MainName$ )
End Sub

Sub dbChgSQL_ParseOrder()

	Dim nPos%, nOrderCount%, sActChar$ : nOrderCount% = 0
	Dim sOrderPart$, sRestSQLExpr$ : sRestSQLExpr$ = dbChgSQL_OrigSQLExpr$
	Dim sAZ$( 4 )
	Dim sFields$( 4 )

	nPos% = InStr( sRestSQLExpr$, "ORDER BY" )
	If ( ( 0 <> nPos% ) And ( "" <> dbChgSQL_OrigSQLExpr$ ) ) Then 
		nOrderCount% = 1
		nPos% = nPos% + 9 'order by
		sRestSQLExpr$ = Mid(sRestSQLExpr$, nPos% )
		While ( ( "" <> sRestSQLExpr$ ) And ( 4 >= nOrderCount% ) )
			Call GetNextOrderPart( sRestSQLExpr$, sOrderPart$ )
			sOrderPart$ = sOrderPart$ + "~"
			nPos% = 0
			Do 
				nPos% = nPos% + 1
				sActChar$ = Mid( sOrderPart$, nPos%, 1 )
			Loop While ( ( " " <> sActChar$ ) And ( "~" <> sActChar$ ) )
			sOrderPart$ = Left( sOrderPart$, Len( sOrderPart$ ) - 1 )
			If ( 0 < InStr( Mid( sOrderPart$, nPos% ), "DESC" ) ) Then
				sAZ$( nOrderCount% ) = "ZA"
			Else
				sAZ$( nOrderCount% ) = "AZ"
			End If
			sFields$( nOrderCount% ) = Trim( Left( sOrderPart$, nPos% ) )
			sActChar$ = Left( sFields$( nOrderCount% ), 1 )
			If ( ( """" = sActChar$ ) Or ( "'" = sActChar$ ) ) Then
				sFields$( nOrderCount% ) = Mid( sFields$( nOrderCount% ), 2, Len(sFields$( nOrderCount% ))-2 )
			End If			
			nOrderCount% = nOrderCount% + 1
		Wend
	End If
	
	'	Init the dialog
	If ( 1 < nOrderCount% ) Then
		nPos% = GetIndexOfItem%( DlgChgSQL.cmbSort1, sFields$( 1 ) )
		If ( -1 <> nPos% ) Then
			DlgChgSQL.cmbSort1.ListIndex = nPos%
		End If
		DlgChgSQL.cmdSort1.Caption = sAZ$( 1 )
	End If
	
	If ( 2 < nOrderCount% ) Then
		nPos% = GetIndexOfItem%( DlgChgSQL.cmbSort2, sFields$( 2 ) )
		If ( -1 <> nPos% ) Then
			DlgChgSQL.cmbSort2.ListIndex = nPos%
		End If
		DlgChgSQL.cmdSort2.Caption = sAZ$( 1 )
	End If
	
	If ( 3 < nOrderCount% ) Then
		nPos% = GetIndexOfItem%( DlgChgSQL.cmbSort3, sFields$( 3 ) )
		If ( -1 <> nPos% ) Then
			DlgChgSQL.cmbSort3.ListIndex = nPos%
		End If
		DlgChgSQL.cmdSort3.Caption = sAZ$( 3 )
	End If
	
	If ( 4 < nOrderCount% ) Then
		nPos% = GetIndexOfItem%( DlgChgSQL.cmbSort4, sFields$( 4 ) )
		If ( -1 <> nPos% ) Then
			DlgChgSQL.cmbSort4.ListIndex = nPos%
		End If
		DlgChgSQL.cmdSort4.Caption = sAZ$( 4 )
	End If
	
End Sub

Sub GetNextOrderPart( sSQLExpr$, sOrderPart$ )

	Dim nPos%
	
	sSQLExpr$ = Trim( sSQLExpr$ )
	nPos% = InStr( sSQLExpr$, "," )
	If ( 0 <> nPos% ) Then
		sOrderPart$ = Left( sSQLExpr$, nPos% - 1 )
		sSQLExpr$ = Mid( sSQLExpr$, nPos% + 1)
	Else
		sOrderPart$ = sSQLExpr$
		sSQLExpr$ = ""
	End If	
End Sub

Sub dbChgSQL_InitListBoxes()

	Dim aTblMaxIndex%, nCount%, sFldName$, nTemp%
	Dim sDBName$ : sDBName$ = Form_Field_GetDatabaseName$()

	Application.OpenDatabaseConnection( sDBName$ )
	If ( "" <> Form_Field_GetTableName$() ) Then
		Application.OpenTableConnection( Form_Field_GetTableName$() )
	Else
		Goto dbChgSQL_ErrorOccured
	End If

	DlgChgSQL.cmbSort1.Height = 1500
	DlgChgSQL.cmbSort2.Height = 1500
	DlgChgSQL.cmbSort3.Height = 1500
	DlgChgSQL.cmbSort4.Height = 1500

	DlgChgSQL.cmbSort1.Clear()
	DlgChgSQL.cmbSort2.Clear()
	DlgChgSQL.cmbSort3.Clear()
	DlgChgSQL.cmbSort4.Clear()

	DlgChgSQL.cmbSort1.AddItem( dbChgSQL_DLG_NoFieldSelected$ )
	DlgChgSQL.cmbSort2.AddItem( dbChgSQL_DLG_NoFieldSelected$ )
	DlgChgSQL.cmbSort3.AddItem( dbChgSQL_DLG_NoFieldSelected$ )
	DlgChgSQL.cmbSort4.AddItem( dbChgSQL_DLG_NoFieldSelected$ )

	aTblMaxIndex% = Application.DataColumnNumber()
	For nCount%=1 To aTblMaxIndex%
		sFldName$ = Application.DataColumnName( nCount% )
		DlgChgSQL.cmbSort1.AddItem( sFldName$ )
		DlgChgSQL.cmbSort2.AddItem( sFldName$ )
		DlgChgSQL.cmbSort3.AddItem( sFldName$ )
		DlgChgSQL.cmbSort4.AddItem( sFldName$ )
	Next
	DlgChgSQL.cmbSort1.ListIndex = 0
	DlgChgSQL.cmbSort2.ListIndex = 0
	DlgChgSQL.cmbSort3.ListIndex = 0
	DlgChgSQL.cmbSort4.ListIndex = 0
	
	Exit Sub
	
dbChgSQL_ErrorOccured:
	MsgBox( dbChgSQL_ErrorCannotTableOrQuery$, 16, dbChgSQL_MainName$ )
	DlgChgSQL.Unload()
	Stop
End Sub

Sub dbChgSQL_PreviewOnPaint()

	Dim sPath$

	sPath$ = Application.Pathsettings.Config + getPathSeparator()

	Call PaintPicOnPreview( DlgChgSQL.SQLPreview, sPath$ + "cjtrep02.bmp", 152, 172, True )
End Sub

Sub dbChgSQL_cmdSort1OnClick()
	Call dbChgSQL_ChangeCaption( DlgChgSQL.cmdSort1 )
End Sub

Sub dbChgSQL_cmdSort2OnClick()
	Call dbChgSQL_ChangeCaption( DlgChgSQL.cmdSort2 )
End Sub

Sub dbChgSQL_cmdSort3OnClick()
	Call dbChgSQL_ChangeCaption( DlgChgSQL.cmdSort3 )
End Sub

Sub dbChgSQL_cmdSort4OnClick()
	Call dbChgSQL_ChangeCaption( DlgChgSQL.cmdSort4 )
End Sub

Sub dbChgSQL_ChangeCaption( commandbox As Object )
	If ( commandbox.Caption = "AZ" ) Then
		commandbox.Caption = "ZA"
	Else
		commandbox.Caption = "AZ"
	End If
End Sub

Sub dbChgSQL_cmbSort1OnSelect()
	Dim sThis$ : sThis$ = DlgChgSQL.cmbSort1.List( DlgChgSQL.cmbSort1.ListIndex )
	If ( ( sThis$ = DlgChgSQL.cmbSort2.List( DlgChgSQL.cmbSort2.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort3.List( DlgChgSQL.cmbSort3.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort4.List( DlgChgSQL.cmbSort4.ListIndex ) ) ) Then
		 Beep
		 DlgChgSQL.cmbSort1.ListIndex = 0
	End If
End Sub

Sub dbChgSQL_cmbSort2OnSelect()
	Dim sThis$ : sThis$ = DlgChgSQL.cmbSort2.List( DlgChgSQL.cmbSort2.ListIndex )
	If ( ( sThis$ = DlgChgSQL.cmbSort1.List( DlgChgSQL.cmbSort1.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort3.List( DlgChgSQL.cmbSort3.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort4.List( DlgChgSQL.cmbSort4.ListIndex ) ) ) Then
		 Beep
		 DlgChgSQL.cmbSort2.ListIndex = 0
	End If
End Sub

Sub dbChgSQL_cmbSort3OnSelect()
	Dim sThis$ : sThis$ = DlgChgSQL.cmbSort3.List( DlgChgSQL.cmbSort3.ListIndex )
	If ( ( sThis$ = DlgChgSQL.cmbSort2.List( DlgChgSQL.cmbSort2.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort1.List( DlgChgSQL.cmbSort1.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort4.List( DlgChgSQL.cmbSort4.ListIndex ) ) ) Then
		 Beep
		 DlgChgSQL.cmbSort3.ListIndex = 0
	End If
End Sub

Sub dbChgSQL_cmbSort4OnSelect()
	Dim sThis$ : sThis$ = DlgChgSQL.cmbSort4.List( DlgChgSQL.cmbSort4.ListIndex )
	If ( ( sThis$ = DlgChgSQL.cmbSort2.List( DlgChgSQL.cmbSort2.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort3.List( DlgChgSQL.cmbSort3.ListIndex ) ) Or _
		 ( sThis$ = DlgChgSQL.cmbSort1.List( DlgChgSQL.cmbSort1.ListIndex ) ) ) Then
		 Beep
		 DlgChgSQL.cmbSort4.ListIndex = 0
	End If
End Sub

Sub dbChgSQL_cmdCancel()
	DlgChgSQL.UnLoad()
End Sub

Sub dbChgSQL_cmdOk()
	Dim sNewSQL$, nPos%, nCount% : nCount% = 0
	Dim sFields$( 4 )
	Dim sAZ$( 4 )
	
	sNewSQL$ = "Select * from " + Application.QuoteTablename( Form_Field_GetTableName$() )

	If ( 0 <> DlgChgSQL.cmbSort1.ListIndex ) Then
		nCount% = nCount% + 1
		sFields$( nCount% ) = DlgChgSQL.cmbSort1.List( DlgChgSQL.cmbSort1.ListIndex )
		sAZ$( nCount% ) = DlgChgSQL.cmdSort1.Caption
	End If
	If ( 0 <> DlgChgSQL.cmbSort2.ListIndex ) Then
		nCount% = nCount% + 1
		sFields$( nCount% ) = DlgChgSQL.cmbSort2.List( DlgChgSQL.cmbSort2.ListIndex )
		sAZ$( nCount% ) = DlgChgSQL.cmdSort2.Caption
	End If
	If ( 0 <> DlgChgSQL.cmbSort3.ListIndex ) Then
		nCount% = nCount% + 1
		sFields$( nCount% ) = DlgChgSQL.cmbSort3.List( DlgChgSQL.cmbSort3.ListIndex )
		sAZ$( nCount% ) = DlgChgSQL.cmdSort3.Caption
	End If
	If ( 0 <> DlgChgSQL.cmbSort4.ListIndex ) Then
		nCount% = nCount% + 1
		sFields$( nCount% ) = DlgChgSQL.cmbSort4.List( DlgChgSQL.cmbSort4.ListIndex )
		sAZ$( nCount% ) = DlgChgSQL.cmdSort4.Caption
	End If
	
	If ( 0 <> nCount% ) Then
		sNewSQL$ = sNewSQL$ + " Order By "
	End If
	
	For nPos% = 1 To nCount% - 1
		sNewSQL$ = sNewSQL$ + sFields$( nPos% )
		If ( "ZA" = sAZ$( nPos% ) ) Then
			sNewSQL$ = sNewSQL$ + " Desc"
		End If
		sNewSQL$ = sNewSQL$ + ", "
	Next
	sNewSQL$ = sNewSQL$ + sFields$( nPos% )
	If ( "ZA" = sAZ$( nPos% ) ) Then
		sNewSQL$ = sNewSQL$ + " Desc"
	End If
	
	Call Form_Field_SetSQLStatement$( sNewSQL$ )
	DlgChgSQL.UnLoad()
	'	Set the unsave flag()
	Selection.Insert( " " )
	Selection.BackSpace()
End Sub

