'SBLLINK:MethodInfo=edfrm_LoadLanguage0
'SBLLINK:MethodInfo=addgrp_LoadLanguage0
'SBLLINK:MethodInfo=chgtab_LoadLanguage0
'SBLLINK:MethodInfo=chgsql_LoadLanguage0
Option Explicit

	Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4
	Const cLANGUAGE_DANISH = 1030, cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033
	Const cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036, cLANGUAGE_GERMAN = 1031
	Const cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
	Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_PORTUGUESE = 2070, cLANGUAGE_RUSSIAN = 1049
	Const cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053, cLANGUAGE_TURKISH = 1055

Sub edfrm_LoadLanguage()

	Select Case ( Application.LanguageID )

		Case cLANGUAGE_ENGLISH
			dbDlgEditForm_ErrorMsg$ = "An error has occured."
			dbDlgEditForm_ErrorMsgCaption$ = "An error occured while setting the alignment."
			dbDlgEditForm_ErrorMsgReadOnly$ = "An error occured while setting the read-only status."
			dbDlgEditForm_ErrorMsgFieldnames$ = "An error occured while setting the field names."

			dbDlgEditForm_Progress_Start$ = "Analyze fields"
			dbDlgEditForm_Dlg_Caption$ = "Edit Fields"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Top"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Left"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "None"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Mixed"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(No Alignment)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Existing fields"
			DlgChgGroup.lblDBFieldName.Caption = "Database column"
			DlgChgGroup.lblFieldDesc.Caption = "Caption"
			DlgChgGroup.chkFieldReadOnly.Caption = "Read-only"
			DlgChgGroup.lblCaption.Caption = "Alignment"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Cancel"

		Case cLANGUAGE_FRENCH
			dbDlgEditForm_ErrorMsg$ = "Une erreur est survenue."
			dbDlgEditForm_ErrorMsgCaption$ = "Une erreur est survenue lors de lalignement."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Une erreur est survenue lors de la protection."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Une erreur est survenue lors de la dtermination du nom de champ."

			dbDlgEditForm_Progress_Start$ = "Analyser champs"
			dbDlgEditForm_Dlg_Caption$ = "Modifier champs"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Haut"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Gauche"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Sans"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Divers"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Sans alignement)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Champs existants"
			DlgChgGroup.lblDBFieldName.Caption = "Colonne de base de donnes"
			DlgChgGroup.lblFieldDesc.Caption = "Description"
			DlgChgGroup.chkFieldReadOnly.Caption = "Protg"
			DlgChgGroup.lblCaption.Caption = "Alignement"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Annuler"

		Case cLANGUAGE_ITALIAN
			dbDlgEditForm_ErrorMsg$ = "Si  avuto un errore."
			dbDlgEditForm_ErrorMsgCaption$ = "Durante l'impostazione dell'allineamento si  avuto un errore."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Durante l'impostazione dello stato di sola lettura si  avuto un errore."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Durante l'impostazione del nome del campo si  avuto un errore."

			dbDlgEditForm_Progress_Start$ = "Analisi dei campi"
			dbDlgEditForm_Dlg_Caption$ = "Modifica dei campi"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "S"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Sinistra"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Senza"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Diversi"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(senza allineamento)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Campi presenti"
			DlgChgGroup.lblDBFieldName.Caption = "Colonna di database"
			DlgChgGroup.lblFieldDesc.Caption = "Descrizione"
			DlgChgGroup.chkFieldReadOnly.Caption = "A sola lettura"
			DlgChgGroup.lblCaption.Caption = "Allineamento"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Annulla"

		Case cLANGUAGE_SPANISH
			dbDlgEditForm_ErrorMsg$ = "Ha ocurrido un error."
			dbDlgEditForm_ErrorMsgCaption$ = "Ha ocurrido un error al configurar la alineacin."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Ha ocurrido un error al establecer la proteccin contra escritura."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Ha ocurrido un error al colocar el nombre del campo."

			dbDlgEditForm_Progress_Start$ = "Analizar campos"
			dbDlgEditForm_Dlg_Caption$ = "Editar campos"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Arriba"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Izquierda"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Sin"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Otros"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Sin alineacin)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Campos existentes"
			DlgChgGroup.lblDBFieldName.Caption = "Columna de la base de datos"
			DlgChgGroup.lblFieldDesc.Caption = "Descripcin"
			DlgChgGroup.chkFieldReadOnly.Caption = "Slo lectura"
			DlgChgGroup.lblCaption.Caption = "Alineacin"
			DlgChgGroup.cmdOk.Caption = "Aceptar"
			DlgChgGroup.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_PORTUGUESE
			dbDlgEditForm_ErrorMsg$ = "Surgiu um erro."
			dbDlgEditForm_ErrorMsgCaption$ = "Ao executar o alinhamento surgiu um erro."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Ao executar o status de s leitura surgiu um erro."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Ao executar os nomes de campo surgiu um erro."

			dbDlgEditForm_Progress_Start$ = "Analisar campos"
			dbDlgEditForm_Dlg_Caption$ = "Editar campos"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Em cima"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Esquerda"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Sem"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Vrios"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Sem alinhamento)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Campos existentes"
			DlgChgGroup.lblDBFieldName.Caption = "Coluna da base de dados"
			DlgChgGroup.lblFieldDesc.Caption = "Descrio"
			DlgChgGroup.chkFieldReadOnly.Caption = "S leitura"
			DlgChgGroup.lblCaption.Caption = "Alinhamento"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_DUTCH
			dbDlgEditForm_ErrorMsg$ = "Er is een fout opgetreden."
			dbDlgEditForm_ErrorMsgCaption$ = "Bij het positioneren is een fout opgetreden."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Bij het vastleggen van de schrijfbeveiligingsstatus is een fout opgetreden."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Bij het bepalen van de veldnaam is een fout opgetreden."

			dbDlgEditForm_Progress_Start$ = "Velden analyseren"
			dbDlgEditForm_Dlg_Caption$ = "Velden bewerken"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Boven"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Links"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Zonder"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Diverse"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Zonder positionering)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Voorhanden zijnde velden"
			DlgChgGroup.lblDBFieldName.Caption = "Databasekolom"
			DlgChgGroup.lblFieldDesc.Caption = "Beschrijving"
			DlgChgGroup.chkFieldReadOnly.Caption = "Schrijfbeveiligd"
			DlgChgGroup.lblCaption.Caption = "Positionering"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Annuleren"

		Case cLANGUAGE_SWEDISH
			dbDlgEditForm_ErrorMsg$ = "Ett fel har uppsttt."
			dbDlgEditForm_ErrorMsgCaption$ = "Vid tilldelningen av justeringen har ett fel uppsttt."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Vid tilldelningen av skrivskyddsstatus har ett fel uppsttt."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Vid tilldelningen av fltnamn har ett fel uppsttt."

			dbDlgEditForm_Progress_Start$ = "Analysera flt"
			dbDlgEditForm_Dlg_Caption$ = "Bearbeta flt"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Uppe"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Vnster"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Utan"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Diverse"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Utan justering)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Existerande flt"
			DlgChgGroup.lblDBFieldName.Caption = "Databaskolumn"
			DlgChgGroup.lblFieldDesc.Caption = "Beskrivning"
			DlgChgGroup.chkFieldReadOnly.Caption = "Skrivskyddad"
			DlgChgGroup.lblCaption.Caption = "Justering"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Avbryt"

		' GERMAN and fallback/default
		Case Else
			dbDlgEditForm_ErrorMsg$ = "Es ist ein Fehler aufgetreten."
			dbDlgEditForm_ErrorMsgCaption$ = "Beim Setzen der Ausrichtung ist ein Fehler aufgetreten."
			dbDlgEditForm_ErrorMsgReadOnly$ = "Beim Setzen des Schreibschutzstatus ist ein Fehler aufgetreten."
			dbDlgEditForm_ErrorMsgFieldnames$ = "Beim Setzen der Feldnamen ist ein Fehler aufgetreten."

			dbDlgEditForm_Progress_Start$ = "Felder analysieren"
			dbDlgEditForm_Dlg_Caption$ = "Felder bearbeiten"

			dbDlgEditForm_Dlg_cmbCaption_Txt_Top$ = "Oben"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Left$ = "Links"
			dbDlgEditForm_Dlg_cmbCaption_Txt_None$ = "Ohne"
			dbDlgEditForm_Dlg_cmbCaption_Txt_Mixed$ = "Diverse"

			dbDlgEditForm_Dlg_GroupsAvailable_NoName$ = "(Ohne Ausrichtung)"

			DlgChgGroup.Load()
			DlgChgGroup.Caption = dbDlgEditForm_Dlg_Caption$
			DlgChgGroup.lblGroupsAvail.Caption = "Vorhandene Felder"
			DlgChgGroup.lblDBFieldName.Caption = "Datenbankspalte"
			DlgChgGroup.lblFieldDesc.Caption = "Beschreibung"
			DlgChgGroup.chkFieldReadOnly.Caption = "Schreibgeschtzt"
			DlgChgGroup.lblCaption.Caption = "Ausrichtung"
			DlgChgGroup.cmdOk.Caption = "OK"
			DlgChgGroup.cmdCancel.Caption = "Abbrechen"
	End Select

End Sub

Sub addgrp_LoadLanguage()

	Select Case ( Application.LanguageID )

		Case cLANGUAGE_ENGLISH
			dbDlgAddGroup_MainName$ = "Insert Field"
			dbDlgAddGroup_ProgressStart$ = "Analyze Fields"

			dbDlgAddGroup_Error$ = "An error has occured."
			dbDlgAddGroup_ErrorCannotStart$ = "Fields cannot be inserted into a form based on a query."
			dbDlgAddGroup_ErrorTitleExist$ = "This caption already exisits. Please choose another."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Top"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Left"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "None"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = dbDlgAddGroup_MainName$
			DlgAddGroup.frmAttr.Caption = "Attributes"
			DlgAddGroup.lblFieldDesc.Caption = "Caption"
			DlgAddGroup.lblDBFieldName.Caption = "Database column"
			DlgAddGroup.lblCaption.Caption = "Alignment"
			DlgAddGroup.chkFieldReadOnly.Caption = "Read-only"
			DlgAddGroup.cmdInsert.Caption = "Insert"
			DlgAddGroup.cmdCancel.Caption = "Close"

		Case cLANGUAGE_FRENCH
			dbDlgAddGroup_MainName$ = "Insrer champ"
			dbDlgAddGroup_ProgressStart$ = "Analyser champs"

			dbDlgAddGroup_Error$ = "Une erreur est survenue."
			dbDlgAddGroup_ErrorCannotStart$ = "Un champ ne peut tre insr dans un formulaire provenant dune requte."
			dbDlgAddGroup_ErrorTitleExist$ = "Cette description existe dj. Veuillez choisir une autre description."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Haut"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Gauche"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Sans"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Insrer champ"
			DlgAddGroup.frmAttr.Caption = "Attributs"
			DlgAddGroup.lblFieldDesc.Caption = "Description"
			DlgAddGroup.lblDBFieldName.Caption = "Colonne de base de donnes"
			DlgAddGroup.lblCaption.Caption = "Alignement"
			DlgAddGroup.chkFieldReadOnly.Caption = "Protg"
			DlgAddGroup.cmdInsert.Caption = "Insrer"
			DlgAddGroup.cmdCancel.Caption = "Fermer"

		Case cLANGUAGE_ITALIAN
			dbDlgAddGroup_MainName$ = "Inserisci campo"
			dbDlgAddGroup_ProgressStart$ = "Analizza campi"

			dbDlgAddGroup_Error$ = "Si  avuto un errore."
			dbDlgAddGroup_ErrorCannotStart$ = "Ad una maschera basata su una query non si pu aggiungere un campo."
			dbDlgAddGroup_ErrorTitleExist$ = "La descrizione esiste gi. Scegliere un'altra"

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "S"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Sinistra"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Senza"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Inserisci campo"
			DlgAddGroup.frmAttr.Caption = "Attributi"
			DlgAddGroup.lblFieldDesc.Caption = "Descrizione"
			DlgAddGroup.lblDBFieldName.Caption = "Colonna del database"
			DlgAddGroup.lblCaption.Caption = "Allineamento"
			DlgAddGroup.chkFieldReadOnly.Caption = "A sola lettura"
			DlgAddGroup.cmdInsert.Caption = "Inserisci"
			DlgAddGroup.cmdCancel.Caption = "Chiudi"

		Case cLANGUAGE_SPANISH
			dbDlgAddGroup_MainName$ = "Insertar campo"
			dbDlgAddGroup_ProgressStart$ = "Analizar campo"

			dbDlgAddGroup_Error$ = "Ha ocurrido un error."
			dbDlgAddGroup_ErrorCannotStart$ = "No se puede agregar campos a un formulario creado a partir de una consulta."
			dbDlgAddGroup_ErrorTitleExist$ = "Ya existe esta descripcin. Por favor seleccione otra."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Arriba"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Izquierda"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Sin"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Insertar campo"
			DlgAddGroup.frmAttr.Caption = "Atributos"
			DlgAddGroup.lblFieldDesc.Caption = "Descripcin"
			DlgAddGroup.lblDBFieldName.Caption = "Columna de la base de datos"
			DlgAddGroup.lblCaption.Caption = "Alineacin"
			DlgAddGroup.chkFieldReadOnly.Caption = "Slo lectura"
			DlgAddGroup.cmdInsert.Caption = "Insertar"
			DlgAddGroup.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_PORTUGUESE
			dbDlgAddGroup_MainName$ = "Inserir campo"
			dbDlgAddGroup_ProgressStart$ = "Analisar campos"

			dbDlgAddGroup_Error$ = "Surgiu um erro."
			dbDlgAddGroup_ErrorCannotStart$ = "Impossvel adicionar um campo a um formulrio que tem por base uma consulta."
			dbDlgAddGroup_ErrorTitleExist$ = "A descrio j existe. Escolha outra, por favor."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Em cima"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Esquerda"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Sem"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Inserir campo"
			DlgAddGroup.frmAttr.Caption = "Atributos"
			DlgAddGroup.lblFieldDesc.Caption = "Descrio"
			DlgAddGroup.lblDBFieldName.Caption = "Coluna da base de dados"
			DlgAddGroup.lblCaption.Caption = "Alinhamento"
			DlgAddGroup.chkFieldReadOnly.Caption = "S leitura"
			DlgAddGroup.cmdInsert.Caption = "Inserir"
			DlgAddGroup.cmdCancel.Caption = "Cerrar"

		Case cLANGUAGE_DUTCH
			dbDlgAddGroup_MainName$ = "Veld invoegen"
			dbDlgAddGroup_ProgressStart$ = "Velden analyseren"

			dbDlgAddGroup_Error$ = "Er is een fout opgetreden."
			dbDlgAddGroup_ErrorCannotStart$ = "Aan een formulier dat berust op een query kan geen veld worden toegevoegd."
			dbDlgAddGroup_ErrorTitleExist$ = "Deze beschrijving bestaat reeds. Kies een andere beschrijving."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Boven"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Links"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Zonder"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Veld invoegen"
			DlgAddGroup.frmAttr.Caption = "Attributen"
			DlgAddGroup.lblFieldDesc.Caption = "Beschrijving"
			DlgAddGroup.lblDBFieldName.Caption = "Databasekolom"
			DlgAddGroup.lblCaption.Caption = "Positionering"
			DlgAddGroup.chkFieldReadOnly.Caption = "Schrijfbeveiligd"
			DlgAddGroup.cmdInsert.Caption = "Invoegen"
			DlgAddGroup.cmdCancel.Caption = "Sluiten"

		Case cLANGUAGE_SWEDISH
			dbDlgAddGroup_MainName$ = "Infoga flt"
			dbDlgAddGroup_ProgressStart$ = "Analysera flt"

			dbDlgAddGroup_Error$ = "Ett fel har uppsttt."
			dbDlgAddGroup_ErrorCannotStart$ = "Ett formulr som bygger p en query kan inte tillfras ngot flt."
			dbDlgAddGroup_ErrorTitleExist$ = "Beskrivningen existerar redan. Var snll och vlj en annan beskrivning."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Uppe"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Vnster"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Utan"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Infoga flt"
			DlgAddGroup.frmAttr.Caption = "Attribut"
			DlgAddGroup.lblFieldDesc.Caption = "Beskrivning"
			DlgAddGroup.lblDBFieldName.Caption = "Databaskolumn"
			DlgAddGroup.lblCaption.Caption = "Justering"
			DlgAddGroup.chkFieldReadOnly.Caption = "Skrivskyddad"
			DlgAddGroup.cmdInsert.Caption = "Infoga"
			DlgAddGroup.cmdCancel.Caption = "Stnga"

		' GERMAN and fallback/default
		Case Else
			dbDlgAddGroup_MainName$ = "Feld einfgen"
			dbDlgAddGroup_ProgressStart$ = "Felder analysieren"

			dbDlgAddGroup_Error$ = "Es ist ein Fehler aufgetreten."
			dbDlgAddGroup_ErrorCannotStart$ = "Einem Formular, das auf einer Abfrage aufbaut, kann kein Feld hinzugefgt werden."
			dbDlgAddGroup_ErrorTitleExist$ = "Die Beschreibung existiert bereits. Bitte whlen Sie eine andere Beschreibung."

			dbDlgAddGroup_Dlg_cmbCaption_Txt_Top$ = "Oben"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_Left$ = "Links"
			dbDlgAddGroup_Dlg_cmbCaption_Txt_None$ = "Ohne"

			DlgAddGroup.Load()
			DlgAddGroup.Caption = "Feld einfgen"
			DlgAddGroup.frmAttr.Caption = "Attribute"
			DlgAddGroup.lblFieldDesc.Caption = "Beschreibung"
			DlgAddGroup.lblDBFieldName.Caption = "Datenbankspalte"
			DlgAddGroup.lblCaption.Caption = "Ausrichtung"
			DlgAddGroup.chkFieldReadOnly.Caption = "Schreibgeschtzt"
			DlgAddGroup.cmdInsert.Caption = "Einfgen"
			DlgAddGroup.cmdCancel.Caption = "Schlieen"

	End Select

End Sub

Sub chgtab_LoadLanguage()

	Select Case ( Application.LanguageID )

		Case cLANGUAGE_ENGLISH
			dbChgTabindex_MainName$ = "Edit Field Order"
			dbChgTabindex_Error$ = "An error has occured."
			dbChgTabindex_CannotStart$ = "There are not enough fields to define a new field sequence."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Existing fields"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Cancel"

		Case cLANGUAGE_FRENCH
			dbChgTabindex_MainName$ = "Modifier lordre des champs"
			dbChgTabindex_Error$ = "Une erreur est survenue."
			dbChgTabindex_CannotStart$ = "Le nombre de champs nest pas suffisant pour dterminer un nouvel ordre."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = "Modifier lordre des champs" 
			DlgChgTabindex.frmAvailFields.Caption = "Champs existants"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Annuler"

		Case cLANGUAGE_ITALIAN
			dbChgTabindex_MainName$ = "Modifica l'ordine dei campi"
			dbChgTabindex_Error$ = "Si  avuto un errore."
			dbChgTabindex_CannotStart$ = "Non ci sono abbastanza campi per stabilire un nuovo ordine"

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Campi presenti"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Annulla"

		Case cLANGUAGE_SPANISH
			dbChgTabindex_MainName$ = "Editar orden de los campos"
			dbChgTabindex_Error$ = "Ha ocurrido un error."
			dbChgTabindex_CannotStart$ = "No hay suficientes campos para determinar un nuevo orden."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Campos existentes"
			DlgChgTabindex.cmdOK.Caption = "Aceptar"
			DlgChgTabindex.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_PORTUGUESE
			dbChgTabindex_MainName$ = "Editar sequncia de campos"
			dbChgTabindex_Error$ = "Surgiu um erro."
			dbChgTabindex_CannotStart$ = "No existem campos suficientes para definir uma nova sequncia."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Campos existentes"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_DUTCH
			dbChgTabindex_MainName$ = "Veldvolgorde bewerken"
			dbChgTabindex_Error$ = "Er is een fout opgetreden."
			dbChgTabindex_CannotStart$ = "Er zijn niet voldoende velden voorhanden om een nieuwe volgorde te bepalen."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Voorhanden zijnde velden"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Abbrechen"

		Case cLANGUAGE_SWEDISH
			dbChgTabindex_MainName$ = "Bearbeta ordingsfljden av flt"
			dbChgTabindex_Error$ = "Ett fel har uppsttt."
			dbChgTabindex_CannotStart$ = "Det existerar inte tillrckligt med flt fr att kunna bestmma en ny ordningsfljd."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Existerande flt"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Avbryt"

		' GERMAN and fallback/default
		Case Else
			dbChgTabindex_MainName$ = "Feldreihenfolge bearbeiten"
			dbChgTabindex_Error$ = "Es ist ein Fehler aufgetreten."
			dbChgTabindex_CannotStart$ = "Es sind nicht genug Felder vorhanden um eine neue Reihenfolge zu bestimmen."

			DlgChgTabindex.Load()
			DlgChgTabindex.Caption = dbChgTabindex_MainName$
			DlgChgTabindex.frmAvailFields.Caption = "Vorhandene Felder"
			DlgChgTabindex.cmdOK.Caption = "OK"
			DlgChgTabindex.cmdCancel.Caption = "Abbrechen"

	End Select

End Sub

Sub chgsql_LoadLanguage()

	Select Case ( Application.LanguageID )

		Case cLANGUAGE_ENGLISH
			dbChgSQL_MainName$ = "Edit Sort Order"
			dbChgSQL_Error$ = "An error has occured."
			dbChgSQL_ErrorCannotStart$ = "A sort order cannot be assigned to a form based on a query."
			dbChgSQL_ErrorCannotTableOrQuery$ = "No tables or queries could be opened."

			dbChgSQL_DLG_NoFieldSelected$ = "(None)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Sort order"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Cancel"

		Case cLANGUAGE_FRENCH
			dbChgSQL_MainName$ = "Modifier tri"
			dbChgSQL_Error$ = "Une erreur est survenue."
			dbChgSQL_ErrorCannotStart$ = "Un tri ne peut tre insr dans un formulaire provenant dune requte."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Aucune table ni requte na pu tre ouverte."

			dbChgSQL_DLG_NoFieldSelected$ = "(aucun)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Tri"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Annuler"

		Case cLANGUAGE_ITALIAN
			dbChgSQL_MainName$ = "Modifica ordine"
			dbChgSQL_Error$ = "Si  avuto un errore."
			dbChgSQL_ErrorCannotStart$ = "Ad una maschera basata su una query non si pu aggiungere un ordinamento."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Non  stato possibile aprire alcune tabella o query."

			dbChgSQL_DLG_NoFieldSelected$ = "(senza)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Ordine"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Annulla"

		Case cLANGUAGE_SPANISH
			dbChgSQL_MainName$ = "Editar orden"
			dbChgSQL_Error$ = "Ha ocurrido un error."
			dbChgSQL_ErrorCannotStart$ = "No se puede agregar un orden a un formulario basado en una consulta."
			dbChgSQL_ErrorCannotTableOrQuery$ = "No se pudo abrir ninguna tabla o consulta."

			dbChgSQL_DLG_NoFieldSelected$ = "(ninguno)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Ordenar"
			DlgChgSQL.cmdReady.Caption = "Aceptar"
			DlgChgSQL.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_PORTUGUESE

			dbChgSQL_MainName$ = "Editar classificao"
			dbChgSQL_Error$ = "Surgiu um erro."
			dbChgSQL_ErrorCannotStart$ = "Impossvel adicionar classificao a um formulrio que tem por base uma consulta."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Foi impossvel abrir tabela ou consulta."

			dbChgSQL_DLG_NoFieldSelected$ = "(nenhum)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Classificao"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Cancelar"

		Case cLANGUAGE_DUTCH
			dbChgSQL_MainName$ = "Sorterung bewerken"
			dbChgSQL_Error$ = "Er is een fout opgetreden."
			dbChgSQL_ErrorCannotStart$ = "Aan een formulier dat gebaseerd is op een query kan geen sortering worden toegevoegd."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Er kon geen tabel of query worden geopend."

			dbChgSQL_DLG_NoFieldSelected$ = "(geen)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Sortering"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Annuleren"

		Case cLANGUAGE_SWEDISH
			dbChgSQL_MainName$ = "Bearbeta sortering"
			dbChgSQL_Error$ = "Ett fel har uppsttt."
			dbChgSQL_ErrorCannotStart$ = "Ett formulr som bygger p en query kan inte tillfras ngon sortering."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Ingen tabell eller query kunde ppnas."

			dbChgSQL_DLG_NoFieldSelected$ = "(ingen)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Sortering"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Avbryt"

		' GERMAN and fallback/default
		Case Else
			dbChgSQL_MainName$ = "Sortierung bearbeiten"
			dbChgSQL_Error$ = "Es ist ein Fehler aufgetreten."
			dbChgSQL_ErrorCannotStart$ = "Einem Formular, das auf einer Abfrage aufbaut, kann keine Sortierung hinzugefgt werden."
			dbChgSQL_ErrorCannotTableOrQuery$ = "Es konnte keine Tabelle oder Abfrage geffnet werden."

			dbChgSQL_DLG_NoFieldSelected$ = "(kein)"

			DlgChgSQL.Load()
			DlgChgSQL.Caption = dbChgSQL_MainName$
			DlgChgSQL.frmSort.Caption = "Sortierung"
			DlgChgSQL.cmdReady.Caption = "OK"
			DlgChgSQL.cmdCancel.Caption = "Abbrechen"
	End Select

End Sub

