'SBLLINK:MethodInfo=Step10
'SBLLINK:MethodInfo=Step20
'SBLLINK:MethodInfo=Step30
'SBLLINK:MethodInfo=Step40
'SBLLINK:MethodInfo=Step50
'SBLLINK:MethodInfo=Step60
'SBLLINK:MethodInfo=Step70
'SBLLINK:MethodInfo=Step80
'SBLLINK:MethodInfo=Step90
'SBLLINK:MethodInfo=Step100
'SBLLINK:MethodInfo=Step110
'SBLLINK:MethodInfo=SetGoOnEnable0
'These Subs evaluate the data of the steps on which the
'Next button is being pressed
'Step1 refers to what happens when the user clicks on 'Next' on the first page
'Step2 refers to what happens when the user clicks on 'Next' on the second page, and so on...

Option Explicit

Function Step1
	If Not bServiceInit Then
		gService = createUNOService("com.sun.star.installation.InternetSettings")
	End If

	Step1 = readAll()
    If Step1 <> 2 Then
		s2OptFull.Value = False
		s2OptPart.Value = True
	End If
	Dialog.PreviousStep.Enabled = True
	Dialog.PreviousStep.Visible = True
	Dialog.Cancel.Enabled = True
	Dialog.Cancel.Visible = True

End Function


Function Step2
	If Dialog.s2OptFull.Value = True Then
		createOverview()
		Step2 = 11
	Else
		If not readBrowser() Then
			Dialog.s3OptImport.Enabled = False
			If Dialog.s3OptImport.Value = True Then Dialog.s3OptManual.Value = True
		End If
		Step2 = 3
	End If
End Function


Function Step3
	If Dialog.s3OptManual.Value = True Then
		'browser Settings manually
		Step3 = 4
	Else
		If not readMail() Then
			Dialog.s5OptImport.Enabled = False
			If Dialog.s5OptImport.Value = True Then Dialog.s5OptManual.Value = True
		End If
		step3 = 5
	End If

End Function


Function Step4
	If not readMail() Then
		Dialog.s5OptImport.Enabled = False
		If Dialog.s5OptImport.Value Then Dialog.s5OptManual.Value = True
	End If
	Step4 = 5

End Function


Function Step5
	If Dialog.s5OptManual.Value = True Then
		Step5 = 6
		SetGoOnEnable
	Else
		If not readNews() Then
			Dialog.s8OptImport.Enabled = False
			If Dialog.s8OptImport.Value = True Then Dialog.s8OptManual.Value = True
		End If
		If Dialog.s5OptImport.Value = True Then
			If readMailUsers(Dialog.s5ListApps.List(Dialog.s5ListApps.ListIndex)) Then
				step5 = 7
			Else
				step5 = 8
			End If
		Else
			step5 = 8
		End If
	End If
	gMailUser = ""
End Function


Function Step6
	If not readNews() Then
		Dialog.s8OptImport.Enabled = False
		If Dialog.s8OptImport.Value = True Then Dialog.s8OptManual.Value = True
	End If
	Step6 = 8

End Function


Function Step7
	If not readNews() Then
		Dialog.s8OptImport.Enabled = False
		If Dialog.s8OptImport.Value = True Then Dialog.s8OptManual.Value = True
	End If
	Step7 = 8
	gMailUser = Dialog.s7ListUsers.List(Dialog.s7ListUsers.ListIndex)
End Function


Function Step8
	If Dialog.s8OptManual.Value = True Then
		Step8 = 9
		SetGoOnEnable()
	Else
		If Dialog.s8OptImport.Value = True Then
			If readNewsUsers(Dialog.s8ListApps.List(Dialog.s8ListApps.ListIndex)) Then
				step8 = 10
			Else
				createOverview()
				step8 = 11
			End If
		Else
			createOverview()
			step8 = 11
		End If
	End If
	gNewsUser = ""
End Function


Function Step9
	createOverview()
	Step9 = 11
End Function


Function Step10
	gNewsUser = Dialog.s10ListUsers.List(Dialog.s10ListUsers.ListIndex)
	createOverview()
	Step10 = 11
End Function


Function Step11
	Application.EnterWait
	Dialog.CurrentStep = 12
	Dialog.PreviousStep.Enabled = False
	Dialog.NextStep.Enabled = False
	Dialog.PreviousStep.Visible = False
	Dialog.NextStep.Visible = False

	Dialog.s12OK.Enabled = False
	If bOutLookSelected Then
		Dialog.S12Text3.Visible = False
	Else
		Dialog.S12Text3.Visible = True
	End If

	setupInternetData()
	Dialog.s12OK.Enabled = True
	Dialog.s12Text2.Visible = False
	Step11 = 12
	Application.LeaveWait
End Function




Sub SetGoOnEnable
	Select Case Dialog.CurrentStep
		Case 5,6
			If (Dialog.s6TxtAccount.Text = "") OR (Dialog.s6TxtReceive.Text = "") OR(Dialog.s6TxtSend.Text = "")_
				OR(Dialog.s6TxtUser.Text = "") Then
				Dialog.NextStep.Enabled = False
			Else
				Dialog.NextStep.Enabled = True
			End If
		Case 8,9
			If (Dialog.s9TxtAccount.Text = "") OR (Dialog.s9TxtServer.Text = "") Then
				Dialog.NextStep.Enabled = False
			Else
				Dialog.NextStep.Enabled = True
			End if
	End Select
End Sub

