'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=nLoadLanguage0
'SBLLINK:MethodInfo=GetLanguageCode0
Option Explicit

Sub Main
	Call Start()
End Sub

Const MAXLANG = 8
Global Const MAXFIELDS = 15

'Laguages
Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4
Const cLANGUAGE_DANISH = 1030, cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033
Const cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036, cLANGUAGE_GERMAN = 1031
Const cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_PORTUGUESE = 2070, cLANGUAGE_RUSSIAN = 1049
Const cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053, cLANGUAGE_TURKISH = 1055

Dim UserFieldNames$ (MAXLANG, MAXFIELDS)
Dim Dlg3_NoField(MAXLANG)
Dim	LetElementBox1 (MAXLANG)
Dim LetElementBox2 (MAXLANG)
Dim LetElementBox3 (MAXLANG)
Dim LetElementBox4 (MAXLANG)
Dim WarnDeleteFields (MAXLANG)
Dim Form_gProgressText$ (MAXLANG)
Dim TitleChangeTable (MAXLANG)
Dim TitleChangeDB (MAXLANG)
Dim TitleLetterWizard (MAXLANG)
Dim TitleLetterWizardPage (MAXLANG)
Dim	Dlg11_NoTitle(MAXLANG)
Dim Dlg11_NoSubject(MAXLANG)
Dim	PageNumFieldHi_ABC(MAXLANG)
Dim	PageNumFieldLo_ABC(MAXLANG)
Dim	PageNumFieldHi_ROM(MAXLANG)
Dim	PageNumFieldLo_ROM(MAXLANG)
Dim	PageNumFieldArabisch(MAXLANG)
Dim	GraphicDlg(MAXLANG)
Dim NoGraphic(MAXLANG)
Dim NoDBInstalled (MAXLANG)
Dim FileDialogAutomName(MAXLANG)

Function nLoadLanguage% ( ByVal nLanguage% )

	Dim nSelLang%
	
	Select Case ( nLanguage% )
	
'		Case cLANGUAGE_ENGLISH
'		Case cLANGUAGE_FRENCH
'		Case cLANGUAGE_ITALIAN
'		Case cLANGUAGE_SPANISH
'		Case cLANGUAGE_PORTUGUESE
'		Case cLANGUAGE_DUTCH
		Case Else
			nSelLang% = 0
			
			UserFieldNames(nSelLang%, 0) = "Firma"
			UserFieldNames(nSelLang%, 1) = "Vorname"
			UserFieldNames(nSelLang%, 2) = "Name"
			UserFieldNames(nSelLang%, 3) = "Krzel"
			UserFieldNames(nSelLang%, 4) = "Strae"
			UserFieldNames(nSelLang%, 5) = "Land"
			UserFieldNames(nSelLang%, 6) = "PLZ"
			UserFieldNames(nSelLang%, 7) = "Ort"
			UserFieldNames(nSelLang%, 8) = "Titel"
			UserFieldNames(nSelLang%, 9) = "Position"
			UserFieldNames(nSelLang%, 10) = "Telefon Privat"
			UserFieldNames(nSelLang%, 11) = "Telefon Geschft"
			UserFieldNames(nSelLang%, 12) = "FAX"
			UserFieldNames(nSelLang%, 13) = "E-Mail"
			UserFieldNames(nSelLang%, 14) = "Staat"
			
			Dlg3_NoField(nSelLang%) = "kein Feld"
			
			LetElementBox1 (nSelLang%) = "Ihr Zeichen"
			LetElementBox2 (nSelLang%) = "Unser Zeichen"
			LetElementBox3 (nSelLang%) = "Ihr Schreiben"
			LetElementBox4 (nSelLang%) = "Unser Schreiben"
			
			WarnDeleteFields (nSelLang%) = "Alle Felder werden bei dem Vorgang gelscht! Soll der Vorgang fortgesetzt werden?"
			TitleChangeTable (nSelLang%) = "Tabellenauswahl"
			TitleChangeDB (nSelLang%) = "Datenbankauswahl"
			TitleLetterWizard (nSelLang%) = "Brief-Autopilot"
			TitleLetterWizardPage (nSelLang%) = "Seite"
			NoDBInstalled (nSelLang%) = "Es ist keine Datenbank installiert"
			Form_gProgressText (nSelLang%) = "Vorlage erzeugen"
			
			Dlg11_NoTitle(nSelLang%) = "kein"
			Dlg11_NoSubject(nSelLang%) = "keins"
			
			PageNumFieldHi_ABC(nSelLang%) = "A B C"
			PageNumFieldLo_ABC(nSelLang%) = "a b c"
			PageNumFieldHi_ROM(nSelLang%) = "Rmisch (I, II, III)"
			PageNumFieldLo_ROM(nSelLang%) = "Rmisch (i, ii, iii)"
			PageNumFieldArabisch(nSelLang%) = "Arabisch (1, 2, 3)"
			'PageNumFieldStandard(nSelLang%) = "Seitenvorlage"
			GraphicDlg (nSelLang%) = "Auswahl des Logos"
			NoGraphic (nSelLang%) = "keine Grafik ausgewhlt"
			FileDialogAutomName (nSelLang%) = "Pfad auswhlen"
	End Select
	
	nLoadLanguage% = nSelLang%

End Function

Function GetLanguageCode ( nLanguage as integer ) as Integer
	Dim nLanguageCode as integer
	Select Case ( nLanguage )
'		Case cLANGUAGE_ENGLISH
'		Case cLANGUAGE_FRENCH
'		Case cLANGUAGE_ITALIAN
'		Case cLANGUAGE_SPANISH
'		Case cLANGUAGE_PORTUGUESE
'		Case cLANGUAGE_DUTCH
		Case Else
			nLanguageCode = 49
		End Select
	GetLanguageCode = nLanguageCode
end Function