'SBLLINK:MethodInfo=IniPreviewBitmapPath0
'SBLLINK:MethodInfo=IniDefaultPreviewGrafik0
'SBLLINK:MethodInfo=GetPreviewGrafikByName0
'SBLLINK:MethodInfo=AddPreviewGrafik0
'SBLLINK:MethodInfo=CreateGraphicObject0
'SBLLINK:MethodInfo=InsertGraphicObject0
'SBLLINK:MethodInfo=ReplacePreviewGrafik0
'SBLLINK:MethodInfo=DelPreviewGrafikByName0
'SBLLINK:MethodInfo=DelPreviewAllMainGrafiks0
'SBLLINK:MethodInfo=DelPreviewAllFollowGrafiks0
'SBLLINK:MethodInfo=GetRelativePos0
'SBLLINK:MethodInfo=IniAllMainGrafiks0
'SBLLINK:MethodInfo=IniAllFollowGrafiks0
'SBLLINK:MethodInfo=ChangeToMainPreview0
'SBLLINK:MethodInfo=ChangeToFollowPreview0
'SBLLINK:MethodInfo=SetMainRecipientPreview0
'SBLLINK:MethodInfo=ReplMainRecipientPreview0
'SBLLINK:MethodInfo=SetMainTextPreview0
'SBLLINK:MethodInfo=ReplMainTextPreview0
'SBLLINK:MethodInfo=SetReferLinePreview0
'SBLLINK:MethodInfo=SetReferencePreview0
'SBLLINK:MethodInfo=ReplReferencePreview0
'SBLLINK:MethodInfo=SetMainSenderPreview0
'SBLLINK:MethodInfo=SetMainLogoPreview0
'SBLLINK:MethodInfo=SetFollowSenderPreview0
'SBLLINK:MethodInfo=SetFollowLogoPreview0
'SBLLINK:MethodInfo=SetFollowTextPreview0
'SBLLINK:MethodInfo=ReplFollowTextPreview0
REM  *****   BASIC  *****
Global sPreviewBitmapPath as String
Global aDefaultPreviewGrafik as Object
Global bPreviewMainPage as Boolean

const cDefaultGrafik = "Grafik1"
const cLeftPreviewMargin = 550
const cTopPreviewJustify = -300

const cRecipient_x = cLeftPreviewMargin, cRecipient_y = 1050, cRecipientFileName_WithAbs = "empf01.bmp"
const cRecipientFileName_WithoutAbs = "empf02.bmp", cRecipientName = "PrevRecipient"

const cMainText_x = cLeftPreviewMargin, cMainText_y = 2300, cMainTextFileName0 = "text00.bmp"
const cMainTextFileName1 = "text01.bmp", cMainTextFileName2 = "text02.bmp"
const cMainTextFileName3 = "text03.bmp", cMainTextFileName4 = "text04.bmp", cMainTextName = "PrevMainText"

const cReferLine_x = cLeftPreviewMargin, cReferLine_y = 2100, cReferLineFileName = "btr01.bmp", cReferLineName = "ReferLine"

const cReference_x = cLeftPreviewMargin, cReference_y = 1850, cReferenceFileName0 = "ref00.bmp"
const cReferenceFileName1 = "ref01.bmp",cReferenceFileName2 = "ref02.bmp",cReferenceFileName3 = "ref03.bmp"
const cReferenceName = "Reference"

const cMainSender_x1 = cLeftPreviewMargin, cMainSender_y1 = 500
const cMainSender_x2 = 1510, cMainSender_y2 = 500
const cMainSender_x3 = 2450, cMainSender_y3 = 500
const cMainSender_x4 = 2450, cMainSender_y4 = cRecipient_y+100
const cMainSenderFileName = "ffabs01.bmp", cMainSenderName = "MainSender"

const cMainLogo_x1 = cLeftPreviewMargin, cMainLogo_y1 = 500
const cMainLogo_x2 = 1380, cMainLogo_y2 = 500
const cMainLogo_x3 = 2220, cMainLogo_y3 = 500
const cMainLogo_x4 = 2220, cMainLogo_y4 = cRecipient_y+100
const cMainLogoFileName1 = "logogrf1.bmp", cMainLogoFileName2 = "logotxt1.bmp", cMainLogoName = "MainLogo"

const cFollowText_x = cLeftPreviewMargin, cFollowText_y = 850, cFollowTextFileName0 = "fftxt00.bmp"
const cFollowTextFileName1 = "fftxt01.bmp", cFollowTextFileName2 = "fftxt02.bmp"
const cFollowTextFileName3 = "fftxt03.bmp", cFollowTextFileName4 = "fftxt04.bmp", cFollowTextName = "PrevFollowText"

const cFollowSender_x1 = cLeftPreviewMargin, cFollowSender_y1 = 400
const cFollowSender_x2 = 1510, cFollowSender_y2 = 400
const cFollowSender_x3 = 2450, cFollowSender_y3 = 400
const cFollowSenderFileName = "ffabs01.bmp", cFollowSenderName = "FollowSender"

const cFollowLogo_x1 = cLeftPreviewMargin, cFollowLogo_y1 = 500
const cFollowLogo_x2 = 1510, cFollowLogo_y2 = 500
const cFollowLogo_x3 = 2450, cFollowLogo_y3 = 500
const cFollowLogoFileName1 = "fflggrf01.bmp", cFollowLogoFileName2 = "fflgtxt01.bmp", cFollowLogoName = "FollowLogo"

Sub IniPreviewBitmapPath
	sPreviewBitmapPath = sTemplatePath$ + "bitmap" + GetPathSeparator()
end Sub

Sub IniDefaultPreviewGrafik (aDoc as Object)
	aDefaultPreviewGrafik = GetPreviewGrafikByName (cDefaultGrafik, aDoc)
end Sub

Function GetPreviewGrafikByName (sName as String, aDoc as Object) as Object
	GetPreviewGrafikByName = aDoc.GraphicObjects.GetByName (sName)
end Function

Function AddPreviewGrafik (sFileName, sName as String, aPos, aDoc as Object) as Object
	Dim aGrafikDesc, aGraphic as Object
	aGraphic = CreateGraphicObject (sPreviewBitmapPath+sFileName, aDoc)
	aGraphic.HoriOrientPosition = aPos.x
	aGraphic.VertOrientPosition = aPos.y
	InsertGraphicObject (aGraphic, aDoc)
	aGraphic.Name = sName
	AddPreviewGrafikByName = aGraphic
end Function

Function CreateGraphicObject (sFileName as String, aDoc as Object) as Object
	Dim aGraphic as Object
	aGraphic = aDoc.CreateInstance (cUnoTextGraphic)
	aGraphic.GraphicURL = sFileName
	CreateGraphicObject = aGraphic
end Function

Sub InsertGraphicObject (aGraphic, aDoc as Object)
	Dim aCursor as Object
	aCursor = aDoc.Text.CreateTextCursor
	aCursor.Text.InsertTextContent (aCursor, aGraphic, True)
end Sub

Function ReplacePreviewGrafik (sFileName, sName as String, aDoc as Object) as Object
	Dim aGrafik, aPos as Object
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aGrafik = GetPreviewGrafikByName (sName, aDoc)
	'Das Property HyperLinkName kann anscheined nur gelesen werden!

	aPos.x = aGrafik.HoriOrientPosition
	aPos.y = aGrafik.VertOrientPosition
	DelPreviewGrafikByName (sName, aDoc)
	aGrafik = AddPreviewGrafik (sFileName, sName, aPos, aDoc)

	ReplacePreviewGrafik = aGrafik
end Function

Sub DelPreviewGrafikByName (sName as String, aDoc as Object)
	if aDoc.GraphicObjects.HasByName (sName) then
		aDoc.GraphicObjects.GetByName (sName).Dispose
	end If	
end Sub

Sub DelPreviewAllMainGrafiks (aDoc as Object)
	DelPreviewGrafikByName (cRecipientName, aDoc)
	DelPreviewGrafikByName (cMainTextName, aDoc)
	DelPreviewGrafikByName (cReferLineName, aDoc)
	DelPreviewGrafikByName (cReferenceName, aDoc)
	DelPreviewGrafikByName (cMainSenderName, aDoc)
	DelPreviewGrafikByName (cMainLogoName, aDoc)
end Sub

Sub DelPreviewAllFollowGrafiks (aDoc as Object)
	DelPreviewGrafikByName (cFollowTextName, aDoc)
	DelPreviewGrafikByName (cFollowSenderName, aDoc)
	DelPreviewGrafikByName (cFollowLogoName, aDoc)
end Sub

Function GetRelativePos (aGrafik, aPos as Object) as Object
	Dim aRelPos as Object
	aRelPos = createUnoStruct("stardiv.uno.awt.Point")
	aRelPos.x = aGrafik.HoriOrientPosition + aPos.x
	aRelPos.y = aGrafik.VertOrientPosition + aPos.y + cTopPreviewJustify
	GetRelativePos = aRelPos
end Function

Sub IniAllMainGrafiks (aDoc as Object)
	SetMainRecipientPreview (aDoc)
	SetMainTextPreview (aDoc)
	SetReferLinePreview (aDoc)
	SetReferencePreview (aDoc)
	SetMainSenderPreview (aDoc)
	SetMainLogoPreview (aDoc)
	bPreviewMainPage = True
end Sub

Sub IniAllFollowGrafiks (aDoc as Object)
	SetFollowTextPreview (aDoc)
	SetFollowSenderPreview (aDoc)
	SetFollowLogoPreview (aDoc)
	bPreviewMainPage = False
end Sub

Sub ChangeToMainPreview (aDoc as Object)
	if (bPreviewMainPage = false) then
		DelPreviewAllFollowGrafiks (aDoc)
		IniAllMainGrafiks (aDoc)
	end If
end Sub

Sub ChangeToFollowPreview (aDoc as Object)
	if (bPreviewMainPage = true) then
		DelPreviewAllMainGrafiks (aDoc)
		IniAllFollowGrafiks (aDoc)
	end If
end Sub

Sub SetMainRecipientPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aPos.x = cRecipient_x
	aPos.y = cRecipient_y
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	if nOwnerInAddressField = 0 then
		AddPreviewGrafik (cRecipientFileName_WithoutAbs, cRecipientName, aPos, aDoc)
	else
		AddPreviewGrafik (cRecipientFileName_WithAbs, cRecipientName, aPos, aDoc)
	end If	
end Sub

Sub ReplMainRecipientPreview (aDoc as Object)
	if nOwnerInAddressField = 0 then
		ReplacePreviewGrafik (cRecipientFileName_WithoutAbs, cRecipientName, aDoc)
	else
		ReplacePreviewGrafik (cRecipientFileName_WithAbs, cRecipientName, aDoc)
	end If	
end Sub


Sub SetMainTextPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aPos.x = cMainText_x
	aPos.y = cMainText_y
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	if bFootOn1 then
		if bLineToText1 = true then
			if bElementPageBox = true then
				AddPreviewGrafik (cMainTextFileName4, cMainTextName, aPos, aDoc)
			else
				AddPreviewGrafik (cMainTextFileName3, cMainTextName, aPos, aDoc)
			end If
		else
			if bElementPageBox = true then
				AddPreviewGrafik (cMainTextFileName2, cMainTextName, aPos, aDoc)
			else
				AddPreviewGrafik (cMainTextFileName1, cMainTextName, aPos, aDoc)
			end If
		end If	
	else
		AddPreviewGrafik (cMainTextFileName0, cMainTextName, aPos, aDoc)
	end If	
end Sub

Sub ReplMainTextPreview (aDoc as Object)
	if bFootOn1 then
		if bLineToText1 = true then
			if bElementPageBox = true then
				ReplacePreviewGrafik (cMainTextFileName4, cMainTextName, aDoc)
			else
				ReplacePreviewGrafik (cMainTextFileName3, cMainTextName, aDoc)
			end If
		else
			if bElementPageBox = true then
				ReplacePreviewGrafik (cMainTextFileName2, cMainTextName, aDoc)
			else
				ReplacePreviewGrafik (cMainTextFileName1, cMainTextName, aDoc)
			end If
		end If	
	else
		ReplacePreviewGrafik (cMainTextFileName0, cMainTextName, aDoc)
	end If	
end Sub

Sub SetReferLinePreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aPos.x = cReferLine_x
	aPos.y = cReferLine_y
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	AddPreviewGrafik (cReferLineFileName, cReferLineName, aPos, aDoc)
end Sub

Sub SetReferencePreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	Dim nRefCount%
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aPos.x = cReference_x
	aPos.y = cReference_y
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	nRefCount = 0
	if bElementCheckBox1 then nRefCount = nRefCount + 1
	if bElementCheckBox2 then nRefCount = nRefCount + 1
	if bElementCheckBox3 then nRefCount = nRefCount + 1
	Select Case (nRefCount)
		Case 0
			AddPreviewGrafik (cReferenceFileName0, cReferenceName, aPos, aDoc)
		Case 1
			AddPreviewGrafik (cReferenceFileName1, cReferenceName, aPos, aDoc)
		Case 2
			AddPreviewGrafik (cReferenceFileName2, cReferenceName, aPos, aDoc)
		Case 3
			AddPreviewGrafik (cReferenceFileName3, cReferenceName, aPos, aDoc)
	End Select	
end Sub

Sub ReplReferencePreview (aDoc as Object)
	Dim nRefCount%
	nRefCount = 0
	if bElementCheckBox1 then nRefCount = nRefCount + 1
	if bElementCheckBox2 then nRefCount = nRefCount + 1
	if bElementCheckBox3 then nRefCount = nRefCount + 1
	Select Case (nRefCount)
		Case 0
			ReplacePreviewGrafik (cReferenceFileName0, cReferenceName, aDoc)
		Case 1
			ReplacePreviewGrafik (cReferenceFileName1, cReferenceName, aDoc)
		Case 2
			ReplacePreviewGrafik (cReferenceFileName2, cReferenceName, aDoc)
		Case 3
			ReplacePreviewGrafik (cReferenceFileName3, cReferenceName, aDoc)
	End Select	
end Sub

Sub SetMainSenderPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	Dim nRefCount%
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	Select Case (nPosOwner1)
		Case cLogoLeft
			aPos.x = cMainSender_x1
			aPos.y = cMainSender_y1
		Case cLogoMid
			aPos.x = cMainSender_x2
			aPos.y = cMainSender_y2
		Case cLogoRight
			aPos.x = cMainSender_x3
			aPos.y = cMainSender_y3
		Case cLogoByAddress
			aPos.x = cMainSender_x4
			aPos.y = cMainSender_y4
	End Select
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	DelPreviewGrafikByName (cMainSenderName, aDoc)
	AddPreviewGrafik (cMainSenderFileName, cMainSenderName, aPos, aDoc)
end Sub

Sub SetMainLogoPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	Dim nRefCount%
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	Select Case (nPosLogo1)
		Case cLogoLeft
			aPos.x = cMainLogo_x1
			aPos.y = cMainLogo_y1
		Case cLogoMid
			aPos.x = cMainLogo_x2
			aPos.y = cMainLogo_y2
		Case cLogoRight
			aPos.x = cMainLogo_x3
			aPos.y = cMainLogo_y3
		Case cLogoByAddress
			aPos.x = cMainLogo_x4
			aPos.y = cMainLogo_y4
	End Select
	
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	DelPreviewGrafikByName (cMainLogoName, aDoc)
	
	'keine Pos darf kein Logo aktivieren
	if (nPosLogo1 = cNoPos) then
		Exit Sub
	end If
	
	'wenn kein Logo aktiviert wird, wird hier auch keine Grafik geholt
	Select Case (nKindOfLogo)
		Case cLogoGrafik
			AddPreviewGrafik (cMainLogoFileName1, cMainLogoName, aPos, aDoc)
		Case cLogoText
			AddPreviewGrafik (cMainLogoFileName2, cMainLogoName, aPos, aDoc)
	End Select
end Sub

Sub SetFollowSenderPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	Dim nRefCount%
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	Select Case (nPosOwner2)
		Case cLogoLeft
			aPos.x = cFollowSender_x1
			aPos.y = cFollowSender_y1
		Case cLogoMid
			aPos.x = cFollowSender_x2
			aPos.y = cFollowSender_y2
		Case cLogoRight
			aPos.x = cFollowSender_x3
			aPos.y = cFollowSender_y3
	End Select
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	DelPreviewGrafikByName (cFollowSenderName, aDoc)
	AddPreviewGrafik (cFollowSenderFileName, cFollowSenderName, aPos, aDoc)
end Sub

Sub SetFollowLogoPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	Dim nRefCount%
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	Select Case (nPosLogo2)
		Case cLogoLeft
			aPos.x = cFollowLogo_x1
			aPos.y = cFollowLogo_y1
		Case cLogoMid
			aPos.x = cFollowLogo_x2
			aPos.y = cFollowLogo_y2
		Case cLogoRight
			aPos.x = cFollowLogo_x3
			aPos.y = cFollowLogo_y3
	End Select
	
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	DelPreviewGrafikByName (cFollowLogoName, aDoc)
	
	'keine Pos darf kein Logo aktivieren
	if (nPosLogo2 = cNoPos) then
		Exit Sub
	end If
	
	'wenn kein Logo aktiviert wird, wird hier auch keine Grafik geholt
	Select Case (nKindOfLogo2)
		Case cLogoGrafik
			AddPreviewGrafik (cFollowLogoFileName1, cFollowLogoName, aPos, aDoc)
		Case cLogoText
			AddPreviewGrafik (cFollowLogoFileName2, cFollowLogoName, aPos, aDoc)
	End Select
end Sub

Sub SetFollowTextPreview (aDoc as Object)
	Dim aPos, aGrafik as Object
	aPos = createUnoStruct("stardiv.uno.awt.Point")
	aPos.x = cFollowText_x
	aPos.y = cFollowText_y
	aPos = GetRelativePos (aDefaultPreviewGrafik, aPos)
	if bFootOn2 then
		if bLineToText2 = true then
			if (bElementPageBox = true) then
				AddPreviewGrafik (cFollowTextFileName4, cFollowTextName, aPos, aDoc)
			else
				AddPreviewGrafik (cFollowTextFileName3, cFollowTextName, aPos, aDoc)
			end If
		else
			if (bElementPageBox = true) then
				AddPreviewGrafik (cFollowTextFileName2, cFollowTextName, aPos, aDoc)
			else
				AddPreviewGrafik (cFollowTextFileName1, cFollowTextName, aPos, aDoc)
			end If
		end If	
	else
		AddPreviewGrafik (cFollowTextFileName0, cFollowTextName, aPos, aDoc)
	end If	
end Sub

Sub ReplFollowTextPreview (aDoc as Object)
	if bFootOn2 then
		if bLineToText2 = true then
			if (bElementPageBox = true) then
				ReplacePreviewGrafik (cFollowTextFileName4, cFollowTextName, aDoc)
			else
				ReplacePreviewGrafik (cFollowTextFileName3, cFollowTextName, aDoc)
			end If
		else
			if (bElementPageBox = true) then
				ReplacePreviewGrafik (cFollowTextFileName2, cFollowTextName, aDoc)
			else
				ReplacePreviewGrafik (cFollowTextFileName1, cFollowTextName, aDoc)
			end If
		end If	
	else
		ReplacePreviewGrafik (cFollowTextFileName0, cFollowTextName, aDoc)
	end If	
end Sub
