'SBLLINK:MethodInfo=QueryMain0
'SBLLINK:MethodInfo=QueryMainWithDefault0
'SBLLINK:MethodInfo=InitDbEngine0
'SBLLINK:MethodInfo=FillDatabases0
'SBLLINK:MethodInfo=OpenDBConnection0
'SBLLINK:MethodInfo=CloseDbConnection0
'SBLLINK:MethodInfo=CreateQuery0
'SBLLINK:MethodInfo=QueryCmdCancel0
'SBLLINK:MethodInfo=QueryTableSelect0
'SBLLINK:MethodInfo=QuerySetNewDataBase0
'SBLLINK:MethodInfo=QueryCmdPrevClicked0
'SBLLINK:MethodInfo=QueryCmdNextOrReadyClicked0
'SBLLINK:MethodInfo=QuerySetTitle0
'SBLLINK:MethodInfo=QueryFillComboIfSearchable0
'SBLLINK:MethodInfo=QueryInitSortPage0
'SBLLINK:MethodInfo=QueryInitFilterPage0
'SBLLINK:MethodInfo=QueryCmbLogicAction0
'SBLLINK:MethodInfo=QueryCmbFieldnameAction0
'SBLLINK:MethodInfo=QuerycmbConditionAction0
'SBLLINK:MethodInfo=QueryTxtValueAction0
'SBLLINK:MethodInfo=QueryRow1Action0
'SBLLINK:MethodInfo=QueryRow2Action0
'SBLLINK:MethodInfo=QueryRow3Action0
'SBLLINK:MethodInfo=QueryRow4Action0
'SBLLINK:MethodInfo=QueryRow5Action0
'SBLLINK:MethodInfo=ResizeComboBoxes0
'SBLLINK:MethodInfo=QueryItemAvailable0
'SBLLINK:MethodInfo=QuerycmbSortEvent10
'SBLLINK:MethodInfo=QuerycmbSortEvent20
'SBLLINK:MethodInfo=QuerycmbSortEvent30
'SBLLINK:MethodInfo=QuerycmbSortEvent40
'SBLLINK:MethodInfo=QuerySetSortingCaption0
'SBLLINK:MethodInfo=QueryCmdSortingOpt10
'SBLLINK:MethodInfo=QueryCmdSortingOpt20
'SBLLINK:MethodInfo=QueryCmdSortingOpt30
'SBLLINK:MethodInfo=QueryCmdSortingOpt40
'SBLLINK:MethodInfo=QueryTitleQueryGetFocus0
'SBLLINK:MethodInfo=QueryGetTablesOfDataBase0
'SBLLINK:MethodInfo=QueryGetFieldsOfDataBase0
'SBLLINK:MethodInfo=QueryCmdSQLStatementClicked0
'SBLLINK:MethodInfo=QueryNoCode0
'SBLLINK:MethodInfo=QuerySetMoveRights0
'SBLLINK:MethodInfo=CheckButtons0
'SBLLINK:MethodInfo=QueryMoveSelected0
'SBLLINK:MethodInfo=QueryMoveAll0
'SBLLINK:MethodInfo=QueryRemoveSelected0
'SBLLINK:MethodInfo=QueryRemoveAll0
'SBLLINK:MethodInfo=QueryPreview1Repaint0
'SBLLINK:MethodInfo=QueryPreview2Repaint0
'SBLLINK:MethodInfo=QueryPreview3Repaint0
'SBLLINK:MethodInfo=QueryTxtQueryGotFocus0
'SBLLINK:MethodInfo=CheckQueryTitle0
'SBLLINK:MethodInfo=QueryTxtQueryLostFocus0
'SBLLINK:MethodInfo=QueryCheckSQLExpression0
'SBLLINK:MethodInfo=QueryCreateSQLStatement0
'SBLLINK:MethodInfo=QueryCreateNow0
Option Explicit

Global Const  DatabaseFieldType_BOOL			= -7
Global Const  DatabaseFieldType_TINYINT			= -6
Global Const  DatabaseFieldType_SMALLINT		= 5
Global Const  DatabaseFieldType_INTEGER			= 4
Global Const  DatabaseFieldType_BIGINT			= -5
Global Const  DatabaseFieldType_REAL			= 7
Global Const  DatabaseFieldType_DOUBLE			= 8
Global Const  DatabaseFieldType_NUMERIC			= 2
Global Const  DatabaseFieldType_DECIMAL			= 3
Global Const  DatabaseFieldType_CURRENCY		= 2222
Global Const  DatabaseFieldType_CHAR			= 1
Global Const  DatabaseFieldType_VARCHAR			= 12
Global Const  DatabaseFieldType_LONGVARCHAR		= -1
Global Const  DatabaseFieldType_DATE			= 91
Global Const  DatabaseFieldType_TIME			= 92
Global Const  DatabaseFieldType_DATETIME		= 93
Global Const  DatabaseFieldType_BINARY			= -2
Global Const  DatabaseFieldType_VARBINARY		= -3
Global Const  DatabaseFieldType_LONGVARBINARY	= -4
Global Const  DatabaseFieldType_OTHER			= 1111

Global Const  DatabaseSearch_NONE	= 0
Global Const  DatabaseSearch_CHAR	= 1
Global Const  DatabaseSearch_BASIC	= 2
Global Const  DatabaseSearch_ALL	= 3

Global Const DatabaseInfo_IDENTIFIER_QUOTE_CHAR	= 26

Global Const	DatabaseCursorType_FORWARD	= 0
Global Const	DatabaseCursorType_SNAPSHOT	= 1
Global Const	DatabaseCursorType_KEYSET	= 2
Global Const	DatabaseCursorType_DYNAMIC	= 3

Global Const	DatabaseCursorOption_UPDATABLE	= 0
Global Const	DatabaseCursorOption_READONLY	= 1
Global Const	DatabaseCursorOption_INSERTONLY	= 2

Global QueryReturnValue$, QueryActiveDataBaseName$, QueryPath$
Global QueryChangesOnFieldPage%, QueryBeamerActiveAtStart%
Global QueryActiveRow%, QueryShowAfterCreate%

const cLogic=0,cFieldName=1,cRelOperator=2,cValue=3
Global ControlArray(0 To 4, 0 To 3) As Object	'	Logic,Fieldname,RelOperator,Value

Global QueryAvailTables As New Strings
Global QueryAvailTablesQueries As New Strings
Global QueryOriginalFieldNames As New Strings

Dim aDbEngine, aDbWorkspace as Object
Dim aCurrentDb as Object
Dim aCurrentTable, aCurrentFields, aCurrentFirstRecord as Object

Dim bNeedFieldRefresh as Boolean

' -----------------------------------------------------------------------------
Sub QueryMain()
	Call QueryMainWithDefault ( "" )
End Sub

' -----------------------------------------------------------------------------
Sub QueryMainWithDefault( ByVal DBName$ )
	Call CreateQuery( DBName$ )
End Sub

' -----------------------------------------------------------------------------
Function InitDbEngine as Boolean
On Local Error Goto CouldNotInit
	aDbEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
	aDbWorkspace = aDbEngine.Workspaces( 0 )

	InitDbEngine = TRUE
	Exit Function

CouldNotInit:
	MsgBox Query_gErrNoEngine$
	InitDbEngine = FALSE
End Function

' -----------------------------------------------------------------------------
Sub FillDatabases
	DlgQuery.cmbAvailDatabase.Clear()

	Dim i%
	Dim aFavorites
	aFavorites = aDbEngine.getFavorites
	For i% = lbound(aFavorites) to ubound(aFavorites)
		DlgQuery.cmbAvailDatabase.AddItem(aFavorites(i%).Name)
	Next i%
End Sub

' -----------------------------------------------------------------------------
Function OpenDBConnection(sName as String) as Boolean
	Application.EnterWait()
	Wait( 0 )

	' reset the table based stuff
	Dim aEmptyObject as Object
	aCurrentFirstRecord = aEmptyObject
	aCurrentFields = aEmptyObject
	aCurrentTable = aEmptyObject

On Local Error goto could_not_open
	CloseDbConnection()	' just in case

	aCurrentDb = aDBWorkspace.open(sName)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, QueryAvailTables, INC_TABLES)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, QueryAvailTablesQueries, INC_TABLES + INC_QUERIES)

	OpenDBConnection = TRUE
	goto exit_function

could_not_open:
	CloseDbConnection()
	QueryAvailTables.Clear()
	QueryAvailTablesQueries.Clear()
	OpenDBConnection = FALSE

exit_function:
	Application.LeaveWait()
End Function

' -----------------------------------------------------------------------------
Sub CloseDbConnection()
	Dim aEmptyObject as Object
	aCurrentFirstRecord = aEmptyObject
	aCurrentFields = aEmptyObject
	aCurrentTable = aEmptyObject
	aCurrentDb = aEmptyObject
End Sub

' -----------------------------------------------------------------------------
Function CreateQuery$(ActiveDataBaseName$)

On Error Goto GlobalError

	if not (InitResources()) then
		exit Function
	end if

	Dim nCount%

	Application.EnterWait()
	Wait( 0 )

	'	Initialize global variables
	QueryReturnValue$ = ""
	QueryActiveDataBaseName$ = ""
	QueryPath$ = ""
	QueryChangesOnFieldPage% = 0
	QueryActiveRow% = 0
	CreateQuery$ = ""
	QueryActiveDataBaseName$ = ActiveDataBaseName$
	QueryBeamerActiveAtStart% = Application.Beamer
	QueryChangesOnFieldPage% = True
	QueryShowAfterCreate% = False

	ControlArray(0,cLogic) = DlgQuery.cmbLogic1
	ControlArray(1,cLogic) = DlgQuery.cmbLogic2
	ControlArray(2,cLogic) = DlgQuery.cmbLogic3
	ControlArray(3,cLogic) = DlgQuery.cmbLogic4
	ControlArray(4,cLogic) = DlgQuery.cmbLogic5

	ControlArray(0,cFieldName) = DlgQuery.cmbFieldName1
	ControlArray(1,cFieldName) = DlgQuery.cmbFieldName2
	ControlArray(2,cFieldName) = DlgQuery.cmbFieldName3
	ControlArray(3,cFieldName) = DlgQuery.cmbFieldName4
	ControlArray(4,cFieldName) = DlgQuery.cmbFieldName5

	ControlArray(0,cRelOperator) = DlgQuery.cmbCondition1
	ControlArray(1,cRelOperator) = DlgQuery.cmbCondition2
	ControlArray(2,cRelOperator) = DlgQuery.cmbCondition3
	ControlArray(3,cRelOperator) = DlgQuery.cmbCondition4
	ControlArray(4,cRelOperator) = DlgQuery.cmbCondition5

	ControlArray(0,cValue) = DlgQuery.txtValue1
	ControlArray(1,cValue) = DlgQuery.txtValue2
	ControlArray(2,cValue) = DlgQuery.txtValue3
	ControlArray(3,cValue) = DlgQuery.txtValue4
	ControlArray(4,cValue) = DlgQuery.txtValue5

	'	Set language
	LoadLanguage ( Application.LanguageID() )

	If Not InitDbEngine() Then
		Application.LeaveWait()
		Exit Function
	End If

	'	Load dialog and string tools
	Application.LoadLibrary( "Tools" )
	wait( 0 )
	InitDlgTools()

	QueryReturnValue$ = ""
	QueryPath$ = Application.Pathsettings.Template
	If InStr (QueryPath$, ";")<>0 Then
		QueryPath$ = Left$(QueryPath$, InStr(QueryPath$, ";")-1)
	End If
	QueryPath$ = QueryPath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	DlgQuery.Load()

	bNeedFieldRefresh = True

	DlgQuery.OptRunNow.Value = True
	DlgQuery.OptRunClosed.Value = False
	DlgQuery.CurrentStep = 1

	If (QueryActiveDataBaseName$ = "") Then
		DlgQuery.cmbAvailDatabase.Visible = True
		DlgQuery.frameDatabase.Visible = True
		DlgQuery.cmbAvailDatabase.Top = 480
		DlgQuery.frameDatabase.Top = 180
		DlgQuery.frameTables.Top = DlgQuery.frameTables.Top + DlgQuery.frameDatabase.Height + 90
		DlgQuery.frameTables.Height = DlgQuery.frameTables.Height - DlgQuery.frameDatabase.Height - 90
		DlgQuery.lbTables.Top = DlgQuery.lbTables.Top + DlgQuery.frameDatabase.Height + 90
		DlgQuery.lbTables.Height = DlgQuery.lbTables.Height - DlgQuery.frameDatabase.Height - 90

		FillDatabases()
		
		If (0 = DlgQuery.cmbAvailDatabase.ListCount()) Then
			MsgBox( Query_gErrNoDataBase$, 16, Query_gWizardname$ )
			While ( Application.IsWait() )
				Application.LeaveWait()
			Wend
			Exit Function
		Else
			DlgQuery.cmbAvailDatabase.ListIndex = 0
			QueryActiveDataBaseName$ = DlgQuery.cmbAvailDatabase.List(DlgQuery.cmbAvailDatabase.ListIndex())
		End If
	Else
		DlgQuery.cmbAvailDatabase.Visible = False
		DlgQuery.frameDatabase.Visible = False
	End If

	DlgQuery.cmdSQLStatement.Visible = False
	DlgQuery.cmdPrev.Enabled = False
	DlgQuery.cmbSort1.Height=1500
	DlgQuery.cmbSort2.Height=1500
	DlgQuery.cmbSort3.Height=1500
	DlgQuery.cmbSort4.Height=1500

	OpenDBConnection(QueryActiveDataBaseName$)

	Call QuerySetTitle()
	Call QueryGetTablesOfDataBase()
	Call ResizeComboBoxes()

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

	CheckButtons(1)
	DlgQuery.Show()

	CreateQuery$ = QueryReturnValue$
	CloseDbConnection()
	Exit Function

GlobalError:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
	MsgBox(Query_gErrDefaultMsg$, 16, Query_gWizardname$)
	CreateQuery = ""
End Function

' -----------------------------------------------------------------------------
Sub QueryCmdCancel
	Call CloseDbConnection()
	DlgQuery.Hide()
	DlgQuery.Unload()
	QueryReturnValue$ = ""
	Application.Beamer = QueryBeamerActiveAtStart%
End Sub

' -----------------------------------------------------------------------------
Sub QueryTableSelect
	bNeedFieldRefresh = True
End Sub

' -----------------------------------------------------------------------------
Sub QuerySetNewDataBase()
	bNeedFieldRefresh = True
	Application.EnterWait()

On Local Error Goto leave_wait
	QueryActiveDataBaseName$ = DlgQuery.cmbAvailDatabase.List(DlgQuery.cmbAvailDatabase.ListIndex())

	' initially clear the tables list
	DlgQuery.lbTables.Clear()
	' and disable some controls so the user can't select a database while selecting a database (or something like that)
	DlgQuery.cmdNextOrReady.Enabled = FALSE
	DlgQuery.cmdCancel.Enabled = FALSE
	DlgQuery.cmbAvailDatabase.Enabled = FALSE
	DlgQuery.lbTables.Enabled = FALSE

	' then open the db (this is the may-be-expensive part)
	OpenDBConnection(QueryActiveDataBaseName$)

	' and fill in the tables
	QueryGetTablesOfDataBase()

	' initialize the filter and the sort page (means set a flags so they are initialized when needed)
	QueryChangesOnFieldPage% = TRUE

	' and enable the ui
	DlgQuery.lbTables.Enabled = TRUE
	DlgQuery.cmbAvailDatabase.Enabled = TRUE
	DlgQuery.cmdCancel.Enabled = TRUE
	DlgQuery.cmdNextOrReady.Enabled = TRUE

leave_wait:
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdPrevClicked()
	' on the last page we have to check the given query title
	If (DlgQuery.CurrentStep = 5) And (Not CheckQueryTitle()) Then
		Exit Sub
	End If

	Dim nNextStep as Integer
	nNextStep = DlgQuery.CurrentStep - 1

	' initialize the upcoming page (before showing it)
	CheckButtons(nNextStep)

	DlgQuery.CurrentStep = nNextStep
	Call QuerySetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdNextOrReadyClicked()
	Dim nNextStep as Integer
	nNextStep = DlgQuery.CurrentStep + 1

	DlgQuery.CurrentStep = nNextStep

	If (DlgQuery.CurrentStep = 2) Then
		' fill in the fields
		QueryGetFieldsOfDataBase()
		if DlgQuery.lbSelected.ListCount() < 1 then
			DlgQuery.cmdMoveAll.SetFocus
		end if	
	End If

	' initialize the upcoming page (before showing it)
	If (nNextStep = 3) Then
		Call QueryInitFilterPage()
	End If
	If (nNextStep = 4) Then
		Call QueryInitSortPage()
	End If

	CheckButtons(DlgQuery.CurrentStep)

	QuerySetTitle()
	If (DlgQuery.CurrentStep = 5) Then
		cmdReady.SetFocus
	end If
End Sub

' -----------------------------------------------------------------------------
Sub QuerySetTitle()
	Select Case (DlgQuery.CurrentStep)
		Case 1
			DlgQuery.Caption = Query_Dlg_1Caption$
		Case 2
			DlgQuery.Caption = Query_Dlg_2Caption$
		Case 3
			DlgQuery.Caption = Query_Dlg_3Caption$
		Case 4
			DlgQuery.Caption = Query_Dlg_4Caption$
		Case 5
			DlgQuery.Caption = Query_Dlg_5Caption$
	End Select
End Sub

' -----------------------------------------------------------------------------
Sub QueryFillComboIfSearchable(aDestCombo as object)
	Dim nAllFields%, nSelectedFields%, nCount%, nCurrentSearchFlag%
	Dim sCurrentField$

	nSelectedFields% = DlgQuery.lbSelected.ListCount()
	nAllFields% = nSelectedFields% + DlgQuery.lbFields.ListCount()

	aDestCombo.Clear()
	aDestCombo.AddItem( Query_ilListboxNoFieldname$ )

	For nCount%=0 To nAllFields% - 1
		if (nCount% < nSelectedFields%) Then
			sCurrentField$ = DlgQuery.lbSelected.List(nCount%)
		Else
			sCurrentField$ = DlgQuery.lbFields.List(nCount% - nSelectedFields%)
		End If
		Dim aTest as Object
		nCurrentSearchFlag% = aCurrentFirstRecord.getByName(sCurrentField$).SearchInfo
		If (nCurrentSearchFlag% <> DatabaseSearch_NONE) Then
			aDestCombo.AddItem(sCurrentField$)
		End If
	Next nCount%
	If (aDestCombo.ListCount>0) Then aDestCombo.ListIndex = 0
End Sub

' -----------------------------------------------------------------------------
Sub QueryInitSortPage()
	Application.EnterWait()

On Local Error Goto outta_here
	' disable the ui while loading
	DlgQuery.cmdNextOrReady.Enabled = False
	DlgQuery.cmdCancel.Enabled = False
	DlgQuery.cmdPrev.Enabled = False
	DlgQuery.cmdReady.Enabled = False
	DlgQuery.cmdSort1.Enabled = False
	DlgQuery.cmdSort2.Enabled = False
	DlgQuery.cmdSort3.Enabled = False
	DlgQuery.cmdSort4.Enabled = False
	DlgQuery.cmdSQLStatement.Enabled = False

	' fill the combo's with the searchable fields
	QueryFillComboIfSearchable(cmbSort1)
	QueryFillComboIfSearchable(cmbSort2)
	QueryFillComboIfSearchable(cmbSort3)
	QueryFillComboIfSearchable(cmbSort4)

outta_here:
	' re-enable the ui
	DlgQuery.cmdSort1.Enabled = True
	DlgQuery.cmdSort2.Enabled = True
	DlgQuery.cmdSort3.Enabled = True
	DlgQuery.cmdSort4.Enabled = True
	CheckButtons(DlgQuery.CurrentStep)
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub QueryInitFilterPage()
	If (not QueryChangesOnFieldPage%) Then Exit Sub
	Dim Row%

	Application.EnterWait()
On Local Error Goto outta_here

	' disable the ui while loading
	DlgQuery.cmdNextOrReady.Enabled = False
	DlgQuery.cmdCancel.Enabled = False
	DlgQuery.cmdPrev.Enabled = False
	DlgQuery.cmdReady.Enabled = False
	DlgQuery.cmdSQLStatement.Enabled = False

	' fill in the fields
	For Row%=0 To 4
		With ControlArray ( Row%, cLogic )
			.Clear ()
			.AddItem ( Query_ilComboBoxLogic_Or$ )
			.AddItem ( Query_ilComboBoxLogic_And$ )
			.Enabled = False
			.ListIndex = 0
		End With

		' fill in the fields list (include a field only if the appropriate search-flag is set)
		QueryFillComboIfSearchable(ControlArray(Row%,cFieldname))

		With ControlArray ( Row%, cRelOperator )
			.Clear ()
			.AddItem ( "=" )
			.AddItem ( "<>" )
			.AddItem ( ">" )
			.AddItem ( "<" )
			.AddItem ( ">=" )
			.AddItem ( "<=" )
			.AddItem ( Query_ilComboBoxCondition_Empty$ )
			.AddItem ( Query_ilComboBoxCondition_NotEmpty$ )
			.AddItem ( Query_ilComboBoxCondition_Like$ )
			.AddItem ( Query_ilComboBoxCondition_NotLike$ )
			.Enabled = False
		End With

		'	First element must be enabled
		ControlArray ( Row%, cFieldName).Enabled = ( 0 = Row% )
		ControlArray ( Row%, cFieldName).ListIndex = 0
		ControlArray ( Row%, cValue).Enabled = False
	Next

outta_here:
	' re-enable the ui
	CheckButtons(DlgQuery.CurrentStep)

	QueryChangesOnFieldPage% = False
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmbLogicAction()
	If (ControlArray(QueryActiveRow%,cLogic).ListIndex >= 0) Then'+++
		ControlArray(QueryActiveRow%,cFieldName).Enabled = True
		If (ControlArray(QueryActiveRow%,cFieldName).ListIndex > 0) Then
			ControlArray(QueryActiveRow%,cRelOperator).Enabled = True
			If (ControlArray(QueryActiveRow%,cRelOperator).Text <> "") Then
				ControlArray(QueryActiveRow%,cValue).Enabled = True
				If ((ControlArray(QueryActiveRow%,cValue).Text <> "") And (QueryActiveRow<4)) Then
					ControlArray(QueryActiveRow%+1,cLogic).Enabled = True
				End If
			End If
		End If
	Else
		ControlArray(QueryActiveRow%,cFieldName).Enabled=False
		ControlArray(QueryActiveRow%,cRelOperator).Enabled=False
		ControlArray(QueryActiveRow%,cValue).Enabled=False
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmbFieldnameAction()
	Dim sSelectedField$
	Dim nSearchInfo%, nOperationsCount%

	If (ControlArray(QueryActiveRow%,cFieldName).ListIndex > 0) Then
		ControlArray(QueryActiveRow%,cRelOperator).Enabled = True
		If (ControlArray(QueryActiveRow%,cRelOperator).Text = "") Then
			ControlArray(QueryActiveRow%,cRelOperator).ListIndex = 0
		End If
		ControlArray(QueryActiveRow%,cValue).Enabled = True

		' check if the selected field is searchable with 'like', remove the according entries from
		' criteria list if not
		nOperationsCount% = ControlArray(QueryActiveRow%,cRelOperator).ListCount
		sSelectedField$ = ControlArray(QueryActiveRow%,cFieldName).List(ControlArray(QueryActiveRow%,cFieldName).ListIndex)

		nSearchInfo% = aCurrentFirstRecord.getByName(sSelectedField$).SearchInfo
		If ((nSearchInfo% And DatabaseSearch_CHAR) = 0) And (nOperationsCount% = 10) Then
			' we need to remove the entries
			if (ControlArray(QueryActiveRow%,cReloperator).ListIndex >= 8) Then
				' the control to be removed is selected -> reset to '='
				ControlArray(QueryActiveRow%,cReloperator).ListIndex = 0
			End If
			ControlArray(QueryActiveRow%,cRelOperator).RemoveItem ( 9 )
			ControlArray(QueryActiveRow%,cRelOperator).RemoveItem ( 8 )
		End If
		If ((nSearchInfo% And DatabaseSearch_CHAR) <> 0) And (nOperationsCount% <> 10) Then
			' we need to reinsert the entries
			ControlArray(QueryActiveRow%,cRelOperator).AddItem ( Query_ilComboBoxCondition_Like$ )
			ControlArray(QueryActiveRow%,cRelOperator).AddItem ( Query_ilComboBoxCondition_NotLike$ )
		End If
	Else
		ControlArray(QueryActiveRow%,cValue).Enabled = False
		ControlArray(QueryActiveRow%,cRelOperator).Enabled = False
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QuerycmbConditionAction()
	Dim nActiveIndex%
	Dim sActiveString$

	nActiveIndex% = ControlArray(QueryActiveRow%,cRelOperator).ListIndex
	sActiveString$ = ControlArray(QueryActiveRow%,cRelOperator).List(nActiveIndex)
	If (sActiveString$ = Query_ilComboBoxCondition_Empty$ Or sActiveString$ = Query_ilComboBoxCondition_NotEmpty$) Then
		ControlArray(QueryActiveRow%,cValue).Enabled = False
		If ( QueryActiveRow% < 4 ) Then
			ControlArray(QueryActiveRow%+1,cFieldName).Enabled = True
			If ( ControlArray(QueryActiveRow%+1,cFieldName).ListIndex > 0 ) Then
				ControlArray(QueryActiveRow%+1,cValue).Enabled = True
			End If
		End If
		If (QueryActiveRow%<4) Then
			ControlArray(QueryActiveRow%+1,clogic).Enabled = True
		End If
	Else
		ControlArray(QueryActiveRow%,cValue).Enabled = True
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QueryTxtValueAction()
	If (QueryActiveRow%<4) Then

		Dim Control As Object
		Control = ControlArray(QueryActiveRow%+1,cLogic)

		If (ControlArray(QueryActiveRow%,cValue).Text <> "") Then
			If (Control.Enabled=False) Then
				Control.Enabled = True
				Control.ListIndex = 0
				ControlArray(QueryActiveRow%+1,cFieldName).Enabled = True
				If ( ControlArray(QueryActiveRow%+1,cFieldName).ListIndex > 0 ) Then
					ControlArray(QueryActiveRow%+1,cValue).Enabled = True
				End If
			End If
		Else
			If (ControlArray(QueryActiveRow%+1,cFieldName).Enabled = False)And(ControlArray(QueryActiveRow%+1,cRelOperator).Enabled = False)And(ControlArray(QueryActiveRow%+1,cValue).Enabled = False) Then
				Control.Enabled = False
			End If
		End If

	End If
End Sub

' -----------------------------------------------------------------------------
'	Determine last-used cell via the GetFocus event
Sub QueryRow1Action()
	QueryActiveRow% = 0
End Sub
Sub QueryRow2Action()
	QueryActiveRow% = 1
End Sub
Sub QueryRow3Action()
	QueryActiveRow% = 2
End Sub
Sub QueryRow4Action()
	QueryActiveRow% = 3
End Sub
Sub QueryRow5Action()
	QueryActiveRow% = 4
End Sub

' -----------------------------------------------------------------------------
Sub ResizeComboBoxes()
	const cHeight% = 1500
	DlgQuery.cmbLogic2.Height = cHeight%
	DlgQuery.cmbLogic3.Height = cHeight%
	DlgQuery.cmbLogic4.Height = cHeight%
	DlgQuery.cmbLogic5.Height = cHeight%

	DlgQuery.cmbFieldName1.Height = cHeight%
	DlgQuery.cmbFieldName2.Height = cHeight%
	DlgQuery.cmbFieldName3.Height = cHeight%
	DlgQuery.cmbFieldName4.Height = cHeight%
	DlgQuery.cmbFieldName5.Height = cHeight%

	DlgQuery.cmbCondition1.Height = cHeight%
	DlgQuery.cmbCondition2.Height = cHeight%
	DlgQuery.cmbCondition3.Height = cHeight%
	DlgQuery.cmbCondition4.Height = cHeight%
	DlgQuery.cmbCondition5.Height = cHeight%
End Sub

' -----------------------------------------------------------------------------
Sub QueryItemAvailable(EventIn As Object, TestTarget As Object)
	Dim EvStr$, EvIndex%, TestStr$, TestIndex%

	TestIndex% = TestTarget.ListIndex()
	EvIndex% = EventIn.ListIndex()

	If (TestIndex%>0 And EvIndex%>0) Then
		TestStr$ = TestTarget.List(TestIndex%)
		EvStr$ = EventIn.List(EvIndex%)
		If (TestStr$=EvStr$) Then
			Beep
			EventIn.ListIndex = 0
		End If
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QuerycmbSortEvent1()
	Call QueryItemAvailable(cmbSort1,cmbSort2)
	Call QueryItemAvailable(cmbSort1,cmbSort3)
	Call QueryItemAvailable(cmbSort1,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub QuerycmbSortEvent2()
	Call QueryItemAvailable(cmbSort2,cmbSort1)
	Call QueryItemAvailable(cmbSort2,cmbSort3)
	Call QueryItemAvailable(cmbSort2,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub QuerycmbSortEvent3()
	Call QueryItemAvailable(cmbSort3,cmbSort1)
	Call QueryItemAvailable(cmbSort3,cmbSort2)
	Call QueryItemAvailable(cmbSort3,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub QuerycmbSortEvent4()
	Call QueryItemAvailable(cmbSort4,cmbSort1)
	Call QueryItemAvailable(cmbSort4,cmbSort2)
	Call QueryItemAvailable(cmbSort4,cmbSort3)
End Sub

' -----------------------------------------------------------------------------
Sub QuerySetSortingCaption(aCommandButton As Object)
	If (aCommandButton.Caption = DlgQuery_4_labelSortDown$) Then
		aCommandButton.Caption = DlgQuery_4_labelSortUp$
	Else
		aCommandButton.Caption = DlgQuery_4_labelSortDown$
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdSortingOpt1()
	Call QuerySetSortingCaption(cmdSort1)
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdSortingOpt2()
	Call QuerySetSortingCaption(cmdSort2)
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdSortingOpt3()
	Call QuerySetSortingCaption(cmdSort3)
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdSortingOpt4()
	Call QuerySetSortingCaption(cmdSort4)
End Sub

' -----------------------------------------------------------------------------
Sub QueryTitleQueryGetFocus()
	txtQueryTitle.Tag = txtQueryTitle.Text
End Sub

' -----------------------------------------------------------------------------
Sub QueryGetTablesOfDataBase()
	Dim nCount%
	Dim sCurrent$

	DlgQuery.lbTables.Clear()

	for nCount% = 1 to QueryAvailTables.Count()
		sCurrent$ = QueryAvailTables.Item(nCount%)
		DlgQuery.lbTables.AddItem(sCurrent$)
	Next nCount%

	If (DlgQuery.lbTables.ListCount>=1) Then
		DlgQuery.lbTables.Selected(0)=True
	Else
		MsgBox( Query_gErrNoTable$ ,16, Query_gWizardname$ )
		QueryReturnValue$ = ""
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QueryGetFieldsOfDataBase()
	If (Not bNeedFieldRefresh) Then Exit Sub

	Dim nCount%, maxCount%
	Dim QueryTitleSuggest$, TableName$, sActFieldName$

	Application.EnterWait()
On Local Error Goto could_not_open_fields
	DlgQuery.lbFields.Clear()
	DlgQuery.lbSelected.Clear()

	' disable some ui elements
	DlgQuery.cmdNextOrReady.Enabled = False
	DlgQuery.cmdCancel.Enabled = False
	DlgQuery.cmdPrev.Enabled = False
	DlgQuery.cmdReady.Enabled = False
	DlgQuery.cmdMoveSelected.Enabled = False
	DlgQuery.cmdMoveAll.Enabled = False
	DlgQuery.cmdRemoveSelected.Enabled = False
	DlgQuery.cmdRemoveAll.Enabled = False
	
	'	which table was selected
	nCount% = DlgQuery.lbTables.ListIndex()
	QueryTitleSuggest$ = DlgQuery.lbTables.List(DlgQuery.lbTables.ListIndex())

	'	Determining a free query name. Tables and queries collide
	'	in their internal logic, so their names must be unique with respect
	'	to each other.
	DlgQuery.txtQueryTitle.Text = SuggestTitleStr$(QueryAvailTablesQueries, Query_ilPrefix_Query_$ + QueryTitleSuggest$)

	'	Fill in the list lbFields
	TableName$ = DlgQuery.lbTables.List(nCount%)

	Dim aFieldsIterator, aCurrentField as Object
	aCurrentTable = aCurrentDb.getTables().getByName(TableName$)
	aCurrentFields = aCurrentTable.getFields()
	aFieldsIterator = aCurrentFields.createEnumeration()

'	Call FixODBCBug()
	QueryOriginalFieldNames.Clear()

	On Local Error Resume Next	' skip fields which can't be read
	Dim bVersionColumn as boolean
	while (aFieldsIterator.hasMoreElements())
		aCurrentField = aFieldsIterator.nextElement()
		bVersionColumn = False
		if (aCurrentField.IsVersioning) Then
			bVersionColumn = true
		End If
		sActFieldName$ = aCurrentField.Name
		if (Not bVersionColumn) Then
			DlgQuery.lbFields.AddItem( sActFieldName$ )
			QueryOriginalFieldNames.Add( sActFieldName$ )
		End If
	Wend

	DlgQuery.lbFields.Selected(0)=True
	QueryChangesOnFieldPage% = TRUE

	' Later we need special field informations for deciding whether a column can be sorted or filtered.
	' Thus we have to open a cursor on the selected table because the information we are interested in
	' is provided only by the record supplied by a statement.
	Dim aStatement, aCursor, aRecord as Object
	aStatement = aCurrentDb.createStatement("SELECT * FROM " & UNOQuoteTableName(aCurrentTable.Name, aCurrentDb), FALSE)
	' some properties to further speed up execution :
	aStatement.CacheSize = 0		' no caching
	aStatement.MaxFieldSize = 10	' an arbitrary - but small - value
	aStatement.MaxRecords = 1		' the first fetched record is enough
	' now do it
	aCursor = aStatement.executeQuery(DatabaseCursorType_FORWARD, DatabaseCursorOption_READONLY)
	aCurrentFirstRecord = aCursor.getRecord

	goto outta_here

could_not_open_fields:
	MsgBox Query_gErrCouldNotOpenObject$, 16, Query_gWizardname$

outta_here:
	bNeedFieldRefresh = False
	CheckButtons(DlgQuery.CurrentStep)
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub QueryCmdSQLStatementClicked()
	Dim sBeamerURL as String
	sBeamerURL = aCurrentDb.URL
	sBeamerURL = sBeamerURL + "#db:Statement;"
	sBeamerURL = sBeamerURL + chr(9)
	sBeamerURL = sBeamerURL + "0"
	sBeamerURL = sBeamerURL + chr(9)
	sBeamerURL = sBeamerURL + QueryCreateSQLStatement$()

	Dim aDummyArgs()
	StarDesktop.LoadComponentFromURL(sBeamerURL, "_beamer", 8, aDummyArgs)
End Sub

' -----------------------------------------------------------------------------
Sub QueryNoCode()
	'	Dummy Sub for Event Handler. Do not delete!
End Sub

' -----------------------------------------------------------------------------
Sub QuerySetMoveRights()
	'	enable or disable the buttons for the moving of available fields
	'	between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>DlgQuery.lbFields.ListIndex())
	FieldCount% = DlgQuery.lbFields.ListCount()

	SelectSelected% = (-1<>DlgQuery.lbSelected.ListIndex())
	SelectCount% = DlgQuery.lbSelected.ListCount()

	DlgQuery.cmdRemoveAll.Enabled = (SelectCount%>=1)
	DlgQuery.cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	DlgQuery.cmdMoveAll.Enabled = (FieldCount%>=1)
	DlgQuery.cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
End Sub

' -----------------------------------------------------------------------------
Sub CheckButtons(nNextStep as Integer)
	' the preview button ist visible only on the search and the filter page
	DlgQuery.cmdSQLStatement.Visible = ((3 = nNextStep) Or (4 = nNextStep))
	DlgQuery.cmdSQLStatement.Enabled = True
	' cancel may be disabled explicitly if needed so we have to reset it
	DlgQuery.cmdCancel.Enabled = True
	' back : only possible if not at the first page
	DlgQuery.cmdPrev.Enabled = (nNextStep > 1)
	' next : not at the last page, not at the second page if no field is selected, not at the first page if no table
	' is selected
	DlgQuery.cmdNextOrReady.Enabled = (nNextStep < 5) And ( (nNextStep <> 2) Or (DlgQuery.lbSelected.ListCount <> 0) ) And _
		( (nNextStep <> 1) or (-1 <> DlgQuery.lbTables.ListIndex()))
	' finish : valid if at least one field is selected
	DlgQuery.cmdReady.Enabled = (DlgQuery.lbSelected.ListCount <> 0)

	if (nNextStep = 2) Then
		QuerySetMoveRights()
	End If
End Sub

' -----------------------------------------------------------------------------
Sub QueryMoveSelected()
	If (0 = SelectionInListBox%(lbFields)) Then
		' double clicked on an empty place ?
		Exit Sub
	End If
	MoveSelectedListBox(lbFields, lbSelected)
	CheckButtons(2)
End Sub

' -----------------------------------------------------------------------------
Sub QueryMoveAll()
	CopyItemsListBox(lbFields, lbSelected)
	CheckButtons(2)
	cmdNextOrReady.SetFocus
End Sub

' -----------------------------------------------------------------------------
Sub QueryRemoveSelected()
	If (0 = SelectionInListBox%(lbSelected)) Then
		' double clicked on an empty place ?
		Exit Sub
	End If
	MoveOrderedSelectedListbox( lbFields, lbSelected, QueryOriginalFieldNames, False )
	CheckButtons(2)
	QueryChangesOnFieldPage% = True
End Sub

' -----------------------------------------------------------------------------
Sub QueryRemoveAll()
	MoveOrderedSelectedListbox( lbFields, lbSelected, QueryOriginalFieldNames, True )
	CheckButtons(2)
	QueryChangesOnFieldPage% = True
End Sub

' -----------------------------------------------------------------------------
'	Repaint Events
Sub QueryPreview1Repaint()
	Call PaintPicOnPreview(DlgQuery.Preview1, QueryPath$ + "cjtable0.bmp", 152, 172, True)
End Sub

Sub QueryPreview2Repaint()
	Call PaintPicOnPreview(DlgQuery.Preview2, QueryPath$ + "end.bmp", 152, 172, True)
End Sub

Sub QueryPreview3Repaint()
	Call PaintPicOnPreview(DlgQuery.Preview3, QueryPath$ + "cjtrep02.bmp", 152, 172, True)
End Sub

Sub QueryTxtQueryGotFocus()
	DlgQuery.txtQueryTitle.Tag = DlgQuery.txtQueryTitle.Text
End Sub

' -----------------------------------------------------------------------------
Function CheckQueryTitle() as Boolean
	CheckQueryTitle = False
	If Not CheckDatabaseIdentifier2(DlgQuery.txtQueryTitle, Query_gErrTitle$, _
		Query_gWizardname$ ) Then
		Exit Function
	End If
	If Not CheckTitleUnique(QueryAvailTablesQueries, DlgQuery.txtQueryTitle, Query_gErrTitleExist, _
		Query_gWizardname$ ) Then
		Exit Function
	End If
	CheckQueryTitle = True
End Function

' -----------------------------------------------------------------------------
Sub QueryTxtQueryLostFocus()
End Sub

' -----------------------------------------------------------------------------
Sub QueryCheckSQLExpression(TextBox As Object)
	'	To spare the users from having to know SQL, this comparison permits
	'	a ? instead of a _, and a * instead of a %.
	Dim nCount%
	Dim TextString$, actChar$, Result$

	TextString$ = TextBox.Text
	Result$ =  ""

	For nCount% = 1 To len(TextString$)
		actChar$ = Mid(TextString$, nCount%, 1)
		If (actChar$ = "?") Then
			Result$ = Result$ + "_"
		Else
			If (actChar$ = "*") Then
				Result$ = Result$ + "%"
			Else
				Result$ = Result$ + actChar$
			End If
		End If
	Next

	TextBox.Text = Result$
End Sub

' -----------------------------------------------------------------------------
Function QueryCreateSQLStatement$()
	Dim ActiveTable$, ActiveFields$, Statement$, SQLExpression$, sRelOperator$, RelOperator$
	Dim nCount%
	Dim bFirstValue%, bIsLineCorrect%, cChar$, sFldName$
	Dim nFieldType as integer

	ActiveTable$ = ""
	ActiveFields$ = ""
	Statement$ = "Select "

	If (lbFields.ListCount()=0 Or lbSelected.ListCount()=0) Then
		ActiveFields$ = "*"
	Else
		For nCount% = 0 To lbSelected.ListCount()-1
			'	Chr(34) = " / Chr(39) = '
			ActiveFields$ = ActiveFields$ + Chr(34) + lbSelected.List(nCount%) + Chr(34)
			If (nCount%<lbSelected.ListCount()-1) Then ActiveFields$ = ActiveFields$ + ", "
		Next
	End If
	Statement$ = Statement$ + ActiveFields$

	ActiveTable$ = lbTables.List(DlgQuery.lbTables.ListIndex())
	Statement$ = Statement$ + " from " + UNOQuoteTableName(ActiveTable$, aCurrentDb)

	SQLExpression$ = ""
	bFirstValue% = True

	For nCount% = 0 To 4
		'	Test: All Data of the current row available,
        '   with the exception of the first case
		If (nCount%=0) Then
			bIsLineCorrect% = True
		Else
			bIsLineCorrect% = ControlArray(nCount%,cLogic).Enabled
		End If
		bIsLineCorrect% = bIsLineCorrect% And (ControlArray(nCount%,cFieldName).Enabled And (ControlArray(nCount%,cFieldName).ListIndex>0))
		bIsLineCorrect% = bIsLineCorrect% And ControlArray(nCount%,cRelOperator).Enabled
		If (bIsLineCorrect%) Then
			sRelOperator$ = ControlArray(nCount%,cRelOperator).List(ControlArray(nCount%,cRelOperator).ListIndex)
			If ((sRelOperator$<>Query_ilComboBoxCondition_Empty$) And (sRelOperator$<>Query_ilComboBoxCondition_NotEmpty$)) Then
				bIsLineCorrect% = bIsLineCorrect% And (ControlArray(nCount%,cValue).Text<>"")
			End If
		End If

		'	If all data is available, expand the SQL expression
		If (bIsLineCorrect%) Then
			'	Logical operatof if this is not the first value
			If (bFirstValue%) Then
				bFirstValue% = False
			Else
				Select Case (ControlArray(nCount%,cLogic).Text)
					Case Query_ilComboBoxLogic_And$
						SQLExpression$ = SQLExpression$ + " And "
					Case Query_ilComboBoxLogic_Or$
						SQLExpression$ = SQLExpression$ + " Or "
				End Select
			End If
            '   Fieldname
			sFldName$ = ControlArray(nCount%,cFieldName).Text
			SQLExpression$ = SQLExpression$ + "(" + Chr(34) + sFldName$ + Chr(34)
			'	RelOperator and optional Value
			RelOperator$ = ControlArray(nCount%,cRelOperator).Text

			'	Chr(34) = " / Chr(39) = '

            ' if its is an integer/Float/double/single Field,
            ' then no wrapping ' arround the expression

			nFieldType = aCurrentFields.getByName(sFldName$).Type
			if	(nFieldType = DatabaseFieldType_CHAR) or _
				(nFieldType = DatabaseFieldType_VARCHAR) or _
				(nFieldType = DatabaseFieldType_LONGVARCHAR) Then
				cChar$ = chr( 39 )
			else
				cChar$ = ""
			endif

			Select Case (RelOperator$)
				Case "=","<",">","<=",">=","<>"
					SQLExpression$ = SQLExpression$ + " " + RelOperator$ + " " + cChar$ + ControlArray(nCount%,cValue).Text + cChar$
				Case Query_ilComboBoxCondition_Like$
					QueryCheckSQLExpression(ControlArray(nCount%,cValue))
					SQLExpression$ = SQLExpression$ + " LIKE " + cChar$ + ControlArray(nCount%,cValue).Text + cChar$
				Case Query_ilComboBoxCondition_NotLike$
					QueryCheckSQLExpression(ControlArray(nCount%,cValue))
					SQLExpression$ = SQLExpression$ + " NOT LIKE " + cChar$ + ControlArray(nCount%,cValue).Text + cChar$
				Case Query_ilComboBoxCondition_Empty$
					SQLExpression$ = SQLExpression$ + " IS NULL "
				Case Query_ilComboBoxCondition_NotEmpty$
					SQLExpression$ = SQLExpression$ + " IS NOT NULL "
			End Select
			SQLExpression$ = SQLExpression$ + ")"
		End If
	Next

	If (SQLExpression$<>"") Then SQLExpression$ = " where " + SQLExpression$
	SQLExpression$ = Statement$ + SQLExpression$

	If ((cmbSort1.ListIndex>0) Or (cmbSort2.ListIndex>0) Or (cmbSort3.ListIndex>0) Or (cmbSort4.ListIndex>0)) Then
		Dim cmbSort(1 To 4) As Object
		Dim cmdSort(1 To 4) As Object

		cmbSort(1) = cmbSort1
		cmbSort(2) = cmbSort2
		cmbSort(3) = cmbSort3
		cmbSort(4) = cmbSort4

		cmdSort(1) = cmdSort1
		cmdSort(2) = cmdSort2
		cmdSort(3) = cmdSort3
		cmdSort(4) = cmdSort4

		SQLExpression$ = SQLExpression$ + " Order By "

		For nCount% = 1 To 4
			If (cmbSort(nCount%).ListIndex>0) Then
				SQLExpression$ = SQLExpression$ + cmbSort(nCount%).List(cmbSort(nCount%).ListIndex)
				If (cmdSort(nCount%).Caption = DlgQuery_4_labelSortDown$) Then SQLExpression$ = SQLExpression$ + " DESC"
				SQLExpression$ = SQLExpression$ + ", "
			End If
		Next

		SQLExpression$ = Left(SQLExpression$, Len(SQLExpression$) - 2)

	End If

	QueryCreateSQLStatement$ = SQLExpression$

End Function

' -----------------------------------------------------------------------------
Sub QueryCreateNow()
	if (Not CheckQueryTitle()) Then
		Exit Sub
	End If

	Dim sFinalTitle$, sFinalSQLString$, sClose$
	Dim aFinalObject as Object

	Application.EnterWait()
	Wait( 0 )

	DlgQuery.Hide()

	sFinalSQLString$ = QueryCreateSQLStatement$()

	sFinalTitle$ = DlgQuery.txtQueryTitle.Text
	aFinalObject = aCurrentDb.getQueries().create()
	If (not IsNull(aFinalObject)) Then
		aFinalObject.Query = sFinalSQLString$
		aFinalObject.IsPassThrough = FALSE
		aCurrentDb.getQueries().insertByName(sFinalTitle$, aFinalObject)

		If (DlgQuery.OptRunNow.Value=True) Then
			QueryShowAfterCreate% = True
			Dim aDummyArgs()
			StarDesktop.LoadComponentFromURL(aFinalObject.URL, "_blank", 8, aDummyArgs())
		Else
			Application.Beamer = QueryBeamerActiveAtStart%
			MsgBox(Query_gSuccessMsg$, 64, Query_gWizardname$ )
		End If
	Else
		MsgBox(Query_gFinalError$, 16, Query_gWizardname$ )
	End If

	QueryReturnValue$ = DlgQuery.txtQueryTitle.Text
	DlgQuery.Unload()

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub


