'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=CalSaveTextValues0
'SBLLINK:MethodInfo=CalRestoreOldValues0
'SBLLINK:MethodInfo=CalChangeYear0
'SBLLINK:MethodInfo=CalCalcPictureData0
'SBLLINK:MethodInfo=CalPreviewPaint0
'SBLLINK:MethodInfo=CalcmdDeleteSelect0
'SBLLINK:MethodInfo=CalDeleteAllSelected0
'SBLLINK:MethodInfo=CalSaveOwnEventControls0
'SBLLINK:MethodInfo=CalSpinOwnEventDayUp0
'SBLLINK:MethodInfo=CalSpinOwnEventDayDown0
'SBLLINK:MethodInfo=CalSpinGeneralYearUp0
'SBLLINK:MethodInfo=CalSpinGeneralYearDown0
'SBLLINK:MethodInfo=CalSpinOwnEventYearDown0
'SBLLINK:MethodInfo=CalSpinOwnEventYearUp0
'SBLLINK:MethodInfo=CalSpinGeneralMonthUp0
'SBLLINK:MethodInfo=CalSpinGeneralMonthDown0
'SBLLINK:MethodInfo=CalSpinOwnEventMonthDown0
'SBLLINK:MethodInfo=CalSpinOwnEventMonthUp0
'SBLLINK:MethodInfo=CalChkYearEnDisabled0
'SBLLINK:MethodInfo=CalMouseMoved0
'SBLLINK:MethodInfo=CalChangeGeneralMonth0
'SBLLINK:MethodInfo=CalChkForChangeInsertAccept0
'SBLLINK:MethodInfo=CalClearInputMask0
'SBLLINK:MethodInfo=CalCountSelected0
'SBLLINK:MethodInfo=CalmdSwitchOwnDataOrGeneral0
'SBLLINK:MethodInfo=LoadDialog0
'SBLLINK:MethodInfo=ShowDialog0
'SBLLINK:MethodInfo=ModIntTextBox0
'SBLLINK:MethodInfo=CalModMonthTextBox0
Option Explicit

Dim CalBitmap As Object


Sub Main()
	Call CalAutopilotTable()
End Sub


Sub CalSaveTextValues()
	txtYear.Tag = txtYear.Text
	txtMonth.Tag = txtMonth.Text
End Sub


Sub CalRestoreOldValues()
	Beep
	' Start of the Gregorian Calendar
	If int(Val(txtyear.Text)) < 1583 then
		txtYear.Text = "1583"
	Else
		' last year where the easter Routin works
		txtYear.Text = "9956"
	End If
	txtMonth.Text = txtMonth.Tag
End Sub



Sub CalChangeYear()
	Dim ValNewYear&
	ValNewYear& = Val(txtYear.Text)
	If ((1583 > ValNewYear&) Or (9956 < ValNewYear&)) Then
		Call CalRestoreOldValues()
	End If          
End Sub



Sub CalCalcPictureData()
	Dim bFittingX%, bFittingY%, DlgWidth%, DlgHeight%, nXMove%, nYMove%, Width%, Height%
	Dim x#, y#

	Width% = 152
	Height% = 189
	BitmapDir = GetBitmapDir()	

	Set CalBitmap = LoadPicture(BitmapDir & GetPathSeparator() & sBitmapFilename$ '(sCurLangLocale))
	If 1 = GetGUIType() Then
		DlgHeight% = CInt(DlgBuffer.Preview1.Height * GetDialogZoomFactorY(DlgBuffer.Preview1.Height))
		DlgWidth% = CInt(DlgBuffer.Preview1.Width * GetDialogZoomFactorX(DlgBuffer.Preview1.Width))
		nXMove% = TwipsPerPixelX() * 3
		nYMove% = TwipsPerPixelX() * 3
	Else
		DlgHeight% = CInt((DlgBuffer.Preview1.Height - TwipsPerPixelY() * 3) * GetDialogZoomFactorY(DlgBuffer.Preview1.Height))
		DlgWidth% = CInt((DlgBuffer.Preview1.Width - TwipsPerPixelX() * 3) * GetDialogZoomFactorX(DlgBuffer.Preview1.Width))
		nXMove% = 0
		nYMove% = 0
	End If
	
	CalTWIPSPicWidth% = TwipsPerPixelX() * Width%
	CalTWIPSPicHeight% = TwipsPerPixelY() * Height%
	
	'       Beste Mglichkeit: Bild in Orignalgroesse zentrieren
	'       Alternative : Nach schlchechter passenden Faktor skalieren
	If (Not ((CalTWIPSPicWidth% <= DlgWidth%) And (CalTWIPSPicHeight% <= DlgHeight%))) Then
		x# = (CalTWIPSPicWidth% / DlgWidth%)
		y# = (CalTWIPSPicHeight% / DlgHeight%)
		If (x# > y#) Then
			CalTWIPSPicWidth% = CInt(DlgWidth%)
			CalTWIPSPicHeight% = CInt(CalTWIPSPicHeight% / x#)
		Else
			CalTWIPSPicHeight% = CInt(DlgHeight%)
			CalTWIPSPicWidth% = CInt(CalTWIPSPicWidth% / y#)
		End If
	End If

	CalStartX% = CInt((DlgWidth% / 2) - (CalTWIPSPicWidth% / 2)) - nXMove%
	CalStartY% = CInt((DlgHeight% / 2) - (CalTWIPSPicHeight% / 2)) - nYMove%
End Sub



Sub CalPreviewPaint()
	Preview1.Cls()
	Preview1.DrawPicture(CalBitmap, CalStartX%, CalStartY%, CalStartX% + CalTWIPSPicWidth%, CalStartY% + CalTWIPSPicHeight%)
	Preview1.DrawBox(CalStartX%, CalStartY%, CalStartX% + CalTWIPSPicWidth%, CalStartY% + CalTWIPSPicHeight%)
End Sub



Sub CalcmdDeleteSelect()

	Dim Count%, CountMarked%, MsgBoxResult%, AllSelected%
	
	AllSelected = False
	CountMarked% = 0
	For Count% = 0 To lbOwnData.ListCount-1
		If (DlgBuffer.lbOwnData.Selected(Count%) = True) Then CountMarked% = CountMarked% + 1
	Next

	If (CountMarked% > 0) Then
		MsgBoxResult% = MsgBox(cCalSubCmdDeleteSelect_DeleteSelEntry$, 4+32, cCalSubCmdDeleteSelect_DeleteSelEntryTitle$)

		If MsgBoxResult% = 6 Then
			If Not AllSelected% Then
				Call CalDeleteAllSelected()
			Else
				DlgBuffer.lbOwnData.Clear()
			End If
			'       Flag zum Speichern der neuen Daten.
			CalOwnDataChanged% = True

			cmdDelete.Enabled = False
			Call CalClearInputMask()
		End If
	End If
End Sub



Sub CalDeleteAllSelected()

	Dim Count%, LastSelPos%

	While LastSelPos% <> -1
		LastSelPos% = -1
		For Count%=0 To lbOwnData.ListCount()-1
			If DlgBuffer.lbOwnData.Selected(Count%) Then LastSelPos% = Count%
		Next
		If LastSelPos% <> - 1 Then
			DlgBuffer.lbOwnData.RemoveItem(LastSelPos%)
		End If
	Wend
	DlgBuffer.lbOwnData.Refresh()
End Sub



Sub CalSaveOwnEventControls()
	DlgBuffer.txtOwnEventDay.Tag = DlgBuffer.txtOwnEventDay.Text
	DlgBuffer.txtOwnEventMonth.Tag = DlgBuffer.txtOwnEventMonth.Text
	DlgBuffer.txtOwnEventYear.Tag = DlgBuffer.txtOwnEventYear.Text
End Sub



Sub ModIntTextBox (txtYear As Object, ByVal nMax%, ByVal nMin%, ByVal sDefault$, IncFactor as Integer)
	Dim nActVal&
	nActVal& = Val(txtYear.Text)
	If ((0 = nActVal&) Or (nMax% < nActVal&) Or (nMin% > nActVal&)) Then 
		Beep
		txtYear.Text = sDefault$
		Exit Sub
	End If
	If IncFactor = 1 Then
		If nMax% > nActVal& Then
			txtYear.Text = Trim(Str(nActVal& + 1))
		Else
			Beep
			txtYear.Text = nMax%
		End if
	ElseIf IncFactor = -1 Then
		If nMin% < nActVal& Then
			txtYear.Text = Trim(Str(nActVal& - 1))
		Else
			Beep
			txtYear.Text = nMin%
		End if
	End If
End Sub


Sub CalSpinOwnEventDayUp()
	Call ModIntTextBox(txtOwnEventDay, 31, 1, "1", 1)
End Sub


Sub CalSpinOwnEventDayDown()
	Call ModIntTextBox(txtOwnEventDay, 31, 1, "1", -1)
End Sub


Sub CalSpinGeneralYearUp()
	Call ModIntTextBox(txtYear, 9956, 1583, Trim(Str(Year(Now()))),1)
End Sub


Sub CalSpinGeneralYearDown()
	Call ModIntTextBox(txtYear, 9956, 1583, Trim(Str(Year(Now()))), -1 )
End Sub


Sub CalSpinOwnEventYearDown()
	Call ModIntTextBox(txtOwnEventYear, 9956, 1583, Trim(Str(Year(Now()))), -1 )
End Sub


Sub CalSpinOwnEventYearUp()
	Call ModIntTextBox(txtOwnEventYear, 9956, 1583, Trim(Str(Year(Now()))) , 1)
End Sub


Sub CalModMonthTextBox(txtMonth As Object,IncFactor as Integer)
	Dim nActVal&
	nActVal& = Val(txtMonth.Text)
	If (1 <= nActVal& And 12 >= nActVal) Then
		txtMonth.Text = cCalShortMonthNames$(nActVal&)
	End If
	nActVal& = CalGetIntOfShortMonthName%(txtMonth.Text)
	If 0 = nActVal& Then
		Beep
		txtMonth.Text = cCalShortMonthNames$(1)
	ElseIf (1 < nActVal&) AND (IncFactor = -1) Then
		txtMonth.Text = cCalShortMonthNames$(nActVal& + IncFactor)
	ElseIf (12 > nActVal&)AND (IncFactor = 1) Then
		txtMonth.Text = cCalShortMonthNames$(nActVal& + IncFactor)
	End If
End Sub


Sub CalSpinGeneralMonthUp()
	CalModMonthTextBox(txtMonth, 1)
End Sub


Sub CalSpinGeneralMonthDown()
	CalModMonthTextBox(txtMonth,-1)
End Sub


Sub CalSpinOwnEventMonthDown()
	Call CalModMonthTextBox(txtOwnEventMonth, -1)
End Sub


Sub CalSpinOwnEventMonthUp()
	Call CalModMonthTextBox(txtOwnEventMonth, 1)
End Sub


Sub CalChkYearEnDisabled()
	'       Falls der RadioButton fr einen Jahreskalender angeklickt
	'       worden ist, mssen die Controls fr den Monat Disabled
	'       werden, da ihre Werte in einer Jahrestabelle aufgehen.
	lblEventYear.Enabled     = Not lblEventYear.Enabled
	txtownEventYear.Enabled  = Not txtownEventYear.Enabled
	SpinOwnEventYear.Enabled = Not SpinOwnEventYear.Enabled
	If (txtOwnEventYear.Text = "") And (lblEventYear.Enabled = True) Then
		txtOwnEventYear.Text = Trim$(Str$(Year(Now())))
	End If
End Sub


Sub CalMouseMoved(Button as integer, Shift as integer, X as single, Y as single)

	'       Nimmt Mousemoves ueber dem Bitmap entgegen, und wertet sie je nach
	'       Land aus.

	Select Case sCurLangLocale
		Case  "de" 'cLANGUAGE_GERMAN
		'       Ermittelt das Land auf dem sich der MausCursor befindet, und 
		'       aktualisiert die Textbox mit der Bundeslandbezeichnung, falls
		'       ein Mausklick stattfandt.
			Dim Land$
			If (Button = 1) Or (MouseClicked% = False)Then 
				cmbState.ListIndex = CalGetGermanLandAtMousePos(X, Y, Land$)
			End If
	End Select
	
	LastMousePosX = X
	LastMousePosY = Y
End Sub


Sub CalChangeGeneralMonth()

	Dim MonthToCheck$
	Dim ValMonthToCheck%

	MonthToCheck$ = DlgBuffer.txtMonth.Text
	ValMonthToCheck% = Val(MonthToCheck$)

	If (ValMonthToCheck% >= 1) And (ValMonthToCheck% <=12) Then
		DlgBuffer.txtMonth.Text = cCalShortMonthNames$(ValMonthToCheck%)
		Exit Sub
	End If

	If CalGetIntOfShortMonthName%(Trim(Left(MonthToCheck$, 3))) = 0 Then
		Beep
		DlgBuffer.txtMonth.Text = DlgBuffer.txtMonth.Tag
	Else
		DlgBuffer.txtMonth.Text = Trim(Left(MonthToCheck, 3))
	End If

End Sub



Sub CalChkForChangeInsertAccept
	'       Aktualisiert die Caption des Insert/Accept Buttons
	If (DataSelectedFromList=True) And (ButtonCaptionIsInsert) Then
		DlgBuffer.cmdInsert.Caption = cSubChkForChangeInsertAccept_Accpet$
	End If
End Sub



Sub CalClearInputMask()
	'       Lscht die Werte der Eingabe Controls fr ein 
	'       neues Ereignis.
	chkEventOnce.Value = False
	lblEventYear.Enabled = False
	txtownEventYear.Enabled = False
	SpinOwnEventYear.Enabled = False
	txtOwnEventYear.Text = ""
	txtEvent.Text = ""
	txtOwnEventDay.Text = ""
	txtOwnEventMonth.Text = ""
	
	txtEvent.SetFocus()
End Sub



Function CalCountSelected%(ByVal listBox as Object, PosSelect%)
	'       Zhlt die selekierten Eintrge im Control listBox.
	'       PosSelect liefert den Index des selektierten Eintrags 
	'       zurck. Dieser Wert ist natrlich nur zu gebrachen, 
	'       wenn nur ein Eintrag selektiert ist.
	Dim Count%, Result%

	Result% = 0
	For Count% = 0 To listBox.ListCount-1
		If ListBox.Selected(Count%) Then
			Result% = Result% + 1
			PosSelect% = Count%
		End If
	Next
	CalCountSelected% = Result%     
End Function



Sub CalmdSwitchOwnDataOrGeneral()
	
	'ndert den Titel der Dialogbox beim Seitenwechsel und die 
	'Beschriftungen der Knpfe
	If DlgBuffer.CurrentStep = 1 Then
		DlgBuffer.CurrentStep = 2
		DlgBuffer.DlgCmdOwnData.Caption = cCalSubcmdSwitchOwnDataOrGeneral_Back$
	Else
		DlgBuffer.CurrentStep = 1
		DlgBuffer.DlgCmdOwnData.Caption = cCalSubcmdSwitchOwnDataOrGeneral_OwnData$
	End If
End Sub


Sub LoadDialog()
	DlgBuffer.load
End Sub

Sub ShowDialog()
	DlgBuffer.Show
End Sub
