'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=CalGetGermanLandAtMousePos0
'SBLLINK:MethodInfo=CalMouseClick0
'SBLLINK:MethodInfo=CalSyncInternalVars0
'SBLLINK:MethodInfo=CalFindWholeYearHolidays_GERMANY0
Option Explicit

Sub Main()
	Call CalAutopilotTable()
End Sub

Function CalGetGermanLandAtMousePos(byval X as single, byval Y as single, Land$)
	'	Liefert das BundesLand, das sich unter Maus befindet.

	X = X / TwipsPerPixelX()
	Y = Y / TwipsPerPixelY()
	X = X * (189.0 / 152.0) - ((CalStartX% * (189.0 / 152.0)) / TwipsPerPixelX())
	Y = Y * (224.0 / 189.0) - ((CalStartY% * (224.0 / 189.0)) / TwipsPerPixelY())

	If (X>78)And(X<140)And(Y>130)And(Y<211) Then
		CalChoosenLand% = CalBLBayern

	ElseIf (X>44)And(X<78)And(Y>153)And(Y<209) Then 
		CalChoosenLand% = CalBLBadenWuert
		
	ElseIf (X>9)And(X<30)And(Y>149)And(Y<164) Then 
		CalChoosenLand% = CalBLSaarland
		
	ElseIf (X>6)And(X<44)And(Y>125)And(Y<148) Then 
		CalChoosenLand% = CalBLRheinlandPfalz
		
	ElseIf (X>4)And(X<53)And(Y>78)And(Y<125) Then 
		CalChoosenLand% = CalBLNordrheinWest

	ElseIf (X>53)And(X<78)And(Y>101)And(Y<140) Then 
		CalChoosenLand% = CalBLHessen

	ElseIf (X>80)And(X<110)And(Y>101)And(Y<131) Then 
		CalChoosenLand% = CalBLThueringen
		
	ElseIf (X>122)And(X<172)And(Y>91)And(Y<121) Then 
		CalChoosenLand% = CalBLSachsen
		
	ElseIf (X>54)And(X<100)And(Y>3)And(Y<39) Then 
		CalChoosenLand% = CalBLSchlHolstein

	ElseIf (X>86)And(X<98)And(Y>40)And(Y<52) Then 
		CalChoosenLand% = CalBLHamburg

	ElseIf (X>100)And(X<162)And(Y>24)And(Y<53) Then 
		CalChoosenLand% = CalBLMeckPomm

	ElseIf (X>59)And(X<74)And(Y>60)And(Y<69) Then 
		CalChoosenLand% = CalBLBremen

	ElseIf (X>57)And(X<63)And(Y>47)And(Y<55) Then 
		CalChoosenLand% = CalBLBremen

	ElseIf (X>28)And(X<86)And(Y>39)And(Y<79) Then 
		CalChoosenLand% = CalBLNiedersachsen

	ElseIf (X>69)And(X<97)And(Y>52)And(Y<98) Then 
		CalChoosenLand% = CalBLNiedersachsen

	ElseIf (X>99)And(X<122)And(Y>62)And(Y<101) Then 
		CalChoosenLand% = CalBLSachsenAnhalt

	ElseIf (X>138)And(X<151)And(Y>69)And(Y<80) Then 
		CalChoosenLand% = CalBLBerlin

	ElseIf (X>125)And(X<168)And(Y>57)And(Y<91) Then 
		CalChoosenLand% = CalBLBrandenburg
	End If
	If (CalChoosenLand >= Lbound(BLNameList)) AND ((CalChoosenLand <= Ubound(BLNameList))) Then
		Land$ = BLNameList(CalChoosenLand)
	End If
	CalGetGermanLandAtMousePos = CalChoosenLand%
End Function

	
Sub CalMouseClick()
	'	Wenn der MausCursor auf dem Previewfeld steht, und die
	'	linke Maustaste gedrueckt wird, wird das aktive Aktualisieren
	'	des Bundeslandes durch MouseClicked% = True unterbunden.

	CalMouseMoved(1, 0, LastMousePosX, LastMousePosY)

	If (CalChoosenLand%>=CalBLBayern) And (CalChoosenLand%<=CalBLThueringen) Then 
		MouseClicked% = True
		LandWhenClick% = CalChoosenLand%
	End If
End Sub


Sub CalSyncInternalVars()
	MouseClicked% = True
	CalChoosenLand% =  DlgBuffer.cmbState.ListIndex
	LandWhenClick% = CalChoosenLand%
End Sub



Sub CalFindWholeYearHolidays_GERMANY(byval YearInt%, byval Country%)
	
	'	Ermittelt die Feiertage eines gesamten Jahres (Parameter YearInt%),
	'	bezogen auf ein bestimmtes Bundesland (Parameter Country%). Kein 
	'	bestimmtes Bundesland bedeutet, dass der Parameter gleich der 
	'	Konstante calBLHamburg ist, da Hamburg nur Standardfeiertage kennt. 
	'	Die Feiertage werden in das Array CalBankHolidayName$ geschrieben. 
	'	Der Index dieses Arrays geht bis vierhundert. Der 1. Januar hat den 
	'	Indexwert 1, der 2. Januar den Indexwert 2 usw. Das bedeutet, da 
	'	wenn am 2. Januar kein Feiertag existiert, liefert 
	'	CalBankHolidayName$(DateSerial(0, 1, 2) eine leere Zeichenkette ("").

	Dim So%, Count%
	Dim OsternDate&, VierterAdvent&

	If (Country% < 1) Or (Country% > 16) Then 
		Country% = CalBLHamburg
	End If
	OsternDate& = CalEasterTable&(YearInt%)
	So% = 1

	CalInsertBankholiday(DateSerial(YearInt%, 1, 1), "Neujahr", cHolidayType_Full)
	
	If (country% = CalBLBayern) Or (country% = CalBLBadenWuert) Or (country% = CalBLSachsenAnhalt) Then
		CalInsertBankholiday(DateSerial(YearInt%, 1, 6), "Hl. 3 Knige", cHolidayType_Full)
	End If
	
	CalInsertBankholiday(OsternDate&-2, "Karfreitag", cHolidayType_Full)
	CalInsertBankholiday(OsternDate&, "Ostersonntag", cHolidayType_Full)
	CalInsertBankholiday(OsternDate&+1, "Ostermontag", cHolidayType_Full)
	CalInsertBankholiday(DateSerial(YearInt%, 5, 1), "Maifeiertag", cHolidayType_Full)
	CalInsertBankholiday(OsternDate&+39, "Christi Himmelfahrt", cHolidayType_Full)
	CalInsertBankholiday(OsternDate&+49, "Pfingstsonntag", cHolidayType_Full)
	CalInsertBankholiday(OsternDate&+50, "Pfingstmontag", cHolidayType_Full)

	If (country% = CalBLBadenWuert) Or (country% = CalBLBayern) Or (country% = CalBLHessen) Or (country% = CalBLNordRheinWest) Or (country% = CalBLRheinlandPfalz) Or (country% = CalBLSaarland) Or (country% = CalBLSachsen) Or (country% = CalBLThueringen) Then
		CalInsertBankholiday(OsternDate&+60, "Fronleichnam", cHolidayType_Full)
	End If

	If (country% = CalBLBayern) Or (country% = CalBLSaarland) Then
		CalInsertBankholiday(DateSerial(YearInt%, 8, 15), "Mari Himmelfahrt", cHolidayType_Full)
	End If

	CalInsertBankholiday(DateSerial(YearInt%, 10, 3), "Tag der dt. Einheit", cHolidayType_Full)

	If (country%=CalBLBrandenburg) Or (country%=CalBLMeckPomm) Or (country%=CalBLSachsenAnhalt) Or (country%=CalBLSachsen) Or (country%=CalBLThueringen) Then
		CalInsertBankholiday(DateSerial(YearInt%, 10, 31), "Reformationstag", cHolidayType_Full)
	End If

	If (country% = CalBLBadenWuert) Or (country% = CalBLBayern) Or (country% = CalBLNordRheinWest) Or (country% = CalBLRheinlandPfalz) Or (country% = CalBLSaarland) Or (country% = CalBLSachsen) Or (country% = CalBLThueringen) Then
		CalInsertBankholiday(DateSerial(YearInt%, 11, 1), "Allerheiligen", cHolidayType_Full)
	End If

	VierterAdvent& = DateSerial(YearInt%, 12, 24)
	While WeekDay(vierterAdvent&) <> So%
		vierterAdvent& = vierterAdvent& - 1
	Wend

	If country% = CalBLSachsen Then
		CalInsertBankholiday(vierterAdvent&-32, "Bu- und Bettag", cHolidayType_Full)
	Else
		CalInsertBankholiday(vierterAdvent&-32, "Bu- und Bettag", cHolidayType_Half)
	End If		' Dank an die EKD fr die Berechnungsvorschrift des Bu- und Bettags!
	CalInsertBankholiday(vierterAdvent&-21, "1. Advent", cHolidayType_Full)
	CalInsertBankholiday(vierterAdvent&-14, "2. Advent", cHolidayType_Full)
	CalInsertBankholiday(vierterAdvent&-7, "3. Advent", cHolidayType_Full)
	CalInsertBankholiday(vierterAdvent&, "4. Advent", cHolidayType_Full)

	CalInsertBankholiday(Dateserial(YearInt%, 12, 24), "Heiligabend", cHolidayType_Half)
	CalInsertBankholiday(Dateserial(YearInt%, 12, 25), "1. Weihnachtstag", cHolidayType_Full)
	CalInsertBankholiday(Dateserial(YearInt%, 12, 26), "2. Weihnachtstag", cHolidayType_Full)
	CalInsertBankholiday(Dateserial(YearInt%, 12, 31), "Sylvester", cHolidayType_Half)
End Sub
