'SBLLINK:MethodInfo=SubCreateTable0
'SBLLINK:MethodInfo=SubCreateTabelWithDefault0
'SBLLINK:MethodInfo=CreateTable0
'SBLLINK:MethodInfo=TableDataBaseSelect0
'SBLLINK:MethodInfo=TableFindDataBaseDefinitions0
'SBLLINK:MethodInfo=TableFillDatabaseField0
'SBLLINK:MethodInfo=TableGetFileNameWithDescription0
'SBLLINK:MethodInfo=TableReadDataBaseTables0
'SBLLINK:MethodInfo=TableNewTableSelected0
'SBLLINK:MethodInfo=TablelbFieldsClicked0
'SBLLINK:MethodInfo=TablelbChangeSelectedClicked0
'SBLLINK:MethodInfo=TableSetMoveRights0
'SBLLINK:MethodInfo=TableMoveSelected0
'SBLLINK:MethodInfo=TableMoveAll0
'SBLLINK:MethodInfo=TableRemoveSelected0
'SBLLINK:MethodInfo=TableRemoveAll0
'SBLLINK:MethodInfo=TableFieldNameChanged0
'SBLLINK:MethodInfo=TableAcceptNewFieldNameClicked0
'SBLLINK:MethodInfo=CloseConnections0
'SBLLINK:MethodInfo=TableCancelPressed0
'SBLLINK:MethodInfo=TableNextPressed0
'SBLLINK:MethodInfo=TablePrevPressed0
'SBLLINK:MethodInfo=TableSetTitle0
'SBLLINK:MethodInfo=TableTitleGetFocus0
'SBLLINK:MethodInfo=CheckTableTitle0
'SBLLINK:MethodInfo=TableFieldNameGetFocus0
'SBLLINK:MethodInfo=TableFieldNameLostFocus0
'SBLLINK:MethodInfo=TablePreview1Repaint0
'SBLLINK:MethodInfo=TablePreview2Repaint0
'SBLLINK:MethodInfo=TableNoCode0
'SBLLINK:MethodInfo=TableStringOf0
'SBLLINK:MethodInfo=TableFilterSelectedToSelectedField0
'SBLLINK:MethodInfo=TableCreateTableNow0
Option Explicit

Dim TableSelectedDefFile$, TableSelectedTable$, TableReturnValue$
Dim TableDataBaseConnection$, TablePath$, BitmapPath$

Dim ChangesOnSecondPage%

Global SourceFieldsCount%
Global SourceFields$(0 To 200)
Global SelectedFieldsCount%
Global SelectedFields$(0 To 200)

Global TableAvailTables As New Strings
Global TableOriginalFieldList As New Strings

const cPrimKey$ = "PRIMARYKEY"
const cPrimKeyID$ = "P"

' -----------------------------------------------------------------------------
Sub SubCreateTable()
	Call SubCreateTabelWithDefault ( "" )
End Sub

' -----------------------------------------------------------------------------
Sub SubCreateTabelWithDefault ( ByVal DBName$ )
	Call CreateTable$( DBName$ )
End Sub

' -----------------------------------------------------------------------------
Function CreateTable$(OpenedDataBaseConnection$)

'On Error Goto GlobalError

	If (Not InitResources()) Then
		Exit Function
	End If

	Dim nCount%
	
	Application.EnterWait()
	Wait( 0 )

	'	Initialize Global Variables 
	TableDataBaseConnection$ = ""
	TableSelectedTable$ = ""
	TableReturnValue$ = ""
	TablePath$ = ""

	BitmapPath$ = Application.PathSettings.Template
	If InStr (BitmapPath$, ";")<>0 Then
		BitmapPath$ = Left$(BitmapPath$, InStr(BitmapPath$, ";")-1)
	End If
	BitmapPath$ = BitmapPath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	ChangesOnSecondPage% = False
	For SourceFieldsCount% = 0 To 200
		SourceFields$(SourceFieldsCount%) = ""
		SelectedFields$(SourceFieldsCount%) = ""
	Next
	SourceFieldsCount% = 0
	SelectedFieldsCount% = 0

	' load strings and dialog tools
	Application.LoadLibrary( "Tools" )

	'	Executes the database table AutoPilot.
    '   Gets called through Table->New->Table
	TableDataBaseConnection$ = OpenedDataBaseConnection$
	TableReturnValue$ = ""
	CreateTable$ = ""
	TablePath$ = Application.PathSettings.Config + GetPathSeparator()
	DlgTable.Load()
	DlgTable.CurrentStep = 1
	DlgTable.optOpenTablleReadWrite.Value = True
	DlgTable.optEdit.Value = False

	LoadLanguage()

	Call TableSetTitle ()

	If (TableDataBaseConnection$ = "") Then
		DlgTable.cmbAvailDatabase.Visible = True
		DlgTable.frameDatabase.Visible = True
		DlgTable.cmbAvailDatabase.Top = 480
		DlgTable.frameDatabase.Top = 180
		DlgTable.frameTables.Top = DlgTable.frameTables.Top + DlgTable.frameDatabase.Height + 90
		DlgTable.frameTables.Height = DlgTable.frameTables.Height - DlgTable.frameDatabase.Height - 90
		DlgTable.lbTables.Top = DlgTable.lbTables.Top + DlgTable.frameDatabase.Height + 90
		DlgTable.lbTables.Height = DlgTable.lbTables.Height - DlgTable.frameDatabase.Height - 90
		DlgTable.cmbSelectDataBase.Top = DlgTable.cmbSelectDataBase.Top + DlgTable.frameDatabase.Height + 90

		DlgTable.cmbAvailDatabase.Clear()
		For nCount% = 1 To Application.DataDefinedDatabaseNumber()
			DlgTable.cmbAvailDatabase.AddItem(Application.DataDefinedDatabase(nCount%))
		Next

		If (0 = DlgTable.cmbAvailDatabase.ListCount()) Then
			MsgBox( Table_gErrorNoDatabaseInstalled$, 64, Table_gWizardName$ )
			Exit Function
		Else
			DlgTable.cmbAvailDatabase.ListIndex = 0
			TableDataBaseConnection$ = DlgTable.cmbAvailDatabase.List(DlgTable.cmbAvailDatabase.ListIndex())
			Application.OpenDatabaseConnection(TableDataBaseConnection$)
		End If
	Else
		DlgTable.cmbAvailDatabase.Visible = False
		DlgTable.frameDatabase.Visible = False
		Application.OpenDatabaseConnection(TableDataBaseConnection$)
	End If

	'Call GetAllInstalledNamesInDatabase(TableDataBaseConnection$, TableAvailTables)
	Call GetInstalledOwnerTableNamesInDatabase(TableDataBaseConnection$, TableAvailTables)

	Call TableFindDataBaseDefinitions()
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
	DlgTable.Show()
	CreateTable$ = TableReturnValue$
	Call CloseConnections()
	Exit Function
GlobalError:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
	MsgBox(Table_gErrorGlobal$, 16, Table_gWizardName$)
	CreateTable$ = ""
End Function

' -----------------------------------------------------------------------------
Sub TableDataBaseSelect()
	TableDataBaseConnection$ = DlgTable.cmbAvailDatabase.List(DlgTable.cmbAvailDatabase.ListIndex())
	Call GetInstalledOwnerTableNamesInDatabase(TableDataBaseConnection$, TableAvailTables)
End Sub

' -----------------------------------------------------------------------------
Sub TableFindDataBaseDefinitions()
	Dim actFileName$, aLine$
	Dim fileChannel%
	On Error Resume Next

	Application.EnterWait()
	Wait( 0 )

	DlgTable.cmbSelectDataBase.Clear()
	actFileName$ = Dir(TablePath$ + SubstPathVars("db*$(lang).def"))
	While (actFileName$<>"")
		fileChannel% = FreeFile%
		Open TablePath$ + actFileName$ For INPUT As fileChannel%
        Line Input #fileChannel%, aLine$    '   one for the name of the category 
		Close #fileChannel%
		DlgTable.cmbSelectDataBase.AddItem(aLine$)
		actFileName$ = Dir
	Wend
	DlgTable.cmbSelectDataBase.ListIndex = 0
	Call TableReadDataBaseTables()

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

' -----------------------------------------------------------------------------
Sub TableFillDatabaseField(ByVal DB_DefFile$)
	Dim fileChannel%, actPos%, TablesFound%
	Dim aLine$, FileToParse$, actToken$, actChar$
	On Error Resume Next

	Application.EnterWait()
	Wait( 0 )

	TablesFound% = 0
	DlgTable.lbTables.Clear()
	DlgTable.lbFields.Clear()
	fileChannel% = FreeFile%
	Open TablePath$ + DB_DefFile$ For INPUT As fileChannel%
    Line Input #fileChannel%, aLine$ '   one for the name of the category 
	Line Input #fileChannel%, aLine$
	While (aLine$<>"")
		actPos% = 1
		actToken$ = ""
		'	Parse Table name 

		actPos% = InStr(1,aLine$,"=")
		actToken$ = Left(aLine,actPos%-1)
		DlgTable.lbTables.AddItem(actToken$)
		TablesFound% = TablesFound% + 1
		Line Input #FileChannel%, aLine$
	Wend
	Close #FileChannel%
	If (TablesFound%>=1) Then
		DlgTable.lbTables.Selected(0)=True
		Call TableNewTableSelected()
		DlgTable.cmdNextOrReady.Enabled = True
	Else
		DlgTable.cmdNextOrReady.Enabled = False
	End If

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

' -----------------------------------------------------------------------------
Function TableGetFileNameWithDescription$(ByVal TableName$)
	Dim actFileName$, aLine$
	Dim fileChannel%
	On Error Resume Next

	Application.EnterWait()
	Wait( 0 )

	actFileName$ = Dir(TablePath$ + SubstPathVars("db*$(lang).def"))
	fileChannel% = FreeFile%
	Open TablePath$ + actFileName$ For INPUT As fileChannel%
    Line Input #fileChannel%, aLine$ 'One for the name of the category
	Close #fileChannel%
	While (aLine$<>TableName$)
		fileChannel% = FreeFile%
		Open TablePath$ + actFileName$ For INPUT As fileChannel%
        Line Input #fileChannel%, aLine$ 'One for the name of the category
		Close #fileChannel%
		If (aLine$<>TableName$) Then actFileName$ = Dir
	Wend
	TableGetFileNameWithDescription$ = actFileName$

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Function

' -----------------------------------------------------------------------------
Sub TableReadDataBaseTables
	Dim sTitle$

	ChangesOnSecondPage% = True
	If (DlgTable.cmbSelectDataBase.ListCount()>=1) Then
		sTitle$ = DlgTable.cmbSelectDataBase.List(DlgTable.cmbSelectDataBase.ListIndex())
		TableSelectedDefFile$ = TableGetFileNameWithDescription$(sTitle$)
		Call TableFillDatabaseField(TableSelectedDefFile$)
	End If
End Sub

' -----------------------------------------------------------------------------
Sub TableNewTableSelected()
	Dim aLine$,actChar$,StrColumnName$,StrColumnType$,StrTypeOption$
	Dim fileChannel%
	Dim actPos%,lenALine%,n%,oldPos%,TmpPos%
	Application.EnterWait()
	Wait( 0 )

	TableOriginalFieldList.Clear()
	ChangesOnSecondPage% = True
	DlgTable.lbSelected.Clear()
	SourceFieldsCount% = 0
	TableSelectedTable$ = DlgTable.lbTables.List(DlgTable.lbTables.ListIndex())

	DlgTable.txttablename.text = SuggestTableTitleStr$(TableAvailTables, TableSelectedTable$)
	DlgTable.txtTableName.Tag = ""

	DlgTable.lbFields.Clear()
	fileChannel% = FreeFile%
	Open TablePath$+TableSelectedDefFile$ For INPUT As fileChannel%
	Line Input #fileChannel%, aLine$

	'	Find Row/Table name
	While ((aLine$<>"") And (Left(aLine,len(TableSelectedTable$))<>TableSelectedTable$))
		Line Input #fileChannel%, aLine$
	Wend
	Close #FileChannel%
	actPos% = len(TableSelectedTable$) + 1
	lenALine% = len(aLine$)

	'	Parse individual columns 
	While (actPos%<=len(aLine$))
        actPos% = actPos%+1 ' ":" or ","
		StrColumnName$ = ""

		oldPos% = actPos%
		actPos% = InStr(oldPos%,aLine$,"(")
		StrColumnName$ = Mid(aLine$,oldPos%,actPos%-oldPos%)
		actPos% = actPos% + 1
		actChar$ = Mid(aLine$,actPos%,1)
		StrColumnType$ = TableStringOf(actChar$)
		actPos% = actPos% + 1
		StrTypeOption$ = ""
		If (Mid(aLine$,actPos%,1)=":") Then
			actPos% = actPos% + 1
			oldPos% = actPos%
			actPos% = InStr(oldPos%,aLine$,")")
			TmpPos% = InStr(oldPos%,aLine$,":")
			if (TmpPos% > 0) and (TmpPos% < actPos%) then
				actPos% = TmpPos%
			End If
			
			if Mid(aLine$,oldPos%,actPos%-oldPos%) = cPrimKeyID$ then
				actPos%=oldPos%-1
			else		
				StrTypeOption$ = Mid(aLine$,oldPos%,actPos%-oldPos%)
			End If	
		End If
		If (StrColumnType$="Long" Or StrColumnType$="Integer" Or StrColumnType$="Single" Or StrColumnType$="Double") Then
			StrTypeOption$ = StrColumnType$
			StrColumnType$ = "Numeric"
		End If
		SourceFields$(SourceFieldsCount%)=StrColumnName$+","+StrColumnType$+","+StrTypeOption$+","
		If (Mid(aLine$,actPos%,1)=":") Then
			actPos% = actPos% + 1
			oldPos% = actPos%
			actPos% = InStr(oldPos%,aLine$,")")
			if Mid(aLine$,oldPos%,actPos%-oldPos%)= cPrimKeyID$ then
				SourceFields$(SourceFieldsCount%)=SourceFields$(SourceFieldsCount%)+ cPrimKey$
			end if	
		End If
		SourceFieldsCount% = SourceFieldsCount% + 1
		DlgTable.lbFields.AddItem(StrColumnName$)
		TableOriginalFieldList.Add(StrColumnName$)
		actPos% = actPos% + 1
	Wend
	If (DlgTable.lbFields.ListCount()>=1) Then DlgTable.cmdMoveAll.Enabled = True

	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub

'	This part moves the fields back and forth 
' -----------------------------------------------------------------------------
Sub TablelbFieldsClicked()
	cmdMoveSelected.Enabled = ( SelectionInListBox(lbFields) >=1 )
End Sub

' -----------------------------------------------------------------------------
Sub TablelbChangeSelectedClicked()

	Dim nCount%

	For nCount%=0 To lbChangeSelected.ListCount()-1

		If lbChangeSelected.Selected( nCount% ) Then

			txtFieldName.Text = lbChangeSelected.List( nCount% )
			Exit Sub
		End If

	Next
End Sub

' -----------------------------------------------------------------------------
Sub TableSetMoveRights()
	'	Enables and disables the buttons for the moving of the available
	'	fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>lbFields.ListIndex())
	FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex)
	SelectCount% = lbSelected.ListCount()

	cmdRemoveAll.Enabled = (SelectCount%>=1)
	cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	cmdMoveAll.Enabled = (FieldCount%>=1)
	cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
	cmdNextOrReady.Enabled = (SelectCount%>=1)
End Sub

' -----------------------------------------------------------------------------
Sub TableMoveSelected()
	Call MoveSelectedListBox(lbFields, lbSelected)
	Call TableSetMoveRights()
	ChangesOnSecondPage% = True
End Sub

' -----------------------------------------------------------------------------
Sub TableMoveAll()
	Call CopyItemsListBox(lbFields, lbSelected)
	Call TableSetMoveRights()
	ChangesOnSecondPage% = True
	cmdNextOrReady.SetFocus
End Sub

' -----------------------------------------------------------------------------
Sub TableRemoveSelected()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, TableOriginalFieldList, False )
	Call TableSetMoveRights()
	ChangesOnSecondPage% = True
End Sub

' -----------------------------------------------------------------------------
Sub TableRemoveAll()
	Call MoveOrderedSelectedListbox( lbFields, lbSelected, TableOriginalFieldList, True )
	Call TableSetMoveRights()
	ChangesOnSecondPage% = True
End Sub

' -----------------------------------------------------------------------------
Sub TableFieldNameChanged()
	Dim index%

	index% = lbChangeSelected.ListIndex
	If (index%=-1) Then Exit Sub

	cmdAcceptNewFieldName.Enabled=(lbChangeSelected.List(index%)<>txtFieldName.Text)
End Sub

' -----------------------------------------------------------------------------
Sub TableAcceptNewFieldNameClicked()
	Dim len_selected%,bNotFound%,nSelIndex%,nSrcIndex%,nCount%
	Dim OldValue$, NewValue$, ch$, sErrMsg$
	Dim sError$, sWizardName$

	txtFieldName.Text = Trim(txtFieldName.Text)

	sError$ = Table_gErrorInvalidName$
	sWizardName$ = Table_gWizardName$

	Call CheckDatabaseIdentifier( txtFieldName, sError$, sWizardName$ )

	For nCount% = 0 To lbSelected.ListCount()-1
		If ( UCase( lbSelected.List( nCount% ) ) = UCase( txtFieldName.Text ) ) Then
			sErrMsg$ = Table_gErrorItemAvailable$
			Call ReplaceTokenInString ( "$1", txtFieldName.Text, sErrMsg$ )
			MsgBox( sErrMsg$, 64, Table_gWizardName$ )
			txtFieldName.Text = lbSelected.List( lbChangeSelected.ListIndex () )
			txtFieldName.SetFocus()
			Exit Sub
		End If
	Next

	nCount% = lbChangeSelected.ListIndex()
	If ( -1 = nCount% ) Then Exit Sub
	len_selected% = len( lbChangeSelected.List( nCount% ) )

	OldValue$ = lbChangeSelected.List(nCount%)
	bNotFound% = True
	nSelIndex% = 0
	While ((nSelIndex%<SelectedFieldsCount%)And bNotFound%)
		If (Left(SelectedFields$(nSelIndex%),len_selected%)=OldValue$) Then
			bNotFound% = False
			nSrcIndex%=0
			While (SourceFields$(nSrcIndex%)<>SelectedFields$(nSelIndex%))
				nSrcIndex% = nSrcIndex% + 1
			Wend
			NewValue$ = txtFieldName.Text + Right(SelectedFields$(nSelIndex%),len(SelectedFields$(nSelIndex%))-len_selected%)
			SourceFields$(nSrcIndex%) = NewValue$
			SelectedFields$(nSelIndex%) = NewValue$
		End If
		nSelIndex% = nSelIndex% + 1
	Wend

	'	Find OldValue in OriginalList and replace with txtFieldName.Text
	Call ReplaceStringInStrings( TableOriginalFieldList, OldValue$, txtFieldName.Text)

	lbChangeSelected.List(nCount%) = txtFieldName.Text
	lbChangeSelected.Selected(nCount%) = True
	lbChangeSelected.SetFocus()

	lbSelected.Clear()
	For nCount% = 0 To lbChangeSelected.ListCount() - 1
		
		lbSelected.AddItem( lbChangeSelected.List( nCount% ) )
	Next
End Sub

' -----------------------------------------------------------------------------
Sub CloseConnections()
	If ( "" <> Application.GetActiveTableConnection() ) Then
		Application.CloseTableConnection( Application.GetActiveTableConnection() )
	End If
	If ( "" <> Application.GetActiveDatabaseConnection() ) Then
		Application.CloseDatabaseConnection( Application.GetActiveDatabaseConnection() )
	End If
End Sub

'	Page control
' -----------------------------------------------------------------------------
Sub TableCancelPressed()
	Call CloseConnections()
	DlgTable.Hide()
	DlgTable.Unload()
	TableReturnValue$ = ""
End Sub

' -----------------------------------------------------------------------------
Sub TableNextPressed()
	If (DlgTable.CurrentStep = 3) And (Not CheckTableTitle()) Then Exit Sub

	DlgTable.CurrentStep = DlgTable.CurrentStep + 1
	cmdNextOrReady.Visible = (DlgTable.CurrentStep<=3)
	cmdNextOrReady.Enabled = (DlgTable.CurrentStep<=3)
	cmdNextOrReady.SetFocus
	
	Call TableSetTitle()

	If (DlgTable.CurrentStep>=2) Then
		cmdPrev.Enabled=True
		cmdNextOrReady.Enabled = ( 0 < lbSelected.ListCount() )
		if lbSelected.ListCount() <1 then
			cmdMoveAll.SetFocus
		end if
	End If

	If ( 3 = DlgTable.CurrentStep ) Then
		cmdNextOrReady.Enabled = False
		cmdPrev.Enabled = False
		If (ChangesOnSecondPage%=True) Then
			Call TableFilterSelectedToSelectedField()
			ChangesOnSecondPage%=False
		End If
		lbChangeSelected.Selected( 0 ) = True
		Call TableLbChangeSelectedClicked()
		cmdPrev.Enabled = True
		cmdNextOrReady.Enabled = True
		cmdNextOrReady.SetFocus
	End If
	
	If ( 4 = DlgTable.CurrentStep ) Then
		cmdReady.SetFocus
	End If

End Sub

' -----------------------------------------------------------------------------
Sub TablePrevPressed()
	If (DlgTable.CurrentStep = 3) And (Not CheckTableTitle()) Then Exit Sub

	DlgTable.CurrentStep = DlgTable.CurrentStep - 1
	cmdNextOrReady.Visible = (DlgTable.CurrentStep<=3)

	Call TableSetTitle()

	If (DlgTable.CurrentStep=2) Then
		lbSelected.Left = 3780
		lbSelected.Visible = True

		lblAccepted.Left = 3780
		lblAccepted.Visible = True
	End If

	If (DlgTable.CurrentStep=1) Then
		cmdPrev.Enabled = False
		cmdNextOrReady.Enabled = True
	End If
End Sub

' -----------------------------------------------------------------------------
Sub TableSetTitle()
	Select Case (DlgTable.CurrentStep)
		Case 1
			DlgTable.Caption = Table_Dlg_1Caption$
		Case 2
			DlgTable.Caption = Table_Dlg_2Caption$
		Case 3
			DlgTable.Caption = Table_Dlg_3Caption$
		Case 4
			DlgTable.Caption = Table_Dlg_4Caption$
	End Select
End Sub

' -----------------------------------------------------------------------------
Sub TableTitleGetFocus()
	txttablename.tag = txttablename.text
End Sub

' -----------------------------------------------------------------------------
Function CheckTableTitle() as Boolean
	CheckTableTitle = False
	If (Not CheckTableIdentifier( txttablename, Table_gErrorInvalidName$, Table_gWizardName$)) Then
		txttablename.Tag = txttablename.Text
		Exit Function
	End If	
		
	If (Not CheckTableTitleUnique(TableAvailTables, txttablename, Table_gErrorUniqueTitle$, Table_gWizardName$)) Then
		txttablename.Tag = txttablename.Text
		Exit Function
	End If	
	CheckTableTitle = True
End Function

' -----------------------------------------------------------------------------
Sub TableFieldNameGetFocus()
	txtFieldName.Tag = txtFieldName.Text
End Sub

' -----------------------------------------------------------------------------
Sub TableFieldNameLostFocus()
	Call CheckDatabaseIdentifier(txtFieldName)
End Sub

' -----------------------------------------------------------------------------
Sub TablePreview1Repaint
	Call PaintPicOnPreview(DlgTable.Preview1,BitmapPath$+"cjtable0.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub TablePreview2Repaint
	Call PaintPicOnPreview(DlgTable.Preview2,BitmapPath$+"end.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub TableNoCode()
End Sub

' -----------------------------------------------------------------------------
Function TableStringOf$(ByVal index%)
	Select Case(index%)
		Case 0:
			TableStringOf$ = "Text"
		Case 1:
			TableStringOf$ = "Numeric"
		Case 2:
			TableStringOf$ = "Integer"
		Case 3:
			TableStringOf$ = "Long"
		Case 4:
			TableStringOf$ = "Single"
		Case 5:
			TableStringOf$ = "Currency"
		Case 6:
			TableStringOf$ = "Date"
		Case 7:
			TableStringOf$ = "Time"
		Case 8:
			TableStringOf$ = "Bool"
		Case 9:
			TableStringOf$ = "Memo"
	End Select
End Function

' -----------------------------------------------------------------------------
Sub TableFilterSelectedToSelectedField()
	Dim index%, NotFound%, AvailCount%
	Dim SearchToken$, FieldName$, actSourceFieldStr$
	Dim FoundCache%(200)
	Dim FieldNameArray$(200)

	For index%=0 To SourceFieldsCount%-1
		FoundCache%(index%)=True
		actSourceFieldStr$ = SourceFields$(index%)
		FieldNameArray$(index%) = Left(actSourceFieldStr$,InStr(1,actSourceFieldStr$,",")-1)
	Next

	lbChangeSelected.Clear
	For SelectedFieldsCount%=0 To lbSelected.ListCount()-1
		SearchToken$ = lbSelected.List(SelectedFieldsCount%)
		NotFound% = True
		AvailCount% = -1
		While (NotFound%)
			AvailCount% = AvailCount% + 1
			If (FoundCache%(AvailCount%)) Then
				If (FieldNameArray$(AvailCount%)=SearchToken$) Then
					NotFound% = False
					FoundCache%(AvailCount%) = False
				End If
			End If
		Wend
		SelectedFields$(SelectedFieldsCount%) = SourceFields$(AvailCount%)
		lbChangeSelected.AddItem( lbSelected.List( SelectedFieldsCount% ) )
	Next
End Sub

' -----------------------------------------------------------------------------
Sub TableCreateTableNow()
	If (Not CheckTableTitle()) Then Exit Sub

	Dim n%,actPos%, TmpPos%
	Dim DataBaseFields As New Strings
	Dim actChar$,actToken$,sTableName$, sErrMsg$, TmpStr$
	Dim MaxCoulumnChars&
	Dim IsPrimaryKey as Boolean
	Dim aDBEngine, aDBWorkspace, aDBDatabase, aMetaData as Object

	Application.EnterWait()
	Wait( 0 )

	DlgTable.Hide()
	sTableName$ = txtTableName.Text
	If ("" = sTableName$) Then sTableName$ = cmbSelectDataBase.List(cmbSelectDataBase.ListIndex())

	For n% = 0 To SelectedFieldsCount%-1
		'	If the description is longer than 10 characters, truncate it.
		actToken$ = SelectedFields$(n%)
		actPos% = InStr(1,actToken,",")
		MaxCoulumnChars& = Application.GetDatabaseLimits ( 2 )
		If ( ( 0 = MaxCoulumnChars& ) Or ( 50 < MaxCoulumnChars& ) ) Then MaxCoulumnChars& = 50
		If (actPos%>MaxCoulumnChars&) Then
			actToken$ = Left(actToken$,MaxCoulumnChars&) + "," + Right(actToken$,len(actToken$)-actPos%)
		End if
		If (Right(actToken$, 2)=",,") Then
			actToken$ = Left(actToken$, len(actToken$)-1)
		End If
		actPos% = InStr(1,actToken, cPrimKey$)
		if actPos%>0 then ' wenn ein Primarykey vorhanden ist muss TRUE eingefuegt werden
			actToken$ = Left(actToken$, actPos%-1) + "TRUE," + Right(actToken$, len(actToken$)-(actPos%-1))
			IsPrimaryKey = True
		else
			actToken$ = actToken$ + "FALSE"
			IsPrimaryKey = False
		end If
		
		' Wenn StarBase, dann FeldTyp vom PrimaryKey = Zaehler
		' Numerische Angabe wird durch den Typ Zaehler (Counter) ersetzt
		'###################
		
		If (IsPrimaryKey = True) then
			actPos% = InStr(1,actToken$,",") 					'actToken = Name, Numeric, Untertyp, ...
			TmpStr$ = Right(actToken$, Len (actToken$)-actPos%) 'TmpStr = Numeric, Untertyp, ...
			TmpPos% = InStr(1,TmpStr$,",")
			if (Left(TmpStr$, TmpPos%-1) = "Numeric") then
				aDBEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
				aDBWorkspace = aDBEngine.Workspaces.getByIndex(0)
				aDBDatabase  = aDBWorkspace.open(aDBEngine.getLocation(TableDataBaseConnection$))
				aMetaData = aDBDatabase.MetaData
				if (aMetaData.GetInfo(11) = "StarBase") then
					TmpStr$ = Right(TmpStr$, Len (TmpStr$)-TmpPos%)	'TmpStr = Untertyp, ...
					TmpPos% = InStr(1,TmpStr$,",")
					TmpStr$ = Right (TmpStr$, Len(TmpStr$)-TmpPos%)	'TmpStr = TRUE,PRIMARYKEY
					'falls Numeric ohne Untertyp angegeben wurde
					if (InStr(1,TmpStr$,",")>0) then
						actToken$ = Left (actToken$, actPos%-1) + ",Counter," + TmpStr$
					End If	
				End IF	
			End if
		End If
		
		'##################
		
		DataBaseFields.Add(actToken$)
	Next

	If (Not Application.OpenDataBaseConnection(TableDataBaseConnection$)) Then
		sErrMsg$ = Table_gErrorCannotOpenDatabase$
		ReplaceTokenInString ( "$1", TableDataBaseConnection$, sErrMsg$ )
		MsgBox( sErrMsg$, 16, Table_gWizardName$ )
		TableReturnValue$ = ""
		Goto EndOfSub
	End If

	If (Application.CreateTable(sTableName$, DataBaseFields)) Then
		If (optOpenTablleReadWrite.Value) Then
			Application.OpenTable(sTableName$,False)
		Else
			MsgBox( Table_gSuccessCreateTable$, 0, Table_gWizardName$ )
		End If
	Else
		MsgBox( Table_gErrorCreateTable$, 0, Table_gWizardName$ )
		TableReturnValue$ = ""
		Application.CloseDataBaseConnection( TableDataBaseConnection$ )
		Goto EndOfSub
	End If
	Application.CloseDataBaseConnection( TableDataBaseConnection$ )
	TableReturnValue$ = sTableName$
	DlgTable.UnLoad ()

EndOfSub:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend

End Sub
