'SBLLINK:MethodInfo=ChangeAllChars0
'SBLLINK:MethodInfo=SetLanguage0
Private const UPPERREPLACECHAR = "X"
Private const LOWERREPLACECHAR = "x"

Private MSGBOXTITLE
Private NOTSAVEDTEXT
Private WARNING


Sub ChangeAllChars   ' Change all chars in the active document


Call SetLanguage

	if Activedocument.Saved = False then
		Status% = MsgBox(NOTSAVEDTEXT, 3+32, MSGBOXTITLE)
			
			select case Status%
				case 6       ' Yes
					Activedocument.Save
								
				case 2   	 ' Abort
					end
					
			end select
	else
		Status% = MsgBox(WARNING, 3+32, MSGBOXTITLE)
			
			if Status% = 7 or Status% = 2 then  ' No, Abort
				end
			end if
	end if
	

		ActiveWindow.Searchsettings.InSelection = FALSE
		ActiveWindow.Searchsettings.RegExp = TRUE  
		ActiveWindow.Searchsettings.CaseSensitive = True

			ActiveWindow.ReplaceAll "[a-z]", LOWERREPLACECHAR  ' Change all lower characters 
			ActiveWindow.ReplaceAll "[-]", LOWERREPLACECHAR  ' Change all lower special characters
		
			ActiveWindow.ReplaceAll "[A-Z]", UPPERREPLACECHAR  ' Change all upper characters 
			ActiveWindow.ReplaceAll "[-]", UPPERREPLACECHAR  ' Change all upper special characters
			ActiveWindow.ReplaceAll "[0-9]", UPPERREPLACECHAR  ' Change all numbers
	
		ActiveWindow.Searchsettings.RegExp = False
		ActiveWindow.Searchsettings.CaseSensitive = False

end sub


sub SetLanguage


	Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4, cLANGUAGE_DANISH = 1030
	Const cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033, cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036
	Const cLANGUAGE_GERMAN = 1031, cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
	Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_RUSSIAN = 1049, cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053
	Const cLANGUAGE_TURKISH = 1055

	Dim nSelLang%

	Select Case ( Application.LanguageID() )

		Case cLANGUAGE_ENGLISH
			MSGBOXTITLE = "Change all characters to a '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "This Document is modified, this macro change all characters of document"
			WARNING = "This macro changes all characters and numbers to an '" & UPPERREPLACECHAR & "' in this document." 
		
		Case cLANGUAGE_FRENCH
			MSGBOXTITLE = "Remplacer tous les caractres par '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Le document a t modif, la macro remplacera tous les caractres par '" & UPPERREPLACECHAR & "'. Enregistrer avant de procder."
			WARNING = "La macro remplacera tous les caractres et nombres par '" & UPPERREPLACECHAR & "' dans le document." 
		Case cLANGUAGE_ITALIAN
			MSGBOXTITLE = "Sostituire tutti i caratteri '" & UPPERREPLACECHAR & "'"
			NOTSAVEDTEXT = "Il documento  stato modificato, la macro sostituer tutti i caratteri con '" & UPPERREPLACECHAR & "'. Salvare il documento prima di procedere ?"
			WARNING = "La macro sostituir tutti i caratteri e numeri con  '" & UPPERREPLACECHAR & "' nel documento attivo." 	

		Case Else
			MSGBOXTITLE = "Alle Buchstaben gegen ein '" & UPPERREPLACECHAR & "' austauschen"
			NOTSAVEDTEXT = "Das Dokument wurde verndert, mit diesem Makro werden alle Buchstaben gegen ein '" & UPPERREPLACECHAR & "' ausgetauscht, soll ich fr sie das Dokument vorher sichern ?"
			WARNING = "Das Makro ersetzt in dem aktven Dokumente alle Buchstaben und Zahlen gegen ein '" & UPPERREPLACECHAR & "'." 

	end select

end sub
