'SBLLINK:MethodInfo=ConnecttoDatabase0
'SBLLINK:MethodInfo=OpenDocument0
'SBLLINK:MethodInfo=TaskonDesktop0
'SBLLINK:MethodInfo=RetrieveFileName0
'SBLLINK:MethodInfo=FillUpCombo0
'SBLLINK:MethodInfo=Callback_started0
'SBLLINK:MethodInfo=Callback_done0
'SBLLINK:MethodInfo=Callback_canceled0
'SBLLINK:MethodInfo=WritedbgInfo0
'SBLLINK:MethodInfo=WriteDbgString0
'SBLLINK:MethodInfo=printdbgInfo0
'SBLLINK:MethodInfo=ShowArray0
'SBLLINK:MethodInfo=GetPathSettings0
'SBLLINK:MethodInfo=GetBitmapDir0
'SBLLINK:MethodInfo=ShowPropertyValues0
'SBLLINK:MethodInfo=ShowElementNames0
'SBLLINK:MethodInfo=ShowSupportedServiceNames0
'SBLLINK:MethodInfo=ShowAvailableServiceNames0
'SBLLINK:MethodInfo=ShowCommands0
'SBLLINK:MethodInfo=InitResources0
'SBLLINK:MethodInfo=GetResText0
'SBLLINK:MethodInfo=InitializeProgressPage0
'SBLLINK:MethodInfo=CutPathView0
'SBLLINK:MethodInfo=ChangeValueofRange0
'SBLLINK:MethodInfo=GetValueofCellbyName0
'SBLLINK:MethodInfo=GetStringofCellbyName0
'SBLLINK:MethodInfo=GetCellByName0
'SBLLINK:MethodInfo=ChangeCellValue0
'SBLLINK:MethodInfo=GetDocumentType0
'SBLLINK:MethodInfo=GetNumberFormatType0
REM  *****  BASIC  *****
Const SBSHARE = 0
Const SBUSER = 1
Dim Taskindex as Integer
Dim oResSrv as Object

' Connects to different Databases
' Note: certain configurations may have to be modified!!!
' Connects to different Databases
' Note: certain configurations may have to be modified!!!
Function ConnecttoDatabase(DBType as String, DBName as String, UserID as String, Password as String )
Dim i As integer
Dim Found As boolean
Dim allTypes() as String
Dim oEnvironment as Object
	' create the Database engine that handles all Data concerning Database interaction

	oEnvironment = CreateUnoService("com.sun.star.sdb.DatabaseEnvironment")

	Select Case lCase(DBType)
		Case "txt"
      		Dim adbtxtProperties(7)As new com.sun.star.beans.PropertyValue

		    adbTxtProperties(0).Name = "TYPE"
		    adbTxtProperties(0).Value = DBType

		    adbTxtProperties(1).Name = "DSN"
			adbTxtProperties(1).Value = DBName

	        adbTxtProperties(2).Name = "HDR"
	        adbTxtProperties(2).Value= "1"

       		adbTxtProperties(3).Name = "CHARSET"
	        adbTxtProperties(3).Value = "IBMPC"

       		adbTxtProperties(4).Name = "FIX"
	        adbTxtProperties(4).Value = "0"

       		adbTxtProperties(5).Name = "decdel"
	        adbTxtProperties(5).Value = "44"

       		adbTxtProperties(6).Name = "del"
	        adbTxtProperties(6).Value = "9"

       		adbTxtProperties(7).Name = "str"
	        adbTxtProperties(7).Value = 39

			ConnecttoDatabase = oEngine.createConnection(adbTxtProperties())

			Case "dbf"
 		       	Dim adbDBFProperties(1) As new com.sun.star.beans.PropertyValue

			    adbDBFProperties(0).Name = "TYPE"
			    adbDBFProperties(0).Value = DBType

			    adbDBFProperties(1).Name = "DSN"
				adbDBFProperties(1).Value = DBName

				ConnecttoDatabase = oEngine.createConnection(adbDBFProperties())

			Case "dao"
        		Dim adbDAOProperties(1) As new com.sun.star.beans.PropertyValue

			    adbDAOProperties(0).Name = "TYPE"
			    adbDAOProperties(0).Value = DBType

			    adbDAOProperties(1).Name = "DSN"
				adbDAOProperties(1).Value = DBName

				ConnecttoDatabase = oEngine.createConnection(adbDAOProperties())

			Case "odbc","adabas"
        		Dim adbODBCProperties(1)As new com.sun.star.beans.PropertyValue
				Dim oConnection as Object
				Dim sUrl as String
				

    			adbODBCProperties(0).Name = "UID"
  	 			adbODBCProperties(0).Value = UserID

    			adbODBCProperties(1).Name = "PWD"
  	 			adbODBCProperties(1).Value = Password
  	 			sUrl = "sdbc:odbc:" & DBName
				ConnectToDatabase = oEnvironment.GetConnectionWithInfo(sUrl, adbODBCProperties())
'				ConnecttoDatabase = oEngine.createConnection(adbODBCProperties())

'			Case "StarBase"
 '       		Dim adbStarBaseProperties(3)As new com.sun.star.beans.PropertyValue
'
'				If Dir(DBName,16)= "" then
'					GoOn = False
'					Msgbox "Datei " & DBName & " nicht vorhanden!"
'					exit Function
'				End If
'
'			    adbStarBaseProperties(0).Name = "TYPE"
'			    adbStarBaseProperties(0).Value = DBType
'
'			    adbStarBaseProperties(1).Name = "DSN"
'				adbStarBaseProperties(1).Value = DBName
'
'			    adbStarBaseProperties(2).Name = "Transact"
'			    adbStarBaseProperties(2).Value = "False"
'
'			    adbStarBaseProperties(3).Name = "Multiuser"
'				adbStarBaseProperties(3).Value = "True"
'
'				ConnecttoDatabase = oEngine.createConnection(adbStarBaseProperties())
	End Select

End Function

' Opens a Document, checks beforehand, wether it has to be loaded
' or wether it is already on the desktop
' Note: The variable Taskindex ist global and specified in the function
' TaskonDesktop
Function OpenDocument(DocPath as String, Args(), oDesktop as Object)

Dim DocName as String
Dim TaskThere as boolean

'	If Dir(DocPath,16)= "" then
'		Msgbox "Datei '" & DocPath & "' nicht vorhanden"
'		GoOn = False
'		exit Function
'	End If

'	TaskThere = TaskOnDesktop(DocPath, oDesktop)
	TaskThere = False
	' If the Document is already on the Desktop just open it , otherwise load it
	If Taskthere = False Then
		OpenDocument = oDesktop.LoadComponentFromURL(DocPath,"_blank",0,Args())
	Else
		OpenDocument = oDesktop.Components.getbyIndex(TaskIndex)
	End if

End Function


' Checks if a Task is on the Desktop and returns a Boolean
Function TaskonDesktop(LocPath as String, oDesktop as Object) as Boolean
Dim Taskthere as Boolean
Dim i as integer
Dim oComponent as Object
Dim LocUrl as string

	Taskthere = False
	' Search if one of the active Components ist the one that you search for
	PrintdbgInfo oDesktop.Components
	For i = 0 to oDesktop.Components.Count - 1

		oComponent = oDesktop.Components.getbyIndex(i)

  	  	If hasUnoInterfaces(oComponent,"com.sun.star.frame.XModel") then
			LocUrl = oComponent.URL

			If UCase(oComponent.URL) = UCase(LocPath) then
				Taskthere = True
				Taskindex = i
				Exit For
			End If
		End If
	Next
	TaskOnDesktop = TaskThere
End Function


' Retrieves a FileName out of a StarOffice-Document
Function RetrieveFileName(LocDoc as Object)
Dim LocURL as String
Dim LocURLArray() as String
Dim MaxArrIndex as integer

	LocURL = LocDoc.Url
	LocURLArray() = ArrayoutofString(LocURL,"/",MaxArrIndex)
	RetrieveFileName = LocURLArray(MaxArrIndex)
End Function



' clears up a Listbox and refills it with the delivered Array
' ValList()
Sub FillUpCombo(LocListbox as Object, ValList() as String)
Dim i as integer
Dim a as Integer

	LocListbox.Clear
	' Trage die bersetzungsrelevanten Verzeichnisnamen in die Listbox ein
	a = 0
	For i = 0 to Ubound(ValList())
		If ValList(i) <> "" Then
			LocListbox.List(a) = ValList(i)
			a = a + 1
		End If
	Next
End Sub

'---------------------------------------------------------------
' XStatusCallback::started
'---------------------------------------------------------------
Sub Callback_started( Event )
'	Msgbox "CallBack Started"
End Sub

'---------------------------------------------------------------
' XStatusCallback::done
'---------------------------------------------------------------
Sub Callback_done( Event )
	ExecDone = True
End Sub

'---------------------------------------------------------------
' XStatusCallback::canceled
'---------------------------------------------------------------
Sub Callback_canceled( Event )
	Msgbox "Could Not open Directory"
	GoOn = False
End Sub



Sub WritedbgInfo(LocObject)

Dim xLocDesktop as Object
Dim locUrl as String
Dim xLocDocument as Object
Dim xLocText as Object
Dim xLocCursor as Object
Dim NoArgs()

	xLocDesktop = createUnoService("com.sun.star.frame.Desktop")
	LocUrl = "staroffice:factory/swriter"
	xLocDocument = xLocDesktop.LoadComponentFromURL(LocUrl,"_blank",0,NoArgs)
	xLocText = xLocDocument.text
	xLocCursor = xLocText.createTextCursor()
	xLocCursor.gotoStart(False)
	If Vartype(LocObject) = 9 then	' an Object Variable
		xLocText.insertString(xLocCursor,LocObject.dbg_properties,False)
		xLocText.insertString(xLocCursor,LocObject.dbg_methods,False)
		xLocText.insertString(xLocCursor,LocObject.dbg_supportedinterfaces,False)
	Elseif Vartype(LocObject) = 8 Then	' a String Variable
		xLocText.insertString(xLocCursor,LocObject,False)
	ElseIf Vartype(LocObject) = 1 Then
		Msgbox("Variable is Null!", 16, "StarOffice 5.2")
	End If
End Sub



Sub WriteDbgString(LocString as string)
Dim xLocDesktop as object
Dim LocUrl as String
Dim xLocDocument as Object
Dim xLocCursor as Object
Dim xLocText as Object

	xLocDesktop = createUnoService("com.sun.star.frame.Desktop")
	LocUrl = "staroffice:factory/swriter"
	xLocDocument = xLocDesktop.LoadComponentFromURL(LocUrl,"_blank",0,NoArgs)
	xLocText = xLocDocument.text
	xLocCursor = xLocText.createTextCursor()
	xLocCursor.gotoStart(False)
	xLocText.insertString(xLocCursor,LocString,False)
End Sub



Sub printdbgInfo(LocObject)
	If Vartype(LocObject) = 9 then
		Msgbox LocObject.dbg_properties
		Msgbox LocObject.dbg_methods
		Msgbox LocObject.dbg_supportedinterfaces
	Elseif Vartype(LocObject) = 8 Then	' a String Variable
		Msgbox LocObject
	ElseIf Vartype(LocObject) = 1 Then
		Msgbox("Variable is Null!", 16, "StarOffice 5.2")
	End If
End Sub


Sub ShowArray(LocArray() as String)
dim i as integer
dim msgstring
	msgstring = ""
	For i = Lbound(LocArray()) to Ubound(LocArray())
		msgstring = msgstring + LocArray(i) + chr(13)
	Next
	Msgbox msgstring
End Sub


' Gets a special configured PathSetting
Function GetPathSettings(sPathType as String, bshowall as Boolean, Optional ListIndex as integer) as String
Dim oSettings as Object, oPathSettings as Object
Dim sPath as String
Dim PathList() as String
Dim MaxIndex as Integer

	oSettings = createUnoService("com.sun.star.frame.Settings")
 	oPathSettings = oSettings.getByName("PathSettings")
	If bShowAll Then
		ShowPropertyValues(oPathSettings)
	Else
	 	sPath = oPathSettings.GetPropertyValue(sPathType) 
	 	If Not IsNull(ListIndex) Then
			' Share and User-Directory
			If Instr(1,sPath,";") <> 0 Then
				PathList = ArrayoutofString(sPath,";", MaxIndex)
				If ListIndex <= MaxIndex Then
					sPath = PathList(ListIndex)
				Else
					Msgbox "Cannot analyze the String " & sPath , 16, "StarOffice 6.0"
				End If
			End If
	 	End If
	End If
	GetPathSettings = sPath
End Function


' Gets the Directory where all bitmaps are stored
Function GetBitmapDir()
Dim PathSeparator as String
Dim oSettings, oPathSettings as Object
Dim TempList(1), TempDir as String
	oSettings = createUnoService( "com.sun.star.frame.Settings" )
	oPathSettings = oSettings.getByName( "PathSettings" )
	Templist() = ArrayoutofString(oPathSettings.Template,";")
	TempDir = Templist(0)
	PathSeparator = GetPathSeparator()
	GetBitmapDir = TempDir & PathSeparator & "wizard" & PathSeparator() & "bitmap" & PathSeparator()
End Function	


Sub ShowPropertyValues(oLocObject as Object)
Dim PropName as String
Dim sValues as String
	On Local Error Goto NOPROPERTYSETINFO:

	sValues = ""
	For i = 0 To Ubound(oLocObject.PropertySetInfo.Properties)
		Propname = oLocObject.PropertySetInfo.Properties(i).Name
		sValues = sValues & PropName & " = " & oLocObject.GetPropertyValue(PropName) & chr(13)
	Next i
	Msgbox(sValues , 64, "StarOffice 5.2")
	Exit Sub

	NOPROPERTYSETINFO:
	Msgbox("Sorry, No PropertySetInfo attached to the object", 16, "StarOffice 5.2")
	Resume LEAVEPROC
	LEAVEPROC:
End Sub


' Retrieves all the Elements of aSequence of an object, with the 
' possibility to define a filter(sfilter <> "")
Sub ShowElementNames(oLocElements() as Object, sFiltername)
Dim i as Integer
Dim NameString as String
	NameString = ""
	For i = 0 To Ubound(oLocElements()) 
		If sFilterName <> "" Then
			If Instr(1, oLocElements(i), sFilterName) Then
				NameString = NameString & oLocElements(i) & chr(13)
			End If
		Else
			NameString = NameString & oLocElements(i) & chr(13)
		End If
	Next i 
	Msgbox(NameString, 64, "StarOffice 6.0")
End Sub


' Retrieves all the supported servicenames of an object, with the 
' possibility to define a filter(sfilter <> "")
Sub ShowSupportedServiceNames(oLocObject as Object, sFilterName as String)
	On Local Error Goto NOSERVICENAMES
	ShowElementNames(oLocobject.SupportedServiceNames(),sFilterName)
	Exit Sub

	NOSERVICENAMES:
	Msgbox("Sorry, No 'SupportedServiceNames' - Property attached to the object", 16, "StarOffice 5.2")
	Resume LEAVEPROC
	LEAVEPROC:
End Sub


' Retrieves all the available Servicenames of an object, with the 
' possibility to define a filter(sfilter <> "")
Sub ShowAvailableServiceNames(oLocObject as Object, sFilterName as String)
	On Local Error Goto NOSERVICENAMES

	ShowElementNames(oLocobject.AvailableServiceNames,sFilterName)
	Exit Sub
	
	NOSERVICENAMES:
	Msgbox("Sorry, No 'AvailableServiceNames' - Property attached to the object", 16, "StarOffice 5.2")
	Resume LEAVEPROC
	LEAVEPROC:
End Sub


Sub ShowCommands(oLocObject as Object)
	On Local Error Goto NOCOMMANDS

	ShowElementNames(oLocObject.QueryCommands)
	Exit Sub
	
	NOCOMMANDS:
	Msgbox("Sorry, No 'QueryCommands' - Property attached to the object", 16, "StarOffice 5.2")
	Resume LEAVEPROC
	LEAVEPROC:
End Sub


Function InitResources(Description, ShortDescription as String) as boolean

	On Error Goto ErrorOcurred
	oResSrv = createUnoService( "com.sun.star.resource.VclStringResourceLoader" )
	If (IsNull(oResSrv)) then
		InitResources = FALSE
		MsgBox( Description & ": No resource loader found", 16, "StarOffice 5.2" )
	Else
		InitResources = TRUE
		oResSrv.FileName = ShortDescription
	End If
	Exit Function

ErrorOcurred:
	Dim nSolarVer
	InitResources = FALSE
	nSolarVer = GetSolarVersion()
	MsgBox("Resource file missing (" & ShortDescription  & trim(str(nSolarVer)) + "*.res)", 16, "StarOffice 5.2")
	Resume CLERROR
	CLERROR:
End Function


Function GetResText( nID as integer ) As string
	On Error Goto ErrorOcurred
	If Not IsNull( oResSrv ) Then
		' eigentlich sollte hier stehen
		GetResText = oResSrv.getString( nID )
	Else
		GetResText = ""
	End If

	Exit Function

	ErrorOcurred:
	GetResText = ""
	MsgBox("Resource with ID =" + str( nID ) + " not found!", 16, "StarOffice 5.2")
	Resume CLERROR
	CLERROR:
End Function


Sub InitializeProgressPage(oDialog as Object)
	oDialog.LabelRetrieval.Visible = False
	oDialog.LabelCurProgress.Visible = False
	oDialog.LabelRetrieval.FontBold = False
	oDialog.LabelCurProgress.FontBold = True
	oDialog.LabelRetrieval.Visible = True
	oDialog.LabelCurProgress.Visible = True
End Sub


Function CutPathView(sDocUrl as String, PathLen as Integer)
Dim sViewPath as String
	sViewPath = ConvertfromURL(sDocURL)
	iViewPathLen = Len(sViewPath)
	If iViewPathLen > 60 Then
		sViewPath = "..." & Right(sViewPath,58)
	End If 
	CutPathView = sViewPath
End Function		


' Inserts a certain String to all cells of a Range that is referred to by
' its name
Sub ChangeValueofRange(oSheet as Object, sRangeName, ReplaceValue)
Dim oCell as Object
Dim oCellRange as Object
Dim oCellAddress as Object
Dim n, m as Integer
	oCellRange = oSheet.GetCellRangeByName(sRangeName)
	oCellAddress = oCellRange.RangeAddress
	For n = oCellAddress.StartColumn To oCellAddress.EndColumn
		For m = oCellAddress.StartRow To oCellAddress.EndRow
			oCell = oSheet.GetCellByPosition(n,m)
			If Vartype(ReplaceValue) = 8 Then
				' Variabletype is String
				oCell.SetString(ReplaceValue)
			Else
				oCell.Value = ReplaceValue
			End If
		Next m
	Next n
End Sub


' Returns the Value of the first cell of a Range
Function GetValueofCellbyName(oSheet as Object, sCellName as String)
Dim oCell as Object
	oCell = GetCellByName(oSheet, sCellName)
	GetValueofCellbyName = oCell.Value
End Function


' Returns the String of the first cell of a Range
Function GetStringofCellbyName(oSheet as Object, sCellName as String)
Dim oCell as Object
	oCell = GetCellByName(oSheet, sCellName)
	GetStringofCellbyName = oCell.String
End Function


' Returns a named Cell
Function GetCellByName(oSheet as Object, sCellName as String) as Object
Dim oCellRange as Object
Dim oCellAddress as Object
	oCellRange = oSheet.GetCellRangeByName(sCellName)
	oCellAddress = oCellRange.RangeAddress
	GetCellByName = oSheet.GetCellByPosition(oCellAddress.StartColumn,oCellAddress.StartRow)
End Function


' Changes the numeric Value of a cell by transmitting the String of the numeric Value 
Sub ChangeCellValue(oCell as Object, ValueString as String)
Dim CellValue 
	oCell.Formula = "=Value(" & """" & ValueString & """" & ")"
	CellValue = oCell.Value
	oCell.Formula = ""
	oCell.Value = CellValue
End Sub



Function GetDocumentType(oDocument)
	If oDocument.SupportsService("com.sun.star.sheet.SpreadsheetDocument") Then
		GetDocumentType() = "sCalc"
	ElseIf oDocument.SupportsService("com.sun.star.text.TextDocument") Then
		GetDocumentType() = "sWriter"
	ElseIf oDocument.SupportsService("com.sun.star.drawing.DrawingDocument") Then
		GetDocumentType() = "sDraw"
	End If
End Function



Function GetNumberFormatType(oDocFormats, oFormatObject as Object) as Integer
Dim ThisFormatKey as Long
Dim oObjectFormat as Object
	On Local Error Goto NOFORMAT
	ThisFormatKey = oFormatObject.NumberFormat
	oObjectFormat = oDocFormats.GetByKey(ThisFormatKey)
	GetNumberFormatType = oObjectFormat.Type
	NOFORMAT:
	If Err <> 0 Then
		Msgbox("Numberformat of Object is not available!", 16, "StarOffice 5.2")
		GetNumberFormatType = 0
		GOTO NOERROR
	End If
	NOERROR:
	On Local Error Goto 0
End Function