'SBLLINK:MethodInfo=nLoadLanguage0
Public ErrorHeader
Public ErrorMsg1
Public ErrorMsg2
Public HeaderLabel$
Public CancelButton$
Public SaveButton$


Function nLoadLanguage% ( ByVal nLanguage% )

	Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4
	Const cLANGUAGE_DANISH = 1030, cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033
	Const cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036, cLANGUAGE_GERMAN = 1031
	Const cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
	Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_PORTUGUESE = 2070, cLANGUAGE_RUSSIAN = 1049
	Const cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053, cLANGUAGE_TURKISH = 1055

	Dim nSelLang%

	Select Case ( nLanguage% )

		Case cLANGUAGE_ENGLISH
			nSelLang% = 2
			ErrorHeader = "Modify userfields"
			ErrorMsg1 = "It is not possible to fill more than 255 userfields"
			ErrorMsg2 = "No userfields found on this document"
			HeaderLabel$ = "Modify userfields"
			CancelButton$ = "Cancel"
			SaveButton$ = "Save"

		Case cLANGUAGE_FRENCH
			nSelLang% = 3
			ErrorHeader = "Editer les champs utilisateur"
			ErrorMsg1 = "Impossible de remplir plus de 255 champs !"
			ErrorMsg2 = "Il n'y a aucun champs utilisateur dans le document !"
			HeaderLabel$ = "Remplir les champs utilisateur"
			CancelButton$ = "Annuler"
			SaveButton$ = "Sauvegarder"

		Case cLANGUAGE_ITALIAN
			nSelLang% = 4
			ErrorHeader = "Modifica i campi utente"
			ErrorMsg1 = "Non  possibile compilare pi di 255 campi utente"
			ErrorMsg2 = "Nel documento non  stato trovato alcun campo utente!"
			HeaderLabel$ = "Compilazione campi utente"
			CancelButton$ = "Annulla"
			SaveButton$ = "Salva"

		Case cLANGUAGE_SPANISH			
			nSelLang% = 5
			ErrorHeader = "Editar campos del usuario"
			ErrorMsg1 = "No se pueden rellenar ms de 255 campos del usuario"
			ErrorMsg2 = "No se encontraron campos del usuario en el documento!"
			HeaderLabel$ = "Rellenar campos del usuario"
			CancelButton$ = "Cancelar"
			SaveButton$ = "Guardar"
			
		Case cLANGUAGE_PORTUGUESE
			nSelLang% = 6
			ErrorHeader = "Editar campos do utilizador"
			ErrorMsg1 = "No  possvel preencher mais do que 255 campos do utilizador."
			ErrorMsg2 = "No foram encontrados campos do utilizador no documento !"
			HeaderLabel$ = "Preencher campos do utilizador"
			CancelButton$ = "Cancelar"
			SaveButton$ = "Guardar"


		Case cLANGUAGE_DUTCH
			nSelLang% = 7
			ErrorHeader = "Gebruikersvelden bewerken"
			ErrorMsg1 = "Er konden niet meer dan 255 gebruikersvelden worden ingevuld"
			ErrorMsg2 = "In het document werden geen gebruikersvelden gevonden!"
			HeaderLabel$ = "Gebruikersvelden invullen"
			CancelButton$ = "Annuleren"
			SaveButton$ = "Opslaan"

		'	GERMAN & Fallback/Default
		Case Else
			nSelLang% = 1
			ErrorHeader = "Benutzerfelder bearbeiten"
			ErrorMsg1 = "Es knnen nicht mehr als 255 Benutzerfelder ausgefllt werden"
			ErrorMsg2 = "Es wurden keine Benutzerfelder auf dem Dokument gefunden !"
			HeaderLabel$ = "Benutzerfelder ausfllen"
			CancelButton$ = "Abbrechen"
			SaveButton$ = "Sichern"

	End Select
	
	nLoadLanguage% = nSelLang%
	
End Function
