#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hjs $ $Date: 2000/09/18 23:35:07 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..

PRJNAME=api

TARGET=cssdata
PACKAGE=com$/sun$/star$/data

# --- Settings -----------------------------------------------------
.INCLUDE :  $(PRJ)$/util$/makefile.pmk

# ------------------------------------------------------------------------

IDLFILES=\
	Database.idl\
	DatabaseCapability.idl\
	DatabaseComponent.idl\
	DatabaseConnection.idl\
	DatabaseCursor.idl\
	DatabaseCursorOption.idl\
	DatabaseCursorType.idl\
	DatabaseDetailedException.idl\
	DatabaseDocument.idl\
	DatabaseDocuments.idl\
	DatabaseEngine.idl\
	DatabaseException.idl\
	DatabaseExceptionContext.idl\
	DatabaseField.idl\
	DatabaseFieldDescriptor.idl\
	DatabaseFields.idl\
	DatabaseFieldType.idl\
	DatabaseIdentifierCase.idl\
	DatabaseIndex.idl\
	DatabaseIndexDefinition.idl\
	DatabaseIndexes.idl\
	DatabaseIndexField.idl\
	DatabaseInfo.idl\
	DatabaseIsolationLevel.idl\
	DatabaseKeyRule.idl\
	DatabaseLimit.idl\
	DatabaseNullsSort.idl\
	DatabaseOuterJoinSupport.idl\
	DatabaseParameter.idl\
	DatabaseParameterType.idl\
	DatabasePrivilige.idl\
	DatabaseProcedureStatement.idl\
	DatabaseQualifier.idl\
	DatabaseQueries.idl\
	DatabaseQuery.idl\
	DatabaseRecord.idl\
	DatabaseRecordField.idl\
	DatabaseRecordMode.idl\
	DatabaseRecordStatus.idl\
	DatabaseRelation.idl\
	DatabaseRelationField.idl\
	DatabaseRelations.idl\
	DatabaseSearch.idl\
	DatabaseSQL92.idl\
	DatabaseSQLConformance.idl\
	DatabaseStatement.idl\
	DatabaseSubquery.idl\
	DatabaseTable.idl\
	DatabaseTableDefinition.idl\
	DatabaseTables.idl\
	DatabaseUpdateCursor.idl\
	DatabaseViewDefinition.idl\
	DatabaseWorkspace.idl\
	DatabaseWorkspaces.idl\
	PreparedDatabaseStatement.idl\
	XDatabase.idl\
	XDatabaseBookmarkCursor.idl\
	XDatabaseConnection.idl\
	XDatabaseCursor.idl\
	XDatabaseCursorSupplier.idl\
	XDatabaseDescriptor.idl\
	XDatabaseDialogs.idl\
	XDatabaseDirectCursor.idl\
	XDatabaseDocumentFactory.idl\
	XDatabaseEngine.idl\
	XDatabaseFavorites.idl\
	XDatabaseFieldDescriptorFactory.idl\
	XDatabaseFieldsSupplier.idl\
	XDatabaseIndexFactory.idl\
	XDatabaseNameContainer.idl\
	XDatabaseQuery.idl\
	XDatabaseQueryComposer.idl\
	XDatabaseQueryComposerFactory.idl\
	XDatabaseQueryFactory.idl\
	XDatabaseRecordSupplier.idl\
	XDatabaseRelationFactory.idl\
	XDatabaseStatement.idl\
	XDatabaseTable.idl\
	XDatabaseTableFactory.idl\
	XDatabaseTransactionSupplier.idl\
	XDatabaseUpdate.idl\
	XDatabaseUpdateCursor.idl\
	XDatabaseVariant.idl\
	XDatabaseWorkspace.idl\
	XDatabaseWorkspaceFactory.idl\
	XPreparedDatabaseStatement.idl\

# ------------------------------------------------------------------

.INCLUDE :  target.mk
.INCLUDE :  $(PRJ)$/util$/target.pmk
