#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:42 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=extensions
TARGET=aui
ENABLE_EXCEPTIONS=TRUE
USE_DEFFILE=TRUE

# --- Settings -----------------------------------------------------
.INCLUDE :	$(PRJ)$/util$/makefile.pmk

# --- Files --------------------------------------------------------

CXXFILES=			adrcont.cxx \
					adrload.cxx \
					adrmod.cxx  \
                                        frameset.cxx \
                                        basepage.cxx \
                                        general.cxx      \
					busiaddr.cxx \
                                        privaddr.cxx \
					busiphon.cxx \
					framectr.cxx \
					adrview.cxx \
					adrbeam.cxx  \
					toolbar.cxx	 \
					datman.cxx	 \
					registry.cxx \
					adrexch.cxx	 \
					fieldwin.cxx \
                                        viewsect.cxx \
                                        privdata.cxx \
                                        adrsect.cxx \
                                        fielddsc.cxx



SLOFILES=			$(SLO)$/adrcont.obj \
					$(SLO)$/adrload.obj \
					$(SLO)$/adrmod.obj \
                                        $(SLO)$/frameset.obj\
                                        $(SLO)$/basepage.obj\
					$(SLO)$/general.obj \
					$(SLO)$/busiaddr.obj \
                                        $(SLO)$/privaddr.obj \
					$(SLO)$/busiphon.obj \
					$(SLO)$/framectr.obj \
					$(SLO)$/adrview.obj \
					$(SLO)$/adrbeam.obj  \
					$(SLO)$/toolbar.obj  \
					$(SLO)$/datman.obj	\
					$(SLO)$/registry.obj \
					$(SLO)$/adrexch.obj \
					$(SLO)$/fieldwin.obj\
                                        $(SLO)$/frameset.obj\
                                        $(SLO)$/basepage.obj\
                                        $(SLO)$/viewsect.obj\
                                        $(SLO)$/privdata.obj\
                                        $(SLO)$/adrsect.obj\
                                        $(SLO)$/fielddsc.obj

SRCFILES=                               adr.src  \
					sections.src \
					menu.src	 \
					toolbar.src

RESLIB1NAME=aui
RESLIB1SRSFILES= $(SRS)/aui.srs
RESLIB1DEPN= adr.src adr.hrc

SHL1TARGET= $(TARGET)$(UPD)$(DLLPOSTFIX)

SHL1STDLIBS= \
		$(SO2LIB)	\
		$(ONELIB)	 \
		$(USRLIB)	 \
		$(UNOLIB)	 \
		$(VOSLIB) 	 \
		$(TOOLSLIB)  \
		$(VCLLIB)    \
		$(TKLIB)	\
		$(SVTOOLLIB)\
		$(SVLLIB)	\
		$(SALLIB)	

.IF "$(SO3)" != ""
SHL1STDLIBS+=\
	$(SOTLIB)
.ENDIF


SHL1LIBS=		$(SLB)$/$(TARGET).lib
SHL1IMPLIB=		i$(TARGET)
SHL1DEPN=		$(SHL1LIBS)
SHL1DEF=		$(MISC)$/$(SHL1TARGET).def

DEF1NAME=		$(SHL1TARGET)
DEF1EXPORTFILE=	exports.dxp

# --- Targets ------------------------------------------------------

.INCLUDE :	target.mk

