/*************************************************************************
 *
 *  $RCSfile: viewsect.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _ADR_VIEWSECT_HXX
#define _ADR_VIEWSECT_HXX

#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SV_COMBOBOX_HXX //
#include <vcl/combobox.hxx>
#endif

#ifndef _SV_SPLITWIN_HXX //autogen wg. SplitWindow
#include <vcl/splitwin.hxx>
#endif

#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYVALUES_HXX_
#include <smart/com/sun/star/beans/PropertyValues.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYSET_HXX_
#include <smart/com/sun/star/beans/XPropertySet.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYVALUE_HXX_
#include <smart/com/sun/star/beans/PropertyValue.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYSTATE_HXX_
#include <smart/com/sun/star/beans/PropertyState.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HXX_
#include <smart/com/sun/star/beans/XPropertySetInfo.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XMULTIPROPERTYSET_HXX_
#include <smart/com/sun/star/beans/XMultiPropertySet.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XFASTPROPERTYSET_HXX_
#include <smart/com/sun/star/beans/XFastPropertySet.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XVETOABLECHANGELISTENER_HXX_
#include <smart/com/sun/star/beans/XVetoableChangeListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYSTATE_HXX_
#include <smart/com/sun/star/beans/XPropertyState.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYSTATECHANGELISTENER_HXX_
#include <smart/com/sun/star/beans/XPropertyStateChangeListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HXX_
#include <smart/com/sun/star/beans/PropertyAttribute.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTIESCHANGELISTENER_HXX_
#include <smart/com/sun/star/beans/XPropertiesChangeListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYCHANGELISTENER_HXX_
#include <smart/com/sun/star/beans/XPropertyChangeListener.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYACCESS_HXX_
#include <smart/com/sun/star/beans/XPropertyAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_XPROPERTYCONTAINER_HXX_
#include <smart/com/sun/star/beans/XPropertyContainer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYSTATECHANGEEVENT_HXX_
#include <smart/com/sun/star/beans/PropertyStateChangeEvent.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BEANS_PROPERTYCHANGEEVENT_HXX_
#include <smart/com/sun/star/beans/PropertyChangeEvent.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XFILEDIALOG_HXX_
#include <smart/com/sun/star/awt/XFileDialog.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTEXTCOMPONENT_HXX_
#include <smart/com/sun/star/awt/XTextComponent.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XLISTBOX_HXX_
#include <smart/com/sun/star/awt/XListBox.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XPROGRESSMONITOR_HXX_
#include <smart/com/sun/star/awt/XProgressMonitor.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_TEXTALIGN_HXX_
#include <smart/com/sun/star/awt/TextAlign.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XSCROLLBAR_HXX_
#include <smart/com/sun/star/awt/XScrollBar.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XVCLCONTAINERPEER_HXX_
#include <smart/com/sun/star/awt/XVclContainerPeer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTABCONTROLLERMODEL_HXX_
#include <smart/com/sun/star/awt/XTabControllerModel.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XMESSAGEBOX_HXX_
#include <smart/com/sun/star/awt/XMessageBox.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTEXTEDITFIELD_HXX_
#include <smart/com/sun/star/awt/XTextEditField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_STYLE_HXX_
#include <smart/com/sun/star/awt/Style.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTIMEFIELD_HXX_
#include <smart/com/sun/star/awt/XTimeField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XVCLWINDOWPEER_HXX_
#include <smart/com/sun/star/awt/XVclWindowPeer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCONTROLMODEL_HXX_
#include <smart/com/sun/star/awt/XControlModel.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XSPINFIELD_HXX_
#include <smart/com/sun/star/awt/XSpinField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XUNOCONTROLCONTAINER_HXX_
#include <smart/com/sun/star/awt/XUnoControlContainer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTEXTLAYOUTCONSTRAINS_HXX_
#include <smart/com/sun/star/awt/XTextLayoutConstrains.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XNUMERICFIELD_HXX_
#include <smart/com/sun/star/awt/XNumericField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XBUTTON_HXX_
#include <smart/com/sun/star/awt/XButton.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTEXTAREA_HXX_
#include <smart/com/sun/star/awt/XTextArea.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XIMAGEBUTTON_HXX_
#include <smart/com/sun/star/awt/XImageButton.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XFIXEDTEXT_HXX_
#include <smart/com/sun/star/awt/XFixedText.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCONTROLCONTAINER_HXX_
#include <smart/com/sun/star/awt/XControlContainer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XDIALOG_HXX_
#include <smart/com/sun/star/awt/XDialog.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_SCROLLBARORIENTATION_HXX_
#include <smart/com/sun/star/awt/ScrollBarOrientation.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XRADIOBUTTON_HXX_
#include <smart/com/sun/star/awt/XRadioButton.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCURRENCYFIELD_HXX_
#include <smart/com/sun/star/awt/XCurrencyField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XPATTERNFIELD_HXX_
#include <smart/com/sun/star/awt/XPatternField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_VCLWINDOWPEERATTRIBUTE_HXX_
#include <smart/com/sun/star/awt/VclWindowPeerAttribute.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTABCONTROLLER_HXX_
#include <smart/com/sun/star/awt/XTabController.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XVCLCONTAINER_HXX_
#include <smart/com/sun/star/awt/XVclContainer.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XDATEFIELD_HXX_
#include <smart/com/sun/star/awt/XDateField.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCOMBOBOX_HXX_
#include <smart/com/sun/star/awt/XComboBox.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCONTROL_HXX_
#include <smart/com/sun/star/awt/XControl.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XCHECKBOX_HXX_
#include <smart/com/sun/star/awt/XCheckBox.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_MESSAGEBOXCOMMAND_HXX_
#include <smart/com/sun/star/awt/MessageBoxCommand.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XLAYOUTCONSTRAINS_HXX_
#include <smart/com/sun/star/awt/XLayoutConstrains.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XPROGRESSBAR_HXX_
#include <smart/com/sun/star/awt/XProgressBar.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XTOPWINDOW_HXX_
#include <smart/com/sun/star/awt/XTopWindow.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_XWINDOW_HXX_
#include <smart/com/sun/star/awt/XWindow.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_AWT_POSSIZE_HXX_
#include <smart/com/sun/star/awt/PosSize.hxx>
#endif


#ifndef _USR_UNO_HXX //autogen wg. UsrObject
#include <usr/uno.hxx>
#endif


class	AdrDataManager;

class AdrControlContainer:	public DockingWindow,
							public XPropertyChangeListener, 
							public UsrObject
{
private:		
		AdrDataManagerHdl		ppDatMan;
		XWindowRef				xCtrWin;
		XControlModelRef		xCtrModel;
		XControlRef				xControl;
		XControlContainerRef	aCtrContainer;
		FixedText				aFixedText;
		long					nLabelWidth;


protected:

		virtual void		Resize();
		virtual long		PreNotify( NotifyEvent& rNEvt );


public:

		AdrControlContainer(Window* pParent,AdrDataManagerHdl	ppDatMan, WinBits nStyle = 0 );
		~AdrControlContainer();

		SMART_UNO_DECLARATION( AdrControlContainer, UsrObject );

		BOOL 						queryInterface( UsrUik aUIK, XInterfaceRef& xRet );

		virtual void				propertyChange(const PropertyChangeEvent& evt) 
																THROWS( (UsrSystemException) );
		virtual void 				disposing( const EventObject& Source );

		void				createXControl(const XControlModelRef&	xCtrModel);
		XControlModelRef	getControlModel();

		void				SetLabel(const String& aStr);
		String				GetLabel();
		void				SetLabelWidth(long nWidth);
		long				GetLabelWidth();

};


class AdrViewSection: public SplitWindow
{
private:

	AdrDataManagerHdl	ppDatMan;
	USHORT				nNextID;
	long				nStdLabelWidth;

protected:

	virtual BOOL		Drop( const DropEvent& rEvt );
	virtual BOOL		QueryDrop( const DropEvent& rEvt );
	virtual void		Resize();

	virtual long		PreNotify( NotifyEvent& rNEvt );

	void				UpdateLabelWidth(long	);

public:
						AdrViewSection(Window* pParent,AdrDataManagerHdl	ppDatMan, 
										WinBits nStyle=0);
						~AdrViewSection();
};



#endif


