/*************************************************************************
 *
 *  $RCSfile: iemisc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/solar.h>
#include <tools/prewin.h>
#include <winreg.h>
/*
#include <ole2.h>
#ifdef WNT
#include <winnls.h>
#else
#include <olenls.h>
#endif
#include <oleauto.h>
*/
#include <tools/postwin.h>
	
	
BOOL IExplorer_Available()
{
	BOOL bRet = FALSE;
	
	HKEY hKey;
	DWORD dwType, dwSize;

	if (::RegOpenKeyEx( HKEY_LOCAL_MACHINE, 
#ifdef UNICODE
						L"Software\\Microsoft\\Internet Explorer",
#else
						"Software\\Microsoft\\Internet Explorer",
#endif
						0,
						KEY_READ,
						&hKey )==ERROR_SUCCESS)
	{
		// die Existenz des Schluessels soll nach MS Doku fuer das Vorhanden sein >IE3 hinreichend sein
		bRet = (::RegQueryValueEx( hKey,
#ifdef UNICODE
								   L"Version",
#else
								   "Version",
#endif
								   NULL, &dwType, NULL, &dwSize )==ERROR_SUCCESS);

		::RegCloseKey( hKey );
	}

	return bRet;
		
//  	static const CLSID CLSID_WebBrowser_V1 = {0xEAB22AC3, 0x30C1, 0x11CF, {0xA7, 0xEB, 0x00, 0x00, 0xC0, 0x5B, 0xAE, 0x0B}};
	
//  	CLSID aClassId;
//  	// Test, != IE3
//  	return ((::CLSIDFromProgID( L"Shell.Explorer", &aClassId ) == S_OK) &&
//  			!::IsEqualCLSID( CLSID_WebBrowser_V1, aClassId ));
}

//-------------------------------------------------------------------------------------------------
void IExplorer_InvokeInternetOptions()
{

	// Plattformen beachten:
//	IShellExecute( ..., "rundll32.exe", "shell32.dll, Control_RunDLL, inetcpl.cpl,@1", ... );
//	IShellExecute( ..., "control.exe", "inetcpl.cpl", ... );
	
//  	IShellDispatch* pShellDisp;
//  	HRESULT hr;

//  	::CoInitialize( NULL );
//  	if (SUCCEEDED(hr = ::CoCreateInstance( CLSID_Shell, NULL, CLSCTX_SERVER,
//  										   IID_IShellDispatch, (void**)&pShellDisp )))
//  	{
//  		BSTR pPanel = ::SysAllocString( L"inetcpl.cpl" );
//  		pShellDisp->ControlPanelItem( pPanel );
//  		::SysFreeString( pPanel );
//  		pShellDisp->Release();
//  	}
//  	::CoUninitialize();
}
