#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************


PRJ=..$/..

PRJNAME=ie
TARGET=ctrl
ENABLE_EXCEPTIONS=TRUE

# from cppumaker --------------------------------------------------
UNOUCRDEP=	$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=	$(SOLARBINDIR)$/applicat.rdb
#UNOUCRDEP=	$(BIN)$/api.db
#UNOUCRRDB=	$(BIN)$/api.db

UNOUCROUT=	$(OUT)$/inc
INCPRE+=	$(OUT)$/inc


# --- Settings --------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk


#----------------------------------------------------------------

.IF "$(GUI)" == "WNT"

UNOTYPES= \
	com.sun.star.frame.XTerminateListener				\
	com.sun.star.frame.XDispatchProviderInterceptor		\
	com.sun.star.frame.XDispatch						\
	com.sun.star.frame.XDispatchProvider				\
	com.sun.star.frame.XStatusListener					\
	com.sun.star.frame.FrameSearchFlag					\
	com.sun.star.frame.XDispatchProviderInterception	\
	com.sun.star.frame.FeatureStateEvent				\
	com.sun.star.frame.DispatchDescriptor				\
	com.sun.star.frame.XController						\
	com.sun.star.frame.XStorable						\
	com.sun.star.frame.XModel							\
	com.sun.star.frame.XFrameActionListener				\
	com.sun.star.frame.XComponentLoader					\
	com.sun.star.frame.XFrame							\
	com.sun.star.frame.FrameActionEvent					\
	com.sun.star.frame.FrameAction						\
	com.sun.star.frame.XTasksSupplier					\
	com.sun.star.frame.XDesktopTask						\
	com.sun.star.frame.WindowArrange					\
	com.sun.star.frame.TerminationVetoException			\
	com.sun.star.frame.XWindowArranger					\
	com.sun.star.frame.XFrameLoader						\
	com.sun.star.frame.XFilterDetect					\
	com.sun.star.frame.XDesktop							\
	com.sun.star.task.XStatusIndicatorFactory			\
	com.sun.star.task.XStatusIndicatorSupplier			\
	com.sun.star.task.XStatusIndicator					\
	com.sun.star.view.XControlAccess					\
	com.sun.star.view.XSelectionChangeListener			\
	com.sun.star.view.DocumentZoomType					\
	com.sun.star.view.XScreenCursor						\
	com.sun.star.view.XViewSettingsSupplier				\
	com.sun.star.view.XSelectionSupplier				\
	com.sun.star.awt.XAdjustmentListener				\
	com.sun.star.awt.XActionListener					\
	com.sun.star.awt.XTextListener						\
	com.sun.star.awt.XSpinListener						\
	com.sun.star.awt.XItemListener						\
	com.sun.star.awt.XVclContainerListener				\
	com.sun.star.awt.WindowAttribute					\
	com.sun.star.awt.XSystemDependentWindowPeer			\
	com.sun.star.awt.InvalidateStyle					\
	com.sun.star.awt.PosSize							\
	com.sun.star.awt.Point								\
	com.sun.star.awt.XWindowListener					\
	com.sun.star.util.URL								\
	com.sun.star.util.XURLTransformer					\
	com.sun.star.uno.XWeak								\
	com.sun.star.uno.XAggregation						\
	com.sun.star.uno.Uik								\
	com.sun.star.uno.TypeClass							\
	com.sun.star.lang.XTypeProvider						\
	com.sun.star.lang.XMultiServiceFactory				\
	com.sun.star.lang.XUnoTunnel						\
	com.sun.star.lang.XServiceInfo						\
	com.sun.star.lang.XEventListener					\
	com.sun.star.lang.XSingleServiceFactory				\
	com.sun.star.lang.SystemDependent					\
	com.sun.star.lang.XServiceName						\
	com.sun.star.container.XNameAccess					\
	com.sun.star.container.XIndexContainer				\
	com.sun.star.container.XContainer					\
	com.sun.star.container.XNameReplace					\
	com.sun.star.container.XSet							\
	com.sun.star.container.ContainerEvent				\
	com.sun.star.container.XIndexReplace				\
	com.sun.star.container.XNameContainer				\
	com.sun.star.registry.MergeConflictException		\
	com.sun.star.registry.XSimpleRegistry				\
	com.sun.star.registry.InvalidValueException			\
	com.sun.star.registry.XRegistryKey					\
	com.sun.star.registry.RegistryKeyType				\
	com.sun.star.registry.RegistryValueType				\
	com.sun.star.registry.InvalidRegistryException		\
	com.sun.star.loader.XImplementationLoader			\
	com.sun.star.loader.CannotActivateFactoryException	\
	com.sun.star.beans.XMultiPropertySet				\
	com.sun.star.beans.XFastPropertySet					\
	com.sun.star.beans.XPropertyState					\
	com.sun.star.beans.XPropertyStateChangeListener		\
	com.sun.star.beans.PropertyAttribute				\
	com.sun.star.beans.XPropertyAccess					\
	com.sun.star.beans.XPropertyContainer



SLOFILES = \
	$(SLO)$/ctrl.obj	\
	$(SLO)$/idisp.obj	\
	$(SLO)$/loader.obj	\
	$(SLO)$/exmisc.obj	\
	$(SLO)$/extdisp.obj	\
	$(SLO)$/other.obj
	


SRCFILES =	app.src

#SHL1TARGET= 	$(TARGET)$(UPD)$(DLLPOSTFIX)
#SHL1STDLIBS=        $(UNOLIB) 	

#        $(SALLIB) 	\
#	$(VOSLIB)	\
#	$(CPPULIB)	\
#	$(CPPUHELPERLIB)	\
#	$(LIBCIMT) 	\
#	ole32.lib 	\
#	uuid.lib 	\
#	oleaut32.lib


#SHL1LIBS = $(SLB)$/$(TARGET).lib

#SHL1DEF=$(MISC)$/$(SHL1TARGET).def


.ENDIF
# ------------------------------------------------------------------


.INCLUDE :  target.mk
.INCLUDE :  $(PRJ)$/util$/target.pmk


