/*************************************************************************
 *
 *  $RCSfile: app.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#ifndef _TOOLS_SIMPLERESMGR_HXX_
#include <tools/simplerm.hxx>
#endif

#ifndef _COM_SUN_STAR_DRAWING_MEASURETEXTVERTPOS_HPP_
#include <com/sun/star/drawing/MeasureTextVertPos.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTANIMATIONDIRECTION_HPP_
#include <com/sun/star/drawing/TextAnimationDirection.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_CONNECTIONTYPE_HPP_
#include <com/sun/star/drawing/ConnectionType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINESTYLE_HPP_
#include <com/sun/star/drawing/LineStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTUREMODE_HPP_
#include <com/sun/star/drawing/TextureMode.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_ARRANGEMENT_HPP_
#include <com/sun/star/drawing/Arrangement.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTANIMATIONKIND_HPP_
#include <com/sun/star/drawing/TextAnimationKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_DASHSTYLE_HPP_
#include <com/sun/star/drawing/DashStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTADJUST_HPP_
#include <com/sun/star/drawing/TextAdjust.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_PROJECTIONMODE_HPP_
#include <com/sun/star/drawing/ProjectionMode.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINEENDTYPE_HPP_
#include <com/sun/star/drawing/LineEndType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_RECTANGLEPOINT_HPP_
#include <com/sun/star/drawing/RectanglePoint.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_MEASURETEXTHORZPOS_HPP_
#include <com/sun/star/drawing/MeasureTextHorzPos.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_CONNECTORTYPE_HPP_
#include <com/sun/star/drawing/ConnectorType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_MIRRORAXIS_HPP_
#include <com/sun/star/drawing/MirrorAxis.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTUREKIND_HPP_
#include <com/sun/star/drawing/TextureKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_NORMALSKIND_HPP_
#include <com/sun/star/drawing/NormalsKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_ALIGNMENT_HPP_
#include <com/sun/star/drawing/Alignment.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_SHADEMODE_HPP_
#include <com/sun/star/drawing/ShadeMode.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_MEASUREKIND_HPP_
#include <com/sun/star/drawing/MeasureKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LAYERTYPE_HPP_
#include <com/sun/star/drawing/LayerType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_SNAPOBJECTTYPE_HPP_
#include <com/sun/star/drawing/SnapObjectType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_FILLSTYLE_HPP_
#include <com/sun/star/drawing/FillStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_CIRCLEKIND_HPP_
#include <com/sun/star/drawing/CircleKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_HORIZONTALDIMENSIONING_HPP_
#include <com/sun/star/drawing/HorizontalDimensioning.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_HATCHSTYLE_HPP_
#include <com/sun/star/drawing/HatchStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_VERTICALDIMENSIONING_HPP_
#include <com/sun/star/drawing/VerticalDimensioning.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTFITTOSIZETYPE_HPP_
#include <com/sun/star/drawing/TextFitToSizeType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_POLYGONKIND_HPP_
#include <com/sun/star/drawing/PolygonKind.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_TEXTUREPROJECTIONMODE_HPP_
#include <com/sun/star/drawing/TextureProjectionMode.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_POLYGONFLAGS_HPP_
#include <com/sun/star/drawing/PolygonFlags.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_DRAWVIEWMODE_HPP_
#include <com/sun/star/drawing/DrawViewMode.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HPP_
#include <com/sun/star/loader/CannotActivateFactoryException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _SVX_UNOSHCOL_HXX

#ifndef _SV_CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif

#include <vcl/config.hxx>

#ifndef _SVX_IMPGRF_HXX	//autogen
#include <svx/impgrf.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXPTITEM_HXX
#include <svtools/ptitem.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _FM_FMOBJFAC_HXX
#include <svx/fmobjfac.hxx>
#endif
#ifndef _TBXCTL_HXX //autogen
#include <basctl/btbxctl.hxx>
#endif
#ifndef _SVX_TBCONTRL_HXX //autogen
#include <svx/tbcontrl.hxx>
#endif
#ifndef _SVX_SRCHDLG_HXX //autogen
#include <svx/srchdlg.hxx>
#endif
#ifndef _SVX_THESDLG_HXX //autogen
#include <svx/thesdlg.hxx>
#endif
#ifndef _SVX_ADRITEM_HXX //autogen
#include <svx/adritem.hxx>
#endif
#ifndef _SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _OUTLINER_HXX //autogen
#include <svx/outliner.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _IMAPDLG_HXX_ //autogen
#include <svx/imapdlg.hxx>
#endif
#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif
#pragma hdrstop

// include ---------------------------------------------------------------

#ifndef _OFF_APP_HXX
#include "app.hxx"
#endif
#ifndef _OFF_APPIMP_HXX
#include "appimp.hxx"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif
#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif

#ifndef _SFX_DBCOLL_HXX
#include "dbcoll.hxx"
#endif
#ifndef _OFF_OFADBMGR_HXX
#include "ofadbmgr.hxx"
#endif
#ifndef _SVX_DLG_HYPERLINK_HXX
#include "hyprlink.hxx"
#endif
#ifndef _SFX_INETOPT_HXX
#include "optuno.hxx"
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif
#ifndef	_SFXMSG_HXX
#include <sfx2/msg.hxx>
#endif
#ifndef _SFXOBJFACE_HXX
#include <sfx2/objface.hxx>
#endif
#ifndef __VC_VCBROWSERWRAPPER_HXX
#include <basctl/vcbrwwrp.hxx>
#endif
#define ITEMID_FIELD 0
#ifndef _SVX_FLDITEM_HXX
#include <svx/flditem.hxx>
#endif
#ifndef _SVDFIELD_HXX
#include <svx/svdfield.hxx>
#endif
#ifndef _OBJFAC3D_HXX
#include <svx/objfac3d.hxx>
#endif
#ifndef _LIBCALL_HXX
#include <svtools/libcall.hxx>
#endif
#ifndef _SVX_SIZEITEM_HXX
#define ITEMID_SIZE 0
#include <svx/sizeitem.hxx>
#endif
#ifndef _SVX_ZOOMITEM_HXX
#include <svx/zoomitem.hxx>
#endif
#ifndef _SVX_LANGITEM_HXX
#define ITEMID_LANGUAGE 0
#include <svx/langitem.hxx>
#endif
#ifndef _SVX_UNOSHGRP_HXX
#include <svx/unoshcol.hxx>
#endif
#endif
#ifndef _SVX_TAB_HYPERLINK_HXX
#include <svx/hyperdlg.hxx>
#endif
#ifndef _SVX_HLNKITEM_HXX
#include <svx/hlnkitem.hxx>
#endif
#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif

#include <sfx2/viewsh.hxx>
#include <sfx2/viewfrm.hxx>

#include "calwin.hxx"
#ifndef _OFA_APEARCFG_HXX
#include "apearcfg.hxx"
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif

//=========================================================================

#define SFX_TYPEMAP
#define Address
#define _ExecAddress  ExecuteApp_Impl
#define _StateAddress GetStateApp_Impl
#define OfficeApplication
#include "ofaslots.hxx"

TYPEINIT1(OfficeApplication,SfxApplication);

#define IS_AVAILABLE(WhichId,ppItem) \
    (pArgs->GetItemState((WhichId), sal_True, ppItem ) == SFX_ITEM_SET)

//=========================================================================

SFX_IMPL_INTERFACE(OfficeApplication,SfxApplication,OffResId(RID_DESKTOP))
{
	SFX_CHILDWINDOW_REGISTRATION( SID_HYPERLINK_INSERT );
//  SFX_CHILDWINDOW_REGISTRATION( SID_HYPERLINK_DIALOG );
//	SFX_CHILDWINDOW_REGISTRATION( SID_SHOW_BROWSER );
}

// ------------------------------------------------------------------------
// hack: this must be implemented somewhere else, hack for 554 update

::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL SvxShapeCollection_CreateInstance( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& rSMgr ) throw( ::com::sun::star::uno::Exception )
{
	return *( new SvxShapeCollection() );
}

void OfficeApplication::Init()
{
    SfxApplication::Init();

	SvxIMapDlgChildWindow::RegisterChildWindow();

	// Handler fuer Grafikfilter setzen; im Handler wird ggf.
	// der Graphicfilter init., wenn das erste Mal auf einen
	// Filter zugegriffen wird (KA 04.08.98)
	Application::SetFilterHdl( LINK( this, OfficeApplication, ImplInitFilterHdl ) );

	pOfaDBMgr = new OfaDBMgr;

	CreateDataImpl();
	UseFontSubst();

	OfficeApplication::RegisterInterface();

	VCBrowserWrapper::RegisterChildWindow();
	SvxHyperlinkDlgWrapper::RegisterChildWindow();
	SvxSearchDialogWrapper::RegisterChildWindow();
	SvxHlinkDlgWrapper::RegisterChildWindow ();

	//OfficeApplication::RegisterInterface();
	SetUserEMailAddress( GetIniManager()->GetAddressToken( ADDRESS_EMAIL ) );
    SvxReloadControllerItem::RegisterControl( SID_RELOAD );
	TbxControls::RegisterControl( SID_CHOOSE_CONTROLS );

    // SvxURLField registrieren
	SvClassManager& rClassManager = SvxFieldItem::GetClassManager();
	rClassManager.SV_CLASS_REGISTER( SvxURLField );
	rClassManager.SV_CLASS_REGISTER( SvxDateField );
	rClassManager.SV_CLASS_REGISTER( SvxPageField );
	rClassManager.SV_CLASS_REGISTER( SvxTimeField );
	rClassManager.SV_CLASS_REGISTER( SvxExtTimeField );
	rClassManager.SV_CLASS_REGISTER( SvxExtFileField );
	rClassManager.SV_CLASS_REGISTER( SvxAuthorField );

    // SvDraw-Felder registrieren
    SdrRegisterFieldClasses();

    // 3D-Objekt-Factory eintragen
    E3dObjFactory();

    // ::com::sun::star::form::component::Form-Objekt-Factory eintragen
    FmFormObjFactory();

	// Servies etc. registrieren
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xSMgr = ::utl::getProcessServiceFactory();
	::com::sun::star::uno::Reference< ::com::sun::star::container::XSet >  xSet( xSMgr, ::com::sun::star::uno::UNO_QUERY );
	::com::sun::star::uno::Sequence< ::rtl::OUString >			aName( 1 );
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XSingleServiceFactory > 	xFact;

	aName.getArray()[0] = ::rtl::OUString::createFromAscii("com.sun.star.drawing.ShapeCollection");
	xFact = ::cppu::createSingleFactory( xSMgr, ::rtl::OUString::createFromAscii("ShapeCollection"), SvxShapeCollection_CreateInstance, aName );
	xSet->insert( ::com::sun::star::uno::makeAny(xFact) );

	aName.getArray()[0] = ::rtl::OUString::createFromAscii("com.sun.star.util.NumberFormatter");
	xFact = ::cppu::createSingleFactory( xSMgr, ::rtl::OUString::createFromAscii("NumberFormatter"), SvNumberFormatterServiceObj_NewInstance, aName );
	xSet->insert( ::com::sun::star::uno::makeAny( xFact ) );

	xSet->insert( ::com::sun::star::uno::makeAny( SfxSettingsContainer::impl_createFactory(xSMgr) ) );

	// Optionen Allgemein -- Darstellung
    OfaTabAppearanceCfg* pAppearanceCfg = GetTabAppearanceConfig();
	pAppearanceCfg->SetInitialized();
	pAppearanceCfg->SetApplicationDefaults ( GetpApp() );
}

// ------------------------------------------------------------------------
void OfficeApplication::Exit()
{
	if ( pSbaObject )
		pSbaObject->CloseAddrPI();
	if ( pDataImpl->pWordDeInitFct )
		pDataImpl->pWordDeInitFct();
    DELETEZ( pOfaDBMgr );   // unbedingt vor SBA und SDB loeschen!
}

sal_Bool OfficeApplication::HasSbaObject() const
{
	return pSbaObject != NULL;
}

//------------------------------------------------------------------------------


void OfficeApplication::UseFontSubst()
{
	OutputDevice::BeginFontSubstitution();
	// Alte Substitution entfernen
	sal_uInt16 nCount = OutputDevice::GetFontSubstituteCount();

	while (nCount)
		OutputDevice::RemoveFontSubstitute(--nCount);

	// Neue Substitution einlesen
	Config *pCfg = GetFontSubstConfig();

	if (pCfg)
	{
		nCount = pCfg->GetKeyCount();

		if (nCount)
		{
			if (pCfg->ReadKey( "Enable" ) == "1")
			{
				sal_uInt16 nFlags;
				ByteString sKey;
				String sFont1, sFont2;

				for (sal_uInt16 i = 1; i < nCount; i++)
				{
					nFlags = 0;
					sKey = pCfg->ReadKey(ByteString::CreateFromInt32(i));

					if (sKey.GetToken(0) == "1")
						nFlags |= FONT_SUBSTITUTE_ALWAYS;
					if (sKey.GetToken(1) == "1")
						nFlags |= FONT_SUBSTITUTE_SCREENONLY;
					sFont1 = String(sKey.GetToken(2),gsl_getSystemTextEncoding());
					sFont2 = String(sKey.GetToken(3),gsl_getSystemTextEncoding());

					OutputDevice::AddFontSubstitute( sFont1, sFont2, nFlags );
				}
			}
		}
	}
	OutputDevice::EndFontSubstitution();
}

// ------------------------------------------------------------------------

void OfficeApplication::AutoBrowseExec_Impl( SfxRequest& rReq )
{
	const SfxItemSet* pArgs = rReq.GetArgs();
	String aName, aURL;

	if ( pArgs )
	{
		const SfxPoolItem* pItem;

		if ( IS_AVAILABLE( SID_AUTOBROWSE, &pItem ) )
			aName = ( (const SfxStringItem*)pItem )->GetValue();

		if ( IS_AVAILABLE( SID_SBA_QRY_URL, &pItem ) )
			aURL = ( (const SfxStringItem*)pItem )->GetValue();
	}

	GetSbaObject();
	DBG_ASSERT( pSbaObject, "Kein SBAOBJ!" );

AGAIN2:
	if ( aURL.Len() ) // wir haben eine fertige Adresse
	{
		INetURLObject aObj;
		aObj.SetSmartURL( aURL );
		SfxStringItem aURLItm( SID_FILE_NAME, aObj.GetMainURL() );
		SfxStringItem aRefItm( SID_REFERER, String::CreateFromAscii(OFA_REFERER) );
		GetDispatcher().Execute( SID_OPENURL,
								 SFX_CALLMODE_RECORD, &aURLItm, &aRefItm, 0L );
	}
	else if ( aName.Len() ) // wir haben nur den Namen
	{
		SbaSearchField eInFld;
		sal_uInt16 nCnt = pSbaObject->SearchEMail( aName, aURL, SBA_URL, eInFld );

		if ( nCnt == 1 )
		{
			if ( !aURL.Len() )
			{
				QueryBox aBox( NULL, OffResId( RID_QRY_NO_URL ) );

				if ( aBox.Execute() == RET_YES )
				{
					ShowAddrPI( sal_True );
					pSbaObject->AddrBookSelect( aName, eInFld );
				}
				else
					return;
			}
			else
				goto AGAIN2;
		}
		else
		{
			if ( nCnt == 0  )
			{
				String aSel( aName );
				aSel.EraseLeadingChars();
				aSel.EraseTrailingChars();
				String aWww = aSel.ToUpperAscii();

				if ( ( aSel.Search('.') != STRING_NOTFOUND &&
					   aSel.Search(' ') == STRING_NOTFOUND ) ||
					 aWww == String::CreateFromAscii("WWW") )
				{
					INetURLObject aObj;

					if ( aObj.SetSmartURL( aSel ) )
					{
						aURL = aObj.GetMainURL();
						aName.Erase();
						goto AGAIN2;
					}
				}

				QueryBox aBox( NULL, OffResId( RID_QRY_NEWBRWADDR ) );

				if( aBox.Execute() == RET_YES )
				{
					ShowAddrPI( sal_True );
					pSbaObject->AddrBookNew( aName, SBA_FIRMASEARCH );
				}
			}
			else
			{
				QueryBox aBox( NULL, OffResId(RID_QRY_SELECTBRWADDR) );

				if( aBox.Execute() == RET_YES )
				{
					ShowAddrPI( sal_True );
					aName += '*';
					pSbaObject->AddrBookSelect( aName, eInFld );
				}
			}
		}
	}
	else // alles muss man selbst machen
	{
		SfxViewShell* pSh = SfxViewShell::Current();

		if ( pSh )
		{
			String aSelection = pSh->GetSelectionText( sal_True );
			aSelection.EraseAllChars( '\n' );// XXX WorkAround bis gefixed
			aSelection.EraseAllChars( '\r' );// XXX WorkAround bis gefixed

			if ( aSelection.Len() )
			{
	   			INetURLObject aUObj( ByteString(aSelection,gsl_getSystemTextEncoding()));
				INetURLObject aMObj;
				aMObj.SetSmartURL(aSelection);

				// ::com::sun::star::util::URL?
				if ( aUObj.GetProtocol() == INET_PROT_HTTP ||
					aMObj.GetProtocol() == INET_PROT_MAILTO ||
					aMObj.GetProtocol() == INET_PROT_FILE )
					aURL = aUObj.GetMainURL();
				else if ( !aUObj.HasError() )	// irgendwas anderes sinnvolles?
				{
					QueryBox aBox( NULL, OffResId( RID_QRY_INVALID_URL ) );

					if ( aBox.Execute() == RET_YES )
						ShowAddrPI( sal_True );
					return;
				}
				else	// Dann wirds wohl ein Name gewesen sein?
					aName = aSelection;

				goto AGAIN2;
			}
			else
			{
				QueryBox aBox( NULL, OffResId( RID_QRY_NO_NAME ) );

				if ( aBox.Execute() == RET_YES )
					ShowAddrPI( sal_True );
			}
		}
	}
}

// ------------------------------------------------------------------------

void OfficeApplication::AutoBrowseState_Impl( SfxItemSet &rSet )
{
/*	SfxViewShell* pSfxViewShell = SfxViewShell::Current();

	if (!SfxViewShell::Current())
		rSet.DisableItem( SID_AUTOBROWSE );*/
}

// ------------------------------------------------------------------------

ResMgr* OfficeApplication::GetOffResManager()
{
	if ( !pImpl->pResMgr )
		pImpl->pResMgr = CreateResManager( "ofa");
	return pImpl->pResMgr;
}

// ------------------------------------------------------------------------

SimpleResMgr* OfficeApplication::GetOffSimpleResManager()
{
	if ( !pImpl->m_pThreadSafeRessources )
	{
		LanguageType nType = Application::GetAppInternational().GetLanguage();
		ByteString sMgrName("ofs");
		sMgrName += ByteString::CreateFromInt32( SOLARUPD );
		pImpl->m_pThreadSafeRessources = SimpleResMgr::Create( sMgrName.GetBuffer(), nType );
	}
	return pImpl->m_pThreadSafeRessources;
}

// ------------------------------------------------------------------------

void OfficeApplication::SetSbxCreatedLink( const Link &rLink )
// nur bis GetSbxObject virtual ist
{
	aSbaCreatedLink = rLink;
}

// ------------------------------------------------------------------------

SbaObject* OfficeApplication::GetSbaObject()
{
	DBG_ASSERT( HasFeature( SFX_FEATURE_DATABASE ), "Feature ::com::sun::star::data::Database not available" );
 	if ( !pSbaObject )
	{
		// lock the solar mutex so no other thread can do a concurrent Load
		// FS - 72858 - 09.02.00
		::vos::OGuard aGuard(Application::GetSolarMutex());

		// maybe another thread already loaded the SBA_DLL while we were waiting for the SolarMutex
		// (this second "if (!pSbaObject)" seems to be a little bit stupid, but it isn't :
		// I don't want to guard the entire method with the solar mutex (this would be to expensive) but only
		// the real load call. But then I need this second check.)
		if (!pSbaObject)
			pSbaObject = (SbaObject*)SBA_DLL()->Load();
	}
	return pSbaObject;
}

// ------------------------------------------------------------------------

sal_Bool OfficeApplication::IsAddrPIOpen() const
{
	return pSbaObject ? pSbaObject->IsAddrPIOpen() : sal_False ;
}

// ------------------------------------------------------------------------

void OfficeApplication::ShowAddrPI( sal_Bool bShow )
{
	if ( IsAddrPIOpen() != bShow )
        SfxViewFrame::Current()->GetBindings().Execute( SID_SBA_ADDRPI );
}

// ------------------------------------------------------------------------

void OfficeApplication::EnableAddrPIButton( sal_uInt16 nFlags )
{
	nAddrButtonFlags = nFlags;
}

// ------------------------------------------------------------------------

sal_uInt16 OfficeApplication::StartThesaurus( Window *pParent,
		::com::sun::star::uno::Reference<
			::com::sun::star::linguistic::XThesaurus >   xThesaurus,
		String			&rNewWord,
		sal_Int16		 nLanguage )
{
	SvxThesaurusDialog aDialog( pParent, xThesaurus, rNewWord, nLanguage );

	sal_uInt16 nReturn = aDialog.Execute();
	if( nReturn == RET_OK )
		rNewWord = aDialog.GetWord();

	return nReturn;
}
// ------------------------------------------------------------------------

void OfficeApplication::DrawExec_Impl( SfxRequest &rReq )
{
	SfxModule *pMod = (*(SfxModule**) GetAppData(SHL_DRAW))->Load();
	if(pMod)
	{
		pMod->ExecuteSlot( rReq );
		pMod->Free();
	}
}

// ------------------------------------------------------------------------

void OfficeApplication::ModuleState_Impl( SfxItemSet &rSet )
{
	// f"ur die Statusabfrage darf das Modul NICHT geladen werden

#ifdef DEBUG
// lass mal alle Features aus .ini sehen
	sal_Bool bf;
	for ( sal_uInt32 j=1; j; j <<= 1 )
	{
		if ( HasFeature( j ) )
			bf = sal_True;
		else
			bf = sal_False;
	}
#endif

	if ( !HasFeature( SFX_FEATURE_SCALC ) )
		rSet.DisableItem( SID_SC_EDITOPTIONS );

	if ( !HasFeature( SFX_FEATURE_SMATH ) )
		rSet.DisableItem( SID_SM_EDITOPTIONS );

	if ( !HasFeature( SFX_FEATURE_SIMPRESS ) )
		rSet.DisableItem( SID_SD_EDITOPTIONS );

	if ( !HasFeature( SFX_FEATURE_SDRAW ) )
		rSet.DisableItem( SID_SD_GRAPHIC_OPTIONS );

	if ( !HasFeature( SFX_FEATURE_SIMAGE ) )
		rSet.DisableItem( SID_SIM_EDITOPTIONS );
}


// ------------------------------------------------------------------------

void OfficeApplication::WriterExec_Impl( SfxRequest &rReq )
{
/*
Hier werden Executes fuer folgende Slots weitergeleitet
SID_SW_AGENDA_WIZZARD
SID_SW_FAX_WIZZARD
SID_SW_LETTER_WIZZARD
SID_SW_MEMO_WIZZARD
SID_SW_EDITOPTIONS
SID_SW_DOCMAN_PATH
*/

	SfxModule *pMod = (*(SfxModule**) GetAppData(SHL_WRITER))->Load();
	if(pMod)
	{
		pMod->ExecuteSlot( rReq );
		pMod->Free();
	}
}

// ------------------------------------------------------------------------

void OfficeApplication::CalcExec_Impl( SfxRequest &rReq )
{
/*
Hier werden Executes fuer folgende Slots weitergeleitet
*/

	SfxModule *pMod = (*(SfxModule**) GetAppData(SHL_CALC))->Load();
	if(pMod)
	{
		pMod->ExecuteSlot( rReq );
		pMod->Free();
	}
}


// ------------------------------------------------------------------------
IMPL_LINK( OfficeApplication, ImplInitFilterHdl, ConvertData*, pData )
{
	// dieser Code wird nur einmal durchlaufen, und zwar dann,
	// wenn das erste Mal auf einen Filter ueber die GraphicConverter-
	// Schnittstele in VCL zugegriffen wird; ::GetGrfFilter zieht den
	// GraphicFilter an (sofern noch nicht geschehen), welcher wiederum
	// den Filter-Handler auf seine eigene Methode umsetzt (KA 04.08.98)
	GetGrfFilter();
	return Application::GetFilterHdl().Call( pData );
}


