/*************************************************************************
 *
 *  $RCSfile: ofadbmgr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _SV_WAITOBJ_HXX //autogen
#include <vcl/waitobj.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif
#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef PRECOMPILED

#ifndef _SVSTDARR_HXX
#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>
#endif

#endif	// Ende der Precompiled Header

#ifndef _SBXCORE_HXX
#include <svtools/sbxcore.hxx>
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _SDB_SDBQRY_HXX //autogen
#include <sdb/sdbqry.hxx>
#endif
#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif
#include <float.h>
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _EXPLORER_HXX //autogen
#include <sfx2/explorer.hxx>
#endif
#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif
#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif
#ifndef _SBA_DBDEFOBJ_HXX
#include "dbdefobj.hxx"
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif
#ifndef _OFF_APP_HXX
#include "app.hxx"
#endif
#ifndef _OFF_OFADBMGR_HXX
#include "ofadbmgr.hxx"
#endif
#ifndef _SFX_DBCOLL_HXX
#include "dbcoll.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif
#ifndef _SBA_DBFILEOB_HXX
#include "dbfileob.hxx"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQL92_HPP_
#include <com/sun/star/data/DatabaseSQL92.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEISOLATIONLEVEL_HPP_
#include <com/sun/star/data/DatabaseIsolationLevel.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif

#undef S
#undef U
#ifdef ENABLEUNICODE
#define S(c)		c
#define U(c)		c
#define UNI2XUB(c)	c
#define XUB2ANY(c)	::com::sun::star::uno::makeAny(::rtl::OUString(c))
#else
#define S(c)		UniString(c)
#define U(c)		UniString(c)
#define UNI2XUB(c)	XubString(c)
#define XUB2ANY(c)	::com::sun::star::uno::makeAny(::rtl::OUString(UniString(c)))
#endif

SV_IMPL_PTRARR(OfaDBParamArr, DBParamPtr)

//------------------------------------------------------------------------
// class OfaDBParam:

struct OfaDatabaseRef
{
	SbaDatabaseRef	pConnection;		// fuer Updates aus der QueryEditSh
};

OfaDBParam::OfaDBParam(SbaObject** pSbaObj) :
	pSbaObject(pSbaObj),
	pDBRef(NULL),
	pCursor(NULL),
	nCurrentPos(0),
	nCurrentSelPos(0),
	bTable(sal_False),
	bDirectPos(sal_False),
	bBasic(sal_False),
	bDirty(sal_False)
{
	pDBRef = new OfaDatabaseRef;
	pSelectionList = new SbaSelectionList;
}

/*--------------------------------------------------------------------
	Beschreibung:	DTOR
 --------------------------------------------------------------------*/

OfaDBParam::~OfaDBParam()
{
	delete pDBRef;
}

/*--------------------------------------------------------------------
	Beschreibung:	Verbindung zur DB trennen
 --------------------------------------------------------------------*/

void OfaDBParam::Clear()
{
	sDBName.Erase();
	sStatement.Erase();
	pDBRef->pConnection = NULL;
	aDBDef = NULL;
	pCursor = NULL;
	nCurrentPos = 0;
	nCurrentSelPos = 0;
	bTable = sal_True;
	pSelectionList->Clear();
	bDirectPos = bDirty = sal_False;
}

void OfaDBParam::SetDBName(const String& rDBName)
{
	sDBName = rDBName;
}

/*--------------------------------------------------------------------
	Beschreibung:	Verbindung zur DB trennen
 --------------------------------------------------------------------*/

String OfaDBParam::GetTableName()
{
	return sSymDBName.GetToken(1, DB_DELIM);
}

OfaDBParam& OfaDBParam::operator=( const OfaDBParam& r )
{
	sDBName			= r.sDBName;
	sSymDBName		= r.sSymDBName;
	sStatement		= r.sStatement;
	pDBRef->pConnection	= r.pDBRef->pConnection;
	aDBDef			= r.aDBDef;
	pCursor			= r.pCursor;
	nCurrentPos		= r.nCurrentPos;
	nCurrentSelPos	= r.nCurrentSelPos;
	bTable			= r.bTable;
	pSelectionList  = r.pSelectionList;
	bDirectPos		= r.bDirectPos;
	bBasic			= r.bBasic;
	bDirty			= r.bDirty;

	return *this;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

sal_Bool OfaDBParam::HasConnection()
{
	return pDBRef->pConnection.Is();
}

/*--------------------------------------------------------------------
	Beschreibung:	DB-Manager
 --------------------------------------------------------------------*/

/*--------------------------------------------------------------------
	Beschreibung: CTOR
 --------------------------------------------------------------------*/

OfaDBMgr::OfaDBMgr() :
			pOffApp(OFF_APP()),
			pSbaObject(NULL),
			nCurrParamPos(0),
			bInMerge(sal_False)//,
//			bBasicHasTable(sal_False)
{
}
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SbaObject* OfaDBMgr::Impl_SbaObject()
{
	return pOffApp->GetSbaObject();
}

/*--------------------------------------------------------------------
	Beschreibung: SQL-::com::sun::star::ucb::Command an DB-::com::sun::star::script::Engine uebermitteln
 --------------------------------------------------------------------*/

#ifdef OFADBMGR_INCLUDE_UNUSED_FUNCTIONS
sal_Bool OfaDBMgr::SendSQLCommand(const sal_Bool bBasic, const String& rStatement)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_Bool bRet = sal_False;

	sal_uInt32 nOldRec = GetCurRecordId(bBasic);	// Alte Position merken

	if (rParam.HasConnection())
	{
		bRet = rParam.pDBRef->pConnection->ExecuteSQL(rStatement);

		if (bRet)
		{
			// Cursor neu initialisieren, um DB-Cache zu loeschen!
			Flush(bBasic);
			ToSelectedRecord(bBasic, nOldRec);	// Alte Position restaurieren

			if (rParam.pCursor->IsOffRange() && nOldRec > 0)
				ToSelectedRecord(bBasic, nOldRec - 1);
			bRet = IsSuccessful(bBasic);
		}
	}

	return bRet;
}
#endif
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void OfaDBMgr::SetNewStatement(const sal_Bool bBasic, const String& rStatement)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	rParam.sStatement = rStatement;

	String sDBName(rParam.GetSymDBName());
	sDBName += ';';
	sDBName += rStatement;

	rParam.SetDBName(sDBName);
	rParam.bTable = sal_False;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String OfaDBMgr::ImportDBField(sal_uInt16 i, SbaDBDataDef* pDef, const ODbRowRef& xRow, double* pNumber, sal_uInt32* pFormat)
{
	String aString;

	const ODbVariantRef& xVar = (*xRow)[i];

	if (!xVar->isNull())
	{
		const SbaColumnList& rCols = pDef->GetOriginalColumns();
		SbaColumn* pCol = rCols.GetObject(i-1);
		const SbaDataFieldTypeItem* pTypeItem = (const SbaDataFieldTypeItem*)&pCol->Get(SBA_DEF_FLTTYPE);
		Color* pColor;
		{
			switch (pTypeItem->GetValue())
			{
				case dbMemo:
				case dbText:
				case dbChar:
				{
					try
					{
						aString = xVar->toString().getStr();
					}
					catch(...)
					{
					}
				}	break;
				case dbCurrency:
				case dbCounter:
				case dbDecimal:
				case dbNumeric:
				case dbDateTime:
				case dbDate:
				case dbTime:
				case dbBool:
				case dbBigInt:
				{
					try
					{
						if (pNumber)
							*pNumber = xVar->toDouble();
					}
					catch(...)
					{
					}
					aString = pDef->GetOutputString(xVar, i-1, &pColor);
				}	break;
				default:
					aString = String();
					break;
			}
		}
		if (pFormat)
		{
			SFX_ITEMSET_GET(*pCol, pFormatItem, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True);
			*pFormat = pFormatItem->GetValue();
		}
	}

	return (aString);
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor zu einem bestimmten Eintrag direkt bewegen
 --------------------------------------------------------------------*/

void OfaDBMgr::GotoRecord(const sal_Bool bBasic, sal_uInt32 nIndex)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (!rParam.pCursor)
		return;

	// Nchsten zu lesenden Datensatz ansteuern
	// Direkt positionieren, wenn es erlaubt und ein lohnender Offset ist.
	if (rParam.bDirectPos && Abs((long)nIndex - (long)rParam.nCurrentPos) > 100)
	{
		rParam.pCursor->MoveAbs(nIndex);
		rParam.nCurrentPos = nIndex;
	}
	else
	{
		if (rParam.pCursor->IsOffRange())
		{
			// Trotz Fehlers nicht auf den ersten Datensatz positionieren,
			// sondern Fehler melden.
			if (!IsSuccessful(bBasic))
				return;
		}


		if (rParam.nCurrentPos > nIndex)
		{
			while (!rParam.pCursor->IsOffRange() && rParam.nCurrentPos > nIndex)
			{
				rParam.pCursor->Prev();
				rParam.nCurrentPos--;
			}
		}
		else
		{
			while (!rParam.pCursor->IsOffRange() && rParam.nCurrentPos < nIndex)
			{
				rParam.pCursor->Next();
				rParam.nCurrentPos++;
			}
		}
	}
}

/*--------------------------------------------------------------------
	Beschreibung: Neuen Datenbankeintrag anlegen
  --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::CreateDatabaseEntry(const String& rDBName, const String& rTitle, const String& rArgs)
{
	sal_Bool bResult = sal_False;
	if (GetSbaObject()->CreateDatabase(rDBName, rTitle, rArgs))
	{
		// aktualisieren im explorer
		DirEntry aEntry(rDBName);
		String aPathToReload = aEntry.GetPath().GetFull();
		GetpApp()->UserEvent(SID_RELOAD, (void *)aPathToReload.GetBuffer());
		bResult = sal_True;
	}
	return bResult;
}

/*--------------------------------------------------------------------
	Beschreibung: Datenbankeintrag loeschen
  --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::DeleteDatabaseEntry(const String& rDBName)
{
	sal_Bool bResult = sal_False;
	// Da auch ueber den Titel eine datenbank geloescht werden kann wird
	// hier nur eventuell der Filename ermittelt
#ifdef IRIX
	// ER: IRIX kann nicht zwischen "Pointer- und Arithmetik-ternaer"
	// unterscheiden, ein "(const String&)" Cast tut es hier nicht, da
	// GetDatabaseName einen temporaeren String liefert!
	String aDBFile;
	if ( DirEntry(rDBName).Exists() )
		aDBFile = rDBName;
	else
		aDBFile = GetSbaObject()->GetDatabaseName(rDBName);
#else
	String aDBFile = DirEntry(rDBName).Exists() ? rDBName : GetSbaObject()->GetDatabaseName(rDBName);
#endif
	if (GetSbaObject()->DropDatabase(rDBName))
	{
		// aktualisieren im explorer
		DirEntry aEntry(aDBFile);
		String aPathToReload = aEntry.GetPath().GetFull();
		GetpApp()->UserEvent(SID_RELOAD, (void *)aPathToReload.GetBuffer());
		bResult = sal_True;
	}
	return bResult;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

long OfaDBMgr::GetDatabaseLimits(const String& rDBName, sal_uInt16 nType)
{
	long nRet(-1); // ist schneller als eine Zuweisung

	SbaDatabaseRef pConnect = GetSbaObject()->GetDatabase( rDBName, sal_False );
	if ( pConnect.Is() )
	{
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = pConnect->GetMetaData();
		switch ( nType )
		{
			case 1:
				nRet = rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::TABLE_NAME_LEN );
				break;
			case 2:
				nRet = rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN );
				break;
			case 3:
				nRet = rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::COLUMNS_IN_TABLE );
		}
	}
	return nRet;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

OfaDBParam& OfaDBMgr::GetDBData(const sal_Bool bBasic, const String* pDBName)
{
	String sDefDBName;

	if (pDBName && pDBName->Len())
	{
		if (bBasic)
			sLastBasicName = *pDBName;
		else
			sLastName = *pDBName;
	}
	else
	{
		if (bBasic)
			pDBName = &sLastBasicName;
		else
			pDBName = &sLastName;
	}

	if (!pDBName->Len())	// Leere Datenbanknamen z.B. vom Basic unterbinden
	{
		sDefDBName = GetAddressDBName();
		pDBName = &sDefDBName;
	}

	sal_Bool bFound = sal_False;
#ifdef UNX
	String sDBName(ExtractDBName(*pDBName));
#else
	String sDBName(ExtractDBName(*pDBName));
	sDBName.ToUpperAscii();
#endif
	OfaDBParam* pParam = NULL;

	for (sal_uInt16 i = 0; i < aDBDataArr.Count(); i++)
	{
		pParam = aDBDataArr[i];

#ifdef UNX
		if (sDBName == pParam->GetSymDBName() && bBasic == pParam->bBasic)
#else
		if (sDBName == String(pParam->GetSymDBName()).ToUpperAscii() && bBasic == pParam->bBasic)
#endif
		{
			bFound = sal_True;
			break;
		}
	}

	if (!bFound)
	{
		DBG_ASSERT(sDBName.Len(), "Datenbankzugriff ohne DB-Name!");
		aDBDataArr.Insert(new OfaDBParam(&pSbaObject), aDBDataArr.Count());
		pParam = aDBDataArr[i];
		pParam->bBasic = bBasic;
		pParam->sSymDBName = ExtractDBName(*pDBName);
		pParam->sStatement = ExtractDBStatement(*pDBName);
		// Ohne Statement Cursor per ueber Tabellennamen oeffnen
		if (!pParam->sStatement.Len() && pParam->sSymDBName.GetToken(1, DB_DELIM).Len())
			pParam->bTable = sal_True;
	}

	if (pParam->GetDirty())
	{
		pParam->SetDirty(sal_False);
		if (OpenDB(bBasic, pParam->GetSymDBName()))
			ToFirstSelectedRecord(bBasic);
	}

	return *pParam;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

OfaDBParam* OfaDBMgr::GetFirstDBData(const sal_Bool bBasic)
{
	OfaDBParam* pParam;
	bCurrBasic = bBasic;
	sal_uInt16 nCount = aDBDataArr.Count();

	for (nCurrParamPos = 0; nCurrParamPos < nCount; nCurrParamPos++)
	{
		pParam = aDBDataArr[nCurrParamPos];

		if (bCurrBasic == pParam->bBasic)
			return pParam;
	}

	return NULL;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

OfaDBParam* OfaDBMgr::GetNextDBData()
{
	OfaDBParam* pParam;

	while (++nCurrParamPos < aDBDataArr.Count())
	{
		pParam = aDBDataArr[nCurrParamPos];

		if (bCurrBasic == pParam->bBasic)
			return pParam;
	}

	return NULL;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String OfaDBMgr::ExtractDBName(const String& rDBName)
{
	return rDBName.GetToken(0);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String OfaDBMgr::ExtractDBStatement(const String& rDBName)
{
	String sStatement;
	sal_uInt16 nPos;

	if ((nPos = rDBName.Search(';')) != STRING_NOTFOUND)
		sStatement = rDBName.Copy(nPos + 1);

	return (sStatement);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

const String& OfaDBMgr::GetAddressDBName()
{
	if (!sAddressName.Len())
	{
		String sDBName;
		String sTableName;

		if (!pOffApp->HasSbaObject())
		{	// force the loading of sba. no chance to get the title without sba.
			GetSbaObject();
		}

		if (pOffApp->HasSbaObject())
		{
			// Symbolischen Namen organisieren:
			sDBName = GetSbaObject()->GetAddrDBName();
			sDBName = GetDatabaseTitle(sDBName);
			sTableName = GetSbaObject()->GetAddrTableName();
		}

		if (!sDBName.Len() || !sTableName.Len())
		{
			SfxIniManager* pIni = ((SfxApplication* )pOffApp)->GetIniManager();
			sDBName = pIni->Get(SFX_KEY_ADDRESSBOOK);
			String sPath = sDBName.GetToken(0, ';');

			sTableName = sDBName.GetToken(1, ';');
			sDBName = String::CreateFromAscii("Adressbuch");

			if (!sPath.Len() || !sTableName.Len())
				sTableName = String::CreateFromAscii("Adressen");
			else
			{
				// these are relicts. the database title is not anymore accessable via the StarBaseDocuments stream.

				// Lesen des Datenbanktitels, wird ohne Datenbankobject gemacht,
				// um Sba, sdb nicht unnoetig anzuziehen.
				// leider dadurch Code Redundanze zu Sdb
				SvStorageRef aStorage = new SvStorage(sPath, STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYWRITE, STORAGE_TRANSACTED);
				if (aStorage.Is() && aStorage->GetError() == ERRCODE_NONE)
				{
					SvStorageStreamRef aStream = aStorage->OpenStream(String::CreateFromAscii("StarBaseDocument"),STREAM_STD_READ);
					if (aStream.Is() && aStream->GetError() == ERRCODE_NONE)
					{
						ByteString aValue;
						aStream->ReadLine(aValue);
						aValue.Convert(RTL_TEXTENCODING_MS_1252, gsl_getSystemTextEncoding());
						if (aValue.GetTokenCount(';') == 2)		// Lesen des Titels
							sDBName = String(aValue.GetToken(1,';'),gsl_getSystemTextEncoding());
					}
				}
			}
		}

		sAddressName = sDBName;
		sAddressName += DB_DELIM;
		sAddressName += sTableName;
	}

	return sAddressName;
}

//------------------------------------------------------------------------------
String OfaDBMgr::GetDatabaseTitle(const String& rFileName)
{
	return SBA_MOD_EXT()->GetDatabaseAlias(rFileName);
//	// Sucht im Datenbankverzeichnis nach ::com::sun::star::text::Bookmarks auf Datenbanken
//	String aResult;
//
//	String aDatabasePath = SBA_MOD()->GetDatabasePath();
//	DirEntry aEntry(aDatabasePath);
//	if (!aEntry.Exists())
//		return aResult;
//
//	// neue basis fuer URLObject setzen, damit Pfadangaben,
//	// die relativ zum Datenbankpfad sind, akzeptiert werden
//
//	aEntry += DirEntry('*');
//	aEntry.SetExtension(INTERNETSHORTCUT_EXT);
//	aEntry.ToAbs();
//
//	// Abpruefen auf aktuelles Url-Schema (File-Protokoll) und
//	// altes Protokoll (private:explorer/database/)
//	INetURLObject aRef;
//
//	aRef.SetSmartProtocol(INET_PROT_FILE);
//	aRef.SetURL(rFileName, sal_False);
//
//	WildCard aFileWc(String(aRef.GetMainURL()).ToUpper());
//	Dir aDir(aEntry, FSYS_KIND_FILE, FSYS_SORT_NAME, FSYS_SORT_END);
//	for (sal_uInt16 i=0 ; i < aDir.Count(); i++)
//	{
//		String sUrlFile = aDir[i].GetFull();
//		String aURL = SBA_MOD_EXT()->readFavoriteTarget(sUrlFile);
//		if (aFileWc.Matches(aURL.Upper()))
//		{
//			aRef.SetURL(aURL, sal_False);
//			String aDatabaseName(aRef.PathToFileName());
//
//			if (DirEntry(aDatabaseName).Exists())
//			{
//				aResult = SBA_MOD_EXT()->readFavoriteTitle(sUrlFile);
//				break;
//			}
//		}
//	}
//
//	return aResult;
}

/*--------------------------------------------------------------------
	Beschreibung: Datenbank ffnen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::OpenDB(const sal_Bool bBasic, sal_Bool bShowError)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.GetDBName().Len() && rParam.HasConnection())
		return (sal_True);	// Verbindung besteht bereits

	WaitObject aWait;

	SbaDatabaseRef pConnect = GetSbaObject()->GetDatabase(rParam.GetSymDBName().GetToken(0, DB_DELIM), bShowError);

	if( pConnect )
	{
		rParam.pDBRef->pConnection = pConnect;

		// Direktpositionierung ist nur moeglich, wenn es der Treiber erlaubt
		rParam.bDirectPos = sal_True;
	}

	return pConnect.Is();
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::OpenDB(const sal_Bool bBasic, const String& rDBName, sal_Bool bShowError)
{
	OfaDBParam& rParam = GetDBData(bBasic, &rDBName);

	if (!rDBName.Len())
		return (sal_False);

	if (rParam.GetDBName().Len() && rParam.HasConnection())
	{
		if (String(ExtractDBName(rDBName)).ToUpperAscii() != String(rParam.GetSymDBName()).ToUpperAscii())
		{
			DBG_ASSERT(!this, "Interne Datenbankdaten inkonsistent!!!");
			RemoveConnection(bBasic);
		}
		else
			return (sal_True);	// Verbindung besteht bereits
	}

	WaitObject aWait();

	SbaDatabaseRef pConnect = GetSbaObject()->GetDatabase(ExtractDBName(rDBName).GetToken(0, DB_DELIM), bShowError);

	if ( pConnect )
	{
		rParam.SetDBName(rDBName);
		rParam.pDBRef->pConnection = pConnect;

		// Direktpositionierung ist nur moeglich, wenn es der Treiber erlaubt
		rParam.bDirectPos = sal_True;

		// ist das Ding ein Statement ?
		if (ExtractDBStatement(rDBName).Len())
			return sal_True;

		// ansonsten testen, ob es eine Abfrage oder eine Tabelle mit dem geforderten Namen gibt
		String sTableName(rParam.GetTableName());
		if (pConnect->HasObject(dbQuery, sTableName))
			return sal_True;
		if (pConnect->HasObject(dbTable, sTableName))
			return sal_True;

		RemoveConnection(bBasic);
		return sal_False;
	}
	else
		return sal_False;
}
/*--------------------------------------------------------------------
	Beschreibung: Wurde die Datenbank schon geoeffnet?
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::IsDBOpen(const sal_Bool bBasic, const String& rDBName)
{
	return (aDBDataArr.Count() ? GetDBData(bBasic, &rDBName).HasConnection() : sal_False);
}

#
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void OfaDBMgr::PreInitDBData(const String& rDBName, long nSelStart, long nSelEnd)
{
	OfaDBParam& rParam = GetDBData(DBMGR_STD, &rDBName);

	rParam.pSelectionList->Clear();

	if (nSelStart > 0)
	{
		if (nSelEnd < nSelStart)
		{
			sal_uInt32 nZw = nSelEnd;
			nSelEnd = nSelStart;
			nSelStart = nZw;
		}

		for (long i = nSelStart; i <= nSelEnd; i++)
			rParam.pSelectionList->Insert((void*)i , LIST_APPEND);
	}
	rParam.SetDirty(sal_True);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void OfaDBMgr::GetDBSelection(const String& rDBDesc, long& rSelStart, long& rSelEnd)
{
	OfaDBParam& rParam = GetDBData(DBMGR_STD, &rDBDesc);

	if (!rParam.pSelectionList->Count())
		rSelStart = -1L;
	else
	{
		rSelStart = (sal_uInt32)rParam.pSelectionList->GetObject(0);
		for (sal_uInt32 i = 1; i < rParam.pSelectionList->Count(); i++)
		{
			long nPrev = (sal_uInt32)rParam.pSelectionList->GetObject(i - 1);
			long nNow = (sal_uInt32)rParam.pSelectionList->GetObject(i);

			if (nNow - nPrev > 1)
			{
				rSelEnd = nPrev;
				return;
			}
		}
		rSelEnd = (sal_uInt32)rParam.pSelectionList->GetObject(i - 1);
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void OfaDBMgr::SetAllDirty(const sal_Bool bBasic, const sal_Bool bDirty)
{
	for (sal_uInt16 i = 0; i < aDBDataArr.Count(); i++)
	{
		OfaDBParam& rParam = *aDBDataArr[i];

		if (bBasic == rParam.bBasic && (!bDirty || !IsInMerge()))
			rParam.SetDirty(bDirty);
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::IsSuccessful(const sal_Bool bBasic)
{
	return (IsSuccessful(bBasic, &GetDBData(bBasic).pCursor));
}

sal_Bool OfaDBMgr::IsSuccessful(const sal_Bool bBasic, SdbCursor **ppCursor)
{
	sal_Bool bRet = sal_False;

	if (*ppCursor != NULL)
	{
		if ( !(*ppCursor)->Status().IsSuccessful())
		{
			bRet = sal_False;

			if ((*ppCursor)->Status().IsError())
			{
				if (bBasic == DBMGR_STD)
				{
					InfoBox aInfoBox( NULL, (*ppCursor)->Status().ErrorMessage() );
					aInfoBox.Execute();
				}
				DBG_ERROR(ByteString((*ppCursor)->Status().ErrorMessage(),gsl_getSystemTextEncoding()).GetBuffer());

				(*ppCursor)->ReleaseRef();
				*ppCursor = NULL;

				return(sal_False);
			}
		}
		else
			bRet = sal_True;
	}

	return (bRet);
}

/*--------------------------------------------------------------------
	Beschreibung: Bei gendertem Select-Statement neuen Cursor anlegen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ChangeStatement(const sal_Bool bBasic, const String &rStatement)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (!rParam.HasConnection())
		return sal_False;

	if (rStatement != rParam.sStatement && rStatement.Len() && rParam.HasConnection())
	{
		SetNewStatement(bBasic, rStatement);
		String sString(rStatement);
		sString.ToUpperAscii();

		if (rParam.pCursor)
		{
			rParam.pCursor->ReleaseRef();
			rParam.aDBDef = NULL;
			rParam.pCursor = NULL;
		}
	}

	if (rParam.pCursor == NULL && rParam.HasConnection())
	{
		sal_uInt16 nOption = bBasic ? 0 : SDB_READONLY;

		if (rParam.bTable)
		{
			String sTable(rParam.GetSymDBName().GetToken(1, DB_DELIM));
			rParam.pCursor = rParam.pDBRef->pConnection->OpenCursor(sTable, SDB_KEYSET, nOption);
			if (rParam.pCursor)
				rParam.pCursor->AddRef();
		}
		else
		{
			if (rParam.sStatement.Len())
			{
				if ((rParam.pCursor = rParam.pDBRef->pConnection->CreateCursor(SDB_KEYSET, nOption)) != NULL)
				{
					rParam.pCursor->Open(rParam.sStatement,rParam.bTable);
					rParam.pCursor->AddRef();
				}
			}
			else	// Ohne Statement oder Tabelle kein Cursor
			{
				rParam.pCursor->ReleaseRef();
				rParam.pCursor = NULL;
			}

		}
		rParam.nCurrentPos = 0;
		IsSuccessful(bBasic);
	}

	return rParam.pCursor != NULL;
}

/*--------------------------------------------------------------------
	Beschreibung: Lesen der Spaltennamen vorbereiten
 --------------------------------------------------------------------*/

SbaDBDataDef* OfaDBMgr::OpenColumnNames(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	String sTableName(rParam.GetTableName());
	DBObject eDBType = dbTable;

	if (!rParam.aDBDef.Is() && rParam.HasConnection())
	{
		if (rParam.sStatement.Len())
		{
			// Leerer Queryname fuer Temporaere-::com::sun::star::sdb::Query
			// siehe dbqryobj.cxx in sba
			String sQueryName = SDB_STATEMENT_DELIMETER;
			sQueryName += '0';	// STATEMENT
			sQueryName += SDB_STATEMENT_DELIMETER;
			sQueryName += rParam.sStatement;
			sTableName = sQueryName;
			eDBType = dbQuery;
		}
		else if (rParam.pDBRef->pConnection->HasObject(dbQuery,sTableName))
			eDBType = dbQuery;

		rParam.aDBDef = (SbaDBDataDef*)rParam.pDBRef->pConnection->OpenDBDef(eDBType, sTableName, bBasic == DBMGR_STD);
	}
	return &rParam.aDBDef;
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor neu initialisieren und alte Position restaurieren
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::RestoreOldCursorPos(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_Bool bRet = sal_False;

	sal_uInt32 nOldRec = GetCurRecordId(bBasic);	// Alte Position merken

	// Cursor neu initialisieren, um DB-Cache zu loeschen!
	Flush(bBasic);
	ToSelectedRecord(bBasic, nOldRec);	// Alte Position restaurieren

	if (rParam.pCursor && rParam.pCursor->IsOffRange() && nOldRec > 0)
		ToSelectedRecord(bBasic, nOldRec - 1);
	bRet = IsSuccessful(bBasic);

	return bRet;
}

/*--------------------------------------------------------------------
	Beschreibung: DB-Cache loeschen
 --------------------------------------------------------------------*/

void OfaDBMgr::Flush(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	// Cursor neu initialisieren, um DB-Cache zu loeschen!
	if (rParam.pCursor)
	{
		rParam.pCursor->ReleaseRef();
		rParam.pCursor = NULL;
		ChangeStatement(bBasic, rParam.sStatement);
		ToFirstSelectedRecord(bBasic);
	}
}

/*--------------------------------------------------------------------
	Beschreibung:	Verbindung zur DB trennen
 --------------------------------------------------------------------*/

void OfaDBMgr::RemoveConnection(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.HasConnection())
	{
		DBG_ASSERT(GetSbaObject(), "pSbaObject==NULL");

		if (rParam.pCursor)
		{
			rParam.pCursor->ReleaseRef();
			rParam.pCursor = NULL;
		}
		rParam.Clear();
	}
}

/*--------------------------------------------------------------------
	Beschreibung: Alle geoeffneten Datenbanken schliessen
 --------------------------------------------------------------------*/

void OfaDBMgr::CloseAll(const sal_Bool bBasic)
{
	OfaDBParam* pParam = NULL;

	for (sal_uInt16 i = 0; i < aDBDataArr.Count(); i++)
	{
		pParam = aDBDataArr[i];

		if (pParam->bBasic == bBasic)
		{
			if (pParam->pCursor)
			{
				pParam->pCursor->ReleaseRef();
				pParam->pCursor = NULL;
			}
			pParam->pDBRef->pConnection = NULL;
			pParam->aDBDef = NULL;
		}
	}
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor anlegen und auf den ersten Eintrag stellen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ToFirstSelectedRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	SbaDatabaseRef pConnect = rParam.pDBRef->pConnection;

	if (!rParam.HasConnection())
		return sal_False;

	if (rParam.pCursor && (rParam.pCursor->IsOffRange() || !IsSuccessful(bBasic)))
		rParam.nCurrentPos = 0;	// Cursor steht im Wald

	if (!rParam.pCursor)	// Neuen Cursor anlegen
	{
		String sTableName(rParam.GetSymDBName().GetToken(1, DB_DELIM));
		if (!rParam.sStatement.Len())	// Ohne Statement keinen Cursor anlegen
		{
			if (!sTableName.Len())
				return (sal_False);
			else
				rParam.bTable = sal_True;
		}

		sal_uInt16 nOption = bBasic ? 0 : SDB_READONLY;

		if (rParam.bTable)
			rParam.pCursor = pConnect->OpenCursor(sTableName, SDB_KEYSET, nOption);
		else
		{
			if ((rParam.pCursor = pConnect->CreateCursor(SDB_KEYSET, nOption)) != NULL)
				rParam.pCursor->Open(rParam.sStatement, rParam.bTable);
			DBG_ASSERT(rParam.pCursor, "DB-Cursor konnte nicht angelegt werden");
		}
		if (rParam.pCursor)
			rParam.pCursor->AddRef();

		rParam.nCurrentPos = 1;
		rParam.nCurrentSelPos = 0;

		if (IsSuccessful(bBasic) && rParam.pCursor)
			rParam.pCursor->First();
		else
			return (sal_False);
	}

	if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
	{
		if (!rParam.nCurrentPos)	// Cursor noch nicht initialisiert
		{
			rParam.pCursor->First();
			rParam.nCurrentPos = 1;
			rParam.nCurrentSelPos = 0;
		}
		sal_uInt32 nIndex = (sal_uInt32)rParam.pSelectionList->GetObject(0);

		DBG_ASSERT(nIndex >= rParam.nCurrentPos, "Zu lesender Datensatz < vorhergehender Datensatz!");

		// Nchsten zu lesenden Datensatz ansteuern
		GotoRecord(bBasic, nIndex);
	}
	else
	{
		rParam.pCursor->First();
		rParam.nCurrentPos = 1;
		rParam.nCurrentSelPos = 0;
	}

	if (rParam.pCursor->IsOffRange() || !IsSuccessful(bBasic))
		return(sal_False);

	return (sal_True);
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor zum nchsten (selektierten) Eintrag
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ToNextSelectedRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.pCursor)
	{
		if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
		{
			sal_uInt32 nCount = rParam.pSelectionList->Count();
			if (nCount - 1 <= rParam.nCurrentSelPos)
			{
				rParam.nCurrentSelPos = nCount;	// Auf illegale Position stellen um weiteres Lesen zu unterbinden
				return(sal_False);
			}

			sal_uInt32 nIndex = (sal_uInt32)rParam.pSelectionList->GetObject(++rParam.nCurrentSelPos);

			DBG_ASSERT(nIndex >= rParam.nCurrentPos, "Zu lesender Datensatz < vorhergehender Datensatz!");

			// Nchsten zu lesenden Datensatz ansteuern
			SetCursorOnValidPos(bBasic);
			GotoRecord(bBasic, nIndex);
		}
		else if (!rParam.pCursor->IsOffRange())
		{
			rParam.pCursor->Next();
			rParam.nCurrentPos++;
		}

		if (rParam.pCursor->IsOffRange() || !IsSuccessful(bBasic))
			return(sal_False);
	}
	else
		return(sal_False);

	return(sal_True);
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor zum vorherigen (selektierten) Eintrag
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ToPrevSelectedRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.pCursor)
	{
		if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
		{
			sal_uInt32 nCount = rParam.pSelectionList->Count();
			if (rParam.nCurrentSelPos - 1 >= nCount || rParam.nCurrentSelPos < 1)
			{
				rParam.nCurrentSelPos = nCount;	// Auf illegale Position stellen um weiteres Lesen zu unterbinden
				return(sal_False);
			}

			sal_uInt32 nIndex = (sal_uInt32)rParam.pSelectionList->GetObject(--rParam.nCurrentSelPos);

			DBG_ASSERT(nIndex <= rParam.nCurrentPos, "Zu lesender Datensatz > vorhergehender Datensatz!");

			// Nchsten zu lesenden Datensatz ansteuern
			SetCursorOnValidPos(bBasic);
			GotoRecord(bBasic, nIndex);
		}
		else
		{
			if (rParam.nCurrentPos < 2)
				return(sal_False);

			rParam.pCursor->Prev();
			rParam.nCurrentPos--;
		}

		if (rParam.pCursor->IsOffRange() || !IsSuccessful(bBasic))
			return(sal_False);
	}
	else
		return(sal_False);

	return(sal_True);
}

/*--------------------------------------------------------------------
	Beschreibung: Anzahl der Datenstze ermitteln
 --------------------------------------------------------------------*/

sal_uInt32 OfaDBMgr::GetRowCount(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	SbaDatabaseRef pConnect = rParam.pDBRef->pConnection;
	sal_uInt32 nRet = 0;

	if (!rParam.HasConnection())
		return 0;

	if (!rParam.pCursor)
		ToFirstSelectedRecord(DBMGR_BASIC);

	if (rParam.pCursor)
	{
		rParam.pCursor->DetermineRowCount();
		nRet = (sal_uInt32)rParam.pCursor->RowCount();
	}

	return nRet;
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor auf den letzten Eintrag stellen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ToLastSelectedRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	SbaDatabaseRef pConnect = rParam.pDBRef->pConnection;
	sal_Bool bRet = sal_False;

	if (!rParam.HasConnection())
		return sal_False;

	if (!rParam.pCursor)	// Neuen Cursor anlegen
	{
		String sTableName(rParam.GetSymDBName().GetToken(1, DB_DELIM));
		if (!rParam.sStatement.Len())	// Ohne Statement keinen Cursor anlegen
		{
			if (!sTableName.Len())
				return (sal_False);
			else
				rParam.bTable = sal_True;
		}

		sal_uInt16 nOption = bBasic ? 0 : SDB_READONLY;

		if (rParam.bTable)
			rParam.pCursor = pConnect->OpenCursor(sTableName, SDB_KEYSET, nOption);
		else
		{
			if ((rParam.pCursor = pConnect->CreateCursor(SDB_KEYSET, nOption)) != NULL)
				rParam.pCursor->Open(rParam.sStatement);
			DBG_ASSERT(rParam.pCursor, "DB-Cursor konnte nicht angelegt werden");
		}
		if (rParam.pCursor)
			rParam.pCursor->AddRef();

		rParam.nCurrentPos = 1;
		rParam.nCurrentSelPos = 0;

		if (IsSuccessful(bBasic) && rParam.pCursor)
			rParam.pCursor->First();
		else
			return (sal_False);
	}
	if (rParam.pCursor)
	{
		if (rParam.pCursor->IsPrepared())
			rParam.pCursor->Open();
		rParam.pCursor->Last();
		if (!IsSuccessful(bBasic))
			return (sal_False);

		if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
		{
			sal_uInt32 nIndex = rParam.pSelectionList->Count() - 1;

			// Nchsten zu lesenden Datensatz ansteuern
			SetCursorOnValidPos(bBasic);
			GotoRecord(bBasic, nIndex);
		}
		else
		{
			rParam.pCursor->Last();
			rParam.pCursor->DetermineRowCount();
			rParam.nCurrentPos = (sal_uInt32)rParam.pCursor->RowCount();
			rParam.nCurrentSelPos = 0;
		}

		if (!rParam.pCursor->IsOffRange() && IsSuccessful(bBasic))
			bRet = sal_True;
	}

	return bRet;
}

/*--------------------------------------------------------------------
	Beschreibung: Ist Cursor auf dem ersten Eintrag?
 --------------------------------------------------------------------*/

/*sal_Bool OfaDBMgr::IsFirstRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_Bool bRet = sal_False;

	if (rParam.HasConnection() && rParam.pCursor)
		bRet = rParam.pCursor->IsOnFirst();

	return bRet;
}

/*--------------------------------------------------------------------
	Beschreibung: Ist Cursor auf dem letzten Eintrag?
 --------------------------------------------------------------------*/

/*sal_Bool OfaDBMgr::IsLastRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_Bool bRet = sal_False;

	if (rParam.HasConnection() && rParam.pCursor)
		bRet = rParam.pCursor->IsOnLast();

	return bRet;
}

/*--------------------------------------------------------------------
	Beschreibung: Cursor zu einem bestimmten Eintrag bewegen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ToSelectedRecord(const sal_Bool bBasic, sal_uInt32 nRecNum)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_uInt32 nIndex;

	if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
	{
		rParam.nCurrentSelPos = nRecNum;

		if (rParam.pSelectionList->Count() >= nRecNum)
		{
			nIndex = (sal_uInt32)rParam.pSelectionList->GetObject(nRecNum);
			SetCursorOnValidPos(bBasic);
			GotoRecord(bBasic, nIndex);
		}
		else
			return (sal_False);
	}
	else
	{
		rParam.nCurrentSelPos = 0;
		SetCursorOnValidPos(bBasic);
		GotoRecord(bBasic, nRecNum + 1);
	}

	if (!rParam.pCursor || !IsSuccessful(bBasic) || rParam.pCursor->IsOffRange())
		return (sal_False);
	else
		return (sal_True);
}

/*--------------------------------------------------------------------
	Beschreibung: Invaliden Cursor auf gltige Position stellen
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::SetCursorOnValidPos(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.pCursor && rParam.pCursor->IsOffRange())
		return ToFirstSelectedRecord(bBasic);
	else
		return sal_True;
}

/*--------------------------------------------------------------------
	Beschreibung: Aktuellen Datensatz lesen
 --------------------------------------------------------------------*/

ODbRowRef OfaDBMgr::GetCurSelectedRecord(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	ODbRowRef aRow;

	if (rParam.pCursor)
	{
		sal_Bool bEnd = rParam.pCursor->IsOffRange();

		if (!bEnd)
		{
			if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
			{
				sal_uInt32 nCount = rParam.pSelectionList->Count();
				if (nCount && nCount <= rParam.nCurrentSelPos)
					return (aRow);
			}

			aRow = rParam.pCursor->GetRow();
		}

		if (!IsSuccessful(bBasic))
			return ODbRowRef();
	}

	return (aRow);
}

/*--------------------------------------------------------------------
	Beschreibung: Absolute Datensatznummer innerhalb der Datenbank
 --------------------------------------------------------------------*/

sal_uInt32 OfaDBMgr::GetCurSelectedRecordId(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	sal_uInt32 nIndex;

	if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
		nIndex = (sal_uInt32)rParam.pSelectionList->GetObject(rParam.nCurrentSelPos);
	else
		nIndex = rParam.nCurrentPos;

	return (nIndex - 1);
}

/*--------------------------------------------------------------------
	Beschreibung: Datensatznummer innerhalb der Selektion oder Datenbank
 --------------------------------------------------------------------*/

sal_uInt32 OfaDBMgr::GetCurRecordId(const sal_Bool bBasic)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
		return rParam.nCurrentSelPos;
	else
		return rParam.nCurrentPos - 1;
}

/*--------------------------------------------------------------------
	Beschreibung: Absolute Datensatznummer auf relative "umrechnen"
 --------------------------------------------------------------------*/

sal_uInt32 OfaDBMgr::AbsToRel(const sal_Bool bBasic, sal_uInt32 nAbsPos)
{
	OfaDBParam& rParam = GetDBData(bBasic);

	if (rParam.pSelectionList.Is() && rParam.pSelectionList->Count())
	{
		sal_uInt32 nSelCount = rParam.pSelectionList->Count();
		nAbsPos++;

		for (sal_uInt32 i = 0; i < nSelCount; i++)
			if ((sal_uInt32)rParam.pSelectionList->GetObject(i) == nAbsPos)
				break;

		return i;
	}
	else
		return nAbsPos;
}

/*--------------------------------------------------------------------
	Beschreibung: Anzahl der Spalten liefern
 --------------------------------------------------------------------*/

/*short OfaDBMgr::GetColumnNum(const sal_Bool bBasic)
{
	short nRet = -1;	// Fehler == -1

	if (OpenDB(bBasic))
	{
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			nRet = (short)aDBDef->Count();
		}
	}
	return nRet;
}


/*--------------------------------------------------------------------
	Beschreibung: Spaltentyp liefern (in ::com::sun::star::form::component::Form einer Zahl,
										siehe SDB.HXX: SdbDatabaseType)
 --------------------------------------------------------------------*/

String OfaDBMgr::GetColumnType(const sal_Bool bBasic, sal_uInt16 nColPos, sal_Bool bSub)
{
	String sTyp;

	if (OpenDB(bBasic))
	{
		sal_uInt16 nCount = 0;
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			if (aDBDef->Count() >= nColPos)
			{
				if (bSub)
					sTyp = GetSubtypeDescription(aDBDef->GetColumn((sal_uInt16)(nColPos-1)));
				else
					sTyp = GetTypeDescription(aDBDef->GetColumn((sal_uInt16)(nColPos-1)));
			}
		}
	}
	return sTyp;
}
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String OfaDBMgr::GetSubtypeDescription(const SbaColumn* pCol)
{
	String sType;
	const SbaDataFieldTypeItem* pType = (const SbaDataFieldTypeItem*)&pCol->Get(SBA_DEF_FLTTYPE);
	SFX_ITEMSET_GET(*pCol, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, sal_True);
	switch (pType->GetValue())
	{
		case dbText:
		case dbChar:
		case dbBinary:
		case dbVarBinary:
			sType = pLength->GetValue();
			break;
		case dbNumeric:
			switch ((SbaNumericSize)pLength->GetValue())
			{
				case dbByte:
					sType.AssignAscii("sal_Int8");
					break;
				case dbInteger:
					sType.AssignAscii("INTEGER");
					break;
				case dbBigInt:
					sType.AssignAscii("BIGINTEGER");
					break;
				case dbLong:
					sType.AssignAscii("sal_Int32");
					break;
				case dbSingle:
					sType.AssignAscii("SINGLE");
					break;
				case dbDouble:
					sType.AssignAscii("DOUBLE");
					break;
			}
			break;
		case dbDecimal:
			sType.AssignAscii("DOUBLE");
			break;
	}
	return sType;
}
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String OfaDBMgr::GetTypeDescription(const SbaColumn* pCol)
{
	String sType;
	const SbaDataFieldTypeItem* pType = (const SbaDataFieldTypeItem*)&pCol->Get(SBA_DEF_FLTTYPE);

	switch (pType->GetValue())
	{
		case dbText:
		case dbChar:
//		case dbByte:
			sType.AssignAscii("TEXT");
			break;
		case dbCounter:
			sType.AssignAscii("COUNTER");
			break;
		case dbVarBinary:
		case dbBinary:
		case dbImage:
			sType.AssignAscii("IMAGE");
			break;
		case dbMemo:
			sType.AssignAscii("MEMO");
			break;
		case dbDecimal:
			sType.AssignAscii("DOUBLE");
			break;
		case dbNumeric:
			sType.AssignAscii("NUMERIC");
			break;
		case dbDateTime:
			sType.AssignAscii("DATE/TIME");
			break;
		case dbDate:
			sType.AssignAscii("DATE");
			break;
		case dbTime:
			sType.AssignAscii("TIME");
			break;
		case dbCurrency:
			sType.AssignAscii("CURRENCY");
			break;
		case dbBool:
			sType.AssignAscii("sal_Bool");
			break;
	}

	return sType;
}


/*--------------------------------------------------------------------
	Beschreibung: Spaltentyp liefern (dbNumeric, dbDateTime...)
 --------------------------------------------------------------------*/

short OfaDBMgr::GetColumnFormatType(const sal_Bool bBasic, sal_uInt16 nColPos)
{
	short nType = -1;

	if (OpenDB(bBasic))
	{
		sal_uInt16 nCount = 0;
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			if (aDBDef->Count() >= nColPos)
			{
				const SbaColumn* pCol = aDBDef->GetColumn(((sal_uInt16)(nColPos-1)));
				const SbaDataFieldTypeItem* pType = (const SbaDataFieldTypeItem*)&pCol->Get(SBA_DEF_FLTTYPE);
				nType = pType->GetValue();
			}
		}
	}
	return nType;
}

/*--------------------------------------------------------------------
	Beschreibung: Spaltenformat fuer Numberformatter liefern
 --------------------------------------------------------------------*/

sal_uInt32 OfaDBMgr::GetColumnFormat(const sal_Bool bBasic, sal_uInt16 nColPos)
{
	sal_uInt32 nFormat = 0;

	if (OpenDB(bBasic))
	{
		sal_uInt16 nCount = 0;
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			const SbaColumnList& rCols = aDBDef->GetOriginalColumns();
			if (rCols.Count() >= nColPos)
			{
				const SbaColumn* pCol = rCols.GetObject(nColPos-1);
				const SbaDataFieldTypeItem* pTypeItem = (const SbaDataFieldTypeItem*)&pCol->Get(SBA_DEF_FLTTYPE);
				const SfxUInt32Item* pFormatItem = (const SfxUInt32Item*)&pCol->Get(SBA_DEF_FMTVALUE);
				nFormat = pFormatItem->GetValue();
			}
		}
	}

	return nFormat;
}

/*--------------------------------------------------------------------
	Beschreibung: Inhalt des Feldes zum Spaltenname suchen und liefern
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::GetColumnCnt(const sal_Bool bBasic, String sColumnName, sal_uInt32 nRecNum, String &rResult, double *pNumber, sal_uInt32 *pFormat)
{
	sal_Bool bRet = sal_False;
	OfaDBParam& rParam = GetDBData(bBasic);

	if (IsInMerge() && !GetCurSelectedRecord(bBasic).Is())
		rResult = aEmptyStr;
	else
	{
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			ODbRowRef aRec;
			sColumnName.ToUpperAscii();

			for (sal_uInt16 i = 1; i <= aDBDef->Count(); i++)
			{
				const SbaColumn* pColumn = aDBDef->GetColumn((sal_uInt16)(i-1));
				const SbaNameItem* pName = (const SbaNameItem*)&pColumn->Get(SBA_DEF_FLTNAME);

				String aTmp(pName->GetValue());
				aTmp.ToUpperAscii();

				if (aTmp == sColumnName)
				{
					sal_uInt32 nOldRec = GetCurRecordId(bBasic);

					aRec = GetSelectedRecord( bBasic, nRecNum );

					if (aRec.Is() && aRec->size() > 0)
					{
						rResult = ImportDBField(i, &aDBDef, aRec, pNumber, pFormat);
						bRet = sal_True;
					}

					if (nOldRec != nRecNum)
						ToSelectedRecord(bBasic, nOldRec);
					break;
				}
			}
			if (bRet == sal_False)
				rResult = aEmptyStr;
		}
	}

	return bRet;
}


/*--------------------------------------------------------------------
	Beschreibung: Spaltenposition eines Spaltennamens liefern
 --------------------------------------------------------------------*/

int OfaDBMgr::GetColumnPos(const sal_Bool bBasic, String sColumnName)
{
	sal_Bool bRet = sal_False;
	int nPos = -1;

	if (OpenDB(bBasic))
	{
		sal_uInt16 nCount = 0;
		SbaDBDataDefRef aDBDef = OpenColumnNames(bBasic);
		if (aDBDef.Is())
		{
			const SbaColumnList& rCols = aDBDef->GetOriginalColumns();
			SbaColumn* pColumn = rCols.Lookup(sColumnName,String());
			if (pColumn)
				nPos = rCols.GetPos(pColumn) + 1;
		}
	}

	return nPos;
}

/*--------------------------------------------------------------------
	Beschreibung: Aktuellen Datensatz lesen
 --------------------------------------------------------------------*/

ODbRowRef OfaDBMgr::GetSelectedRecord(const sal_Bool bBasic, sal_uInt32 nRecNum)
{
	OfaDBParam& rParam = GetDBData(bBasic);
	ODbRowRef aRow;

	if (rParam.pCursor)
	{
		ToSelectedRecord(bBasic, nRecNum);

		sal_Bool bEnd = rParam.pCursor->IsOffRange();

		if (!bEnd)
			aRow = rParam.pCursor->GetRow();
	}

	return (aRow);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

sal_Bool OfaDBMgr::ShowInBeamer(const String& rDBName, const String& rName, sal_uInt16 nType, const String& rStatement)
{
	sal_Bool bRet = sal_True;

	if (rDBName.Len())
	{
		SbaDatabaseRef pConnection = GetSbaObject()->GetDatabase(rDBName, sal_False);

		if (!pConnection)
			bRet = sal_False;
		else if (rStatement.Len())
			pConnection->ShowStatement(rStatement, sal_False);
		else
			pConnection->ShowDBDef((DBObject)nType, rName);
	}
	return bRet;
}


