/*************************************************************************
 *
 *  $RCSfile: sbaconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma warning (once : 4270)

#ifndef _SV_FILEDLG_HXX //autogen
#include <svtools/filedlg.hxx>
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif

#ifndef _EXPLORER_HXX //autogen
#include <sfx2/explorer.hxx>
#endif

#ifndef _IODLG_HXX
#include <sfx2/iodlg.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _SDB_SDBENV_HXX //autogen
#include <sdb/sdbenv.hxx>
#endif

#ifndef _SDB_ODBCCONF_HXX //autogen
#include <sdb/odbcconf.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SDB_SDBCONN_HXX //autogen
#include <sdb/sdbconn.hxx>
#endif

#ifndef _PASSWD_HXX //autogen
#include <sfx2/passwd.hxx>
#endif

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXINIPROP_HXX //autogen
#include <svtools/iniprop.hxx>
#endif

#ifndef DEFAULT_LIST_SEPARATOR
#define DEFAULT_LIST_SEPARATOR	char(11)
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef SBA_SBACONN_HXX
#include "sbaconn.hxx"
#endif
#ifndef _DBCONFIG_HXX
#include "dbconfig.hxx"
#endif
#ifndef SBA_SBACONN_HRC
#include "sbaconn.hrc"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _DLGINDEXES_HXX
#include "dlgindex.hxx"
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SBA_DLGERR_HXX
#include <dlgerr.hxx>
#endif

#ifndef SBA_USER_HXX
#include "user.hxx"
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif
#ifndef SBA_ADANEWDB_HXX
#include "adanewdb.hxx"
#endif
#ifndef _SBA_ADASTAT_HXX_
#include "adastat.hxx"
#endif

#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif

#include <ctype.h>		//isdigit

DBG_NAME( SbaDlgTypeselect );
DBG_NAME( SbaDbtypeDlg );
DBG_NAME( SbaGeneralPage );
DBG_NAME( SbaOdbcPage );
DBG_NAME( SbaDb2Page );
DBG_NAME( SbaTextPage );
DBG_NAME( SbaDbasePage );
DBG_NAME( SbaFmkPage );
DBG_NAME( SbaORCL7Page );
DBG_NAME( SbaJdbcPage );
DBG_NAME( SbaDAOPage );
DBG_NAME( SbaADOPage );
DBG_NAME( SbaOTERPage );
DBG_NAME( SbaStarBasePage );
DBG_NAME( SbaCommonBehaviourTabPage );
DBG_NAME( SbaAdabasPage );
DBG_NAME( SbaAdabasSettings );
DBG_NAME( SbaAddrbookPage );


//==================================================================

#define FILL_STRING_ITEM(editcontrol, itemset, itemid)							\
	if (editcontrol.GetText() != editcontrol.GetSavedValue())					\
	{																			\
		itemset.Put(SfxStringItem(GetWhich(itemid), editcontrol.GetText()));	\
	}

#define CLEARUP(objectptr) if (objectptr) { delete objectptr; objectptr = NULL; }

//==================================================================

#ifndef PRODUCT
static char __ver[] = "$Workfile:   sbaconn.cxx  $$Revision: 1.1.1.1 $";
#endif

static sal_Unicode aNotAllowed[] = { '\xff', '\x7F', '#', '%', ';', '/', '?', ':', '@', '\\', '=', '&', '.', '\'' };

#pragma optimize( "", off )	// Bug, wenn unter OS2 optimiert wird

enum	DbTypeEnum{ T_NONE, T_ADABAS, T_JDBC, T_ODBC,T_ORCL7, T_DB2, T_DBF, T_OTER, T_DAO, T_ADO, T_TXT, T_FMK, T_ADDRBOOK};

struct DbTypeDef
{
	String		aKeyName;
	String		aLongName;
	DbTypeEnum	eServerType;
};

class SbaCharset
{
	private:
	String			aNameList;
	String			aKeyList;

	public:
	SbaCharset();
	inline	String	GetNameList() const
					{ return aNameList; }
	inline	String	GetKeyList() const
					{ return aKeyList; }
	String			KeyToName( const String& rKey ) const;
	String			NameToKey( const String& rName ) const;
};

DECLARE_LIST( DbTypeDefList, DbTypeDef* );

//==================================================================
SbaCharset::SbaCharset():
	aNameList( SbaResId(STR_CHARSETNAMES) ),
	aKeyList( SbaResId(STR_CHARSETKEYS) )
{
}

// -----------------------------------------------------------------------
String SbaCharset::KeyToName( const String& rKey ) const
{
	String	aRet;
	xub_StrLen nCnt = aKeyList.GetTokenCount();

	for( xub_StrLen i=0 ; i<nCnt ; i++ )
	{
		if( aKeyList.GetToken(i).EqualsIgnoreCaseAscii( rKey ) )
		{
			aRet = aNameList.GetToken( i );
			break;
		}
	}

	return aRet;
}

// -----------------------------------------------------------------------
String SbaCharset::NameToKey( const String& rName ) const
{
	String	aRet;
	xub_StrLen	nCnt = aNameList.GetTokenCount();

	for( xub_StrLen i=0 ; i<nCnt ; i++ )
	{
		if( aNameList.GetToken(i).EqualsIgnoreCaseAscii( rName ) )
		{
			aRet = aKeyList.GetToken( i );
			break;
		}
	}

	return aRet;
}

#ifndef SDB_SEPARATOR
#define SDB_SEPARATOR char(11)
#endif

//==================================================================
SbaDlgTypeselect::SbaDlgTypeselect(Window * pParent,
								   const String& rStrList,
								   const String& rServer,
								   sal_uInt16 nServerType)
				 :ModalDialog( pParent, SbaResId(DLG_TYPESELECT) )
				 ,aLB_DATASOURCE(	this, ResId( LB_DATASOURCE ) )
				 ,aPB_OK(			this, ResId( PB_OK ) )
				 ,aPB_CANCEL(		this, ResId( PB_CANCEL ) )
				 ,aPB_HELP(		this, ResId( PB_HELP ) )
				 ,aPB_MANAGE(		this, ResId( PB_MANAGE ) )
				 ,aGB_BOX1(		this, ResId( GB_BOX1 ) )
				 ,aServerType(rServer)

{
	DBG_CTOR( SbaDlgTypeselect, NULL );

	if(nServerType == T_ADABAS)
	{
		aGB_BOX1.SetText(SbaResId(STR_LOCAL_DATASOURCES));
	}

	for( xub_StrLen i=0 ; i < rStrList.GetTokenCount(SDB_SEPARATOR) ; i++ )
	{
		aLB_DATASOURCE.InsertEntry( rStrList.GetToken(i, SDB_SEPARATOR) );
	}

	if( aLB_DATASOURCE.GetEntryCount() )
		aLB_DATASOURCE.SelectEntryPos( 0 );

#if (defined(WIN) || defined(WNT))
	if (nServerType == T_ODBC)
	{
	  aPB_MANAGE.Show();
	  aPB_MANAGE.Enable();
	  aPB_MANAGE.SetClickHdl(LINK(this,SbaDlgTypeselect,ManageClickHdl));
	}
#endif

	aLB_DATASOURCE.SetDoubleClickHdl(LINK(this,SbaDlgTypeselect,ListDblClickHdl));
	FreeResource();
}

// -----------------------------------------------------------------------
SbaDlgTypeselect::~SbaDlgTypeselect()
{
	DBG_DTOR( SbaDlgTypeselect, NULL );
}

// -----------------------------------------------------------------------
IMPL_LINK( SbaDlgTypeselect, ListDblClickHdl, ListBox *, pListBox )
{
	if( pListBox == &aLB_DATASOURCE )
	{
		if( pListBox->GetSelectEntryCount() )
		{
			EndDialog( RET_OK );
		}
	}
	return 0;
}

// -----------------------------------------------------------------------
IMPL_LINK( SbaDlgTypeselect, ManageClickHdl, PushButton*, pButton )
{
#if defined(WIN) || defined(WNT)
	SdbODBCConfig aConfig;
	if (!aConfig.ManageDataSource(*this))
	{
		SBA_MOD()->ShowDbStatus(aConfig.Status(),dbReadError);
	}
	else
	{
		String aSelectedStr(aLB_DATASOURCE.GetSelectEntry());
		aLB_DATASOURCE.Clear();

		// aktualisieren
		SdbEnvironmentRef aEnv = SdbEnvironmentRef();
		String aList(	aEnv->ServerNames(aServerType));

		for (xub_StrLen i=0 ; i < aList.GetTokenCount(SDB_SEPARATOR) ; i++ )
			aLB_DATASOURCE.InsertEntry( aList.GetToken(i, SDB_SEPARATOR) );

		if (aLB_DATASOURCE.GetEntryCount())
		{
			if (aSelectedStr.Len())
				aLB_DATASOURCE.SelectEntry(aSelectedStr);

			if (!aLB_DATASOURCE.GetSelectEntryCount())
				aLB_DATASOURCE.SelectEntryPos( 0 );
		}
	}
#endif
	return 0;
}


#define GET_ATTR_P(c,w)	(const c*)&(pAttrs->Get( (w) ))

//==================================================================
SbaDbtypeDlg::SbaDbtypeDlg( Window* pParent, const SfxItemSet* pAttrs, SbaDBConfig* pCaller)
			 :SfxTabDialog( pParent, SbaResId( TAB_DLG_CONNECT ), pAttrs )
			 ,aGeneralTitle(ResId(ST_GENERAL))
			 ,aTypeTitle(	ResId(ST_TYPE	))
			 ,aTextTitle(	ResId(ST_TEXT	))
			 ,aOdbcTitle(	ResId(ST_ODBC	))
			 ,aDb2Title(	ResId(ST_DB2	))
			 ,aORCL7Title(	ResId(ST_ORCL7))
			 ,aJdbcTitle(	ResId(ST_JDBC	))
			 ,aDAOTitle(	ResId(ST_DAO	))
			 ,aADOTitle(	ResId(ST_ADO	))
			 ,aOTERTitle(	ResId(ST_OTER	))
			 ,aStarBaseTitle(ResId(ST_STARBASE_ADMIN ))
			 ,aDbaseTitle(	ResId(ST_DBASE))
			 ,aFmkTitle(	ResId(ST_FMK	))
			 ,aTabSubscrTitle( ResId(ST_TABSUBSCR) )
			 ,aTitle(		ResId(ST_TITLE_PROP))
			 ,aAdabasTitle(	ResId(ST_ADABAS	))
			 ,aAdabasAdminTitle(	ResId(ST_ADABAS_ADMIN	))
			 ,aAddrbookTitle( ResId(ST_ADDRBOOK ))
			 ,nTypePageId( 0 )
			 ,nServerType(T_NONE)
			 ,pOwner(pCaller)
			 ,m_bServerAdmin(sal_False)
{
	DBG_CTOR( SbaDbtypeDlg, NULL );

	// Verfuegbare Typen
	pDbTypeDefList = new DbTypeDefList;
	const SfxStringItem* pTypeItem	= GET_ATTR_P(SfxStringItem,WID_CONN_TYP);
	const SfxStringItem* pDsnItem	= GET_ATTR_P(SfxStringItem,WID_CONN_DSN);
	if(!pDsnItem->GetValue().Len() && (!pTypeItem->GetValue().EqualsAscii("JDBC") &&
									   !pTypeItem->GetValue().EqualsAscii("ADDRBOOK") &&
									   !pTypeItem->GetValue().EqualsAscii("ADO")))
		GetOKButton().Enable(sal_False);

	const SfxBoolItem*	 pMultiItem	= GET_ATTR_P(SfxBoolItem,WID_CONN_MULTI_USER_ON);
	bMultiUser = pMultiItem->GetValue();
	String	aKeyStr( ResId(ST_TYPEKEY) );
	String	aNameStr( ResId(ST_TYPENAME) );
	xub_StrLen	nCnt = aKeyStr.GetTokenCount();
	String aSupportList( SdbEnvironmentRef()->ServerTypes());
	xub_StrLen	nMaxSup = aSupportList.GetTokenCount();
	sal_uInt16  nType = T_NONE;

	if(getenv("DBCONFIG"))
		m_bServerAdmin = sal_True;

	for( xub_StrLen nIdx=0 ; nIdx<nCnt ; nIdx++ )
	{
		for( xub_StrLen j=0 ; j<nMaxSup ; j++ )
		{
			if( aSupportList.GetToken(j) == aKeyStr.GetToken( nIdx ) )
			{
				DbTypeDef	aDef;
				aDef.aKeyName  = aKeyStr.GetToken( nIdx );
				aDef.aLongName = aNameStr.GetToken( nIdx );
				aDef.eServerType = (DbTypeEnum)(nIdx+1); // Achtung!
				pDbTypeDefList->Insert(new DbTypeDef(aDef), LIST_APPEND );

				if (pTypeItem->GetValue() == aDef.aKeyName)	// aktueller Server
					nType = aDef.eServerType;
				break;
			}
		}
	}

	AddTabPage( TAB_PAG_GENERAL, aGeneralTitle, SbaGeneralPage::Create, 0 );
	AddTabPage( TAB_PAG_TYPE, aTypeTitle, SbaTypePage::Create, 0 );
	AddDetailPage(TAB_PAG_TABSUBSCR); // wird spaeter wieder  removed
	SetCurPageId(TAB_PAG_GENERAL);
	if(m_bServerAdmin && nType == T_ADABAS && pDsnItem->GetValue().Len())
	{
		String aDSN = pDsnItem->GetValue();
		String aHostname = aDSN.GetToken(0,':');
		if(aHostname.Len() && aDSN.GetTokenCount(':') >= 2)
		{
			::rtl::OUString sLocalHost;
			osl_getLocalHostname(&sLocalHost.pData);
			if (!sLocalHost.equals(aHostname))
				m_bServerAdmin = sal_False;
		}
	}
	CreateDetailPage(nType);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaDbtypeDlg::~SbaDbtypeDlg()
{
	if( pDbTypeDefList )
	{
		for (sal_uInt32 i=0; i<pDbTypeDefList->Count(); i++ )
			delete pDbTypeDefList->GetObject( i );
		pDbTypeDefList->Clear();

		delete pDbTypeDefList;
	}

	DBG_DTOR( SbaDbtypeDlg, NULL );
}
// -----------------------------------------------------------------------
void SbaDbtypeDlg::PageCreated( sal_uInt16 nPageId, SfxTabPage& rTabPage )
{
	DBG_CHKTHIS( SbaDbtypeDlg, NULL );

	switch (nPageId)
	{
		case TAB_PAG_GENERAL:
			((SbaGeneralPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_TYPE:
			((SbaTypePage&)rTabPage).SetParentDlg(this);
			break;
		case TAB_PAG_DBASE:
			((SbaDbasePage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_TEXT:
			((SbaTextPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_ODBC:
			((SbaOdbcPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_JDBC:
			((SbaJdbcPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_DB2:
			((SbaDb2Page&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_ADABAS:
			((SbaAdabasPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_ADABAS_SETTINGS:
			((SbaAdabasSettings&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_ADDRBOOK:
			((SbaAddrbookPage&)rTabPage).SetParentDlg( this );
			GetOKButton().Enable(sal_True);
			break;
		case TAB_PAG_ORCL7:
			((SbaORCL7Page&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_DAO:
			((SbaDAOPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_ADO:
			((SbaADOPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_OTER:
			((SbaOTERPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_STARBASE_ADMIN:
			((SbaStarBasePage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_FMK:
			((SbaFmkPage&)rTabPage).SetParentDlg( this );
			break;
		case TAB_PAG_TABSUBSCR:
			((SbaTabSubscrPage&)rTabPage).SetParentDlg( this );
			break;
		default:
			DBG_ERROR( "SbaDbtypeDlg::PageCreated[nPageId invalid]" );
			break;
	}
}

// -----------------------------------------------------------------------
void SbaDbtypeDlg::AddDetailPage( sal_uInt16 nPageId )
{
	DBG_CHKTHIS( SbaDbtypeDlg, NULL );

	switch (nPageId)
	{
		case TAB_PAG_DBASE:
			AddTabPage( nPageId, aDbaseTitle, SbaDbasePage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_TEXT:
			AddTabPage( nPageId, aTextTitle, SbaTextPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ODBC:
			AddTabPage( nPageId, aOdbcTitle, SbaOdbcPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_JDBC:
			AddTabPage( nPageId, aJdbcTitle, SbaJdbcPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_DB2:
			AddTabPage( nPageId, aDb2Title, SbaDb2Page::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ADABAS:
			AddTabPage( nPageId, aAdabasTitle, SbaAdabasPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ADABAS_SETTINGS:
			AddTabPage( nPageId, aAdabasAdminTitle, SbaAdabasSettings::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ADDRBOOK:
			AddTabPage( nPageId, aAddrbookTitle, SbaAddrbookPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ORCL7:
			AddTabPage( nPageId, aORCL7Title, SbaORCL7Page::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_DAO:
			AddTabPage( nPageId, aDAOTitle, SbaDAOPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_ADO:
			AddTabPage( nPageId, aADOTitle, SbaADOPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_OTER:
			AddTabPage( nPageId, aOTERTitle, SbaOTERPage::Create, 0, sal_False, 3 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_STARBASE_ADMIN:
			AddTabPage( nPageId, aStarBaseTitle, SbaStarBasePage::Create, 0, sal_False, 2 );
			break;
		case TAB_PAG_FMK:
			AddTabPage( nPageId, aFmkTitle, SbaFmkPage::Create, 0, sal_False, 2 );
			nTypePageId = nPageId;
			break;
		case TAB_PAG_TABSUBSCR:
			AddTabPage( nPageId, aTabSubscrTitle, SbaTabSubscrPage::Create, 0 );
			break;
		default:
			DBG_ERROR( "SbaDbtypeDlg::CreateDetailPage[nPageId invalid]" );
		break;
	}

	Invalidate();//Hack um die erste TabPage richtig zu zeichnen
}

// -----------------------------------------------------------------------
void SbaDbtypeDlg::CreateDetailPage( sal_uInt16 nNewServerType )
{
	if (nServerType == nNewServerType)
		return;

	sal_uInt16	nTabId = T_NONE;
	/* Reihenfolge der Seiten:
		1. General
		2.TypePage
		bei StarBase
		3. AdminPage
		4. StarBase Seite
		5. Tabellen, wenn im Multiuser betrieb
		bei allen anderen
		3. Treiber Seite
		4. Tabelle

		Die ersten beiden Seiten bleiben immer bestehen.
		Ist fuer weitere Seiten mit zu flegen
	*/
	if((bMultiUser && nTypePageId == TAB_PAG_OTER) || nTypePageId != TAB_PAG_OTER)
		RemoveTabPage(TAB_PAG_TABSUBSCR);
	if (nTypePageId)
		RemoveTabPage(nTypePageId); // Treiberseite loeschen
	if(nTypePageId == TAB_PAG_OTER)
		RemoveTabPage(TAB_PAG_STARBASE_ADMIN);
	else if(nTypePageId == TAB_PAG_ADABAS && m_bServerAdmin)
		RemoveTabPage(TAB_PAG_ADABAS_SETTINGS);
	switch (nNewServerType)
	{
		case T_ODBC:	nTabId=TAB_PAG_ODBC;	break;
		case T_JDBC:	nTabId=TAB_PAG_JDBC;	break;
		case T_DB2:		nTabId=TAB_PAG_DB2;		break;
		case T_ADABAS:	nTabId=TAB_PAG_ADABAS;	
						if(m_bServerAdmin)
							AddDetailPage(TAB_PAG_ADABAS_SETTINGS);
						break;
		case T_ADDRBOOK:	nTabId=TAB_PAG_ADDRBOOK;	break;
		case T_ORCL7:	nTabId=TAB_PAG_ORCL7;	break;
		case T_DAO:		nTabId=TAB_PAG_DAO;		break;
		case T_ADO:		nTabId=TAB_PAG_ADO;		break;
		case T_OTER:
			AddDetailPage(TAB_PAG_STARBASE_ADMIN);
			nTabId=TAB_PAG_OTER;	break;
		case T_DBF:		nTabId=TAB_PAG_DBASE;	break;
		case T_TXT:		nTabId=TAB_PAG_TEXT;	break;
		case T_FMK:		nTabId=TAB_PAG_FMK;		break;
		default:
			nServerType = T_NONE;
			DBG_ASSERT( nTabId != T_NONE, "Type not found" );
	}

	AddDetailPage(nTabId);
	if((bMultiUser && nTypePageId == TAB_PAG_OTER) || nTypePageId != TAB_PAG_OTER)
		AddDetailPage(TAB_PAG_TABSUBSCR);

	nServerType = nNewServerType;
}

// -----------------------------------------------------------------------
sal_uInt16 SbaDbtypeDlg::GetSelectServerType(const String& aServerName)
{
	DBG_CHKTHIS( SbaDbtypeDlg, NULL );

	String aServerList( SdbEnvironmentRef()->ServerTypes());
	xub_StrLen	nServerCnt = aServerList.GetTokenCount();
	sal_uInt16	nRetVal = 0;

	for( sal_uInt16 i=0 ; i<(sal_uInt16)pDbTypeDefList->Count(); i++ )
	{
		DbTypeDef* pDef = pDbTypeDefList->GetObject( i );
		if( pDef->aLongName == aServerName )
		{
			for( xub_StrLen j=0 ; j<nServerCnt ; j++ )
			{
				if( pDef->aKeyName.EqualsIgnoreCaseAscii(aServerList.GetToken(j)) )
					break;
			}
			DBG_ASSERT( j<nServerCnt, "Server not found" );

			nRetVal = (sal_uInt16)pDef->eServerType;
			break;
		}
	}
	return nRetVal;
}


//========================================================================
void SbaAliasEdit::KeyInput( const KeyEvent& rKEvt )
{
	String sNotAllowed(aNotAllowed, sizeof(aNotAllowed)/sizeof(aNotAllowed[0]));
	const KeyCode aKeyCode = rKEvt.GetKeyCode();
	sal_uInt16 nGrp = aKeyCode.GetGroup();

	const char c = rKEvt.GetCharCode();

//	if ( sNotAllowed.Search(c) == STRING_NOTFOUND &&
//		(c > 0x1f || nGrp == KEYGROUP_CURSOR || nGrp == KEYGROUP_MISC))
	if (sNotAllowed.Search(c) == STRING_NOTFOUND)
		Edit::KeyInput(rKEvt);
}

//========================================================================
SbaGeneralPage::SbaGeneralPage( Window* pParent, const SfxItemSet& rCoreAttrs )
			   :SfxTabPage( pParent, SbaResId( TAB_PAG_GENERAL ), rCoreAttrs )
			   ,aBMP_DB(this,ResId(BMP_DB))
			   ,aET_NAME(this, ResId(ET_NAME))
			   ,aFL_1(this, ResId(FL_1))
			   ,aFT_TYPE(this, ResId(FT_TYP))
			   ,aFT_TYPE_SHOW(this, ResId(FT_SHOW_TYP))
			   ,aFT_FILE(this, ResId(FT_FILENAME))
			   ,aFT_FILE_SHOW(this, ResId(FT_SHOW_FILENAME))
			   ,aFL_2(this, ResId(FL_2))
			   ,aFT_CREATED(this, ResId(FT_CREATED))
			   ,aFT_CREATED_SHOW(this, ResId(FT_SHOW_CREATED))
			   ,aFT_CHANGED(this, ResId(FT_CHANGED))
			   ,aFT_CHANGED_SHOW(this, ResId(FT_SHOW_CHANGED))
			   ,aReadOnly(ResId(ST_READONLY))
			   ,pParentDlg(0)
			   ,bAttrsChanged(sal_False)
{
	DBG_CTOR(SbaGeneralPage,NULL);
	aET_NAME.SetLoseFocusHdl(LINK(this,SbaGeneralPage,EditLoseFocusHdl));
	aET_NAME.SetModifyHdl(LINK(this,SbaGeneralPage,EditModifyHdl));
	aBMP_DB.SetImage(SfxExplorer::GetImage(IMG_SFX_EXP_DATABASE,sal_True));
	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaGeneralPage::~SbaGeneralPage()
{
	DBG_DTOR(SbaGeneralPage,NULL);
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaGeneralPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return new SbaGeneralPage( pParent, rAttrSet);
}

// -----------------------------------------------------------------------
#define IS_AVAILABLE(w) (rCoreAttrs.GetItemState( (w) ) >= SFX_ITEM_AVAILABLE)
#define GET_ATTR(c,w)	(const c*)&(rCoreAttrs.Get( (w) ))

void SbaGeneralPage::Reset(const SfxItemSet& rCoreAttrs)
{
	DBG_CHKTHIS(SbaGeneralPage,NULL);
	const SfxStringItem* pAliasItem	= GET_ATTR(SfxStringItem,WID_CONN_ALIAS);
	const SfxStringItem* pFileItem	= GET_ATTR(SfxStringItem,WID_CONN_FILENAME);
	const SfxStringItem* pTypeItem	= GET_ATTR(SfxStringItem,WID_CONN_TYP);
	const SfxBoolItem* pModItem	= GET_ATTR(SfxBoolItem,WID_CONN_MODIFY);
	bMod = pModItem->GetValue();
	String aName( pAliasItem->GetValue());

	aET_NAME.SetText(aName);
	aET_NAME.SaveValue();
	aET_NAME.ClearModifyFlag();
	//pParentDlg->GetOKButton().Enable(aName.Len() != 0 && bMod);

	String aStr(pParentDlg->aTitle);
	aStr += pAliasItem->GetValue();
	if (!bMod)
	{
		aStr += ' ';
		aStr += aReadOnly;
	}

	pParentDlg->SetText(aStr);

	for (sal_uInt32 i=0; i < pParentDlg->pDbTypeDefList->Count(); i++)
	{
		DbTypeDef* pDef = pParentDlg->pDbTypeDefList->GetObject(i);
		if (pDef->eServerType == pParentDlg->ServerType())
		{
			aFT_TYPE_SHOW.SetText(pDef->aLongName);
			break;
		}
	}

	if (pFileItem->GetValue().Len())
	{
		aFT_FILE_SHOW.SetText(pFileItem->GetValue());
		FileStat aStat(DirEntry(pFileItem->GetValue()));
		if (aStat.GetError() == ERRCODE_NONE)
		{
			International aInt = Application::GetAppInternational();
			String aStr( aInt.GetDate(aStat.DateCreated()));
			aStr.AppendAscii(", ");
			aStr += aInt.GetTime(aStat.TimeCreated());
			aFT_CREATED_SHOW.SetText(aStr);

			aStr = aInt.GetDate(aStat.DateModified());
			aStr.AppendAscii(", ");
			aStr += aInt.GetTime(aStat.TimeModified());
			aFT_CHANGED_SHOW.SetText(aStr);
		}
		bAttrsChanged = sal_False;
	}
	else
		bAttrsChanged = sal_True;
}

// -----------------------------------------------------------------------
void SbaGeneralPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS(SbaGeneralPage,NULL);
	for (sal_uInt32 i=0; i < pParentDlg->pDbTypeDefList->Count(); i++)
	{
		DbTypeDef* pDef = pParentDlg->pDbTypeDefList->GetObject(i);
		if (pDef->eServerType == pParentDlg->ServerType())
		{
			aFT_TYPE_SHOW.SetText(pDef->aLongName);
			break;
		}
	}

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
		aET_NAME.Disable();
}

// -----------------------------------------------------------------------
int SbaGeneralPage::DeactivatePage(SfxItemSet* pSet)
{
	DBG_CHKTHIS(SbaGeneralPage,NULL);
	if(pSet)
		FillItemSet(*pSet);

	if(!aET_NAME.GetText().Len())
	{
		String aError(SbaResId(SBA_STR_ALIAS_NAME_FAILURE));
		SbaMsgBox(pParentDlg,String(SbaResId(SBA_STAT_WARNING)),aError).Execute();
//		ErrorBox aDlg(NULL,WB_OK, aError);
//		aDlg.Execute();
		aET_NAME.GrabFocus();
		return 0;
	}

	return 1;
}


// -----------------------------------------------------------------------
sal_Bool SbaGeneralPage::FillItemSet( SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS(SbaGeneralPage,NULL);
	sal_Bool bReturn(bAttrsChanged);

	if (bAttrsChanged)
	{
		rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_ALIAS), aET_NAME.GetText() ) );
		bAttrsChanged = sal_False;
	}

	return bReturn;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaGeneralPage, EditLoseFocusHdl, Control *, pControl )
{
	Edit*	pEdit = (Edit*)pControl;
	if (pEdit->IsModified()){
		bAttrsChanged = sal_True;
		String aStr(pParentDlg->aTitle);
		aStr += pEdit->GetText();
		pParentDlg->SetText(aStr);
	}
	return 0;
}

// -----------------------------------------------------------------------
IMPL_LINK(SbaGeneralPage, EditModifyHdl, Edit *, pEdit )
{
	DBG_CHKTHIS( SbaGeneralPage, NULL );
	String sNotAllowed(aNotAllowed, sizeof(aNotAllowed)/sizeof(aNotAllowed[0]));

	String sName(pEdit->GetText());
	const xub_StrLen nOldLen = sName.Len();
	Selection aSel(pEdit->GetSelection());

	for (xub_StrLen i=0; i < sName.Len();)
	{
		const sal_Unicode c = sName.GetChar(i++);

		if (/*c < 0x20 || */sNotAllowed.Search(c) != STRING_NOTFOUND)
		{
			sName.EraseAllChars(c);
			i--;
		}
	}

	const xub_StrLen nLen = sName.Len();

	if (nOldLen != nLen)
	{
		pEdit->SetText(sName);
		pEdit->SetSelection(aSel);	// Cursorpos restaurieren
	}

	//pParentDlg->GetOKButton().Enable(nLen && bMod);
	bAttrsChanged = bMod;
	return 0;
}
/*
Punkte drfen nicht ganz am Anfang oder ganz am
Ende stehen und nicht zwei direkt nebeneinander. Nicht erlaubte
Zeichen sind alle Control-Zeichen ('\x00'-'\x1F', '\x7F'), das
Leerzeichen, sowie die Zeichen '#', '%', ';', '/', '?', ':', '@', '='
und '&'. Insbesonder erlaubt sind alle Zeichen '\x80'-'\xFF'.
*/
//========================================================================
SbaTypePage::SbaTypePage(Window* pParent, const SfxItemSet& rCoreAttrs)
			  :SfxTabPage( pParent, SbaResId( TAB_PAG_TYPE), rCoreAttrs )
			  ,aFT_DATATYPE(			this, ResId( FT_DATATYPE ) )
			  ,aLB_DATATYPE(			this, ResId( LB_DATATYPE ) )
			  ,aFT_DSNNAME(				this, ResId( FT_DSNNAME ) )
			  ,aET_DSNNAME(				this, ResId( ET_DSNNAME ) )
			  ,aPB_DSNNAME(				this, ResId( PB_DSNNAME ) )
			  ,aPB_RESTORE_BACKUP(		this, ResId( PB_RESTORE_BACKUP ) )
			  ,aPB_NEWDB(				this, ResId( PB_NEWDB ) )
			  ,aFT_ORCL_EXPL(			this, ResId( FT_ORCL_EXPL) )
			  ,aFT_OTER_EXPL(			this, ResId( FT_OTER_EXPL) )
			  ,aStrTextFilterList(		ResId( ST_TEXTFILTER ) )
			  ,aStrDbaseFilterList(		ResId( ST_DBASEFILTER ) )
			  ,aDSNName(				ResId( ST_DSN_NAME ) )
			  ,aDSNDir(					ResId( ST_DSN_DIR ) )
			  ,aDBFilename(				ResId( ST_DBFILENAME ) )
			  ,bFound(sal_True)
#ifdef MAC
	,aStrFmkFilterList( ResId( ST_FMKFILTER ) )
#endif
	,pParentDlg(0)
	,bAttrsChanged( sal_False )
	,bDbNew(sal_False)
{

	aPB_DSNNAME.SetClickHdl(LINK(this,SbaTypePage,ButtonClickHdl));
	aPB_NEWDB.SetClickHdl(LINK(this,SbaTypePage,ButtonNEWDBClickHdl));
	aPB_RESTORE_BACKUP.SetClickHdl(LINK(this,SbaTypePage,ButtonNEWDBClickHdl));
	aLB_DATATYPE.SetSelectHdl(LINK(this,SbaTypePage,ListBoxHdl));
	aET_DSNNAME.SetModifyHdl(LINK(this,SbaTypePage,EditLoseFocusHdl));

	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
void SbaTypePage::SetParentDlg( SbaDbtypeDlg* pDlg )
{
	pParentDlg = pDlg;
	for (sal_uInt16 i=0 ; i<(sal_uInt16)pParentDlg->pDbTypeDefList->Count(); i++ )
	{
		DbTypeDef* pDef = pParentDlg->pDbTypeDefList->GetObject( i );
		aLB_DATATYPE.InsertEntry(pDef->aLongName);
	}

	sal_uInt16	nInitialServerType(pParentDlg->ServerType());
		//pParentDlg->GetSelectServerType(aLB_DATATYPE.GetSelectEntry());
	
	switch (nInitialServerType)
	{
		case T_ORCL7:	aPB_NEWDB.Hide();
						aPB_DSNNAME.Hide();
						aFT_OTER_EXPL.Hide();
						aPB_RESTORE_BACKUP.Hide();
		break;
		case T_JDBC:
		case T_ADO:
		case T_ADDRBOOK:
						aPB_NEWDB.Hide();
						aFT_DSNNAME.Hide();
						aET_DSNNAME.Hide();
						aPB_DSNNAME.Hide();
						aFT_ORCL_EXPL.Hide();
						aFT_OTER_EXPL.Hide();
						aPB_RESTORE_BACKUP.Hide();
			break;
		case T_ADABAS:
						if(pDlg->m_bServerAdmin)
						{
							Point aPos(aPB_NEWDB.GetPosPixel());
							Size aSize(aPB_NEWDB.GetSizePixel());
							Size aRight2( LogicToPixel( Size(12,0), MAP_APPFONT ));
							//	aPB_NEWDB.SetPosPixel(Point(GetSizePixel().Width()-aSize.Width()-aRight2.Width(),aPos.Y()));
							aPB_NEWDB.Show();
						}
						else
						{
							aPB_NEWDB.Hide();
							aPB_RESTORE_BACKUP.Hide();
						}
						//	aPB_DSNNAME.Hide();
						aFT_ORCL_EXPL.Hide();
						aFT_OTER_EXPL.Hide();
						aET_DSNNAME.SetText(String());
			break;
		case T_DB2:
		case T_ODBC:	aPB_NEWDB.Hide();
						aPB_RESTORE_BACKUP.Hide();
						aFT_ORCL_EXPL.Hide();
						aFT_OTER_EXPL.Hide();
			break;

		case T_DAO:		aPB_NEWDB.Hide();
						aPB_RESTORE_BACKUP.Hide();
						aFT_ORCL_EXPL.Hide();
						aFT_OTER_EXPL.Hide();
			break;
		case T_OTER:
						aFT_ORCL_EXPL.Hide();
						aPB_NEWDB.Hide();
						aPB_RESTORE_BACKUP.Hide();
			break;
		default:
						aPB_NEWDB.Hide();
						aPB_RESTORE_BACKUP.Hide();
						aFT_ORCL_EXPL.Hide();
						aFT_OTER_EXPL.Hide();
	}
}

// -----------------------------------------------------------------------
SbaTypePage::~SbaTypePage()
{
}

// -----------------------------------------------------------------------
String SbaTypePage::FindServerType( const String& aName )
{
	String	aRet;

	if( pParentDlg->pDbTypeDefList )
	{
		for (sal_uInt32 i=0; i<pParentDlg->pDbTypeDefList->Count(); i++ )
		{
			DbTypeDef* pDef = pParentDlg->pDbTypeDefList->GetObject( i );
			if( pDef->aLongName == aName )
			{
				aRet = pDef->aKeyName;
				break;
			}
		}
	}

	return aRet;
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaTypePage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaTypePage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaTypePage::Reset( const SfxItemSet& rCoreAttrs )
{
	const SfxStringItem*	 pDsnItem	= GET_ATTR(SfxStringItem,WID_CONN_DSN);
	const SfxStringItem*	 pTypeItem	= GET_ATTR(SfxStringItem,WID_CONN_TYP);

	aET_DSNNAME.SetText(pDsnItem->GetValue());

	switch (pParentDlg->ServerType())
	{
		case T_JDBC:
		case T_ADO:
		case T_ADDRBOOK:
			break;
		case T_ADABAS:
			if(aET_DSNNAME.GetText().Len())
			{
				pParentDlg->GetOKButton().Enable(sal_True);
				String aDSN = aET_DSNNAME.GetText();
				String aHostname = aDSN.GetToken(0,':');
				sal_Bool bStartServer = sal_True;
				if(aHostname.Len() && aDSN.GetTokenCount(':') >= 2)
				{
					::rtl::OUString sLocalHost;
					osl_getLocalHostname(&sLocalHost.pData);
					if (!sLocalHost.equals(aHostname))
						bStartServer = sal_False;
					else
						aHostname = aDSN.GetToken(1,':');
				}
				else if(aDSN.GetTokenCount(':') >= 2)
					aHostname = aDSN.GetToken(1,':');
				if(!bStartServer)
					pParentDlg->RemoveTabPage(TAB_PAG_ADABAS_SETTINGS);
			}
		case T_ODBC:
		case T_DB2:
		case T_ORCL7:
						aFT_DSNNAME.SetText(aDSNName);
						break;
		case T_DAO:
		case T_OTER:
						aFT_DSNNAME.SetText(aDBFilename);
						break;
		default:
						aFT_DSNNAME.SetText(aDSNDir);
	}

	String aServerName(pTypeItem->GetValue());
	for( sal_uInt16 i=0 ; i<(sal_uInt16)pParentDlg->pDbTypeDefList->Count(); i++ )
	{
		DbTypeDef* pDef = pParentDlg->pDbTypeDefList->GetObject( i );
		if (pDef->aKeyName.Equals(aServerName))
		{
			aLB_DATATYPE.SelectEntry( pDef->aLongName );
			pParentDlg->CreateDetailPage( pDef->eServerType );
			break;
		}
	}
}

void SbaTypePage::ActivatePage( const SfxItemSet& rSet )
{
	SfxTabPage::ActivatePage(rSet);

	if (!((const SfxBoolItem*)rSet.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aFT_DATATYPE.Disable();
		aLB_DATATYPE.Disable();
		aFT_DSNNAME.Disable();
		aET_DSNNAME.Disable();
		aPB_NEWDB.Disable();
		aPB_RESTORE_BACKUP.Disable();
		aPB_DSNNAME.Disable();
		aFT_ORCL_EXPL.Disable();
		aFT_OTER_EXPL.Disable();
	}
}

// -----------------------------------------------------------------------
int SbaTypePage::DeactivatePage(SfxItemSet* pSet)
{
	if(pSet)
		FillItemSet(*pSet);
	return bFound;
}

// -----------------------------------------------------------------------
static DirEntry CreateEntry(const String& rPath, const String& aDatabasePath)
{
	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String aNewPath(aIniManProp.GetIniManager()->SubstPathVars(rPath));

	INetURLObject aURL;
	aURL.SetSmartProtocol(INET_PROT_FILE);
	aURL.SetSmartURL(aNewPath);

	if (aDatabasePath.Len())
	{
		// absolutieren zum Datenbankfile
		INetURLObject aDbURL;
		aDbURL.SetSmartProtocol(INET_PROT_FILE);
		aDbURL.SetSmartURL(aDatabasePath);
		INetURLObject aAbsURL;
		aAbsURL.SetSmartProtocol(INET_PROT_FILE);
		if (aDbURL.GetNewAbsURL(aNewPath, &aAbsURL) && aAbsURL.GetProtocol() == INET_PROT_FILE)
			aNewPath = aAbsURL.PathToFileName();
	}
	return DirEntry(aNewPath);
}

// -----------------------------------------------------------------------
sal_Bool SbaTypePage::FillItemSet( SfxItemSet& rCoreAttrs )
{
	sal_Bool bReturn(bAttrsChanged);

	if(m_AdabasSysUser.Len())
		rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_USER_ID), m_AdabasSysUser));
	if(m_AdabasSysPwd.Len())
		rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_USER_PWD), m_AdabasSysPwd));
	if(m_AdabasCtrlUser.Len())
		rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_CTRLUSER), m_AdabasCtrlUser));
	if(m_AdabasCtrlPwd.Len())
		rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_CTRLPWD), m_AdabasCtrlPwd));

	if (bAttrsChanged)
	{
		if (aLB_DATATYPE.GetSelectEntryPos() != aLB_DATATYPE.GetSavedValue() )
		{
			String aStr( FindServerType( aLB_DATATYPE.GetSelectEntry() ));
			rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_TYP), aStr ) );
			switch (pParentDlg->ServerType())		// default Zeichsatz setzen
			{
				case T_OTER:
					break;
				case T_DB2:
				case T_ADABAS:
				case T_ODBC:
				case T_JDBC:
				case T_TXT:
				case T_ADDRBOOK:
				case T_ADO:
					rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_CHARSET), String::CreateFromAscii("System")));
					break;
				default:
					rCoreAttrs.Put(SfxStringItem(GetWhich(WID_CONN_CHARSET), String::CreateFromAscii("IBMPC")));
			}
		}

		if (aET_DSNNAME.GetSavedValue() != aET_DSNNAME.GetText())
		{
			SfxItemSet* pCurrentSet = (SfxItemSet*) pParentDlg->GetExampleSet();
			SfxStringItem aFileItem((const SfxStringItem&)pCurrentSet->Get(WID_CONN_FILENAME));

			String aDsn( aET_DSNNAME.GetText());
			// Odbc haengt manchmal noch Beschreibungen in (...) an
			// Die werden gelscht
			switch (pParentDlg->ServerType())
			{
				case T_OTER:
					{
						DirEntry aEntry = CreateEntry(aDsn, aFileItem.GetValue());
						bFound = aEntry.Exists();
						if(!bFound && (!bDbNew || !aEntry.GetExtension().EqualsIgnoreCaseAscii("rb1")))
						{
							String aError(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN));
							ErrorBox aDlg(NULL,WB_OK, aError);
							aDlg.Execute();
							aET_DSNNAME.GrabFocus();
						}
						else
							bFound = sal_True; // auch neue Datenbanken gelten als gefunden
					}
					break;
				case T_DAO:
					{
						DirEntry aEntry = CreateEntry(aDsn, aFileItem.GetValue());
						bFound = aEntry.Exists();
						if(!bFound && (!bDbNew || !aEntry.GetExtension().EqualsIgnoreCaseAscii("mdb")))
						{
							String aError(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN));
							ErrorBox aDlg(NULL,WB_OK, aError);
							aDlg.Execute();
							aET_DSNNAME.GrabFocus();
						}
						else
							bFound = sal_True; // auch neue Datenbanken gelten als gefunden
					}
					break;
				case T_DBF:
					{
						DirEntry aEntry = CreateEntry(aDsn, aFileItem.GetValue());
						bFound = aEntry.Exists() ||
							(FileStat(aEntry).IsKind(FSYS_KIND_WILD) && aEntry.GetPath().Exists());
						if(!bFound && !bDbNew){
							String aError(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN));
							ErrorBox aDlg(NULL,WB_OK, aError);
							aDlg.Execute();
							aET_DSNNAME.GrabFocus();
						}else
							bFound = sal_True;
					}
					break;
				case T_ODBC:
					{
						xub_StrLen nIdx(aDsn.Search( '(' ));
						if( nIdx != STRING_NOTFOUND )
						{
							aDsn.Erase( nIdx );
							aDsn.EraseTrailingChars( ' ' );
						}
						bFound = sal_True;
					}
					break;
				case T_TXT:
					{
						// Dateiextension setzen
						DirEntry aEntry = CreateEntry(aDsn, aFileItem.GetValue());
						bFound = aEntry.Exists() ||
							(FileStat(aEntry).IsKind(FSYS_KIND_WILD) && aEntry.GetPath().Exists());
						aEntry.SetBase('*');
						const SfxStringItem* pExtensionItem	= GET_ATTR(SfxStringItem,WID_CONN_EXT);
						aEntry.SetExtension(pExtensionItem->GetValue());
						if(!bFound && !bDbNew){
							String aError(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN));
							ErrorBox aDlg(NULL,WB_OK, aError);
							aDlg.Execute();
							aET_DSNNAME.GrabFocus();
						}
					}
					break;
				default:
					bFound = sal_True;
			}

			rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_DSN), aDsn ) );
		}else
			bFound = sal_True; // kein Eintrag vorhanden
		rCoreAttrs.Put( SfxBoolItem(GetWhich(WID_CONN_DBNEW), bDbNew ) );

		if (bFound)
			// nur bei Erfolg ruecksetzen, sonst passiert beim naechsten DeactivatePage gar nix (es kommt dann einfach ein
			// FASE zurueck)
			bAttrsChanged = sal_False;
	}

	return bReturn;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaTypePage, EditLoseFocusHdl, Control *, pControl )
{
	bAttrsChanged = sal_True;
	String aDsn( aET_DSNNAME.GetText());
	if(pParentDlg && (aDsn.Len() != 0))
	{
		pParentDlg->GetOKButton().Enable(sal_True);
		aPB_NEWDB.Enable(sal_True);
		aPB_RESTORE_BACKUP.Enable(sal_True);
	}
	else if(pParentDlg)
	{
		pParentDlg->GetOKButton().Enable(sal_False);
		aPB_NEWDB.Enable(sal_True);
		aPB_RESTORE_BACKUP.Enable(sal_True);
	}
	return 0;

}

// -----------------------------------------------------------------------
IMPL_LINK( SbaTypePage, ListBoxHdl, ListBox *, pListBox )
{
	if( pListBox == &aLB_DATATYPE )
	{
		sal_uInt16	nNewServerType(pParentDlg->GetSelectServerType(aLB_DATATYPE.GetSelectEntry()));

		if (nNewServerType!=0 && nNewServerType!=pParentDlg->ServerType() )
		{
			aET_DSNNAME.SetText(String());
			// Zunaechst alles zuruecksetzen
			sal_uInt16	nOldServerType = pParentDlg->ServerType();
			SfxItemSet* pCurrentSet = (SfxItemSet*) pParentDlg->GetExampleSet();

			SfxStringItem aAliasItem((const SfxStringItem&)pCurrentSet->Get(WID_CONN_ALIAS));
			SfxStringItem aFileItem((const SfxStringItem&)pCurrentSet->Get(WID_CONN_FILENAME));
			SfxStringItem aTypeItem((const SfxStringItem&)pCurrentSet->Get(WID_CONN_TYP));
			SfxStringItem aDSNItem((const SfxStringItem&)pCurrentSet->Get(WID_CONN_DSN));

			pCurrentSet->ClearItem();

			pCurrentSet->Put(aAliasItem);
			pCurrentSet->Put(aFileItem);
			pCurrentSet->Put(aTypeItem);

			if(pParentDlg)
				pParentDlg->GetOKButton().Enable(sal_False);
//			Point aPos2(aPB_NEWDB.GetPosPixel());
//			Size aSize2(aPB_NEWDB.GetSizePixel());
//			Size aRight = LogicToPixel( Size(12,0), MAP_APPFONT );
//			//	aPB_NEWDB.SetPosPixel(Point(GetSizePixel().Width()-aPB_DSNNAME.GetSizePixel().Width()-aSize2.Width()-aRight.Width(),aPos2.Y()));
			switch (nNewServerType)
			{
				case T_ORCL7:	aPB_NEWDB.Hide();
								aPB_DSNNAME.Hide();
								aFT_DSNNAME.Show();
								aET_DSNNAME.Show();
								aFT_DSNNAME.SetText(aDSNName);
								aET_DSNNAME.SetText(String());
								aFT_ORCL_EXPL.Show();
								aFT_OTER_EXPL.Hide();
								aPB_RESTORE_BACKUP.Hide();
					break;
				case T_JDBC:
				case T_ADO:
				case T_ADDRBOOK:
								aPB_NEWDB.Hide();
								aFT_DSNNAME.Hide();
								aET_DSNNAME.Hide();
								aPB_DSNNAME.Hide();
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Hide();
								aET_DSNNAME.SetText(String());
								aPB_RESTORE_BACKUP.Hide();
					break;
				case T_ADABAS:

								if(pParentDlg->m_bServerAdmin)
								{
									Point aPos(aPB_NEWDB.GetPosPixel());
									Size aSize(aPB_NEWDB.GetSizePixel());
									Size aRight2( LogicToPixel( Size(12,0), MAP_APPFONT ));
									//	aPB_NEWDB.SetPosPixel(Point(GetSizePixel().Width()-aSize.Width()-aRight.Width(),aPos.Y()));
									aPB_NEWDB.Show();
									aPB_RESTORE_BACKUP.Show();
								}
								else
								{
									aPB_NEWDB.Hide();
									aPB_RESTORE_BACKUP.Hide();
								}
								aFT_DSNNAME.Show();
								aET_DSNNAME.Show();
								aPB_DSNNAME.Show();
								aFT_DSNNAME.SetText(aDSNName);
								aET_DSNNAME.SetText(String());
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Hide();
								aPB_NEWDB.Enable(aET_DSNNAME.GetText().Len());
								aPB_RESTORE_BACKUP.Enable(aET_DSNNAME.GetText().Len());
					break;
				case T_DB2:
				case T_ODBC:	aPB_NEWDB.Hide();
								aPB_RESTORE_BACKUP.Hide();
								aFT_DSNNAME.Show();
								aET_DSNNAME.Show();
								aPB_DSNNAME.Show();
								aFT_DSNNAME.SetText(aDSNName);
								aET_DSNNAME.SetText(String());
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Hide();
					break;

				case T_DAO:		aPB_NEWDB.Hide();
								aFT_DSNNAME.Show();
								aPB_RESTORE_BACKUP.Hide();
								aET_DSNNAME.Show();
								aPB_DSNNAME.Show();
								aFT_DSNNAME.SetText(aDBFilename);
								aET_DSNNAME.SetText(String());
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Hide();
					break;
				case T_OTER:
								aPB_NEWDB.Hide();
								aFT_DSNNAME.Show();
								aPB_RESTORE_BACKUP.Hide();
								aET_DSNNAME.Show();
								aPB_DSNNAME.Show();
								aFT_DSNNAME.SetText(aDBFilename);
								aET_DSNNAME.SetText(String());
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Show();
					break;
				default:
								aPB_NEWDB.Hide();
								aPB_RESTORE_BACKUP.Hide();
								aFT_DSNNAME.Show();
								aET_DSNNAME.Show();
								aPB_DSNNAME.Show();
								aFT_ORCL_EXPL.Hide();
								aFT_OTER_EXPL.Hide();
								aFT_DSNNAME.SetText(aDSNDir);
								if (nOldServerType == T_DBF || nOldServerType == T_TXT || nOldServerType == T_FMK)
									pCurrentSet->Put(aDSNItem);
								else
									aET_DSNNAME.SetText(String());	// nur wenn Odbc vorher, dann Text lschen

			}

			// jetzt die neue Seite
			pParentDlg->CreateDetailPage( nNewServerType );

#ifdef WIN
			Invalidate();
#endif
			bFound = sal_True;
			bAttrsChanged = sal_True;
		}
	}
	return 0;
}
//------------------------------------------------------------------
sal_Bool IsCharOk(char c)
{
	if ( ((c >= 97) && (c <= 122)) || ((c >= 65) && (c <=  90)) || ((c >= 48) && (c <=  57)) ||  c == '_')
		  return sal_True;
	else
		return sal_False;
}

//------------------------------------------------------------------------------
sal_Bool IsSQLNameValid(const String& rName)
{
	ByteString aName(rName, gsl_getSystemTextEncoding());
		// TODO : think about encoding this in ascii ... should be sufficient, as all valid chars are ascii chars

	const char* pStr = aName.GetBuffer();
	if (isdigit(*pStr) || (*pStr == '_'))
		return sal_False;

	for (; *pStr; ++pStr )
		if(!IsCharOk(*pStr))
			return sal_False;

	return sal_True;
}

// -----------------------------------------------------------------------
IMPL_LINK( SbaTypePage, ButtonNEWDBClickHdl, Button *, pButton )
{
	// try to seperate the hostname from the database name
	String aDSN = aET_DSNNAME.GetText();
	String aHostname = aDSN.GetToken(0,':');
	sal_Bool bStartServer = sal_True;
	if(aHostname.Len() && aDSN.GetTokenCount(':') >= 2)
	{
		::rtl::OUString sLocalHost;
		osl_getLocalHostname(&sLocalHost.pData);
		if(!sLocalHost.equals(aHostname))
			bStartServer = sal_False;
		else
			aHostname = aDSN.GetToken(1,':');
	}
	else if(aDSN.GetTokenCount(':') >= 2)
		aHostname = aDSN.GetToken(1,':');
	// aHostname contains the real DB name
	if(aHostname.Len())
	{
		if(bStartServer)
		{
			if(aHostname.Len() < 9)
			{	
				if(!IsSQLNameValid(aHostname))
				{
					String aMsg(SbaResId(SBA_STR_INVALID_CHARACTER));
					SbaMsgBox(pParentDlg,String(SbaResId(SBA_STAT_WARNING)),aMsg).Execute();
					return 0;
				}
				String aTest(getenv("DBCONFIG"), gsl_getSystemTextEncoding());
				(aTest += DirEntry::GetAccessDelimiter()).AppendAscii("config") += DirEntry::GetAccessDelimiter();
				aTest += aHostname;
				DirEntry aDBName(aTest);
				if(aDBName.Exists())
				{
					SbaExtInfoBox(this, SbaResId(QUERY_QRY_DELETEDB),aHostname).Execute();
					return 0;
				}

				pParentDlg->Hide();
				SbaAdabasNewDbPage aNewDb( pParentDlg->GetParent(),aHostname,&aPB_RESTORE_BACKUP == pButton);
				if(aNewDb.Execute())
				{
					if(pButton != &aPB_RESTORE_BACKUP)
					{
						m_AdabasSysUser		= aNewDb.GetSysUser();
						m_AdabasSysPwd		= aNewDb.GetSysPwd();
						m_AdabasCtrlUser	= aNewDb.GetCtrlUser();
						m_AdabasCtrlPwd		= aNewDb.GetCtrlPwd();
					}
				}
				pParentDlg->Show();
				pParentDlg->Invalidate();
			}
			else
			{
				String aMsg(SbaResId(SBA_STR_NAME_TOO_LONG));
				aMsg.SearchAndReplaceAscii("\'#\'", '8');
				SbaMsgBox(pParentDlg,String(SbaResId(SBA_STAT_WARNING)),aMsg).Execute();
			}
		}
		else
			SbaMsgBox(pParentDlg,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_STR_NOT_OWN_HOST))).Execute();
	}
	else
		SbaMsgBox(pParentDlg,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_DSN_NOT_INSERTED))).Execute();

	return 0;
}

// -----------------------------------------------------------------------
IMPL_LINK( SbaTypePage, ButtonClickHdl, Button *, pButton )
{
	SdbEnvironmentRef xEnv;
	String aServerType(FindServerType(aLB_DATATYPE.GetSelectEntry()));
	String aList(xEnv->ServerNames(aServerType));
	String aCompareString; aCompareString.AssignAscii("*.");

	if (xEnv->Status().IsError())
	{
		SBA_MOD()->ShowDbStatus(xEnv->Status(),dbReadError);
		return 0;
	}

	// wenn als ServerNames-String so etwas wie "*.txt" uebergeben wurde...
	if (aCompareString.Match(aList)>2)
	{
		WinBits	nBits(WB_3DLOOK | WB_STDMODAL | WB_OPEN);
		String sFilter(aList);
		sFilter += SbaResId(RID_STR_FILES);

		SfxFileDialog* pFileDlg = new SfxFileDialog( this, nBits ); //	new FileDialog( this, nBits );
		pFileDlg->AddFilter(sFilter, aList);
		pFileDlg->SetCurFilter(sFilter);
		SbaIniWrap aIniWrap;
		pFileDlg->SetStandardDir(aIniWrap.GetDefaultDatabasePath());
		if (pFileDlg->Execute())
		{
			INetURLObject aUrl(pFileDlg->GetPath());
			aET_DSNNAME.SetText( aUrl.PathToFileName() );
			bAttrsChanged = sal_True;
			bDbNew = sal_False;
			if(aList.EqualsIgnoreCaseAscii("*.rb1"))
				pParentDlg->RemoveTabPage(TAB_PAG_TABSUBSCR);
			//pParentDlg->AddDetailPage(TAB_PAG_TABSUBSCR);
			if(pParentDlg)
				pParentDlg->GetOKButton().Enable(sal_True);
		}

		delete pFileDlg;
	}
	else

	if (aList == '*')
	{
		WinBits	nBits(WB_3DLOOK | WB_STDMODAL | WB_OPEN | SFXWB_PATHDIALOG);
		SfxFileDialog* pFileDlg = new SfxFileDialog(this, nBits);

		String strOld(aET_DSNNAME.GetText());
		if (strOld.Len())
		{
			DirEntry aConverter(strOld);
			pFileDlg->SetPath(aConverter.GetFull(FSYS_STYLE_URL));
		}
		if (pFileDlg->Execute())
		{
			DirEntry aConverter = DirEntry(pFileDlg->GetPath());
			aET_DSNNAME.SetText(aConverter.GetFull());
			bAttrsChanged = sal_True;
			if(pParentDlg)
				pParentDlg->GetOKButton().Enable(sal_True);
		}

		delete pFileDlg;
	}
	else
	{
		SbaDlgTypeselect* pDlg = new SbaDlgTypeselect( this, aList,aServerType, pParentDlg->ServerType());

		if( pDlg->Execute() )
		{
			if (pParentDlg->ServerType() == T_DB2)
			{
				String strTemp = pDlg->GetSelectEntry();
				aET_DSNNAME.SetText(strTemp.GetToken(0, ' '));
			} else
				aET_DSNNAME.SetText( pDlg->GetSelectEntry() );

			bAttrsChanged = sal_True;
			if(pParentDlg)
				pParentDlg->GetOKButton().Enable(sal_True);
		}
		delete pDlg;
	}
	return 0;
}

//========================================================================
SbaCommonBehaviourTabPage::SbaCommonBehaviourTabPage(Window* pParent, sal_uInt16 nResId, const SfxItemSet& rCoreAttrs,
	sal_uInt16 nControlFlags)

	:SfxTabPage(pParent, SbaResId(nResId), rCoreAttrs)
	,pFT_USERNAME(NULL)
	,pET_USERNAME(NULL)
	,pFT_PASSWORD(NULL)
	,pET_PASSWORD(NULL)
	,pCB_ASK_WHEN_EMPTY_PWD(NULL)
	,pFT_OPTIONS(NULL)
	,pET_OPTIONS(NULL)
	,pFT_CHARSET(NULL)
	,pLB_CHARSET(NULL)
	,pSbaCharset(NULL)
	,m_nControlFlags(nControlFlags)
{
	DBG_CTOR(SbaCommonBehaviourTabPage,NULL);
	if ((m_nControlFlags & CBTP_USE_UIDPWD) == CBTP_USE_UIDPWD)
	{
		pFT_USERNAME = new FixedText(this, ResId(FT_USERNAME));
		pET_USERNAME = new Edit(this, ResId(ET_USERNAME));
		pFT_PASSWORD = new FixedText(this, ResId(FT_PASSWORD));
		pET_PASSWORD = new Edit(this, ResId(ET_PASSWORD));

		pCB_ASK_WHEN_EMPTY_PWD = new CheckBox(this, SbaResId(CB_ASK_WHEN_EMPTY_PWD));
	}

	if ((m_nControlFlags & CBTP_USE_OPTIONS) == CBTP_USE_OPTIONS)
	{
		pFT_OPTIONS = new FixedText(this, ResId(FT_OPTIONS));
		pET_OPTIONS = new Edit(this, ResId(ET_OPTIONS));
	}

	if ((m_nControlFlags & CBTP_USE_CHARSET) == CBTP_USE_CHARSET)
	{
		pFT_CHARSET = new FixedText(this, ResId(FT_CHARSET));
		pLB_CHARSET = new ListBox(this, ResId(LB_CHARSET));

		pSbaCharset = new SbaCharset;

		String	strNameList(pSbaCharset->GetNameList());
		xub_StrLen nCount(strNameList.GetTokenCount());

		for (xub_StrLen i=0; i<nCount; ++i)
			pLB_CHARSET->InsertEntry(strNameList.GetToken(i));
	}
}

// -----------------------------------------------------------------------
SbaCommonBehaviourTabPage::~SbaCommonBehaviourTabPage()
{
	DBG_DTOR(SbaCommonBehaviourTabPage,NULL);
	CLEARUP(pFT_USERNAME);
	CLEARUP(pET_USERNAME);
	CLEARUP(pFT_PASSWORD);
	CLEARUP(pET_PASSWORD);
	CLEARUP(pCB_ASK_WHEN_EMPTY_PWD);

	CLEARUP(pFT_OPTIONS);
	CLEARUP(pET_OPTIONS);

	CLEARUP(pFT_CHARSET);
	CLEARUP(pLB_CHARSET);
	CLEARUP(pSbaCharset);
}

// -----------------------------------------------------------------------
void SbaCommonBehaviourTabPage::ActivatePage(const SfxItemSet& rCoreAttrs)
{
	DBG_CHKTHIS(SbaCommonBehaviourTabPage,NULL);
	const SfxStringItem* pUidItem = GET_ATTR(SfxStringItem, WID_CONN_USER_ID);
	const SfxStringItem* pPwdItem = GET_ATTR(SfxStringItem, WID_CONN_USER_PWD);
	const SfxStringItem* pOptionsItem = GET_ATTR(SfxStringItem,WID_CONN_OPTIONS);
	const SfxStringItem* pCharsetItem = GET_ATTR(SfxStringItem, WID_CONN_CHARSET);
	const SfxBoolItem* pAllowEmptyPwd = GET_ATTR(SfxBoolItem, WID_CONN_ASK_WHEN_EMPTY_PWD);

	if ((m_nControlFlags & CBTP_USE_UIDPWD) == CBTP_USE_UIDPWD)
	{
		pET_USERNAME->SetText(pUidItem->GetValue());
		pET_PASSWORD->SetText(pPwdItem->GetValue());
		pCB_ASK_WHEN_EMPTY_PWD->Check(pAllowEmptyPwd->GetValue());

		pET_USERNAME->ClearModifyFlag();
		pET_PASSWORD->ClearModifyFlag();

		pET_USERNAME->SaveValue();
		pET_PASSWORD->SaveValue();
		pCB_ASK_WHEN_EMPTY_PWD->SaveValue();

		pET_USERNAME->SetModifyHdl(LINK(this, SbaCommonBehaviourTabPage, OnPasswordModified));
		pET_PASSWORD->SetModifyHdl(LINK(this, SbaCommonBehaviourTabPage, OnPasswordModified));
		LINK(this, SbaCommonBehaviourTabPage, OnPasswordModified).Call(pCB_ASK_WHEN_EMPTY_PWD);
			// fuer den initialen Zustand
	}

	if ((m_nControlFlags & CBTP_USE_OPTIONS) == CBTP_USE_OPTIONS)
	{
		pET_OPTIONS->SetText(pOptionsItem->GetValue());
		pET_OPTIONS->ClearModifyFlag();
		pET_OPTIONS->SaveValue();
	}

	if ((m_nControlFlags & CBTP_USE_CHARSET) == CBTP_USE_CHARSET)
	{
		pLB_CHARSET->SelectEntry(pSbaCharset->KeyToName(pCharsetItem->GetValue()));
		pLB_CHARSET->SaveValue();
	}



	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		if ((m_nControlFlags & CBTP_USE_UIDPWD) == CBTP_USE_UIDPWD)
		{
			pFT_USERNAME->Disable();
			pET_USERNAME->Disable();
			pFT_PASSWORD->Disable();
			pET_PASSWORD->Disable();
			pCB_ASK_WHEN_EMPTY_PWD->Disable();
		}

		if ((m_nControlFlags & CBTP_USE_OPTIONS) == CBTP_USE_OPTIONS)
		{
			pFT_OPTIONS->Disable();
			pET_OPTIONS->Disable();
		}

		if ((m_nControlFlags & CBTP_USE_CHARSET) == CBTP_USE_CHARSET)
		{
			pFT_CHARSET->Disable();
			pLB_CHARSET->Disable();
		}
	}
}

// -----------------------------------------------------------------------
int SbaCommonBehaviourTabPage::DeactivatePage(SfxItemSet* pSet)
{
	DBG_CHKTHIS(SbaCommonBehaviourTabPage,NULL);
	if (pSet)
		FillItemSet(*pSet);
	return 1;
}

// -----------------------------------------------------------------------
sal_Bool SbaCommonBehaviourTabPage::FillItemSet(SfxItemSet& rSet)
{
	DBG_CHKTHIS(SbaCommonBehaviourTabPage,NULL);
	sal_Bool bAttrsChanged = sal_False;
	if ((m_nControlFlags & CBTP_USE_UIDPWD) == CBTP_USE_UIDPWD)
	{
		if (pET_USERNAME->GetText() != pET_USERNAME->GetSavedValue())
		{
			String strUserId(pET_USERNAME->GetText());
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_USER_ID), strUserId));
			bAttrsChanged = sal_True;
		}

		if (pET_PASSWORD->GetText() != pET_PASSWORD->GetSavedValue())
		{
			String strPassword(pET_PASSWORD->GetText());
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_USER_PWD), strPassword));
			bAttrsChanged = sal_True;
		}

		if (pCB_ASK_WHEN_EMPTY_PWD->IsChecked() != pCB_ASK_WHEN_EMPTY_PWD->GetSavedValue())
			rSet.Put(SfxBoolItem(GetWhich(WID_CONN_ASK_WHEN_EMPTY_PWD), pCB_ASK_WHEN_EMPTY_PWD->IsChecked()));
	}

	if ((m_nControlFlags & CBTP_USE_OPTIONS) == CBTP_USE_OPTIONS)
	{
		if( pET_OPTIONS->GetText() != pET_OPTIONS->GetSavedValue() )
		{
			String strOptions = pET_OPTIONS->GetText();
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_OPTIONS), strOptions));
			bAttrsChanged = sal_True;
		}
	}

	if ((m_nControlFlags & CBTP_USE_CHARSET) == CBTP_USE_CHARSET)
	{
		if (pLB_CHARSET->GetSelectEntryPos() != pLB_CHARSET->GetSavedValue())
		{
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_CHARSET), pSbaCharset->NameToKey(pLB_CHARSET->GetSelectEntry())));
			bAttrsChanged = sal_True;
		}
	}

	return bAttrsChanged;
}

//========================================================================
IMPL_LINK( SbaCommonBehaviourTabPage, OnPasswordModified, Control*, pControl)
{
	DBG_ASSERT((m_nControlFlags & CBTP_USE_UIDPWD) == CBTP_USE_UIDPWD, "SbaCommonBehaviourTabPage::OnPasswordModified : wrong mode, will probably crash");

	pCB_ASK_WHEN_EMPTY_PWD->Enable((pET_USERNAME->GetText().Len() > 0) && (pET_PASSWORD->GetText().Len() == 0));
	return 0L;
}

//========================================================================
SbaOdbcPage::SbaOdbcPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_ODBC, rCoreAttrs, CBTP_USE_UIDPWD | CBTP_USE_CHARSET | CBTP_USE_OPTIONS)
	,aFL_1			(this, ResId(FL_1))

	,pParentDlg(0)
{
	DBG_CTOR(SbaOdbcPage, NULL);

	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaOdbcPage::~SbaOdbcPage()
{
	DBG_DTOR( SbaOdbcPage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaOdbcPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaOdbcPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaOdbcPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

//========================================================================
SbaDb2Page::SbaDb2Page( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_DB2, rCoreAttrs, CBTP_USE_UIDPWD | CBTP_USE_CHARSET | CBTP_USE_OPTIONS)
	,aFL_1			(this, ResId(FL_1))
	,pParentDlg(0)
{
	DBG_CTOR( SbaDb2Page, NULL );

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaDb2Page::~SbaDb2Page()
{
	DBG_DTOR( SbaDb2Page, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaDb2Page::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaDb2Page( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaDb2Page::Reset( const SfxItemSet& rCoreAttrs )
{
}

//========================================================================
SbaAdabasPage::SbaAdabasPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_ADABAS, rCoreAttrs, CBTP_USE_UIDPWD)
	,pParentDlg(0)
{
	DBG_CTOR( SbaAdabasPage, NULL );

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaAdabasPage::~SbaAdabasPage()
{
	DBG_DTOR( SbaAdabasPage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaAdabasPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaAdabasPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaAdabasPage::Reset( const SfxItemSet& rCoreAttrs )
{
}
// -----------------------------------------------------------------------
sal_Bool SbaAdabasPage::FillItemSet( SfxItemSet& rCoreAttrs )
{
	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rCoreAttrs);
	return sal_True;
}
// -----------------------------------------------------------------------
void SbaAdabasPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaAdabasPage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);
}
//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaAdabasPage, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaAdabasPage, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaAdabasPage, AttributesChangedHdl, void *, EMPTYARG )
//========================================================================
SbaAdabasSettings::SbaAdabasSettings( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_ADABAS_SETTINGS, rCoreAttrs, CBTP_NONE)
	,m_FT_CACHE_SIZE(		this, ResId( FT_CACHE_SIZE		) )
	,m_NF_CACHE_SIZE(		this, ResId( NF_CACHE_SIZE		) )
	,m_FT_DATA_INCREMENT(	this, ResId( FT_DATA_INCREMENT	) )
	,m_NF_DATA_INCREMENT(	this, ResId( NF_DATA_INCREMENT	) )
	,m_CB_SHUTDB(			this, ResId( CB_SHUTDB			) )
	,aFL_1(					this, ResId( FL_1				) )
	,m_FT_CTRLUSERNAME(		this, ResId( FT_CTRLUSERNAME	) )
	,m_ET_CTRLUSERNAME(		this, ResId( ET_CTRLUSERNAME	) )
	,m_FT_CTRLPASSWORD(		this, ResId( FT_CTRLPASSWORD	) )
	,m_ET_CTRLPASSWORD(		this, ResId( ET_CTRLPASSWORD	) )
	,m_PB_STAT(				this, ResId( PB_STAT			) )
	,pParentDlg(0)
	,bAttrsChanged(sal_False)
{
	DBG_CTOR( SbaAdabasSettings, NULL );

	m_PB_STAT.SetClickHdl(				LINK(this,SbaAdabasSettings,PBClickHdl));

	m_CB_SHUTDB.Enable(sal_False);
	m_CB_SHUTDB.SetClickHdl(			LINK(this,SbaAdabasSettings,AttributesChangedHdl));
	m_NF_CACHE_SIZE.SetModifyHdl(		LINK(this,SbaAdabasSettings,AttributesChangedHdl));
	m_NF_DATA_INCREMENT.SetModifyHdl(	LINK(this,SbaAdabasSettings,AttributesChangedHdl));
	m_ET_CTRLUSERNAME.SetModifyHdl(		LINK(this,SbaAdabasSettings,AttributesChangedHdl));
	m_ET_CTRLPASSWORD.SetModifyHdl(		LINK(this,SbaAdabasSettings,AttributesChangedHdl));

	m_ET_CTRLUSERNAME.SetLoseFocusHdl(	LINK(this,SbaAdabasSettings,LoseFocusHdl));
	m_ET_CTRLPASSWORD.SetLoseFocusHdl(	LINK(this,SbaAdabasSettings,LoseFocusHdl));
		
	m_NF_DATA_INCREMENT.SetMin(20);
	m_NF_DATA_INCREMENT.SetMax(LONG_MAX);
	m_NF_DATA_INCREMENT.SetValue(20);
	m_NF_DATA_INCREMENT.SetDecimalDigits(0);

	m_NF_CACHE_SIZE.SetMin(4);
	m_NF_CACHE_SIZE.SetMax(LONG_MAX);
	m_NF_CACHE_SIZE.SetValue(4);
	m_NF_CACHE_SIZE.SetDecimalDigits(0);

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaAdabasSettings::~SbaAdabasSettings()
{
	DBG_DTOR( SbaAdabasSettings, NULL );
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasSettings, LoseFocusHdl, Edit *, pEdit )
{
	m_CB_SHUTDB.Enable(m_ET_CTRLUSERNAME.GetText().Len() && m_ET_CTRLPASSWORD.GetText().Len());
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasSettings, PBClickHdl, Button *, pButton )
{
	SdbEnvironmentRef xEnv = SdbEnvironmentRef();
	SdbConnectionRef pConn = xEnv->OpenConnection( m_aConnection );

	if( !pConn.Is() )
	{
		SBA_MOD()->ShowDbStatus(xEnv->Status(), dbReadError);
		return 0;
	}
	SbaAdabasStatistics aDlg(pParentDlg->GetParent(),pConn);
	pParentDlg->Hide();
	aDlg.Execute();
	pParentDlg->Show();
	pParentDlg->Invalidate();
	return 0;
}
// -----------------------------------------------------------------------
SfxTabPage*	SbaAdabasSettings::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaAdabasSettings( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaAdabasSettings::Reset( const SfxItemSet& rCoreAttrs )
{
}
// -----------------------------------------------------------------------
sal_Bool SbaAdabasSettings::FillItemSet( SfxItemSet& rCoreAttrs )
{
	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rCoreAttrs);
	if ( bAttrsChanged )
	{
		rCoreAttrs.Put( SfxBoolItem(GetWhich(WID_CONN_SHUTSERVICE), m_CB_SHUTDB.IsEnabled() && m_CB_SHUTDB.IsChecked() ) );
		rCoreAttrs.Put( SfxInt32Item(GetWhich(WID_CONN_DATAINC), m_NF_DATA_INCREMENT.GetValue() ) );
		rCoreAttrs.Put( SfxInt32Item(GetWhich(WID_CONN_CACHESIZE), m_NF_CACHE_SIZE.GetValue() ) );
		rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_CTRLUSER), m_ET_CTRLUSERNAME.GetText()));
		rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_CTRLPWD), m_ET_CTRLPASSWORD.GetText()));
	}
	return sal_True;
}
// -----------------------------------------------------------------------
void SbaAdabasSettings::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaAdabasSettings, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);
	const SfxBoolItem* pShutItem	= GET_ATTR(SfxBoolItem,WID_CONN_SHUTSERVICE);
	const SfxInt32Item* pIncItem	= GET_ATTR(SfxInt32Item,WID_CONN_DATAINC);
	const SfxInt32Item* pCacheItem	= GET_ATTR(SfxInt32Item,WID_CONN_CACHESIZE);
	
	m_CB_SHUTDB.Check( pShutItem->GetValue() );
	m_NF_DATA_INCREMENT.SetValue( pIncItem->GetValue() );
	m_NF_CACHE_SIZE.SetValue( pCacheItem->GetValue() );

	const SfxStringItem*	 pCtrlUserItem	= GET_ATTR(SfxStringItem,WID_CONN_CTRLUSER);
	const SfxStringItem*	 pCtrlPwdItem	= GET_ATTR(SfxStringItem,WID_CONN_CTRLPWD);

	m_ET_CTRLUSERNAME.SetText(pCtrlUserItem->GetValue());
	m_ET_CTRLPASSWORD.SetText(pCtrlPwdItem->GetValue());

	SbaDbtypeDlg* pDlg = (SbaDbtypeDlg*)(GetParent()->GetParent());
	SbaDBConfig* pOwner = pDlg->GetOwner();
	m_aConnection = pOwner->BuildArgString( rCoreAttrs );
	m_CB_SHUTDB.Enable(m_ET_CTRLUSERNAME.GetText().Len() && m_ET_CTRLPASSWORD.GetText().Len());
}

//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaAdabasSettings, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaAdabasSettings, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaAdabasSettings, AttributesChangedHdl, void *, EMPTYARG )

//========================================================================
SbaAddrbookPage::SbaAddrbookPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_ADDRBOOK, rCoreAttrs,0)
	,pParentDlg(0)
	,m_pbMapping(this,ResId(PB_MAPPING))
{
	DBG_CTOR( SbaAddrbookPage, NULL );

	m_pbMapping.SetClickHdl(LINK(this,SbaAddrbookPage,ButtonClickHdl));

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaAddrbookPage::~SbaAddrbookPage()
{
	DBG_DTOR( SbaAddrbookPage, NULL );
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAddrbookPage, ButtonClickHdl, Button *, pButton )
{
	return 0;
}
// -----------------------------------------------------------------------
SfxTabPage*	SbaAddrbookPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaAddrbookPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaAddrbookPage::Reset( const SfxItemSet& rCoreAttrs )
{
}
//========================================================================
SbaTextPage::SbaTextPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_TEXT, rCoreAttrs, CBTP_USE_CHARSET)

	,aCB_HDR( this, ResId( CB_HDR ) )
	,aFT_DEL( this, ResId( FT_DEL ) )
	,aCM_DEL( this, ResId( CM_DEL ) )
	,aFT_STR( this, ResId( FT_STR ) )
	,aCM_STR( this, ResId( CM_STR ) )
	,aFT_DECDEL( this, ResId( FT_DECDEL ) )
	,aCM_DECDEL( this, ResId( CM_DECDEL ) )

	,aFT_THODEL( this, ResId( FT_THODEL ) )
	,aCM_THODEL( this, ResId( CM_THODEL ) )
	,aFL_1(this, ResId(FL_1))

	,aFT_EXTENSION( this, ResId( FT_EXTENSION ) )
	,aCM_EXTENSION( this, ResId( CM_EXTENSION ) )

	,aStrDelList(ResId(ST_DEL_DEL))
	,aStrStrList(ResId(ST_DEL_STR))

	,pParentDlg(0)
	,bAttrsChanged(sal_False)
{
	DBG_CTOR( SbaTextPage, NULL );

	SetExchangeSupport(sal_True);

	xub_StrLen nCnt = aStrDelList.GetTokenCount( '\t' );
	for( xub_StrLen i=0 ; i<nCnt ; i+=2 )
		aCM_DEL.InsertEntry( aStrDelList.GetToken( i, '\t' ) );

	nCnt = aStrStrList.GetTokenCount( '\t' );
	for( i=0 ; i<nCnt ; i+=2 )
		aCM_STR.InsertEntry( aStrStrList.GetToken( i, '\t' ) );

	aCB_HDR.SetClickHdl(LINK(this,SbaTextPage,AttributesChangedHdl));

	aCM_DEL.SetLoseFocusHdl(LINK(this,SbaTextPage,EditLoseFocusHdl));
	aCM_DEL.SetUpdateDataHdl(LINK(this,SbaTextPage,DelimeterHdl));
	aCM_DEL.SetSelectHdl(LINK(this,SbaTextPage,DelimeterHdl));

	aCM_STR.SetLoseFocusHdl(LINK(this,SbaTextPage,EditLoseFocusHdl));
	aCM_STR.SetUpdateDataHdl(LINK(this,SbaTextPage,DelimeterHdl));
	aCM_STR.SetSelectHdl(LINK(this,SbaTextPage,DelimeterHdl));

	aCM_DECDEL.SetLoseFocusHdl(LINK(this,SbaTextPage,EditLoseFocusHdl));
	aCM_THODEL.SetLoseFocusHdl(LINK(this,SbaTextPage,EditLoseFocusHdl));
	aCM_EXTENSION.SetLoseFocusHdl(LINK(this,SbaTextPage,EditLoseFocusHdl));
	aCM_EXTENSION.SetSelectHdl(LINK(this,SbaTextPage,ExtensionHdl));

	pLB_CHARSET->SetSelectHdl(LINK(this,SbaTextPage,AttributesChangedHdl));
	pLB_CHARSET->SetZOrder(&aCM_EXTENSION, WINDOW_ZORDER_BEHIND);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaTextPage::~SbaTextPage()
{
	DBG_DTOR(SbaTextPage, NULL);
}

//------------------------------------------------------------------------
IMPL_LINK( SbaTextPage, DelimeterHdl, Control *, pControl )
{
	bAttrsChanged = sal_True;
	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaTextPage, ExtensionHdl, Control *, pControl )
{
	String aExt(aCM_EXTENSION.GetText());
	if (aExt.EqualsIgnoreCaseAscii("sdf"))
	{
		if (aCM_STR.GetText() != ';')
			aCM_DEL.SetText(';');

		pLB_CHARSET->SelectEntry( pSbaCharset->KeyToName(String::CreateFromAscii("IBMPC")));
		bAttrsChanged = sal_True;
		return 0;
	}
	if (aExt.EqualsIgnoreCaseAscii("txt"))
	{
		if (aCM_STR.GetText() != ';')			// s.o.
			aCM_DEL.SetText(';');
		pLB_CHARSET->SelectEntry(pSbaCharset->KeyToName(String::CreateFromAscii("System")));
		bAttrsChanged = sal_True;
		return 0;
	}
	else if (aExt.EqualsIgnoreCaseAscii("csv"))
	{
		if (aCM_STR.GetText() != ',')
			aCM_DEL.SetText(',');
		pLB_CHARSET->SelectEntry(pSbaCharset->KeyToName(String::CreateFromAscii("System")));
		bAttrsChanged = sal_True;
		return 0;
	}
	else
	{
		bAttrsChanged = sal_True;
		return 0;
	}
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaTextPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaTextPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaTextPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaTextPage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);

	const SfxUInt16Item*	 pDelItem		= GET_ATTR(SfxUInt16Item,WID_CONN_DEL);
	const SfxUInt16Item*	 pStrItem		= GET_ATTR(SfxUInt16Item,WID_CONN_STR);
	const SfxUInt16Item*	 pDecdelItem	= GET_ATTR(SfxUInt16Item,WID_CONN_DECDEL);
	const SfxUInt16Item*	 pThodelItem	= GET_ATTR(SfxUInt16Item,WID_CONN_THODEL);

	const SfxStringItem*	 pExtensionItem	= GET_ATTR(SfxStringItem,WID_CONN_EXT);

	const SfxBoolItem*		 pHdrItem		= GET_ATTR(SfxBoolItem,WID_CONN_HDR);

	aCB_HDR.Check( pHdrItem->GetValue() );

	SetSeparator( aCM_DEL, aStrDelList, pDelItem->GetValue() );
	SetSeparator( aCM_STR, aStrStrList, pStrItem->GetValue() );

	aCM_DECDEL.SetText( sal_Unicode(pDecdelItem->GetValue()) );
	aCM_THODEL.SetText( sal_Unicode(pThodelItem->GetValue()) );
	aCM_EXTENSION.SetText( pExtensionItem->GetValue());

//---
	aCB_HDR.SaveValue();
	aCM_DEL.SaveValue();
	aCM_STR.SaveValue();
	aCM_DECDEL.SaveValue();
	aCM_THODEL.SaveValue();
	aCM_EXTENSION.SaveValue();

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aCB_HDR.Disable();
		aFT_DEL.Disable();
		aCM_DEL.Disable();
		aFT_STR.Disable();
		aCM_STR.Disable();
		aFT_DECDEL.Disable();
		aCM_DECDEL.Disable();
		aFT_THODEL.Disable();
		aCM_THODEL.Disable();
		aFT_EXTENSION.Disable();
		aCM_EXTENSION.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaTextPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
int SbaTextPage::DeactivatePage(SfxItemSet* pSet)
{
	String aErrorText;
	// Kein FeldTrenner
	String aDelText(aCM_DEL.GetText());
	//	if (!aCM_DEL.GetText().Len())	// Bug(#42168), wenn diese Zeile unter OS2 mit prod. compiliert wird
										// -> lokale Variable, keine Ahnung, warum dieser Fehler auftritt
	if(!aDelText.Len())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_MISSING));
		aErrorText.SearchAndReplaceAscii("#1",aFT_DEL.GetText());
		goto Error;
	}
	// kein Decimaltrenner
	if (!aCM_DECDEL.GetText().Len())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_MISSING));
		aErrorText.SearchAndReplaceAscii("#1",aFT_DECDEL.GetText());
		goto Error;
	}
	// Feld und TextTrenner duerfen nicht gleich sein
	if (aCM_STR.GetText() == aCM_DEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_STR.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_DEL.GetText());
		goto Error;
	}

	// Tausender und DecimalTrenner duerfen nicht gleich sein
	if (aCM_DECDEL.GetText() == aCM_THODEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_DECDEL.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_THODEL.GetText());
		goto Error;
	}
	// Tausender und FeldTrenner duerfen nicht gleich sein
	if (aCM_DEL.GetText() == aCM_THODEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_DEL.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_THODEL.GetText());
		goto Error;
	}
	// Zehner und FeldTrenner duerfen nicht gleich sein
	if (aCM_DEL.GetText() == aCM_DECDEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_DEL.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_DECDEL.GetText());
		goto Error;
	}

	// Tausender und TextTrenner duerfen nicht gleich sein
	if (aCM_STR.GetText() == aCM_THODEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_STR.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_THODEL.GetText());
		goto Error;
	}
	// Zehner und TextTrenner duerfen nicht gleich sein
	if (aCM_STR.GetText() == aCM_DECDEL.GetText())
	{
		aErrorText = String(SbaResId(SBA_STR_DEL_DIFFER));
		aErrorText.SearchAndReplaceAscii("#1",aFT_STR.GetText());
		aErrorText.SearchAndReplaceAscii("#2",aFT_DECDEL.GetText());
		goto Error;
	}

	if (aCM_EXTENSION.GetText().Search('*') != STRING_NOTFOUND ||
		aCM_EXTENSION.GetText().Search('?') != STRING_NOTFOUND)
	{
		aErrorText = String(SbaResId(SBA_STR_NO_WILDCARDS));
		aErrorText.SearchAndReplaceAscii("#1",aFT_EXTENSION.GetText());
		goto Error;
	}
	else if (pSet)
	{
		FillItemSet(*pSet);
	}
	return 1;

Error:
	aErrorText.EraseAllChars('~');
	ErrorBox aDlg(NULL,WB_OK, aErrorText);
	aDlg.Execute();
	aCM_DEL.GrabFocus();
	return 0;
}

// -----------------------------------------------------------------------
sal_Bool SbaTextPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaTextPage, NULL );

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);

	if( aCB_HDR.IsChecked() != aCB_HDR.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem(GetWhich(WID_CONN_HDR), aCB_HDR.IsChecked() ) );
		bChangedSomething = sal_True;
	}

	if( aCM_DEL.GetText() != aCM_DEL.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item(GetWhich(WID_CONN_DEL), GetSeparator( aCM_DEL, aStrDelList) ) );
		bChangedSomething = sal_True;
	}
	if( aCM_STR.GetText() != aCM_STR.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item(GetWhich(WID_CONN_STR), GetSeparator( aCM_STR, aStrStrList) ) );
		bChangedSomething = sal_True;
	}

	if( aCM_DECDEL.GetText() != aCM_DECDEL.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item(GetWhich(WID_CONN_DECDEL), (sal_uInt16)(aCM_DECDEL.GetText().GetChar(0)) ) );
		bChangedSomething = sal_True;
	}
	if( aCM_THODEL.GetText() != aCM_THODEL.GetSavedValue() )
	{
		rSet.Put( SfxUInt16Item(GetWhich(WID_CONN_THODEL), (sal_uInt16)(aCM_THODEL.GetText().GetChar(0)) ) );
		bChangedSomething = sal_True;
	}
	if( aCM_EXTENSION.GetText() != aCM_EXTENSION.GetSavedValue() )
	{
		rSet.Put( SfxStringItem(GetWhich(WID_CONN_EXT), aCM_EXTENSION.GetText()));
		bChangedSomething = sal_True;
	}

	return bChangedSomething;
}

//------------------------------------------------------------------------
sal_uInt16 SbaTextPage::GetSeparator( const ComboBox& rBox, const String& rList )
{
	DBG_CHKTHIS( SbaTextPage, NULL );
	char	nTok = '\t';
	sal_uInt16	nRet(0);
	sal_uInt16	nPos(rBox.GetEntryPos( rBox.GetText() ));

	if( nPos == COMBOBOX_ENTRY_NOTFOUND )
	{
		nRet = (sal_uInt16)(rBox.GetText().GetChar(0));
	}
	else
	{
		nRet = (sal_uInt16)rList.GetToken((nPos*2)+1, nTok ).ToInt32();
	}

	return nRet;
}

//------------------------------------------------------------------------
void SbaTextPage::SetSeparator( ComboBox& rBox, const String& rList, sal_uInt16 nVal )
{
	DBG_CHKTHIS( SbaTextPage, NULL );

	char	nTok = '\t';
	xub_StrLen	nCnt(rList.GetTokenCount( nTok ));
	xub_StrLen	i;

	for( i=0 ; i<nCnt ; i+=2 )
	{
		sal_uInt16	nTVal(rList.GetToken( i+1, nTok ).ToInt32());

		if( nTVal == nVal )
		{
			rBox.SetText( rList.GetToken( i, nTok ) );
			break;
		}
	}

	if( i >= nCnt )
	{
		rBox.SetText( (sal_Unicode)nVal );
	}
}

//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaTextPage, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaTextPage, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaTextPage, AttributesChangedHdl, void *, EMPTYARG )

//------------------------------------------------------------------------
IMPL_LINK( SbaTextPage, EditLoseFocusHdl, Control *, pControl )
{
	DBG_CHKTHIS( SbaTextPage, NULL );

	Edit*	pEdit = (Edit*)pControl;
	if( pEdit->IsModified() )
	{
		if (pControl == &aCM_EXTENSION) // SelectHdl nochmal, falls Eingabe ueber Tastatur
			aCM_EXTENSION.GetSelectHdl().Call(pControl);
		else if (pControl == &aCM_STR)
			aCM_STR.GetSelectHdl().Call(pControl);
		else if (pControl == &aCM_DEL)
			aCM_STR.GetSelectHdl().Call(pControl);
	}
	return 0;
}

//========================================================================
SbaDbasePage::SbaDbasePage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_DBASE, rCoreAttrs, CBTP_USE_CHARSET)

	,aCB_SHOWDELETED(	this, ResId( CB_SHOWDELETED ) )
	,aCB_LONGTABLENAMES(	this, ResId( CB_LONGTABLENAMES ) )
	,aPB_INDEXES(	this, ResId( PB_INDEXES ) )

	,pParentDlg(0)
	,pDSNItem(NULL)
{
	DBG_CTOR( SbaDbasePage, NULL );

	SetExchangeSupport(sal_True);

	aPB_INDEXES.SetClickHdl(LINK(this,SbaDbasePage,ButtonClickHdl));
	pLB_CHARSET->SetZOrder(&aCB_LONGTABLENAMES, WINDOW_ZORDER_BEHIND);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaDbasePage::~SbaDbasePage()
{
	DBG_DTOR( SbaDbasePage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaDbasePage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaDbasePage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaDbasePage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaDbasePage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);

	const SfxBoolItem*		 pDeletedItem	= GET_ATTR(SfxBoolItem,WID_CONN_DELETED);
	const SfxBoolItem*		 pLongNameItem	= GET_ATTR(SfxBoolItem,WID_CONN_LONGTABLENAME);
	pDSNItem = GET_ATTR(SfxStringItem,WID_CONN_DSN); // mit diesem Item wird der Indexdialog initialisiert, deshalb kein lokaler Focus


	aCB_SHOWDELETED.Check( pDeletedItem->GetValue() != sal_False );
	aCB_LONGTABLENAMES.Check( pLongNameItem->GetValue() != sal_False );

	aCB_SHOWDELETED.SaveValue();
	aCB_LONGTABLENAMES.SaveValue();

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aCB_SHOWDELETED.Disable();
		aCB_LONGTABLENAMES.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaDbasePage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
sal_Bool SbaDbasePage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaDbasePage, NULL );

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);

	if( aCB_SHOWDELETED.IsChecked() != aCB_SHOWDELETED.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem(GetWhich(WID_CONN_DELETED), aCB_SHOWDELETED.IsChecked() ) );
		bChangedSomething = sal_True;
	}

	if( aCB_LONGTABLENAMES.IsChecked() != aCB_LONGTABLENAMES.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem(GetWhich(WID_CONN_LONGTABLENAME), aCB_LONGTABLENAMES.IsChecked() ) );
		bChangedSomething = sal_True;
	}

	return bChangedSomething;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaDbasePage, ButtonClickHdl, Button *, pButton )
{
	DlgIndexes* pIndexDlg = new DlgIndexes( this, pDSNItem->GetValue() );

	if ( pIndexDlg->Execute() )
	{
	}

	delete pIndexDlg;

	return 0;
}

//========================================================================
SbaFmkPage::SbaFmkPage( Window* pParent, const SfxItemSet& rCoreAttrs ):
	SfxTabPage( pParent, SbaResId( TAB_PAG_FMK ), rCoreAttrs ),

	aCB_FETCHALL( this, ResId( CB_FETCHALL ) ),
	aFT_MAXROWS( this, ResId( FT_MAXROWS ) ),
	aET_MAXROWS( this, ResId( ET_MAXROWS ) ),
	pParentDlg(0),
	bAttrsChanged( sal_False )
{
	DBG_CTOR( SbaFmkPage, NULL );
	SetExchangeSupport(sal_True);

	aCB_FETCHALL.SetClickHdl(LINK(this,SbaFmkPage,ButtonClickHdl));
	aET_MAXROWS.SetModifyHdl(LINK(this,SbaFmkPage,EditLoseFocusHdl));

	FreeResource();
}

// -----------------------------------------------------------------------
SbaFmkPage::~SbaFmkPage()
{
	DBG_DTOR( SbaFmkPage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaFmkPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaFmkPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaFmkPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaFmkPage, NULL );

	const SfxStringItem*	 pMaxrowsItem	= GET_ATTR(SfxStringItem,WID_CONN_MAXROWS);
	const SfxBoolItem*		 pFetchallItem	= GET_ATTR(SfxBoolItem,WID_CONN_FETCHALL);


	aCB_FETCHALL.Check( pFetchallItem->GetValue() );
	aET_MAXROWS.SetText( pMaxrowsItem->GetValue() );

	ButtonClickHdl( &aCB_FETCHALL );

	aCB_FETCHALL.SaveValue();
	aET_MAXROWS.SaveValue();

	bAttrsChanged = sal_False;

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aCB_FETCHALL.Disable();
		aFT_MAXROWS.Disable();
		aET_MAXROWS.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaFmkPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
int SbaFmkPage::DeactivatePage(SfxItemSet* pSet)
{
	if (pSet)
		FillItemSet(*pSet);
	return 1;
}

// -----------------------------------------------------------------------
sal_Bool SbaFmkPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaFmkPage, NULL );

	sal_Bool bReturn(bAttrsChanged);

	if ( bAttrsChanged )
	{
	/*
		if( aLB_CHARSET.GetSelectEntryPos() != aLB_CHARSET.GetSavedValue() )
		{
			rSet.Put(
				SfxStringItem(GetWhich(WID_CONN_CHARSET),
					pSbaCharset->NameToKey( aLB_CHARSET.GetSelectEntry() ) ) );
		}
	*/
		if( aET_MAXROWS.GetText() != aET_MAXROWS.GetSavedValue() )
			rSet.Put( SfxStringItem(GetWhich(WID_CONN_MAXROWS), aET_MAXROWS.GetText() ) );

		if( aCB_FETCHALL.IsChecked() != aCB_FETCHALL.GetSavedValue() )
			rSet.Put( SfxBoolItem(GetWhich(WID_CONN_FETCHALL), aCB_FETCHALL.IsChecked() ) );

		bAttrsChanged = sal_False;
	}

	return bReturn;}

//------------------------------------------------------------------------
IMPL_LINK( SbaFmkPage, ButtonClickHdl, Button *, pButton )
{
	if( pButton == &aCB_FETCHALL )
	{
		if( aCB_FETCHALL.IsChecked() )
			aET_MAXROWS.Enable();
		else
			aET_MAXROWS.Disable();
		bAttrsChanged = sal_True;
	}
	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaFmkPage, EditLoseFocusHdl, Control *, pControl )
{
	DBG_CHKTHIS( SbaFmkPage, NULL );
	bAttrsChanged = sal_True;
	return 0;
}

//========================================================================
SbaTableTreeListBox::SbaTableTreeListBox( Window* pParent, WinBits nWinStyle ) : SbaTreeListBox(pParent,nWinStyle)
	,m_aTableImage( ResId(TABLE_S))
	,m_aViewImage( ResId(VIEW_S))
{
	// Bitmaps setzen
	SetDefaultExpandedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
	SetDefaultCollapsedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
}
//------------------------------------------------------------------------
SbaTableTreeListBox::SbaTableTreeListBox( Window* pParent, const ResId& rResId )
	: SbaTreeListBox(pParent,rResId)
	,m_aTableImage(SbaResId(TABLE_S))
	,m_aViewImage( SbaResId(VIEW_S))
{
	// Bitmaps setzen
	SetDefaultExpandedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
	SetDefaultCollapsedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
}
//------------------------------------------------------------------------
void SbaTableTreeListBox::Command( const CommandEvent& rEvt )
{
	sal_Bool bHandled = sal_False;
	switch( rEvt.GetCommand() )
	{
		case COMMAND_CONTEXTMENU:
		{
			// die Stelle, an der geklickt wurde
			Point ptWhere;
			if (rEvt.IsMouseEvent())
			{
				ptWhere = rEvt.GetMousePosPixel();
				SvLBoxEntry* ptClickedOn = GetEntry(ptWhere);
				if (ptClickedOn == NULL)
					break;
				if ( !IsSelected(ptClickedOn) )
				{
					SelectAll(sal_False);
					Select(ptClickedOn, sal_True);
					SetCurEntry(ptClickedOn);
				}
			}
			else
				ptWhere = GetEntryPos(GetCurEntry());


			SvLBoxEntry* pCurrent = GetCurEntry();
			if (!pCurrent)
				break;

			SvSortMode eSortMode = GetModel()->GetSortMode();
			PopupMenu aContextMenu(SbaResId(RID_SBA_TBLPOPUPMENU));
			switch( aContextMenu.Execute( this, ptWhere ) )
			{
				case SID_TBL_SORT_ASC:
					GetModel()->SetSortMode(SortAscending);
					break;
				case SID_TBL_SORT_DESC:
					GetModel()->SetSortMode(SortDescending);
					break;
			}
			if(eSortMode != GetModel()->GetSortMode())
				GetModel()->Resort();
		}
		break;
		default:
			SvTreeListBox::Command( rEvt );
	}
}
//------------------------------------------------------------------------
void SbaTableTreeListBox::UpdateTableList(SdbDatabase* pDatabase,sal_Bool bViewsAllowed)
{
	//////////////////////////////////////////////////////////////////////
	// Datenbank- und Tabellennamen setzen

	Clear();

	if(!pDatabase)
		return;
	// =======================================================================
	// Tabellenliste updaten

	sal_uInt16 nCount = pDatabase->GetObjectCount(dbTable),
			i	  = 0;
	String aCatalog, aSchema, aName, aTableName;
	SvLBoxEntry* pCat,*pSchema;
	while (i < nCount)
	{
		pCat = pSchema = NULL;

		aTableName = pDatabase->GetObjectName( dbTable, i++ );

		sal_Bool bView = pDatabase->IsView(aTableName);
		if(!bView || (bView && bViewsAllowed))
		{
			Image& aImage = bView ? m_aViewImage : m_aTableImage;
			pDatabase->QualifiedNameComponents(aTableName,aCatalog, aSchema, aName);

			if(aCatalog.Len())
			{
				pCat = GetEntryPosByName( aCatalog);
				if(!pCat)
					pCat = InsertEntry(aCatalog);
			}

			if(aSchema.Len())
			{
				pSchema = GetEntryPosByName( aSchema);
				if(!pSchema)
					pSchema = InsertEntry(aSchema,pCat);
			}

			InsertEntry(aName,aImage,aImage, pSchema ? pSchema : pCat);
		}
	}
}
//------------------------------------------------------------------------
void SbaTableTreeListBox::UpdateTableList(SdbConnection* pDatabase,sal_Bool bViewsAllowed)
{
	//////////////////////////////////////////////////////////////////////
	// Datenbank- und Tabellennamen setzen
	Clear();
	if(!pDatabase)
		return;
	// =======================================================================
	// Tabellenliste updaten

	sal_uInt16 nCount = pDatabase->GetTableCount(),
			i	  = 0;
	String aCatalog, aSchema, aName, aTableName;
	SvLBoxEntry* pCat,*pSchema;
	while (i < nCount)
	{
		pCat = pSchema = NULL;

		aTableName = pDatabase->GetTableName( i++ );

		sal_Bool bView = pDatabase->IsView(aTableName);
		if(!bView || (bView && bViewsAllowed))
		{
			Image& aImage = bView ? m_aViewImage : m_aTableImage;
			pDatabase->QualifiedNameComponents(aTableName,aCatalog, aSchema, aName);

			if(aCatalog.Len())
			{
				pCat = GetEntryPosByName( aCatalog);
				if(!pCat)
					pCat = InsertEntry(aCatalog);
			}

			if(aSchema.Len())
			{
				pSchema = GetEntryPosByName( aSchema);
				if(!pSchema)
					pSchema = InsertEntry(aSchema,pCat);
			}

			InsertEntry(aName,aImage,aImage, pSchema ? pSchema : pCat);
		}
	}
}

//------------------------------------------------------------------------
//=============================================================================
DBG_NAME(SbaTabSubscrPage);
//------------------------------------------------------------------------
SbaTabSubscrPage::SbaTabSubscrPage( Window* pParent, const SfxItemSet& rCoreAttrs ) :
	SfxTabPage( pParent, SbaResId( TAB_PAG_TABSUBSCR ), rCoreAttrs ),
	aFT_TabSubscr( this, SbaResId(FT_TABSUBSCR) ),
	aTLB_Tables(this, SbaResId(CLB_TABSUBSCR)),
	aPB_AddAll( this, SbaResId(PB_ADDALL) ),
	bCheckedAll( sal_True )
{
	DBG_CTOR(SbaTabSubscrPage,NULL);

	SetExchangeSupport(sal_True);
	aPB_AddAll.SetClickHdl( LINK(this, SbaTabSubscrPage, AddAllClickHdl) );
	aPB_AddAll.SetText( SbaResId(SBA_STR_ALL) );
	// TabListBox initialisieren
	aTLB_Tables.SetSelectionMode( MULTIPLE_SELECTION );
	aTLB_Tables.SetDragDropMode( 0 );
	aTLB_Tables.EnableInplaceEditing( sal_False );
	aTLB_Tables.SetWindowBits(WB_BORDER | WB_HASLINES | WB_HASLINESATROOT | WB_SORT | WB_HASBUTTONS | WB_HSCROLL |WB_HASBUTTONSATROOT);

	aTLB_Tables.Clear();

	FreeResource();
}

//------------------------------------------------------------------------
SbaTabSubscrPage::~SbaTabSubscrPage()
{
	DBG_DTOR(SbaTabSubscrPage,NULL);
}
//------------------------------------------------------------------------
SfxTabPage*	SbaTabSubscrPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return ( new SbaTabSubscrPage( pParent, rAttrSet ) );
}
//------------------------------------------------------------------------
void SbaTabSubscrPage::ActivatePage( const SfxItemSet& rSet )
{
	//////////////////////////////////////////////////////////////////////
	// Connection aufbauen
	SbaDbtypeDlg* pDlg = (SbaDbtypeDlg*)(GetParent()->GetParent());
	SbaDBConfig* pOwner = pDlg->GetOwner();

	String aConnection;
	switch (pDlg->ServerType())		// default Zeichsatz setzen
	{
		case T_OTER:
		case T_DBF:
		case T_TXT:
		case T_DAO:
		{
			SfxItemSet* pSet = rSet.Clone();
			SfxStringItem aFileItem((const SfxStringItem&)pSet->Get(WID_CONN_FILENAME));
			SfxStringItem aDsnItem((const SfxStringItem&)pSet->Get(WID_CONN_DSN));

			// build the correct file dsn
			DirEntry aEntry = CreateEntry(aDsnItem.GetValue(), aFileItem.GetValue());
			pSet->Put( SfxStringItem(GetWhich(WID_CONN_DSN), aEntry.GetFull() ) );
			aConnection = pOwner->BuildArgString( *pSet );
			delete pSet;
		}	break;
		case T_JDBC:
		case T_ADO:
			aConnection = pOwner->BuildArgString( rSet );
			break;
		default:
		{
		   aConnection = pOwner->BuildArgString( rSet );
		   const SfxStringItem* pDsnItem = (const SfxStringItem*)rSet.GetItem( WID_CONN_DSN );
		   if (!pDsnItem->GetValue().Len())
		   {
			   SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_STR_CONN_FAILED))).Execute();
			   return;
		   }
		}
	}

	SdbEnvironmentRef xEnv = SdbEnvironmentRef();
	SdbConnectionRef xConnection = xEnv->OpenConnection( aConnection );
	if( !xConnection.Is() )
	{
		SBA_MOD()->ShowDbStatus(xEnv->Status(), dbReadError);
		aPB_AddAll.Enable( sal_False );
		aTLB_Tables.Clear();
		aTLB_Tables.GrabFocus();
		return;
	}


	m_cSeparator = xConnection->GetQualifierSeparator();
	//////////////////////////////////////////////////////////////////////
	// Tabellen in CheckListBox einfuegen
	aTLB_Tables.UpdateTableList(xConnection,sal_True);

	//////////////////////////////////////////////////////////////////////
	// Tabellen in CheckListBox markieren
	const SfxStringItem* pTableItem	= (const SfxStringItem*)rSet.GetItem( WID_CONN_TABLE );
	String aTableList( pTableItem->GetValue());
	if (aTableList.GetToken(0,DEFAULT_LIST_SEPARATOR).EqualsAscii("-1"))	// -1 bedeuted nicht vorhanden s. CommandParser
		bCheckedAll = sal_False;
	else if (aTableList.GetChar(0) == '*')
		CheckAll();
	else
	{
		String aListBoxTable;
		String aTableListTable;
		String aCatalog,aSchema,aName;
		for(xub_StrLen i=0; i<aTableList.GetTokenCount(DEFAULT_LIST_SEPARATOR); i++ )
		{
			aTableListTable = aTableList.GetToken( i, DEFAULT_LIST_SEPARATOR );
			xConnection->QualifiedNameComponents(aTableListTable,aCatalog, aSchema, aName);
			SvLBoxEntry* pCatalog = NULL;
			SvLBoxEntry* pSchema = NULL;
			SvLBoxEntry* pEntry = NULL;
			pCatalog = aTLB_Tables.GetEntryPosByName(aCatalog);
			pSchema = aTLB_Tables.GetEntryPosByName(aSchema,pCatalog);
			pEntry = aTLB_Tables.GetEntryPosByName(aName,pSchema);

			if(pEntry)
				aTLB_Tables.SetCheckButtonState( pEntry,SV_BUTTON_CHECKED );
		}
		aTLB_Tables.CheckButtons();
		bCheckedAll = sal_False;
	}

	//////////////////////////////////////////////////////////////////////
	// AddAll Button Enablen
	if( !aTLB_Tables.GetEntryCount() )
		aPB_AddAll.Enable( sal_False );
	else
		aPB_AddAll.Enable( sal_True );

	if (!((const SfxBoolItem*)rSet.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aTLB_Tables.Disable();
		aFT_TabSubscr.Disable();
		aPB_AddAll.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaTabSubscrPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

//------------------------------------------------------------------------
void SbaTabSubscrPage::CheckAll( sal_Bool bCheck )
{
	SvButtonState eState = bCheck ? SV_BUTTON_CHECKED : SV_BUTTON_UNCHECKED;
	SvLBoxEntry* pEntry = aTLB_Tables.GetModel()->First();
	while(pEntry)
	{
		aTLB_Tables.SetCheckButtonState( pEntry, eState);
		pEntry = aTLB_Tables.GetModel()->Next(pEntry);
	}

	aPB_AddAll.SetText(bCheck ? SbaResId(SBA_STR_NONE) : SbaResId(SBA_STR_ALL));
	bCheckedAll = bCheck;
}

//------------------------------------------------------------------------
int SbaTabSubscrPage::DeactivatePage(SfxItemSet* pSet)
{
	if (pSet)
		FillItemSet(*pSet);
	return 1;
}

//------------------------------------------------------------------------
sal_Bool SbaTabSubscrPage::FillItemSet( SfxItemSet& rCoreAttrs )
{
	/////////////////////////////////////////////////////////////////////////
	// Erzeugen des Output-Strings, in dem die Tabellen zusammmengefasst sind
	String aTableList;
	sal_uInt16 nEntryCount = 0;
	sal_uInt16 nPos=0;

	SvLBoxEntry* pEntry = aTLB_Tables.GetModel()->First();
	while(pEntry)
	{
		if(aTLB_Tables.GetCheckButtonState(pEntry) == SV_BUTTON_CHECKED && !aTLB_Tables.GetModel()->HasChilds(pEntry))
		{
			if(aTLB_Tables.GetModel()->HasParent(pEntry))
			{
				SvLBoxEntry* pSchema = aTLB_Tables.GetModel()->GetParent(pEntry);
				if(aTLB_Tables.GetModel()->HasParent(pSchema))
				{
					SvLBoxEntry* pCatalog = aTLB_Tables.GetModel()->GetParent(pSchema);
					aTableList += aTLB_Tables.GetEntryText( pCatalog );
					aTableList += m_cSeparator;
				}
				aTableList += aTLB_Tables.GetEntryText( pSchema );
				aTableList += '.';
			}
			aTableList += aTLB_Tables.GetEntryText( pEntry );
			aTableList += DEFAULT_LIST_SEPARATOR;
			nPos++;
		}
		if(!aTLB_Tables.GetModel()->HasChilds(pEntry))
			nEntryCount++;
		pEntry = aTLB_Tables.GetModel()->Next(pEntry);
	}
	if(aTableList.Len())
		aTableList.Erase( aTableList.Len()-1, 1 );	// Letzten Delimiter abtrennen
	if(nPos == nEntryCount)
		aTableList = '*';

	//////////////////////////////////////////////////////////////////////
	// String in Output-Itemset schreiben
	rCoreAttrs.Put( SfxStringItem(GetWhich(WID_CONN_TABLE), aTableList) );
	return sal_True;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaTabSubscrPage, AddAllClickHdl, PushButton*, pButton )
{
	CheckAll( !bCheckedAll );

	return 0;
}

//========================================================================
SbaORCL7Page::SbaORCL7Page( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage( pParent, TAB_PAG_ORCL7, rCoreAttrs, CBTP_USE_UIDPWD | CBTP_USE_CHARSET | CBTP_USE_OPTIONS)

	,aFL_1(this, ResId(FL_1))

	,pParentDlg(0)
{
	DBG_CTOR( SbaORCL7Page, NULL );

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaORCL7Page::~SbaORCL7Page()
{
	DBG_DTOR( SbaORCL7Page, NULL );
}


// -----------------------------------------------------------------------
SfxTabPage*	SbaORCL7Page::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaORCL7Page( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaORCL7Page::Reset( const SfxItemSet& rCoreAttrs )
{
}

//========================================================================
SbaDAOPage::SbaDAOPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_DAO, rCoreAttrs, CBTP_USE_UIDPWD)

	,aFL_1(this, ResId(FL_1))
	,aFT_DBPASSWD		(this, ResId(FT_DBPASSWD))
	,aET_DBPASSWD		(this, ResId(ET_DBPASSWD))
	,aFT_SYSTEMDB		(this, ResId(FT_SYSTEMDB))
	,aET_SYSTEMDB		(this, ResId(ET_SYSTEMDB))
	,aPB_SYSTEMDB		(this, ResId(PB_SYSTEMDB))
	,aFT_SYSTEMDB_EXPL	(this, ResId(FT_SYSTEMDB_EXPL))

	,pParentDlg(0)
	,bAttrsChanged( sal_False )
	,bFound(sal_True)
{
	DBG_CTOR( SbaDAOPage, NULL );
	aET_DBPASSWD.SetModifyHdl(LINK(this,SbaDAOPage,AttributesChangedHdl));
	aET_SYSTEMDB.SetModifyHdl(LINK(this,SbaDAOPage,EditLoseFocusHdl));
	aPB_SYSTEMDB.SetClickHdl(LINK(this,SbaDAOPage,PBClickHdl));
	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaDAOPage::~SbaDAOPage()
{
	DBG_DTOR( SbaDAOPage, NULL );
}


// -----------------------------------------------------------------------
SfxTabPage*	SbaDAOPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaDAOPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaDAOPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaDAOPage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);

	const SfxStringItem*	 pCharsetItem	= GET_ATTR(SfxStringItem,WID_CONN_CHARSET);
	const SfxStringItem*	 pDBPasswdItem	= GET_ATTR(SfxStringItem,WID_CONN_DBPASSWD);
	const SfxStringItem*	 pSystemDBItem	= GET_ATTR(SfxStringItem,WID_CONN_SYSTEMDB);

	if (!pSystemDBItem->GetValue().Len())
	{
		String aEmpty;
		pET_USERNAME->SetText(aEmpty);
		pET_PASSWORD->SetText(aEmpty);
		pET_USERNAME->Disable();
		pET_PASSWORD->Disable();
		pFT_USERNAME->Disable();
		pFT_PASSWORD->Disable();
		pCB_ASK_WHEN_EMPTY_PWD->Disable();
	}
	else
	{
		// das Setzen des Textes wurde in SbaCommonBehaviourTabPage::ActivatePage erledigt, also nur noch enablen
		pFT_USERNAME->Enable(sal_True);
		pFT_PASSWORD->Enable(sal_True);
	}

	aET_DBPASSWD.SetText( pDBPasswdItem->GetValue() );
	aET_SYSTEMDB.SetText( pSystemDBItem->GetValue() );

	pET_USERNAME->ClearModifyFlag();
	pET_PASSWORD->ClearModifyFlag();
	aET_DBPASSWD.ClearModifyFlag();
	aET_SYSTEMDB.ClearModifyFlag();

	pET_USERNAME->SaveValue();
	pET_PASSWORD->SaveValue();
	pCB_ASK_WHEN_EMPTY_PWD->SaveValue();
	aET_DBPASSWD.SaveValue();
	aET_SYSTEMDB.SaveValue();

	bAttrsChanged = sal_False;

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		pFT_USERNAME->Disable();
		pET_USERNAME->Disable();
		pFT_PASSWORD->Disable();
		pET_PASSWORD->Disable();
		pCB_ASK_WHEN_EMPTY_PWD->Disable();
		aFT_DBPASSWD.Disable();
		aET_DBPASSWD.Disable();
		aFT_SYSTEMDB.Disable();
		aET_SYSTEMDB.Disable();
		aPB_SYSTEMDB.Disable();
		aFT_SYSTEMDB_EXPL.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaDAOPage::Reset( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaDAOPage, NULL );
}

// -----------------------------------------------------------------------
sal_Bool SbaDAOPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaDAOPage, NULL );

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);
	bChangedSomething = bChangedSomething || bAttrsChanged;

	if ( bAttrsChanged )
	{
		FILL_STRING_ITEM(aET_DBPASSWD, rSet, WID_CONN_DBPASSWD);

		if( aET_SYSTEMDB.GetText() != aET_SYSTEMDB.GetSavedValue() )
		{
			String aSystemDB(aET_SYSTEMDB.GetText());
			SfxAppIniManagerProperty aIniManProp;
			GetpApp()->Property(aIniManProp);
			String aNewDsn(aIniManProp.GetIniManager()->SubstPathVars(aSystemDB));
			DirEntry aEntry(aNewDsn);
			bFound = aEntry.Exists();

			if(!bFound && !aEntry.GetExtension().EqualsIgnoreCaseAscii("mdw"))
			{
				String aError(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN));
				ErrorBox aDlg(NULL,WB_OK, aError);
				aDlg.Execute();
				aET_SYSTEMDB.GrabFocus();
			}
			else
				rSet.Put( SfxStringItem(GetWhich(WID_CONN_SYSTEMDB), aSystemDB ) );
		}

		bAttrsChanged = sal_False;
	}

	return bChangedSomething;
}

//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaDAOPage, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaDAOPage, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaDAOPage, AttributesChangedHdl, void *, EMPTYARG )

//------------------------------------------------------------------------
IMPL_LINK( SbaDAOPage, EditLoseFocusHdl, Control *, pControl )
{
	bAttrsChanged = sal_True;
	// wenn an der SystemDB etwas geaendert wurde,
	// ueberpruefen, ob Eintrag leer
	if (!aET_SYSTEMDB.GetText().Len())
	{
		String aEmpty;
		pET_USERNAME->SetText(aEmpty);
		pET_PASSWORD->SetText(aEmpty);
		pET_USERNAME->Enable(sal_False);
		pET_PASSWORD->Enable(sal_False);
		pFT_USERNAME->Enable(sal_False);
		pFT_PASSWORD->Enable(sal_False);
		pCB_ASK_WHEN_EMPTY_PWD->Enable(sal_False);
		bFound = sal_True;
	}
	else
	{
		pET_USERNAME->Enable(sal_True);
		pET_PASSWORD->Enable(sal_True);
		pFT_USERNAME->Enable(sal_True);
		pFT_PASSWORD->Enable(sal_True);
		pCB_ASK_WHEN_EMPTY_PWD->Enable(sal_True);
	}
	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaDAOPage, PBClickHdl, Button *, pButton )
{
	String sMask; sMask.AssignAscii("*.mdw");
	String sFilter(sMask);
	sFilter += SbaResId(RID_STR_FILES);

	SfxFileDialog* pFileDlg = new SfxFileDialog( this, WB_3DLOOK | WB_STDMODAL); //	new FileDialog( this, nBits );
	pFileDlg->AddFilter(sFilter, sMask);
	pFileDlg->SetCurFilter(sFilter);
	SbaIniWrap aIniWrap;
	pFileDlg->SetStandardDir(aIniWrap.GetDefaultDatabasePath());

	if (pFileDlg->Execute())
	{
		INetURLObject aUrl(pFileDlg->GetPath());
		aET_SYSTEMDB.SetText( aUrl.PathToFileName() );
		pET_USERNAME->Enable(sal_True);
		pET_PASSWORD->Enable(sal_True);
		pFT_USERNAME->Enable(sal_True);
		pFT_PASSWORD->Enable(sal_True);
		pCB_ASK_WHEN_EMPTY_PWD->Enable(sal_True);
		bAttrsChanged = sal_True;
	}
	delete pFileDlg;
	return 0;
}
//========================================================================
SbaADOPage::SbaADOPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_ADO, rCoreAttrs, CBTP_USE_UIDPWD)
	,aFT_PROVIDER		(this, ResId(FT_PROVIDER))
	,aET_PROVIDER		(this, ResId(ET_PROVIDER))
	,pParentDlg(0)
	,bAttrsChanged( sal_False )
	,bFound(sal_True)
{
	DBG_CTOR( SbaADOPage, NULL );
	aET_PROVIDER.SetModifyHdl(LINK(this,SbaADOPage,AttributesChangedHdl));
	aET_PROVIDER.SetModifyHdl(LINK(this,SbaADOPage,EditLoseFocusHdl));

	pET_USERNAME->SetZOrder(&aET_PROVIDER, WINDOW_ZORDER_BEHIND);
	pET_PASSWORD->SetZOrder(pET_USERNAME, WINDOW_ZORDER_BEHIND);
	pCB_ASK_WHEN_EMPTY_PWD->SetZOrder(pET_PASSWORD, WINDOW_ZORDER_BEHIND);

	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaADOPage::~SbaADOPage()
{
	DBG_DTOR( SbaADOPage, NULL );
}


// -----------------------------------------------------------------------
SfxTabPage*	SbaADOPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaADOPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaADOPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaADOPage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);

	const SfxStringItem*	 pCharsetItem	= GET_ATTR(SfxStringItem,WID_CONN_CHARSET);
	const SfxStringItem*	 pProviderItem	= GET_ATTR(SfxStringItem,WID_CONN_PROVIDER);

	aET_PROVIDER.SetText( pProviderItem->GetValue() );

	pET_USERNAME->ClearModifyFlag();
	pET_PASSWORD->ClearModifyFlag();
	aET_PROVIDER.ClearModifyFlag();

	pET_USERNAME->SaveValue();
	pET_PASSWORD->SaveValue();
	pCB_ASK_WHEN_EMPTY_PWD->SaveValue();
	aET_PROVIDER.SaveValue();

	bAttrsChanged = sal_False;

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		pFT_USERNAME->Disable();
		pET_USERNAME->Disable();
		pFT_PASSWORD->Disable();
		pET_PASSWORD->Disable();
		pCB_ASK_WHEN_EMPTY_PWD->Disable();
		aFT_PROVIDER.Disable();
		aET_PROVIDER.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaADOPage::Reset( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaADOPage, NULL );
}

// -----------------------------------------------------------------------
sal_Bool SbaADOPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaADOPage, NULL );

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);
	bChangedSomething = bChangedSomething || bAttrsChanged;

	if ( bAttrsChanged )
	{
		FILL_STRING_ITEM(aET_PROVIDER, rSet, WID_CONN_PROVIDER);

		bAttrsChanged = sal_False;
	}

	return bChangedSomething;
}

//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaADOPage, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaADOPage, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaADOPage, AttributesChangedHdl, void *, EMPTYARG )

//------------------------------------------------------------------------
IMPL_LINK( SbaADOPage, EditLoseFocusHdl, Control *, pControl )
{
	bAttrsChanged = sal_True;
	// wenn an der SystemDB etwas geaendert wurde,
	// ueberpruefen, ob Eintrag leer
	pET_USERNAME->Enable(sal_True);
	pET_PASSWORD->Enable(sal_True);
	pFT_USERNAME->Enable(sal_True);
	pFT_PASSWORD->Enable(sal_True);
	pCB_ASK_WHEN_EMPTY_PWD->Enable(sal_True);
	bAttrsChanged = sal_True;
	if(aET_PROVIDER.GetText().Len())
		pParentDlg->GetOKButton().Enable(sal_True);
	else
		pParentDlg->GetOKButton().Enable(sal_False);
	return 0;
}

//========================================================================
SbaJdbcPage::SbaJdbcPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_JDBC, rCoreAttrs, CBTP_USE_UIDPWD | CBTP_USE_CHARSET)

	,aFT_JDBCDRV	(this, ResId(FT_JDBCDRV))
	,aET_JDBCDRV	(this, ResId(ET_JDBCDRV))
	,aFT_URL		(this, ResId(FT_URL))
	,aET_URL		(this, ResId(ET_URL))
	,aFL_1			(this, ResId(FL_1))

	,pParentDlg(0)
	,bAttrsChanged( sal_False )
{
	DBG_CTOR( SbaJdbcPage, NULL );

	aET_JDBCDRV.SetModifyHdl(LINK(this,SbaJdbcPage,EditLoseFocusHdl));
	aET_URL.SetModifyHdl(LINK(this,SbaJdbcPage,EditLoseFocusHdl));

	SetExchangeSupport(sal_True);

	pET_USERNAME->SetZOrder(&aET_URL, WINDOW_ZORDER_BEHIND);
	pET_PASSWORD->SetZOrder(pET_USERNAME, WINDOW_ZORDER_BEHIND);
	pCB_ASK_WHEN_EMPTY_PWD->SetZOrder(pET_PASSWORD, WINDOW_ZORDER_BEHIND);
	pLB_CHARSET->SetZOrder(pCB_ASK_WHEN_EMPTY_PWD, WINDOW_ZORDER_BEHIND);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaJdbcPage::~SbaJdbcPage()
{
	DBG_DTOR( SbaJdbcPage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaJdbcPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaJdbcPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaJdbcPage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaJdbcPage, NULL );

	SbaCommonBehaviourTabPage::ActivatePage(rCoreAttrs);

	const SfxStringItem*	 pJdbcDrvItem	= GET_ATTR(SfxStringItem,WID_CONN_JDBCDRV);
	const SfxStringItem*	 pUrlItem		= GET_ATTR(SfxStringItem,WID_CONN_URL);

	aET_JDBCDRV.SetText(	 pJdbcDrvItem->GetValue() );
	aET_URL.SetText(		 pUrlItem->GetValue() );

	aET_JDBCDRV.ClearModifyFlag();
	aET_URL.ClearModifyFlag();

	aET_JDBCDRV.SaveValue();
	aET_URL.SaveValue();

	bAttrsChanged = sal_False;

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aFT_JDBCDRV.Disable();
		aET_JDBCDRV.Disable();
		aFT_URL.Disable();
		aET_URL.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaJdbcPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
sal_Bool SbaJdbcPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS(SbaJdbcPage, NULL);

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);
	bChangedSomething = bChangedSomething || bAttrsChanged;

	if (bAttrsChanged)
	{
		FILL_STRING_ITEM(aET_JDBCDRV, rSet, WID_CONN_JDBCDRV);
		FILL_STRING_ITEM(aET_URL, rSet, WID_CONN_URL);

		bAttrsChanged = sal_False;
	}

	return bChangedSomething;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaJdbcPage, EditLoseFocusHdl, Control *, pControl )
{
	bAttrsChanged = sal_True;
	if(aET_JDBCDRV.GetText().Len() && aET_URL.GetText().Len())
		pParentDlg->GetOKButton().Enable(sal_True);
	else
		pParentDlg->GetOKButton().Enable(sal_False);
	return 0;
}
//========================================================================
SbaOTERPage::SbaOTERPage( Window* pParent, const SfxItemSet& rCoreAttrs )
	:SbaCommonBehaviourTabPage(pParent, TAB_PAG_OTER, rCoreAttrs, CBTP_USE_UIDPWD)

	,pParentDlg(0)
{
	DBG_CTOR( SbaOTERPage, NULL );

	SetExchangeSupport(sal_True);
	FreeResource();
}

// -----------------------------------------------------------------------
SbaOTERPage::~SbaOTERPage()
{
	DBG_DTOR( SbaOTERPage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaOTERPage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaOTERPage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaOTERPage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
sal_Bool SbaOTERPage::FillItemSet( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaOTERPage, NULL );

	sal_Bool bChangedSomething = SbaCommonBehaviourTabPage::FillItemSet(rSet);

	// wenn kein ::com::sun::star::sdbcx::User-Name, dann auch das Passwort ruecksetzen
//	const SfxStringItem* pUserId = (const SfxStringItem*)&(rSet.Get(WID_CONN_USER_ID));
//	if (!pUserId->GetValue().Len())
//	{
//		rSet.Put(SfxStringItem(GetWhich(WID_CONN_USER_PWD), String()));
//		bChangedSomething = sal_True;
//	}

	return bChangedSomething;
}

//========================================================================
SbaStarBasePage::SbaStarBasePage( Window* pParent, const SfxItemSet& rCoreAttrs ):
	SfxTabPage( pParent, SbaResId( TAB_PAG_STARBASE_ADMIN ), rCoreAttrs ),

	aGB_PWD(		this, ResId( GB_PWD					) ),
	aGB_ATT(		this, ResId( GB_ATTRIBUTES			) ),
	aPB_PWD(		this, ResId( PB_PWD					) ),
	aFT_USERNAME(	this, ResId( FT_USERNAME			) ),
	aET_USERNAME(	this, ResId( ET_USERNAME			) ),
	aFT_PASSWORD(	this, ResId( FT_PASSWORD			) ),
	aET_PASSWORD(	this, ResId( ET_PASSWORD			) ),
	aFT_CONFIRM(	this, ResId( FT_PASSWORD_CONFIRM	) ),
	aET_CONFIRM(	this, ResId( ET_PASSWORD_CONFIRM	) ),
	aCB_MULTI_USER(	this, ResId( CB_MULTI_USER			) ),
	aCB_TRANSACT(	this, ResId( CB_TRANSACT			) ),
	m_PB_CONVERT(	this, ResId( PB_CONVERT				) ),
	pParentDlg(0),
	bAttrsChanged( sal_False ),
	aTxt1(ResId(ST_PWD_SET)),
	aTxt2(ResId(ST_PWD_CHANGE))
{
	DBG_CTOR( SbaStarBasePage, NULL );
	aET_USERNAME.SetModifyHdl(	LINK(this,SbaStarBasePage,AttributesChangedHdl));
	aET_USERNAME.SetLoseFocusHdl(	LINK(this,SbaStarBasePage,LoseFocusHdl));
	aET_USERNAME.SetMaxTextLen(18);
	aET_PASSWORD.SetMaxTextLen(18);
	aET_CONFIRM.SetMaxTextLen(18);
	aFT_USERNAME.Disable();
	aFT_PASSWORD.Disable();
	aFT_CONFIRM.Disable();
	aPB_PWD.SetClickHdl(		LINK(this,SbaStarBasePage,CbClickPWD_ON_Hdl));
	aCB_MULTI_USER.SetClickHdl(	LINK(this,SbaStarBasePage,AttributesChangedHdl));
	aCB_TRANSACT.SetClickHdl(	LINK(this,SbaStarBasePage,AttributesChangedHdl));
	m_PB_CONVERT.SetClickHdl(	LINK(this,SbaStarBasePage,ConvertHdl));

	if(!getenv("DBCONFIG"))
		m_PB_CONVERT.Hide();
		

	SetExchangeSupport(sal_True);

	FreeResource();
}

// -----------------------------------------------------------------------
SbaStarBasePage::~SbaStarBasePage()
{
	DBG_DTOR( SbaStarBasePage, NULL );
}

// -----------------------------------------------------------------------
SfxTabPage*	SbaStarBasePage::Create( Window* pParent,	const SfxItemSet& rAttrSet )
{
	return ( new SbaStarBasePage( pParent, rAttrSet ) );
}

// -----------------------------------------------------------------------
void SbaStarBasePage::ActivatePage( const SfxItemSet& rCoreAttrs )
{
	DBG_CHKTHIS( SbaStarBasePage, NULL );

	const SfxStringItem*	pDsnItem		= GET_ATTR(SfxStringItem,WID_CONN_DSN);
	const SfxStringItem*	pUidItem		= GET_ATTR(SfxStringItem,WID_CONN_ADMIN_ID);
	const SfxStringItem*	pPwdItem		= GET_ATTR(SfxStringItem,WID_CONN_ORIG_ADMIN_PWD);
	aPwd = pPwdItem->GetValue();

	const SfxBoolItem*	pMultiUserOnItem	= GET_ATTR(SfxBoolItem,WID_CONN_MULTI_USER_ON);
	const SfxBoolItem*	pTransactOnItem		= GET_ATTR(SfxBoolItem,WID_CONN_TRANSACT);
	const SfxBoolItem*	pDbNewItem			= GET_ATTR(SfxBoolItem,WID_CONN_DBNEW);

	const SfxStringItem* pFileItem			= GET_ATTR(SfxStringItem,WID_CONN_FILENAME);
	m_aFileName = pFileItem->GetValue();

	if(pDbNewItem->GetValue() || !pUidItem->GetValue().Len())
		aPB_PWD.SetText(aTxt1);
	else
	{
		aPB_PWD.SetText(aTxt2);
	}

	if (aPB_PWD.IsEnabled())	// ich habe den aendern-Button noch nicht benutzt ...
	{
		aET_PASSWORD.SetText(aPwd);
		aET_CONFIRM.SetText(aPwd);

		aET_PASSWORD.SaveValue();
		aET_CONFIRM.SaveValue();

		aET_PASSWORD.Disable();
		aET_CONFIRM.Disable();
		aET_USERNAME.Disable();
		aFT_USERNAME.Disable();
		aFT_PASSWORD.Disable();
		aFT_CONFIRM.Disable();
	}

	aET_USERNAME.SetText(pUidItem->GetValue() );
	aET_USERNAME.ClearModifyFlag();
	aET_USERNAME.SaveValue();

	aCB_MULTI_USER.Check(!pMultiUserOnItem->GetValue());
	aCB_TRANSACT.Check(pTransactOnItem->GetValue());
	bAttrsChanged = sal_False;

	if (!((const SfxBoolItem*)rCoreAttrs.GetItem(WID_CONN_MODIFY))->GetValue())
	{
		aPB_PWD.Disable();
		aFT_USERNAME.Disable();
		aET_USERNAME.Disable();
		aFT_PASSWORD.Disable();
		aET_PASSWORD.Disable();
		aFT_CONFIRM.Disable();
		aET_CONFIRM.Disable();
		aCB_MULTI_USER.Disable();
		aCB_TRANSACT.Disable();
	}
}

// -----------------------------------------------------------------------
void SbaStarBasePage::Reset( const SfxItemSet& rCoreAttrs )
{
}

// -----------------------------------------------------------------------
int SbaStarBasePage::DeactivatePage(SfxItemSet* pSet)
{
	DBG_CHKTHIS( SbaStarBasePage, NULL );
	String aPWD(aET_PASSWORD.GetText());
	String aCON(aET_CONFIRM.GetText());

	if (aET_USERNAME.IsEnabled() && aET_USERNAME.GetText().Len())
		// wenn die Controls zur Passworteingabe aktiv sind und es einen Benutzernamen gibt, Test auf Mindestlaenge
		if (aPWD.Len() < 3)
		{
			ErrorBox(NULL, WB_OK, String(SbaResId(SBA_STR_NEED_3_CHARS))).Execute();
			aET_PASSWORD.GrabFocus();
			return 0;
		}
	if (!aPWD.Equals(aCON))
	{
		ErrorBox(this,SbaResId(ERR_PWD_CONFIRM)).Execute();
		aET_PASSWORD.GrabFocus();
		return 0;
	}
	if (pSet)
		FillItemSet(*pSet);
	aOldPwd.Erase();
	return 1;
}

// -----------------------------------------------------------------------
sal_Bool SbaStarBasePage::FillItemSet(SfxItemSet& rSet)
{
	DBG_CHKTHIS(SbaStarBasePage, NULL);

	sal_Bool bReturn(bAttrsChanged);

	if (bAttrsChanged)
	{

		if (aET_USERNAME.GetText() != aET_USERNAME.GetSavedValue())
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_NEW_ADMIN_ID), aET_USERNAME.GetText()));

		if (aET_PASSWORD.GetText() != aET_PASSWORD.GetSavedValue())
			rSet.Put(SfxStringItem(GetWhich(WID_CONN_NEW_ADMIN_PWD), aET_PASSWORD.GetText()));

		rSet.Put( SfxBoolItem(GetWhich(WID_CONN_MULTI_USER_ON)	, !aCB_MULTI_USER.IsChecked() ) );
		rSet.Put( SfxBoolItem(GetWhich(WID_CONN_TRANSACT)		, aCB_TRANSACT.IsChecked() ) );

		bAttrsChanged = sal_False;
	}

	return bReturn;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaStarBasePage, LoseFocusHdl,Control *, pControl)
{
	DBG_CHKTHIS( SbaStarBasePage, NULL );
	if (pControl == &aET_USERNAME)
	{
		if (!aET_USERNAME.GetText().Len())
		{
			String sEmpty;
			aET_PASSWORD.SetText(sEmpty);
			aET_CONFIRM.SetText(sEmpty);
		}
	}
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaStarBasePage, ConvertHdl,Button*,pButton)
{
	SBA_MOD_EXT()->ExecuteConvert(m_aFileName,sal_False);
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaStarBasePage, CbClickPWD_ON_Hdl,Button*,pButton)
{
	DBG_CHKTHIS( SbaStarBasePage, NULL );
	bAttrsChanged = sal_True;

	sal_Bool bSuccess = sal_True;
	if(aTxt2.Equals(aPB_PWD.GetText()) && !aOldPwd.Len())
	{
		// ab hier wird ein bereits vorhandenes PWd geaendert
		SfxPasswordDialog	aDlg(this);
		aDlg.SetMinLen(3);
		if(aDlg.Execute())
		{
			aOldPwd = aDlg.GetPassword();
			bSuccess = (aPwd.Equals(aOldPwd));
			if (!bSuccess)
			{
				aOldPwd.Erase();
				ErrorBox(this,SbaResId(ERR_WRONG_PWD)).Execute();
			}
		} else
			bSuccess = sal_False;
	}

	if (bSuccess)
	{
		aET_USERNAME.Enable();
		aET_PASSWORD.Enable();
		aET_CONFIRM.Enable();
		aFT_USERNAME.Enable();
		aFT_PASSWORD.Enable();
		aFT_CONFIRM.Enable();

		aPB_PWD.Disable();
		aET_USERNAME.GrabFocus();
	}
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK_INLINE_START( SbaStarBasePage, AttributesChangedHdl, void *, EMPTYARG )
{
	DBG_CHKTHIS( SbaStarBasePage, NULL );

	bAttrsChanged = sal_True;
	return 0;
}
IMPL_LINK_INLINE_END( SbaStarBasePage, AttributesChangedHdl, void *, EMPTYARG )

