#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 15:17:20 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..

PRJNAME=sal
.IF "$(WORK_STAMP)"=="MIX364"
TARGET=cppsal
.ELSE
TARGET=cpposl
.ENDIF
USE_LDUMP2=TRUE

PROJECTPCH4DLL=TRUE
PROJECTPCH=cont_pch
PROJECTPCHSOURCE=cont_pch

TARGETTYPE=CUI

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

START_SCRIPT = sdaemon.sh

SLOFILES=   $(SLO)$/conditn.obj  \
			$(SLO)$/diagnose.obj \
			$(SLO)$/semaphor.obj \
			$(SLO)$/socket.obj   \
			$(SLO)$/interlck.obj \
			$(SLO)$/mutex.obj    \
			$(SLO)$/thread.obj   \
			$(SLO)$/module.obj   \
			$(SLO)$/process.obj  \
			$(SLO)$/security.obj \
			$(SLO)$/profile.obj  \
			$(SLO)$/time.obj     \
			$(SLO)$/daemon.obj   \
			$(SLO)$/file.obj     \
			$(SLO)$/signal.obj   \
			$(SLO)$/pipe.obj   	 \
			$(SLO)$/system.obj	 \
			$(SLO)$/channel.obj	 \
			$(SLO)$/util.obj	 \
			$(SLO)$/ports.obj

#.IF "$(UPDATER)"=="YES"
OBJFILES=   $(OBJ)$/conditn.obj  \
			$(OBJ)$/diagnose.obj \
			$(OBJ)$/semaphor.obj \
			$(OBJ)$/socket.obj   \
			$(OBJ)$/interlck.obj \
			$(OBJ)$/mutex.obj    \
			$(OBJ)$/thread.obj   \
			$(OBJ)$/module.obj   \
			$(OBJ)$/process.obj  \
			$(OBJ)$/security.obj \
			$(OBJ)$/profile.obj  \
			$(OBJ)$/time.obj     \
			$(OBJ)$/daemon.obj   \
			$(OBJ)$/file.obj     \
			$(OBJ)$/signal.obj   \
			$(OBJ)$/pipe.obj   	 \
			$(OBJ)$/system.obj	 \
			$(OBJ)$/channel.obj	 \
			$(OBJ)$/util.obj	 \
			$(OBJ)$/ports.obj
#.ENDIF

DEPOBJFILES = $(OBJ)$/sdaemon.obj

# --- Targets ------------------------------------------------------

.IF "$(COM)"=="C50"
APP1STDLIBS+=-lC
.ENDIF

ALL: \
	ALLTAR \
	$(BIN)$/$(START_SCRIPT) 

.INCLUDE :  target.mk


$(BIN)$/$(START_SCRIPT): $(START_SCRIPT)
	@+$(COPY) $(START_SCRIPT) $@
	@+echo $(START_SCRIPT) copied

