/*************************************************************************
 *
 *  $RCSfile: dataobj3.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:44:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
//#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
//#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
//#define _SV_MULTISEL_HXX

//SV
//#define _CLIP_HXX ***
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
#define _SELENG_HXX
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX
//#define _TOOLBOX_HXX
#define _STATUS_HXX
#define _SVTCTRL3_HXX
//#define _DIALOG_HXX
#define _MSGBOX_HXX
//#define _SYSDLG_HXX ***
#define _FILDLG_HXX
//#define _PRNDLG_HXX ***
#define _COLDLG_HXX
#define _TABDLG_HXX
#define _MENU_HXX
//#define _GDIMTF_HXX ***
//#define _POLY_HXX ***
#define _ACCEL_HXX //*
//#define _GRAPH_HXX ***
#define _SOUND_HXX

#if defined  WIN
#define _MENUBTN_HXX
#endif

//svtools
#define _SCRWIN_HXX
#define _RULER_HXX
#define _TABBAR_HXX
#define _VALUESET_HXX
#define _STDMENU_HXX
#define _STDCTRL_HXX
#define _CTRLBOX_HXX
#define _CTRLTOOL_HXX
#define _EXTATTR_HXX
#define _FRM3D_HXX
#define _EXTATTR_HXX

//SVTOOLS
#define _SVTREELIST_HXX
#define _FILTER_HXX
#define _SVLBOXITM_HXX
#define _SVTREEBOX_HXX
#define _SVICNVW_HXX
#define _SVTABBX_HXX

//sfxcore.hxx
#define _SFXINIMGR_HXX
//#define _SFXCFGITEM_HXX ***
//#define _SFX_PRINTER_HXX ***
#define _SFXGENLINK_HXX
#define _SFXHINTPOST_HXX
#define _SFXDOCINF_HXX
#define _SFXLINKHDL_HXX
//#define _SFX_PROGRESS_HXX ***

//sfxsh.hxx
//#define _SFX_SHELL_HXX ***
//#define _SFXAPP_HXX ***
#define _SFX_BINDINGS_HXX
#define _SFXDISPATCH_HXX
//#define _SFXMSG_HXX ***
#define _SFXOBJFACE_HXX
#define _SFXREQUEST_HXX
#define _SFXMACRO_HXX
// SFX
#define _SFXAPPWIN_HXX
#define _SFX_SAVEOPT_HXX
//#define _SFX_CHILDWIN_HXX
#define _SFXCTRLITEM_HXX
#define _SFXPRNMON_HXX
#define _INTRO_HXX
#define _SFXMSGDESCR_HXX
#define _SFXMSGPOOL_HXX
#define _SFXFILEDLG_HXX
#define _PASSWD_HXX
#define _SFXTBXCTRL_HXX
#define _SFXSTBITEM_HXX
#define _SFXMNUITEM_HXX
#define _SFXIMGMGR_HXX
#define _SFXTBXMGR_HXX
#define _SFXSTBMGR_HXX
#define _SFX_MINFITEM_HXX
#define _SFXEVENT_HXX

//sfxdoc.hxx
//#define _SFX_OBJSH_HXX ***
//#define _SFX_CLIENTSH_HXX ***
#define _SFXDOCINF_HXX
//#define _SFX_OBJFAC_HXX ***
#define _SFX_DOCFILT_HXX
//#define _SFXDOCFILE_HXX ***
//define _VIEWFAC_HXX ***
#define _SFXVIEWFRM_HXX
//#define _SFXVIEWSH_HXX ***
#define _MDIFRM_HXX
#define _SFX_IPFRM_HXX
//#define _SFX_INTERNO_HXX ***

//inet
#define _INETINDP_HXX
#define _INETIMP_HXX
#define _INETWRAP_HXX
#define _INETKEEP_HXX
#define _PLUGMGR_HXX
#define _URLOBJ_HXX


//sfxdlg.hxx
//#define _SFXTABDLG_HXX ***
#define _BASEDLGS_HXX
#define _SFX_DINFDLG_HXX
#define _SFXDINFEDT_HXX
#define _SFX_MGETEMPL_HXX
#define _SFX_TPLPITEM_HXX
#define _SFX_STYLEDLG_HXX
#define _NEWSTYLE_HXX
#define _SFXDOCTEMPL_HXX
#define _SFXDOCTDLG_HXX
#define _SFX_TEMPLDLG_HXX
#define _SFXNEW_HXX
#define _SFXDOCMAN_HXX
//#define _SFXDOCKWIN_HXX

//sfxitems.hxx
#define _SFX_WHMAP_HXX
#define _ARGS_HXX
//#define _SFXPOOLITEM_HXX ***
//#define _SFXINTITEM_HXX ***
//#define _SFXENUMITEM_HXX ***
#define _SFXFLAGITEM_HXX
//#define _SFXSTRITEM_HXX ***
#define _SFXPTITEM_HXX
#define _SFXRECTITEM_HXX
//#define _SFXITEMPOOL_HXX ***
//#define _SFXITEMSET_HXX ***
#define _SFXITEMITER_HXX
#define _SFX_WHITER_HXX
#define _SFXPOOLCACH_HXX
#define _AEITEM_HXX
#define _SFXRNGITEM_HXX
//#define _SFXSLSTITM_HXX ***
//#define _SFXSTYLE_HXX ***

//xout.hxx
//#define _XENUM_HXX ***
//#define _XPOLY_HXX ***
//#define _XATTR_HXX ***
//#define _XOUTX_HXX ***
//#define _XPOOL_HXX ***
#define _XTABLE_HXX

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SVDDRAG_HXX ***	// SdrDragStat (nur intern)
//#define _SVDPAGE_HXX ***	// SdrPage
#define _SVDSURO_HXX		// SdrObjSurrogate
#define _SVDOPAGE_HXX		// SdrPageObj
#define _SVDOVIRT_HXX		// SdrVirtObj
#define _SVDOGRP_HXX		// SdrGroupObj
//#define _SVDOTEXT_HXX ***	// SdrTextObj
#define _SVDOPATH_HXX		// SdrPathObj
//#define _SVDOEDGE_HXX		// SdrEdgeObj
//#define _SVDORECT_HXX ***	// SdrRectObj (+SdrTextObj)
#define _SVDCAPT_HXX		// SdrCaptionObj
#define _SVDOCIRC_HXX		// SdrCircleObj
//#define _SVDOGRAF_HXX ***	// SdrGrafObj (+SdrRectObj)
//#define _SVDOOLE2_HXX	***	// SdrOle2Obj (+SdrRectObj)
//#define _SDR_NOOBJECTS ***
//#define _SDR_NOVIEWS ***

//#define SI_NOITEMS ***
//#define SI_NODRW ***
//#define _VCATTR_HXX ***
//#define _VCONT_HXX
//#define _VCSBX_HXX ***
#define SI_NOOTHERFORMS
//#define _VCTRLS_HXX ***
//#define _VCDRWOBJ_HXX ***
#define SI_NOCONTROL
#define _SETBRW_HXX
#define _VCBRW_HXX
#define SI_NOSBXCONTROLS
#define _SIDLL_HXX

#define SFX_NOCLOOKS

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

class SbxArray;

#ifndef PCH
#include <segmentc.hxx>
#endif

// INCLUDE ---------------------------------------------------------------

#include <svx/svdpage.hxx>
#include <svx/svditer.hxx>
#include <svx/svdmodel.hxx>
#include <svx/svdograf.hxx>
#include <svx/svdxcgv.hxx>

#include <svtools/intitem.hxx>
#include <svtools/urlbmk.hxx>
#include <svtools/zforlist.hxx>

#include <sot/formats.hxx>

#include "document.hxx"
#include "dataobj.hxx"
#include "docsh.hxx"
#include "viewdata.hxx"
#include "printfun.hxx"
#include "cell.hxx"
#include "impex.hxx"

#include "scitems.hxx"
#include "dociter.hxx"

#include <svx/algitem.hxx>

SEG_EOFGLOBALS()

#pragma SEG_FUNCDEF(dataobj3_01)

void lcl_PaintToDev( OutputDevice* pDev, ScDocument* pDoc, double nPrintFactor,
							const ScRange& rBlock, BOOL bMetaFile )
{
	if (!pDoc)
		return;

#ifdef GCC
	static Point aDefaultPoint;
	Rectangle aBound( aDefaultPoint, pDev->GetOutputSize() ); 		//! Groesse aus Clip-Bereich
#else
	Rectangle aBound( Point(), pDev->GetOutputSize() ); 		//! Groesse aus Clip-Bereich
#endif

	ScViewData aViewData(NULL,NULL);
	aViewData.InitData( pDoc );

	aViewData.SetTabNo( rBlock.aEnd.Tab() );
	aViewData.SetScreen( rBlock.aStart.Col(), rBlock.aStart.Row(),
							rBlock.aEnd.Col(), rBlock.aEnd.Row() );

//	aBound = Rectangle( Point(), aViewData.GetScrSize() );

	ScPrintFunc::DrawToDev( pDoc, pDev, nPrintFactor, aBound, &aViewData, bMetaFile );
}



#pragma SEG_FUNCDEF(dataobj3_02)

BOOL __EXPORT ScDataObject::GetData( SvData* pData )
{
	if (!GetTypeList().Get(*pData))
		return FALSE;

	BOOL bOK = FALSE;
	ULONG nFormat = pData->GetFormat();

	if ( pBookmark && pBookmark->SetData( *pData ) )
		return TRUE;

	if ( nFormat && nFormat == nSdrFormat )
	{
		//	SvDraw (Zeichenobjekte zwischen Office-Applikationen)

		if (bDrawOnly)
		{
			pDrawModel->SetStreamingSdrModel(TRUE);
			SvMemoryStream aStream(4096,4096);
			aStream.SetVersion(SOFFICE_FILEFORMAT_NOW);
			pDrawModel->GetItemPool().Store(aStream);
			aStream << *pDrawModel;
			pData->SetData( (void*) aStream.GetData(), aStream.GetSize() );
			pDrawModel->SetStreamingSdrModel(FALSE);
			return TRUE;
		}
	}

	if ( nFormat && nFormat == nGraphicFormat )
	{
		//	kann dann nur einzelnes Grafikobjekt sein

		if (bDrawOnly)
		{
			SdrPage* pPage = pDrawModel->GetPage(0);
			if (pPage)
			{
				SdrObjListIter aIter( *pPage, IM_FLAT );
				SdrObject* pObject = aIter.Next();
				if (pObject && pObject->GetObjIdentifier() == OBJ_GRAF)
				{
					SdrGrafObj* pGraphObj = (SdrGrafObj*) pObject;
					const Graphic* pGraphic = &pGraphObj->GetGraphic();
					pData->SetData( (SvDataCopyStream*) pGraphic );
					return TRUE;
				}
			}
		}
	}

	if ( nFormat == FORMAT_GDIMETAFILE || nFormat == FORMAT_BITMAP )
	{
		if (bDrawOnly)
		{
			SdrExchangeView aView(pDrawModel);
			Point aPos;
			SdrPageView* pPv = aView.ShowPagePgNum(0,aPos);
			DBG_ASSERT(pPv,"pPv nicht da...");
			aView.MarkAll(pPv);
			if (nFormat == FORMAT_GDIMETAFILE)
			{
				//	TRUE = einzelne Grafik direkt uebernehmen
				GDIMetaFile aMtf = aView.GetAllMarkedMetaFile(TRUE);
				pData->SetData(&aMtf);
			}
			else	// FORMAT_BITMAP
			{
				Bitmap aBmp = aView.GetAllMarkedBitmap(TRUE);
				pData->SetData(&aBmp);
			}
			return TRUE;
		}
	}


/*	if (nFormat == FORMAT_GDIMETAFILE)
	{
		VirtualDevice aVirtDev;
		aVirtDev.SetOutputSizePixel( aVirtDev.LogicToPixel( GetSizeTwips(), MAP_TWIP ) );
		GDIMetaFile* pMtf = new GDIMetaFile;
		pMtf->Record( &aVirtDev );

		//! 	nPrintFactor ohne DocShell berechnen ?

		lcl_PaintToDev( &aVirtDev, pDoc, 1.0, aBlock, TRUE );
		aVirtDev.SetMapMode( MapMode( MAP_100TH_MM ) );

		pMtf->Stop();
		pMtf->SetPrefSize( aVirtDev.GetOutputSize() );
		pMtf->SetPrefMapMode( MAP_100TH_MM );
		pData->SetData(pMtf);

		delete pMtf;
		bOK = TRUE;
	}
	else
*/
	if (nFormat == FORMAT_BITMAP)
	{
		if (bDrawOnly)
		{
			SdrExchangeView aView(pDrawModel);
			Point aPos;
			SdrPageView* pPv = aView.ShowPagePgNum(0,aPos);
			DBG_ASSERT(pPv,"pPv nicht da...");
			aView.MarkAll(pPv);
			Bitmap aBmp = aView.GetAllMarkedBitmap();
			pData->SetData(&aBmp);
			bOK = TRUE;
		}
		else
		{
			VirtualDevice aVirtDev;
			aVirtDev.SetOutputSizePixel( aVirtDev.LogicToPixel( GetSizeTwips(), MAP_TWIP ) );
			lcl_PaintToDev( &aVirtDev, pDoc, 1.0, aBlock, FALSE );
			aVirtDev.SetMapMode( MapMode( MAP_PIXEL ) );

			Bitmap aBmp = aVirtDev.GetBitmap( Point(), aVirtDev.GetOutputSize() );
			pData->SetData(&aBmp);
			bOK = TRUE;
		}
	}
	else if( pDoc && ScImportExport::IsFormatSupported( nFormat ) )
	{
		ScImportExport aObj( pDoc, aBlock );
		aObj.SetFormulas( pDoc->GetViewOptions().GetOption( VOPT_FORMULAS ) );
		bOK = aObj.ExportData( *pData );
	}
	else if ( pDoc && nFormat == FORMAT_RTF && aBlock.aStart != aBlock.aEnd )
	{	// RTF mit mehreren Zellen
		ScImportExport aObj( pDoc, aBlock );
//		aObj.SetFormulas( pDoc->GetViewOptions().GetOption( VOPT_FORMULAS ) );
		bOK = aObj.ExportData( *pData );
	}
	else if ( pDoc && (nFormat == FORMAT_RTF || ( nFormat == nEditFormat && nEditFormat != 0 )) )
	{
		USHORT nCol = aBlock.aStart.Col();
		USHORT nRow = aBlock.aStart.Row();
		USHORT nTab = aBlock.aStart.Tab();

		const ScPatternAttr* pPattern = pDoc->GetPattern( nCol, nRow, nTab );
		ScTabEditEngine aEngine( *pPattern, pDoc->GetEditPool() );
		ScBaseCell* pCell = NULL;
		pDoc->GetCell( nCol, nRow, nTab, pCell );
		if (pCell)
		{
			if (pCell->GetCellType() == CELLTYPE_EDIT)
			{
				const EditTextObject* pObj;
				((ScEditCell*)pCell)->GetData(pObj);
				aEngine.SetText( *pObj );
			}
			else
			{
				String aText;
				pDoc->GetString( nCol, nRow, nTab, aText );
				aEngine.SetText(aText);
			}
		}

		SvMemoryStream aStream;
		if (nFormat == FORMAT_RTF)
			aEngine.Write( aStream, EE_FORMAT_RTF );
		else
			aEngine.Write( aStream, EE_FORMAT_BIN );
		ULONG nLen = aStream.Tell();

		pData->SetData( (void*) aStream.GetData(), nLen, TRANSFER_COPY );
		bOK = TRUE;
	}
	else if (nFormat == SOT_FORMATSTR_ID_OBJECTDESCRIPTOR ||
			 nFormat == SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR)
	{
		SvMemoryStream aStm;
		aStm << aObjDescriptor;
		pData->SetData( (void*) aStm.GetData(), aStm.GetSize() );
		bOK = TRUE;
	}
	else
	{
		if (bIsOleObj)							// einzelnes Ole-Objekt
		{
			InitOleRef();
			if (aOleRef.Is())
				bOK = aOleRef->GetData( pData );
		}
		else
		{
			GetCalcData( pData );
			if (aDocShellRef.Is())
				bOK = aDocShellRef->GetData( pData );
		}
	}
/*
		if (nFormat == FORMAT_GDIMETAFILE)
		{
			Size aHMMSize = Window::LogicToLogic( GetSizeTwips(), MAP_TWIP, MAP_100TH_MM );
			GDIMetaFile* pMtf = NULL;
			pData->GetData( &pMtf, TRANSFER_REFERENCE );
			pMtf->SetPrefSize( aHMMSize );
			pMtf->SetPrefMapMode( MAP_100TH_MM );
		}
*/

	return (bOK);
}

#pragma SEG_FUNCDEF(dataobj3_03)

//	static
void ScDataObject::StripRefs( ScDocument* pDoc,
					USHORT nStartX, USHORT nStartY, USHORT nEndX, USHORT nEndY,
					ScDocument* pDestDoc, USHORT nSubX, USHORT nSubY )
{
	if (!pDestDoc)
	{
		pDestDoc = pDoc;
		DBG_ASSERT(nSubX==0&&nSubY==0, "Verschieben im Dokument geht nicht");
	}

	//	Im Clipboard koennen die Daten in hinterer Tabelle stehen...

	USHORT nSrcTab = 0;
	while (nSrcTab<MAXTAB && !pDoc->HasTable(nSrcTab))
		++nSrcTab;
	USHORT nDestTab = 0;
	while (nDestTab<MAXTAB && !pDestDoc->HasTable(nDestTab))
		++nDestTab;

	if (!pDoc->HasTable(nSrcTab) || !pDestDoc->HasTable(nDestTab))
	{
		DBG_ERROR("Tabelle nicht da in ScDataObject::StripRefs");
		return;
	}

	SvNumberFormatter* pFormatter = pDoc->GetFormatTable();
	ScTripel aStart, aEnd;

	ScCellIterator aIter( pDoc, nStartX, nStartY, nSrcTab, nEndX, nEndY, nSrcTab );
	ScBaseCell* pCell = aIter.GetFirst();
	while (pCell)
	{
		if (pCell->GetCellType() == CELLTYPE_FORMULA)
		{
			ScFormulaCell* pFCell = (ScFormulaCell*) pCell;
			BOOL bOut = FALSE;
			ScDetectiveRefIter aRefIter( pFCell );
			while ( !bOut && aRefIter.GetNextRef( aStart, aEnd ) )
			{
				if ( aStart.GetTab() != nSrcTab || aEnd.GetTab() != nSrcTab ||
						aStart.GetCol() < nStartX || aEnd.GetCol() > nEndX ||
						aStart.GetRow() < nStartY || aEnd.GetRow() > nEndY )
					bOut = TRUE;
			}
			if (bOut)
			{
				USHORT nCol = aIter.GetCol() - nSubX;
				USHORT nRow = aIter.GetRow() - nSubY;

				ScBaseCell* pNew = 0;
				USHORT nErrCode = pFCell->GetErrCode();
				if (nErrCode)
				{
					pNew = new ScStringCell( ScGlobal::GetErrorString(nErrCode) );
					if ( ((const SvxHorJustifyItem*) pDestDoc->GetAttr(
							nCol,nRow,nDestTab, ATTR_HOR_JUSTIFY))->GetValue() ==
							SVX_HOR_JUSTIFY_STANDARD )
						pDestDoc->ApplyAttr( nCol,nRow,nDestTab,
								SvxHorJustifyItem(SVX_HOR_JUSTIFY_RIGHT, ATTR_HOR_JUSTIFY) );
				}
				else if (pFCell->IsValue())
				{
					double fVal = pFCell->GetValue();
					pNew = new ScValueCell( fVal );
				}
				else
				{
					String aStr;
					pFCell->GetString(aStr);
					pNew = new ScStringCell( aStr );
				}
				pDestDoc->PutCell( nCol,nRow,nDestTab, pNew );

				//	Zahlformate

				ULONG nOldFormat = ((const SfxUInt32Item*)
								pDestDoc->GetAttr(nCol,nRow,nDestTab, ATTR_VALUE_FORMAT))->GetValue();
				if ( (nOldFormat % SV_COUNTRY_LANGUAGE_OFFSET) == 0 )
				{
					ULONG nNewFormat = pFCell->GetStandardFormat( *pFormatter,
						nOldFormat );
					pDestDoc->ApplyAttr( nCol,nRow,nDestTab,
								SfxUInt32Item(ATTR_VALUE_FORMAT, nNewFormat) );
				}
			}
		}
		pCell = aIter.GetNext();
	}
}

/*------------------------------------------------------------------------

	$Log: dataobj3.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:44:53  hr
	initial import
	
	Revision 1.32  2000/09/17 14:08:53  willem.vandorp
	OpenOffice header added.
	
	Revision 1.31  2000/08/31 16:38:17  willem.vandorp
	Header and footer replaced
	
	Revision 1.30  1999/07/30 13:16:42  HR
	#65293#: removed #define _SVDOEDGE_HXX
	

	  Rev 1.29   30 Jul 1999 15:16:42   HR
   #65293#: removed #define _SVDOEDGE_HXX

	  Rev 1.28   10 Jun 1999 19:42:54   NN
   SvxINetBookmark -> INetBookmark

	  Rev 1.27   01 Apr 1999 22:51:32   ER
   #49711# RTF Clipboard Export

	  Rev 1.26   26 Nov 1998 10:06:04   NN
   #59398# Clipboard-IDs umgestellt

	  Rev 1.25   02 Jul 1998 21:06:50   ER
   #43509# EditCells mit EditPool

	  Rev 1.24   29 May 1998 19:36:02   ER
   Standardformat via FormulaCell GetStandardFormat

	  Rev 1.23   05 Dec 1997 20:08:08   ANK
   Includes geaendert

	  Rev 1.22   13 May 1997 18:43:38   ER
   #39880# StandardFormat auch wenn modulo SV_COUNTRY_LANGUAGE_OFFSET == 0

	  Rev 1.21   11 Apr 1997 16:22:08   TRI
   includes

	  Rev 1.20   21 Feb 1997 18:47:44   NN
   SetVersion am Stream fuer SvDraw Clipboard-Format

	  Rev 1.19   10 Jan 1997 17:30:56   ER
   GetErrCode, GetValue non-pascal

	  Rev 1.18   10 Dec 1996 19:39:38   HJS
   ein forward dazu

	  Rev 1.17   01 Nov 1996 06:25:52   MH
   chg: includes, defines

	  Rev 1.16   17 Oct 1996 11:25:26   TRI
   includes geaendert

	  Rev 1.15   01 Oct 1996 21:23:40   NN
   bei Zeichenobjekten auch SvDraw-Model anbieten

	  Rev 1.14   12 Aug 1996 11:33:54   NF
   clooks

	  Rev 1.13   09 Aug 1996 20:33:26   NN
   Svx-Includes aus scitems.hxx raus

	  Rev 1.12   01 Aug 1996 14:20:28   NF
   clooks

	  Rev 1.11   31 Jul 1996 10:37:26   NF
   clooks

	  Rev 1.10   29 Jul 1996 20:58:54   NN
   Block als ScRange

	  Rev 1.9   24 Jun 1996 14:28:30   NN
   einzelnes Grafikobjekt im Graphic-Format (Animation)

	  Rev 1.8   14 Jun 1996 15:07:00   HJS
   defines entfernt

	  Rev 1.7   10 Jun 1996 14:37:22   MH
   del: SFXMSG - define

	  Rev 1.6   03 Jun 1996 15:39:54   NN
   aBlockStart immer Position im Dokument

	  Rev 1.5   23 Apr 1996 18:07:58   NN
   StripRefs: Daten im Clipboard stehen nicht immer in der ersten Tabelle

	  Rev 1.4   11 Apr 1996 15:55:02   NN
   #25777# StripRefs, Bitmap/Metafile aus Drawing immer ueber View

	  Rev 1.3   02 Apr 1996 19:20:48   NF
   define _ACCEL_HXX entfernt

	  Rev 1.2   02 Apr 1996 19:18:16   NF
   define _VCON_HXX entfernt

	  Rev 1.1   02 Apr 1996 11:28:16   NN
   #26662# nEditFormat static Member, weil in dataobj und dataobj3

	  Rev 1.0   20 Mar 1996 12:39:12   NF
   DATAOBJ.CXX augeteilt

	  Rev 1.61   12 Mar 1996 12:14:14   NF
   CLOOKS

	  Rev 1.60   11 Mar 1996 17:32:38   NF
   CLOOKS

	  Rev 1.59   10 Mar 1996 19:09:26   HJS
   ein def zu viel

	  Rev 1.58   10 Mar 1996 18:06:28   NN
   URLs immer absolut exportieren, bei URL keine OLE-Formate

	  Rev 1.57   09 Mar 1996 17:50:36   NF
   CLOOKS

	  Rev 1.56   08 Mar 1996 14:52:14   NN
   Bookmark-Formate

	  Rev 1.55   28 Feb 1996 13:45:24   mk
   GCC

	  Rev 1.53   31 Jan 1996 18:21:06   NN
   #24964# mit RTF immer auch EditEngineFormat anbieten

	  Rev 1.52   29 Jan 1996 17:13:26   NN
   #24848# bei Test auf belegte Daten Blockende nicht vor Start verschieben

	  Rev 1.51   22 Jan 1996 16:25:02   NN
   Null-Abfragen

	  Rev 1.50   16 Jan 1996 17:30:10   NF
   OLE auskommentiert

	  Rev 1.49   16 Jan 1996 17:26:24   NN
   Drag&Drop ohne Markierung: alle Daten

	  Rev 1.48   16 Jan 1996 13:27:44   NN
   auch einzelnes Ole-Objekt moeglich

	  Rev 1.47   12 Dec 1995 18:20:40   NN
   View-Optionen im ctor und bei ImpEx

	  Rev 1.46   04 Dec 1995 13:05:14   NF
   zuviele defines

	  Rev 1.45   18 Nov 1995 11:01:20   MD
   CLOKs entfernt

	  Rev 1.44   17 Nov 1995 20:11:18   TRI
   CLOOKS

	  Rev 1.43   17 Nov 1995 15:44:30   NN
   auskommentierte Funktion raus

	  Rev 1.42   16 Nov 1995 20:39:16   MO
   CLOOK-Split

	  Rev 1.41   13 Nov 1995 17:36:02   NN
   Area bei Bitmap nicht veraendern

	  Rev 1.40   10 Nov 1995 18:35:52   NN
   static -> lcl

	  Rev 1.39   10 Nov 1995 16:57:10   NN
   Seitenformat in DocShell uebernehmen

	  Rev 1.38   08 Nov 1995 13:04:04   MO
   301-Aenderungen

	  Rev 1.37   06 Nov 1995 20:02:32   NN
   InitDrawLayer aufrufen

	  Rev 1.36   25 Oct 1995 16:42:56   MD
   Umstellung auf ScAddress

	  Rev 1.35   18 Oct 1995 11:52:00   NN
   Bitmap und Metafile aus einzelnem Grafikobjekt direkt erzeugen

	  Rev 1.34   17 Oct 1995 16:49:16   NN
   ScGlobal-Clipboardstatus auch bei Draw-Objekt zuruecksetzen

	  Rev 1.33   07 Oct 1995 10:45:56   MD
   Anmelden der CB-Formate ueber ScImportExport

	  Rev 1.32   06 Oct 1995 19:26:52   MD
   Umstellung auf ScImportExport

	  Rev 1.31   04 Oct 1995 12:49:38   NN
   RTF fuer einzelne Zellen

	  Rev 1.30   29 Sep 1995 18:29:56   NN
   DocShell fuer Zeichenobjekte richtig

	  Rev 1.29   28 Sep 1995 10:24:28   NN
   VisArea richtig setzen

	  Rev 1.28   22 Sep 1995 15:00:44   MD
   GetDataHere() ueberladen

	  Rev 1.27   22 Sep 1995 11:14:24   MD
   MEDIUM_MEMORY in GetTyleList()

	  Rev 1.26   18 Sep 1995 19:19:00   MD
   Bug 19385: tatsaechliche Tbl-Groesse wird ins CB uebernommen

	  Rev 1.25   18 Sep 1995 18:39:54   NN
   PrefSize von Metafile nicht mehr nachtraeglich aendern

	  Rev 1.24   11 Sep 1995 16:20:54   MD
   Ableitung geaendert: von ScDataMemberObject

	  Rev 1.23   28 Jul 1995 14:52:12   HJS
   clook

	  Rev 1.22	 27 Jul 1995 11:59:52	NN
   GetData fuer Drawing

	  Rev 1.21	 26 Jul 1995 15:50:24	HJS
   clook

	  Rev 1.20	 21 Jul 1995 18:46:32	NN
   Draw-Model

	  Rev 1.19	 09 Jul 1995 14:06:24	NN
   ObjDescriptor mit DocShell initialisieren

	  Rev 1.18	 25 Jun 1995 17:25:50	NN
   Clipboard Optimierung

	  Rev 1.17	 24 Jun 1995 17:06:36	NN
   neuer DrawToDev Aufruf

	  Rev 1.16	 17 Jun 1995 13:43:08	TRI
   EXPORTS

	  Rev 1.15	 10 Jun 1995 16:08:26	NN
   Groesse von Metafile

	  Rev 1.14	 08 Jun 1995 16:05:52	NN
   TypeList und DocShellRef freigeben

	  Rev 1.13	 06 Jun 1995 17:17:32	NN
   unnoetige Zuweisungen raus

	  Rev 1.12	 29 May 1995 20:54:52	NN
   Cut-Flag bei CopyFromClip nicht zuruecksetzen

	  Rev 1.11	 09 May 1995 19:09:56	NN
   DrawToDev jetzt an ScPrintFunc

	  Rev 1.10	 27 Apr 1995 12:09:20	NN
   Hoehen/Breiten/VisArea bei DocShell

	  Rev 1.9	24 Apr 1995 16:44:58   NN
   Clipboard als Bitmap

	  Rev 1.8	20 Apr 1995 19:33:36   NN
   Metafile

	  Rev 1.7	24 Mar 1995 12:57:54   TRI
   Segmentierung

	  Rev 1.6	15 Mar 1995 12:57:22   NN
   Parameter bMetaFile bei DrawToDev

	  Rev 1.5	03 Mar 1995 22:58:30   NN
   Tabellennummer

	  Rev 1.4	20 Feb 1995 21:01:42   NN
   Cursor bei Ole-Daten

	  Rev 1.3	17 Feb 1995 18:59:04   NN
   Export-Formate, ClipBoard behalten

	  Rev 1.2	15 Feb 1995 01:59:40   NN
   Bitmaps mit richtiger Groesse

	  Rev 1.1	08 Feb 1995 12:44:18   NN
   Bug: Bereich bei Drag&Drop

	  Rev 1.0	05 Feb 1995 19:41:14   NN
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


