/*************************************************************************
 *
 *  $RCSfile: chwindow.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX

//SV
#define _CLIP_HXX
//#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
#define _SELENG_HXX
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
#define _MOREBTN_HXX
//#define _TOOLBOX_HXX
#define _STATUS_HXX
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
#define _FILDLG_HXX
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX ***
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX

#if defined  WIN
#define _MENUBTN_HXX
#endif

//svtools
#define _SCRWIN_HXX
#define _RULER_HXX
//#define _TABBAR_HXX
//#define _VALUESET_HXX
#define _STDMENU_HXX
//#define _STDCTRL_HXX
//#define _CTRLBOX_HXX
#define _CTRLTOOL_HXX
#define _EXTATTR_HXX
#define _FRM3D_HXX
#define _EXTATTR_HXX

//SVTOOLS
#define _SVTREELIST_HXX
#define _FILTER_HXX
#define _SVLBOXITM_HXX
#define _SVTREEBOX_HXX
#define _SVICNVW_HXX
#define _SVTABBX_HXX

//sfxcore.hxx
#define _SFXINIMGR_HXX
//#define _SFXCFGITEM_HXX
//#define _SFX_PRINTER_HXX
#define _SFXGENLINK_HXX
#define _SFXHINTPOST_HXX
#define _SFXDOCINF_HXX
#define _SFXLINKHDL_HXX
//#define _SFX_PROGRESS_HXX

//sfxsh.hxx
//#define _SFX_SHELL_HXX
//#define _SFXAPP_HXX
//#define _SFX_BINDINGS_HXX
//#define _SFXDISPATCH_HXX
#define _SFXMSG_HXX
#define _SFXOBJFACE_HXX
//#define _SFXREQUEST_HXX
#define _SFXMACRO_HXX

// SFX
#define _SFXAPPWIN_HXX
#define _SFX_SAVEOPT_HXX
//#define _SFX_CHILDWIN_HXX
//#define _SFXCTRLITEM_HXX
#define _SFXPRNMON_HXX
#define _INTRO_HXX
#define _SFXMSGDESCR_HXX
#define _SFXMSGPOOL_HXX
#define _SFXFILEDLG_HXX
#define _PASSWD_HXX
#define _SFXTBXCTRL_HXX
#define _SFXSTBITEM_HXX
#define _SFXMNUITEM_HXX
#define _SFXIMGMGR_HXX
#define _SFXTBXMGR_HXX
#define _SFXSTBMGR_HXX
#define _SFX_MINFITEM_HXX
#define _SFXEVENT_HXX

//sfxdoc.hxx
//#define _SFX_OBJSH_HXX
//#define _SFX_CLIENTSH_HXX
//#define _SFXDOCINF_HXX
//#define _SFX_OBJFAC_HXX
#define _SFX_DOCFILT_HXX
#define _SFXDOCFILE_HXX
//define _VIEWFAC_HXX
//#define _SFXVIEWFRM_HXX
//#define _SFXVIEWSH_HXX
#define _MDIFRM_HXX
#define _SFX_IPFRM_HXX
//#define _SFX_INTERNO_HXX

//sfxdlg.hxx
//#define _SFXTABDLG_HXX
#define _BASEDLGS_HXX
#define _SFX_DINFDLG_HXX
#define _SFXDINFEDT_HXX
#define _SFX_MGETEMPL_HXX
#define _SFX_TPLPITEM_HXX
//#define _SFX_STYLEDLG_HXX
#define _NEWSTYLE_HXX
#define _SFXDOCTEMPL_HXX
#define _SFXDOCTDLG_HXX
#define _SFX_TEMPLDLG_HXX
#define _SFXNEW_HXX
#define _SFXDOCMAN_HXX
#define _SFXDOCKWIN_HXX

//sfxitems.hxx
#define _SFX_WHMAP_HXX
//#define _ARGS_HXX
//#define _SFXPOOLITEM_HXX
//#define _SFXINTITEM_HXX
//#define _SFXENUMITEM_HXX
#define _SFXFLAGITEM_HXX
//#define _SFXSTRITEM_HXX
#define _SFXPTITEM_HXX
#define _SFXRECTITEM_HXX
//#define _SFXITEMPOOL_HXX
//#define _SFXITEMSET_HXX
#define _SFXITEMITER_HXX
#define _SFX_WHITER_HXX
#define _SFXPOOLCACH_HXX
//#define _AEITEM_HXX
#define _SFXRNGITEM_HXX
//#define _SFXSLSTITM_HXX
//#define _SFXSTYLE_HXX

//xout.hxx
//#define _XENUM_HXX
//#define _XPOLY_HXX
//#define _XATTR_HXX
//#define _XOUTX_HXX
//#define _XPOOL_HXX
//#define _XTABLE_HXX

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS

//#define SI_NOITEMS
//#define SI_NODRW
#define _SI_NOSBXCONTROLS
//#define _VCATTR_HXX
#define _VCONT_HXX
//#define _VCSBX_HXX
#define _SI_NOOTHERFORMS
#define _VCTRLS_HXX
//#define _VCDRWOBJ_HXX
#define _SI_NOCONTROL
#define _SETBRW_HXX
#define _VCBRW_HXX
#define _SI_NOSBXCONTROLS
#define _SIDLL_HXX

#include <svx/flstitem.hxx>

#pragma hdrstop

#ifndef _SV_HELP_HXX //autogen wg. Help
#include <vcl/help.hxx>
#endif

#ifndef _SVDPAGV_HXX //autogen wg. SdrPageView
#include <svx/svdpagv.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen wg. SvNumberFormatter
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#endif

#include "chwindow.hxx"
#include "viewshel.hxx"
#include "dragserv.hxx"
#include "schview.hxx"
#include "schhids.h"
#include "objid.hxx"

#include "strings.hrc"		// for QuickHelp Strings
#include "glob.hrc"
#include "schresid.hxx"
#include "datarow.hxx"
#include "datapoin.hxx"
#include "schattr.hxx"
#include "chaxis.hxx"


#define QUICK_HELP_TOLERANCE	  2		// in pixels

/************************************************************************/

#define MIN_ZOOM	10
#define MAX_ZOOM	650


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchWindow::SchWindow(Window* pParent) :
	Window(pParent, WinBits(WB_CLIPCHILDREN)),
	pViewShell(NULL),
	aWinPos(0, 0),			// vorsichtshalber; die Werte sollten aber
	aViewOrigin(0, 0),		// vom Besitzer des Fensters neu gesetzt
	aViewSize(1000, 1000)	// werden
{
	MapMode aMap(GetMapMode());
	aMap.SetMapUnit(MAP_100TH_MM);
	SetMapMode(aMap);

	Color aWhiteColor( COL_WHITE );
	SetBackground ( aWhiteColor );

	// Hilfe-ID setzen
	SetHelpId( HID_SCH_WIN_DOCUMENT );
	SetUniqueId( HID_SCH_WIN_DOCUMENT );

	EnableDrop();
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchWindow::~SchWindow()
{
}

/*************************************************************************
|*
|* Die Haelfte des Sichtbaren Bereich eines anderen Fensters darstellen
|*
\************************************************************************/

void SchWindow::ShareViewArea(const SchWindow* pOtherWin)
{
	aViewOrigin	= pOtherWin->aViewOrigin;
	aViewSize  	= pOtherWin->aViewSize;

	long nZoom = pOtherWin->GetZoom();
	MapMode aMap(GetMapMode());
	aMap.SetScaleX(Fraction(nZoom, 100));
	aMap.SetScaleY(Fraction(nZoom, 100));
	aMap.SetOrigin(pOtherWin->GetMapMode().GetOrigin());
	SetMapMode(aMap);
}

/*************************************************************************
|*
|* Paint event
|*
\************************************************************************/

void SchWindow::Paint(const Rectangle& rRect)
{
	if (pViewShell)
		pViewShell->Paint(rRect);
}

/*************************************************************************
|*
|* Keyboard event
|*
\************************************************************************/

void SchWindow::KeyInput(const KeyEvent& rKEvt)
{
	if (!pViewShell || !pViewShell->KeyInput(rKEvt))
		Window::KeyInput(rKEvt);
}

/*************************************************************************
|*
|* MouseButtonDown event
|*
\************************************************************************/

void SchWindow::MouseButtonDown(const MouseEvent& rMEvt)
{
	if (!pViewShell || !pViewShell->MouseButtonDown(rMEvt))
		Window::MouseButtonDown(rMEvt);
}

/*************************************************************************
|*
|* MouseMove event
|*
\************************************************************************/

void SchWindow::MouseMove(const MouseEvent& rMEvt)
{
	if (!pViewShell || !pViewShell->MouseMove(rMEvt))
		Window::MouseMove(rMEvt);
}

/*************************************************************************
|*
|* MouseButtonUp event
|*
\************************************************************************/

void SchWindow::MouseButtonUp(const MouseEvent& rMEvt)
{
	if (!pViewShell || !pViewShell->MouseButtonUp(rMEvt))
		Window::MouseButtonUp(rMEvt);
}

/*************************************************************************
|*
|* Command event
|*
\************************************************************************/

void SchWindow::Command(const CommandEvent& rCEvt)
{
	if (!pViewShell || !pViewShell->Command(rCEvt))
		Window::Command(rCEvt);
}

/*************************************************************************
|*
|* den eigentlichen Zoomfaktor in Prozent setzen; protected, wird
|* nur intern benutzt
|*
\************************************************************************/

long SchWindow::SetZoomFactor(long nZoom)
{
	if (nZoom > MAX_ZOOM)
		nZoom = MAX_ZOOM;
	if (nZoom < MIN_ZOOM)
		nZoom = MIN_ZOOM;

	MapMode aMap(GetMapMode());
	aMap.SetScaleX(Fraction(nZoom, 100));
	aMap.SetScaleY(Fraction(nZoom, 100));
	SetMapMode(aMap);
	return nZoom;
}

/*************************************************************************
|*
|* Zoomfaktor in Prozent setzen und Darstellungsbereich um den
|* Zoom-Mittelpunkt zentrieren
|*
\************************************************************************/

void SchWindow::SetZoom(long nZoom)
{
	if (nZoom > MAX_ZOOM)
		nZoom = MAX_ZOOM;
	if (nZoom < MIN_ZOOM)
		nZoom = MIN_ZOOM;

	Size aSize = PixelToLogic(GetSizePixel());
	long nW = aSize.Width()  * GetZoom() / nZoom;
	long nH = aSize.Height() * GetZoom() / nZoom;
	aWinPos.X() += (aSize.Width()  - nW) / 2;
	aWinPos.Y() += (aSize.Height() - nH) / 2;
	SetZoomFactor(nZoom);
}

/*************************************************************************
|*
|* Fensterposition und Zoomfaktor nach uebergebenem Rechteck setzen
|* obere linke Ecke des Rechtecks muss relativ zur linken oberen
|* Ecke des Fensters angegeben werden; gibt den berechneten Zoom-
|* faktor zurueck
|*
\************************************************************************/

long SchWindow::SetZoomRect(const Rectangle& rZoomRect)
{
	Size aWinSize = PixelToLogic(GetSizePixel());
	DBG_ASSERT(rZoomRect.GetWidth(), "ZoomRect-Breite = 0!");
	DBG_ASSERT(rZoomRect.GetHeight(), "ZoomRect-Hoehe = 0!");
	long nX = aWinSize.Width()	* 100 / rZoomRect.GetWidth();
	long nY = aWinSize.Height() * 100 / rZoomRect.GetHeight();
	long nZoom = Min(nX, nY) * GetZoom() / 100;

	aWinPos.X() = aViewOrigin.X() + rZoomRect.Left();
	aWinPos.Y() = aViewOrigin.Y() + rZoomRect.Top();

	if (nX < nY)
	{
		aWinSize.Height() = aWinSize.Height() * 100 / nX;
		aWinPos.Y() += rZoomRect.GetHeight() / 2 - aWinSize.Height() / 2;
	}

	if (nY < nX)
	{
		aWinSize.Width()  = aWinSize.Width() * 100 / nY;
		aWinPos.X() += rZoomRect.GetWidth() / 2 - aWinSize.Width() / 2;
	}

	return SetZoomFactor(nZoom);
}

/*************************************************************************
|*
|* QueryDrop-Event
|*
\************************************************************************/

BOOL SchWindow::QueryDrop(DropEvent& rEvt)
{
	return pViewShell && pViewShell->QueryDrop(rEvt);
}

/*************************************************************************
|*
|* Drop-Event
|*
\************************************************************************/

BOOL SchWindow::Drop(const DropEvent& rEvt)
{
	return pViewShell && pViewShell->Drop(rEvt);
}

/*************************************************************************
|*
|* Neuen MapMode-Origin berechnen und setzen
|*
\************************************************************************/

void SchWindow::UpdateMapOrigin()
{
	MapMode aMap(GetMapMode());

	Point aNewOrigin(-aWinPos.X() + aViewOrigin.X(),
					 -aWinPos.Y() + aViewOrigin.Y());

	if (aMap.GetOrigin() != aNewOrigin)
	{
		aMap.SetOrigin(aNewOrigin);
		SetMapMode(aMap);
		Invalidate();
	}
}


/*************************************************************************
|*
|* DataChanged
|*
\************************************************************************/

void SchWindow::DataChanged( const DataChangedEvent& rDCEvt )
{
	Window::DataChanged( rDCEvt );

	// PRINTER bei allen Dokumenten weglassen, die keinen Printer benutzen.
	// FONTS und FONTSUBSTITUTION weglassen, wenn keine Textausgaben
	// vorhanden sind, bzw. wenn das Dokument keinen Text zulaesst.

	if ( (rDCEvt.GetType() == DATACHANGED_PRINTER) ||
		 (rDCEvt.GetType() == DATACHANGED_DISPLAY) ||
		 (rDCEvt.GetType() == DATACHANGED_FONTS) ||
		 (rDCEvt.GetType() == DATACHANGED_FONTSUBSTITUTION) ||
		 ((rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
		  (rDCEvt.GetFlags() & SETTINGS_STYLE)) )
	{
		if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
			 (rDCEvt.GetFlags() & SETTINGS_STYLE) )
		{
			// ScrollBars neu anordnen bzw. Resize ausloesen, da sich
			// ScrollBar-Groesse geaendert haben kann. Dazu muss dann im
			// Resize-Handler aber auch die Groesse der ScrollBars aus
			// den Settings abgefragt werden.
			Resize();

			// Daten neu Setzen, die aus den Systemeinstellungen bzw. aus
			// den Settings uebernommen werden. Evtl. weitere Daten neu
			// berechnen, da sich auch die Aufloesung hierdurch geaendert
			// haben kann.
		}

		if ( (rDCEvt.GetType() == DATACHANGED_DISPLAY) ||
			 ((rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
			  (rDCEvt.GetFlags() & SETTINGS_STYLE)) )
		{
			// Virtuelle Device die auch von der Aufloesung oder von
			// Systemeinstellungen abhaengen, sollten geupdatet werden.
			// Ansonsten sollte zumindest bei DATACHANGED_DISPLAY
			// die virtuellen Devices geupdatet werden, da es einige
			// Systeme erlauben die Aufloesung und Farbtiefe waehrend
			// der Laufzeit zu aendern oder eben bei Palettenaenderungen
			// die virtuellen Device geupdatet werden muessen, da bei
			// Ausgaben ein anderes Farbmatching stattfinden kann.
		}

		if ( rDCEvt.GetType() == DATACHANGED_FONTS )
		{
			// Wenn das Dokument Font-AuswahlBoxen anbietet, muessen
			// diese geupdatet werden. Wie dies genau aussehen muss,
			// weiss ich leider auch nicht. Aber evtl. kann man das
			// ja global handeln. Dies muessten wir evtl. mal
			// mit PB absprechen, aber der ist derzeit leider Krank.
			// Also bevor dies hier gehandelt wird, vorher mit
			// PB und mir absprechen.
		}

		if ( (rDCEvt.GetType() == DATACHANGED_FONTS) ||
			 (rDCEvt.GetType() == DATACHANGED_FONTSUBSTITUTION) )
		{
			// Formatierung neu durchfuehren, da Fonts die im Dokument
			// vorkommen, nicht mehr vorhanden sein muessen oder
			// jetzt vorhanden sind oder durch andere ersetzt wurden
			// sind.
			if( pViewShell )
			{
				SchChartDocShell* pDocSh = pViewShell->GetDocSh();
				if( pDocSh )
					pDocSh->SetPrinter( pDocSh->GetPrinter() );
			}
		}

		if ( rDCEvt.GetType() == DATACHANGED_PRINTER )
		{
			// Wie hier die Behandlung aussehen soll, weiss ich leider
			// selbst noch nicht. Evtl. mal einen Printer loeschen und
			// schauen was gemacht werden muss. Evtl. muesste ich in
			// VCL dafuer noch etwas einbauen, wenn der benutze Printer
			// geloescht wird. Ansonsten wuerde ich hier evtl. die
			// Formatierung neu berechnen, wenn der aktuelle Drucker
			// zerstoert wurde.
			if( pViewShell )
			{
				SchChartDocShell* pDocSh = pViewShell->GetDocSh();
				if( pDocSh )
					pDocSh->SetPrinter( pDocSh->GetPrinter() );
			}
		}

		// Alles neu ausgeben
		Invalidate();
	}
}


// for quick help
void SchWindow::RequestHelp( const HelpEvent& rHEvt )
{
	if ( rHEvt.GetMode() & HELPMODE_QUICK )
	{
		if( pViewShell ) {
			SdrView* pView = pViewShell->GetView();
			if( pView && ! pView->IsDragObj() )
			{
				SdrPage* pPage = pView->GetPageViewPvNum(0)->GetPage();

				if( pPage )
				{
					// find object under cursor
					Point aPointerPos = PixelToLogic( GetPointerPosPixel() );
					SdrObject *pHitObj = GetHitObject( (SdrObjList*)pPage, aPointerPos );

					if( pHitObj )
					{	
						if (Help::IsBalloonHelpEnabled())
							Help::ShowBalloon( this, rHEvt.GetMousePosPixel(), pHitObj->GetBoundRect(),
											   GetQuickHelpText( pHitObj, (ChartModel*)pPage->GetModel(), TRUE ).ConvertLineEnd() );
						else
							Help::ShowQuickHelp( this, pHitObj->GetBoundRect(),
												 GetQuickHelpText( pHitObj, (ChartModel*)pPage->GetModel(), FALSE) );
					}
				}
			}
		}
	}
	else
		Window::RequestHelp( rHEvt );
}


SdrObject *SchWindow::GetHitObject( SdrObjList *pObjList, Point &aPos )
{
	UINT32 nTolerance = PixelToLogic( Size( QUICK_HELP_TOLERANCE, 0 ) ).Width();

	SdrObject *pHitObj;

	// simple depth first search
	if( pObjList )
	{
		SdrObjListIter aIterator( *pObjList, IM_FLAT, TRUE ); // iterate backward
		while (aIterator.IsMore())
		{
			pHitObj = aIterator.Next();

			if( pHitObj->IsHit( aPos, nTolerance ) )
			{
				SchObjectId* pId = GetObjectId( *pHitObj );
				if( pHitObj->IsGroupObject() )
				{
					if( pId )
					{
						switch( pId->GetObjId() )
						{
							case CHOBJID_DIAGRAM_FLOOR:
							case CHOBJID_DIAGRAM_WALL:
  							case CHOBJID_DIAGRAM_DATA:
								return pHitObj;

							case CHOBJID_TEXT:
							case CHOBJID_LINE:
							case CHOBJID_AREA:
								return pObjList->GetOwnerObj();	// return parent object
								
							default:							// recurse with SubList
								{
									SdrObject *pResult = GetHitObject( pHitObj->GetSubList(), aPos );
									if( pResult )
										return pResult;
									break;
								}
						}
					}
				}
				else	// non-group object
				{
					if( pId )
					{
						switch( pId->GetObjId() )
						{
							case CHOBJID_TEXT:
							case CHOBJID_LINE:
							case CHOBJID_AREA:
								return pObjList->GetOwnerObj();		// return parent object

							default:
								break;
						}
					}
					return pHitObj;
				}
			}
		}
	}
	
	return NULL;
}

String SchWindow::GetQuickHelpText( SdrObject *pObj, ChartModel* pModel, BOOL bVerbose )
{
	SchObjectId* pId = GetObjectId( *pObj );

	if( pId )
	{
		const sal_Unicode aQuote( '\"' );
		switch( pId->GetObjId() )
		{
			case CHOBJID_DIAGRAM_AREA:
				return String(SchResId( STR_DIAGRAM_AREA ));

			case CHOBJID_DIAGRAM_ROWGROUP:
			case CHOBJID_DIAGRAM_ROWS:
			case CHOBJID_DIAGRAM_ROWSLINE:
			case CHOBJID_DIAGRAM_SPECIAL_GROUP:
			case CHOBJID_DIAGRAM_STACKEDGROUP:
			case CHOBJID_LEGEND_SYMBOL_ROW:
				{
					SchDataRow *pDataRow = GetDataRow(*pObj);
					String aResult( SchResId( STR_DIAGRAM_ROW ) );

					if( pDataRow )
					{
						if( pModel )
						{
							String aName( aQuote );
							aName.Append( pModel->RowText( pDataRow->GetRow()) );
							aName.Append( aQuote );
							aResult.SearchAndReplaceAscii( "$(ROW)",  aName );
						}
					}
					return aResult;
				}
				break;

			case CHOBJID_LEGEND_SYMBOL_COL:
				return String(SchResId( STR_LEGEND_SYMBOL_COL ));

			case CHOBJID_LEGEND:
			case CHOBJID_LEGEND_BACK:
				return String(SchResId( STR_LEGEND ));

			case CHOBJID_DIAGRAM_DATA:
				{
					SchDataPoint *pDataPoint = GetDataPoint(*pObj);
					if( pDataPoint )
					{
						long nCol = pDataPoint->GetCol();
						long nRow = pDataPoint->GetRow();

						String aText;
						long nUId = ( (const SfxInt32Item&)pModel->GetDataRowAttr( nRow ).Get( SCHATTR_AXIS ) ).GetValue();
						ChartAxis *pAxis = pModel->GetAxisByUID( nUId );
						long nNumf = pAxis->GetNumFormat( FALSE );

						Color* pTextColor = NULL;
						pModel->GetNumFormatter()->GetOutputString(
							pModel->GetData(nCol, nRow), nNumf, aText, &pTextColor);

						String aResult( SchResId( bVerbose? STR_BALLOONHELP_DATAPOINT: STR_QUICKHELP_DATAPOINT ) );

						aResult.SearchAndReplaceAscii( "$(VALUE)", aText );

						if( bVerbose )
						{
							String aStrQuoted( aQuote );
							aStrQuoted.Append( pModel->ColText( nCol ));
							aStrQuoted.Append( aQuote );
							aResult.SearchAndReplaceAll( String( RTL_CONSTASCII_USTRINGPARAM( "$(NEWLINE)" )),
														 String( RTL_CONSTASCII_USTRINGPARAM( "\n" )));
							aResult.SearchAndReplaceAscii( "$(PT_STR)",  aStrQuoted );
							aStrQuoted = aQuote;
							aStrQuoted.Append( pModel->RowText( nRow ));
							aStrQuoted.Append( aQuote );
							aResult.SearchAndReplaceAscii( "$(ROW_STR)", aStrQuoted );
						}
						else
						{
							aResult.SearchAndReplaceAscii( "$(PT_NUM)",  String::CreateFromInt32( nCol + 1 ));
							aResult.SearchAndReplaceAscii( "$(ROW_NUM)", String::CreateFromInt32( nRow + 1 ));
						}
					
						return aResult;
					}
				}
				break;

			case CHOBJID_TITLE_MAIN:
				return String(SchResId( STR_TITLE_MAIN ));

			case CHOBJID_TITLE_SUB:
				return String(SchResId( STR_TITLE_SUB ));

			case CHOBJID_DIAGRAM_TITLE_X_AXIS:
				return String(SchResId( STR_DIAGRAM_TITLE_X_AXIS ));

			case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
				return String(SchResId( STR_DIAGRAM_TITLE_Y_AXIS ));

			case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
				return String(SchResId( STR_DIAGRAM_TITLE_Z_AXIS ));

			case CHOBJID_DIAGRAM_X_AXIS:
			case CHOBJID_DIAGRAM_A_AXIS:
				return String(SchResId( STR_DIAGRAM_X_AXIS ));

			case CHOBJID_DIAGRAM_Y_AXIS:
			case CHOBJID_DIAGRAM_B_AXIS:
				return String(SchResId( STR_DIAGRAM_Y_AXIS ));

			case CHOBJID_DIAGRAM_Z_AXIS:
			case CHOBJID_DIAGRAM_C_AXIS:
				return String(SchResId( STR_DIAGRAM_Z_AXIS ));

				// attention: x and y grids are interchanged
			case CHOBJID_DIAGRAM_X_GRID_MAIN:
				return String(SchResId( STR_DIAGRAM_Y_GRID_MAIN ));

			case CHOBJID_DIAGRAM_Y_GRID_MAIN:
				return String(SchResId( STR_DIAGRAM_X_GRID_MAIN ));

			case CHOBJID_DIAGRAM_Z_GRID_MAIN:
				return String(SchResId( STR_DIAGRAM_Z_GRID_MAIN ));

				// attention: x and y grids are interchanged
			case CHOBJID_DIAGRAM_X_GRID_HELP:
				return String(SchResId( STR_DIAGRAM_Y_GRID_HELP ));

			case CHOBJID_DIAGRAM_Y_GRID_HELP:
				return String(SchResId( STR_DIAGRAM_X_GRID_HELP ));

			case CHOBJID_DIAGRAM_Z_GRID_HELP:
				return String(SchResId( STR_DIAGRAM_Z_GRID_HELP ));

			case CHOBJID_DIAGRAM_DESCR_ROW:
				return String(SchResId( STR_DIAGRAM_DESCR_ROW ));

			case CHOBJID_DIAGRAM_DESCR_COL:
				return String(SchResId( STR_DIAGRAM_DESCR_COL ));

			case CHOBJID_DIAGRAM_DESCR_SYMBOL:
				return String(SchResId( STR_LEGEND_SYMBOL_ROW ));

			case CHOBJID_DIAGRAM_STOCKLINE:
				return String(SchResId( STR_LINE ));

			case CHOBJID_DIAGRAM_WALL:
				return String(SchResId( STR_DIAGRAM_WALL ));

			case CHOBJID_DIAGRAM_FLOOR:
				return String(SchResId( STR_DIAGRAM_FLOOR ));

			case CHOBJID_DIAGRAM_AVERAGEVALUE:
				return String(SchResId( STR_AVERAGEVALUE ));
				
			case CHOBJID_DIAGRAM_ERROR:
				return String(SchResId( STR_DIAGRAM_ERROR ));
				
			case CHOBJID_DIAGRAM_REGRESSION:
				return String(SchResId( STR_DIAGRAM_REGRESSION ));

			case CHOBJID_DIAGRAM_NET:
				return String(SchResId( STR_NET ));

			default:
#ifdef DBG_UTIL
				return String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( GetCHOBJIDName( pId->GetObjId())));
#else
				break;
#endif
		}
	}

#ifdef DBG_UTIL
	return String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Invalid Id" ));
#else
	return String();
#endif
}



