#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:53:27 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..
PRJNAME=sim
TARGET=dlg

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

CXXFILES = \
		rotate.cxx		\
		rgbdlg.cxx		\
		contrast.cxx	\
		graydlg.cxx		\
		gamma.cxx		\
		mosaic.cxx		\
		tiledlg.cxx		\
		sharpnss.cxx	\
		solardlg.cxx	\
		relief.cxx		\
		sizedlg.cxx		\
		defaults.cxx	\
		poster.cxx		\
		agedlg.cxx		\
		printopt.cxx	\
		newdlg.cxx		\
		progress.cxx	\
		frmprop.cxx		

SRCFILES = \
		rotate.src		\
		rgbdlg.src		\
		contrast.src	\
		graydlg.src		\
		gamma.src		\
		mosaic.src		\
		tiledlg.src		\
		sharpnss.src	\
		solardlg.src	\
		relief.src		\
		sizedlg.src		\
		defaults.src	\
		poster.src		\
		agedlg.src		\
		printopt.src	\
		newdlg.src		\
		frmprop.src		

SLOFILES =	\
		$(SLO)$/rotate.obj		\
		$(SLO)$/rgbdlg.obj		\
		$(SLO)$/contrast.obj	\
		$(SLO)$/graydlg.obj		\
		$(SLO)$/gamma.obj		\
		$(SLO)$/mosaic.obj		\
		$(SLO)$/tiledlg.obj		\
		$(SLO)$/sharpnss.obj	\
		$(SLO)$/solardlg.obj	\
		$(SLO)$/relief.obj		\
		$(SLO)$/sizedlg.obj		\
		$(SLO)$/defaults.obj	\
		$(SLO)$/poster.obj		\
		$(SLO)$/agedlg.obj		\
		$(SLO)$/printopt.obj	\
		$(SLO)$/newdlg.obj		\
		$(SLO)$/progress.obj	\
		$(SLO)$/frmprop.obj		

# --- Targets -------------------------------------------------------

.INCLUDE :  target.mk
