/*************************************************************************
 *
 *  $RCSfile: wpsexe.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#define WPStOfExe5_Class_Source
#include "wpsexe.ih"

#undef  WPStOfExe5MethodDebug
#undef  M_WPStOfExe5MethodDebug
#define WPStOfExe5MethodDebug(a,b) SOM_NoTrace(a,b)
#define M_WPStOfExe5MethodDebug(a,b) SOM_NoTrace(a,b)

#undef SOM_CurrentClass
#define SOM_CurrentClass SOMInstance
SOM_Scope MRESULT   SOMLINK wpstofexe5_wpDrop(WPStOfExe5 *somSelf,
		HWND hwndCnr,
		PDRAGINFO pdrgInfo,
		PDRAGITEM pdrgItem)
{
	AppOpenFct pFct = SOM_ParentResolveE(WPObject,SOM_CurrentClass,wpOpen);
	Drop( somSelf, hwndCnr, pdrgInfo, pdrgItem, pFct );
	return (MRESULT)RC_DROP_DROPCOMPLETE;
	/* return (parent_wpDrop(somSelf,hwndCnr,pdrgInfo,pdrgItem)); */
}

SOM_Scope HWND   SOMLINK wpstofexe5_wpOpen(WPStOfExe5 *somSelf,
		HWND hwndCnr,
		ULONG ulView,
		ULONG param)
{
	char aBuf[25];
	AppOpenFct pFct = SOM_ParentResolveE(WPObject,SOM_CurrentClass,wpOpen);

	//ltoa( ulView, &aBuf[0], 10 );
	//MyMsgBox("ulView", aBuf );

	/* WPStOfExeData *somThis = WPStOfExeGetData(somSelf); */
	WPStOfExe5MethodDebug("WPStOfExe","wpstofexe_wpOpen");

	if( ulView == OPEN_RUNNING )
	{
		// DosBeep( 440, 1000 );
		if( OpenExe( somSelf, hwndCnr, ulView, param, pFct ) == 1 )
			// kein Dateiname -> Settings anzeigen
			// (beim D&D eines Programm-Templates vom Template-Ordner
			// auf den Desktop, wird wpOpen mit ulView = OPEN_RUNNING
			// aufgerufen (besser waere OPEN_SETTINGS) )
			ulView = OPEN_SETTINGS;
	}
	if( ulView == OPEN_SETTINGS )
	{
		// DosBeep( 1000, 500 );
		return (parent_wpOpen(somSelf,hwndCnr,ulView,param));
	}
	return hwndCnr;
}

#undef SOM_CurrentClass
#define SOM_CurrentClass SOMMeta
SOM_Scope PSZ   SOMLINK wpstofexe5M_wpclsQueryTitle(M_WPStOfExe5 *somSelf)
{
	/* M_WPStOfExeData *somThis = M_WPStOfExeGetData(somSelf); */
	M_WPStOfExe5MethodDebug("M_WPStOfExe5","wpstofexe5M_wpclsQueryTitle");
	return (PSZ)"StarOffice 5";
}

SOM_Scope ULONG SOMLINK wpstofexe5M_wpclsQueryStyle(M_WPStOfExe5 *somSelf)
{
	ULONG 		nStyle;
	/* M_WPStOfExeData *somThis = M_WPStOfExeGetData(somSelf); */
	M_WPStOfExe5MethodDebug("M_WPStOfExe5","wpstofexe5M_wpclsQueryStyle");
	nStyle = (parent_wpclsQueryStyle(somSelf));
	nStyle |= CLSSTYLE_NEVERTEMPLATE;
	return nStyle;
}

