/*************************************************************************
 *
 *  $RCSfile: unoifac2.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVT_UNOIFAC2_HXX
#define _SVT_UNOIFAC2_HXX


#ifndef _SVT_UNOIFACE_HXX
#include "unoiface.hxx"
#endif

#ifndef _TEXTDATA_HXX
#include <textdata.hxx>
#endif
#ifndef _SVEDIT_HXX
#include <svmedit.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svarray.hxx>
#endif
#ifndef _TXTCMP_HXX //autogen
#include <txtcmp.hxx>
#endif
#ifndef _XTEXTEDT_HXX //autogen
#include <xtextedt.hxx>
#endif
#ifndef _SFX_ITEMPROP_HXX //autogen
#include <itemprop.hxx>
#endif

#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HXX
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXTCURSOR_HPP_
#include <com/sun/star/text/XTextCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXTRANGE_HPP_
#include <com/sun/star/text/XTextRange.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXT_HPP_
#include <com/sun/star/text/XText.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXTVIEWCURSOR_HPP_
#include <com/sun/star/text/XTextViewCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXTVIEWCURSORSUPPLIER_HPP_
#include <com/sun/star/text/XTextViewCursorSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_VIEW_XSCREENCURSOR_HPP_
#include <com/sun/star/view/XScreenCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_URL_HPP_
// #include <com/sun/star/util/url.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XSEARCHABLE_HPP_
#include <com/sun/star/util/XSearchable.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XSEARCHDESCRIPTOR_HPP_
#include <com/sun/star/util/XSearchDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XCONNECTABLE_HPP_
#include <com/sun/star/io/XConnectable.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XDATAOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XDataOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATACONTROL_HPP_
#include <com/sun/star/io/XActiveDataControl.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XDATAINPUTSTREAM_HPP_
#include <com/sun/star/io/XDataInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XMARKABLESTREAM_HPP_
#include <com/sun/star/io/XMarkableStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XINPUTSTREAM_HPP_
#include <com/sun/star/io/XInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XSTREAMLISTENER_HPP_
#include <com/sun/star/io/XStreamListener.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _SV_GEN_HXX
#include <tools/gen.hxx>
#endif

class SvtXEditorControl;

//	----------------------------------------------------
//	class SvtECWindow
//	----------------------------------------------------

// moegliche Werte fuer 'nType' in BuildSequence.
// Sie bestimmen welche '::com::sun::star::uno::Sequence' fuer den Dispatch Aufruf gebildet wird.
#define SVTEC_SEQ_DEFAULT		0
#define SVTEC_SEQ_DOWNLOAD  	1
#define SVTEC_SEQ_ADD_BOOKMARK  2

class TextAttribHyperLink;

class SvtECWindow : public MultiLineEdit
{
	friend class SvtXEditorControl;
	SvtECWindow( const SvtECWindow& );
	SvtECWindow& operator = ( const SvtECWindow& );

private:
	::com::sun::star::util::URL							aURL;		// ::com::sun::star::util::URL die von xDispatch im Handler verwendet wird
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>		aArgs;		// Argumente die von xDispatch im Handler verwendet werden
	Timer						aDispatchTimer;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch > 				xDispatch;	// das im Handler benutzte ::com::sun::star::frame::XDispatch Objekt
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > 				xController;
	sal_Bool            			bMarkHyperLinks;


	DECL_LINK(		DispatchTimerHdl, Timer* );

	void 			BuildSequence(::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> &aArgs, sal_uInt16 nType, const TextAttribHyperLink *pAttr) const;
	sal_Bool 			LaunchDispatch(const ::com::sun::star::util::URL &rURL, ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> &rArgs, sal_Bool bOpenNewWin);

	void			AutoShowVScrollBar() const;
	void			UpdateThumbPosVScrollBar() const;

protected:

public:
					SvtECWindow( Window* pParent, WinBits nWinStyle );
					~SvtECWindow();

	// Window
	long			PreNotify( NotifyEvent& rNEvt );
	long			Notify( NotifyEvent& rNEvt );
	void			Resize();

	void			SetController( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >  xCtrl )	{ xController = xCtrl; }
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > 	GetController()								{ return xController; }

	ExtTextEngine*	GetTextEngine() const { return MultiLineEdit::GetTextEngine(); }
	ExtTextView*	GetTextView() const   { return MultiLineEdit::GetTextView(); }
	ScrollBar*		GetVScrollBar() const { return MultiLineEdit::GetVScrollBar(); }

	sal_Bool		IsMarkHyperLinks() const { return bMarkHyperLinks; }
	void			SetMarkHyperLinks(sal_Bool bVal);
	sal_uInt16 		SetHyperLinkAttribs(sal_uInt32 nBeginPara = 0, sal_uInt32 nEndPara = ULONG_MAX);
};


//	----------------------------------------------------
//	class SvtECParent
//	----------------------------------------------------

class SvtECChild;
SV_DECL_PTRARR(ChildArray, SvtECChild *, 16, 16);

class SvtECParent
{
private:
	ChildArray	*mpChilds;

	SvtECParent( const SvtECParent & );
	SvtECParent & operator = ( const SvtECParent & );

protected:

public:
	SvtECParent();
	virtual ~SvtECParent();

	void		AddChild( SvtECChild *pChild );
	void		RemoveChild( SvtECChild *pChild );
};


//	----------------------------------------------------
//	class SvtECChild
//	----------------------------------------------------

typedef SvtXEditorControl  SvtECParentType;

class SvtECChild
{
	friend SvtECParent::~SvtECParent();

private:
	SvtECParentType *mpParent;

	//! nur zum Aufruf aus SvtECParent::~SvtECParent() gedacht
	void				ClearParent() { mpParent = NULL; }

protected:

public:
	SvtECChild( SvtECParentType *pParent );
	SvtECChild( const SvtECChild &rChild );
	virtual ~SvtECChild();

	SvtECParentType *	GetParent() const { return mpParent; }
	void				SetParent( SvtECParentType *pParent );

	SvtECChild & operator = ( const SvtECChild &rChild );
};


//	----------------------------------------------------
//	class SvtXECTextRange
//	----------------------------------------------------
class SvtXECTextRange : public ::com::sun::star::text::XTextRange, 
						public ::com::sun::star::lang::XUnoTunnel,
						public ::cppu::OWeakObject,
						public SvtECChild
{
	friend class SvtXECTextCursor;
	friend class SvtXEditorControl;
	friend class SvtTextController;
	friend class XTextHelper;

private:
	TextSelection		maSelection;

	SvtXECTextRange & operator = ( const SvtXECTextRange & );

protected:
	const TextSelection &	GetSelection() const { return maSelection; }
	void					SetSelection( const TextSelection &aSel ) { maSelection = aSel; }
	void					SetSelection( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  &xRange ) throw( ::com::sun::star::uno::RuntimeException );

	SvtXECTextRange( SvtXEditorControl* pEC, const TextPaM &aStart, const TextPaM &aEnd );
	SvtXECTextRange( SvtXEditorControl* pEC, const TextSelection &aSelection );

public:
	SvtXECTextRange();
	SvtXECTextRange( SvtXEditorControl* pEC );
	SvtXECTextRange( const SvtXECTextRange &rRange );
	virtual ~SvtXECTextRange();

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::release(); }

    // ::com::sun::star::lang::XUnoTunnel
	static const ::com::sun::star::uno::Sequence< sal_Int8 >&	GetUnoTunnelId() throw();
	static SvtXECTextRange*										GetImplementation( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& rxIFace ) throw();
	sal_Int64													SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& rIdentifier ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XTextRange
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XText > SAL_CALL getText(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getStart(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getEnd(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL getString(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setString( const ::rtl::OUString& aString ) throw(::com::sun::star::uno::RuntimeException);
};

//	----------------------------------------------------
//	class SvtXECTextCursor
//	----------------------------------------------------
class SvtXECTextCursor :	public ::com::sun::star::text::XTextViewCursor, 
							public ::com::sun::star::view::XScreenCursor,
							public ::com::sun::star::lang::XTypeProvider,
							public SvtXECTextRange
{
	friend class SvtXEditorControl;

private:
	SvtXECTextCursor( const SvtXECTextCursor & );
	SvtXECTextCursor & operator = ( const SvtXECTextCursor & );

	sal_Bool 					ScreenUpDown(sal_Bool bScreenUp);
	sal_Bool					Move( TextPaM& rPaM, sal_uInt16 nCount, sal_Bool bLeft ) throw( ::com::sun::star::uno::RuntimeException );

protected:
	SvtXECTextRange*		GetRangeFrom( ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  xRange ) const;

public:
	SvtXECTextCursor() : SvtXECTextRange( NULL ) {}
	SvtXECTextCursor( SvtXEditorControl* pEC );
	SvtXECTextCursor( SvtXEditorControl* pEC, const TextSelection& rSelection );
	SvtXECTextCursor( SvtXEditorControl* pEC, const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > & xRange ); // throw( ::com::sun::star::uno::RuntimeException );
	virtual ~SvtXECTextCursor();

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::release(); }

    // ::com::sun::star::lang::XUnoTunnel
	static const ::com::sun::star::uno::Sequence< sal_Int8 >&	GetUnoTunnelId() throw();
	static SvtXECTextCursor*									GetImplementation( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& rxIFace ) throw();
	sal_Int64													SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& rIdentifier ) throw(::com::sun::star::uno::RuntimeException);

    // ::com::sun::star::lang::XTypeProvider
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XTextRange
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XText > SAL_CALL getText(  ) throw(::com::sun::star::uno::RuntimeException) { return SvtXECTextRange::getText() ; }
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getStart(  ) throw(::com::sun::star::uno::RuntimeException) { return SvtXECTextRange::getStart() ; }
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getEnd(  ) throw(::com::sun::star::uno::RuntimeException) { return SvtXECTextRange::getEnd() ; }
    virtual ::rtl::OUString SAL_CALL getString(  ) throw(::com::sun::star::uno::RuntimeException) { return SvtXECTextRange::getString() ; }
    virtual void SAL_CALL setString( const ::rtl::OUString& aString ) throw(::com::sun::star::uno::RuntimeException) { SvtXECTextRange::setString(aString) ; }

	// ::com::sun::star::text::XTextCursor
    virtual void SAL_CALL collapseToStart(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL collapseToEnd(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL isCollapsed(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL goLeft( sal_Int16 nCount, sal_Bool bExpand ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL goRight( sal_Int16 nCount, sal_Bool bExpand ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL gotoStart( sal_Bool bExpand ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL gotoEnd( sal_Bool bExpand ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL gotoRange( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& xRange, sal_Bool bExpand ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XTextViewCursor
    virtual sal_Bool SAL_CALL isVisible(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setVisible( sal_Bool bVisible ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::awt::Point SAL_CALL getPosition(  ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::view::XScreenCursor
    virtual sal_Bool SAL_CALL screenDown(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL screenUp(  ) throw(::com::sun::star::uno::RuntimeException);
};

//	----------------------------------------------------
//	class SvtXECTRIndexAccess
//	----------------------------------------------------

class SvtXECTRIndexAccess : public ::com::sun::star::container::XIndexAccess, 
							public ::cppu::OWeakObject,
							public SvtECChild
{
	friend class SvtXEditorControl;

private:
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  >	maSelections;	// die "Liste" der Ergebnisse
	sal_Int32						mnCount;		// die Anzahl der Elemente in der
												// der ::com::sun::star::uno::Sequence, nicht ihre Laenge

	SvtXECTRIndexAccess( const SvtXECTRIndexAccess & );
	SvtXECTRIndexAccess & operator = ( const SvtXECTRIndexAccess & );

protected:
	::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > 		GetElement(sal_uInt16 nIndex) const;
	void				InsertElementAtEnd(::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >  &xRange);

public:
	SvtXECTRIndexAccess();
	SvtXECTRIndexAccess( SvtXEditorControl* pEC );
	virtual ~SvtXECTRIndexAccess();

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::release(); }

	// ::com::sun::star::container::XElementAccess
    virtual ::com::sun::star::uno::Type SAL_CALL getElementType(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL hasElements(  ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::container::XIndexAccess
    virtual sal_Int32 SAL_CALL getCount(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Any SAL_CALL getByIndex( sal_Int32 Index ) throw(::com::sun::star::lang::IndexOutOfBoundsException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException);
};

//	----------------------------------------------------
//	class SvtXECSearchDescriptor
//	----------------------------------------------------

// WID's fuer suchen und ersetzen
#define WID_WORDS				 0
#define WID_BACKWARDS            1
#define WID_REGULAR_EXPRESSION   2
#define WID_CASE_SENSITIVE       3
#define WID_IN_SELECTION         4
//#define WID_SEARCH_ALL			 5
//#define WID_STYLES               6
#define WID_SIMILARITY           7
#define WID_SIMILARITY_RELAX     8
#define WID_SIMILARITY_EXCHANGE  9
#define WID_SIMILARITY_ADD       10
#define WID_SIMILARITY_REMOVE    11

// UNO property names fuer suchen und ersetzen
#define UPN_SEARCH_WORDS				"SearchWords"
#define UPN_SEARCH_BACKWARDS            "SearchBackwards"
#define UPN_SEARCH_REGULAR_EXPRESSION   "SearchRegularExpression"
#define UPN_SEARCH_CASE_SENSITIVE       "SearchCaseSensitive"
#define UPN_SEARCH_IN_SELECTION         "SearchInSelection"
//#define UPN_SEARCH_ALL					"SearchAll"
//#define UPN_SEARCH_STYLES				"SearchStyles"
#define UPN_SEARCH_SIMILARITY           "SearchSimilarity"
#define UPN_SEARCH_SIMILARITY_RELAX     "SearchSimilarityRelax"
#define UPN_SEARCH_SIMILARITY_EXCHANGE  "SearchSimilarityExchange"
#define UPN_SEARCH_SIMILARITY_ADD       "SearchSimilarityAdd"
#define UPN_SEARCH_SIMILARITY_REMOVE    "SearchSimilarityRemove"

// in SfxItemPropertyMap verwendete Flags
#define PROPERTY_NONE	0

class SvtXECSearchDescriptor :	public ::com::sun::star::util::XSearchDescriptor, 
								public ::com::sun::star::lang::XUnoTunnel,
								public ::cppu::OWeakObject,
								public SvtECChild
{
	friend class SvtXEditorControl;

private:
	SearchParam			maParam;				// Such-Parameter passend fuer MultiLineEdit
	sal_Bool			mbBackward;				// rueckwaerts suchen ?

	SvtXECSearchDescriptor( const SvtXECSearchDescriptor & );
	SvtXECSearchDescriptor & operator = ( const SvtXECSearchDescriptor & );

protected:
	void				SetSearchDefaults();
	const SearchParam &	GetSearchParam() const { return maParam; }
	sal_Bool				IsBackward() const { return mbBackward; }

public:
	SvtXECSearchDescriptor();
	SvtXECSearchDescriptor( SvtXEditorControl* pEC );
	virtual ~SvtXECSearchDescriptor();

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ OWeakObject::release(); }

	    // ::com::sun::star::lang::XUnoTunnel
	static const ::com::sun::star::uno::Sequence< sal_Int8 >&	GetUnoTunnelId() throw();
	static SvtXECSearchDescriptor*								GetImplementation( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& rxIFace ) throw();
	sal_Int64													SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& rIdentifier ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::beans::XPropertySet
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > SAL_CALL getPropertySetInfo(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setPropertyValue( const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::beans::PropertyVetoException, ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Any SAL_CALL getPropertyValue( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addPropertyChangeListener( const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener >& xListener ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException){;}
    virtual void SAL_CALL removePropertyChangeListener( const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener >& aListener ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException){;}
    virtual void SAL_CALL addVetoableChangeListener( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener >& aListener ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException){;}
    virtual void SAL_CALL removeVetoableChangeListener( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener >& aListener ) throw(::com::sun::star::beans::UnknownPropertyException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException){;}

	// ::com::sun::star::util::XSearchDescriptor
    virtual ::rtl::OUString SAL_CALL getSearchString(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setSearchString( const ::rtl::OUString& aString ) throw(::com::sun::star::uno::RuntimeException);
};

//	----------------------------------------------------
//	class SvtXEditorControl
//	----------------------------------------------------
class SvtXEditorControl;

class XTextHelper : public ::com::sun::star::text::XText
{
private:
	SvtXEditorControl*	mpEC;

public:
	XTextHelper( SvtXEditorControl* pEC ) { mpEC = pEC; }

	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XTextRange
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XText > SAL_CALL getText(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getStart(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange > SAL_CALL getEnd(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL getString(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setString( const ::rtl::OUString& aString ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XSimpleText
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor > SAL_CALL createTextCursor(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextCursor > SAL_CALL createTextCursorByRange( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& aTextPosition ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL insertString( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& xRange, const ::rtl::OUString& aString, sal_Bool bAbsorb ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL insertControlCharacter( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& xRange, sal_Int16 nControlCharacter, sal_Bool bAbsorb ) throw(::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::text::XText
    virtual void SAL_CALL insertTextContent( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextRange >& xRange, const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextContent >& xContent, sal_Bool bAbsorb ) throw(::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeTextContent( const ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextContent >& xContent ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException);
};

SV_DECL_PTRARR(TextCursorPtrArray, SvtXECTextCursor*, 32, 32);

class SvtXEditorControl :	public VCLXMultiLineEdit,
							public XTextHelper,
							public ::com::sun::star::text::XTextViewCursorSupplier, 
							public ::com::sun::star::util::XSearchable,
							public SvtECParent
{
	friend class SvtXECTextCursor;
	friend class SvtXECTextRange;
	friend class SvtXECSearchDescriptor;
	friend class SvtTextLoader;
	friend class SvtXTCDispatch;
	friend class XTextHelper;

private:
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 		mxCursor;
	::com::sun::star::uno::Reference< ::com::sun::star::io::XOutputStream > 	mxSink;

	SvtXEditorControl( const SvtXEditorControl & );
	SvtXEditorControl & operator = ( const SvtXEditorControl & );

protected:
	SvtECWindow*		GetECWindow()		 { return (SvtECWindow*) GetWindow(); }
	const SvtECWindow*	GetECWindow() const { return (SvtECWindow*) GetWindow(); }
	SvtECWindow*		CreateWindow( Window* pParent );
	void				AutoShowVScrollBar() const;
	void				UpdateThumbPosVScrollBar() const;
	void                ImpSetSelection(const TextSelection &rSel, sal_Bool bForceAutoScroll);

public:
	SvtXEditorControl();
	virtual ~SvtXEditorControl();

	void					ConnectDataSource( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource > & rSource );

	// ::com::sun::star::uno::XInterface
    ::com::sun::star::uno::Any					SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType ) throw(::com::sun::star::uno::RuntimeException);
	void										SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException)	{ VCLXMultiLineEdit::acquire(); }
	void										SAL_CALL release() throw(::com::sun::star::uno::RuntimeException)	{ VCLXMultiLineEdit::release(); }

    // ::com::sun::star::lang::XTypeProvider
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type >	SAL_CALL getTypes() throw(::com::sun::star::uno::RuntimeException);
	::com::sun::star::uno::Sequence< sal_Int8 >						SAL_CALL getImplementationId() throw(::com::sun::star::uno::RuntimeException);


	// ::com::sun::star::text::XTextViewCursorSupplier
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::text::XTextViewCursor > SAL_CALL getViewCursor(  ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::util::XSearchable
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > SAL_CALL createSearchDescriptor(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > SAL_CALL findAll( const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor >& xDesc ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL findFirst( const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor >& xDesc ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL findNext( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& xStartAt, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor >& xDesc ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::awt::XVclWindowPeer
    void SAL_CALL setProperty( const ::rtl::OUString& PropertyName, const ::com::sun::star::uno::Any& Value ) throw(::com::sun::star::uno::RuntimeException);
    ::com::sun::star::uno::Any SAL_CALL getProperty( const ::rtl::OUString& PropertyName ) throw(::com::sun::star::uno::RuntimeException);
};


#endif
