/*************************************************************************
 *
 *  $RCSfile: propbrw3.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:01:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
#ifndef _SVX_PROPBRW_HRC
#include "propbrw.hrc"
#endif
#ifndef _SVX_PROPBRW_HXX
#include "propbrw.hxx"
#endif
#ifndef SVX_PROPERTY_HXX
#include "property.hxx"
#endif
#ifndef _SVX_FMTOOLS_HXX
#include "fmtools.hxx"
#endif
#ifndef _SVX_FMSERVS_HXX
#include "fmservs.hxx"
#endif
#ifndef _SVX_FMSHIMP_HXX
#include "fmshimp.hxx"
#endif
#include <stdlib.h>
#include <stdio.h>
#include <wchar.h>
#ifndef _SVDPAGV_HXX
#include "svdpagv.hxx"
#endif
#ifndef _SVX_FMUNOPGE_HXX
#include "fmpgeimp.hxx"
#endif
#ifndef SVX_PROPCTR2_HXX
#include "propctr2.hxx"
#endif
#ifndef _NUMUNO_HXX //autogen wg. SvNumberFormatsSupplierObj
#include <svtools/numuno.hxx>
#endif
#ifndef _ZFORLIST_HXX //autogen wg. SvNumberFormatter
#include <svtools/zforlist.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_COLRDLG_HXX //autogen
#include <svtools/colrdlg.hxx>
#endif
#ifndef _SV_COLOR_HXX
#include <vcl/color.hxx>
#endif
#ifndef _SVX_IMPGRF_HXX //autogen
#include <impgrf.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_XNAMINGSERVICE_HPP_
#include <com/sun/star/uno/XNamingService.hpp>
#endif
#include <com/sun/star/lang/XUnoTunnel.hpp>
#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_FORMCOMPONENTTYPE_HPP_
#include <com/sun/star/form/FormComponentType.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XPERSISTOBJECT_HPP_
#include <com/sun/star/io/XPersistObject.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLCLASS_HPP_
#include <com/sun/star/reflection/XIdlClass.hpp>
#endif
#ifndef _COM_SUN_STAR_REFLECTION_XIDLMETHOD_HPP_
#include <com/sun/star/reflection/XIdlMethod.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XEVENTATTACHERMANAGER_HPP_
#include <com/sun/star/script/XEventAttacherManager.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_SCRIPTEVENTDESCRIPTOR_HPP_
#include <com/sun/star/script/ScriptEventDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#include <com/sun/star/beans/PropertyAttribute.hpp>

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _IODLG_HXX //autogen
#include <sfx2/iodlg.hxx>
#endif
#ifndef _SVX_FMSHELL_HXX
#include "fmshell.hxx"
#endif
#ifndef _SVX_DIALMGR_HXX //autogen
#include "dialmgr.hxx"
#endif
#ifndef _SVX_FMOBJ_HXX
#include "fmobj.hxx"
#endif
#ifndef _SFX_OBJITEM_HXX //autogen
#include <sfx2/objitem.hxx>
#endif
#ifndef _SVX_FMPAGE_HXX
#include "fmpage.hxx"
#endif
#define ITEMID_MACRO SID_ATTR_MACROITEM
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif
#ifndef _MACROPG_HXX //autogen
#include <sfx2/macropg.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVX_FMPROP_HXX
#include "fmprop.hxx"
#endif
#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif
#ifndef _SVX_FMHELP_HRC
#include "fmhelp.hrc"
#endif
#include <set>
#ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
#include <com/sun/star/util/XLocalizedAliases.hpp>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

#include <svtools/urihelper.hxx>

#undef S
#undef U
#ifdef ENABLEUNICODE
#define S(c)		c
#define U(c)		c
#define UNI2XUB(c)	c
#define XUB2ANY(c)	::com::sun::star::uno::makeAny(::rtl::OUString(c))
#else
#define S(c)		UniString(c)
#define U(c)		UniString(c)
#define UNI2XUB(c)	XubString(c)
#define XUB2ANY(c)	::com::sun::star::uno::makeAny(::rtl::OUString(UniString(c)))
#endif

#define PROPEV_TYPE 0xffffffff


::rtl::OUString GetUIHeadlineName(sal_Int16 nClassId, const ::com::sun::star::uno::Any& aUnoObj)
{
	::rtl::OUString aClassName;
	switch (nClassId)
	{
		case ::com::sun::star::form::FormComponentType::TEXTFIELD:
		{
			::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  xIFace;
			if (aUnoObj.getValueTypeClass() == ::com::sun::star::uno::TypeClass_INTERFACE)
				xIFace = ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > (*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aUnoObj.getValue(), ::com::sun::star::uno::UNO_QUERY);

			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_EDIT));
			if (xIFace.is())
			{	// we have a chance to check if it's a formatted field model
				::com::sun::star::uno::Reference< ::com::sun::star::lang::XServiceInfo >  xInfo(xIFace, ::com::sun::star::uno::UNO_QUERY);
				if (xInfo.is() && (xInfo->supportsService(FM_SUN_COMPONENT_FORMATTEDFIELD)))
					aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_FORMATTED));
				else if (!xInfo.is())
				{
					// couldn't distinguish between formatted and edit with the service name, so try with the properties
					::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xProps(xIFace, ::com::sun::star::uno::UNO_QUERY);
					if (xProps.is())
					{
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  xPropsInfo = xProps->getPropertySetInfo();
						if (xPropsInfo.is() && xPropsInfo->hasPropertyByName(FM_PROP_FORMATSSUPPLIER))
							aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_FORMATTED));
					}
				}
			}
		}
		break;

		case ::com::sun::star::form::FormComponentType::COMMANDBUTTON:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_PUSHBUTTON)); break;
		case ::com::sun::star::form::FormComponentType::RADIOBUTTON:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_RADIOBUTTON)); break;
		case ::com::sun::star::form::FormComponentType::CHECKBOX:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_CHECKBOX)); break;
		case ::com::sun::star::form::FormComponentType::LISTBOX:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_LISTBOX)); break;
		case ::com::sun::star::form::FormComponentType::COMBOBOX:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_COMBOBOX)); break;
		case ::com::sun::star::form::FormComponentType::GROUPBOX:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_GROUPBOX)); break;
		case ::com::sun::star::form::FormComponentType::IMAGEBUTTON:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_IMAGEBUTTON)); break;
		case ::com::sun::star::form::FormComponentType::FIXEDTEXT:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_FIXEDTEXT)); break;
		case ::com::sun::star::form::FormComponentType::GRIDCONTROL:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_DBGRID)); break;
		case ::com::sun::star::form::FormComponentType::FILECONTROL:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_FILECONTROL)); break;

		case ::com::sun::star::form::FormComponentType::DATEFIELD:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_DATEFIELD)); break;
		case ::com::sun::star::form::FormComponentType::TIMEFIELD:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_TIMEFIELD)); break;
		case ::com::sun::star::form::FormComponentType::NUMERICFIELD:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_NUMERICFIELD)); break;
		case ::com::sun::star::form::FormComponentType::CURRENCYFIELD:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_CURRENCYFIELD)); break;
		case ::com::sun::star::form::FormComponentType::PATTERNFIELD:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_PATTERNFIELD)); break;
		case ::com::sun::star::form::FormComponentType::IMAGECONTROL:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_PROPTITLE_IMAGECONTROL)); break;
		case ::com::sun::star::form::FormComponentType::HIDDENCONTROL:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_HIDDEN_CLASSNAME)); break;

		case ::com::sun::star::form::FormComponentType::CONTROL:
		default:
			aClassName = ::rtl::OUString(SVX_RES(RID_STR_CONTROL_CLASSNAME)); break;
	}

	return aClassName;
}

// Vergleichen von PropertyInfo
static int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	EvtUIDescCompare(const void* pFirst, const void* pSecond)
{
	return ((EvtUiDesc*)pFirst)->aName.compareTo(((EvtUiDesc*)pSecond)->aName);
}

EvtUiDesc* GetEvtTranslation(const ::rtl::OUString& rName)
{
	static EvtUiDesc* pEventTranslation = NULL;
	static sal_Int32 nCount = 0;
	if (!pEventTranslation)
	{
		static EvtUiDesc __READONLY_DATA aEvtUiDescs[] =
		{
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XApproveActionListener::approveAction"),	 SVX_RESSTR(RID_STR_EVT_APPROVEACTIONPERFORMED),HID_EVT_APPROVEACTIONPERFORMED),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XActionListener::actionPerformed"),	 SVX_RESSTR(RID_STR_EVT_ACTIONPERFORMED		),HID_EVT_ACTIONPERFORMED		),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XChangeListener::changed"),			 SVX_RESSTR(RID_STR_EVT_CHANGED				),HID_EVT_CHANGED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XTextListener::textChanged"),		 SVX_RESSTR(RID_STR_EVT_TEXTCHANGED			),HID_EVT_TEXTCHANGED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XItemListener::itemStateChanged"), SVX_RESSTR(RID_STR_EVT_ITEMSTATECHANGED	),HID_EVT_ITEMSTATECHANGED		),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XFocusListener::focusGained"),		 SVX_RESSTR(RID_STR_EVT_FOCUSGAINED			),HID_EVT_FOCUSGAINED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XFocusListener::focusLost"),		 SVX_RESSTR(RID_STR_EVT_FOCUSLOST			),HID_EVT_FOCUSLOST				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XKeyListener::keyPressed"),		 SVX_RESSTR(RID_STR_EVT_KEYTYPED			),HID_EVT_KEYTYPED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XKeyListener::keyReleased"),		 SVX_RESSTR(RID_STR_EVT_KEYUP				),HID_EVT_KEYUP				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseListener::mouseEntered"),	 SVX_RESSTR(RID_STR_EVT_MOUSEENTERED		),HID_EVT_MOUSEENTERED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseMotionListener::mouseDragged"),	 SVX_RESSTR(RID_STR_EVT_MOUSEDRAGGED		),HID_EVT_MOUSEDRAGGED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseMotionListener::mouseMoved"),		 SVX_RESSTR(RID_STR_EVT_MOUSEMOVED			),HID_EVT_MOUSEMOVED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseListener::mousePressed"),	 SVX_RESSTR(RID_STR_EVT_MOUSEPRESSED		),HID_EVT_MOUSEPRESSED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseListener::mouseReleased"),	 SVX_RESSTR(RID_STR_EVT_MOUSERELEASED		),HID_EVT_MOUSERELEASED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.awt.XMouseListener::mouseExited"),		 SVX_RESSTR(RID_STR_EVT_MOUSEEXITED			),HID_EVT_MOUSEEXITED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XResetListener::approveReset"),	 SVX_RESSTR(RID_STR_EVT_APPROVERESETTED		),HID_EVT_APPROVERESETTED		),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XResetListener::resetted"),		 SVX_RESSTR(RID_STR_EVT_RESETTED			),HID_EVT_RESETTED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XSubmitListener::approveSubmit"),	 SVX_RESSTR(RID_STR_EVT_SUBMITTED			),HID_EVT_SUBMITTED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XUpdateListener::approveUpdate"),	 SVX_RESSTR(RID_STR_EVT_BEFOREUPDATE		),HID_EVT_BEFOREUPDATE			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XUpdateListener::updated"),			 SVX_RESSTR(RID_STR_EVT_AFTERUPDATE			),HID_EVT_AFTERUPDATE			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XLoadListener::loaded"),			 SVX_RESSTR(RID_STR_EVT_LOADED				),HID_EVT_LOADED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XLoadListener::reloaded"),		 SVX_RESSTR(RID_STR_EVT_RELOADED			),HID_EVT_RELOADED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XLoadListener::unloaded"),		 SVX_RESSTR(RID_STR_EVT_UNLOADED			),HID_EVT_UNLOADED				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XConfirmDeleteListener::confirmDelete"),	 SVX_RESSTR(RID_STR_EVT_CONFIRMDELETE		),HID_EVT_CONFIRMDELETE			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.sdb.XRowSetApproveListener::approveRowChange"), SVX_RESSTR(RID_STR_EVT_APPROVEROWCHANGE	),HID_EVT_APPROVEROWCHANGE		),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.sdbc.XRowSetListener::rowChanged"),		 SVX_RESSTR(RID_STR_EVT_ROWCHANGE			),HID_EVT_ROWCHANGE				),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.sdb.XRowSetApproveListener::approveCursorMove"),SVX_RESSTR(RID_STR_EVT_POSITIONING			),HID_EVT_POSITIONING			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.sdbc.XRowSetListener::cursorMoved"),		 SVX_RESSTR(RID_STR_EVT_POSITIONED			),HID_EVT_POSITIONED			),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XDatabaseParameterListener::approveParameter"), SVX_RESSTR(RID_STR_EVT_APPROVEPARAMETER	),HID_EVT_APPROVEPARAMETER		),
			EvtUiDesc(nCount++,::rtl::OUString::createFromAscii("com.sun.star.form.XErrorListener::errorOccured"),	 SVX_RESSTR(RID_STR_EVT_ERROROCCURED		),HID_EVT_ERROROCCURED			),
		};
		pEventTranslation = (EvtUiDesc*)aEvtUiDescs;
		nCount = sizeof(aEvtUiDescs) / sizeof(EvtUiDesc);

		qsort((void*) aEvtUiDescs,
			 nCount,
			 sizeof(EvtUiDesc),
			 &EvtUIDescCompare);
	}

	EvtUiDesc aSearch(0, rName, String(), 0);
	return (EvtUiDesc*)bsearch(&aSearch, (void*)pEventTranslation, nCount, sizeof(EvtUiDesc), &EvtUIDescCompare);
}

class SvxPropDataLess
{
public:
	bool operator() (const SvxPropData& lhs, const SvxPropData& rhs) const
	{	return lhs.nBtUniqueId < rhs.nBtUniqueId;	}
};

//------------------------------------------------------------------------
void FmPropController::InsertEvents()
{
	//////////////////////////////////////////////////////////////////////
	// Seite fuer Events
	nEventPage = pPropBox->AppendPage(SVX_RESSTR(RID_STR_EVENTS),HID_FM_PROPDLG_TAB_EVT);

	sal_Bool  bRemoveFlag=sal_True;

try
{
	::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess >  xIndexAcc(xParentObjInter, ::com::sun::star::uno::UNO_QUERY);
	sal_Int32 nObjIdx=-1;

	if (xIndexAcc.is() && aUnoObj.getValueTypeClass() == ::com::sun::star::uno::TypeClass_INTERFACE)

	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSet((*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aUnoObj.getValue()), ::com::sun::star::uno::UNO_QUERY);
		sal_Int32 nCount=xIndexAcc->getCount();

		::com::sun::star::uno::Any aWuerg;
		for(sal_Int32 i=0;i<nCount;i++)
		{
			aWuerg=xIndexAcc->getByIndex(i);
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xTestSet((*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aWuerg.getValue()), ::com::sun::star::uno::UNO_QUERY);
			if(( ::com::sun::star::beans::XPropertySet *)xTestSet.get() == ( ::com::sun::star::beans::XPropertySet *)xSet.get())
			{
				nObjIdx=i;
				break;
			}
		}
	}

	sal_uInt32 nScrEvts=0;
	::com::sun::star::uno::Sequence< ::com::sun::star::script::ScriptEventDescriptor > aSeqScrEvts;
	if(nObjIdx>=0 && xEvManager.is())
	{
		 aSeqScrEvts=xEvManager->getScriptEvents(nObjIdx);
		 nScrEvts=aSeqScrEvts.getLength();
	}

	sal_uInt32 nLength = aListenerSeq.getLength();
	const ::com::sun::star::uno::Type * pListeners = aListenerSeq.getConstArray();

	SvxPropData aProperty;
	aProperty.pDataPtr= (void *) PROPEV_TYPE;
	aProperty.bIsLocked = sal_True;

	const ::com::sun::star::script::ScriptEventDescriptor* pEvDes = aSeqScrEvts.getConstArray();
	set<SvxPropData, SvxPropDataLess> aEventSet;
	String aListener;
	String aListenerClassName;
	String aMethName;
	for( sal_uInt32 i = 0 ; i < nLength ; ++i, ++pListeners )
	{
		// Methode ansprechen
		//	const ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass > & rxClass = pListeners[i];

		// Namen besorgen
		aListener = (const sal_Unicode*)pListeners->getTypeName();
		sal_Int32 nTokenCount = aListener.GetTokenCount('.');


		if(nTokenCount>0)
			aListenerClassName= aListener.GetToken(nTokenCount-1, '.' );
		else
			aListenerClassName= aListener;

		if (aListenerClassName.Len() != 0)
		{
			// Methoden der Listener ausgeben
			::com::sun::star::uno::Sequence< ::rtl::OUString > aMethSeq(getEventMethods( *pListeners ));
			const ::rtl::OUString * pMethods = aMethSeq.getConstArray();
			sal_uInt32 nMethCount = aMethSeq.getLength();

			for( sal_uInt32 j = 0 ; j < nMethCount ; j++,++pMethods )
			{
				//	::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlMethod >  xMethod = pMethods[ j ];

				//	aMethName=xMethod->getName();
				aProperty.eKind = KOC_EDIT;
				aProperty.aName = aListenerClassName;
				aProperty.aName += UniString(';');
				aProperty.aName += (const sal_Unicode*)*pMethods;
				aProperty.aTitle = (const sal_Unicode*)*pMethods;
				aProperty.nHelpId=0;
				aProperty.aValue = String();
				aProperty.bHasVisibleXButton = sal_True;

				for (sal_uInt32 nI=0; nI<nScrEvts;nI++)
				{
					const ::com::sun::star::script::ScriptEventDescriptor& rEvDe = pEvDes[nI];
					if (aListenerClassName.Equals((const sal_Unicode*)rEvDe.ListenerType) && pMethods->equals(rEvDe.EventMethod))
						aProperty.aValue = (const sal_Unicode*)rEvDe.ScriptCode;
				}

				EvtUiDesc *pEvtUiDesc = GetEvtTranslation(*pMethods);
				if (pEvtUiDesc!=NULL)
				{
					aProperty.aTitle = pEvtUiDesc->aTrans;
					aProperty.nHelpId= pEvtUiDesc->nHelpId;
					aProperty.nBtUniqueId=pEvtUiDesc->nIndex;
					aEventSet.insert(aProperty);
				}
			}
		}
	}

	for (set<SvxPropData, SvxPropDataLess>::const_iterator iter = aEventSet.begin(); iter != aEventSet.end(); iter++)
	{
		// Now set the right id
		SvxPropData aData(*iter);
		aData.nBtUniqueId=UID_EVT_MACRODLG;
		pPropBox->InsertEntry( aData );
	}

	bRemoveFlag = aEventSet.empty();
}
catch(...)
{
	DBG_ERROR("FmPropController::InsertEvents : catched an exception !")
	bRemoveFlag=sal_True;
}


	if(bRemoveFlag)
	{
		pPropBox->RemovePage(nEventPage);
		nEventPage=0;
	}
}


//------------------------------------------------------------------------
void FmPropController::UpdateUI()
{
	// ::com::sun::star::beans::Introspection auswerten
try
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  aPropSet;

	if(xUnoAccess.is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  a2PropSet(
			xUnoAccess->queryAdapter(::getCppuType((const
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>*)0)), ::com::sun::star::uno::UNO_QUERY);


		aPropSet=a2PropSet;

		Window* pPa=pPropBox->GetParent()->GetParent();
		if (pPa)
		{
			UniString aTitle=pPa->GetText();
			sal_Bool bTitleSet(sal_False);
			if (::utl::hasProperty(FM_PROP_CLASSID, aPropSet))
			{
				::com::sun::star::uno::Any aUsrTest( aPropSet->getPropertyValue(FM_PROP_CLASSID));
				if (!aUsrTest.getValueType().equals( ::getVoidCppuType()))

				{
					sal_Int16 nClassID = ::utl::getINT16(aPropSet->getPropertyValue(FM_PROP_CLASSID));
					aTitle += GetUIHeadlineName(nClassID, aUnoObj).getStr();
					pPa->SetText(aTitle);
					bTitleSet = sal_True;
				}
			}
			else if (!::utl::hasProperty(FM_PROP_DATASOURCE, aPropSet) || !::utl::hasProperty(FM_PROP_NAME, aPropSet))
			{	// no form component and (no form or no name) -> Multiselection
				aTitle += SVX_RESSTR(RID_STR_PROPTITLE_MULTISELECT);
				pPa->SetText(aTitle);
			}
		}
	}
	pPropBox->DisableUpdate();
	bLongValue=sal_False;

	InsertEvents();
	sal_uInt32 nPropCount = aPropSeq.getLength();
	const ::com::sun::star::beans::Property*	pProps = aPropSeq.getConstArray();
	SvxPropData* pProperty;
	sal_Bool bRemoveDatPage=sal_True;

	::com::sun::star::uno::TypeClass eType;
	::com::sun::star::uno::Any aVal,aSupplier,aKey,aDigits,aSeparator,aDefault;
	::rtl::OUString aStrVal;
	::com::sun::star::beans::PropertyState eState;

	for( sal_uInt32 i=0; i<nPropCount; i++,++pProps )
	{
		//	const ::com::sun::star::beans::Property& rProp = pProps[i];
		pProperty = new SvxPropData();

		const FmPropertyInfo* pFmPropInfo = FmPropertyInfoService::getPropertyInfo(pProps->Name);
		if (!pFmPropInfo)
		{
			delete pProperty;
			continue;
		}

		sal_Int32 nPropId = pFmPropInfo->nId;

		if (nPropId==FM_ATTR_SIZE)
		{
			delete pProperty;
			continue;
		}

		//////////////////////////////////////////////////////////////////////
		// ::com::sun::star::uno::TypeClass des Property ermitteln

		eType = pProps->Type.getTypeClass();

		//////////////////////////////////////////////////////////////////////
		// Wert holen und in ::rtl::OUString wandeln
		eState=::com::sun::star::beans::PropertyState_DIRECT_VALUE;
		if(xPropertyState.is()) eState=xPropertyState->getPropertyState(pProps->Name);

		aVal = aPropSet->getPropertyValue( pProps->Name );
		aStrVal = AnyToString(aVal, *pProps, nPropId);

		//////////////////////////////////////////////////////////////////////
		// Default Properties
		pProperty->eKind = KOC_EDIT;
		pProperty->aName = (const sal_Unicode*)pProps->Name;
		pProperty->aTitle = (const sal_Unicode*)pProps->Name;
		pProperty->aValue = (const sal_Unicode*)aStrVal;
		pProperty->pControl = NULL;
		pProperty->bIsLocked = sal_False;
		pProperty->bHasVisibleXButton = sal_False;
		pProperty->bIsHyperLink = sal_False;

		if((pProps->Attributes & ::com::sun::star::beans::PropertyAttribute::MAYBEVOID) && nPropId != FM_ATTR_BORDER) //&& eState!=DIRECT_VALUE
		{
			pProperty->bHasDefault =sal_True;
			if(aVal.getValueType().equals( ::getVoidCppuType()))

				pProperty->aValue = (const sal_Unicode*)aStandard;
		}
		else
			pProperty->bHasDefault =sal_False;

		//////////////////////////////////////////////////////////////////////
		// Font
		sal_Bool bFilter = sal_True;
		if( nPropId== FM_ATTR_TEXTCOLOR)
		{
			nFontColorPos = i;
			delete pProperty;
			continue;
		}
		else if( nPropId == FM_ATTR_FONT_NAME)
		{
			bFilter = sal_False;
			nFontTypePos = i;

			pProperty->aName = String::CreateFromAscii("Font");
			pProperty->aTitle = String::CreateFromAscii("Font");
			pProperty->bIsLocked = sal_True;
			pProperty->bHasVisibleXButton = sal_True;
			pProperty->nBtUniqueId=UID_PROP_DLG_FONT_TYPE;
			aVal >>= (::rtl::OUString)pProperty->aValue;
		}
		else if( nPropId == FM_ATTR_TARGET_URL)
		{
			pProperty->bHasVisibleXButton = sal_True;
			pProperty->nBtUniqueId=UID_PROP_DLG_ATTR_TARGET_URL;
		}
		else if( nPropId == FM_ATTR_IMAGE_URL)
		{
			pProperty->bHasVisibleXButton = sal_True;
			pProperty->nBtUniqueId=UID_PROP_DLG_IMAGE_URL;
		}

		else if( nPropId== FM_ATTR_ECHO_CHAR)
		{
			pProperty->eKind = KOC_CHAREDIT;  //@ new CharEdit
		}
		//////////////////////////////////////////////////////////////////////
		// Color
		else if( nPropId== FM_ATTR_BACKGROUNDCOLOR )
		{
			bFilter = sal_False;
			pProperty->eKind = KOC_COLORBOX;  //@ new ColorListbox
			pProperty->bIsLocked = sal_True;
			pProperty->bHasVisibleXButton = sal_True;
			pProperty->nBtUniqueId=UID_PROP_DLG_BACKGROUNDCOLOR;

		}

		else if (nPropId == FM_ATTR_LABEL || nPropId == FM_ATTR_TEXT
				|| nPropId == FM_ATTR_GROUPBOX || nPropId == FM_ATTR_DEFAULT_TEXT)
		{
			pProperty->eKind = KOC_MEDIT;  //@ new MultilineEdit
		}
		else if (FM_ATTR_CONTROLLABEL == nPropId)
		{
			bFilter = sal_False;
			pProperty->bHasVisibleXButton = sal_True;
			pProperty->bIsLocked = sal_True;
			pProperty->aValue = (const sal_Unicode*)AnyToString(aVal, *pProps, FM_ATTR_CONTROLLABEL);
			pProperty->nBtUniqueId = UID_PROP_DLG_CONTROLLABEL;
		}
		else if ((FM_ATTR_FORMATKEY == nPropId) || (FM_ATTR_EFFECTIVE_MIN == nPropId)
			|| (FM_ATTR_EFFECTIVE_MAX == nPropId) || (FM_ATTR_EFFECTIVE_DEFAULT == nPropId))
		{
			// only if the set has a formatssupplier, too
			if (::utl::hasProperty(FM_PROP_FORMATSSUPPLIER, aPropSet))
			{
				// and the supplier is really available
				aSupplier = aPropSet->getPropertyValue(FM_PROP_FORMATSSUPPLIER);
				if (aSupplier.hasValue() && aSupplier.getValueType().equals(
					::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier>*)0)))

				{
					// and it has an implementation we know
					::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(*(::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > *)aSupplier.getValue());
					::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel > xTunnel(xSupplier,::com::sun::star::uno::UNO_QUERY);
					DBG_ASSERT(xTunnel.is(), "FmPropController::ChangeFormatProperty : xTunnel is invalid!");
					SvNumberFormatsSupplierObj* pSupplier = (SvNumberFormatsSupplierObj*)xTunnel->getSomething(SvNumberFormatsSupplierObj::getUnoTunnelId());

					if (pSupplier != NULL)
					{
						bFilter = sal_False;	// don't do further checks
						sal_Bool bIsFormatKey = (FM_ATTR_FORMATKEY == nPropId);

						pProperty->eKind = KOC_USERDEFINED;

						pProperty->bIsLocked = bIsFormatKey;
						pProperty->bHasVisibleXButton = bIsFormatKey;

						if (bIsFormatKey)
						{
							pProperty->pControl = new SvxPropFormatEdit(pPropBox, aStandard, WB_READONLY | WB_TABSTOP | WB_BORDER);
								// HACK : the Control need's a non-null parent, but we don't have one ... so use the property box
							((SvxPropFormatEdit*)pProperty->pControl)->SetFormatSupplier(pSupplier);

							pProperty->nBtUniqueId=UID_PROP_DLG_NUMBER_FORMAT;
						}
						else
						{
							pProperty->pControl = new SvxPropDoubleNumericField(pPropBox, aStandard, WB_TABSTOP | WB_BORDER);
								// HACK : same as above

							FormatDescription aDesc;
							aDesc.pSupplier = pSupplier;
							aKey = aPropSet->getPropertyValue(FM_PROP_FORMATKEY);
							aDesc.nKey = aKey.hasValue() ? ::utl::getINT32(aKey) : 0;
							((SvxPropDoubleNumericField*)pProperty->pControl)->SetFormatDescription(aDesc);
						}

						// the initial value
						if (!aVal.getValueType().equals(::getVoidCppuType()))

						{
							if (bIsFormatKey)
							{
								pProperty->aValue = String::CreateFromInt32(::utl::getINT32(aVal));
							}
							else
							{

								if (aVal.getValueTypeClass() == ::com::sun::star::uno::TypeClass_DOUBLE)

									pProperty->aValue = (const sal_Unicode*)AnyToStr(aVal);
								else
									DBG_WARNING("FmPropController::UpdateUI : non-double values not supported for Effective*-properties !");
									// our UI supports only setting double values for the min/max/default, but by definition
									// the default may be a string if the field is not in numeric mode ....
							}
						}
					}
				}
			}
		}
		//////////////////////////////////////////////////////////////////////
		// ::rtl::OUString ::com::sun::star::uno::Sequence
		else if( eType == ::com::sun::star::uno::TypeClass_SEQUENCE )
		{
			pProperty->eKind = KOC_LEDIT;
			bFilter = sal_False;
		}

		else if( ::com::sun::star::uno::TypeClass_BYTE <=eType && eType<=::com::sun::star::uno::TypeClass_DOUBLE)
		{
			if(	nPropId==FM_ATTR_DATE || nPropId==FM_ATTR_DATEMIN || nPropId==FM_ATTR_DATEMAX || nPropId==FM_ATTR_DEFAULT_DATE)
				pProperty->eKind = KOC_DATEFIELD;
			else if(nPropId==FM_ATTR_TIME || nPropId==FM_ATTR_TIMEMIN || nPropId==FM_ATTR_TIMEMAX|| nPropId==FM_ATTR_DEFAULT_TIME)
				pProperty->eKind = KOC_TIMEFIELD;
			else
			{
				if (nPropId== FM_ATTR_VALUEMIN || nPropId== FM_ATTR_VALUEMAX || nPropId==FM_ATTR_DEFAULT_VALUE)
				{
					pProperty->eKind = KOC_USERDEFINED;
					pProperty->pControl = new SvxPropDoubleNumericField(pPropBox, aStandard, WB_TABSTOP | WB_BORDER | WB_SPIN);
						// HACK : same as above

					// we don't set a formatter so the control uses a default (which uses the application
					// language and a default numeric format)
					// but we set the decimal digits
					aDigits = aPropSet->getPropertyValue(FM_PROP_DECIMAL_ACCURACY);
					((SvxPropDoubleNumericField*)pProperty->pControl)->SetDecimalDigits(::utl::getINT16(aDigits));

					// and the thousands separator
					aSeparator = aPropSet->getPropertyValue(FM_PROP_SHOWTHOUSANDSEP);
					((SvxPropDoubleNumericField*)pProperty->pControl)->SetThousandsSep(::utl::getBOOL(aSeparator));

					// and the default value for the property
					try
					{
						if (xPropertyState.is() && ((FM_ATTR_VALUEMIN == nPropId) || (FM_ATTR_VALUEMAX == nPropId)))
						{
							aDefault = xPropertyState->getPropertyDefault(pProps->Name);
							if (aDefault.getValueTypeClass() == ::com::sun::star::uno::TypeClass_DOUBLE)

								((SvxPropDoubleNumericField*)pProperty->pControl)->SetDefaultValue(::utl::getDouble(aDefault));
						}
					}
					catch(...)
					{
						// just ignore it
					}

					// and allow empty values only for the default value
					((SvxPropDoubleNumericField*)pProperty->pControl)->EnableEmptyField(FM_ATTR_DEFAULT_VALUE == nPropId);
				}
				else
				{
					if(nPropId== FM_ATTR_HEIGHT || nPropId== FM_ATTR_WIDTH || nPropId== FM_ATTR_ROWHEIGHT)
						pProperty->nDigits=1;

					pProperty->eKind = KOC_NUMFIELD;
				}
			}
		}

		//////////////////////////////////////////////////////////////////////
		// Filter
		if( bFilter )
		{
			switch( eType )		// ::com::sun::star::uno::TypeClass Inspection
			{
			case ::com::sun::star::uno::TypeClass_INTERFACE:
			case ::com::sun::star::uno::TypeClass_ARRAY:
				delete pProperty;
				continue;
			}

			switch( aVal.getValueTypeClass() )		// ::com::sun::star::uno::TypeClass ::com::sun::star::uno::Any

			{
			case ::com::sun::star::uno::TypeClass_VOID:
				if (pProps->Attributes & ::com::sun::star::beans::PropertyAttribute::MAYBEVOID)
					break;

			case ::com::sun::star::uno::TypeClass_INTERFACE:
			case ::com::sun::star::uno::TypeClass_ARRAY:
			case ::com::sun::star::uno::TypeClass_UNKNOWN:
				delete pProperty;
				continue;
			}

			switch( nPropId )
			{
			case FM_ATTR_CURSORTYPE:
			case FM_ATTR_DEFAULTCONTROL:
				delete pProperty;
				continue;
			}

			if( pProps->Name.compareTo(::rtl::OUString::createFromAscii("type unknown")) == COMPARE_EQUAL )
			{
				delete pProperty;
				continue;
			}

			if( pProps->Attributes & ::com::sun::star::beans::PropertyAttribute::TRANSIENT )
			{
				delete pProperty;
				continue;
			}

			else if( pProps->Attributes & ::com::sun::star::beans::PropertyAttribute::READONLY )
			{
				delete pProperty;
				continue;
			}
		}

		//////////////////////////////////////////////////////////////////////
		// sal_Bool-Werte
		if( eType == ::com::sun::star::uno::TypeClass_BOOLEAN )
		{
			UniString aEntries( SVX_RES(RID_STR_BOOL) );
			for ( xub_StrLen i=0; i<2; ++i )
				pProperty->theValues.push_back( aEntries.GetToken(i) );

			pProperty->eKind = KOC_LISTBOX;
		}

		//////////////////////////////////////////////////////////////////////
		// TYPECLASS_VOID
		else if( eType == ::com::sun::star::uno::TypeClass_VOID )
			pProperty->aValue = String();

		//////////////////////////////////////////////////////////////////////
		// Listen mit ResStrings fuellen
		switch( nPropId )
		{
			case FM_ATTR_COMMANDTYPE:
		//case FM_ATTR_SEARCH:
			case FM_ATTR_ALIGN:
			case FM_ATTR_CURSORTYPE:
			case FM_ATTR_BUTTONTYPE:
			case FM_ATTR_SUBMIT_METHOD:
			case FM_ATTR_SUBMIT_ENCODING:
			case FM_ATTR_DATEFORMAT:
			case FM_ATTR_TIMEFORMAT:
			case FM_ATTR_BORDER:
			case FM_ATTR_CYCLE:
			case FM_ATTR_NAVIGATION:
			{
				UniString aEntries = GetEnumString( nPropId );
				for ( xub_StrLen i=0; i<aEntries.GetTokenCount(); ++i )
					pProperty->theValues.push_back( aEntries.GetToken(i));

				pProperty->eKind = KOC_LISTBOX;
			}
			break;
		case FM_ATTR_DEFAULT_CHECKED:
		{
			UniString aEntries = GetEnumString( nPropId );
			xub_StrLen nEntryCount = aEntries.GetTokenCount();

			sal_Bool bTriState= ::utl::hasProperty(FM_PROP_TRISTATE, aPropSet);
			if (!bTriState)
			{
				nEntryCount--;
			}
			else
			{
				::com::sun::star::uno::Any aUsrTest= aPropSet->getPropertyValue(FM_PROP_TRISTATE);
				if(!::utl::getBOOL(aUsrTest))
						nEntryCount--;
			}

			for ( xub_StrLen i=0; i<nEntryCount; ++i )
				pProperty->theValues.push_back(aEntries.GetToken(i));

			pProperty->eKind = KOC_LISTBOX;
		}
		break;

		case FM_ATTR_LISTSOURCETYPE:
		{
			UniString aEntries = GetEnumString( nPropId );
			xub_StrLen i = 0;
			// Combobox kennt keine WerteListe
			if (::utl::hasProperty(FM_PROP_CLASSID, aPropSet))
			{
				::com::sun::star::uno::Any aUsrTest= aPropSet->getPropertyValue(FM_PROP_CLASSID);
				if (!aUsrTest.getValueType().equals( ::getVoidCppuType()))

				{
					sal_Int16 nClassID = ::utl::getINT16(aPropSet->getPropertyValue(FM_PROP_CLASSID));
					if (nClassID == ::com::sun::star::form::FormComponentType::COMBOBOX)
						++i;
				}
			}
			for (; i<aEntries.GetTokenCount(); ++i)
				pProperty->theValues.push_back( aEntries.GetToken(i));

			pProperty->eKind = KOC_LISTBOX;
		}
		break;
		case FM_ATTR_TARGET_FRAME:
		{
			UniString aEntries( SVX_RES(RID_STR_ENUM_SUBMIT_TARGET) );
			for ( xub_StrLen i=0; i<aEntries.GetTokenCount(); ++i )
				pProperty->theValues.push_back(aEntries.GetToken(i));

			pProperty->eKind = KOC_COMBOBOX;
		}
		break;

		}

		//////////////////////////////////////////////////////////////////////
		// DataSource
		if( nPropId == FM_ATTR_DATASOURCE )
		{
			pProperty->nBtUniqueId=UID_PROP_DLG_ATTR_DATASOURCE;
			// if the form already belong to a Database, don't set this property
			::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection >  xConnection = findConnection(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aUnoObj.getValue());
			if (xConnection.is())
			{
				pProperty->bHasVisibleXButton = sal_False;
				pProperty->bIsLocked = sal_True;
				pProperty->eKind = KOC_EDIT;

				// maybe the string value of the property is empty. this is allowed by the service definition,
				// (the form will use the connection we found here as it's datasource, so it does not need a
				// data source description)
				// of course we want to show the user a data source name anyway.
				// FS - 74645 - 31.03.00
				if (!pProperty->aValue.Len())
				{
					::rtl::OUString sDisplayName;
					try
					{
						// first find somebody who can give us an URL the connection is build upon
						::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >
							xTitleSupplier(xConnection, ::com::sun::star::uno::UNO_QUERY);
						if (!xTitleSupplier.is() || !::utl::hasProperty(FM_PROP_URL, xTitleSupplier))
						{
							::com::sun::star::uno::Reference< ::com::sun::star::container::XChild >
								xConnAsChild(xConnection, ::com::sun::star::uno::UNO_QUERY);
							if (xConnAsChild.is())
								xTitleSupplier =
									::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >::query(xConnAsChild->getParent());
						}

						if (xTitleSupplier.is() && ::utl::hasProperty(FM_PROP_URL, xTitleSupplier))
						{
							sDisplayName = ::utl::getString(xTitleSupplier->getPropertyValue(FM_PROP_URL));
							// then check if we have an alias for the URL
							::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases >
								xAliases(::utl::getProcessServiceFactory()->createInstance(SRV_SDB_DATABASE_ACCESS_CONTEXT), ::com::sun::star::uno::UNO_QUERY);
							if (xAliases.is())
							{
								//////////////////////////////////////////////////////////////////////
								// get the application language
								XubString sLanguage, sCountry;
								ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
								sDisplayName = xAliases->lookupProgrammatic(::com::sun::star::lang::Locale(U(sLanguage), U(sCountry), ::rtl::OUString()), sDisplayName);
							}
						}
					}
					catch(...)
					{
					}
					pProperty->aValue = (const sal_Unicode*)sDisplayName;
				}
			}
			else
			{
				pProperty->bHasVisibleXButton = sal_True;
				pProperty->eKind = KOC_COMBOBOX;

				::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases >  xAliases(::utl::getProcessServiceFactory()->createInstance(SRV_SDB_DATABASE_ACCESS_CONTEXT), ::com::sun::star::uno::UNO_QUERY);
				if (xAliases.is())
				{
					// get the application language
					XubString sLanguage, sCountry;
					ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
					// get all registered names for that language
					UniString aLan(sLanguage),aCoun(sCountry);
					::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair> aAliases = xAliases->listAliases(::com::sun::star::lang::Locale(aLan, aCoun, ::rtl::OUString()));
					const ::com::sun::star::util::AliasProgrammaticPair* pAliases = aAliases.getConstArray();
					for (sal_Int32 i = 0; i < aAliases.getLength(); ++i, ++pAliases)
						pProperty->theValues.push_back(pAliases->Alias);
				}
			}
		}

		//////////////////////////////////////////////////////////////////////
		// ControlSource
		else if( nPropId == FM_ATTR_CONTROLSOURCE )
			SetFields( *pProperty );

		//////////////////////////////////////////////////////////////////////
		// CursorSource
		else if (nPropId == FM_ATTR_COMMAND)
			bHasCursorSource = sal_True;

		//////////////////////////////////////////////////////////////////////
		// ListSource
		else if( nPropId == FM_ATTR_LISTSOURCE )
			bHasListSource = sal_True;

		//////////////////////////////////////////////////////////////////////
		// UI-Eintrag
		switch( nPropId ) 		// DataPage
		{
			case FM_ATTR_COMMAND:
			case FM_ATTR_CONTROLSOURCE:
			case FM_ATTR_LISTSOURCE:
			case FM_ATTR_LISTSOURCETYPE:
			case FM_ATTR_BOUNDCOLUMN:
			case FM_ATTR_MASTERFIELDS:
			case FM_ATTR_DETAILFIELDS:
			case FM_ATTR_DATASOURCE:
			case FM_ATTR_COMMANDTYPE:
			case FM_ATTR_CURSORTYPE:
			case FM_ATTR_INSERTONLY:
			case FM_ATTR_NAVIGATION:
			case FM_ATTR_CYCLE:
			case FM_ATTR_ALLOWADDITIONS:
			case FM_ATTR_ALLOWEDITS:
			case FM_ATTR_ALLOWDELETIONS:
			case FM_ATTR_CACHESIZE:
			case FM_ATTR_PRIVILEGES:
			case FM_ATTR_ESCAPE_PROCESSING:
			case FM_ATTR_LASTDIRTY:
			case FM_ATTR_FILTER_CRITERIA:
			case FM_ATTR_SORT:
			case FM_ATTR_EMPTY_IS_NULL:
			case FM_ATTR_FILTERPROPOSAL:
				bRemoveDatPage =sal_False;
				pPropBox->SetPage( nDataPage );
				break;
			default:
				pPropBox->SetPage( nDefaultPage );
		}

		pProperty->nHelpId=pFmPropInfo->nHelpId;
		if ( pFmPropInfo->aTranslation.Len() != 0 )
		{

			pProperty->aTitle = pFmPropInfo->aTranslation;
			if(eState==::com::sun::star::beans::PropertyState_AMBIGUOUS_VALUE)
			{
				pProperty->bIsUnknown=sal_True;
				pProperty->aValue = String();
			}
			pPropBox->InsertEntry( *pProperty );
		}

		//////////////////////////////////////////////////////////////////////
		// UI-Objekt zuruecksetzen
		pProperty->theValues.clear();

		delete pProperty;
	}

	SetCursorSource(sal_True);
	SetListSource(sal_True);

	if(bRemoveDatPage && !bHasCursorSource && !bHasListSource)
	{
		pPropBox->RemovePage(nDataPage);
		nDataPage=0;
	}

	pPropBox->SetPage( nDataPage );

	pPropBox->EnableUpdate();
}
catch(...)
{
	DBG_ERROR("FmPropController::UpdateUI : catched an exception !")
}


}


//------------------------------------------------------------------------
void FmPropController::Modified( const XubString& aName, const XubString& aVal, void* pData )
{
try
{
	sal_Int32 nPropId=PROP_ID( aName );

	// Wenn CursorSourceType veraendert wurde, CursorSource anpassen
	if( nPropId == FM_ATTR_COMMANDTYPE )
	{
		Commit( aName, aVal, pData );
		SetCursorSource();
	}

	//////////////////////////////////////////////////////////////////////
	// Wenn ListSourceType veraendert wurde, ListSource anpassen
	if( nPropId == FM_ATTR_LISTSOURCETYPE )
	{
		Commit( aName, aVal, pData );
		SetListSource();
	}
}
catch(...)
{
	DBG_ERROR("FmPropController::Modified : catched an exception !")
}


}

//------------------------------------------------------------------------
void FmPropController::Clicked( const XubString& aName, const XubString& aVal, void* pData )
{
try
{
	sal_Int32 nPropId=PROP_ID( aName );

	//////////////////////////////////////////////////////////////////////
	// DataSource & ImageURL
	if(nPropId == FM_ATTR_TARGET_URL)
	{

		::rtl::OUString aStrTrans=PROP_TRANSLATION( nPropId );

		SfxFileDialog* pDlg = new SfxFileDialog(
					 GetpApp()->GetAppWindow(), WB_3DLOOK );

		pDlg->SetPath( aVal );
		if( pDlg->Execute() == RET_OK )
		{
			XubString aDataSource = pDlg->GetPath();
			Commit( aName, aDataSource, pData );

		}
		delete pDlg;
	}


	//////////////////////////////////////////////////////////////////////
	// Bei Datenquelle auch Cursor-/ListSource fuellen
	else if( nPropId == FM_ATTR_DATASOURCE )
	{
		UniString aUserVal=aVal;

		//////////////////////////////////////////////////////////////////////
		// ::com::sun::star::util::URL- Adresse koennte relativ sein
		aUserVal = INetURLObject::RelToAbs(aVal);

		::com::sun::star::uno::Reference< ::com::sun::star::uno::XNamingService >  xDatabaseAccesses(::utl::getProcessServiceFactory()->createInstance(SRV_SDB_DATABASE_ACCESS_CONTEXT), ::com::sun::star::uno::UNO_QUERY);
		if (xDatabaseAccesses.is())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  xDatabaseAccess;
			try
			{
				xDatabaseAccess = ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >
					(xDatabaseAccesses->getRegisteredObject(aVal), ::com::sun::star::uno::UNO_QUERY);
			}
			catch(::com::sun::star::container::NoSuchElementException& e)
			{
				e;	// make compiler happy
			}
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xAccessProps(xDatabaseAccess, ::com::sun::star::uno::UNO_QUERY);
			::rtl::OUString aURL;
			if (xAccessProps.is())
			{
				DBG_ASSERT(::utl::hasProperty(FM_PROP_URL, xAccessProps), "FmPropController::Clicked : invalid DatabaseAccess object !");
				if (::utl::hasProperty(FM_PROP_URL, xAccessProps))
					aURL = ::utl::getString(xAccessProps->getPropertyValue(FM_PROP_URL));
			}

			if (aURL.len())
				aUserVal = aURL.getStr();
		}

		::rtl::OUString aStrTrans = PROP_TRANSLATION( nPropId );

		SfxFileDialog* pDlg = new SfxFileDialog(GetpApp()->GetAppWindow(), WB_3DLOOK );

		pDlg->SetPath( aUserVal);
		pDlg->AddFilter(String::CreateFromAscii("StarBase"),String::CreateFromAscii("*.sdb"));

		if( pDlg->Execute() == RET_OK )
		{
			XubString aDataSource = pDlg->GetPath();
			Modified( aName, aDataSource, pData );
			Commit( aName, aDataSource, pData );
		}
		delete pDlg;

	}

	//////////////////////////////////////////////////////////////////////
	// ::com::sun::star::util::URL
	else if( nPropId == FM_ATTR_IMAGE_URL)
	{

		::rtl::OUString aStrTrans=PROP_TRANSLATION( nPropId );

		SvxImportGraphicDialog* pDlg = new SvxImportGraphicDialog(
									   NULL,S(aStrTrans),
									   ENABLE_STANDARD );

		if (aVal.Len() != 0)
			pDlg ->SetPath( aVal,sal_False);


		if( pDlg->Execute() == RET_OK )
		{
			XubString aDataSource = pDlg->GetPath();
			Commit( aName, aDataSource, pData );
		}
		delete pDlg;
	}


	//////////////////////////////////////////////////////////////////////
	// Color
	else if( nPropId == FM_ATTR_BACKGROUNDCOLOR )
	{
		sal_uInt32 nColor = aVal.ToInt32();
		Color aColor( nColor );
		SvColorDialog aColorDlg( GetpApp()->GetAppWindow() );
		aColorDlg.SetColor( aColor );

		if( aColorDlg.Execute() )
		{
			aColor = aColorDlg.GetColor();
			nColor = aColor.GetColor();

			String aColorString = String::CreateFromInt32( (sal_Int32)nColor );
			Commit( aName, aColorString, pData );
		}
	}

	else if (nPropId == FM_ATTR_FORMATKEY)
	{
		ChangeFormatProperty(aName, aVal);
	}

	else if (nPropId == FM_ATTR_CONTROLLABEL)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xModel(*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aUnoObj.getValue(), ::com::sun::star::uno::UNO_QUERY);
		FmSelectLabelDialog dlgSelectLabel(GetpApp()->GetAppWindow(), xModel);
		if (RET_OK == dlgSelectLabel.Execute())
		{
			// if the properties transport would be via UsrAnys (instead of strings) we would have a chance
			// to use the regular commit mechanism here ....
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSelected(dlgSelectLabel.GetSelected());
			if (xSelected.is())
				xModel->setPropertyValue(FM_PROP_CONTROLLABEL, ::com::sun::star::uno::makeAny(xSelected));
			else
				xModel->setPropertyValue(FM_PROP_CONTROLLABEL, ::com::sun::star::uno::Any());
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Font
	else if( aName.EqualsAscii("Font"))
	{
		ChangeFontProperty(aName);
	}
	else if(pData == (void *) PROPEV_TYPE)
	{
		ChangeEventProperty(aName);
	}
}
catch(...)
{
	DBG_ERROR("FmPropController::Clicked : catched an exception !")
}


}

//------------------------------------------------------------------------
void FmPropController::Commit( const XubString& rName, const XubString& aVal, void* pData )
{
	if (pChangeListener)
		pChangeListener->Lock();
try
{


	//////////////////////////////////////////////////////////////////////
	// Property-Info holen
	sal_Int32 nPropId=PROP_ID( rName );

	::com::sun::star::beans::Property aProp = GetProperty( rName );

	UniString aUserVal=aVal;

	//////////////////////////////////////////////////////////////////////
	// ::com::sun::star::util::URL- Adresse koennte relativ sein
	if((nPropId == FM_ATTR_TARGET_URL || nPropId == FM_ATTR_IMAGE_URL) && aVal.Len())
	{
		aUserVal = URIHelper::SmartRelToAbs(aVal);
	}

	::com::sun::star::uno::Any aValue;
	if(!(aStandard.equals(U(aVal)) &&(aProp.Attributes & ::com::sun::star::beans::PropertyAttribute::MAYBEVOID)))
	{
		aValue = StringToAny( aUserVal, aProp, nPropId);
	}

	sal_Bool bDontSetToDefault = sal_False;

	if((nPropId==FM_ATTR_VALUE || nPropId==FM_ATTR_DEFAULT_VALUE ||
		nPropId==FM_ATTR_DEFAULT_DATE || nPropId==FM_ATTR_DATE ||
		nPropId==FM_ATTR_DEFAULT_TIME || nPropId==FM_ATTR_TIME || nPropId==FM_ATTR_BOUNDCOLUMN)
		&& aVal.Len()==0)
	{
		aValue = ::com::sun::star::uno::Any();
		bDontSetToDefault = sal_True;
	}

	//////////////////////////////////////////////////////////////////////
	// Wert setzen
	sal_Bool bDontForwardToPropSet = !(aProp.Attributes & ::com::sun::star::beans::PropertyAttribute::MAYBEVOID) &&
				aValue.getValueType().equals( ::getVoidCppuType());


	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  aPropSet(xUnoAccess->queryAdapter(
		::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet>*)0)),
		::com::sun::star::uno::UNO_QUERY);


	if (FM_ATTR_CONTROLLABEL == nPropId)
	{
		bDontForwardToPropSet = sal_True;
		// the string fo the control label is not to be set as PropertyValue, it's only for displaying
		bDontSetToDefault = sal_True;
	}

	if (!bDontForwardToPropSet)
		aPropSet->setPropertyValue( rName, aValue );

	if(xPropertyState.is() && aValue.getValueType().equals( ::getVoidCppuType()) && !bDontSetToDefault)
	{
		xPropertyState->setPropertyToDefault(rName);
	}
	//////////////////////////////////////////////////////////////////////
	// Wert neu holen und ggf. neu setzen
	::com::sun::star::uno::Any aNewValue = aPropSet->getPropertyValue(rName);
	::rtl::OUString aNewStrVal = AnyToString(aNewValue, aProp, nPropId);

	pPropBox->SetPropertyValue( rName, aNewStrVal );

	if(nPropId==FM_ATTR_TRISTATE)
	{
		SvxPropData aProperty;

		sal_Bool isTriState	=	::utl::getBOOL(aNewValue);
		UniString fPropName = FM_PROP_DEFAULTCHECKED;
		aProperty.aName		=	fPropName;
//		aProperty.aName		=	(UniString)FM_PROP_DEFAULTCHECKED;
		aProperty.aTitle	=	PROP_TRANSLATION(FM_ATTR_DEFAULT_CHECKED);
		aProperty.nHelpId	=	PROP_HELPID( FM_ATTR_DEFAULT_CHECKED);
		sal_uInt16 nPos		=	pPropBox->GetPropertyPos(aProperty.aName);
		aProperty.eKind		=	KOC_LISTBOX;
		aProperty.aValue	=	pPropBox->GetPropertyValue(aProperty.aName).getStr();

		UniString aEntries = GetEnumString( FM_ATTR_DEFAULT_CHECKED );

		xub_StrLen nEntryCount = aEntries.GetTokenCount();

		if (!isTriState) nEntryCount--;

		sal_Bool isInside=sal_False;
		for( xub_StrLen i=0; i<nEntryCount; i++ )
		{
			aProperty.theValues.push_back( aEntries.GetToken(i));
			if(aProperty.aValue == aEntries.GetToken(i))
				isInside=sal_True;
		}

		if(!isInside)
			aProperty.aValue=aEntries.GetToken(0);

		if(nPos!=LISTBOX_ENTRY_NOTFOUND)
			pPropBox->ChangeEntry( aProperty,nPos);

		aProperty.theValues.clear();

		Commit(aProperty.aName,aProperty.aValue,NULL);
	}
	else if ((FM_ATTR_DECIMAL_ACCURACY == nPropId) || (FM_ATTR_SHOWTHOUSANDSEP == nPropId))
	{
		sal_Bool bAccuracy = (FM_ATTR_DECIMAL_ACCURACY == nPropId);
		sal_uInt16	nNewDigits = bAccuracy ? ::utl::getINT16(aNewValue) : 0;
		sal_Bool	bUseSep = bAccuracy ? sal_False : ::utl::getBOOL(aNewValue);

		pPropBox->DisableUpdate();

		// propagate the changes to the min/max/default fields
		::com::sun::star::uno::Any aCurrentProp;
		::rtl::OUString aAffectedProps[] = { FM_PROP_DEFAULT_VALUE, FM_PROP_VALUEMIN, FM_PROP_VALUEMAX };
		for (sal_uInt16 i=0; i<sizeof(aAffectedProps)/sizeof(aAffectedProps[0]); ++i)
		{
			SvxPropDoubleNumericField* pField = (SvxPropDoubleNumericField*)pPropBox->GetPropertyControl(aAffectedProps[i]);
			if (pField)
				if (bAccuracy)
					pField->SetDecimalDigits(nNewDigits);
				else
					pField->SetThousandsSep(bUseSep);
		}

		pPropBox->EnableUpdate();
	}
	else if (FM_ATTR_FORMATKEY == nPropId)
	{
		FormatDescription aNewDesc;

		::com::sun::star::uno::Any aSupplier = aPropSet->getPropertyValue(FM_PROP_FORMATSSUPPLIER);
		DBG_ASSERT(aSupplier.getValueType().equals(::getCppuType(
			(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier>*)0)),

			"FmPropController::Commit : invalid property change !");
			// we only allowed the FormatKey property to be displayed if the set had a valid FormatsSupplier
		::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier = *(::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > *)aSupplier.getValue();
		DBG_ASSERT(xSupplier.is(), "FmPropController::Commit : invalid property change !");
			// same argument
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel > xTunnel(xSupplier,::com::sun::star::uno::UNO_QUERY);
		DBG_ASSERT(xTunnel.is(), "FmPropController::ChangeFormatProperty : xTunnel is invalid!");
		SvNumberFormatsSupplierObj* pSupplier = (SvNumberFormatsSupplierObj*)xTunnel->getSomething(SvNumberFormatsSupplierObj::getUnoTunnelId());
			// the same again

		aNewDesc.pSupplier = pSupplier;
		aNewDesc.nKey = aVal.ToInt32();
			// nKey will be zero if aVal is empty or standard

		// give each control which has to know this an own copy of the description
		SvxPropControl* pControl = pPropBox->GetPropertyControl(FM_PROP_EFFECTIVE_MIN);
		if (pControl)
			((SvxPropDoubleNumericField*)pControl)->SetFormatDescription(aNewDesc);

		pControl = pPropBox->GetPropertyControl(FM_PROP_EFFECTIVE_MAX);
		if (pControl)
			((SvxPropDoubleNumericField*)pControl)->SetFormatDescription(aNewDesc);

		pControl = pPropBox->GetPropertyControl(FM_PROP_EFFECTIVE_DEFAULT);
		if (pControl)
			((SvxPropDoubleNumericField*)pControl)->SetFormatDescription(aNewDesc);
	}

		//////////////////////////////////////////////////////////////////////
	// Bei Datenquelle auch Cursor-/ListSource fuellen
	if( nPropId == FM_ATTR_DATASOURCE )
	{
		::com::sun::star::beans::Property aProp = GetProperty( rName );

		::rtl::OUString aUserVal=aVal;

		// does there exist a DatabaseAccess with that name ?
		::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases >  xAliases(::utl::getProcessServiceFactory()->createInstance(SRV_SDB_DATABASE_ACCESS_CONTEXT), ::com::sun::star::uno::UNO_QUERY);
		if (xAliases.is())
		{
			//////////////////////////////////////////////////////////////////////

			// get the application language
			XubString sLanguage, sCountry;
			ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
			UniString aLanguage(sLanguage), aCountry(sCountry);
			try
			{
				// ::com::sun::star::util::URL- Adresse koennte relativ sein
				::rtl::OUString sAbsolute = INetURLObject::RelToAbs(aVal);
				aUserVal = xAliases->lookupProgrammatic(::com::sun::star::lang::Locale(aLanguage, aCountry, ::rtl::OUString()), sAbsolute);
			}
			catch(...)
			{
			}
		}

		::com::sun::star::uno::Any aValue = StringToAny( aUserVal, aProp, nPropId);

		sal_Bool bFlag=!(aProp.Attributes & ::com::sun::star::beans::PropertyAttribute::MAYBEVOID) &&
				aValue.getValueType().equals( ::getVoidCppuType());


		if(!bFlag)
			aPropSet->setPropertyValue(rName, aValue );

		if(xPropertyState.is()&& aValue.getValueType().equals( ::getVoidCppuType()))

		{
			xPropertyState->setPropertyToDefault(rName);
		}

		SetCursorSource();
		SetListSource();
	}
}
catch(::com::sun::star::beans::PropertyVetoException& eVetoException)
{
	InfoBox(pMasterController, S(eVetoException.Message)).Execute();
}
catch(::com::sun::star::uno::Exception& e)
{
	e;
	DBG_ERROR("FmPropController::Commit : catched an exception !")
}


	if (pChangeListener)
		pChangeListener->UnLock();
}

//------------------------------------------------------------------------
void FmPropController::Select( const XubString& aName, void* pData )
{
}

//------------------------------------------------------------------------
void FmPropController::LinkClicked( const XubString& aName, void* pData )
{
}

