/*************************************************************************
 *
 *  $RCSfile: wizfxdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:14:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WIZFXDLG_HXX
#define _WIZFXDLG_HXX

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif



#include "wizlogo.hxx"
#include "wizmarg.hxx"
#include "wizempf.hxx"
#include "wizfusz.hxx"
#include "numfmtlb.hxx"

class WizardFaxDialog: public SwWizardDialog
{
protected:
	FixedText     a1_Text_Stil;
	RadioButton   a1_RBtn_Stil1;
	RadioButton   a1_RBtn_Stil2;
	RadioButton   a1_RBtn_Stil3;
	FixedText     a1_Text_FaxTit;
	ComboBox      a1_CLst_FaxTit;
	FixedText     a1_Text_Format;
	ListBox       a1_List_Format;

	WizardLogoDlg aLogo;

	ImageButton   a3_PBtn_LoadAdr;
	MultiLineEdit a3_MEdt_AbsInp;
	FixedText     a3_Text_Telfon;
	Edit          a3_Edit_Telfon;
	FixedText     a3_Text_Telfax;
	Edit          a3_Edit_Telfax;
	GroupBox      a3_GBox_AbsInp;
	ImageButton  a3_BBtn_AbsnOL;
	ImageButton  a3_BBtn_AbsnOR;
	FixedText     a3_Text_AbsnWd;
	MetricField   a3_MFld_AbsnWd;
	FixedText     a3_Text_AbsnHg;
	MetricField   a3_MFld_AbsnHg;
	GroupBox      a3_GBox_AbsPos;

	WizardEmpfDlg aEmpf;

	FixedText     a5_Text_Welche;
	CheckBox      a5_CBox_Datum;
	NumFormatListBox	a5_List_Datum;
	CheckBox      a5_CBox_Uhrzt;
	NumFormatListBox	a5_List_Uhrzt;
	CheckBox      a5_CBox_Betref;
	Edit          a5_Edit_Betref;
	CheckBox      a5_CBox_KopiAn;
	CheckBox      a5_CBox_Elem1;
	Edit          a5_Edit_Elem1;
	CheckBox      a5_CBox_Elem2;
	Edit          a5_Edit_Elem2;
	CheckBox      a5_CBox_Elem3;
	Edit          a5_Edit_Elem3;
	CheckBox      a5_CBox_Elem4;
	Edit          a5_Edit_Elem4;

	WizardFuszDlg aFusz;
	WizardMargDlg aMarg;

	FixedBitmap   a8_BMap_Fahne;
	FixedText     a8_Text_Final;

public:
	WizardFaxDialog(Window* pParent);
	~WizardFaxDialog();
};

#endif  //_WIZFXDLG_HXX


