/*************************************************************************
 *
 *  $RCSfile: util.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:19:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _UTIL_HXX_
#define _UTIL_HXX_


#ifndef _UTLSTACK_HXX_
#include	<utlstack.hxx>	// class fe_stack
#endif
#ifndef _UTLEXPRL_HXX_
#include	<utlexprl.hxx>	// class UTL_ExprList
#endif
#ifndef _UTLSTRL_HXX_
#include	<utlstrl.hxx>	// class UTL_StrList
#endif
#ifndef _UTLIDL_HXX_
#include	<utlidl.hxx>	// class UTL_IdList
#endif
#ifndef _UTLECPTL_HXX_
#include	<utlecptl.hxx>	// class UTL_ExceptList
#endif
#ifndef _UTLNAMEL_HXX_
#include	<utlnamel.hxx>	// class UTL_NameList
#endif
#ifndef _UTLLABL_HXX_
#include	<utllabl.hxx>	// class UTL_LabelList
#endif
#ifndef _UTLDECLL_HXX_
#include	<utldecll.hxx>	// class UTL_DeclList
#endif
#ifndef _UTLPKGL_HXX_
#include	<utlpkgl.hxx>  	// class UTL_PkgList
#endif
#ifndef _IDLGLOB_HXX_
#include	<idlglob.hxx>  	// Class IDL_Global
#endif
#ifndef _UTLERROR_HXX_
#include	<utlerror.hxx>	// class UTL_Error
#endif
#ifndef _UTLIND_HXX_
#include	<utlind.hxx>   	// class UTL_Indenter
#endif
#ifndef _UTLNLIST_HXX_
#include	<utlnlist.hxx>
#endif
#ifndef _UTLMAP_HXX_
#include	<utlmap.hxx>
#endif

#endif	// _UTIL_UTIL_HXX

