/*************************************************************************
 *
 *  $RCSfile: staticmb.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 17:03:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define __PUT_STATIC_DATA_MEMBERS_HERE
#ifdef MACOSX
#define __STL_NO_STATIC_TEMPLATE_DATA
#endif
#include <cppuhelper/implbase1.hxx>
#include <cppuhelper/implbase2.hxx>

#include <com/sun/star/beans/XPropertyChangeListener.hpp>
#include <com/sun/star/beans/XPropertiesChangeListener.hpp>
#include <com/sun/star/io/XInputStream.hpp>
#include <com/sun/star/io/XOutputStream.hpp>
#include <com/sun/star/io/XPersistObject.hpp>
#include <com/sun/star/io/XSeekable.hpp>
#include <com/sun/star/container/XEnumeration.hpp>
#include <com/sun/star/script/XAllListener.hpp>
#include <com/sun/star/script/XEventAttacherManager.hpp>
#include <com/sun/star/util/XChangesListener.hpp>

using namespace com::sun::star::beans;
using namespace com::sun::star::io;
using namespace com::sun::star::container;
using namespace com::sun::star::script;
using namespace com::sun::star::util;

namespace cppu {

	ClassData1 WeakImplHelper1<XPropertyChangeListener>::s_aCD = ClassData1( 1 );
	ClassData1 WeakImplHelper1<XPropertiesChangeListener>::s_aCD = ClassData1( 1 );
	ClassData1 WeakImplHelper1<XInputStream>::s_aCD = ClassData1( 1 );
	ClassData1 WeakImplHelper1<XOutputStream>::s_aCD = ClassData1( 1 );
	ClassData1 WeakImplHelper1<XAllListener>::s_aCD = ClassData1( 1 );
	ClassData2 WeakImplHelper2<XEventAttacherManager, XPersistObject>::s_aCD = ClassData2( 1 );
	ClassData1 WeakImplHelper1<XEnumeration>::s_aCD = ClassData1( 1 );
	ClassData2 WeakImplHelper2<XInputStream, XSeekable>::s_aCD = ClassData2( 1 );
	ClassData1 WeakImplHelper1<XChangesListener>::s_aCD = ClassData1( 1 );

}
