/*************************************************************************
 *
 *  $RCSfile: sv.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 10:23:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SV_H
#define _SV_SV_H

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#if defined(__SC__) || defined(_MSC_VER) || (defined(ALPHA) && defined(WNT))
#ifndef ALL_WARNINGS
#pragma warning(disable: 4355)
#endif
#endif

#ifdef MACOSX
#define CALLBACK
#define IMAGE_ICON		1
typedef BOOL	WIN_BOOL;
typedef INT32	LONG;
typedef UINT32	UINT;
typedef INT16	WORD;
typedef INT32	DWORD;
typedef INT32	GWL_STYLE;
typedef INT32	GWL_EXSTYLE;
typedef INT32	GWW_HINSTANCE;
typedef INT32	COLORREF;
typedef INT32	WPARAM;
typedef INT32	LPARAM;
typedef INT32	LRESULT;
typedef void	*HINSTANCE;
typedef void	*HWND;
typedef void	*HDC;
typedef void	*HGDIOBJ;
typedef void	*HPEN;
typedef void	*HBRUSH;
typedef void	*HFONT;
typedef void	*HBITMAP;
typedef void	*HRGN;
typedef void	*HPALETTE;
typedef void	*HCURSOR;
typedef void	*HICON;
typedef void	*HGLOBAL;
typedef void	*HHOOK;
typedef void	*LPMSG;
typedef void	*HIMC;
typedef void	*HANDLE;
typedef void	*LPTSTR;
typedef void	*HGLRC;
struct RECT {
	int top;
	int bottom;
	int left;
	int right;
};
struct POINT {
	int x;
	int y;
};
struct FIXED {
	long value;
	long fract;
};
#endif /* MACOSX */

#if __PRIVATE
#if !(defined GCC && defined NO_OPTIMIZE)
#define NOOLDSV
#endif
#endif

#endif // _SV_SV_H
