'SBLLINK:MethodInfo=DontStartHere0
'SBLLINK:MethodInfo=GetMonthName0
'SBLLINK:MethodInfo=GetPathSeparator0
'SBLLINK:MethodInfo=GetMaxDayInMonth0
'SBLLINK:MethodInfo=ParaEmpty0
'SBLLINK:MethodInfo=WeekDayStr0
'SBLLINK:MethodInfo=TimeStr2TimeInt0
'SBLLINK:MethodInfo=TimeInt2TimeStr0
'SBLLINK:MethodInfo=IsValidTime0
'SBLLINK:MethodInfo=GetPrevValidTime0
'SBLLINK:MethodInfo=GetNextValidTime0
'SBLLINK:MethodInfo=getNextDayGR0
'SBLLINK:MethodInfo=getLastDayGR0
'SBLLINK:MethodInfo=getDayInInt0
'	**********************************************
'	**********************************************
'
'	Globale Tools fr das Modul: AutoPilot_Tabelle
'	
'	**********************************************
'
'	Diese einzelnen Funktionne und Routinen werden 
'	von vielen Routinen in AutoPilot_Tabelle ver-
'	wendet. Da sie zudem noch wiederverwendbar 
'	sind, wurden Sie in ein Extra Modul sortiert.
'
'	**********************************************
'
'	StarDivision, Hamburg, 7. Mrz 1996, 
'
'	**********************************************
'	**********************************************


Sub DontStartHere
	MsgBox("Dieses Modul kann nur ber seine Schnittstellen angesprochen werden.", 0, "StarBasic Programmausfhrung")
	Stop
End Sub

Const Mon=0, Tue=1, Wed=2, Thu=3, Fri=4, Sa=5, Su=6

' 1 cm entspricht 567 Twips, und der Starwriter rechnet intern 
'	mit Twips. Also werden diese auch zur Parameterbergabe bentigt.
Const cm = 567

Function GetMonthName$(byval monthNumber%)
'	Liefert fr die Monatszahl einen Monatsstring
'	zurck. GetMonthName$(1) = "Januar"

	Dim MonthName$(1 To 12)
	
	'	Das Monatsnamen - Array wird initialisiert.
	MonthName$(1) = "Januar"
	MonthName$(2) = "Februar"
	MonthName$(3) = "Mrz"
	MonthName$(4) = "April"
	MonthName$(5) = "Mai"
	MonthName$(6) = "Juni"
	MonthName$(7) = "Juli"
	MonthName$(8) = "August"
	MonthName$(9) = "September"
	MonthName$(10) = "Oktober"
	MonthName$(11) = "November"
	MonthName$(12) = "Dezember"

	GetMonthName$ = MonthName$(monthNumber%)
	
End Function

Sub GetPathSeparator$
'	Der StarWriter luft unter diversen Plattformen. Damit es bei den
'	Pfaden nicht zu Problemen kommt, wird das Betriebssystem abgefragt
'	und dann wird der entsprechende PathSeperator zurckgeliefert.
	const cWindows    = 1
	const cPM         = 2
	const cMacintosh  = 3
	const cMotif      = 4
	const cOpenWindow = 5
	
	Dim GUI%
	GUI% = GetGUIType()
	
	If (GUI% = cWindows) Or (GUI% = cPM) Then GetPathSeparator$ = "\"
	If (GUI% = cMacintosh) Then GetPathSeparator$ = ":"
	If (GUI% = cMotif) Or (GUI% = cOpenWindow) Then GetPathSeparator$ = "/"
End Sub

Function GetMaxDayInMonth%(byval YearVal%, byval MonthVal%)
'	Liefert den hchsten Tag in einem Monat

	Dim tmpDate&
	Dim	MaxDay%
	
	MaxDay = 27
	tmpDate& = DateSerial(YearVal%, MonthVal%, MaxDay)
	
	While (Month(tmpDate&) = MonthVal%)
		MaxDay% = MaxDay% + 1
		tmpDate& = tmpDate& + 1
	Wend
	Maxday% = MaxDay% - 1
	GetMaxDayInMonth% = MaxDay%	
End Function

Function ParaEmpty%
'	liefert True zurck falls der Absatz leer ist, und false wenn nicht.
	Activewindow.Escape()
	If ((Selection.IsStartOfPara And Selection.IsEndOfPara) = true) Then
		ParaEmpty% = true
	Else
		ParaEmpty% = false
	End If
End Function

Function WeekDayStr$ (Date$)
'	Liefert einen String, "Mo" bis "So", der zu dem bergebenen
'	Datum passt. Das Datum ist ein String und kann nahezu beliebige
'	Formate besitzen.

    Dim aWeekDay(1 To 7)

    aWeekDay(1) = "So"
    aWeekDay(2) = "Mo"
    aWeekDay(3) = "Di"
    aWeekDay(4) = "Mi"
    aWeekDay(5) = "Do"
    aWeekDay(6) = "Fr"
    aWeekDay(7) = "Sa"

'	Bei Datumsfunktionen tritt bei einem nicht zulssigen Datum
'	ein Laufzeitfehler auf. Dieses wird hiermit vermieden.
On Error Goto ErrorHandling

    WeekDayStr$ = aWeekDay(Weekday(Date$))
    Exit Function
    
'	Falls ein Fehler auftritt liefert die Funktion konstant "Mo" zurck.
ErrorHandling:
	WeekDayStr$ = Mo
End Function

Function TimeStr2TimeInt%(byval myTime$)
'	TimeStr sei zB. 01:12. TimeInt ist der Minutenwert,
'	also in diesem Fall 72, 1*60 + 12
	
	Dim Result%
	If (Len(myTime$) <> 5) Then print "Zeitstring " + myTime$ + " " + Len(myTime$) + " falsche lnge"
	
	Result% = Val(Right$( myTime$, 2))
	'	Dieses Left$ ist ntig weil str$(val("2")) nicht "2", sondern
	'	" 2" zurckliefert.
	Result% = Result% + (60 * Val(Left$( myTime$, 2)))
	TimeStr2TimeInt% = Result%
End Function

Function TimeInt2TimeStr$(byval TimeInt%)
'	Wandelt einen Integer Wert, der Minuten angibt, in einen String um.
'	Die Left$ Anweisungen sind ntig weil str$(val("2")) nicht "2", sondern
'	" 2" zurckliefert.
	Dim HourInt%, MinuteInt%, x
	Dim VarHour$, VarMinute$, Result$
	
	MinuteInt% = TimeInt% Mod 60
	VarMinute$ = Right(Str$(MinuteInt%), len(Str$(MinuteInt%))-1)
	If (MinuteInt% <= 9) Then VarMinute$ = "0" + VarMinute$
	
	TimeInt% = TimeInt% - MinuteInt%

	HourInt% = TimeInt% / 60
	VarHour$ = Right(Str$(HourInt%), len(Str$(HourInt%))-1)
	If (HourInt% <= 9) Then VarHour$="0" + VarHour$
	
	Result$ = VarHour$ + ":" + VarMinute$

	TimeInt2TimeStr$ = Result$
End Function

Function IsValidTime%(byval time$)
'	Diese Funktion nimmt die Zeit auseinander und sieht nach, ob sie
'	ein korrektes Format besitzt.
	
	If (Len(time$) <> 5) Then Goto notValid

	If (Mid$(time$, 3, 1) <> ":") Then Goto notValid

	If (Mid$(time$, 1, 2) <> "00") Then
		If (val(Mid$(time$, 1, 2)) = 0) Then Goto notValid
		If (val(Mid$(time$, 1, 2)) > 23) Then Goto notValid
	End If

	If (Mid$(time$, 4, 2) <> "00") Then
		If (val(Mid$(time$, 4, 2)) = 0) Then Goto notValid
		If (val(Mid$(time$, 4, 2)) > 59) Then Goto notValid
	End If
	
	IsValidTime% = true
	Exit Function

notValid:
	IsValidTime% = false

End Function

Sub GetPrevValidTime(time$, byval MinRate%)
'	Berechnet den nchstzurckliegenden Zeitpunkt, der
'	durch MinRate teilbar ist.
	
	Dim timeMin%

	timeMin% = TimeStr2TimeInt%(time$)
	timeMin% = timeMin% - timeMin% mod MinRate%
	
	time$ = TimeInt2TimeStr$(timeMin%)
End Sub

Sub GetNextValidTime(time$, byval MinRate%)
'	Berechnet den nchstliegenden Zeitpunkt, der
'	durch MinRate teilbar ist.

	GetPrevValidTime(time$, MinRate%)
	time$ = TimeInt2TimeStr$(TimeStr2TimeInt%(time$) + MinRate%)
End Sub

Function getNextDayGR$(byval actDayStr$)
' 	liefert den deutschen(GR) Bezeichner des nchsten Wochentags
'	in KurzForm zurck.
	Dim nextDay$
	
	Select Case actDayStr$
		case "Mo" 
			nextDay$ = "Di"
		case "Di"
			nextDay$ = "Mi"
		case "Mi"
			nextDay$ = "Do"
		case "Do"
			nextDay$ = "Fr"
		case "Fr"
			nextDay$ = "Sa"
		case "Sa"
			nextDay$ = "So"
		case "So"
			nextDay$ = "Mo"
		case else 
			nextDay$ = "?"
	End Select
	
	getNextDayGR$ = nextDay$
End Function

Function getLastDayGR$(byval actDayStr$)
' 	liefert den deutschen(GR) Bezeichner des gestrigen Wochentags
'	in KurzForm zurck.
	Dim lastDay$
	
	Select Case actDayStr$
		case "Mo" 
			lastDay$ = "So"
		case "Di"
			lastDay$ = "Mo"
		case "Mi"
			lastDay$ = "Di"
		case "Do"
			lastDay$ = "Mi"
		case "Fr"
			lastDay$ = "Do"
		case "Sa"
			lastDay$ = "Fr"
		case "So"
			lastDay$ = "Sa"
		case else 
			lastDay$ = "?"
	End Select
	getLastDayGR$ = lastDay$
End Function

Function getDayInInt%(byval actDayStr$)
' 	actDayStr ist ein kurzer deutscher Wochentagsbezeichner.
'	Diese Funktion liefert den passenden symbolischen Wert fr einen
'	solchen Tag. Die Bezeichner Mon bis Su sind Konstanten, die ganz
'	oben deklariert worden sind.
	Dim lastDay$
	
	Select Case actDayStr$
		case "Mo" 
			getDayInInt% = Mon
		case "Di"
			getDayInInt% = Tue
		case "Mi"
			getDayInInt% = Wed
		case "Do"
			getDayInInt% = Thu
		case "Fr"
			getDayInInt% = Fri
		case "Sa"
			getDayInInt% = Sa
		case "So"
			getDayInInt% = Su
	End Select
End Function


