'SBLLINK:MethodInfo=nLoadLanguage0
'SBLLINK:MethodInfo=SetDialogLanguage0
'SBLLINK:MethodInfo=InitResources0
'SBLLINK:MethodInfo=GetResText0

Global Const RID_DB_COMMON_START		= 1000
Global Const RID_DB_COMBO_WIZARD_START	= 2700

Const MAXLANG = 8
'	Language 1 = German
'	         2 = English
'	         3 = French
'	         4 = Italian
'			 5 = Spanish
'			 6 = Portuguese
'			 7 = Dutch
'			 8 = Swedish

'	Global Msg
Dim Form_gWizardName$ (MAXLANG)
Dim Form_gErrMsg$ (MAXLANG)
Dim Form_gErrFormOpen$ (MAXLANG)
Dim Form_gErrNoDatabase$ (MAXLANG)
Dim Form_gErrNoTableInDatabase$ (MAXLANG)
Dim Form_gErrTitleSuggestedExist$ (MAXLANG)
Dim Form_gErrTitleSyntaxError$ (MAXLANG)
Dim Form_gProgressText$ (MAXLANG)

'	Non const control-properties
Dim Form_Dlg_1Caption$ (MAXLANG)
Dim Form_Dlg_2Caption$ (MAXLANG)
Dim Form_Dlg_3Caption$ (MAXLANG)
Dim Form_Dlg_4Caption$ (MAXLANG)
Dim Form_Dlg_5Caption$ (MAXLANG)

'	Const control-properties
Dim Form_0_cmdCancel$ (MAXLANG)
Dim Form_0_cmdPrev$ (MAXLANG)
Dim Form_0_cmdNextOrReady$ (MAXLANG)

Dim Form_1_frameDatabase$ (MAXLANG)
Dim Form_1_frameTables$ (MAXLANG)
Dim Form_1_frameTables1$ (MAXLANG)
Dim Form_1_frameTables2$ (MAXLANG)

Dim Form_2_lblAvailable$ (MAXLANG)
Dim Form_2_lblSelected$ (MAXLANG)
Dim Form_2_txInfo$ (MAXLANG)
Dim Form_2_fcInfo$ (MAXLANG)

Dim Form_3_txConnection1$ (MAXLANG)
Dim Form_3_txConnection2$ (MAXLANG)
Dim Form_3_cmdFinish$ (MAXLANG)

Dim Form_4_lblInfo3$ (MAXLANG)
Dim Form_4_lblDBField$ (MAXLANG)
Dim Form_4_opDBField$ (MAXLANG)
Dim Form_4_opNoDBField$ (MAXLANG)

'	Internal Logic
Dim Form_ilFormTitleSuggestPrefix$ (MAXLANG)


Function nLoadLanguage% ( ByVal nLanguage% )

	Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4
	Const cLANGUAGE_DANISH = 1030, cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033
	Const cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036, cLANGUAGE_GERMAN = 1031
	Const cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
	Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_PORTUGUESE = 2070, cLANGUAGE_RUSSIAN = 1049
	Const cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053, cLANGUAGE_TURKISH = 1055

	Dim nSelLang%

	Select Case ( nLanguage% )

		Case cLANGUAGE_ENGLISH
			nSelLang% = 2
		Case cLANGUAGE_FRENCH
			nSelLang% = 3
		Case cLANGUAGE_ITALIAN
			nSelLang% = 4
		Case cLANGUAGE_SPANISH
			nSelLang% = 5
		Case cLANGUAGE_PORTUGUESE
			nSelLang% = 6
		Case cLANGUAGE_DUTCH
			nSelLang% = 7
		Case cLANGUAGE_SWEDISH
			nSelLang% = 8
		Case Else
			nSelLang% = 1
	End Select

	'	Global Msg
	if bIsComboBox then
		Form_gWizardName$ ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 0)
	else
		Form_gWizardName$ ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 1)
	end If
	Form_gErrMsg$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 6)
	Form_gErrFormOpen$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 7)
	Form_gErrNoDatabase$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 8)
	Form_gErrNoTableInDatabase$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 9)
	Form_gErrTitleSuggestedExist$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 10)
	Form_gErrTitleSyntaxError$ ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 11)
	Form_gProgressText$ ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 2)

	'	Internal Logic
	Form_ilFormTitleSuggestPrefix$ ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 3)

	'	Non const control-properties
	Form_Dlg_1Caption$ ( nSelLang% ) = Form_gWizardName$ ( nSelLang% ) + GetResText( RID_DB_COMBO_WIZARD_START + 4)
	Form_Dlg_2Caption$ ( nSelLang% ) = Form_gWizardName$ ( nSelLang% ) + GetResText( RID_DB_COMBO_WIZARD_START + 5)
	Form_Dlg_3Caption$ ( nSelLang% ) = Form_gWizardName$ ( nSelLang% ) + GetResText( RID_DB_COMBO_WIZARD_START + 6)
	Form_Dlg_4Caption$ ( nSelLang% ) = Form_gWizardName$ ( nSelLang% ) + GetResText( RID_DB_COMBO_WIZARD_START + 7)
	Form_Dlg_5Caption$ ( nSelLang% ) = Form_gWizardName$ ( nSelLang% ) + GetResText( RID_DB_COMBO_WIZARD_START + 8)

	'	const control-properties
	Form_0_cmdCancel ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 1)
	Form_0_cmdPrev ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 2)
	Form_0_cmdNextOrReady ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 3)

	Form_1_frameDatabase ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 4)
	Form_1_frameTables1 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 9)
	Form_1_frameTables2 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 10)

	Form_2_lblAvailable ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 11)
	Form_2_lblSelected ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 12)

	if bIsComboBox then
		Form_2_txInfo ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 13)
	else
		Form_2_txInfo ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 14)
	end If

	Form_2_fcInfo ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 15)

	Form_3_txConnection1 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 16)
	Form_3_txConnection2 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 17)
	Form_3_cmdFinish ( nSelLang% ) = GetResText( RID_DB_COMMON_START + 0)

	if bIsComboBox then
		Form_4_lblInfo3 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 18)
	else
		Form_4_lblInfo3 ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 19)
	end If

	Form_4_lblDBField ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 20)
	Form_4_opDBField ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 21)
	Form_4_opNoDBField ( nSelLang% ) = GetResText( RID_DB_COMBO_WIZARD_START + 22)

	nLoadLanguage% = nSelLang%
	SetDialogLanguage ( 	nSelLang% )
End Function

Sub SetDialogLanguage ( nSelLang% )

	With DlgComboDB
		.cmdCancel.Caption = Form_0_cmdCancel ( nSelLang% )
		.cmdPrev.Caption = Form_0_cmdPrev ( nSelLang% )
		.cmdNextOrReady.Caption = Form_0_cmdNextOrReady ( nSelLang% )

		.frameDatabase.Caption = Form_1_frameDatabase ( nSelLang% )
		.frameTables.Caption = Form_1_frameTables2 ( nSelLang% )
		.frameTable1.Caption = Form_1_frameTables1 ( nSelLang% )
		.frameTable2.Caption = Form_1_frameTables2 ( nSelLang% )
		
		.lblAvailable.Caption = Form_2_lblAvailable ( nSelLang% )
		.lblSelected.Caption = Form_2_lblSelected ( nSelLang% )
		.txInfo.Caption = Form_2_txInfo ( nSelLang% )
		.fcInfo.Caption = Form_2_fcInfo ( nSelLang% )
		
		.txConnection1.Caption = Form_3_txConnection1 ( nSelLang% )
		.txConnection2.Caption = Form_3_txConnection2 ( nSelLang% )
		.cmdFinish.Caption = Form_3_cmdFinish ( nSelLang% )
		
		.lblInfo3.Caption = Form_4_lblInfo3 ( nSelLang% )
		.lblDBField.Caption = Form_4_lblDBField ( nSelLang% )
		.opDBField.Caption = Form_4_opDBField ( nSelLang% )
		.opNoDBField.Caption = Form_4_opNoDBField ( nSelLang% )
		.cmdFinishCombo.Caption = Form_3_cmdFinish ( nSelLang% )
	End With

End Sub

Dim gResSrv as Object

function InitResources() as boolean

	On Local Error Goto ErrorOcurred

	gResSrv = createUnoService( "com.sun.star.resource.VclStringResourceLoader" )

	if ( IsNull( gResSrv ) ) then
		InitResources = FALSE
		MsgBox( "FormWizard: No resource loader found" )
	else
		InitResources = TRUE
		gResSrv.FileName = "dbw"
	end if
	
	exit function

ErrorOcurred:
	InitResources = FALSE
	nSolarVer = GetSolarVersion()
	MsgBox "Resource file missing ( dbw" + trim(str(nSolarVer)) + "*.res )"

end function


function GetResText( nID as integer ) as string

	On Local Error Goto ErrorOcurred

	if not IsNull( gResSrv ) then
		GetResText = gResSrv.getString( nID )
	else
		GetResText = ""
	end if

	exit function

ErrorOcurred:
	GetResText = ""
	MsgBox "Resource with ID =" + str( nID ) + " not found!"
end function

