'SBLLINK:MethodInfo=nLoadLanguage0
Option Explicit
Const MAXLANG = 8
'	Language 1 = German
'	         2 = English
'	         3 = French
'	         4 = Italian
'			 5 = Spanish
'			 6 = Portuguese
'			 7 = Dutch
'			 8 = Swedish

'	Global Msg

Dim CreateRep_gMyName$ (MAXLANG)
Dim CreateRep_gErrReportInComplete$ (MAXLANG)
Dim CreateRep_gErrCannotOpenQuery$ (MAXLANG)
Dim CreateRep_gErrFieldsDeleted$ (MAXLANG)
Dim CreateRep_gErrMsg$ (MAXLANG)
Dim CreateRep_gErrToManyData$ (MAXLANG)

Function nLoadLanguage% ( ByVal nLanguage% )

	Const cLANGUAGE_DONTKNOW = 1023, cLANGUAGE_SYSTEM = 0, cLANGUAGE_CHINESE = 4
	Const cLANGUAGE_DANISH = 1030, cLANGUAGE_DUTCH = 1043, cLANGUAGE_ENGLISH = 1033
	Const cLANGUAGE_FINNISH = 1035, cLANGUAGE_FRENCH = 1036, cLANGUAGE_GERMAN = 1031
	Const cLANGUAGE_GREEK = 1032, cLANGUAGE_ITALIAN = 1040, cLANGUAGE_JAPANESE = 1041
	Const cLANGUAGE_NORWEGIAN = 20, cLANGUAGE_PORTUGUESE = 2070, cLANGUAGE_RUSSIAN = 1049
	Const cLANGUAGE_SPANISH = 1034, cLANGUAGE_SWEDISH = 1053, cLANGUAGE_TURKISH = 1055

	Dim nSelLanguage%

	Select Case ( nLanguage% )

		Case cLANGUAGE_ENGLISH
			nSelLanguage% = 2
			CreateRep_gMyName$ ( nSelLanguage% ) = "Create report"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "The report is incomplete."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "The query $1 could not be opened."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Fields have been deleted from the query $1."
			CreateRep_gErrMsg ( nSelLanguage% ) = "An error occurred during creation of the report."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "The table/query contains too many records."

		Case cLANGUAGE_FRENCH
			nSelLanguage% = 3
			CreateRep_gMyName$ ( nSelLanguage% ) = "Crer un tat"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "L'tat n'est pas complet."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "Impossible d'ouvrir la requte $1."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Le champs $1 de la requte a t supprim."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Erreur lors de la cration de l'tat."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "La table/requte contient trop denregistrements."

		Case cLANGUAGE_ITALIAN
			nSelLanguage% = 4
			CreateRep_gMyName$ ( nSelLanguage% ) = "Creazione di un report"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "Il report non  completo."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "Non  stato possibile aprire la query $1."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Dalla query $1 sono stati eliminati errori."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Durante la creazione del report si  avuto un errore."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "La tabella/query contiene troppi record di dati."

		Case cLANGUAGE_SPANISH
			nSelLanguage% = 5
			'	Global Msg
			CreateRep_gMyName$ ( nSelLanguage% ) = "Crear reporte"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "El reporte est incompleto."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "No se pudo abrir la consulta $1."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Se han eliminado campos de la consulta $1."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Se ha producido un error al crear el reporte."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "La tabla/consulta contiene demasiados registros."


		Case cLANGUAGE_PORTUGUESE
			nSelLanguage% = 6
			CreateRep_gMyName$ ( nSelLanguage% ) = "Criar relatrio"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "O relatrio est incompleto."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "Foi impossvel abrir a consulta $1."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Foram eliminados campos da consulta $1."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Surgiu um erro ao criar o relatrio."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "A tabela/consulta contm demasiados registos."

		Case cLANGUAGE_DUTCH
			nSelLanguage% = 7
			CreateRep_gMyName$ ( nSelLanguage% ) = "Bericht maken"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "Het bericht is niet compleet."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "De query $1 kon niet worden geopend."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Uit query $1 werden velden gewist."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Bij het maken van het bericht is een fout opgetreden."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "De tabel/query bevat te veel records."

		Case cLANGUAGE_SWEDISH
			nSelLanguage% = 8
			CreateRep_gMyName$ ( nSelLanguage% ) = "Skapa rapport"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "Rapporten r ofullstndig."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "Queryn $1 kunde inte ppnas."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Frn Queryn $1 togs flt bort."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Vid uppbyggandet av rapporten har ett fel uppsttt."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "Tabellen/Queryn innehller fr mnga dataposter."

		'	GERMAN & Fallback/Default
		Case Else
			'	Global Msg
			nSelLanguage% = 1
			CreateRep_gMyName$ ( nSelLanguage% ) = "Bericht erzeugen"
			CreateRep_gErrReportInComplete ( nSelLanguage% ) = "Der Bericht ist unvollstndig."
			CreateRep_gErrCannotOpenQuery ( nSelLanguage% ) = "Die Abfrage $1 konnte nicht geffnet werden."
			CreateRep_gErrFieldsDeleted ( nSelLanguage% ) = "Aus der Abfrage $1 wurden Felder gelscht."
			CreateRep_gErrMsg ( nSelLanguage% ) = "Beim Aufbauen des Berichtes ist ein Fehler aufgetreten."
			CreateRep_gErrToManyData$ (nSelLanguage% ) = "Die Tabelle/Abfrage enthlt zu viele Datenstze."

	End Select
	nLoadLanguage% = nSelLanguage%
End Function
