'SBLLINK:MethodInfo=CalcForGroup0
'SBLLINK:MethodInfo=GetTypOfDoc0
'SBLLINK:MethodInfo=GetDrawPage0
'SBLLINK:MethodInfo=SearchNewGroupNumber0
'SBLLINK:MethodInfo=GetGroupNumber0
'SBLLINK:MethodInfo=CreateControlShape0
'SBLLINK:MethodInfo=CreateRadioButton0
const cUnknownDoc = 0, cStarWriterDoc = 1, cStarCalcDoc = 2, cStarImpressDoc = 3, cStarDrawDoc = 4
const cOffset = 300, cHeight = 400, cButtonHeight = 300, cTopHeight = 300, cMinWidth = 6000
const cRadioBoxId = 3, cGroupBoxId = 8
const cGroupName = "Group", cRadioGroupName = "RadioGroup"

function CalcForGroup( BYVAL aGroupBoxControl as Object, nCount% )

	DIM n%, nType%
	DIM aDoc, aForm, aDPage, aShape, aTmpObj, aShapeSize, aShapePoint, aSize, aPoint, aDesc as Object
	DIM aRadioButtonControl, aShapes as Object
	DIM aGroupedShapes as Object
	DIM bFlag as Boolean
	DIM nTmpHeight%, nTopSpace%, sGroupPostfix$

  aSize = createUnoStruct("com.sun.star.awt.Size")
  aPoint = createUnoStruct("com.sun.star.awt.Point")
  aShapes = createUnoService("com.sun.star.drawing.ShapeCollection")
	aForm = aGroupBoxControl.Parent
	aDoc = aForm.Parent.Parent
	aDPage = GetDrawPage (aDoc)
	bFlag = False

	'das richtige Shape finden
	'Problem ist, das nur ber den Namen verglichen werden kann -> unsichere Methode!

	For n% = 0 to aDPage.Count-1
		aShape = aDPage.GetByIndex(n%)
    If HasUnoInterfaces (aShape, "com.sun.star.drawing.XControlShape") then
			aTmpObj = aShape.Control
			if aTmpObj.Name = aGroupBoxControl.Name then
				bFlag = True
				Exit For
			End If
		end If
	next

	If (bFlag = True) Then
		nTopSpace% = 0
		nButtonSpace% = 0
		aShapeSize = aShape.Size
		aSize.Height = aShapeSize.Height
		aSize.Width = aShapeSize.Width

		if aShapeSize.Height<int(cButtonHeight*(nCount%+1)+cButtonHeight+Int(cButtonHeight/4)) then
			aSize.Height = Int(cButtonHeight*(nCount%+1)+cButtonHeight+Int(cButtonHeight/4))
			aShape.Size = aSize
		End If

		if aShapeSize.Width<cMinWidth then
			aSize.Width = cMinWidth
			aShape.Size = aSize
		End If

		aShapeSize = aShape.Size
		nTmpHeight% = Int ((aShapeSize.Height-Int(cButtonHeight/4)) / (nCount%+1))
		'nTopSpace% = -Int(cButtonHeight/4)
		if (GetTypOfDoc (aDoc) = cStarWriterDoc) then
			aShape.AnchorType = 2
		End If
		aShapePoint = aShape.Position
		aSize.Width = aShapeSize.Width - cOffset
		aSize.Height = cHeight
		aPoint.x = aShapePoint.x + cOffset
		aShapes.Add(aShape)
		sGroupPostfix$ = GetGroupNumber (aGroupBoxControl.Name)
		for n%=0 to nCount% -1
			aPoint.y = aShapePoint.y + (n%+1)*nTmpHeight%+nTopSpace%
			aRadioButtonControl = CreateRadioButton (aDoc)

			' Namen des Feldes uebernehmen
			aRadioButtonControl.Label = lbSelected.List(n%)

			'Defaultwert setzen
			if ( opField.Value = True) and ( cbField.Text = lbSelected.List(n%)) then
				aRadioButtonControl.DefaultState = 1 ' True
			End IF

			'Wertdarstellung eintragen
			aRadioButtonControl.RefValue = Trim(lbRadioValues.List(n%))

			'Datenbankfeld setzen
			if ( bIsTable and (opDBField.Value = True)) then
				aRadioButtonControl.DataField = cbDBField.Text
			End IF
			aRadioButtonControl.Name = cRadioGroupName+sGroupPostfix$

			aShape = CreateControlShape (aRadioButtonControl, aSize, aPoint, aDPage, aDoc)

			aShape.Name = cRadioGroupName+sGroupPostfix$
			aShapes.Add(aShape)

			' set the GroupBox as "LabelControl" for the RadioButton
			aRadioButtonControl.LabelControl = aGroupBoxControl
		Next

		'Gruppenbeschreibung setzen
		aGroupBoxControl.Label = edGroupTitle.Text
		aGroupedShapes = aDPage.group (aShapes )
		If Not IsNull ( aGroupedShapes ) Then
			aDoc.CurrentController.select( aGroupedShapes )
		End If
	End If
end function

Function GetTypOfDoc (aDoc as Object) as long
  if HasUnoInterfaces (aDoc,"com.sun.star.text.XTextDocument") then
		GetTypOfDoc = cStarWriterDoc
	else
  if HasUnoInterfaces (aDoc,"com.sun.star.sheet.XSpreadsheetDocument") then
		GetTypOfDoc = cStarCalcDoc
	else
  if HasUnoInterfaces (aDoc,"com.sun.star.presentation.XPresentationSupplier") then
		GetTypOfDoc = cStarImpressDoc
	else
  if HasUnoInterfaces (aDoc,"com.sun.star.drawing.XDrawPagesSupplier") then
		GetTypOfDoc = cStarDrawDoc
	else
		GetTypOfDoc = cUnknownDoc
	End IF
	End IF
	End IF
	End IF
End Function

Function GetDrawPage (aDoc as Object) as Object
	Select Case ( GetTypOfDoc (aDoc))
		Case cStarWriterDoc
			GetDrawPage = aDoc.DrawPage
		Case cStarCalcDoc
			GetDrawPage = aDoc.CurrentController.ActiveSheet.DrawPage
		Case cStarImpressDoc, cStarDrawDoc
			GetDrawPage = aDoc.CurrentController.CurrentPage
	End Select
End Function

Function SearchNewGroupNumber (aForm as Object) as long
	Dim i%, nClassId%, nGroupCount%
	nGroupCount% = 0
	For i%=0 to aForm.Count-1
		nClassId%=aForm.GetElementByIndex(i).ClassId
		if (nClassId% = cGroupBoxId) then
			nGroupCount% = nGroupCount% +1
		End If
	Next
	SearchNewGroupNumber = nGroupCount%
End Function

Function GetGroupNumber (sTitel as String) as String
	Dim i%, sTmpChar$
	For i%=Len(sTitel) to 0 step -1
		sTmpChar$ = Mid( sTitel, i%, 1)
		if (sTmpChar$<"0") or (sTmpChar$>"9") Then
			GetGroupNumber = Trim(Right(sTitel, Len(sTitel) -i%))
			Exit For
		end if
	Next
End Function

Function CreateControlShape (aControl, aSize, aPos, aDrawPage, aDoc as Object) as Object
	Dim aShape as Object
	aShape = aDoc.CreateInstance ("com.sun.star.drawing.ControlShape")
	aShape.Size = aSize
	aShape.Position = aPos
	if (GetTypOfDoc (aDoc) = cStarWriterDoc) then
		aShape.AnchorType = 2
	end If
	aShape.Control = aControl
	aDrawPage.Add ( aShape )
	CreateControlShape = aShape
end Function

Function CreateRadioButton (aDoc as Object) as Object
  CreateRadioButton = aDoc.CreateInstance ("com.sun.star.form.component.RadioButton")
end Function
