'SBLLINK:MethodInfo=setupInternetData0
'SBLLINK:MethodInfo=createOverview0
'SBLLINK:MethodInfo=importAll0
'SBLLINK:MethodInfo=setupManualBrowser0
'SBLLINK:MethodInfo=setupImportBrowser0
'SBLLINK:MethodInfo=setupEmailAccount0
'SBLLINK:MethodInfo=setupImportMail0
'SBLLINK:MethodInfo=getNextSMTP0
'SBLLINK:MethodInfo=setupManualNews0
'SBLLINK:MethodInfo=setupImportNews0
'SBLLINK:MethodInfo=makeContent0
'SBLLINK:MethodInfo=createMailGroup0
'SBLLINK:MethodInfo=InitializeMailGroup0
'SBLLINK:MethodInfo=createOutBox0
'SBLLINK:MethodInfo=readOutSettings0
'SBLLINK:MethodInfo=readAll0
'SBLLINK:MethodInfo=readBrowser0
'SBLLINK:MethodInfo=readMail0
'SBLLINK:MethodInfo=readNews0
'SBLLINK:MethodInfo=readMailUsers0
'SBLLINK:MethodInfo=readNewsUsers0
'SBLLINK:MethodInfo=setAsStandard0
'SBLLINK:MethodInfo=toggleStandards0
'SBLLINK:MethodInfo=copyOfficeStorages0
'Here reside the subs that actually setup the data that has
'been collected in the dialogs. Here's also the code that imports
'data from other applications
Option Explicit

Public aViewList(20,1) as String
Public bOutlookSelected as Boolean

Sub setupInternetData
	'main routine for setting up the data after all data has been collected from the user
    Dim aList as Object
	Dim aValues as Object
	Dim MailSet as Boolean

	MailSet = False

	setAsStandard()
	createMailGroup()

	If Dialog.s2OptFull.Value = True Then
		If importAll() Then MailSet = True
	Else
		If Dialog.s3OptImport.Value = True Then
			'Import Browser Settings
			If not IsNull( gService ) Then
				If ( gService.hasByName( "browser" ) ) Then
					aList = gService.getByName( "browser" )
					aValues = aList.getByName(Dialog.s3ListApps.List(Dialog.s3ListApps.ListIndex))
					setupImportBrowser(aValues)
				End If
			End If
		Else
			If Dialog.s3OptManual.Value = True Then
				'browser Settings manually
				setupManualBrowser()
			End If
		End If
		If Dialog.s5OptImport.Value = True Then
			'Import email Settings
			If not IsNull( gService ) Then
				If ( gService.hasByName( "mail" ) ) Then
					aList = gService.getByName( "mail" )
					aValues = aList.getByName(Dialog.s5ListApps.List(Dialog.s5ListApps.ListIndex))
					setupImportMail(aValues, gMailUser)
					MailSet = True
				End If
			End If
		Else
			If Dialog.s5OptManual.Value = True Then
				'email Settings manually
				If Dialog.s6OptPop3.Value = True Then
					SetupEMailAccount("application/vnd.sun.staroffice.pop3-box",6)
				Else
					SetupEMailAccount("application/vnd.sun.staroffice.imap-box",3)
				EndIf
				MailSet = True
			End If
		End If
		If Dialog.s8OptImport.Value = True Then
			'Import news Settings
			If not IsNull( gService ) Then
				If ( gService.hasByName( "news" ) ) Then
					aList = gService.getByName( "news" )
					aValues = aList.getByName(Dialog.s8ListApps.List(Dialog.s8ListApps.ListIndex))
					setupImportNews(aValues, gNewsUser)
					MailSet = True
				End If
			End If
		Else
			If Dialog.s8OptManual.Value = True Then
				'news Settings manually
				setupManualNews()
				MailSet = True
			End If
		End If
	End If
	If MailSet = True Then createOutBox()
	Dialog.NextStep.Enabled = False
	Dialog.PreviousStep.Enabled = False
	Dialog.Cancel.Enabled = False
End Sub


Sub createOverview
	'determines what to do after all data has been collected and
	'fill the overview page with content
	Dim NoSettings as Boolean
	NoSettings = True
	Dialog.s11Text.Caption = getResText(DLG_03 + 2) & CHR(13)
	If Dialog.s1ChkStdOffice.Value = True Then
		Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 3)
		NoSettings = False
	End If
	If Dialog.s2OptFull.Value = True Then
		'Import all
		Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 5)

		Dim iSelindex as Integer

		iSelIndex = Dialog.s2ListApps.ListIndex
		If aViewList(iSelIndex,0) <> aViewList(iSelIndex,1) Then
			bOutlookSelected = True
		Else
			bOutlookSelected = False
		End If


		If not bOutlookSelected Then
			' E-Mails and news accounts of Outlook cannot be imported
			Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 7)
			Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 9)
		End If
		NoSettings = False
	Else
		If Dialog.s3OptImport.Value = True Then
			'Import Browser Settings
			Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 5)
			NoSettings = False
		Else
			If Dialog.s3OptManual.Value = True Then
				'browser Settings manually
				Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 4)
				NoSettings = False
			End If
		End If
		If Dialog.s5OptImport.Value = True Then
			'Import email Settings

			Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 7)
			NoSettings = False
		Else
			If Dialog.s5OptManual.Value = True Then
				'email Settings manually
				Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 6)
				NoSettings = False
			End If
		End If
		If Dialog.s8OptImport.Value = True Then
			'Import news Settings
			Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 9)
			NoSettings = False
		Else
			If Dialog.s8OptManual.Value = True Then
				'news Settings manually
				Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 8)
				NoSettings = False
			End If
		End If
	End If
	If NoSettings = True Then
		Dialog.s11Text.Caption = Dialog.s11Text.Caption & CHR(13) & getResText(DLG_03 + 10)
	End If
End Sub


Function importAll
	'is called when the user selected an application to import everything from
	Dim aList as Object
	Dim aValues as Object
	Dim aApp as Object

	importAll = False
	If not IsNull( gService ) Then
		If ( gService.hasByName( "alle" ) ) Then
			aList = gService.getByName( "alle" )
			aValues = aList.getByName( aViewList(Dialog.s2ListApps.ListIndex,1 ))
			If aValues.hasByName( "browser" ) Then
				aApp = aValues.getByName( "browser" )
				setupImportBrowser(aApp)
			End If
			If aValues.hasByName( "mail" ) Then
				aApp = aValues.getByName( "mail" )
				setupImportMail(aApp, gMailUser)
				importAll = True
			End If
			If aValues.hasByName( "news" ) Then
				aApp = aValues.getByName( "news" )
				setupImportNews(aApp, gNewsUser)
				importAll = True
			End If
		End If
	End If
End Function


Sub setupManualBrowser
	'set the browser settings if the user selected manual browser settings
	Dim aPort as Long
	Dim aProxy as Integer
	If Dialog.s4ChkNoProxy.Value = False Then
		aProxy = 2
	Else
		aProxy = 0
	End If
	aPort = val(Dialog.s4TxtPort.Text)
	gINetSettings.setPropertyValue( "ProxyType", aProxy )
	If ( aProxy = 2 ) Then
		gINetSettings.setPropertyValue( "HTTPProxyName", Dialog.s4TxtProxy.Text )
		gINetSettings.setPropertyValue( "HTTPProxyPort", aPort )
		gINetSettings.setPropertyValue( "SecurityProxyName", Dialog.s4TxtProxy.Text )
		gINetSettings.setPropertyValue( "SecurityProxyPort", aPort )
	End If
End Sub


Sub setupImportBrowser(aValues as Object)
	'import browser settings from other application
	Dim i as Integer
	Dim aProp
	Dim INetBrwList(9) as String
	Dim BrowserList(0) as String

	INetBrwList(0) = "HTTPProxyPort"
	INetBrwList(1) = "HTTPProxyName"
	INetBrwList(2) = "FTPProxyPort"
	INetBrwList(3) = "FTPProxyName"
	INetBrwList(4) = "SecurityProxyPort"
	INetBrwList(5) = "SecurityProxyName"
	INetBrwList(6) = "SocksProxyPort"
	INetBrwList(7) = "SocksProxyName"
	INetBrwList(8) = "ProxyType"
	INetBrwList(9) = "NoProxy"

	BrowserList(0) = "HomePage"

	For i = 0 to ubound( INetBrwList() )
		If aValues.hasByName( INetBrwList(i) ) Then
			aProp = aValues.getByName( INetBrwList( i ) )
			gINetSettings.setPropertyValue( INetBrwList( i ), aProp )
		End If
	Next i
	For i = 0 to ubound( BrowserList() )
		If aValues.hasByName( BrowserList(i) ) Then
			aProp = aValues.getByName( BrowserList( i ) )
			gBrowserSettings.setPropertyValue( BrowserList( i ), aProp )
		End if
	Next i
End Sub


Sub setupEmailAccount(sInetType as String, UBoundProp as Integer)
	'create pop3 account via ucb and set general mail settings
	'this is called when the user selected a manual mail setup
	dim xContentID as Object
	dim xParent as Object

	xContentID = gUCB.createContentIdentifier(gGroupDir)
	xParent = gUCB.queryContent(xContentID)

	dim aProperties( UBoundProp ) as new com.sun.star.beans.PropertyValue

	aProperties( 0 ).Name  = "ServerName"
	aProperties( 0 ).Value = Dialog.s6TxtReceive.Text
	aProperties( 0 ).Handle = -1
	aProperties( 1 ).Name  = "UserName"
	aProperties( 1 ).Value = Dialog.s6TxtUser.Text
	aProperties( 1 ).Handle = -1
	aProperties( 2 ).Name  = "Title"
	aProperties( 2 ).Value = Dialog.s6TxtAccount.Text
	aProperties( 2 ).Handle = -1
	aProperties( 3 ).Name  = "Password"
	aProperties( 3 ).Value = Dialog.s6TxtPassword.Text
	aProperties( 3 ).Handle = -1

	If sInetType = "application/vnd.sun.staroffice.pop3-box" Then
		Dim aSendProperties( 0 ) as new com.sun.star.chaos.SendInfo
		aSendProperties(0).ProtocolType = "SMTP"
		aSendProperties(0).Value = Dialog.s6TxtSend.Text

		aProperties( 4 ).Name  = "UseOutBoxPrivateProtocolSettings"
		aProperties( 4 ).Value = False
		aProperties( 4 ).Handle = -1
		aProperties( 5 ).Name  = "UseOutBoxPublicProtocolSettings"
		aProperties( 5 ).Value = False
		aProperties( 5 ).Handle = -1
		aProperties( 6 ).Name  = "SendServerNames"
		aProperties( 6 ).Value = aSendProperties()
		aProperties( 6 ).Handle = -1
	
	
		makeContent(xParent, sInetType, aProperties())
	Else
		makeContent(xParent, sInetType, aProperties())
	End If
	gINetSettings.setPropertyValue( "MailUserName", Dialog.s6TxtUser.Text )
	gINetSettings.setPropertyValue( "SMTPServer", Dialog.s6TxtSend.Text )
	gINetSettings.setPropertyValue( "POPServer", Dialog.s6TxtReceive.Text )
End Sub



Sub setupImportMail(aValues as Object, aUserName as String)
	'create pop3 account via ucb if the import application is not StarOffice
	'and set general mail settings, otherwise copy storage files from old StarOffice
	'this is called when the user selected to import the mail settings
	Dim t,i as Integer
	Dim aProp
	Dim MailSettings(3) as String
	Dim xContentID as Object
	Dim xParent as Object
	Dim aBox as Object
	Dim aBoxes as Object
	Dim aUsers as Object
	Dim aList as Object
	Dim sInetType as String
	Dim NoImport as Boolean
	Dim aProperties( 6 ) as new com.sun.star.beans.PropertyValue
	Dim aSendProperties( 0 ) as new com.sun.star.chaos.SendInfo

	NoImport = False

	MailSettings(0) = "SMTPServer"
	MailSettings(1) = "POPServer"
	MailSettings(2) = "MailUserName"
	MailSettings(3) = "IMAPServerName"

	aUsers = aValues.getElementNames()
	If aUserName = "" Then aUserName = aUsers(0)

	aValues = aValues.getByName( aUserName )
	For i = 0 to UBound( MailSettings() )
		If aValues.hasByName( MailSettings(i) ) Then
			aProp = aValues.getByName( MailSettings( i ) )
			gINetSettings.setPropertyValue( MailSettings( i ), aProp )
		End If
	Next i

	If aValues.hasByName("box") Then
		aBoxes = aValues.getByName("box")
		aList = aBoxes.getElementNames()

		If Mid(aUserName, 1, 1) = "*" Then aUserName = Mid(aUserName, 2, Len(aUserName)-1)

		xContentID = gUCB.createContentIdentifier(gGroupDir)
		xParent = gUCB.queryContent(xContentID)
		For t = 0 to UBound(aList)
			If aBoxes.hasByName(aList(t)) Then
				aBox = aBoxes.getByName(aList(t))
				If aBox.getByName("typ") = 1 Then
					'import box from StarOffice
					copyOfficeStorages(aBox)
				Else
					'import from other application
					Select Case aBox.getByName("ServerTyp")
						Case 2
							NoImport = False
							sInetType = "application/vnd.sun.staroffice.pop3-box"
						Case 4
							'IMAP knnen wir noch nicht importieren (ausser StarOffice)
							'sInetType = "application/vnd.sun.staroffice.imap-box"
							NoImport = True
						Case Else
							NoImport = True
					End Select
					If not NoImport Then
						aProperties( 0 ).Name  = "ServerName"
						If aBox.hasByName("ServerName") Then
							aProperties( 0 ).Value = aBox.getByName("ServerName")
						Else
							aProperties( 0 ).Value = ""
						End If
						aProperties( 0 ).Handle = -1
						aProperties( 1 ).Name  = "UserName"
						If aBox.hasByName("MailUserName") Then
							aProperties( 1 ).Value = aBox.getByName("MailUserName")
						Else
							aProperties( 1 ).Value = ""
						End If
						aProperties( 1 ).Handle = -1
						aProperties( 2 ).Name  = "Title"
						aProperties( 2 ).Value = gMailboxName & " " & aBox.getByName("ServerName")
						aProperties( 2 ).Handle = -1
						aProperties( 3 ).Name  = "Password"
						aProperties( 3 ).Value = ""
						aProperties( 3 ).Handle = -1
						aProperties( 4 ).Name  = "UseOutBoxPrivateProtocolSettings"
						aProperties( 4 ).Value = False
						aProperties( 4 ).Handle = -1
						aProperties( 5 ).Name  = "UseOutBoxPublicProtocolSettings"
						aProperties( 5 ).Value = False
						aProperties( 5 ).Handle = -1

						aSendProperties(0).ProtocolType = "SMTP"
						
						'-------------Start of Workaround for Bug #74885
						Dim t1 as Integer
						Dim aBox1 as Object
						Dim getNextSMTP2 as String
						getNextSMTP2 = ""
						For t1 = t to UBound(aList)
							If aBoxes.hasByName(aList(t1)) Then
								aBox1 = aBoxes.getByName(aList(t1))
								'import from other application
								If aBox1.getByName("ServerTyp") = 1 Then
									getNextSMTP2 = aBox1.getByName("ServerName")
								Else
									'NoOp
								End If
							End If
						Next t1
						aSendProperties(0).Value = getNextSMTP2
						'-------------End of Workaround for Bug #74885
						
						'commented out because of Bug #74885
						'aSendProperties(0).Value = getNextSMTP(t, aBoxes, aList)

						aProperties( 6 ).Name  = "SendServerNames"
						aProperties( 6 ).Value = aSendProperties()
						aProperties( 6 ).Handle = -1

						makeContent(xParent, sInetType, aProperties())
					End If
				End If
			End If
		Next t
	End If
End Sub


Function getNextSMTP(i as Integer, aBoxes as Object, aList as Object)
	'finds the next SMTP Server name that fits to the previously found mail account
	Dim t as Integer
	Dim aBox as Object
	getNextSMTP = ""
	For t = i to UBound(aList)
		If aBoxes.hasByName(aList(t)) Then
			aBox = aBoxes.getByName(aList(t))
			'import from other application
			If aBox.getByName("ServerTyp") = 1 Then
				getNextSMTP = aBox.getByName("ServerName")
			Else
				'NoOp
			End If
		End If
	Next t
End Function


Sub setupManualNews
	'create news account via ucb and set general news settings
	'this is called when the user selected a manual news setup
	dim xContentID as Object
	dim xParent as Object
	dim sInetType as String

	xContentID = gUCB.createContentIdentifier(gGroupDir)
	xParent = gUCB.queryContent(xContentID)

	sInetType = "application/vnd.sun.staroffice.news-box"

	dim aProperties( 1 ) as new com.sun.star.beans.PropertyValue
	aProperties( 0 ).Name  = "ServerName"
	aProperties( 0 ).Value = Dialog.s9TxtServer.Text
	aProperties( 0 ).Handle = -1
	aProperties( 1 ).Name  = "Title"
	aProperties( 1 ).Value = Dialog.s9TxtAccount.Text
	aProperties( 1 ).Handle = -1

	makeContent(xParent, sInetType, aProperties())

	gINetSettings.setPropertyValue( "NNTPServer", Dialog.s9TxtServer.Text )
End Sub


Sub setupImportNews(aValues as Object, aUserName as String)
	'create news account via ucb from the imported information
	'and set general news settings.
	'this is called when the user selected to import the news settings
	Dim i,t as Integer
	Dim aProp
	Dim NewsSettings(0) as String
	Dim xContentID as Object
	Dim xParent as Object
	Dim aNewsGroup as Object
	Dim aList as Object
	Dim aUsers as Object
	Dim sInetType as String
	Dim aProperties( 1 ) as new com.sun.star.beans.PropertyValue

	xContentID = gUCB.createContentIdentifier(gGroupDir)
	xParent = gUCB.queryContent(xContentID)
	sInetType = "application/vnd.sun.staroffice.news-box"

	NewsSettings(0) = "NNTPServer"

	aUsers = aValues.getElementNames()
	If aUserName = "" Then aUserName = aUsers(0)

	aValues = aValues.getByName( aUserName )
	If Mid(aUserName, 1, 1) = "*" Then aUserName = Mid(aUserName, 2, Len(aUserName)-1)
	aList = aValues.getElementNames()
	For t = 0 to UBound(aList)
		aNewsGroup = aValues.getByName(aList(t))
		
		If aNewsgroup.hasByName("dateien") Then
			'import storage from StarOffice
			copyOfficeStorages(aNewsGroup)
		Else	
			For i = 0 to UBound( NewsSettings() )
			If aNewsGroup.hasByName( NewsSettings(i) ) Then
				aProp = aNewsGroup.getByName( NewsSettings( i ) )
				gINetSettings.setPropertyValue( NewsSettings( i ), aProp )
			End If
			Next i
			aProperties( 0 ).Name = "ServerName"
			aProperties( 0 ).Value = aNewsGroup.getByName( NewsSettings( 0 ) )
			aProperties( 0 ).Handle = -1
			aProperties( 1 ).Name  = "Title"
			aProperties( 1 ).Value = gNewsboxName & " " & aNewsGroup.getByName( NewsSettings( 0 ) )
			aProperties( 1 ).Handle = -1
			makeContent(xParent, sInetType, aProperties())
		End If
	Next t
End Sub


Sub makeContent(xParent as Object, sInetType as String, aProperties())
'This creates a new Internet content, such as a mail or news account
'by accepting the parent object where the acount is to be created,
'the type of content and a set of properties.

	Dim xCreator as Object
	Dim xInetContent as Object
	Dim xPropTask as Object
	Dim xCommandTask as Object
	Dim aInetContentInfo as new com.sun.star.ucb.ContentInfo
	Dim aCommand as new com.sun.star.ucb.Command

	' (1) create new empty content of given type
	aInetContentInfo.Type = sInetType
	xInetContent = xParent.createNewContent (aInetContentInfo)

	' (2) setup content by setting properties.
	xPropTask = xInetContent.createPropertyTask(com.sun.star.ucb.PropertyTaskType.SET,aProperties(),null)
	xPropTask.execute()

	' (3) insert content ( make it persistent )
	aCommand.Name   = "insert"
	aCommand.Handle = -1
	aCommand.Argument = null
	xCommandTask = xInetContent.createCommandTask(aCommand, null, null)

	xCommandTask.execute()
End Sub


Sub createMailGroup
	'create an explorer group entry if it is not there already
	Dim NewsSettings(0) as String
	Dim groupdir as String
	Dim xContentID as Object
	Dim xParent as Object
	Dim sInetType as String
	Dim aProperties( 0 ) as new com.sun.star.beans.PropertyValue
	
	If Dir(gGroupDir,16) = "" Then	
		groupdir = substpathvars("$(userurl)") & "/config/groups/"
		
		xContentID = gUCB.createContentIdentifier(groupdir)
		xParent = gUCB.queryContent(xContentID)
		sInetType = "application/vnd.sun.staroffice.fsys-folder"
	
		aProperties( 0 ).Name  = "Title"
		aProperties( 0 ).Value = getResText(MAIL_FOLDER)
		aProperties( 0 ).Handle = -1
		makeContent(xParent, sInetType, aProperties())
	End If
	InitializeMailGroup(gGroupDir)
End Sub


Sub InitializeMailGroup(GroupURL as String)		
Dim GroupWorkplaceURL as String
Dim Group as Object
Dim CHAOS as Object
Dim BackGround
Dim sViewURL as String
	Application.LoadLibrary("Initialize")
	CHAOS = createUNOService( "com.sun.star.chaos.System" )

	GroupWorkplaceURL = InitChaos()
	If FileExists(GroupURL) Then
		sViewURL = MakeViewURL( GroupWorkplaceURL, GroupURL ) 
		Group = CHAOS.createAnchor(sViewURL )
		Group.GroupViewConfig = 64 			'Treeview
		Group.UserSortCriterium = "FF"
		Group = MakeGroupFolderObject( GroupURL, GroupWorkplaceURL )
		BackGround = Group.FolderBackground
		Group.FolderBackground = BackGround
	End If
End Sub


Sub createOutBox
	'create an outbox if there isn't one already
	'to determine that, the routine has to perform an update command on the
	'directory where the storage files have been copied to
	Dim xContentID as Object
	Dim xParent as Object
	Dim aCommand as new com.sun.star.ucb.Command
	Dim xCommandTask as Object
	Dim outboxes()

	xContentID = gUCB.createContentIdentifier(gGroupDir)
	xParent = gUCB.queryContent(xContentID)

	aCommand.Name   = "update"
	aCommand.Handle = -1
	aCommand.Argument = null
	xCommandTask = xParent.createCommandTask(aCommand, null, null)

	xCommandTask.execute()

	outboxes() = gChaos.queryViews("",".chaos/out-box")
	If UBound(outboxes()) = -1 Then
		Dim sInetType as String
		sInetType = "application/vnd.sun.staroffice.out-box"
		Dim aProperties( 0 ) as new com.sun.star.beans.PropertyValue

		aProperties( 0 ).Name  = "Title"
		aProperties( 0 ).Value = gOutBoxName
		aProperties( 0 ).Handle = -1

		makeContent(xParent, sInetType, aProperties())
	End If
End Sub


Sub readOutSettings()
	'read out general office settings to display them already on the
	'dialog pages
	If gINetSettings.getPropertyValue( "ProxyType" ) = 0 Then
		Dialog.s4ChkNoProxy.Value = True
	Else
		Dialog.s4ChkNoProxy.Value = False
	End If
	ChangeProxyFields()
	Dialog.s4TxtProxy.Text = gINetSettings.getPropertyValue( "HTTPProxyName" )
	Dialog.s4TxtPort.Text = LTrim(Str(gINetSettings.getPropertyValue( "HTTPProxyPort" )))
End Sub


Function readAll

	'find all available applications for a complete import
	Dim i as Integer
	Dim aObj as Object
	Dim aList
	Dim IEList(6) as String
	Dim DummyIndex as Integer
	Dim lRetValue as Long
	Dim bDontgetOutlook as Boolean
	
	

	If not IsNull( gService ) Then
		If ( gService.hasByName( "alle" ) ) Then
			aObj = gService.getByName( "alle" )
			aList = aObj.getElementNames()
			Dialog.s2ListApps.Clear
			For i = LBound(aList) to UBound(aList)
				' Initialization 
				bDontgetOutlook = False
				If Instr(1,Ucase(aList(i)),"OUTLOOK") Then
					Application.LoadLibrary("ImportWizard")
					If Instr(1,Ucase(aList(i)),"OUTLOOK EXPRESS")Then
						lRetValue = OpenRegKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Outlook Express")
						If lRetValue = 0 Then
							' Key exists
							bDontGetOutLook = True
						End If
					Else
						bDontgetOutlook = True
					End If
				End If

				If bDontGetOutlook Then
					IEList() = ArrayoutofString(aList(i)," ", DummyIndex)
					aViewList(i,0) = IEList(0) & " " & IEList(1)	
					Dialog.s2outlookimport.Visible = bDontgetOutLook
				Else
					aViewList(i,0) = aList(i)
				End If						
				aViewList(i,1) = aList(i)				
				Dialog.s2ListApps.AddItem( aViewList(i,0) )
			Next i
		

			
			If i > 0 Then
				readAll = 2
			Else
				If not readBrowser() Then
					Dialog.s3OptImport.Enabled = False
					If Dialog.s3OptImport.Value = True Then Dialog.s3OptManual.Value = True
				End If
				readAll = 3
			End If
		Else
			If not readBrowser() Then
				Dialog.s3OptImport.Enabled = False
				If Dialog.s3OptImport.Value = True Then Dialog.s3OptManual.Value = True
			End If
			readAll = 3
		End If
	Else
		If not readBrowser() Then
			Dialog.s3OptImport.Enabled = False
			Dialog.s3OptImport.Value = Dialog.s3OptManual.Value
		End If
		readAll = 3
	End If
End Function


Function readBrowser
	'find all available applications for a browser settings import
	Dim i as Integer
	Dim aObj as Object
	Dim aList
	If not IsNull( gService ) Then
		If ( gService.hasByName( "browser" ) ) Then
			aObj = gService.getByName( "browser" )
			aList = aObj.getElementNames()
			Dialog.s3ListApps.Clear
			For i = LBound(aList) to UBound(aList)
				Dialog.s3ListApps.AddItem( aList(i) )
			Next i
			readBrowser = True
		Else
			readBrowser = False
		End If
	Else
		readBrowser = False
	End If
End Function


Function readMail
	'find all available applications for a mail settings import
	Dim i as Integer
	Dim aObj as Object
	Dim aList
	If not IsNull( gService ) Then
		If ( gService.hasByName( "mail" ) ) Then
			aObj = gService.getByName( "mail" )
			aList = aObj.getElementNames()
			Dialog.s5ListApps.Clear
			For i = LBound(aList) to UBound(aList)
				Dialog.s5ListApps.AddItem( aList(i) )
			Next i
			readMail = True
		Else
			readMail = False
		End If
	Else
		readMail = False
	End If
End Function


Function readNews
	'find all available applications for a news settings import
	Dim i as Integer
	Dim aObj as Object
	Dim aList
	If not IsNull( gService ) Then
		If ( gService.hasByName( "news" ) ) Then
			aObj = gService.getByName( "news" )
			aList = aObj.getElementNames()
			Dialog.s8ListApps.Clear
			For i = LBound(aList) to UBound(aList)
				Dialog.s8ListApps.AddItem( aList(i) )
			Next i
			readNews = True	
		Else
			readNews = False
		End If
	Else
		readNews = False
	End If
End Function


Function readMailUsers(iApp as String)
'find all available users in a given application for a mail settings import
	Dim aAList as Object
	Dim aList as Object
	Dim aValues as Object
	Dim i, t as Integer
	t = 0
	readMailUsers = False
	If not IsNull( gService ) Then
		If ( gService.hasByName( "mail" ) ) Then
			aAList = gService.getByName( "mail" )
			aValues = aAList.getByName( iApp )
			aList = aValues.getElementNames()
			Dialog.s7ListUsers.Clear
			For i = LBound(aList) to UBound(aList)
				Dialog.s7ListUsers.AddItem( aList(i) )
				t = t + 1
			Next i
		End If
	End If
	If t > 1 Then readMailUsers = True
End Function


Function readNewsUsers(iApp as String)
'find all available users in a given application for a news settings import
	Dim aAList as Object
	Dim aList as Object
	Dim aValues as Object
	Dim i, t as Integer
	t = 0
	readNewsUsers = False
	If not IsNull( gService ) Then
		If ( gService.hasByName( "news" ) ) Then
			aAList = gService.getByName( "news" )
			aValues = aAList.getByName( iApp )
			aList = aValues.getElementNames()
			Dialog.s10ListUsers.Clear
			For i = LBound(aList) to UBound(aList)
				Dialog.s10ListUsers.AddItem( aList(i) )
				t = t + 1
			Next i
		End If
	End If
	If t > 1 Then readNewsUsers = True
End Function


Sub setAsStandard
	' Set StarOffice as standard web/mail/news application
	If Dialog.s1ChkStdOffice.Value = True Then
		If gProtChkService.IsSingleSettingAvailable() Then
			If Dialog.s1ChkStdHttp.Value = True Then
				gProtChkService.setProtocolHandler( 1 )		'HTTP
			End If
			If Dialog.s1ChkStdFtp.Value = True Then
				gProtChkService.setProtocolHandler( 2 )		'FTP
			End If
			If Dialog.s1ChkStdMail.Value = True Then
				gProtChkService.setProtocolHandler( 4 )		'Mail
			End If
			If Dialog.s1ChkStdNews.Value = True Then
				gProtChkService.setProtocolHandler( 5 )		'News
			End If
		else
			gProtChkService.setProtocolHandler( 0 )			'Alltogether
		End If
	End If
End Sub


Sub toggleStandards
'determine if single settings for the protocol handler are available and en/disable
'the corresponding checkboxes
	Dim singleSetting as Boolean
	singleSetting = False
	Dialog.s1ChkStdHttp.Enabled = Dialog.s1ChkStdOffice.Value
	Dialog.s1ChkStdFtp.Enabled = Dialog.s1ChkStdOffice.Value
	Dialog.s1ChkStdMail.Enabled = Dialog.s1ChkStdOffice.Value
	Dialog.s1ChkStdNews.Enabled = Dialog.s1ChkStdOffice.Value
	If not IsNull( gProtChkService ) Then singleSetting = gProtChkService.IsSingleSettingAvailable()
	Dialog.s1ChkStdOffice.Visible = singleSetting
	Dialog.s1ChkStdHttp.Visible = singleSetting
	Dialog.s1ChkStdFtp.Visible = singleSetting
	Dialog.s1ChkStdMail.Visible = singleSetting
	Dialog.s1ChkStdNews.Visible = singleSetting
End Sub


Sub copyOfficeStorages( aBox as Object )
'for a mail import from an old StarOffice installation the storage files
'are simply copied
	Dim i As Integer
	Dim aFiles As Object
	Dim aStorage As Object
	Dim aSource As String, aDest As String

	aFiles		= aBox.GetByName( "dateien" )

	aStorage	= aFiles.getByName( "scc" )
	aSource		= aStorage.getByName( "quelle" )
	aDest		= aStorage.getByName( "ziel" )
	
	For i = len(aDest) to 1 step -1
		If Mid(aDest,i,1) = "\" or Mid(aDest,i,1) = "/" or Mid(aDest,i,1) = ":" Then
			aDest = Mid(aDest,i+1,(len(aDest)-i))
			Exit For
		End If
	Next i
	
	aDest = gGroupDir & aDest
	
	If FileExists( aSource ) and not FileExists( aDest ) Then
		FileCopy( aSource, aDest )
	Else
		Exit Sub
	End If

	aStorage	= aFiles.getByName( "user" )
	aSource		= aStorage.getByName( "quelle" )
	aDest		= aStorage.getByName( "ziel" )

	If FileExists( aSource ) and not FileExists( aDest ) Then
		FileCopy( aSource, aDest )
	End If

	aStorage	= aFiles.getByName( "cache" )
	aSource		= aStorage.getByName( "quelle" )
	aDest		= aStorage.getByName( "ziel" )

	If FileExists( aSource ) and not FileExists( aDest ) Then
		FileCopy( aSource, aDest )
	End If
End Sub