'SBLLINK:MethodInfo=SetPrinterOnDoc0
'SBLLINK:MethodInfo=GetSeperateOfText0
'SBLLINK:MethodInfo=GetLinesOfText0
'SBLLINK:MethodInfo=GetSeparateCountOfText0
'SBLLINK:MethodInfo=CopyStringsToArray0
'SBLLINK:MethodInfo=CopyArrayToStrings0
'SBLLINK:MethodInfo=AddArrayToStrings0
'SBLLINK:MethodInfo=InsertString0
'SBLLINK:MethodInfo=CopyStringsToBox0
'SBLLINK:MethodInfo=CopyBoxToStrings0
'SBLLINK:MethodInfo=GetSelectedStringListItem0
'SBLLINK:MethodInfo=SetSelectedItemFromListBox0
'SBLLINK:MethodInfo=GetSelectedItemFromListBox0
'SBLLINK:MethodInfo=GetSelectedTextFromListBox0
'SBLLINK:MethodInfo=SetHidden0
'SBLLINK:MethodInfo=ClearHidden0
'SBLLINK:MethodInfo=ClearAllHidden0
'SBLLINK:MethodInfo=SetOrgHidden0
'SBLLINK:MethodInfo=SetPaintLock0
'SBLLINK:MethodInfo=ClearPaintLock0
'SBLLINK:MethodInfo=GetRangeStr0
'SBLLINK:MethodInfo=GetControlByName0
'SBLLINK:MethodInfo=GetControlViewByName0
'SBLLINK:MethodInfo=GetDBObject0
'SBLLINK:MethodInfo=GetSizeOfGrafik0
'SBLLINK:MethodInfo=GetDateList0
'SBLLINK:MethodInfo=StrInArray0
'SBLLINK:MethodInfo=PathToUrl0
'SBLLINK:MethodInfo=GetTemplateRanges0
'SBLLINK:MethodInfo=GetPrinterPaperTray0
'SBLLINK:MethodInfo=GetAllFormDescriptions0
'SBLLINK:MethodInfo=GetFormDescription0
'SBLLINK:MethodInfo=GetPrinterFonts0
'SBLLINK:MethodInfo=UnLock0
'SBLLINK:MethodInfo=GetSelectionInList0
'SBLLINK:MethodInfo=GetParagraphStyleByName0
'SBLLINK:MethodInfo=GetCharHeight0
'SBLLINK:MethodInfo=GetLineSpacing0
REM  *****  BASIC  *****

Function GetSeperateOfText(sText as String, sSeparateChar as String) as Variant
	Dim nPos1%, nPos2%, nCount%, nIndex%
	nIndex = 0
	nCount = GetSeparateCountOfText (sText, sSeparateChar)
	Dim aArray (nCount-1) as String
	nPos1 = 1
	nPos2 = InStr (sText, sSeparateChar)
	while nPos2>0
		aArray (nIndex) = mid (sText, nPos1, nPos2-nPos1) 
		nPos1 = nPos2 + 1
		nPos2 = InStr (nPos1, sText, sSeparateChar)
		nIndex = nIndex + 1
	wend
	aArray (nIndex) = mid (sText, nPos1, len(sText)-nPos1+1)
	GetSeperateOfText = aArray()
end Function

Function GetLinesOfText(sText as String) as Variant
	GetLinesOfText = GetSeperateOfText (sText, chr(cReturn))
end Function

Function GetSeparateCountOfText(sText as String, sSeparateChar as String) as Integer
	Dim nPos%, nCount%
	nCount = 1
	nPos = InStr (sText, sSeparateChar)
	while nPos>0
		nPos = InStr (nPos+1, sText, sSeparateChar)
		nCount = nCount + 1
	wend
	GetSeparateCountOfText = nCount
end Function

Function StrInArray%(ByVal AvailNames As Variant, ByVal ActiveName$)
	Dim Result%, nCount%
	Dim bNotFound%
	
	bNotFound% = True
	nCount% = 0
	ActiveName$ = UCase(ActiveName$)
	While ((nCount%<=UBound(AvailNames)) And bNotFound%)
		If (UCase(AvailNames(nCount%))=UCase(ActiveName$)) Then 
			bNotFound%=False
		Else
			nCount% = nCount% + 1
		End If
	Wend
	
	If (bNotFound%) Then
		StrInArray% = -1
	Else
		StrInArray% = nCount%
	End If	
End Function

Function CopyStringsToArray (sStringList as Object, OPTIONAL sAddList as Variant) as Variant
	Dim nCount%, i%, nAddCount%, nDimElements%
	
	if IsObject(sAddList) and (not(IsNull (sAddList))) then
		nAddCount% = sAddList.Count
	else	
		nAddCount% = 0
	end If	
		
	if nAddCount% < 1 Then
		nCount% = sStringList.Count
	else
		nCount% = sStringList.Count + nAddCount%
	end if
	
	nDimElements% = nCount%
	if nCount% = 0 then
		nDimElements% = 1 ' dieses Array wird dann aber nicht uebergeben, sondern ein leeres
	end If
	
	Dim sArray (nDimElements%-1) as String
	Dim sArrayEmpty () as String
	
	for i% = 0 to nAddCount%-1
		sArray (i%) = sAddList.Item (i%+1)
	next
	
	for i% = 0 to nCount%-nAddCount%-1
		sArray (i%+nAddCount%) = sStringList.Item (i%+1)
	next
	
	if nCount% > 0 then
		CopyStringsToArray = sArray()
	else
		CopyStringsToArray = sArrayEmpty()
	end If	
End Function

Sub CopyArrayToStrings (sArray as Variant, sStringList as Strings) 
	Dim nCount%, i%
	sStringList.Clear()
	nCount% = UBound (sArray)
	for i% = 0 to nCount%
		sStringList.Add (sArray(i%))
	next
end Sub

Sub AddArrayToStrings (sArray as Variant, sStringList as Strings) 
	Dim nCount%, i%
	nCount% = UBound (sArray)
	for i% = 0 to nCount%
		sStringList.Add (sArray(i%))
	next
end Sub

Sub InsertString (sString as String, sStringList as Strings, nIndex as long) 
	Dim nCount%, i%
	Dim sNewStrings as New Strings
	Dim aTestArray as Variant
	
	if nIndex <= sStringList.Count() then
		for i% = 1 to sStringList.Count
			if  i% = nIndex+1 then
				sNewStrings.Add(sString)
			end If	
			sNewStrings.Add(sStringList.Item(i%))
		next
		sStringList.Clear()
		for i% = 1 to sNewStrings.Count
			sStringList.Add(sNewStrings.Item(i%))
		next
	end If
	aTestArray = CopyStringsToArray (sNewStrings)
end Sub

Sub CopyStringsToBox (sName as String, sStringList as Object, OPTIONAL sAddList as Variant)
	Dim aControl as Object
	Dim aItems as Variant
	aControl = GetControlByName (sName)
	if IsObject(sAddList) and (not(IsNull (sAddList))) then
		aItems = CopyStringsToArray (sStringList, sAddList)
	else
		aItems = CopyStringsToArray (sStringList)
	end If	
	aControl.StringItemList = aItems
End Sub

Sub CopyBoxToStrings (sName as String, sStringList as Object)
	Dim aControl as Object
	Dim aItems as Variant
	aControl = GetControlByName (sName)
	aItems = aControl.StringItemList
	CopyArrayToStrings (aItems, sStringList)
End Sub

Function GetSelectionInList (sStringList as Strings, sSearchStr as String) as integer
	Dim i%
	GetSelectionInList = 0
	for i = 1 to sStringList.Count
		if sSearchStr = sStringList.Item (i) then
			GetSelectionInList = i-1
			exit For
		end If	
	next
End Function

Function GetSelectedStringListItem (sStringList as Object, nIndex) as String
	if (nIndex >= 0) and (sStringList.Count > nIndex) then
		GetSelectedStringListItem = sStringList.Item (nIndex + 1)
	else
		GetSelectedStringListItem = ""
	end If
end Function

Sub SetSelectedItemFromListBox (sName as String, nIndex as long)
	Dim SelItems (0)
	Dim aControl as Object
	Dim aItemNames as Variant
	SelItems(0) = nIndex
	aControl = GetControlByName(sName)
	aItemNames = aControl.StringItemList
	if UBound(aItemNames)>=nIndex then
		aControl.SelectedItems  = SelItems()
	end If
end Sub

Function GetSelectedItemFromListBox (sName as String) as integer
	Dim SelItems as Variant
	SelItems = GetControlByName(sName).SelectedItems
	if UBound (SelItems) >=0 then
		GetSelectedItemFromListBox = SelItems(0)
	else
		GetSelectedItemFromListBox = 0
	end If	
end Function

Function GetSelectedTextFromListBox (sName as String) as String
	Dim nIndex as long
	Dim aItems as Variant
	
	GetSelectedTextFromListBox = ""
	nIndex = GetSelectedItemFromListBox (sName)
	aItems = GetControlByName (sName).StringItemList
	if nIndex >=0 then
		GetSelectedTextFromListBox = aItems (nIndex)
	end If	
end Function

Sub SetHidden (RangeNr as long)
	aSections.GetByName(GetRangeStr(RangeNr)).IsHidden = True
	'aSections.GetByIndex(RangeNr).IsHidden = True
end Sub

Sub ClearHidden (RangeNr as long)
	aSections.GetByName(GetRangeStr(RangeNr)).IsHidden = False
	'aSections.GetByIndex(RangeNr).IsHidden = False
end Sub

Sub ClearAllHidden(bLock as Boolean)
	Dim i%, nCount%
	nCount% = aSections.Count
	for i = 1 to nCount%
		call ClearHidden (i%)
	next
end Sub

Sub SetOrgHidden(bLock as Boolean)
	Dim i%, nCount%
	nCount% = aSections.Count
	call ClearHidden(nPageCounter%)
	for i% = 1 to nCount%
		if i%<>nPageCounter% then
			call SetHidden (i%)
		end If	
	next
end Sub

Sub SetPaintLock
	bLockStack (nLockStackCount%) = aActiveWindow.IsPaintLocked
	if (not bLockStack (nLockStackCount%)) then
		aActiveWindow.LockPaint(True)
		aDoc.LockControllers
	End If
	nLockStackCount% = nLockStackCount% + 1
End Sub

Sub ClearPaintLock
	nLockStackCount% = nLockStackCount% - 1
	if nLockStackCount%<0 then
		nLockStackCount% = 0
	end If	
	if (not bLockStack (nLockStackCount%)) then
		aActiveWindow.LockPaint(False)
		aDoc.UnLockControllers
	End If
End Sub

Function GetRangeStr (RangeNr as long) as string
	GetRangeStr = cRangeStr+Trim(Str(RangeNr))
end Function

Function GetControlByName (sName as String) as Object
	GetControlByName = aForm.GetByName(sName)
end Function

Function GetControlViewByName (sName as String) as Object
	Dim aView, aControl as Object
	aView = aDoc.CurrentController
	aControl = aForm.GetByName(sName)
	GetControlViewByName = aView.GetControl(aControl)
end Function

Function GetDBObject(sDBName as String) as Object
	Dim aDBEngine, aDBWorkspace, aDBDatabase as Object
	aDBEngine = CreateUnoService("stardiv.one.data.DatabaseEngine")
	aDBWorkspace = aDBEngine.Workspaces.getByIndex(0)
	aDBDatabase  = aDBWorkspace.open(aDBEngine.getLocation(sDBName))
	GetDBObject = aDBDatabase
End Function		

Function GetSizeOfGrafik (sName as String, aDoc as Object) as Object

	'Die Funkton legt ein Grafik-Objekt an, liest die Gre aus, und entfernt die Grafik wieder
	
	Dim aDescGrafik, aGraphic as Object
	aGraphic = CreateGraphicObject (sName, aDoc)
	'aDescGrafik.AnchorPageNo = 2 ' auf Seite 2 -> damit die Grafik nicht sichtbar wird 
	'aGraphic = aDoc.GraphicObjects.InsertGraphic(aDescGrafik)
	GetSizeOfGrafik = aGraphic.Size
	aGraphic.Dispose
end Function

Sub GetDateList (aDoc as Object)
	Dim sValue as String
	Dim aFormatArray as Variant
	Dim i%
	sValue = ReadUserField(cUfldLanguage, aDoc)
	if sValue = "" then
		aFormatArray = aDoc.GetEntryTable (2, 0, True) ' Parameter (FormatType = 2, Standard = 0, ? = True)
	else
		aFormatArray = aDoc.GetEntryTable (2, Val(Trim(sValue)), True) ' Parameter (FormatType = 2, Language, ? = True)
	end If	
	'aFormatArray = aDoc.GetEntryTable (2, 1031, True) ' Parameter (FormatType = 2, Standard = 0, ? = True)
	sDateList.Clear()
	sDateNumList.Clear()
	for i = 0 to UBound(aFormatArray)
		sValue = aDoc.GetOutputString(0, 36525, aFormatArray(i)) ' Parameter (Farbe, Wert des Datums, Datumsformat)
		sDateList.Add (sValue)
		sDateNumList.Add (Trim(Str(aFormatArray(i)))
	next
	if sDateList.Count>0 then
		nSelElementDate = 0
	else
		nSelElementDate = -1 ' nichts selektiert
	end If
end Sub

Sub SetPrinterOnDoc (sPrinterName as String, aDoc as Object)
	Dim aPropArray (0) as Object
	aPropArray(0) = CreateUnoStruct("stardiv.uno.beans.PropertyValue")
	aPropArray(0).Name = "Name"
	aPropArray(0).Value = sPrinterName
	aDoc.Printer = aPropArray()
end Sub

Function PathToUrl (sPath as String) as String
	Dim aUrl, aUrlTrans as Object
	aUrl = createUnoStruct("stardiv.one.frame.URL")
	aUrlTrans = createUnoService("stardiv.one.frame.URLTransformer")
	aUrl.Complete = sPath
	aUrlTrans.ParseSmart( aUrl, "file:" )
	PathToUrl = aUrl.Main
End Function

Sub GetTemplateRanges (sTitleList as Strings)
	Dim aCHAOS, aViews, aAnchor, aStatus, aAnchorListener as Object
	sTemplateTitleList = sTitleList
	sTemplateTitleList.Clear
	bGetTemlateActive = True
	sTemplateTitleList.Add ("Standard") ' Standard ging es immer und wird nicht ausgelesen
	aCHAOS  = createUNOService( "stardiv.one.chaos.System" )
	aViews = aCHAOS.queryViews( "", "application/template" )
	if not IsNull( aViews ) then
		aAnchor = aCHAOS.CreateAnchor( aViews( 0 ) )
		aStatus = CreateUnoListener( "Status_", "stardiv.one.chaos.XStatusCallback" )
		aAnchorListener = CreateUnoListener( "Anchor_", "stardiv.one.chaos.XAnchorEventListener" )
 		aAnchor.addAnchorEventListener( aAnchorListener )
		aAnchor.execute( "open", 1, aStatus )
		while bGetTemlateActive wend ' warten, bis Aktion beendet -> Deadlock-Gefahr!
	end if
End Sub

Function GetPrinterPaperTray (sPrinterName as String) as Variant
	Dim aInfoPrinter, aPrinter as Object
	Dim aFormDescriptions, aPaperTray, aPrinterNames as Variant
	Dim nPrinterNr%
	aPrinter = CreateUnoService ("stardiv.vcl.PrinterServer")
	aPrinterNames = aPrinter.PrinterNames ' Namen der Drucker
	nPrinterNr = StrInArray (aPrinterNames(), sPrinterName)
	if nPrinterNr > -1 then
		aInfoPrinter = aPrinter.CreateInfoPrinter (aPrinterNames(nPrinterNr))
		aFormDescriptions = aInfoPrinter.FormDescriptions 'Druckerschchte
		aPaperTray = GetAllFormDescriptions (aFormDescriptions) 
	end If
	GetPrinterPaperTray = aPaperTray
end Function

Function GetAllFormDescriptions (aFormDescriptions as Object) as Variant
	Dim i%
	Dim aPaperTray (UBound (aFormDescriptions)) as String
	for i = 0 to UBound (aFormDescriptions)
		aPaperTray (i) = GetFormDescription (aFormDescriptions (i))
	next
	GetAllFormDescriptions = aPaperTray()
end Function

Function GetFormDescription (sFormDescription as String) as String
	Dim nPos1%, nPos2%
	nPos1 = InStr (sFormDescription, cFormDescriptionSeparator)
	nPos1 = InStr (nPos1+1, sFormDescription, cFormDescriptionSeparator)
	nPos2 = InStr (nPos1+1, sFormDescription, cFormDescriptionSeparator)
	GetFormDescription = Mid (sFormDescription, nPos1+1, nPos2-nPos1-1)
end Function

Sub GetPrinterFonts (sPrinterName as String, sFontList as Strings)
	Dim aFontArray as Variant
	Dim aFont as Object
	Dim sLastFontName as String
	Dim i%
	aPrinter = CreateUnoService ("stardiv.vcl.PrinterServer")
	aInfoPrinter = aPrinter.CreateInfoPrinter (sPrinterName)
	aNewPrinter = aInfoPrinter.CreateDevice ()
	aFontArray = aNewPrinter.FontDescriptors 'Fonts
	sLastFontName = ""
	sFontList.Clear
	for i=0 to UBound (aFontArray)
		aFont = aFontArray (i)
		if not (aFont.Name = sLastFontName) then
			sLastFontName = aFont.Name
			sFontList.Add (sLastFontName)
		end If	
	next
End Sub

Function GetParagraphStyleByName (sStyleName as String, aDoc as Object) as Object
	GetParagraphStyleByName = aDoc.StyleFamilies.GetByName ("ParagraphStyles").GetByName( sStyleName )
end Function

Function GetCharHeight (nEnum as Integer) as Integer
	Select Case (nEnum)
		Case cSize9pt
			GetCharHeight = 9
		Case cSize10pt
			GetCharHeight = 10
		Case cSize11pt
			GetCharHeight = 11
		Case cSize12pt
			GetCharHeight = 12
		Case cSize13pt
			GetCharHeight = 13
		Case else
			GetCharHeight = 12
		End Select
end Function

Function GetLineSpacing (nEnum as Integer) as Integer
	Select Case (nEnum)
		Case cSpacing1
			GetLineSpacing = 100
		Case cSpacing1Komma2
			GetLineSpacing = 120
		Case cSpacing1Komma3
			GetLineSpacing = 130
		Case cSpacing1Komma5
			GetLineSpacing = 150
		Case cSpacing2
			GetLineSpacing = 200
		Case else
			GetLineSpacing = 100
	End Select
end Function

Sub UnLock
	ActiveWindow.LockPaint(False)
	ActiveDocument.Uno.UnLockControllers
End Sub