'SBLLINK:MethodInfo=Main0
'SBLLINK:MethodInfo=MainWithDefault0
'SBLLINK:MethodInfo=InitDbEngine0
'SBLLINK:MethodInfo=FillDatabases0
'SBLLINK:MethodInfo=OpenDBConnection0
'SBLLINK:MethodInfo=CloseDbConnection0
'SBLLINK:MethodInfo=CreateReport0
'SBLLINK:MethodInfo=ReportTableSelect0
'SBLLINK:MethodInfo=ReportNewDatabaseSelect0
'SBLLINK:MethodInfo=ReportCmdCancel0
'SBLLINK:MethodInfo=ReportSetMoveRights0
'SBLLINK:MethodInfo=CheckButtons0
'SBLLINK:MethodInfo=ReportCmdPrevClicked0
'SBLLINK:MethodInfo=ReportCmdReadyClicked0
'SBLLINK:MethodInfo=ReportCmdNextOrReadyClicked0
'SBLLINK:MethodInfo=ReportReadTemplates0
'SBLLINK:MethodInfo=ReportGetTemplateFilename0
'SBLLINK:MethodInfo=ReportParaStyleSelected0
'SBLLINK:MethodInfo=ReportSetTitle0
'SBLLINK:MethodInfo=ReportGetTables0
'SBLLINK:MethodInfo=ReportGetFields0
'SBLLINK:MethodInfo=ReportNoCode0
'SBLLINK:MethodInfo=ReportMoveSelected0
'SBLLINK:MethodInfo=ReportMoveAll0
'SBLLINK:MethodInfo=ReportRemoveSelected0
'SBLLINK:MethodInfo=ReportRemoveAll0
'SBLLINK:MethodInfo=ReportResetGroupingData0
'SBLLINK:MethodInfo=ReportGroupPreview0
'SBLLINK:MethodInfo=ReportGroupClicked0
'SBLLINK:MethodInfo=ReportUngroupClicked0
'SBLLINK:MethodInfo=ReportlbGroupingClicked0
'SBLLINK:MethodInfo=ReportCopyListBoxToCombobox0
'SBLLINK:MethodInfo=ReportInitSortPage0
'SBLLINK:MethodInfo=ReportPreview1Repaint0
'SBLLINK:MethodInfo=ReportPreview3Repaint0
'SBLLINK:MethodInfo=ReportPreview4Repaint0
'SBLLINK:MethodInfo=ReportPreview5Repaint0
'SBLLINK:MethodInfo=ReportPreview6Repaint0
'SBLLINK:MethodInfo=ReportPreview7Repaint0
'SBLLINK:MethodInfo=ReportPreview8Repaint0
'SBLLINK:MethodInfo=ReportItemAvailable0
'SBLLINK:MethodInfo=ReportcmbSortEvent10
'SBLLINK:MethodInfo=ReportcmbSortEvent20
'SBLLINK:MethodInfo=ReportcmbSortEvent30
'SBLLINK:MethodInfo=ReportcmbSortEvent40
'SBLLINK:MethodInfo=ReportSetSortingCaption0
'SBLLINK:MethodInfo=ReportCmdSortingOpt10
'SBLLINK:MethodInfo=ReportCmdSortingOpt20
'SBLLINK:MethodInfo=ReportCmdSortingOpt30
'SBLLINK:MethodInfo=ReportCmdSortingOpt40
'SBLLINK:MethodInfo=ReportTitleReportGetFocus0
'SBLLINK:MethodInfo=CheckReportTitle0
'SBLLINK:MethodInfo=ReportGetColumnWidth0
'SBLLINK:MethodInfo=ReportIsFieldSortable0
'SBLLINK:MethodInfo=ReportIsFieldGrouped0
'SBLLINK:MethodInfo=ReportGetStyleType0
'SBLLINK:MethodInfo=ReportCreateReportNow0
'SBLLINK:MethodInfo=PutReportIntoDB0
Option Explicit

Global Const  DatabaseFieldType_BOOL			= -7
Global Const  DatabaseFieldType_TINYINT			= -6
Global Const  DatabaseFieldType_SMALLINT		= 5
Global Const  DatabaseFieldType_INTEGER			= 4
Global Const  DatabaseFieldType_BIGINT			= -5
Global Const  DatabaseFieldType_REAL			= 7
Global Const  DatabaseFieldType_DOUBLE			= 8
Global Const  DatabaseFieldType_NUMERIC			= 2
Global Const  DatabaseFieldType_DECIMAL			= 3
Global Const  DatabaseFieldType_CURRENCY		= 2222
Global Const  DatabaseFieldType_CHAR			= 1
Global Const  DatabaseFieldType_VARCHAR			= 12
Global Const  DatabaseFieldType_LONGVARCHAR		= -1
Global Const  DatabaseFieldType_DATE			= 91
Global Const  DatabaseFieldType_TIME			= 92
Global Const  DatabaseFieldType_DATETIME		= 93
Global Const  DatabaseFieldType_BINARY			= -2
Global Const  DatabaseFieldType_VARBINARY		= -3
Global Const  DatabaseFieldType_LONGVARBINARY	= -4
Global Const  DatabaseFieldType_OTHER			= 1111

Global Const  DatabaseSearch_NONE	= 0
Global Const  DatabaseSearch_CHAR	= 1
Global Const  DatabaseSearch_BASIC	= 2
Global Const  DatabaseSearch_ALL	= 3

Global Const DatabaseInfo_IDENTIFIER_QUOTE_CHAR	= 26

Global Const	DatabaseCursorType_FORWARD	= 0
Global Const	DatabaseCursorType_SNAPSHOT	= 1
Global Const	DatabaseCursorType_KEYSET	= 2
Global Const	DatabaseCursorType_DYNAMIC	= 3

Global Const	DatabaseCursorOption_UPDATABLE	= 0
Global Const	DatabaseCursorOption_READONLY	= 1
Global Const	DatabaseCursorOption_INSERTONLY	= 2

Global ReportActiveTableName$, ReportActiveDatabaseName$, ReportPath$,Report_Return_Result$
Global ReportChangedDataBaseSelection%,ReportGroupingChanged%,ReportFirstTimeGroupingShowed%
Global TemplatePath$

Global ReportInstalledDBNames As New Strings

Global ReportOriginalFieldList As New Strings
Global ReportInstalledQueries As New Strings
Global ReportInstalledTables As New Strings

' the UNO-DB-engine and it's default workspace
Dim aDbEngine, aDbWorkspace as Object
' the currently selected db
Dim aCurrentDb as Object
' the currently selected table, it's fields an a recordset representing it's first record
Dim aCurrentTable, aCurrentFields, aCurrentFirstRecord as Object

Dim bNeedFieldRefresh as Boolean

'       Group-Preview
Const MaxLevel% = 4
Global ReportLevelFields$(0 To MaxLevel%)

Const MaxFieldIndex% = 200
Const cText = 1, cFloat = 2, cInteger = 3, cLong = 4, cBoolean = 5, cMemo = 6

' -----------------------------------------------------------------------------
Sub Main()
	Call MainWithDefault ( "" )
End Sub

' -----------------------------------------------------------------------------
Sub MainWithDefault ( ByVal DBName$ )

On Error Goto GlobalError

	If (Not InitResources()) Then
		Exit Sub
	End If

	TemplatePath$ = Application.PathSettings.Template
	If InStr (TemplatePath$, ";")<>0 Then
		TemplatePath$ = Left$(TemplatePath$, InStr(TemplatePath$, ";")-1)       ' Non-Unix
	End If
	ReportPath$ = TemplatePath$ + GetPathSeparator() + "wizard" + _
							GetPathSeparator() + "bitmap" + GetPathSeparator()

	bNeedFieldRefresh = True
	CreateReport$( DBName$ )

	Exit Sub

GlobalError:
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
	Application.Interactive = True
	MsgBox(Report_gErrMsg$ , 16, Report_gWizardName$)
End Sub

' -----------------------------------------------------------------------------
Function InitDbEngine as Boolean
On Local Error Goto CouldNotInit
	aDbEngine = CreateUnoService("com.sun.star.data.DatabaseEngine")
	aDbWorkspace = aDbEngine.Workspaces( 0 )

	InitDbEngine = TRUE
	Exit Function

CouldNotInit:
	MsgBox Report_gErrNoEngine$ ( QueryActiveLanguage% )
	InitDbEngine = FALSE
End Function

' -----------------------------------------------------------------------------
Sub FillDatabases
	DlgReport.cmbAvailDatabase.Clear()

	Dim i%
	Dim aFavorites
	aFavorites = aDbEngine.getFavorites
	For i% = lbound(aFavorites) to ubound(aFavorites)
		DlgReport.cmbAvailDatabase.AddItem(aFavorites(i%).Name)
	Next i%
End Sub

' -----------------------------------------------------------------------------
Function OpenDBConnection(sName as String) as Boolean
	Application.EnterWait()
	Wait( 0 )

On Local Error goto could_not_open
	CloseDbConnection()	' just in case

	aCurrentDb = aDBWorkspace.open(sName)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, ReportInstalledDBNames, INC_REPORTS)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, ReportInstalledQueries, INC_QUERIES)
	UNO_GetAllInstalledNamesInDatabase(aCurrentDb, ReportInstalledTables, INC_TABLES)

	OpenDBConnection = TRUE
	goto exit_function

could_not_open:
	CloseDbConnection()
	ReportInstalledDBNames.Clear()
	ReportInstalledQueries.Clear()
	ReportInstalledTables.Clear()
	OpenDBConnection = FALSE

exit_function:
	Application.LeaveWait()
End Function

' -----------------------------------------------------------------------------
Sub CloseDbConnection()
	Dim aEmptyObject as Object
	aCurrentFirstRecord = aEmptyObject
	aCurrentFields = aEmptyObject
	aCurrentTable = aEmptyObject
	aCurrentDb = aEmptyObject
End Sub

' -----------------------------------------------------------------------------
Function CreateReport$(ActiveDataBaseName$)

On Error Goto GlobalError

	'       Initialize Global Variables
	Dim n%, nCount%

	Application.EnterWait()
	Wait( 0 )

	LoadLanguage ( Application.LanguageID )

	CreateReport$ = ""
	If Not InitDbEngine() Then
		Application.LeaveWait()
		Exit Function
	End If

	Application.LoadLibrary( "Tools" )
	InitDlgTools()

	ReportActiveTableName$ = ""
	ReportActiveDatabaseName$ = ""
	Report_Return_Result$ = ""
	ReportChangedDataBaseSelection% = 0
	ReportGroupingChanged% = 0
	ReportFirstTimeGroupingShowed% = 0
	Report_Return_Result$ = ""
	ReportActiveDatabaseName$ = ActiveDataBaseName$
	For n%=0 To MaxLevel%-1
		ReportLevelFields$(n%) = ""
	Next
	ReportFirstTimeGroupingShowed% = True
	ReportGroupingChanged% = True
	ReportChangedDataBaseSelection% = False

	DlgReport.Load()

	DlgReport.optCreateAndView.Value = True
	DlgReport.optCreateAndStore.Value = False

	If (ReportActiveDatabaseName$ = "") Then
		DlgReport.cmbAvailDatabase.Visible = True
		DlgReport.cmbAvailDatabase.Top = 420
		DlgReport.frameDatabase.Visible = True
		DlgReport.frameDatabase.Top = 180
		DlgReport.frameTables.Top = DlgReport.frameTables.Top + DlgReport.frameDatabase.Height + 90
		DlgReport.frameTables.Height = DlgReport.frameTables.Height - DlgReport.frameDatabase.Height - 90
		DlgReport.lbTables.Top = DlgReport.lbTables.Top + DlgReport.frameDatabase.Height + 90
		DlgReport.lbTables.Height = DlgReport.lbTables.Height - DlgReport.frameDatabase.Height - 90

		FillDatabases()

		If (0 = DlgReport.cmbAvailDatabase.ListCount()) Then
			MsgBox(Report_gErrNoDatabase$ , 64, Report_gWizardName$ )
			While ( Application.IsWait() )
				Application.LeaveWait()
			Wend
			Exit Function
		Else
			DlgReport.cmbAvailDatabase.ListIndex = 0
			ReportActiveDatabaseName$ = DlgReport.cmbAvailDatabase.List(DlgReport.cmbAvailDatabase.ListIndex())
		End If
		DlgReport.cmbAvailDatabase.SetFocus
	Else
		DlgReport.cmbAvailDatabase.Visible = False
		DlgReport.frameDatabase.Visible = False
		DlgReport.lbTables.SetFocus
	End If

	DlgReport.cmbSort1.Height=1500
	DlgReport.cmbSort2.Height=1500
	DlgReport.cmbSort3.Height=1500
	DlgReport.cmbSort4.Height=1500
	DlgReport.CurrentStep = 1
	DlgReport.cmdPrev.Enabled = False

	OpenDbConnection(ReportActiveDatabaseName$)

	ReportSetTitle()
	ReportGetTables()
	ReportResetGroupingData()
	ReportReadTemplates()
	CheckButtons(1)

	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	' initialize some defaults (in case somebody uses the "finish" button before visiting the last page)
	DlgReport.optStyle1.Value = 1
	DlgReport.optStyle2.Value = 0
	DlgReport.optStyle3.Value = 0
	DlgReport.optStyle4.Value = 0
	DlgReport.optStyle5.Value = 0
	DlgReport.optStyle6.Value = 0
	DlgReport.optPortrait.Value = 0
	DlgReport.optLandscape.Value = 1
	DlgReport.optCreateAndView.Value = 1
	DlgReport.optCreateAndStore.Value = 0

	DlgReport.Show()
	CreateReport$ = Report_Return_Result$
	Exit Function
GlobalError:
	while( Application.IsWait() )
		Application.LeaveWait()
	wend
	MsgBox ( Report_gErrMsg$ , 16, Report_gWizardName$ )
	CreateReport$ = ""
End Function

' -----------------------------------------------------------------------------
Sub ReportTableSelect
	bNeedFieldRefresh = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportNewDatabaseSelect()
	Application.EnterWait()
On Local Error Goto leave_wait
	ReportActiveDatabaseName$ = DlgReport.cmbAvailDatabase.List(DlgReport.cmbAvailDatabase.ListIndex())

	' initially clear the tables list
	DlgReport.lbTables.Clear()
	' and disable some controls so the user can't select a database while selecting a database (or something like that)
	DlgReport.cmdNextOrReady.Enabled = FALSE
	DlgReport.cmdCancel.Enabled = FALSE
	DlgReport.cmbAvailDatabase.Enabled = FALSE
	DlgReport.lbTables.Enabled = FALSE

	' just in case there were already selected fields
	DlgReport.cmdReady.Enabled = FALSE
	DlgReport.lbSelected.Clear()
	DlgReport.lbFields.Clear()

	' then open the db (this is the may-be-expensive part)
	OpenDBConnection(ReportActiveDatabaseName$)

	' and fill in the tables
	ReportGetTables()
	ReportResetGroupingData()

	' and enable the ui
	DlgReport.lbTables.Enabled = TRUE
	DlgReport.cmbAvailDatabase.Enabled = TRUE
	DlgReport.cmdCancel.Enabled = TRUE
	DlgReport.cmdNextOrReady.Enabled = TRUE

leave_wait:
	bNeedFieldRefresh = True
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdCancel()
	DlgReport.Hide()
	DlgReport.UnLoad()
	Report_Return_Result$ = ""
	CloseDbConnection()
End Sub

' -----------------------------------------------------------------------------
Sub ReportSetMoveRights()
	'       enables or disables the buttons for the moving of available
	'       fields between the two list boxes.
	Dim FieldCount%, FieldSelected%, SelectCount%,SelectSelected%

	FieldSelected% = (-1<>lbFields.ListIndex())
	FieldCount% = lbFields.ListCount()

	SelectSelected% = (-1<>lbSelected.ListIndex())
	SelectCount% = lbSelected.ListCount()

	cmdRemoveAll.Enabled = (SelectCount%>=1)
	cmdRemoveSelected.Enabled = (SelectCount%>=1 And SelectSelected%)
	cmdMoveAll.Enabled = (FieldCount%>=1)
	cmdMoveSelected.Enabled = (FieldCount%>=1 And FieldSelected%)
	cmdNextOrReady.Enabled = (SelectCount%>=1)
End Sub

' -----------------------------------------------------------------------------
Sub CheckButtons(nNextStep as Integer)
	' "next" button : disabled on the last page and on the second page if no fields are selected
	DlgReport.cmdNextOrReady.Enabled = (nNextStep <> 7) And ((nNextStep <> 2) Or (DlgReport.lbSelected.ListCount()<>0)) _
		And ((nNextStep <> 1) Or (DlgReport.lbTables.ListCount>=1))
	' "prev" button : disabled on page 1
	DlgReport.cmdPrev.Enabled = (nNextStep <> 1)
	' "finish" button : enabled if there are enough informations to create the report, this means
	' there has to be at least one field in the report
	DlgReport.cmdReady.Enabled = (DlgReport.lbSelected.ListCount() <> 0)
	' cancel may be disabled explicitly if needed so we have to reset it
	DlgReport.cmdCancel.Enabled = True

	If (2 = nNextStep) Then
		ReportSetMoveRights()
	End If
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdPrevClicked()
	If (DlgReport.CurrentStep = 7) And (Not CheckReportTitle()) Then Exit Sub

	Dim nNextStep as Integer
	nNextStep = DlgReport.CurrentStep - 1

	CheckButtons(nNextStep)

	If (1 = nNextStep) Then
		If (-1=lbTables.ListIndex()) Then lbTables.Selected(0)=True
	End If

	If (2 = nNextStep) Then
		ReportChangedDataBaseSelection% = False
	End If

	If ( ( 5 = DlgReport.CurrentStep ) And ( 2 = GetGUIType() ) ) Then
		Call ReportPreview5Repaint()
		Call ReportPreview4Repaint()
	End If

	DlgReport.CurrentStep = nNextStep
	Call ReportSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdReadyClicked ()
	If (Not CheckReportTitle()) Then Exit Sub

	Application.Interactive = False
	Call ReportCreateReportNow()
	Application.Interactive = True
'	DlgReport.UnLoad()
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdNextOrReadyClicked()
	Dim nNextStep as Integer
	nNextStep = DlgReport.CurrentStep + 1

	CheckButtons(nNextStep)

	DIM n%
	If ( nNextStep = 6 ) Then
		cmdReady.SetFocus
	else
		DlgReport.cmdNextOrReady.SetFocus
	End If

	If (nNextStep=3) Then
		If (ReportFirstTimeGroupingShowed%) Then
			Call ReportResetGroupingData()
			ReportChangedDataBaseSelection% = False
			ReportFirstTimeGroupingShowed% = False
		End If
		If (ReportChangedDataBaseSelection%) Then
			Call ReportResetGroupingData()
			ReportChangedDataBaseSelection% = False
		End If

		If( lbGroupingSource.ListCount < 1 ) Then
			cmdGroup.Enabled = False
		End If
		lbGroupingSource.SetFocus
	End If

	If (nNextStep=4) Then
		If (ReportGroupingChanged%=True) Then
			Call ReportInitSortPage()
			ReportGroupingChanged% = False
		End If
	End If
	If (nNextStep=5) Then
		If (ReportLevelFields$(0)="") Then
			OptStyle1.Caption = Report_ilStrTable$
			OptStyle2.Visible = False
			OptStyle3.Caption = Report_ilStrColumns
			OptStyle4.Visible = False
			OptStyle5.Visible = False
			OptStyle6.Visible = False
			If (False = (OptStyle1.Value Or OptStyle3.Value)) Then
				OptStyle1.Value = True
			End If
		Else
			OptStyle1.Caption = Report_ilStrStepped_A
			OptStyle2.Visible = True
			OptStyle3.Caption = Report_ilStrLeft_A
			OptStyle4.Visible = True
			OptStyle5.Visible = True
			OptStyle6.Visible = True
			If (False = (OptStyle1.Value Or OptStyle2.Value Or OptStyle3.Value Or OptStyle4.Value Or OptStyle5.Value Or OptStyle6.Value)) Then
				OptStyle1.Value = True
			End If
		End If
		If ( 2 = GetGUIType() ) Then
			Call ReportPreview5Repaint()
			Call ReportPreview4Repaint()
		End If
	End If

	If (nNextStep=6) Then
		lbParaStyles.SetFocus
	End If

	If (nNextStep=7) Then
	'   optCreateAndView is default
		optCreateAndView.Value = Not optCreateAndStore.Value
		txtReportTitle.SetFocus
	End If

	DlgReport.CurrentStep = nNextStep

	If (nNextStep=2) Then
		ReportGetFields()
		If (lbSelected.ListCount()=0) Then
			cmdMoveAll.SetFocus
		End If
	End If

	Call ReportSetTitle()
End Sub

' -----------------------------------------------------------------------------
Sub ReportReadTemplates()
	Dim actFile$, sActTitle$, sSep$
	Dim ActFileInfo as new DocumentInfo

	sSep$ = GetPathSeparator()

	DlgReport.lbParaStyles.Clear()
	actFile$ = Dir(TemplatePath$ + sSep$ + "wizard" + sSep$ + "rpst*.vor")
	While (actFile$ <> "")
		ActFileInfo.Load(TemplatePath$ + sSep$ + "wizard" + sSep$ + ActFile$)
		sActTitle$ = ActFileInfo.Title
		If ( sActTitle$ <> "" ) Then
			DlgReport.lbParaStyles.AddItem( sActTitle$ )
		End If
		actFile$=Dir
	Wend
	If ( 0 < DlgReport.lbParaStyles.ListCount() ) Then
		DlgReport.lbParaStyles.Selected(0) = True
	End If
End Sub

' -----------------------------------------------------------------------------
Function ReportGetTemplateFilename$()
	Dim FindTitle$, actFile$, sPath$, sSep$
	Dim ActFileInfo as new DocumentInfo

	FindTitle$ = DlgReport.lbParaStyles.List(DlgReport.lbParaStyles.ListIndex())

	sSep$ = GetPathSeparator()

	sPath$ = TemplatePath$ + sSep$ + "wizard" + sSep$

	actFile$ = Dir( sPath$ + "rpst*.vor")
	While ( "" <> actFile$ )
		ActFileInfo.Load ( sPath$ + ActFile$ )
		If (ActFileInfo.Title = FindTitle$) Then
			ReportGetTemplateFilename$ = actFile$
			Exit Function
		End If
		actFile$=Dir
	Wend
	ReportGetTemplateFilename$ = ""
End Function

' -----------------------------------------------------------------------------
Sub ReportParaStyleSelected()
	Call ReportPreview8Repaint()
End Sub

' -----------------------------------------------------------------------------
Sub ReportSetTitle()
	Select Case (DlgReport.CurrentStep)
		Case 1
			DlgReport.Caption = DlgReport_Dlg_1Caption$
		Case 2
			DlgReport.Caption = DlgReport_Dlg_2Caption$
		Case 3
			DlgReport.Caption = DlgReport_Dlg_3Caption$
		Case 4
			DlgReport.Caption = DlgReport_Dlg_4Caption$
		Case 5
			DlgReport.Caption = DlgReport_Dlg_5Caption$
		Case 6
			DlgReport.Caption = DlgReport_Dlg_6Caption$
		Case 7
			DlgReport.Caption = DlgReport_Dlg_7Caption$
	End Select
End Sub

' -----------------------------------------------------------------------------
Sub ReportGetTables()
	Dim nCount%

	DlgReport.lbTables.Clear()
	for nCount% = 1 to ReportInstalledQueries.Count()
		DlgReport.lbTables.AddItem(ReportInstalledQueries.Item(nCount%))
	Next nCount%
	for nCount% = 1 to ReportInstalledTables.Count()
		DlgReport.lbTables.AddItem(ReportInstalledTables.Item(nCount%))
	Next nCount%

	If ( 0 < DlgReport.lbTables.ListCount ) Then
		DlgReport.lbTables.Selected ( 0 ) = True
		DlgReport.cmdNextOrReady.Enabled = True
	Else
		MsgBox(Report_gErrNoTableInDatabase$ , 16, Report_gWizardName$  )
		DlgReport.cmdNextOrReady.Enabled = False
		Report_Return_Result$ = ""
	End If
	ReportChangedDataBaseSelection% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportGetFields()
	If (not bNeedFieldRefresh) Then Exit Sub

	Dim n%, maxFields%
	Dim sActFieldName$
	Dim bIsTable As Boolean

	Application.EnterWait()
On Local Error Goto field_error
	' disable the ui while loading
	DlgReport.cmdNextOrReady.Enabled = False
	DlgReport.cmdCancel.Enabled = False
	DlgReport.cmdPrev.Enabled = False
	DlgReport.cmdReady.Enabled = False
	DlgReport.cmdMoveSelected.Enabled = False
	DlgReport.cmdMoveAll.Enabled = False
	DlgReport.cmdRemoveSelected.Enabled = False
	DlgReport.cmdRemoveAll.Enabled = False

	DlgReport.lbFields.Clear()

	' Which table was selected
	n% = DlgReport.lbTables.ListIndex()
	If ( -1 = n% ) Then Exit Sub
	ReportActiveTableName$ = DlgReport.lbTables.List(DlgReport.lbTables.ListIndex())
	bIsTable = aCurrentDb.getTables().hasByName(ReportActiveTableName$)
	DlgReport.txtReportTitle.Text = SuggestTitleStr$ ( ReportInstalledDBNames, Report_ilStrReportTitlePrefixSuggestion$  + ReportActiveTableName$ )

	ReportOriginalFieldList.Clear()
	DlgReport.lbSelected.Clear()

	if bIsTable Then
		aCurrentTable = aCurrentDb.getTables().getByName(ReportActiveTableName$)
	Else
		aCurrentTable = aCurrentDb.getQueries().getByName(ReportActiveTableName$)
	End If
	aCurrentFields = aCurrentTable.getFields()

	' Fill in the listbox lbFields
	Dim aNameSequence()
	Dim i%
	aNameSequence = aCurrentTable.getFields().getElementNames()
	For i%=lbound(aNameSequence) To ubound(aNameSequence)
		sActFieldName$ = aNameSequence(i%)
		If (Not isVersionColumn(aCurrentFields, sActFieldName$)) Then
			DlgReport.lbFields.AddItem( sActFieldName$ )
			ReportOriginalFieldList.Add( sActFieldName$ )
		End If
	Next i%

	If (DlgReport.lbFields.ListCount()>=1) Then
		DlgReport.cmdMoveSelected.Enabled = True
		DlgReport.cmdMoveAll.Enabled = True
		DlgReport.lbFields.Selected(0) = True
	Else
		DlgReport.cmdMoveSelected.Enabled = False
		DlgReport.cmdMoveAll.Enabled = False
	End If
	ReportChangedDataBaseSelection% = True
	ReportGroupingChanged% = True

	' Later we need special field informations for deciding whether a column can be sorted or filtered.
	' Thus we have to open a cursor on the selected table/query because the information we are interested in
	' is provided only by the record supplied by a statement.
	Dim aStatement, aCursor, aRecord as Object
	If bIsTable Then
		aStatement = aCurrentDb.createStatement("SELECT * FROM " & UNOQuoteTableName(aCurrentTable.Name, aCurrentDb), FALSE)
	Else
		aStatement = aCurrentDb.createStatement(aCurrentTable.Query, aCurrentTable.IsPassThrough)
	End If
	' some properties to speed up execution :
	aStatement.CacheSize = 0		' no caching
	aStatement.MaxFieldSize = 10	' an arbitrary - but small - value
	aStatement.MaxRecords = 1		' the first record will be sufficient
	' now do it (build the cursor forward-only and read-only, that's faster, again)
	aCursor = aStatement.executeQuery(DatabaseCursorType_FORWARD, DatabaseCursorOption_READONLY)
	aCurrentFirstRecord = aCursor.getRecord
	goto outta_here

field_error:
	MsgBox Report_gErrCouldNotOpenObject$, 16, Report_gWizardName

outta_here:
	CheckButtons(DlgReport.CurrentStep)
	bNeedFieldRefresh = False
	Application.LeaveWait()
End Sub

' -----------------------------------------------------------------------------
Sub ReportNoCode()
	'       Empty Routine. Do not delete!
End Sub

' -----------------------------------------------------------------------------
Sub ReportMoveSelected()
	If (0 = SelectionInListBox%(lbFields)) Then
		' double clicked on an empty place ?
		Exit Sub
	End If
	MoveSelectedListBox(lbFields, lbSelected)
	CheckButtons(2)
	ReportChangedDataBaseSelection% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportMoveAll()
	CopyItemsListBox(lbFields, lbSelected)
	CheckButtons(2)
	ReportChangedDataBaseSelection% = True
	cmdNextOrReady.SetFocus
End Sub

' -----------------------------------------------------------------------------
Sub ReportRemoveSelected()
	If (0 = SelectionInListBox%(lbSelected)) Then
		' double clicked on an empty place ?
		Exit Sub
	End If
	MoveOrderedSelectedListbox( lbFields, lbSelected, ReportOriginalFieldList, False )
	CheckButtons(2)
	ReportChangedDataBaseSelection% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportRemoveAll()
	MoveOrderedSelectedListbox( lbFields, lbSelected, ReportOriginalFieldList, True )
	CheckButtons(2)
	ReportChangedDataBaseSelection% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportResetGroupingData()
	Dim n%, sStr$
	DlgReport.lbGroupingSource.Clear()
	DlgReport.cmdUngroup.Enabled = False
	For n%=0 To MaxLevel%
		ReportLevelFields$(n%)=""
	Next
	For n%=0 To DlgReport.lbSelected.ListCount()-1
		sStr$ = DlgReport.lbSelected.List(n%)
		if( 0 <> ReportIsFieldSortable%( sStr$ )) then
			DlgReport.lbGroupingSource.AddItem( sStr$ )
		end if
	Next

	If( DlgReport.lbGroupingSource.ListCount() >= 1 ) Then
		DlgReport.lbGroupingSource.Selected(0)=True
	End If

	DlgReport.cmdGroup.Enabled = ( DlgReport.lbGroupingSource.ListCount() > 1 )
	Call ReportGroupPreview()
End Sub

' -----------------------------------------------------------------------------
Sub ReportGroupPreview()
	Const StdWidth% = 100
	Dim n%,x1%,x2%,y1%,y2%,maxHeight%,TextHeight%,txtLeft%,txtTop%,actHeight%,actString$
	Dim DlgHeight%, DlgWidth%

	DlgHeight% = DlgReport.preGroupingDest.Height * GetDialogZoomFactorY(DlgReport.preGroupingDest.Height)
	DlgWidth% = DlgReport.preGroupingDest.Width * GetDialogZoomFactorX(DlgReport.preGroupingDest.Width)

	DlgReport.preGroupingDest.Cls()
	TextHeight%=DlgReport.preGroupingDest.GetTextHeight("Xp")

	maxHeight% = DlgHeight% - 2*StdWidth% - 2*TextHeight%
	n%=0

    '   show Levels
	While (n%<MaxLevel% And ReportLevelFields$(n%)<>"")
		x1% = StdWidth%*(n%+1)
		y1% = actHeight% + StdWidth%
		x2% = x1%+1500
		y2% = y1% + TextHeight% + StdWidth%
		actHeight% = y2%
		DlgReport.preGroupingDest.DrawBox(x1%,y1%,x2%,y2%)
		DlgReport.preGroupingDest.DrawText(x1%+StdWidth%/2,y1%+StdWidth%/2,ReportLevelFields$(n%))
		n% = n% + 1
	Wend
	actHeight% = actHeight% + StdWidth%
	x1% = StdWidth%*(n%+1)
	y1% = actHeight%
	x2% = DlgWidth% - 2*StdWidth%
	y2% = DlgHeight% - 2*StdWidth%
	'       Box for normal Fields
	txtLeft% = x1% + StdWidth%
	txtTop% = y1% + StdWidth%/2

	n%=0
	While( DlgReport.lbSelected.ListCount() > n% And txtTop%<maxHeight)
		actString$ = DlgReport.lbSelected.List(n%)
		if( 0 = ReportIsFieldGrouped%( actString$ )) then
			DlgReport.preGroupingDest.DrawText(txtLeft%,txtTop%,actString$)
			txtTop% = txtTop% + TextHeight%
		end if
		n% = n% + 1
	Wend
	'       Were all fields chosen?
	If ((DlgReport.lbSelected.ListCount()-1)>n%) Then
		DlgReport.preGroupingDest.DrawText(txtLeft%,txtTop%,"...")
	End If
	DlgReport.preGroupingDest.DrawBox(x1%,y1%,x2%,y2%)
End Sub

' -----------------------------------------------------------------------------
Sub ReportGroupClicked()
	Dim n%,selectedAt%
	Call ReportlbGroupingClicked()
	If (cmdGroup.Enabled=False) Then Exit Sub
	selectedAt% = lbGroupingSource.ListIndex()
	If (selectedAt% = -1) Then
		Exit Sub
	End If

	n% = 0
	While (n%<MaxLevel% And ReportLevelFields$(n%)<>"")
		n% = n% + 1
	Wend
	ReportLevelFields$(n%) = lbGroupingSource.List(selectedAt%)
	lbGroupingSource.RemoveItem(selectedAt%)
	If (lbGroupingSource.ListCount()>0) Then
		If (selectedAt%=lbGroupingSource.ListCount()) Then
			lbGroupingSource.Selected(selectedAt%-1) = True
		Else
			lbGroupingSource.Selected(selectedAt%) = True
		End If
	End If
	Call ReportGroupPreview()
	cmdGroup.Enabled = (lbGroupingSource.ListCount()>1) And (ReportLevelFields$(MaxLevel%-1)="")
	cmdUngroup.Enabled = True
	ReportGroupingChanged% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportUngroupClicked()
	If (ReportLevelFields$(3)<>"") Then
		lbGroupingSource.AddItem(ReportLevelFields$(3))
		ReportLevelFields$(3)=""
	ElseIf (ReportLevelFields$(2)<>"") Then
		lbGroupingSource.AddItem(ReportLevelFields$(2))
		ReportLevelFields$(2)=""
	ElseIf (ReportLevelFields$(1)<>"") Then
		lbGroupingSource.AddItem(ReportLevelFields$(1))
		ReportLevelFields$(1)=""
	ElseIf (ReportLevelFields$(0)<>"") Then
		lbGroupingSource.AddItem(ReportLevelFields$(0))
		ReportLevelFields$(0)=""
		cmdUngroup.Enabled = False
	End If

	Call ReportGroupPreview()

	cmdGroup.Enabled = lbGroupingSource.ListCount > 1
	If (lbGroupingSource.ListCount >= 1 ) Then
		lbGroupingSource.Selected(0)=True
	End If
	ReportGroupingChanged% = True
End Sub

' -----------------------------------------------------------------------------
Sub ReportlbGroupingClicked()
End Sub

' -----------------------------------------------------------------------------
'       Sorting options and pages
Sub ReportCopyListBoxToCombobox(lb As Object, combo As Object)
	Dim n%

	combo.Clear()
	combo.AddItem( Report_ilListboxNoneValue$  )
	For n%=0 To lb.ListCount()-1
		combo.AddItem(lb.List(n%))
	Next
	If (combo.ListCount>0) Then combo.ListIndex = 0
End Sub

' -----------------------------------------------------------------------------
Sub ReportInitSortPage()
	Call ReportCopyListBoxToCombobox(lbGroupingSource, cmbSort1)
	Call ReportCopyListBoxToCombobox(lbGroupingSource, cmbSort2)
	Call ReportCopyListBoxToCombobox(lbGroupingSource, cmbSort3)
	Call ReportCopyListBoxToCombobox(lbGroupingSource, cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview1Repaint()
	Call PaintPicOnPreview(DlgReport.Preview1, ReportPath$+"cjtrep01.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview3Repaint()
	Call PaintPicOnPreview(DlgReport.Preview3, ReportPath$+"cjtrep02.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview4Repaint()
	Dim FileName$

	FileName$=""

	If ( "" = ReportLevelFields$(0) ) Then
		'       no grouping
		If (OptStyle1.Value) Then
			FileName$ = "cjtabula.bmp"
		Else
			FileName$ = "cjtrep04.bmp"
		End If
	Else
	'   grouping available
		If (OptStyle1.Value) Then FileName$ = "cjst1.bmp"
		If (OptStyle2.Value) Then FileName$ = "cjst2.bmp"

		If (OptStyle3.Value) Then FileName$ = "cgleft1.bmp"
		If (OptStyle4.Value) Then FileName$ = "cgleft2.bmp"

	'   5,6 stil 1,2
		If (OptStyle5.Value) Then FileName$ = "cjgl.bmp"
		If (OptStyle6.Value) Then FileName$ = "cjblock.bmp"
		'
		If ( "" = FileName$ ) Then
			'       eintrag 3,4 linksbndig 1,2
			FileName$ = "cjbuend.bmp"
		End If
	End If

	Call PaintPicOnPreview(DlgReport.Preview4, ReportPath$+FileName$, 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview5Repaint()
	Dim Height%, Width%, FileName$
	If (optPortrait.Value=True) Then
		FileName$ = "dbpg1.bmp"
		Height% = 32
		Width% = 26
	Else
		optLandscape.Value = True
		FileName$ = "dbpg2.bmp"
		Height% = 26
		Width% = 32
	End If
	Call PaintPicOnPreview(DlgReport.Preview5, ReportPath$+FileName$, Width%, Height%, False)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview6Repaint()
	Call PaintPicOnPreview(DlgReport.Preview6, ReportPath$+"cjtrep05.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview7Repaint()
	Call PaintPicOnPreview(DlgReport.Preview7, ReportPath$+"end.bmp", 152, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportPreview8Repaint()
	Dim sBitmapFile$

	Select Case ( UCase ( ReportGetTemplateFilename$() ) )
		Case "RPST01.VOR"
			sBitmapFile$ = "cjtrep06.bmp"
		Case "RPST02.VOR"
			sBitmapFile$ = "cjtrep09.bmp"
		Case "RPST03.VOR"
			sBitmapFile$ = "cjtrep08.bmp"
		Case "RPST04.VOR"
			sBitmapFile$ = "cjtrep07.bmp"
		Case Else
			sBitmapFile$ = "cjtrep06.bmp"
	End Select

	Call PaintPicOnPreview(DlgReport.Preview8, ReportPath$+sBitmapFile$, 164, 172, True)
End Sub

' -----------------------------------------------------------------------------
Sub ReportItemAvailable(EventIn As Object, TestTarget As Object)
	Dim EvStr$, EvIndex%, TestStr$, TestIndex%

	TestIndex% = TestTarget.ListIndex()
	EvIndex% = EventIn.ListIndex()

	If (TestIndex%>0 And EvIndex%>0) Then
		TestStr$ = TestTarget.List(TestIndex%)
		EvStr$ = EventIn.List(EvIndex%)
		If (TestStr$=EvStr$) Then
			Beep
			EventIn.ListIndex = 0
		End If
	End If
End Sub

' -----------------------------------------------------------------------------
Sub ReportcmbSortEvent1()
	Call ReportItemAvailable(cmbSort1,cmbSort2)
	Call ReportItemAvailable(cmbSort1,cmbSort3)
	Call ReportItemAvailable(cmbSort1,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub ReportcmbSortEvent2()
	Call ReportItemAvailable(cmbSort2,cmbSort1)
	Call ReportItemAvailable(cmbSort2,cmbSort3)
	Call ReportItemAvailable(cmbSort2,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub ReportcmbSortEvent3()
	Call ReportItemAvailable(cmbSort3,cmbSort1)
	Call ReportItemAvailable(cmbSort3,cmbSort2)
	Call ReportItemAvailable(cmbSort3,cmbSort4)
End Sub

' -----------------------------------------------------------------------------
Sub ReportcmbSortEvent4()
	Call ReportItemAvailable(cmbSort4,cmbSort1)
	Call ReportItemAvailable(cmbSort4,cmbSort2)
	Call ReportItemAvailable(cmbSort4,cmbSort3)
End Sub

' -----------------------------------------------------------------------------
Sub ReportSetSortingCaption(aCommandButton As Object)
	If (aCommandButton.Caption = DlgReport_4_labelSortDown$) Then
		aCommandButton.Caption = DlgReport_4_labelSortUp$
	Else
		aCommandButton.Caption = DlgReport_4_labelSortDown$
	End If
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdSortingOpt1()
	Call ReportSetSortingCaption(cmdSort1)
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdSortingOpt2()
	Call ReportSetSortingCaption(cmdSort2)
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdSortingOpt3()
	Call ReportSetSortingCaption(cmdSort3)
End Sub

' -----------------------------------------------------------------------------
Sub ReportCmdSortingOpt4()
	Call ReportSetSortingCaption(cmdSort4)
End Sub

' -----------------------------------------------------------------------------
Sub ReportTitleReportGetFocus()
	txtReportTitle.Tag = txtReportTitle.Text
End Sub

' -----------------------------------------------------------------------------
Function CheckReportTitle as Boolean
	CheckReportTitle = False

	If ( Len(txtReportTitle.Text) > 32 ) Then
		txtReportTitle.Text = Trim ( Left ( txtReportTitle.Text, 31 ) )
		MsgBox Report_gErrNameToLong$, 64, Report_gWizardName$
		txtReportTitle.SetFocus()
		txtReportTitle.Tag = "ERROR"
		Exit Function
	End If

	If (Not CheckDatabaseIdentifier2(txtReportTitle, Report_gErrInvalidTitle$, Report_gWizardName$)) Then Exit Function
	If (Not CheckTitleUnique(ReportInstalledDBNames, txtReportTitle, Report_gErrSuggestedTitleExist$, Report_gWizardName$)) Then Exit Function

	CheckReportTitle = True
End Function

' -----------------------------------------------------------------------------
Function ReportGetColumnWidth$(ByVal ColName$)
	Dim subtype$
	Dim nFieldType as Integer
	nFieldType = aCurrentFields.getByName(ColName$).Type
	Select Case (nFieldType)
		Case DatabaseFieldType_BOOL			: subType$ = "5"
		Case DatabaseFieldType_TINYINT		: subtype$ = "4"
		Case DatabaseFieldType_SMALLINT		: subtype$ = "6"
		Case DatabaseFieldType_INTEGER		: subtype$ = "11"
		Case DatabaseFieldType_BIGINT		: subtype$ = "16"
		Case DatabaseFieldType_REAL			: subtype$ = "21"
		Case DatabaseFieldType_DOUBLE		: subtype$ = "21"
		Case DatabaseFieldType_NUMERIC		: subtype$ = "21"
		Case DatabaseFieldType_DECIMAL		: subtype$ = "21"
		Case DatabaseFieldType_CURRENCY		: subtype$ = "15"
		Case DatabaseFieldType_CHAR			: subtype$ = "21"
		Case DatabaseFieldType_VARCHAR		: subtype$ = "21"
		Case DatabaseFieldType_LONGVARCHAR	: subtype$ = "100"
		Case DatabaseFieldType_DATE			: subtype$ = "11"
		Case DatabaseFieldType_TIME			: subtype$ = "11"
		Case DatabaseFieldType_DATETIME		: subtype$ = "14"
		Case DatabaseFieldType_DATE			: subtype$ = "11"
		Case DatabaseFieldType_DATE			: subtype$ = "11"
		Case Else :
			subType$ = "25"
	End Select
	ReportGetColumnWidth$ = subType$
End Function

' -----------------------------------------------------------------------------
Function ReportIsFieldSortable%(ByVal ColName$)
On Local Error Goto return_false
	Dim aColumn as Object
	aColumn = aCurrentFirstRecord.getByName(ColName$)
	If (aColumn.SearchInfo And DatabaseSearch_BASIC) <> 0 Then
		ReportIsFieldSortable% = TRUE
		Exit Function
	End If
return_false:
	ReportIsFieldSortable% = FALSE
End Function

' -----------------------------------------------------------------------------
Function ReportIsFieldGrouped%(ByVal ColName$)
	DIM n%
	ReportIsFieldGrouped% = 0
	for n% = 0 to MaxLevel%-1

		if( "" = ReportLevelFields( n% ) ) then Exit for

		if( ColName = ReportLevelFields( n% ) ) then
			ReportIsFieldGrouped% = 1
			Exit for
		end if

	next n%
End Function

' -----------------------------------------------------------------------------
Const cTabular=1,cColumnar=2,cOrganized=3,cJustified=4,cLeft1Justified=5,cLeft2Justified=6,cStyle1=7,cStyle2=8

Function ReportGetStyleType%()
	'       If grouping is used, different meaning of the styles
	If (ReportLevelFields$(0)="") Then
	'   no grouping
		If (OptStyle1.Value=True) Then
			ReportGetStyleType% = cTabular
		Else
			ReportGetStyleType% = cColumnar
		End If
	Else
		If (OptStyle1.Value=True) Then
	    ReportGetStyleType% = cLeft1Justified'  Left justified 1
			Exit Function
		End If
		If (OptStyle2.Value=True) Then
	    ReportGetStyleType% = cLeft2Justified'  Left justified 2
			Exit Function
		End If
		If (OptStyle3.Value=True) Then
	    ReportGetStyleType% = cStyle1 ' Style 1
			Exit Function
		End If
		If (OptStyle4.Value=True) Then
	    ReportGetStyleType% = cStyle2 ' Style 2
			Exit Function
		End If
		If (OptStyle5.Value=True) Then
			ReportGetStyleType% = cOrganized
			Exit Function
		End If
		If (OptStyle6.Value=True) Then
			ReportGetStyleType% = cJustified
			Exit Function
		End If
		'       Default
		ReportGetStyleType% = cStyle1
	End If
End Function

' -----------------------------------------------------------------------------
Dim ReportGroupType%(0 To MaxFieldIndex%)
Dim ReportFieldName$(0 To MaxFieldIndex%)
Dim ReportFieldType%(0 To MaxFieldIndex%)
Dim ReportFieldGroupWidth(0 To MaxFieldIndex%) As Integer
Dim ReportFieldDataWidth(0 To MaxFieldIndex%) As Integer
Dim ReportStructFieldSize%, ReportStructGroupSize%

Sub ReportCreateReportNow()
	Const cLandscape = 1, cPortrait = 2

	Dim subtype$, index%, actPos%, styleType%, ORDER_BY_used%, DocTitle$, nOrientation%
	Dim SQLStatement$, TemplateFilename$, sQueryName$, sActFieldName$, sActGroupName$, sStyleTemplate$, sTmp$

	Application.EnterWait()
	Wait( 0 )

	DlgReport.Hide()

	If ( -1 < StrInStrings%( ReportInstalledQueries, ReportActiveTableName$ ) ) Then
		sQueryName$ = ReportActiveTableName$
	Else
		sQueryName$ = ""
	End If

	ORDER_BY_used% = False
	index% = DlgReport.lbTables.ListIndex()

	'       Initialize the fields
	For index% = 0 To MaxFieldIndex%
		ReportGroupType%( index% ) = 0
		ReportFieldName$( index% ) = ""
		ReportFieldType%( index% ) = 0
		ReportFieldGroupWidth( index% ) = 0
		ReportFieldDataWidth( index% ) = 0
	Next

	'       Types and names for the grouping
	ReportStructGroupSize% = 0
	If ( "" <> ReportLevelFields$ ( 0 ) ) Then ORDER_BY_used% = True
	While ( "" <> ReportLevelFields$(ReportStructGroupSize%) )
		sActGroupName$ = ReportLevelFields$ ( ReportStructGroupSize% )
		ReportFieldGroupWidth ( ReportStructGroupSize% ) = Val ( ReportGetColumnWidth% ( sActGroupName$ ) )
		SQLStatement$ = SQLStatement$ + UNOQuoteTableName(ReportLevelFields$(ReportStructGroupSize%), aCurrentDb) + ", "
		ReportStructGroupSize% = ReportStructGroupSize% + 1
	Wend

	'       The given sorting parameters are processed in the order given.
	'       Therefore they get copied to the start of the field array, then
	'       removed from the source listbox.
	ReportStructFieldSize% = 0
	Dim ArrayObject(1 To 4) As Object
	Dim SortCmdObject(1 To 4) As Object
	Dim Combo As Object
	ArrayObject(1) = cmbSort1
	ArrayObject(2) = cmbSort2
	ArrayObject(3) = cmbSort3
	ArrayObject(4) = cmbSort4
	SortCmdObject(1) = cmdSort1
	SortCmdObject(2) = cmdSort2
	SortCmdObject(3) = cmdSort3
	SortCmdObject(4) = cmdSort4
	For index% = 1 To 4
		Combo = ArrayObject(index%)
		If (Combo.ListIndex()>=1) Then
			ORDER_BY_used% = True
			sActFieldName$ = ArrayObject(index%).List(Combo.ListIndex())
			ReportFieldName$(ReportStructFieldSize%) = sActFieldName$
			ReportFieldDataWidth(ReportStructFieldSize%) = Val(ReportGetColumnWidth$(Combo.List(Combo.ListIndex())))

			actPos% = GetIndexOfItem%(lbGroupingSource, sActFieldName$)
			lbGroupingSource.RemoveItem(actPos%)
			actPos% = GetIndexOfItem%(lbSelected, sActFieldName$)
			lbSelected.RemoveItem(actPos%)

			SQLStatement$ = SQLStatement$ + UNOQuoteTableName(sActFieldName$, aCurrentDb)
			If (SortCmdObject(index%).Caption=DlgReport_4_labelSortDown$) Then
				SQLStatement$ = SQLStatement$ + " desc"
			End If
			SQLStatement$ = SQLStatement$ + ", "
			ReportStructFieldSize% = ReportStructFieldSize% + 1
		End If
	Next

	If ( "" <> sQueryName$ ) Then
		If ( Not ORDER_BY_used% ) Then
			SQLStatement$ = ""
		End If
	Else
		If ORDER_BY_used% Then
			SQLStatement$ = "Select * from " + UNOQuoteTableName(ReportActiveTableName$, aCurrentDb) + " order by " + SQLStatement$
		Else
			SQLStatement$ = "Select * from " + UNOQuoteTableName(ReportActiveTableName$, aCurrentDb)
		End If
	End If

	If ( ", " = Right(SQLStatement,2) ) Then
		SQLStatement = Left(SQLStatement,Len(SQLStatement)-2)
	End If

	Call FixODBCBug()
	If ( "" <> sQueryName$ ) Then
		ReportActiveTableName$ = ""
	Else
		ReportActiveTableName$ = DlgReport.lbTables.List(DlgReport.lbTables.ListIndex())
	End If

	'       Bring the remaining unsorted fields over into the
	'       FieldArray.

	if( lbSelected.ListCount() <> lbGroupingSource.ListCount() ) then

		For index% = 0 To lbSelected.ListCount() - 1
			sActFieldName$ = lbSelected.List ( index% )
			if( 0 = ReportIsFieldGrouped%( sActFieldName$ )) then
				ReportFieldName$(ReportStructFieldSize%) = sActFieldName$
				ReportFieldDataWidth(ReportStructFieldSize%) = Val(ReportGetColumnWidth$( sActFieldName$ ))
				ReportStructFieldSize% = ReportStructFieldSize% + 1
			end if
		Next

	else

		For index% = 0 To lbGroupingSource.ListCount() - 1
			sActFieldName$ = lbGroupingSource.List ( index% )
			ReportFieldName$(ReportStructFieldSize%) = sActFieldName$
			ReportFieldDataWidth(ReportStructFieldSize%) = Val(ReportGetColumnWidth$( sActFieldName$ ))
			ReportStructFieldSize% = ReportStructFieldSize% + 1
		Next
	end if

	If (optLandscape.Value = True) Then
		nOrientation% = cLandscape
	Else
		nOrientation% = cPortrait
	End If

    ' Templatename ReportGetTemplateFilename$()
	styleType% = ReportGetStyleType%()
	DocTitle$ = DlgReport.txtReportTitle.Text

	If (DlgReport.optCreateAndView.Value) Then
		sTmp$ = ";1"
	Else
		sTmp$ = ";0"
	End If

	If ( "" <> sQueryName$ ) Then ReportActiveTableName$ = ""

	sStyleTemplate$ = ReportGetTemplateFilename$()

	While( Application.IsWait() )
		Application.LeaveWait()
	Wend

	' the methods in the CreateReportView module aren't UNO-base, so we need to give them their expected
	' context : an database opened via the application
	Application.OpenDatabaseConnection(ReportActiveDatabaseName$)
	If aCurrentDb.getTables().hasByName(aCurrentTable.Name) Then
		Application.OpenTableConnection(aCurrentTable.Name)
	Else
		Application.OpenQueryConnection(aCurrentTable.Name)
	End If

	DlgReport.Unload
	Report_Return_Result$ = DocTitle$ + ";" + _
		ReportView_Create( ReportStructGroupSize%, ReportLevelFields$(), ReportFieldGroupWidth(), _
			ReportStructFieldSize%, ReportFieldName$(), ReportFieldDataWidth(), ReportActiveDatabaseName$, _
			ReportActiveTableName$, SQLStatement, sStyleTemplate$, styleType%, DocTitle$, nOrientation%,_
			sQueryName$) + sTmp$

	PutReportIntoDB()
End Sub

Sub PutReportIntoDB()
	Dim sReturnValue$, sTitle$, sFileURL$, nLen%
	sReturnValue$ = Report_Return_Result$

	Application.EnterWait()
	Wait( 0 )

	If (Report_Return_Result$<>"") Then
		nLen% = InStr(1, sReturnValue$, ";") - 1
		sTitle$ = Left(sReturnValue$, nLen%)
		sReturnValue$ = Mid(sReturnValue$, nLen% + 2)

		nLen% = InStr(1, sReturnValue$, ";") - 1
		sFileURL$ = Left(sReturnValue$, nLen%)
		sReturnValue$ = Mid(sReturnValue$, nLen% + 2)

		' a non-UNO part : We could create a report via UNO, but to fill it with the temporary
		' file created recently we need an input stream. Unfortunately there is no UNO service such
    ' as 'com.sun.star.io.FileInputStream'.
		' So we have to use old-style (application-based) database access again.
		Application.OpenDatabaseConnection(ReportActiveDatabaseName$)
		If ( Application.CreateReport(sTitle$, sFileURL$) ) Then
			If (Right(sReturnValue$, 1) = "1") Then
				Application.OpenReport(sTitle$, 1)
			Else
				CloseDbConnection()
			End If
		Else
			MsgBox ( Report_gErrCannottInstallReport , 16, Report_gWizardName$  )
			While ( Application.IsWait() )
				Application.LeaveWait()
			Wend
			Exit Sub
		End If
	End If
	While ( Application.IsWait() )
		Application.LeaveWait()
	Wend
end Sub
