'SBLLINK:MethodInfo=LoadLanguage0
Option Explicit


' L a n g u a g e   c o n s t a n t s
' -----------------------------------
Public Const cLANGUAGE_SYSTEM = "", cLANGUAGE_CHINESE = "zh", cLANGUAGE_DANISH = "da"
Public Const cLANGUAGE_DUTCH = "nl", cLANGUAGE_ENGLISH = "en", cLANGUAGE_FINNISH = "fi"
Public Const cLANGUAGE_FRENCH = "fr", cLANGUAGE_GERMAN = "de", cLANGUAGE_GREEK = "el"
Public Const cLANGUAGE_ITALIAN = "it", cLANGUAGE_JAPANESE = "ja", cLANGUAGE_NORWEGIAN = "no"
Public Const cLANGUAGE_POLISH = "pl", cLANGUAGE_PORTUGUESE = "pt", cLANGUAGE_RUSSIAN = "ru"
Public Const cLANGUAGE_SPANISH = "es", cLANGUAGE_SWEDISH = "sv", cLANGUAGE_TURKISH = "tr"

Public BLNameList(1 To 16) as String


' R e s o u r c e   s t r i n g   c o n s t a n t s
' -------------------------------------------------
' Dialog labels start at 1000
Const dlgCalTitle = 1000
Const dlgCalTitleBack = 1001
Const dlgCalTitleOwnData = 1002
Const dlgSchdlTitle = 1003
Const dlgOK = 1004
Const dlgCancel = 1005
Const dlgCalFrameOption = 1006
Const dlgCalOptionYear = 1007
Const dlgCalOptionMonth = 1008
Const dlgSchdlDescription = 1009
Const dlgSchdlCountry = 1010
Const dlgTime = 1011
Const dlgYear = 1012
Const dlgCalMonth = 1013
Const dlgSpecificBankholidays = 1014
Const dlgCalOwnData = 1015
Const dlgCalInsert = 1016
Const dlgCalDelete = 1017
Const dlgCalNewEvent = 1018
Const dlgCalEvent = 1019
Const dlgCalEventOnce = 1020
Const dlgCalEventDay = 1021
Const dlgCalEventMonth = 1022
Const dlgCalEventYear = 1023
' Bitmap file is 1099
Const dlgBitmapFile = 1099
' Names of states start at 1100
Const dlgState = 1100
' Months start at 1200
Const dlgMonth = 1200
' Abreviated months start 1225
Const dlgShortMonth = 1225
' Messages start at 1300
Const msgCalErrorTitle = 1300
Const msgCalError = 1301
Const msgCalRemoveTitle = 1302
Const msgCalRemove = 1303
' Styles start at 1400
Const stlWorkday = 1400
Const stlWeekend = 1401
' Sheet names start at 1410
Const nameCalYear = 1410
Const nameCalMonth = 1411
' Misc. schedule data starts at 1500
Const sProgess = 1500



Sub LoadLanguage%(ByVal LangLocale)
Dim Dummy$, i, Count%

	If InitResources("Calendar-template", "cal") Then

		' C o u n t r y   s p p e c i f i c   s e t t i n g s
		' ---------------------------------------------------
		If LangLocale  = cLANGUAGE_GERMAN Then
			DlgBuffer.lblSpecBankholidays.Visible = True
			DlgBuffer.cmbState.Visible = True

			' Load all states
			BLNameList(1) = "Bayern"
			BLNameList(2) = "Baden-Wrttemberg"
			BLNameList(3) = "Berlin"
			BLNameList(4) = "Bremen"
			BLNameList(5) = "Brandenburg"
			BLNameList(6) = "Hamburg"
			BLNameList(7) = "Hessen"
			BLNameList(8) = "Mecklenburg-Vorpommern"
			BLNameList(9) = "Niedersachsen"
			BLNameList(10) = "Nordrhein-Westfalen"
			BLNameList(11) = "Rheinland-Pfalz"
			BLNameList(12) = "Saarland"
			BLNameList(13) = "Sachsen"
			BLNameList(14) = "Sachsen-Anhalt"
			BLNameList(15) = "Schleswig Holstein"
			BLNameList(16) = "Thringen"
			Dim FirstItem as String

			FirstItem = GetResText(dlgState)
			DlgBuffer.cmbState.AddItem(FirstItem)
			For i = 1 To Ubound(BLNameList())
				DlgBuffer.cmbState.AddItem(BLNameList(i))
			Next i 
		Else 
			DlgBuffer.lblSpecBankholidays.Visible = False
			DlgBuffer.cmbState.Visible = False
		End If

		' L o a d   r e s o u r c e   s t r i n g s
		' -----------------------------------------
		' Load dialog captions
		sWizardTitle$ = GetResText(msgCalErrorTitle)
		sError$ = GetResText(msgCalError)
		cCalSubCmdDeleteSelect_DeleteSelEntryTitle$ = GetResText(msgCalRemoveTitle)
		cCalSubCmdDeleteSelect_DeleteSelEntry$ = GetResText(msgCalRemove)
		cCalSubcmdSwitchOwnDataOrGeneral_OwnData$ = GetResText(dlgCalTitleOwnData)
		cCalSubcmdSwitchOwnDataOrGeneral_Back$ = GetResText(dlgCalTitleBack)
		DlgBuffer.frmTime.Caption = GetResText(dlgTime)
		DlgBuffer.lblYear.Caption = GetResText(dlgYear)
		DlgBuffer.DlgCmdCancel.Caption = GetResText(dlgCancel)
		DlgBuffer.DlgCmdOk.Caption = GetResText(dlgOK)
		DlgBuffer.lblSpecBankholidays.Caption = GetResText(dlgSpecificBankholidays)

		' Load bitmap file
		sBitmapFilename$ = GetResText(dlgBitmapFile)

		' Load calendar specific strings
		DlgBuffer.Caption = GetResText(dlgCalTitle)
		DlgBuffer.frmCalender.Caption = GetResText(dlgCalFrameOption)
		DlgBuffer.optYear.Caption = GetResText(dlgCalOptionYear)
		DlgBuffer.optMonth.Caption = GetResText(dlgCalOptionMonth)
		DlgBuffer.lblMonth.Caption = GetResText(dlgCalMonth)
		DlgBuffer.DlgCmdOwnData.Caption = GetResText(dlgCalOwnData)
		DlgBuffer.frmNewEvent.Caption = GetResText(dlgCalNewEvent)
		DlgBuffer.lblEvent.Caption = GetResText(dlgCalEvent)
		DlgBuffer.lblEventDay.Caption = GetResText(dlgCalEventDay)
		DlgBuffer.lblEventMonth.Caption = GetResText(dlgCalEventMonth)
		DlgBuffer.lblEventYear.Caption = GetResText(dlgCalEventYear)
		DlgBuffer.chkEventOnce.Caption = GetResText(dlgCalEventOnce)
		DlgBuffer.cmdInsert.Caption = GetResText(dlgCalInsert)
		DlgBuffer.cmdDelete.Caption = GetResText(dlgCalDelete)
		' Load long month names
		For Count% = 0 To 11
			cCalLongMonthNames$(Count%+1) = GetResText(dlgMonth+Count%)
			cCalShortMonthNames$(Count%+1)= Left$(cCalLongMonthNames$(Count%+1), 3)
		Next
		' Load sheet names
		sCalendarTitle$ = GetResText(nameCalYear)
		sMonthTitle$ = GetResText(nameCalMonth)
		' Load names of styles
		cCalStyleWorkday$ = GetResText(stlWorkday)
		cCalStyleWeekend$ = GetResText(stlWeekend)
	End If
End Sub
