'SBLLINK:MethodInfo=StartNewSpelling0
'SBLLINK:MethodInfo=RunNewSpelling0
'SBLLINK:MethodInfo=ReplaceRegularExpression0
'SBLLINK:MethodInfo=DeleteRegularChars0
'SBLLINK:MethodInfo=CheckCaseSensitivity0
'SBLLINK:MethodInfo=CheckDetailList0
'SBLLINK:MethodInfo=CheckDetailTable0
'SBLLINK:MethodInfo=CorrectString0
'SBLLINK:MethodInfo=MakeReplacement0
'SBLLINK:MethodInfo=SwapFirstChar0
'SBLLINK:MethodInfo=WriteDetailsToList0
'SBLLINK:MethodInfo=ChangeFirstCase0
'SBLLINK:MethodInfo=AddFoundingtoTrashList0
'SBLLINK:MethodInfo=RetrieveSentenceString0
'SBLLINK:MethodInfo=SwapButtonCaption0
'SBLLINK:MethodInfo=SwapBigCapatStart0
'SBLLINK:MethodInfo=EvaluateFounding0
'SBLLINK:MethodInfo=SetCursoroverHyphenWord0
'SBLLINK:MethodInfo=SetCarefulFlag0
'SBLLINK:MethodInfo=FindFirstNonNumberChar0
Option Explicit
REM  *****  BASIC  *****

Const SBSIMPLE = 0
Const SBNEXTWORD = 1
Const SBINSERTBLANK = 2
Const SBANGLO = 3
Const SBTWOTOONE = 4
Const SBNUMBERS = 5
Const SBSWAPCAPS = 6

Const SBMAKEBIG = 1
Const SBMAKESMALL = -1


Sub StartNewSpelling()
Dim i as Integer
Dim PathSeparator as String
	bDevelop = True
	NewStart = True
	FirstRun = True

	'Achtung: Documente sind im Array 'sfileArray' nicht nullbasierend
	DocuIndex = 1

	Application.LoadLibrary("Tools")
'	Application.LoadLibrary("Translater")

	oDesktop = createUnoService("com.sun.star.frame.Desktop")
	PathSeparator = GetPathSeparator()

	DBPath = SubstPathVars("$(inst)") & PathSeparator & "share" & PathSeparator & "database" & PathSeparator & _
							"german" & PathSeparator & "SBSpell.rb1"
	BitMapPath = GetTemplateDir & substpathvars("$(vlang)") & GetPathSeparator() & "wizard" & GetPathSeparator() & "bitmap" & GetPathSeparator()

	' Verbindung zur Zuordnungstabelle mit den TranstoolNamen
' 	oSpellConnection = ConnecttoDatabase("DAO", "D:\Arbeitsverzeichnis\Autopiloten\Rechtschreibung\Spelling.mdb","","")
 	oSpellConnection = ConnecttoDatabase("StarBase", DBPath,"","")

	SpellTables(0,0) = "Simple"
	SpellTables(0,1) = "SimpleDetail"
	SpellTables(1,0) = "NextWord"
	SpellTables(1,1) = "NextWordDetail"
	SpellTables(2,0) = "InsertBlank"
	SpellTables(3,0) = "Anglo"
	SpellTables(4,0) = "TwoToOne"
	SpellTables(4,1) = "TwoToOneDetail"
	SpellTables(5,0) = "Numbers"
	SpellTables(6,0) = "SwapCaps"
	SpellTables(6,1) = "NextWordDetail"
	SentList(0) = "."
	SentList(1) = "!"
	SentList(2) = "?"
	SentList(3) = ":"

	GoOn = SelectSpellTable("Prefix",False)
	i = 0
	Do
		i = i + 1
		Prefix(i) =oSpellRecord.Prefix
		oSpellCursor.MoveRelative(1)
	Loop Until Not oSpellCursor.IsValid

	Prefix(0) = Cstr(i)
	Filterlist(0) = "application/vnd.stardivision.writer"
	Filterlist(1) = "application/vnd.stardivision.calc"
	Filterlist(2) = "application/vnd.stardivision.writer-global"
	Filterlist(3) = "text/html"
	If bDevelop Then
		WizardPath = GetTemplateDir & substpathvars("$(vlang)") & GetPathSeparator() & "internal" & GetPathSeparator()& "LogSpell.vor"
		oLogDocument = OpenDocument(WizardPath,NoArgs(),oDesktop)
		oLogTable = oLogDocument.TextTables.GetbyName("Tabelle1")
	End If
	SubstDir =  SubstpathVars("$(workdirurl)")
	Source =  SubstpathVars("$(workdirurl)")
'	Source = "e:\extras\source\samples\texts\lang\german\" 'file:///d|/Office52/share/samples/german/texts/StarOffice5.sdw"
	DialogConvert.TBSource.Text = Source
	DialogConvert.Load
	DialogConvert.CurrentStep = 1
	DialogConvert.OptionButton1.Value = True
	DialogConvert.OBDir.Value = True
	DialogConvert.CBBack.Enabled = False
	DialogConvert.Show
End Sub



Function RunNewSpelling(sBase as Integer, sDocURL as String, TargetFile as String, ByVal LoadTable as Boolean)
Dim i, p as integer
Dim FoundStart as Integer
	GoOn = True
	If sDocURL <> "" Then
		oDocument = OpenDocument(sDocURL, NoArgs(), oDesktop)
		ImplementationName = oDocument.GetImplementationName
		If DialogConvert.CheckBox1.Value Then
			If ImplementationName <> "ScModelObj" Then
				oDocument.RecordChanges = True
				oDocument.ShowChanges = False
			End If
		End If
	End If

	If FirstRun Then
		If ImplementationName = "ScModelObj" Then
			oSearchBase = oDocument.Sheets.GetbyIndex(0)
		Else
			oSearchBase = oDocument
		End If

		GlobTargetFile = TargetFile
		DocuIndex = DocuIndex + 1
		If bDevelop Then
			InsertConvertLogFileHeader(oLogDocument, oLogTable, Targetfile)
		End If
		FirstRun = False
	End If
	oStatusline = oDocument.GetCurrentController.GetFrame.GetStatusIndicator

	oSearchDesc = oSearchBase.CreateSearchDescriptor()

	For s = SBASE To 6

		oSpellInsert = False
		If LoadTable Then
			GoOn = SelectSpellTable(SpellTables(s,0), True)
			If GoOn = False Then
				RunNewSpelling = GoOn
				Exit Function
			End If
		End If

		Do
			' Die Zahlen brauchen nicht mit einer Datenbanktabelle abgehandelt werden
			sOldWord = oSpellRecord.WordOld
			MasterKey = oSpellRecord.Key
			' Defaultmig wird nicht nach ganzen Wrtern gesucht
			oSearchDesc.SearchWords = False
			oSearchDesc.Searchstring = sOldWord
			' Defaulteinstellung
      OnlyBigCapsatStart = False

			Select Case s

				Case SBSIMPLE
					WholeWordOnly = ConvertToBoolean(oSpellRecord.WholeWordOnly)
					oSearchDesc.SearchWords = WholeWordOnly
					RegularExpression = ConvertToBoolean(oSpellRecord.RegularExpression)
					oSearchDesc.SearchRegularExpression = RegularExpression
					sNewWord = oSpellRecord.WordNew
					CheckDetails = ConvertToBoolean(oSpellRecord.CheckDetails)
					CheckFirstCap = ConvertToBoolean(oSpellRecord.CheckFirstCap)
					CheckIfDifferent = ConvertToBoolean(oSpellRecord.CheckIfDifferent)
					oSearchDesc.SearchCaseSensitive = False

				Case SBNEXTWORD
					WholeWordOnly = ConvertToBoolean(oSpellRecord.WholeWordonly)
					oSearchDesc.SearchWords = WholeWordOnly
					RegularExpression = False
					sNewWord = oSpellRecord.WordNew
					CheckFirstCap = ConvertToBoolean(oSpellRecord.CheckFirstCap)
					CheckDetails = ConvertToBoolean(oSpellRecord.CheckDetails)
					CheckIfDifferent = False
					oSearchDesc.SearchCaseSensitive = False

				Case SBINSERTBLANK
					WholeWordOnly = False
					oSearchDesc.SearchWords = False
					oSearchDesc.SearchRegularExpression = True
					RegularExpression = True
					CheckDetails = False
					CheckIfDifferent = False
					oSearchDesc.SearchCaseSensitive = False

				Case SBANGLO
					WholeWordOnly = True
					oSearchDesc.SearchWords = True
					RegularExpression = False
					oSearchDesc.SearchRegularExpression = False
					sNewWord = oSpellRecord.WordNew
					CheckDetails = False
					CheckIfDifferent = False
					oSearchDesc.SearchCaseSensitive = True
					
				Case SBTWOTOONE
					' aus zwei mach eins
					WholeWordOnly = ConvertToBoolean(oSpellRecord.WholeWordOnly)
					sNewWord = oSpellRecord.WordNew
					CheckDetails = ConvertToBoolean(oSpellRecord.CheckDetails)
					CheckFirstCap = ConvertToBoolean(oSpellRecord.CheckFirstCap)
					CheckIfDifferent = False
					oSearchDesc.SearchWords = WholeWordOnly
					RegularExpression = ConvertToBoolean(oSpellRecord.RegularExpression)
					oSearchDesc.SearchRegularExpression = ConvertToBoolean(RegularExpression)
					oSearchDesc.SearchCaseSensitive = False

				Case SBNUMBERS
				 	WholeWordonly = False
				 	RegularExpression = True
				 	oSearchDesc.SearchRegularExpression = RegularExpression
					oSearchDesc.SearchCaseSensitive = False
				 	CheckDetails = False
				 	CheckFirstCap = True
					CheckIfDifferent = False
					sNewWord = oSpellRecord.WordNew
					oSpellInsert = ConvertToBoolean(oSpellRecord.Insert)
					
				Case SBSWAPCAPS
				 	WholeWordonly = ConvertToBoolean(oSpellRecord.WholeWordOnly)
				 	oSearchDesc.SearchWords = WholeWordOnly
				 	RegularExpression = ConvertToBoolean(oSpellRecord.RegularExpression)
				 	oSearchDesc.SearchRegularExpression = RegularExpression
					oSearchDesc.SearchCaseSensitive = ConvertToBoolean(oSpellRecord.CaseSensitive)
				 	CheckFirstCap = ConvertToBoolean(oSpellRecord.CheckFirstCap)
					sNewWord = oSpellRecord.WordNew
					CheckDetails = ConvertToBoolean(oSpellRecord.CheckDetails)
				 	OnlyBigCapsatStart = ConvertToBoolean(oSpellRecord.OnlyBigCapsatStart)
					CheckIfDifferent = ConvertToBoolean(oSpellRecord.CheckIfDifferent)
			End Select
			
			SetCarefulFlag()
			oFoundall = oSearchBase.FindAll(oSearchDesc)
			oStatusline.SetText("Suchbegriff : '" & sOldWord & "'")
			FoundCount = oFoundAll.Count
			If (FoundCount > 2) AND (CheckDetails) Then
				WriteDetailsToList(SpellTables(s,1), Masterkey) 
				CheckList = True
			Else 
				CheckList = False
			End If
			MaxTrashIndex = 0
			IsTrash = False

			For Foundindex = 0 to FoundCount-1
				EvaluateFounding(oFoundAll(FoundIndex))
				If GoOn = False Then
					GlobDocument = oDocument
					FoundIndex = FoundIndex + 1
					exit For
				End If
			Next FoundIndex 
			
			If GoOn = False Then 
				Exit Do
			End If
			
			On Local Error Resume Next
			oSpellCursor.MoveRelative(1)
			If Err <> 0 Then
				Msgbox " Konnte Cursor nicht bewegen"
			End If
		Loop until Not oSpellCursor.IsValid

		If NOT GoOn Then
			Exit For
		End If
		LoadTable = True
	Next s		

	If GoOn Then
		If (DialogConvert.CheckBox1.Value) And (ImplementationName <> "ScModelObj") Then
			oDocument.ShowChanges = True
		End If
		oDocument.StoreToUrl(GlobTargetFile,NoArgs()) 
		oDocument.Dispose()
		FirstRun = True
	End If
	RunNewSpelling = GoOn
End Function



Sub ReplaceRegularExpression(FoundString, sNewWord, sOldWord, SwapChar as String)									
Dim FoundStart as Integer
Dim sLocOldWord as String

	FoundStart = Instr(1,FoundString,sNewWord)
	If FoundStart <> 0 Then
		' Das neue Wort ist im gefundenen String enthalten
		Mid(FoundString,1 , Len(sNewWord) ,sNewWord) 
		NewString = FoundString
	Else
		sLocOldWord = DeleteRegularChars(sOldWord, SwapChar)
		sNewWord = SwapFirstChar(sNewWord, SwapChar)	
		NewString = Replacestring(sWholeWord,sNewWord,sLocOldWord)
	End If
	
End Sub								



Function DeleteRegularChars(ByVal sLocOldWord as String, SwapChar as String)
Dim ExceptString as String
Dim Pos as Integer

	' Teilstring steht am Wortende
	sLocOldWord = DeleteStr(sLocOldWord,"\<")

	' Teilstring steht am Wortende
	sLocOldWord = DeleteStr(sLocOldWord,"\>")

	' Teilstring steht am Wortende
	sLocOldWord = DeleteStr(sLocOldWord,"+")
		
	If Not oSpellInsert Then
		' Note: Das Zeichen [^...]ist nur, um die Suchergebnisse einzugrenzen, Der String darin mu also
		' eliminiert werden
		Do 
			Pos = Instr(1,sLocOldWord,"[")
			If  Pos <> 0 Then
				ExceptString = FindPartString(sLocOldWord,"[","]",1)
				sLocOldWord = DeleteStr(sLocOldWord,"[" & ExceptString & "]")
			End If
		Loop Until Pos < 1	
	End If
'	Do
'		Pos = Instr(1,sLocOldWord,"?")
'		If Pos > 1 Then
'			Mid(sLocOldWord,Pos + 1, 1,"")
'		End If
'	Loop Until Pos = < 2

	DeleteRegularChars = sLocOldWord
End Function



Function CheckCaseSensitivity(CheckFirstCap as Boolean, FoundString as String) as Integer					
Dim FirstChar as String
Dim AscFirstChar as Integer
Dim IsSentChar as Integer

	If CheckFirstCap Then
		FirstChar = Left(FoundString,1)
		AscFirstChar = Asc(FirstChar)
		' ToDo: Umlaute!!!
		If (AscFirstChar > 64) And (AscFirstChar < 91) OR (AscFirstChar = 196) OR (AscFirstChar = 214) OR (AscFirstChar = 220) Then
			' Erste Buchstabe ist grogeschrieben
			CheckCaseSensitivity = SBMAKEBIG
		Else
			CheckCaseSensitivity = SBMAKESMALL
		End If
	End If
End Function				



Sub CheckDetailList(FoundString, SwapChar, sNewWord, sOldWord as String)
Dim i, LastRec as Integer
Dim sDetOldWord as String
Dim LeaveFor as Boolean

	LeaveFor = False
	LastRec = DetList(0)
	If Not CheckIfDifferent Then
		' Es wird auf Gleichheit geprft
		For	i = 1 To LastRec 	
			sDetOldWord = DetList(i)
			leavefor =	CorrectString(FoundString,DetList(i), SwapChar, sNewWord, sOldWord)
			If LeaveFor = True Then
				Exit For
			End If
		Next
	Else
		'Es wird auf Ungleichheit geprft
		For i = 1 To LastRec
			sDetOldWord = DetList(i)
			If Instr(1,sWholeWord,sDetOldWord) <> 0 Then
				LeaveFor = True
				exit For
			End If
		Next			
		If Not LeaveFor Then
			MakeReplacement(SwapChar, sNewWord, sOldWord)
		End If
	End If
		
End Sub



Sub CheckDetailTable(FoundString, SwapChar, sNewWord, sOldWord as String, Masterkey as Integer)	
Dim sDetOldWord as String	

Dim LeaveDo as Boolean

	SelectDetailTable(SpellTables(s,1),"DetKey",Masterkey)
	If Not CheckIfDifferent Then
		' Prfen auf Gleichheit und ggfs konvertieren
		Do 
			sDetOldWord = oDetailRecord.WordOld
			LeaveDo = CorrectString(FoundString, sDetOldWord, SwapChar, sNewWord, sOldWord)
			If LeaveDo = True Then
				Exit Do
			End If
			On Local Error Resume Next
			oDetailCursor.MoveRelative(1)
		Loop Until Not oDetailCursor.IsValid 

	Else
		LeaveDo = False
		Do
			sDetOldWord = oDetailRecord.WordOld
			If Instr(1,sWholeWord,sDetOldWord) <> 0 Then
				LeaveDo = True
				exit Do
			End If
			oDetailCursor.MoveRelative(1)
		Loop Until Not oDetailCursor.IsValid
		If Not LeaveDo Then
			MakeReplacement(SwapChar, sNewWord, sOldWord)
		End If
	End If
End Sub



Function CorrectString(FoundString, sDetOldWord, SwapChar, sNewWord, sOldWord as String) 	
Dim Corrected as Boolean	
Dim FoundStart as Integer

	Corrected = False
	Select Case s
		Case SBSIMPLE
			If Instr(1,sWholeWord,sDetOldWord) <> 0 Then
				If RegularExpression Then
					ReplaceRegularExpression(FoundString, sNewWord,sOldWord, SwapChar, CheckFirstCap)
				Else
					MakeReplacement(SwapChar, sNewWord, sOldWord)
					Corrected = True
				End If
			End If

		Case SBNEXTWORD
			If sWholeWord = sDetOldWord Then
				oTextCursor.CollapsetoStart()
				ChangeFirstCase(sWholeWord, True)
				Corrected = True
			End If

		Case SBTWOTOONE
			If Instr(1,sWholeWord,sDetOldWord) <> 0 Then
				If Right(sWholeWord,1) = " " Then
					sNewWord = oDetailRecord.WordNew & " "
				ElseIf Left(sWholeWord,1) = " " Then
					sNewWord = " " & oDetailRecord.WordNew
				Else
					sNewWord = oDetailRecord.WordNew
				End If
				NewString = sNewWord
				Corrected = True
			End If

		Case SBSWAPCAPS
			If ConvertToBoolean(oSpellRecord.CheckBefore) Then
				If sDetOldWord = sPrevWord Then
					ChangeFirstCase(FoundString, True)
					Corrected = True
				End If				
			ElseIf ConverttoBoolean(oSpellrecord.CheckAfter) Then
				'Swap Char
				If UCase(Left(sNextWord,1)) <> Left(sNextWord,1) Then
					If (sWholeWord = sDetOldWord) Then
'						oTextCursor.GoToNextWord(False)
'						oTextCursor.GotoEndofWord(True)
'						sWholeWord = sNextWord
						ChangeFirstCase(sWholeWord, True)
						Corrected = True
					End If
				End If
			End If
	End Select			
	CorrectString = Corrected
End Function



Sub MakeReplacement(SwapChar, sNewWord, sOldWord as String)
	If OnlyBigCapsatStart Then
		SwapBigCapatStart()
	Else
		sNewWord = SwapFirstChar(sNewWord, SwapChar)
		NewString = Replacestring(sWholeWord,sNewWord,sOldWord)
	End If
End Sub



Function SwapFirstChar(ByVal CheckString as String, SwapChar as Integer)	
	If CheckFirstCap Then
		Select Case SwapChar
			Case SBMAKEBIG
				Mid(CheckString,1,1,UCASE(Left(CheckString,1)))
			Case SBMAKESMALL
				Mid(CheckString,1,1,LCASE(Left(CheckString,1)))
		End Select															
	End If		
	SwapFirstChar = CheckString					
End Function



Function WriteDetailsToList(DetailTable as String, Masterkey as integer) 
Dim i as Integer
Dim sDetOldWord as String
	SelectDetailTable(DetailTable,"Detkey",Masterkey)
	i = 1
	Do 
		sDetOldWord = oDetailRecord.WordOld
		DetList(i) = sDetOldWord
		oDetailCursor.MoveRelative(1)
		i = i + 1
	Loop Until Not oDetailCursor.IsValid
	DetList(0) = cstr(i-1)
	WriteDetailsToList = DetList()
End Function



Sub ChangeFirstCase(sReplWord as String,Big as Boolean)
Dim FirstChar as String
	oTextCursor.GoRight(1,True)
	FirstChar = Left(sReplWord,1)
	If Big = True Then
		NewString = ReplaceString(sReplWord,UCase(FirstChar), FirstChar)
	Else
		NewString = ReplaceString(sReplWord,LCase(FirstChar),FirstChar)
	End If
End Sub



Function AddFoundingtoTrashList()
Dim IsThere as Boolean
	'In den Tabellen 'InsertBlank' und 'SwapCaps' ist mit kontextsensitiven Zusammenhngen zu rechnen
	If (s <> SBSWAPCAPS) AND (s <> SBINSERTBLANK) Then
		IsThere = FieldInArray(TrashList(),MaxTrashIndex,sWholeWord)
		If Not IsThere Then
			MaxTrashIndex = MaxTrashindex + 1
			Trashlist(0) = MaxTrashIndex
			Trashlist(MaxTrashIndex) = sWholeWord
			AddFoundingtoTrashList = False
		Else
			AddFoundingtoTrashList = True
		End If
	Else
		AddFoundingtoTrashList = True
	End If
		
End Function



Sub RetrieveSentenceString(oFound)
Dim oParaCursor as Object
Dim i as Integer
Dim blabla as String
	oParaCursor = oFound.Text.CreateTextCursorbyRange(oFound)
	oParaCursor.GotoStartofWord(False)
	For i = 0 To 10
		blabla = oParaCursor.String
		oParaCursor.GotoPreviousWord(False)
	Next i
	For i = 0 To 20
		oParaCursor.GotoNextWord(True)
	Next i
	DialogConvert.TextBox3.Text = oParaCursor.String
	DialogConvert.CommandButton5.Caption = NewString
End Sub



Sub SwapButtonCaption()
Dim SwapButton as Object
Dim sCursorText as String
	sCursorText = DialogConvert.TextBox3.Text
	SwapButton = DialogConvert.CommandButton5
	If SwapButton.Caption = sWholeWord Then
		SwapButton.Caption = NewString
		DialogConvert.TextBox3.Text = ReplaceString(sCursorText,sWholeWord,NewString)
	Else
		SwapButton.Caption = sWholeWord
		DialogConvert.TextBox3.Text = ReplaceString(sCursorText,NewString,sWholeWord)
	End If
End Sub



Sub SwapBigCapatStart()
	If UCase(Left(sWholeWord,1)) = Left(sWholeWord,1) Then
		oPrevCursor.GotoPreviousWord(False)
		oPrevCursor.CollapsetoStart()
		' ToDo: Hier wre eigentlich eine funktionierende Methode 'IsStartofSentence' ntig
		oPrevCursor.GoLeft(2,True)
		sPrevWord = oPrevCursor.String
		If (Instr(1,sPrevWord,".") = 0)AND(Instr(1,sPrevWord,"!") = 0)AND(Instr(1,sPrevWord,":") = 0)AND(Instr(1,sPrevWord,"?") = 0) Then
			NewString = SwapFirstChar(sWholeWord,SBMAKESMALL)					
		End If
	Else 
		bLog = False
	End If
End Sub					



Sub EvaluateFounding(oFound as Object)
Dim p as integer
Dim FoundStart as Integer
Dim FirstChar, LastChar as String
Dim AscSecChar, AscThirdChar as Integer
Dim RuleIsThere as Boolean
Dim PrePos as Integer
Dim TempsWholeWord as String
Dim Prefound as String

	TempsWholeWord = ""
	FoundString = oFound.String
	IsTrash = False
	bLog = True
	NewString = ""
	If ImplementationName = "ScModelObj" Then
		oTextCursor = oFound.Text.CreateTextCursorbyRange(oFound)
	Else
		oTextCursor = oFound.Text.CreateTextCursorbyRange(oFound)
	End If	

	' Den Cursor auf den Anfang des nchsten Wortes setzen
	Select Case s

		Case SBSIMPLE, SBNUMBERS
			If Not WholeWordOnly Then
				SetCursorOverHyphenWord()
			Else
				sWholeWord = FoundString
			End If

		Case SBNEXTWORD
			If WholeWordOnly   Then
				oTextCursor.GotoNextWord(False)
				oTextCursor.CollapseToStart()
				oTextCursor.GotoEndofWord(True)
				sWholeWord = oTextCursor.String
				oTextCursor.GotoPreviousWord(False)
			Else
				Foundstring = DeleteRegularChars(sOldWord , SwapChar)
				SetCursoroverHyphenWord()	
			End If	

		Case SBINSERTBLANK
			Foundstring = DeleteRegularChars(sOldWord , SwapChar)
			oTextCursor.GotoPreviousWord(False)
			oTextCursor.GotoStartofWord(False)
			oTextCursor.GotoEndofWord(True)
			sWholeWord = oTextCursor.String
																					
		Case SBANGLO
			sWholeWord = oTextCursor.String

		Case SBTWOTOONE
			If ConvertToBoolean(oSpellrecord.CheckBefore) Then
				oTextCursor.GotoPreviousWord(False)
				oTextCursor.GotoPreviousWord(False)
				oTextCursor.GoToNextWord(True)
				oTextCursor.GoToNextWord(True)
				sWholeWord = oTextCursor.String
			End If
			If ConvertToBoolean(oSpellRecord.CheckAfter) Then
				oTextCursor.GotoNextWord(False)
				oTextCursor.GotoNextWord(False)
				oTextCursor.GoToPreviousWord(True)
				oTextCursor.GoToPreviousWord(True)
				sWholeWord = oTextCursor.String
			End If
			If Not CheckDetails Then
				sWholeWord = FoundString
			End If
		
		Case SBSWAPCAPS
			oTextCursor.GotoStartofWord(False)
			oTextCursor.GotoEndofWord(True)
			sWholeWord = oTextCursor.String
			oNextWordCursor = oFound.Text.CreateTextCursorbyRange(oFound)
			oNextWordCursor.GotoNextWord(False)
			oNextWordCursor.GotoEndofWord(True)
			sNextWord = oNextWordCursor.String
			If (CheckDetails) and (ConvertToBoolean(oSpellRecord.CheckAfter)) Then
				sWholeWord = sNextWord
				oNextWordCursor.GotoNextWord(False)
				oNextWordCursor.GotoEndofWord(True)
				oTextCursor.GotoNextWord(False)
				oTextCursor.GotoEndofWord(True)
				sNextWord = oNextWordCursor.String
			End If
			oPrevCursor = oFound.Text.CreateTextCursorbyRange(oFound)

			If ConvertToBoolean(oSpellRecord.CheckBefore) Then
				oPrevCursor = oFound.Text.CreateTextCursorbyRange(oFound)
				oPrevCursor.GoToPreviousWord(False)
				oPrevCursor.GoToPreviousWord(False)
				oPrevCursor.GotoStartofWord(False)
				oPrevCursor.GotoEndofWord(True)
				sPrevWord = oPrevCursor.String
			End If
	End Select

	If s <> SBTWOTOONE THEN
		IsTrash = FieldInArray(TrashList(),MaxTrashIndex,sWholeWord)
	End If	
	
	If Not IsTrash Then
		' Mu der erste Buchstabe in der Gro/Kleinschreibung angepat werden
		SwapChar = CheckCaseSensitivity(CheckFirstCap, FoundString)
		If CheckDetails Then
			' Prfe Detailtabelle, bevor etwas bersetzt wird
			If CheckList = False Then
				CheckDetailTable(FoundString, SwapChar, sNewWord, sOldWord,Masterkey)
			Else 
				CheckDetailList(FoundString, SwapChar, sNewWord, sOldWord)
			End If
		Else
			Select Case s

				Case SBSIMPLE, SBANGLO, SBTWOTOONE
					If Not RegularExpression Then
						sNewWord = SwapFirstChar(sNewWord, SwapChar)	
						NewString = Replacestring(sWholeWord,sNewWord,sOldWord)
					Else
						If ConvertToBoolean(oSpellRecord.RegularExpression) Then
							ReplaceRegularExpression(FoundString, sNewWord, sOldWord, SwapChar, CheckFirstCap)
						End If
					End If

				Case SBNEXTWORD
					NewString = Replacestring(sWholeWord,sNewWord,sOldWord)
					If NOT CheckFirstCap Then
						'Hyphentabelle: den Anfang des nchstenWortes klein schreiben siehe
						' Afro-Amerikaner --> Afroamerikaner
						oTextCursor.CollapseToEnd()
						ChangeFirstCase(sWholeWord, False)
					Else
						MsgBox "Fr diesen Fall gibt es noch keine Lsung!"
					End If

				Case SBINSERTBLANK
					' ToDo: grogeschriebene Wrter am Satzanfang!!!
					FoundStart = Instr(1,sWholeWord,FoundString)
					If Ucase(sWholeWord) <> UCase(FoundString) Then
						FirstChar = Left(sWholeWord,1)
						If LCase(FirstChar) = FirstChar Then
							' erste Buchstabe ist kleingeschrieben
							If ConvertToBoolean(oSpellrecord.CheckBefore) Then
								If (FoundStart > 1) Then
									LastPrefix = Int(Prefix(0))
									Prefound = UCase(Mid(sWholeWord,FoundStart-2,2))
									If (Prefound = "ZU") OR (Prefound = "GE") Then
										p = LastPrefix + 1								
									Else
										For p = 1 To LastPrefix
											PrePos = Instr(1, sWholeWord,Prefix(p))
											If PrePos =  1 Then
												Prelen = Len(Prefix(p)
												If UCase(Mid(sWholeWord,FoundStart-PreLen,Prelen)) = UCase(Prefix(p)) Then
													If ConvertToBoolean(oSpellRecord.CheckAfter) Then
														' Jetzt soll er auch hinten nichts einfgen
														Foundstring = ""
													End If
													exit For
												End If
											End If
										Next p
									End If
									If p > LastPrefix Then
										' Es steht kein definiertes Prefix vor dem Verb -> also ersetzen
										NewString = ReplaceString(sWholeWord, " " & FoundString,FoundString)
										If ConvertToBoolean(oSpellrecord.CheckAfter) Then
											FoundString = " " & FoundString
											TempsWholeWord = sWholeWord
											sWholeWord = NewString
										End If									
									End If
								End If
							End If 
							If ConvertToBoolean(oSpellrecord.CheckAfter) Then
								If FoundStart + Len(FoundString) + 2 <= Len(sWholeWord) Then
									If NOT ((oSpellrecord.RuleID = -2) AND (TempsWholeWord = "")) Then
										NewString = ReplaceString(sWholeWord,FoundString & " ",FoundString)									
										If TempsWholeWord <> "" Then
											sWholeWord = TempsWholeWord
										End If
									End If
								End If
							End If
						End If
					End If

				Case SBNUMBERS
					' ToDo: Suffixe wie 68er - 
					LastChar = FindFirstNonNumberChar(sWholeWord)
					' Mu der erste Buchstabe in der Gro/Kleinschreibung angepat werden
					SwapChar = CheckCaseSensitivity(True, LastChar)
					' Zahlen am Satzanfang
					If Not oSpellInsert Then
						' Zahl durch Wort ersetzen
						ReplaceRegularExpression(FoundString, sNewWord, sOldWord, SwapChar)									
'						NewString = ReplaceString(sWholeWord,sNewWord & LCase(LastChar) , FoundString)
					Else
						sOldRepl = Left(FoundString,Len(FoundString)-1)
						' Bindestrich nach Zahl
						NewString = ReplaceString(sWholeWord,sOldRepl & sNewWord & LastChar,FoundString)
					End If
					NewString = SwapFirstChar(NewString,SwapChar)	

				Case SBSWAPCAPS
					If OnlyBigCapsatStart Then
						SwapBigCapatStart()
					ElseIf UCase(Left(sNextWord,1)) <> Left(sNextWord,1) Then
						If Not RegularExpression Then
							sNewWord = SwapFirstChar(sNewWord, SwapChar)	
							NewString = ReplaceString(sWholeWord,sNewWord,sOldWord)
						Else
							' Es ist kein neues Wort mitgegeben worden, so da 
							' defaultgem kleingeschrieben wird  "das goethesche Gedicht" (konvertierte Version)
							If sNewWord = "" Then
								FirstChar = Left(FoundString,1)
								If Firstchar = UCase(FirstChar) Then
									Mid(FoundString, 1, 1, LCase(Left(FoundString,1))) 
								End If
							Else
								ReplaceRegularExpression(FoundString, sNewWord, sOldWord, SwapChar, CheckFirstCap)
							End If
						End If
					End If
			End Select
		End If

		If NewString <> ""  Then
			' Etwas wurde gendert
			If oSpellCareful Then
				' Interaktiv Rcksprache mit dem User halten
				GoOn = False
				EnableStep2DialogControls(True)
				RetrieveSentenceString(oFound)
				RuleisThere = SelectDetailTable("Rules","ID", oSpellRecord.RuleID)
				If RuleIsThere Then
					DialogConvert.Label4.Caption = oDetailRecord.Rule
				End If
			Else
				oTextCursor.String = NewString
				oStatusline.SetText(sWholeWord & " durch " & NewString & " ersetzt")
			End If
		Else
			IsTrash = AddFoundingtoTrashList()
		End If	

		If Not IsTrash AND GoOn AND bLog Then
			' Vermerk in der Logdatei machen
			If bDevelop Then
				InsertConvertStrings(oLogDocument, oLogTable, sOldWord, sWholeWord, NewString)
			End If
		End If
	End If		
End Sub



Sub SetCursoroverHyphenWord()
Dim Hyphpos as Integer

	HyphPos = Instr(1,FoundString,"-")
	If HyphPos = 0 Then
		oTextCursor.GotoStartofWord(False)
		oTextCursor.GotoEndofWord(True)
		sWholeWord = oTextCursor.String
	Else							
		sWholeWord = oTextCursor.String
	End If
End Sub							



Sub SetCarefulFlag()
	If DialogConvert.OptionButton1.Value Then
		oSpellCareful = True
	ElseIf DialogConvert.OptionButton2.Value Then
		oSpellCareful = ConvertToBoolean(oSpellrecord.Careful)
	ElseIf DialogConvert.OptionButton3.Value Then
		oSpellCareful = False
	End If
End Sub



Function FindFirstNonNumberChar(BigString)
Dim i as Integer
Dim BigLen as Integer
Dim AsciChar as Integer
Dim iChar as String
	BigLen = Len(Bigstring)
	i = 1
	Do
		iChar = Mid(BigString,i,1)
		AsciChar = Asc(iChar)
		If AsciChar > 47 AND AsciChar < 58 Then
			i = i + 1
		Else
			FindFirstNonNumberChar = iChar
			exit Do
		End If
	Loop Until i > BigLen
	If i > BigLen Then
		FindFirstNonNumberChar = ""
	End If
End Function
