'SBLLINK:MethodInfo=SchedPrintTasksAllInfo0
'SBLLINK:MethodInfo=SchedPrintEventsAllInfo0
'SBLLINK:MethodInfo=SchedPrintTaskEventAllInfo0
'SBLLINK:MethodInfo=PrintTaskEventOneDay0
'SBLLINK:MethodInfo=initPreventList0
'SBLLINK:MethodInfo=isInPreventList0
'SBLLINK:MethodInfo=insertInPreventList0
'SBLLINK:MethodInfo=CreateOneTaskEventAllInfo_impl0
'SBLLINK:MethodInfo=showVariable0
'SBLLINK:MethodInfo=InsertVariable0
'SBLLINK:MethodInfo=_SetVariable0
'SBLLINK:MethodInfo=CreateAccessArray0
'SBLLINK:MethodInfo=__SetVariable0
'SBLLINK:MethodInfo=SetVariable0
'SBLLINK:MethodInfo=CreateHiddenParagraph0
'SBLLINK:MethodInfo=Hidden0
'SBLLINK:MethodInfo=SetAndAddIndi0
'SBLLINK:MethodInfo=CreateOneTaskEventAllInfo0
'SBLLINK:MethodInfo=GetRecurrencies0
'SBLLINK:MethodInfo=GetReminders0
'SBLLINK:MethodInfo=GetDateAsString0
'SBLLINK:MethodInfo=GetTimeAsString0
'SBLLINK:MethodInfo=GetParticipants0
'SBLLINK:MethodInfo=GetLinks0
'SBLLINK:MethodInfo=CreateTemplateAll0
'SBLLINK:MethodInfo=SetCursorParaKeepTogether0
' *****   Ausgabe einzelner Tasks/Events  *****
' $Revision: 1.1.1.1 $

' Dim _bDeletePage as Boolean

' this array will prevent the appear of an event more than once
' the maxsize is 256 elements.
Global _nPreventListCount as Integer
Global _aPreventList$(257)

' --------------------------------------------------------------------------------
Sub SchedPrintTasksAllInfo(aDoc as Object, aScheduleComponent as Object, _
				    aIndi as Object, bDeleteAll as Boolean,_
				    bCreateMode as Boolean)
	' PRE: aDoc aktuelles Dokument
	'      aScheduleComponent: (Aktueller Termin)
	'      aIndi: Object des Indikators

	aNames = Array(_
	"AccessLevel",_
	"Archived",_
	"Attachments",_
	"Categories",_
	"Description",_
	"Links",_
	"OwnerUid",_
	"OwnerVersion",_
	"Participants",_
	"Priority",_
	"References",_
	"RelatedObjects",_
	"StartDate",_
	"TimeZoneUid",_
	"Title",_
	"Type",_
	"Uid",_
	"CloseDate",_
	"CompletionDate",_
	"CompletionPercentage",_
	"DueDate",_
	"TaskState"_
	)
	
	Dim aConfig as Object, aTaskStyleDescriptor as Object
	if (bCreateMode = FALSE) then
		aConfig = aScheduleComponent.Configuration
		aTaskCursorDescriptor = aConfig.TaskCursorDescriptor
		aTaskCursorDescriptor.PropertyNames = aNames()
		aTaskStyleDescriptor = aConfig.TaskStyleDescriptor
	endif

	SchedPrintTaskEventAllInfo(aDoc, aScheduleComponent, _
							   aIndi, bDeleteAll, bCreateMode,_
							   7,_
							   aTaskCursorDescriptor, aTaskStyleDescriptor)
End Sub
' ------------------------------------------------------------------------------
Sub SchedPrintEventsAllInfo(aDoc as Object, aScheduleComponent as Object, _
						    aIndi as Object, bDeleteAll as Boolean,_
							bCreateMode as Boolean)

	aNames = Array(_
	"AccessLevel",_
	"Archived",_
	"Attachments",_
	"Categories",_
	"Description",_
	"Links",_
	"OwnerUid",_
	"OwnerVersion",_
	"Participants",_
	"Priority",_
	"References",_
	"RelatedObjects",_
	"StartDate",_
	"TimeZoneUid",_
	"Title",_
	"Type",_
	"Uid",_
	"BusyType",_
	"DayEvent",_
	"EndDate",_
	"Location",_
	"Recurrences",_
	"Reminders"_
	)

	Dim aConfig as Object
	Dim aEventCursorDescriptor as Object
	Dim aEventStyleDescriptor as Object
	if (bCreateMode = FALSE) then
		aConfig = aScheduleComponent.Configuration
		aEventCursorDescriptor = aConfig.EventCursorDescriptor.createClone
		aEventCursorDescriptor.ContainerName="Recurring.Client.Rights.Events"
		aEventCursorDescriptor.PropertyNames = aNames()
		aEventStyleDescriptor = aConfig.EventStyleDescriptor.createClone
	endif

	Call SchedPrintTaskEventAllInfo(aDoc, aScheduleComponent,_
								    aIndi, bDeleteAll, bCreateMode,_
									6, _
									aEventCursorDescriptor, aEventStyleDescriptor)
End Sub

' ------------------------------------------------------------------------------
Sub SchedPrintTaskEventAllInfo(aDoc as Object, aScheduleComponent as Object, _
							   aIndi as Object, bDeleteAll as Boolean, bCreateMode as Boolean,_
							   nType as Integer, _
							   aCursorDescriptor as Object, aStyleDescriptor as Object)

	Dim nIndicatorStep as Double, nIndicatorValue as Double
	Dim aCursor as Object
	Dim nCount%
	nCount% = 0

	if (NOT isnull(aIndi)) then
		aIndi.Value = 5
	endif
	
	nIndicatorValue = 10

	' Aenderung:
	' Fuer jeden Selectierten Termin muss ein Cursor erstellt werden.

	' Alle Aufgaben einzeln ausgeben.
	Dim nRecordCount as Integer
	
	if (bCreateMode = TRUE) then
		CreateOneTaskEventAllInfo(aDoc, aScheduleComponent, _
                                  nType, bDeleteAll, _
								  aCursor, aStyleDescriptor, bCreateMode,_
								  aIndi, nIndicatorValue, nIndicatorStep)
		if (NOT isnull(aIndi)) then
			aIndi.Value = 90
		endif
	else
		aPrintContext = aScheduleComponent.PrintContext
		
		if (aPrintContext.PrintSelectedObjects = TRUE) then
			' Ausdruck aller Selektierten Termine

			if (nType = 6) then
				aCursorDescriptor.ContainerType = aPrintContext.EventViewState.Container
				aUids = aPrintContext.EventViewState.SelectedUids
			else
				aCursorDescriptor.ContainerType = aPrintContext.TaskViewState.Container
				aUids = aPrintContext.TaskViewState.SelectedUids
			endif
			
			nRecordCount = ubound(aUids)
			if (nRecordCount = 0) then
				nIndicatorStep = (100-10-10) / 1
			else
				nIndicatorStep = (100-10-10) / nRecordCount
			endif
			
			Dim aFilter as Object, nPos as Integer

			for nPos = 0 to nRecordCount
				aFilter = aCursorDescriptor.Filter.insertNewByIndex(0)
				aFilter.PropertyName = "Uid"
				aFilter.Value = aUids(nPos)
				aFilter.Operator = _scheduleOperator_EQUAL
			
				aSession    = aScheduleComponent.Session
				aCursor = aSession.createCursor( aCursorDescriptor, com.sun.star.schedule.ScheduleCursorType.SNAPSHOT )
				aCursor.MoveToFirst()

				if (aCursor.isValid) then
					CreateOneTaskEventAllInfo_impl(aDoc, aScheduleComponent, _
							nType,_
							bDeleteAll,_
							aCursor, aStyleDescriptor, bCreateMode,_
							aIndi, nIndicatorValue, nIndicatorStep, nCount%)
				endif
				nCount% = nCount% + 1
			next
		else
			' Ausdruck aller Termine

			' inplizid: is showndays = 0, we are in a Listview
			' heavy todo: we need a list to prevent events that take place at more then one day
			' we put his UID in the list and prevent this event it is already in the list
			initPreventList()
			Dim nDaysToPrint as Integer
			aPrintArea = aPrintContext.EventViewState.ShownDays
			nDaysToPrint = uBound(aPrintArea) + 1
			if (nType = 6 and nDaysToPrint > 0) then
				' Filter setzen

				Dim nDay as Integer, nMonth as Integer, nYear as Integer
				Dim aEventCursorDescriptor as Object
				Dim aTempDate as New com.sun.star.util.DateTime
				
				Dim nFactor as Double
				nFactor = 1/nDaysToPrint
				
				for i = 0 to nDaysToPrint - 1
					aEventCursorDescriptor = aCursorDescriptor.createclone

					nDay = aPrintArea(i).Day
					nMonth = aPrintArea(i).Month
					nYear = aPrintArea(i).Year
					nStartDay = DateSerial(nYear, nMonth, nDay)

					nEndDay = nStartDay

					' 00:00:00 < StartDate
					aTempDate.Day   = Day(nEndDay + 1)
					aTempDate.Month = Month(nEndDay + 1)
					aTempDate.Year  = Year(nEndDay + 1)
					aTempDate.Hours	 = 0
					aTempDate.Minutes = 0
					aTempDate.Seconds = 0
					aTempDate.HundredthSeconds = 0
				
					aFilter = aEventCursorDescriptor.Filter.insertNewByIndex(0)
					aFilter.PropertyName = "StartDate"
					aFilter.Value = aTempDate
					aFilter.Operator = _scheduleOperator_LOWER ' com.sun.star.schedule.ScheduleQueryOperator.LOWER
				
					' 0:00:00 NextDay > EndDate
					aTempDate.Day   = Day(nStartDay)
					aTempDate.Month = Month(nStartDay)
					aTempDate.Year  = Year(nStartDay)
					aTempDate.Hours	 = 0
					aTempDate.Minutes = 0
					aTempDate.Seconds = 0
					aTempDate.HundredthSeconds = 0
	
					aFilter = aEventCursorDescriptor.Filter.insertNewByIndex(1)
					aFilter.PropertyName = "EndDate"
					aFilter.Value = aTempDate
					aFilter.Operator = _scheduleOperator_GREATER ' com.sun.star.schedule.ScheduleQueryOperator.GREATER

					PrintTaskEventOneDay(aDoc, aScheduleComponent, aEventCursorDescriptor,_
						nType, bDeleteAll, bCreateMode, _
						aIndi, nIndicatorValue,nFactor,_
						aStyleDescriptor, nCount%, TRUE)
				next
			else
				PrintTaskEventOneDay(aDoc, aScheduleComponent, aCursorDescriptor,_
					nType, bDeleteAll, bCreateMode, _
					aIndi, nIndicatorValue,1,_
					aStyleDescriptor, nCount%, FALSE)
			endif
		endif
	endif
End Sub
' ------------------------------------------------------------------------------
Sub PrintTaskEventOneDay(aDoc as Object, aScheduleComponent as Object, aCursorDescriptor as Object,_
nType as Integer, bDeleteAll as Boolean, bCreateMode as Boolean,_
aIndi as Object, nIndicatorValue as Double, nFactor as Double, _
aStyleDescriptor as Object, nCount%, bNeedList as Boolean)

	Dim aSession as Object, aCursor as Object
	Dim nIndicatorStep as Double
	Dim nRecordCount as Integer
	Dim aSort as Object

	aCursorDescriptor.Grouping.Clear
	' Dim aSort as Object, aFilter as Object
	
	aSort = aCursorDescriptor.Sorting.insertNewByIndex(0)
	aSort.PropertyName = "StartDate"
	aSort = aCursorDescriptor.Sorting.insertNewByIndex(1)
	aSort.PropertyName = "Title"

	aSession    = aScheduleComponent.Session
	aCursor = aSession.createCursor( aCursorDescriptor, com.sun.star.schedule.ScheduleCursorType.SNAPSHOT )

	aCursor.MoveToLast
	nRecordCount = aCursor.Position + 1
	aCursor.MoveToFirst
	if (nRecordCount = 0) then 
		nRecordCount = 1 
	endif
	
	nIndicatorStep = (100-10-10) / nRecordCount * nFactor
	
	while (aCursor.isvalid)
		if (NOT isInPreventList(aCursor.Uid)) then
			CreateOneTaskEventAllInfo_impl(aDoc, aScheduleComponent, _
					nType,_
					bDeleteAll,_
					aCursor, aStyleDescriptor, bCreateMode,_
					aIndi, nIndicatorValue, nIndicatorStep, nCount%)
			if (bNeedList) then insertInPreventList(aCursor.Uid)
		endif
		aCursor.moveRelative(1)
		nCount% = nCount% + 1
	wend
End Sub
' ------------------------------------------------------------------------------
Sub initPreventList()
	Dim i as Integer
	for i=0 to 256
		_aPreventList(i) = ""
	next
	_nPreventListCount = 0
End Sub
' ------------------------------------------------------------------------------
Function isInPreventList(aElement as String) as Boolean
	Dim bBack as Boolean
	bBack = FALSE
	for i=0 to _nPreventListCount
		if (_aPreventList(i) = aElement) then
			bBack = TRUE
			Exit For
		endif
	next
	isInPreventList = bBack
End Function
' ------------------------------------------------------------------------------
Sub insertInPreventList(aElement as String)
	_aPreventList(_nPreventListCount) = aElement
	_nPreventListCount = _nPreventListCount + 1

	if (_nPreventListCount > 256) then
		initPreventList()
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateOneTaskEventAllInfo_impl(aDoc as Object, aScheduleComponent as Object, _
			nType as Integer,_
			bDeleteAll as Boolean,_
			aCursor as Object, aStyleDescriptor as Object, bCreateMode as Boolean,_
			aIndi as Object, nIndicatorValue as Double, nIndicatorStep as Double,_
			nCount as Integer)

	Dim aTempDocument as Object
	Dim sTempFile as String
	Dim aTempDoc as Object
	Dim aCrsr as Object

	aTempDoc = aDoc

	aCrsr = aDoc.text.createTextCursor()

	sTempFile = GetWorkPath() + GetPathSeparator() + "SSPrint.sdw"
	' sTemplateFile = aDoc.DocumentInfo.TemplateFileName
	sTemplateFile = aDoc.getURL()

	' Neue Seite laden
	if (nCount <> 0) then
		aTempDocument = documents.open( sTemplateFile, "", "h" )
		aTempDoc = aTempDocument.UNO
	endif
	
	CreateOneTaskEventAllInfo(aTempDoc, aScheduleComponent,_
		nType, bDeleteAll, _
		aCursor, aStyleDescriptor, bCreateMode,_
		aIndi, nIndicatorValue, nIndicatorStep)
	
	' if (NOT isnull(aIndi)) then
	' 	  aIndi.Value = nIndicatorValue
	' 	  nIndicatorValue = nIndicatorValue + nIndicatorStep
	' endif
	
	' Seite abschliessen
	if (nCount <> 0) then
		aTempDocument.SaveAs sTempFile              ' TempDokument abspeichern
		aTempDocument.Close(false, sTempFile)
		aCrsr.gotoEnd(FALSE)

		'
		' Newpage erzwingen
		'
		aDoc.Text.insertControlCharacter(aCrsr, 0, false)
		' Seitenumbruch
		if (GetFieldTypeAsBoolean(aDoc, "bPageBreak", FALSE) = TRUE) then
			aCrsr.pagedescname = aCrsr.pagestyle
		endif
		aCrsr.gotoEnd(FALSE)
		
		aCrsr.insertDocumentFromURL(sTempFile, Array())	' am aktuellen Cursor anhaengen
		on local error goto killfehler
		Wait(2)
		Kill ( sTempFile )							' Tempdokument schliessen
killfehler:
		on local error goto 0
	endif
End Sub
' ------------------------------------------------------------------------------
Sub showVariable(aDoc as Object, aCrsr as Object, aName as String)
	aVf = aDoc.createinstance("com.sun.star.text.TextField.GetExpression")
	aVf.content = aName 
	aVf.SubType = 0
	aDoc.text.inserttextcontent(aCrsr, aVf, false)
	aVf.SubType = 0
End Sub
' ------------------------------------------------------------------------------
Sub InsertVariable(aDoc as Object, aCrsr as Object, aName as String, bTab as Boolean)
	' POST: An der Cursorpos. des Doks eine Variable eintragen
	Dim sStardivSetExp as String
	Dim sVarName as String

	sStardivSetExp = "com.sun.star.text.FieldMaster.SetExpression"
	sVarName = sStardivSetExp + "." + aName

	if (aDoc.textfieldmasters.hasbyname(sVarName)) then 
		aVt = aDoc.textfieldmasters.getbyname(sVarName)
	else
		aVt = aDoc.createinstance(sStardivSetExp)
		aVt.name = aName
	endif
	aVf = aDoc.createinstance("com.sun.star.text.TextField.SetExpression")

	on local error goto var_gibts_schon_error
	aVf.SubType = 0
var_gibts_schon_error:
	on local error goto 0

	aVf.attachtextfieldmaster(aVt)

	on local error goto error_there_is_no_visible
	aVf.Visible = FALSE
error_there_is_no_visible:
	on local error goto 0

	if (bTab = TRUE) then
		aDoc.text.insertString(aCrsr, chr$(9), false)
	endif
	aDoc.text.inserttextcontent(aCrsr, aVf, false)
End Sub
' ------------------------------------------------------------------------------
Sub _SetVariable(aDoc as Object, aName as String, aValue as String)
	' POST: Im Dokument die Variable aName mit aValue besetzen

	aCrsr = aDoc.Text.createTextCursor
	aCrsr.gotoEnd(false)
	aDoc.Text.insertString(aCrsr, aName, false)
	aDoc.Text.insertString(aCrsr, " := ", false)
	aDoc.Text.insertString(aCrsr, aValue, false)
	aDoc.Text.insertControlCharacter(aCrsr,0,false)
End Sub
' ------------------------------------------------------------------------------
Global aObjCache(21) as Object

Sub CreateAccessArray(aDoc as Object)
	' POST: Zugriffsarray erstellen, MUSS einmal pro Dokument erzeugt werden.
	Dim aFieldEnum as Object, aField as Object
	Dim sName as String
	
	aFieldEnum = aDoc.textfields.createenumeration
	on local error goto setvarerror

	' Array loeschen, damit keine alten zuweisungen moeglich werden
	Dim noargs as Object
	for i=0 to 20
		aObjCache(i) = noargs
	next

	while aFieldEnum.hasMoreElements
		aField = aFieldEnum.NextElement
		if aField.SupportedServiceNames(0) = "com.sun.star.text.TextField.SetExpression" then
			sName = aField.variablename
			'if (sName = aName) then
			'	aField.formula = aValue
			'	aField.SubType = 0
			'endif
			for i=0 to 20
				if (sName = sched_FieldNames$(i)) then
					aObjCache(i) = aField
					i=20
				endif
			next
		endif
	wend
setvarerror:
	on local error goto 0
End Sub
' ------------------------------------------------------------------------------
Sub __SetVariable(aDoc as Object, aName as String, aValue as String)
	' Eine Variable setzen
	Exit Sub
	Dim aFieldEnum as Object, aField as Object

	aFieldEnum = aDoc.textfields.createenumeration
	on local error goto setvarerror
	while aFieldEnum.hasMoreElements
		aField = aFieldEnum.NextElement
		if aField.SupportedServiceNames(0) = "com.sun.star.text.TextField.SetExpression" then
			if (aField.variablename = aName) then
				aField.formula = aValue
				aField.SubType = 0
			endif
		endif
	wend
setvarerror:
	on local error goto 0
End Sub
' ------------------------------------------------------------------------------
Sub SetVariable(aDoc as Object, aNameNum as Integer, aValue as String)
	' Eine Variable setzen
	' Exit Sub
	on local error goto setvarerror2
	Dim aField as Object
	aField = aObjCache(aNameNum)
	aName = aField.variablename

	aField.formula = aValue
	aField.SubType = 0

setvarerror2:
	on local error goto 0

End Sub
' ------------------------------------------------------------------------------
Sub CreateHiddenParagraph(aDoc as Object, aCrsr as Object, aObj as Object, aName as String)
	' Dim aCrsr as Object
	Dim sCondition as String

	on local error goto laufzeitfehler

	' aCrsr = aDoc.Text.CreateTextCursor
	' aCrsr.gotoEnd(false)

	insertVariable(aDoc, aCrsr, aName, TRUE)             ' Variable setzen
	Hidden(aDoc, aCrsr, aName)
	aTransName = GetTranslateName(aObj, aName)
	aCrsr.CharStyle = TranslateStyle("ScheduleDetailDesc")
	aDoc.Text.insertString(aCrsr, aTransName + ":" + chr$(9), false)   ' Text 

	aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
	showVariable(aDoc, aCrsr, aName)                     ' Variable anzeigen
	aDoc.Text.insertControlCharacter(aCrsr, 0, false)

	on local error goto 0
	Exit Sub
laufzeitfehler:
	resume next
End Sub
' ------------------------------------------------------------------------------
Sub Hidden(aDoc as Object, aCrsr as Object, aName as String)
	sCondition = aName + "==" + chr$(34) + chr$(34)
	HiddenLine(aDoc, aCrsr, sCondition)                  ' Versteckter Absatz
End Sub
' ------------------------------------------------------------------------------
Sub SetAndAddIndi(aIndi as Object, nIndiValue as Double, nIndiStep as Double)
	nIndiValue = nIndiValue + nIndiStep
	if (NOT isnull(aIndi)) then
		aIndi.Value = nIndiValue
	endif
End Sub
' ------------------------------------------------------------------------------
Sub CreateOneTaskEventAllInfo(aDoc as Object, aScheduleComponent as Object,_
							  nType as Integer, bDeleteAll as Boolean, _
				  aCursor as Object, aTaskStyle as Object, bCreateMode as Boolean,_
				  aIndi as Object, nIndicatorValue as Double, nIndicatorStep as Double)


	Dim nIndicatorLowStep as Double
	nIndicatorLowStep = nIndicatorStep / 5

	Dim aCrsr as Object
	aCrsr = aDoc.text.createTextCursor

	if (bDeleteAll = TRUE) then
		ClearDocument(aDoc)
	endif
	aCrsr.gotoEnd(FALSE)
	_bDeletePage = FALSE  ' Globaler Schalter, nur beim 1. mal die Seite loeschen.
	
	' Eine Kapitelueberschrift eintragen, es ist die einzige
	' Moeglichkeit auf jeder Seite eine andere Kopfzeile darzustellen.
	
	Dim nDays as Date
	Dim sTempStr as String
	sTempStr = "" ' Sched_Month$(Month(nDays)) + " " + Year(nDays)
	ChapterTitle(aDoc, aCrsr, sTempStr)
	
	' -----------------------------------------------------
	' Kopf und Fusszeile erstellen
	' -----------------------------------------------------
	if (bCreateMode) then
		FillHeadAndFoot(aDoc, 2, nDays, nMonth, nYear,"")
	else
		FillHeadAndFoot(aDoc, 2, nDays, nMonth, nYear,GetUserNameFromCalendar(aScheduleComponent))
	endif
	
	on local Error goto CursorAccessError

	if (bCreateMode) then
		' Vorlage erstellen
		' aDoc.Text.insertControlCharacter(aCrsr, 0, false)
		' aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
		CreateTemplateAll(aDoc, aCrsr, TRUE, nType)
		InsertLastLine(aDoc, aCrsr)
	else
		' Es muessen immer aller Werte gesetzt werden, da ueber die Versteckten
		' Absaetze entschieden wird, was nicht angezeigt werden soll.
		
		CreateAccessArray(aDoc)
SetAndAddIndi(aIndi, nIndicatorValue, nIndicatorLowStep)

		' __SetVariable(aDoc, sched_fieldnames$(20), aCursor.Title)      ' "Title"
		SetVariable(aDoc, 20, aCursor.Title)      ' "Title"

		' __SetVariable(aDoc, sched_fieldnames$(7), aCursor.Description) ' "Description"
		SetVariable(aDoc, 7, aCursor.Description) ' "Description"

		' __SetVariable(aDoc, sched_fieldnames$(2), aCursor.Categories)  ' "Categorie"
		SetVariable(aDoc, 2, aCursor.Categories)  ' "Categorie"
		
		sTxt = sched_AccessLevel$(aCursor.AccessLevel)
		' __SetVariable(aDoc, sched_fieldnames$(0), sTxt)                ' "AccessLevel"
		SetVariable(aDoc, 0, sTxt)                ' "AccessLevel"

		' __SetVariable(aDoc, sched_fieldnames$(14), aCursor.Priority)   ' "Priority"
		SetVariable(aDoc, 14, aCursor.Priority)   ' "Priority"
		
SetAndAddIndi(aIndi, nIndicatorValue, nIndicatorLowStep)

		Dim aPart as Object
		aPart = aCursor.Participants
		sTxt = GetParticipants(aPart)
		' __SetVariable(aDoc, sched_fieldnames$(13), sTxt)               ' "Participants"
		SetVariable(aDoc, 13, sTxt)               ' "Participants"
		
		Dim aLink as Object, aLinkObj as Object
		aLink = aCursor.Links
		sTxt = GetLinks(aLink)
		' __SetVariable(aDoc, sched_fieldnames$(11), sTxt)               ' "Links"
		SetVariable(aDoc, 11, sTxt)               ' "Links"

SetAndAddIndi(aIndi, nIndicatorValue, nIndicatorLowStep)

		' --------------- Tasks -----------------
		if (nType = 7) then
			if (NOT isempty(aCursor.StartDate)) then
				sTxt = GetDateAsString(aDoc, aCursor.StartDate)
			else
				sTxt = ""
			endif
			' __SetVariable(aDoc, sched_fieldnames$(17), sTxt)           ' "StartDate"
			SetVariable(aDoc, 17, sTxt)           ' "StartDate"

			if (NOT isempty(aCursor.DueDate)) then
				sTxt = GetDateAsString(aDoc, aCursor.DueDate)
			else
				sTxt = ""
			endif
			' __SetVariable(aDoc, sched_fieldnames$(8), sTxt)            ' "DueDate"
			SetVariable(aDoc, 8, sTxt)            ' "DueDate"
			
			if (NOT isempty(aCursor.CompletionDate)) then
				sTxt = GetDateAsString(aDoc, aCursor.CompletionDate)
			else
				sTxt = ""
			endif
			' __SetVariable(aDoc, sched_fieldnames$(4), sTxt)            ' "CompletionDate"
			SetVariable(aDoc, 4, sTxt)            ' "CompletionDate"
			
			if (NOT isempty(aCursor.CloseDate)) then
				sTxt = GetDateAsString(aDoc, aCursor.CloseDate)
			else
				sTxt = ""
			endif
			' __SetVariable(aDoc, sched_fieldnames$(3), sTxt)            ' "CloseDate"
			SetVariable(aDoc, 3, sTxt)            ' "CloseDate"

			sTxt = sched_taskstate$(aCursor.TaskState)
			' __SetVariable(aDoc, sched_fieldnames$(19), sTxt)               ' "TaskState"
			SetVariable(aDoc, 19, sTxt)               ' "TaskState"

			sTxt = aCursor.CompletionPercentage
			' __SetVariable(aDoc, sched_fieldnames$(5), sTxt)                ' "CompletionPercentage"
			SetVariable(aDoc, 5, sTxt)                ' "CompletionPercentage"

		endif

SetAndAddIndi(aIndi, nIndicatorValue, nIndicatorLowStep)

		' --------------- Events ---------------
		if (nType = 6) then
			sTxt = aCursor.Location
			' __SetVariable(aDoc, sched_fieldnames$(12), sTxt)            ' "Location"
			SetVariable(aDoc, 12, sTxt)            ' "Location"
			
			sTxt = GetDateAsString(aDoc, aCursor.StartDate)
			' __SetVariable(aDoc, sched_fieldnames$(17), sTxt)            ' "StartDate"
			SetVariable(aDoc, 17, sTxt)            ' "StartDate"

			sTxt = GetTimeAsString(aDoc, aCursor.StartDate)
			' __SetVariable(aDoc, sched_fieldnames$(18), sTxt)            ' "StartTime"
			SetVariable(aDoc, 18, sTxt)            ' "StartTime"

			sTxt = GetDateAsString(aDoc, aCursor.EndDate)
			' __SetVariable(aDoc, sched_fieldnames$(9), sTxt)            ' "EndDate"
			SetVariable(aDoc, 9, sTxt)            ' "EndDate"

			sTxt = GetTimeAsString(aDoc, aCursor.EndDate)
			' __SetVariable(aDoc, sched_fieldnames$(10), sTxt)            ' "EndTime"
			SetVariable(aDoc, 10, sTxt)            ' "EndTime"

			if (aCursor.DayEvent = TRUE) then
				sTxt = sched_dayevent$
			else
				sTxt = ""
			endif
			' __SetVariable(aDoc, sched_fieldnames$(6), sTxt)            ' "DayEvent"
			SetVariable(aDoc, 6, sTxt)            ' "DayEvent"

			sTxt = Sched_BusyType$(aCursor.BusyType)
			' __SetVariable(aDoc, sched_fieldnames$(1), sTxt)            ' "BusyType"
			SetVariable(aDoc, 1, sTxt)            ' "BusyType"
			
			sTxt = GetRecurrencies(aCursor)
			' __SetVariable(aDoc, sched_fieldnames$(15), sTxt)            ' "Recurrences"
			SetVariable(aDoc, 15, sTxt)            ' "Recurrences"
			
			sTxt = GetReminders(aCursor)
			' __SetVariable(aDoc, sched_fieldnames$(16), sTxt)            ' "Reminders"
			SetVariable(aDoc, 16, sTxt)            ' "Reminders"

		endif
	endif
SetAndAddIndi(aIndi, nIndicatorValue, nIndicatorLowStep)

CursorAccessError:
	on local error goto 0

End Sub
' ------------------------------------------------------------------------------
Function GetRecurrencies(aCursor as Object) as String
	'
	' Recurrencies (Wiederholungen)
	'
	Dim aRecu as Object, aRecuObj as Object
	Dim nCount as Integer, sTxt as String

	on local error goto getrecurrenceerror

	aRecu = aCursor.Recurrences
	nCount = aRecu.Count

	if (nCount > 0) then
		for i=0 to nCount - 1
			aRecuObj = aRecu.GetByIndex(i)

			' DEBUG Code, please don't remove this
			' print "weekday " + aRecuObj.ByWeekDay
			' print "dayofmonth " + aRecuObj.DayOfMonth
			' print "freq " + aRecuObj.Frequency
			' print "month " + aRecuObj.Month
			' print "onlyweekdays " + aRecuObj.OnlyWeekDays
			' print "weekday " + aRecuObj.WeekDay
			' print "weekdays " + aRecuObj.WeekDays
			' print "weeknumber " + aRecuObj.WeekNumber

			select case aRecuObj.Type
		    case 1 ' Daily
				sTxt = sched_recurtype$(1) + ", "
				if (aRecuObj.OnlyWeekDays = TRUE) then
					sTxt = sTxt + sched_everyWeekDay$
				else
					sTxt = sTxt + sched_everyXDay$
					sTxt = ReplaceString(sTxt, "$(FREQ)", aRecuObj.Frequency)
				endif

		    case 2 ' Weekly
				sTxt = sched_recurtype$(2) + ", "
				if (aRecuObj.Frequency = 1) then
					sTxt = sTxt + sched_everyWeekOn$
				else
					sTxt = sTxt + sched_everyXWeeks$
					sTxt = ReplaceString(sTxt, "$(FREQ)", aRecuObj.Frequency)
				endif
				if (UBound(aRecuObj.WeekDays) >= 0) then
					sTxt = sTxt + " "
					for i=0 to UBound(aRecuObj.WeekDays)
						sTxt = sTxt + Sched_weekday$(aRecuObj.WeekDays(i))
						if (i < UBound(aRecuObj.WeekDays)) then
							sTxt = sTxt + ", "
						endif
					next
				endif

		    case 3 ' Monthly
				sTxt = sched_recurtype$(3) + ", "
				if (aRecuObj.ByWeekDay = FALSE) then
					sTxt = sTxt + sched_everyXMonth$
					sTxt = ReplaceString(sTxt, "$(DayOfMonth)", aRecuObj.DayOfMonth)
					sTxt = ReplaceString(sTxt, "$(FREQ)", aRecuObj.Frequency)
				else
					sTxt = sTxt + sched_everyXWeekAllYMonth$
					sTxt = ReplaceString(sTxt, "$(WeekNumber)", aRecuObj.WeekNumber)
					sTxt = ReplaceString(sTxt, "$(WeekDay)", Sched_weekday$(aRecuObj.WeekDay))
					sTxt = ReplaceString(sTxt, "$(FREQ)", aRecuObj.Frequency)
				endif

			case 4 ' Yearly
				sTxt = sched_recurtype$(4) + ", "
				if (aRecuObj.ByWeekDay = FALSE) then
					sTxt = sTxt + sched_everyXDayOnMonth$
					sTxt = ReplaceString(sTxt, "$(DayOfMonth)", aRecuObj.DayOfMonth)
					sTxt = ReplaceString(sTxt, "$(Month)", Sched_Month$(aRecuObj.Month))
				else
					sTxt = sTxt + sched_everyXWeekOnYMonth$
					sTxt = ReplaceString(sTxt, "$(WeekNumber)", aRecuObj.WeekNumber)
					sTxt = ReplaceString(sTxt, "$(WeekDay)", Sched_weekday$(aRecuObj.WeekDay))
					sTxt = ReplaceString(sTxt, "$(Month)", Sched_Month$(aRecuObj.Month))
				endif
			end select
		next
	endif
getrecurrenceerror:
	on local error goto 0
	GetRecurrencies = sTxt
End Function
' ------------------------------------------------------------------------------
Function GetReminders(aCursor as Object) as String
	'
	' Reminders (Erinnerungen)
	'
	Dim aRem as Object, aRemObj as Object
	Dim nCount as Integer, sTxt as String

	on local error goto getremindererror
	sTxt = ""
	aRem = aCursor.Reminders
	nCount = aRem.Count
	if (nCount > 0) then
		for i=0 to nCount - 1
			aRemObj = aRem.GetByIndex(i)
			if (aRemObj.Type and 1) then ' Dialog
				sTxt = sched_showDialog$
			endif

			if (aRemObj.Type and 2) then ' Sound
				if (sTxt <> "") then
					sTxt = sTxt + ", "
				endif
				sTxt = sTxt + sched_playSound$
				if (aRemObj.Action = "") then
					sTxt = ReplaceString(sTxt, "$(URL)", sched_standardSound$)
				else
					sTxt = ReplaceString(sTxt, "$(URL)", aRemObj.Action)
				endif
			endif

			if (aRemObj.Type and 4) then ' EMail
				if (sTxt <> "") then
					sTxt = sTxt + ", "
				endif
				sTxt = sTxt + " " + sched_sendEmailOn$
				sTxt = ReplaceString(sTxt, "$(URL)", aRemObj.Action)
			endif

			if (aRemObj.Offset.Positive = FALSE) then
				nSec = aRemObj.Offset.Seconds
				if (sTxt <> "") then
					sTxt = sTxt + ", "
				endif
				sTxt = sTxt + " " + sched_Notification$
				if (nSec < 60) then
					sTxt = ReplaceString(sTxt, "$(SEC)", nSec)
					sTxt = ReplaceString(sTxt, "$(TYPE)", sched_time$(1))
				elseif (nSec < 3600) then
					sTxt = ReplaceString(sTxt, "$(SEC)", nSec/60)
					sTxt = ReplaceString(sTxt, "$(TYPE)", sched_time$(2))
				elseif (nSec < (3600 * 24)) then
					sTxt = ReplaceString(sTxt, "$(SEC)", nSec/3600)
					sTxt = ReplaceString(sTxt, "$(TYPE)", sched_time$(3))
				else
					sTxt = ReplaceString(sTxt, "$(SEC)", nSec/(3600 * 24))
					sTxt = ReplaceString(sTxt, "$(TYPE)", sched_tim$(4))
				endif
			endif
		next
	endif
getremindererror:
	on local error goto 0
	GetReminders = sTxt
End Function
' ------------------------------------------------------------------------------
Function GetDateAsString(aDoc as Object, aDateTm as Object) as String
	' Rueckgabe eines Datums
	Dim aPrintDate as Date

	aPrintDate = DateSerial(aDateTm.Year, aDateTm.Month, aDateTm.Day)
	GetDateAsString = GetBasicDateAsString(aDoc, aPrintDate)
End Function
' ------------------------------------------------------------------------------
Function GetTimeAsString(aDoc as Object, aDateTm as Object) as String
	' Rueckgabe einer Zeit
	Dim aPrintTime as Double
	aPrintTime = TimeSerial(aDateTm.Hours, aDateTm.Minutes, aDateTm.Seconds)
	GetTimeAsString = GetBasicTimeAsString(aDoc, aPrintTime)
End Function
' ------------------------------------------------------------------------------
Function GetParticipants(aPart as Object) as String
	' POST: alle Teilnehmer anzeigen
	Dim sTxt as String, aPartObj as Object
	Dim i as Integer
	Dim nCount as Integer

	on local error goto getparterror
	nCount = aPart.Count

	if (nCount > 0) then
		Dim bKomma as Boolean
		bKomma = FALSE
		for i=0 to nCount - 1
			aPartObj = aPart.GetByIndex(i)
			sTxt = sTxt + aPartObj.Name
			if (i < nCount - 1) then
				sTxt = sTxt + ", "
			endif
		next
	endif
getparterror:
	on local error goto 0
	GetParticipants = sTxt
End Function
' ------------------------------------------------------------------------------
Function GetLinks(aLink as Object) as String
	Dim aLinkObj as Object, i as Integer
	Dim sTxt as String
	Dim nCount as Integer

	on local error goto getlinkerror
	nCount = aLink.Count
	if (nCount > 0) then
		for i=0 to nCount - 1
			aLinkObj = aLink.GetByIndex(i)
			sTxt = " Name: <$(Name)>, zeigt auf URL: <$(URL)>"
			sTxt = ReplaceString(sTxt, "$(Name)", aLinkObj.Name)
			sTxt = ReplaceString(sTxt, "$(URL)", aLinkObj.URL)
			sTxt = sTxt + chr$(13)
		next
	endif
getlinkerror:
	on local error goto 0
	GetLinks = sTxt
End Function
' ------------------------------------------------------------------------------
Sub CreateTemplateAll(aDoc as Object, aCrsr as Object, bType as Boolean, nType as Integer)
	' Erstellen der Beispielvorlagen

	' Einstellen des TabStops
	Dim aPStyle as Object, aPStyles as Object
	aPStyles = aDoc.stylefamilies.ParagraphStyles

	' GetByIndex(0) soll "Standard" liefern.

	aPStyles.GetByIndex(0) ' #66810#

	on local error goto error_notabsstops

	Dim aNewStops(1) as object
	Dim aTabStop as new com.sun.star.style.TabStop
	aTabStop.position = GetFieldTypeAsLong(aDoc, "nTabStopPos0", 10)
	aTabStop.alignment = GetFieldTypeAsLong(aDoc, "nTabStopAlign0", 0)
	aNewStops(0) = aTabStop

	Dim aTabStop2 as new com.sun.star.style.TabStop
	aTabStop2.position = GetFieldTypeAsLong(aDoc, "nTabStopPos1", 3000)
	aTabStop2.alignment = GetFieldTypeAsLong(aDoc, "nTabStopAlign1", 0)
	aNewStops(1) = aTabStop2
	aPStyle.paratabstops = aNewStops()

	goto no_problems_notabstops
	
error_notabsstops:
	' msgbox "Warning: no TabStops setable, because the Standard-Pattern not found."

no_problems_notabstops:
	on local error goto 0

	'
	' Umbrueche verhindern
	'
	SetCursorParaKeepTogether(aCrsr, TRUE)

	' aCrsr.Split = FALSE

	Dim aObj as Object
	if (nType = 6) then 
		' Event
		aObj = CreateUnoService("com.sun.star.schedule.ScheduleEventFieldNames")
	else
		' Task
		aObj = CreateUnoService("com.sun.star.schedule.ScheduleTaskFieldNames")
	endif

	if (GetFieldTypeAsBoolean(aDoc, "bXTitle", bType)) then
		' CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(20))
		aCrsr.CharStyle = TranslateStyle("ScheduleDetailTitle")
		aName = sched_fieldnames$(20)
		insertVariable(aDoc, aCrsr, aName, TRUE)
		Hidden(aDoc, aCrsr, aName)
		showVariable(aDoc, aCrsr, aName)
		aDoc.Text.insertControlCharacter(aCrsr, 0, false)
	endif
	
	if (nType = 7) then
		if (GetFieldTypeAsBoolean(aDoc, "bXStartDate", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(17))
		endif
	else
		' Event
		if (GetFieldTypeAsBoolean(aDoc, "bXStartDate", bType)) then
			' Start: dd.mm.yy um hh:ss Tagestermin

			aCrsr.CharStyle = TranslateStyle("ScheduleDetailDesc")
			aName = sched_fieldnames$(17)
			insertVariable(aDoc, aCrsr, aName, TRUE)
			Hidden(aDoc, aCrsr, aName)
			aTransName = GetTranslateName(aObj, aName)

			aDoc.Text.insertString(aCrsr, aTransName + ":" + chr$(9), false)
			aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
			showVariable(aDoc, aCrsr, aName)
			aDoc.Text.insertString(aCrsr, " " + sched_on$ + " ", false)

			aName = sched_fieldnames$(18)
			insertVariable(aDoc, aCrsr, aName, FALSE)
			showVariable(aDoc, aCrsr, aName)

			if (GetFieldTypeAsBoolean(aDoc, "bXDayEvent", bType)) then
				aDoc.Text.insertString(aCrsr, " ", false)
				aName = sched_fieldnames$(6)
				insertVariable(aDoc, aCrsr, aName, TRUE)
				showVariable(aDoc, aCrsr, aName)
			endif
			aDoc.Text.insertControlCharacter(aCrsr, 0, false)
		endif

		if (GetFieldTypeAsBoolean(aDoc, "bXEndDate", bType)) then
			' Ende: dd.mm.yy um hh:ss
			aCrsr.CharStyle = TranslateStyle("ScheduleDetailDesc")
			aName = sched_fieldnames$(9)
			insertVariable(aDoc, aCrsr, aName, TRUE)
			Hidden(aDoc, aCrsr, aName)
			aTransName = GetTranslateName(aObj, aName)

			aDoc.Text.insertString(aCrsr, aTransName + ":" + chr$(9), false)
			aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
			showVariable(aDoc, aCrsr, aName)
			aDoc.Text.insertString(aCrsr, " " + sched_on$ + " ", false)

			aName = sched_fieldnames$(10)
			insertVariable(aDoc, aCrsr, aName, FALSE)
			showVariable(aDoc, aCrsr, aName)
			aDoc.Text.insertControlCharacter(aCrsr, 0, false)
		endif
		if (GetFieldTypeAsBoolean(aDoc, "bXLocation", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(12))
		endif
	endif
	if (nType = 7) then 'Task
		if (GetFieldTypeAsBoolean(aDoc, "bXDueDate", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(8))
		endif
		
		if (GetFieldTypeAsBoolean(aDoc, "bXCompletionDate", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(4))
		endif
		
		if (GetFieldTypeAsBoolean(aDoc, "bXCloseDate", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(3))
		endif
	endif

	if (GetFieldTypeAsBoolean(aDoc, "bXCategories", bType)) then
		CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(2))
	endif
	
	if (GetFieldTypeAsBoolean(aDoc, "bXAccessLevel", bType)) then
		CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(0))
	endif
	
	if (GetFieldTypeAsBoolean(aDoc, "bXPriority", bType)) then
		CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(14))
	endif
	
	' Tasks
	if (nType = 7) then
		if (GetFieldTypeAsBoolean(aDoc, "bXTaskState", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(19))
		endif
		
		if (GetFieldTypeAsBoolean(aDoc, "bXCompletionPercentage", bType)) then
			' CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(5))
			aName = sched_fieldnames$(5)
			insertVariable(aDoc, aCrsr, aName, TRUE)             ' Variable setzen
			Hidden(aDoc, aCrsr, aName)
			aTransName = GetTranslateName(aObj, aName)
			aCrsr.CharStyle = TranslateStyle("ScheduleDetailDesc")
			aDoc.Text.insertString(aCrsr, aTransName + ":" + chr$(9), false)   ' Text 
			
			aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
			showVariable(aDoc, aCrsr, aName)                     ' Variable anzeigen
			aDoc.Text.insertString(aCrsr, " %", false)
			aDoc.Text.insertControlCharacter(aCrsr, 0, false)
		endif
	endif
	' Events
	if (nType = 6) then
		if (GetFieldTypeAsBoolean(aDoc, "bXBusyType", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(1))
		endif
		if (GetFieldTypeAsBoolean(aDoc, "bXRecurrencies", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(15))
		endif
		if (GetFieldTypeAsBoolean(aDoc, "bXReminders", bType)) then
			CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(16))
		endif
	endif

	if (GetFieldTypeAsBoolean(aDoc, "bXParticipants", bType)) then
		CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(13))
	endif
	
	'
	' Umbrueche wieder zulassen
	'
	SetCursorParaKeepTogether(aCrsr, FALSE)
	' aCrsr.Split = TRUE

	if (GetFieldTypeAsBoolean(aDoc, "bXLinks", bType)) then
		CreateHiddenParagraph(aDoc, aCrsr, aObj, sched_fieldnames$(11))
	endif

	if (GetFieldTypeAsBoolean(aDoc, "bXDescription", bType)) then
		aCrsr.CharStyle = TranslateStyle("ScheduleDetailDesc")
		aName = sched_fieldnames$(7)
		insertVariable(aDoc, aCrsr, aName, TRUE)
		Hidden(aDoc, aCrsr, aName)
		aTransName = GetTranslateName(aObj, aName)
		aDoc.Text.insertString(aCrsr, aTransName + ":", false)
		aDoc.Text.insertControlCharacter(aCrsr, 1, false)

		Hidden(aDoc, aCrsr, aName)
		aCrsr.CharStyle = TranslateStyle("ScheduleDetail")
		showVariable(aDoc, aCrsr, aName)
		aDoc.Text.insertString(aCrsr, " ", false)
		aDoc.Text.insertControlCharacter(aCrsr, 0, false)
	endif

	aDoc.Text.insertControlCharacter(aCrsr, 0, false)

End Sub
' ------------------------------------------------------------------------------
Sub SetCursorParaKeepTogether(aCrsr as Object, bValue as Boolean)
	' POST: Setzt KeepTogether am Cursor 
	' #62268# (Para)KeepTogether

	on local error goto keeptogether1
	aCrsr.ParaKeepTogether = bValue
	goto next1

keeptogether1:
	aCrsr.KeepTogether = bValue
next1:
	on local error goto 0
End Sub

