'SBLLINK:MethodInfo=SchedPrintMonth0
'SBLLINK:MethodInfo=PrintOneMonth0
'SBLLINK:MethodInfo=InsertTextInCell0
'SBLLINK:MethodInfo=GetTheMonth0
'SBLLINK:MethodInfo=CreateExampleEvent0
'SBLLINK:MethodInfo=GetUserNameFromCalendar0
' Drucken einer Monatsuebersicht
' OPTION EXPLICIT
' $Revision: 1.1.1.1 $
	
' --------------------------------------------------------------------------------
' Erstellen einer Monatsuebersicht
' --------------------------------------------------------------------------------
Sub SchedPrintMonth(aDoc as Object, aScheduleComponent as Object, aIndi as Object)
	' PRE: ScheduleUNOObject
	'      ScheduleView (Aktueller Termin)

	Dim aPrintContext as Object, aEventViewState as Object
	aPrintContext = aScheduleComponent.PrintContext
	aEventViewState = aPrintContext.EventViewState

	' Dim aPrintArea as Object
	Dim nDaysToPrint as Integer
	aPrintArea = aEventViewState.CurrentWeek 'ShownDays
	nDaysToPrint = uBound(aPrintArea) + 1

	Dim nIndicatorStep as Double, nIndicatorValue as Double

	if (NOT isnull(aIndi)) then
		aIndi.Value = 5
	endif
	Dim nTextRows as Integer, nTextCols as Integer

	nTextRows = getFieldType_TextRows(aDoc)
	nTextCols = getFieldType_TextColumns(aDoc)

	Dim nNumMonth as Integer
	nNumMonth = nTextRows * nTextCols

	Dim bAllDaysVisible as Boolean
	bAllDaysVisible = getFieldType_CheckAllDaysVisible(aDoc)
	
	Dim aWeekFoundOnPos%(nDaysToPrint)
	' Dim aYearToPrint%(nDaysToPrint)
	nFilled = 0
	Dim nDay as Integer, nMonth as Integer, nYear as Integer
	Dim nDay2 as Integer, nMonth2 as Integer, nYear2 as Integer
	Dim i as Integer, j as Integer, nPMonth as Integer
	Dim nKnownMonth as Integer, nSearchMonth as Integer
		
	Dim nLastMonth as Integer
	nLastMonth = -1

	' Tabelle erstellen, die die Monate enthaelt, die in der Ansicht zu sehen sind.
	' 
	for i = 0 to nDaysToPrint - 1 step 7
		' Nachsehen, ob Monat schon gedruckt werden soll.
		nDay = aPrintArea(i).Day()
		nMonth = aPrintArea(i).Month()
		nYear = aPrintArea(i).Year()
		
		bMonthIsAllreadyPrint = FALSE

		nSearchMonth = GetTheMonth(nDay, nMonth, nYear)
		' Workaround: 
		' Wir sind in der letzten Woche, die zu sehen/angewaehlt ist,
		' der 1. Tag dieser Woche gehrt noch zum letzten Monat,
		' der gefundene Monat ist der nchste Monat,
		' so soll dieser Monat nicht erscheinen/gedruckt werden.
		if (i + 7 = nDaysToPrint) then
			if (nMonth = nLastMonth) then
				nLastMonth = nLastMonth + 1
				if (nLastMonth > 12) then
					nLastMonth = 1
				endif
				if (nLastMonth = nSearchMonth) then
					nSearchMonth = nMonth
				endif
			endif
		endif
		nLastMonth = nMonth

		for j = 0 to nFilled - 1
			' if (aMonthToPrint%(j) = nPMonth) then
			' Pruefen, ob die Woche sich innerhalb eines von einer Monatsansicht
			' aufgespanntem Intervall befindet.

			nDay2   = aPrintArea(aWeekFoundOnPos%(j)).Day()
			nMonth2 = aPrintArea(aWeekFoundOnPos%(j)).Month()
			nYear2  = aPrintArea(aWeekFoundOnPos%(j)).Year()
			nKnownMonth = GetTheMonth(nDay2, nMonth2, nYear2)

			if (nKnownMonth = nSearchMonth) then
				bMonthIsAllreadyPrint = TRUE
				' Exit For (BUG !!!!!), springt aus der falschen Schleife.
			endif
		next
		if (bMonthIsAllreadyPrint = FALSE) then
			' aMonthToPrint%(nFilled) = nPMonth			  ' Monat und Jahr merken, 
			' aYearToPrint%(nFilled) = aPrintArea(i).Year() ' die gedruckt werden sollen.
			aWeekFoundOnPos%(nFilled) = i
			nFilled = nFilled + 1
		endif
	next

	' Wir pruefen nochmal, ob es 1, 2, 3 Monate sind, die ausgedruckt werden sollen.
	' if (nFilled <= 3) then
	' 	if (nDaysToPrint > 27) then ' evtl. Monatsansicht ==> nur einen Monat drucken
	' 	endif
	' endif

	nNumMonth = nFilled
	
	' -----------------------------------------------------
	' Suche des Monatsstarts, falls wir nicht am 1. eines Monats sind.
	' -----------------------------------------------------
	nDay = aEventViewState.CurrentWeek(0).Day
	nMonth = aEventViewState.CurrentWeek(0).Month
	nYear = aEventViewState.CurrentWeek(0).Year
	
	' -----------------------------------------------------
	' Sind wir in einer Wochenansicht, nicht an der 1. Woche des Monats, 
	' muessen wir uns an den Monatsanfang jugglen
	' -----------------------------------------------------
	Dim nDays as Long, nStartDays as Long, nEndDays as Long
	Dim nWeekCount as Long
	Dim aTempDocument as Object, sTempFile as String, sTemplateFile as String
	sTempFile = GetWorkPath() + GetPathSeparator() + "SSPrint.sdw"	
	'sTemplateFile = aDoc.DocumentInfo.TemplateFileName
	sTemplateFile = aDoc.getURL()

	nDays = DateSerial(nYear, nMonth, nDay)
	Dim aTempDoc as Object
	aTempDoc = aDoc
	nWeekCount = 0
		
	aDaysPerMonth = Array(0,31,28,31,30,31,30,31,31,30,31,30,31)
	
	aCrsr = aDoc.text.createTextCursor()
	for i = 1 to nNumMonth

		nDay = aEventViewState.CurrentWeek(aWeekFoundOnPos%(i-1)).Day
		nMonth = aEventViewState.CurrentWeek(aWeekFoundOnPos%(i-1)).Month
		nYear = aEventViewState.CurrentWeek(aWeekFoundOnPos%(i-1)).Year
		nDays = DateSerial(nYear, nMonth, nDay)

		nDay = Day(nDays)
		if (nDay > 1) then
			nDayPerMonth = aDaysPerMonth(nMonth) - 6
			while (nDay < nDayPerMonth and nDay > 1) ' NEW: 26 is the old Value
				nDays = nDays - 7
				nDay = Day(nDays)
			wend
		endif
		nStartDays = nDays
		nDays = nDays + 28
		nWeeks = 4

		'
		' Anzahl der Wochen zaehlen
		'
		nDay = Day(nDays)
		while nDay > 22
			nDays = nDays + 7
			nWeeks = nWeeks + 1
			nDay = Day(nDays)
		wend
		nEndDays = nDays - 1

		'
		' Den richtigen Monat suchen
		'
		nMonthDays = nStartDays
		nDay = Day(nMonthDays)
		while nDay > 22
			nMonthDays = nMonthDays + 1
			nDay = Day(nMonthDays)
		wend
		nMonth = Month(nMonthDays)
		nYear = Year(nMonthDays)

		' Dim sVon$, sBis$
		' sVon$ = DateSerial(Year(nStartDays), Month(nStartDays), Day(nStartDays))
		' sBis$ = DateSerial(Year(nEndDays), Month(nEndDays), Day(nEndDays))
		' msgbox "Drucke " + sVon$ + " bis " + sBis$ + _
		'	   " den Monat " + nMonth + "."

		if (i <> 1) then
			aTempDocument = documents.open( sTemplateFile, "", "h" )
			aTempDoc = aTempDocument.UNO
		endif

		nIndicatorValue = 10
		nIndicatorStep = ((100-10-10) / (nEndDays - nStartDays)) / nNumMonth
		
		PrintOneMonth(aTempDoc, aScheduleComponent, aIndi,_
						nStartDays, nEndDays, nWeeks, nMonth, nYear,_
						nTextRows, nTextCols,_
						bAllDaysVisible, _
						nIndicatorValue, nIndicatorStep,_
						FALSE)

		nDays = nStartDays + 7 * nWeeks

		if (i <> 1) then
			aTempDocument.SaveAs sTempFile              ' TempDokument abspeichern
			aTempDocument.Close(false, sTempFile)
			aCrsr.gotoEnd(FALSE)
' //! 
			' aCrsr.Text = " " ' \newpage
			aDoc.Text.insertControlCharacter(aCrsr,0, false)
			aCrsr.pagedescname = aCrsr.pagestyle
			aCrsr.gotoEnd(FALSE)

			aCrsr.insertDocumentFromURL(sTempFile, Array())	' am aktuellen Cursor anhaengen
			Wait(1)
			Kill ( sTempFile )							' Tempdokument schliessen
		endif
	next
End Sub

' --------------------------------------------------------------------------------
' Erstellen einer Monatsuebersicht eines Monats
' --------------------------------------------------------------------------------

Sub PrintOneMonth(aDoc as Object, _
				  aScheduleComponent as Object, aIndi as Object, _
				  nStartDays as Date, nEndDays as Date, nWeeks as Integer, _
				  nMonth as Integer, nYear as Integer, _
				  nTextRows as Integer, nTextColumns as Integer, _
				  bAllDaysVisible as Boolean, _
				  nIndicatorValue as Double, nIndicatorStep as Double,_
				  bCreateMode as Boolean)

	Dim aCrsr as Object, aCell as Object
	Dim aDocPagestyle as Object, sPageStyleName$

	aCrsr = aDoc.text.createTextCursor
	sPageStyleName$ = aCrsr.pageStyle
	aDocPagestyle = aDoc.StyleFamilies.getByName("PageStyles").getByName(spageStyleName$)

	' Alles was im Dokument steht markieren und ueberschreiben
	ClearDocument(aDoc)
	
	' Monat, Jahr als Kapitelueberschrift eintragen, es ist die einzige
	' Moeglichkeit auf jeder Seite eine andere Kopfzeile darzustellen.
	
	Dim sTempStr as String
	sTempStr = Sched_Month$(nMonth) + " " + nYear
	ChapterTitle(aDoc, aCrsr, sTempStr)

	' -----------------------------------------------------
	' Tabelle erstellen
	' -----------------------------------------------------
	Dim aTables as Object
	Dim aCellCrsr as Object
	Dim aCrsr2 as Object

	aCrsr2 = aDoc.text.start
	aCrsr2.gotoEnd(false)
	aTables = aDoc.createinstance("com.sun.star.text.TextTable")
	aTables.initialize(nWeeks * 2 + 1, 7)
	' aTables.attach(aCrsr2)
	aCrsr2.Text.insertTextContent(aCrsr2, aTables, FALSE)

	aCell = aTables.getCellByName("A2")
	aCellCrsr = aCell.createTextCursor
	
	' Letzte Zeile unterdrueckt eine Leere Seite
	aCrsr.ParaStyle = TranslateStyle("ScheduleTask")
	InsertLastLine(aDoc, aCrsr)

	' -----------------------------------------------------
	' Informationen, die am Dokument gespeichert wurden
	' -----------------------------------------------------
	Dim bAMPM as Boolean
	Dim bStartTimeOnly as Boolean
	Dim bFixTableHeight as Boolean
	Dim bCheckLocation as Boolean
	Dim sPoint as String

	bAMPM           = getFieldType_AMPM(aDoc)
	bStartTimeOnly  = getFieldType_StartTimeOnly(aDoc)
	bFixTableHeight = getFieldType_FixTableHeight(aDoc)
	bCheckLocation  = getFieldType_CheckLocation(aDoc)
	sPoint          = getFieldType_DayEventPoint(aDoc)

	' -----------------------------------------------------
	' Kopf und Fusszeile erstellen
	' -----------------------------------------------------
	if (bCreateMode) then
		FillHeadAndFoot(aDoc, 4, nDays, nMonth, nYear,"")
	else
		FillHeadAndFoot(aDoc, 4, nDays, nMonth, nYear,GetUserNameFromCalendar(aScheduleComponent))
	endif
	' -----------------------------------------------------
	' Noch bedruckbare hoehe berechnen
	' -----------------------------------------------------

	Dim nPageHeight as Long
	nPageHeight = calcPageHeight(aDocPageStyle, aDoc)

	' -----------------------------------------------------
	' Einstellen der Tabellenhoehe
	' -----------------------------------------------------
	' alle Tabellenzeilen mit der selben hoehe initialisieren
	Dim aRow as Object
	Dim i as Integer
	for i = 0 to (nWeeks * 2 + 1) - 1
		aRow = aTables.rows.getByIndex(i)
		aRow.Height = getFieldType_TitleHeight(aDoc)
		aRow.SizeType = 1			' Tabellenhoehe fest
	next

	' Hoehe der Datentragenden Zeilen berechnen
	Dim nHeight as Double
	nHeight = (nPageHeight - ((1 + nWeeks) * aRow.Height)) / nWeeks

	' Hoehe der Datentragenden Zeilen setzen
	for i = 2 to nWeeks * 2 + 1 step 2
		aRow = aTables.rows.getByIndex(i)
		aRow.Height = nHeight
		if (bFixTableHeight = FALSE) then
			aRow.SizeType = 2       ' Tabellenhoehe mindestens Height
		endif
	next

	' -----------------------------------------------------
	' Die Wochentagnamen in die Tabelle eintragen
	' -----------------------------------------------------

	Dim nDayOfWeek as Integer, nWeek as Integer
	Dim sWeekDayName$
	Dim aTableCrsr as Object
	Dim nValue as Double
	
	nDayOfWeek = 0
	nWeek      = 0
	aCell = aTables.getCellByName(IndexToString(nDayOfWeek, 0))
	aCellCrsr = aCell.createTextCursor

	Dim isWeekEnd as Boolean
	for nDay = nStartDays to nStartDays + 6
		aCell = aTables.getCellByName(IndexToString(nDayOfWeek, 0))
		aCellCrsr = aCell.createTextCursor
		if (WeekDay(nDay) = 1 or WeekDay(nDay) = 7) then
			isWeekEnd = TRUE
		else
			isWeekEnd = FALSE
		endif
		aCellCrsr.ParaStyle = TranslateStyle("ScheduleWeekdayTitle")
		nDayOfWeek = nDayOfWeek + 1
		sWeekDayName$ = TranslateWeekDay(WeekDay(nDay))
		aCell.insertString(aCellCrsr, sWeekDayName$, false)
	next
	
	' -----------------------------------------------------
	' Die Tabelle mit Daten der einzelnen Tage fuellen
	' -----------------------------------------------------
	nDayOfWeek = 0
	Dim sParaStr$
	
	for nDay = nStartDays to nEndDays
		' Indicator setzen
		if (NOT isnull(aIndi)) then
			aIndi.Value = nIndicatorValue
			nIndicatorValue = nIndicatorValue + nIndicatorStep
		endif
		
		if (WeekDay(nDay) = 1 or WeekDay(nDay) = 7) then
			isWeekEnd = TRUE
		else
			isWeekEnd = FALSE
		endif

		aCell = aTables.getCellByName(IndexToString(nDayOfWeek, (nWeek * 2) + 1))
		aCellCrsr = aCell.createTextCursor
		
		' Wir setzen den CellBackground auf die Farbe, die im ParaStyle eingestellt ist
		' so verhindert man unschoene Raender.
		Dim nColor as Long
		if (Month(nDay) = nMonth) then
			if (isWeekEnd = FALSE) then
				aCellCrsr.ParaStyle = TranslateStyle("ScheduleWeekdayNumber")
				if (aCellCrsr.ParaBackTransparent = FALSE) then
					nColor = aCellCrsr.ParaBackColor
					aCell.backtransparent = FALSE
					aCell.BackColor = nColor
				endif
			else
				aCellCrsr.ParaStyle = TranslateStyle("ScheduleWeekendNumber")
				if (aCellCrsr.ParaBackTransparent = FALSE) then
					nColor = aCellCrsr.ParaBackColor
					aCell.backtransparent = FALSE
					aCell.BackColor = nColor
				endif
			endif
		else
			sParaStr$ = TranslateStyle("ScheduleOtherMonthNumber")
			aCellCrsr.ParaStyle = sParaStr$
			if (aCellCrsr.ParaBackTransparent = FALSE) then
				nColor = aCellCrsr.ParaBackColor
				aCell.backtransparent = FALSE
				aCell.BackColor = nColor
			endif
		endif

'		sParaStr$ = aCellCrsr.ParaStyle

		' aCellCrsr = aCell.createTextCursor
		' aCellCrsr.CharWeight = 8
		' aCellCrsr.ParaAdjust = 3
		' nValue = 11 * 35
		' aCellCrsr.CharHeight = nValue
		if (Month(nDay) = nMonth or bAllDaysVisible = TRUE) then
			aCell.insertString(aCellCrsr, Day(nDay), false)
		endif

		aCell = aTables.getCellByName(IndexToString(nDayOfWeek, (nWeek * 2) + 2))
		' aCell.text = "Week " + nWeek + " Day " + nDayOfWeek

		if (bCreateMode = TRUE) then
			
			'//! Hier den Beispieltag einsetzen, der gefuellt wird.
			if (WeekDay(nDay) = 2 and Day(nDay) < 8) then   ' Montag
				CreateExampleEvent(aDoc, aCell, nDay )
			endif
			if (WeekDay(nDay) = 7 and Day(nDay) < 8) then    ' Samstag
				CreateExampleEvent(aDoc, aCell, nDay )
			endif
		else
			if (Month(nDay) = nMonth or bAllDaysVisible = TRUE) then
				InsertTextInCell(aDoc, aCell, aScheduleComponent, nDay,_
								 bAMPM, bStartTimeOnly, bCheckLocation, _
								 sPoint)
			endif
		endif

		nDayOfWeek = nDayOfWeek + 1			' Counter fuer Positionierung
		if (nDayOfWeek = 7) then
			nDayOfWeek = 0
			nWeek = nWeek + 1
		endif
	next
End Sub

' --------------------------------------------------------------------------------
' Daten eines Tages in eine Celle eintragen
' --------------------------------------------------------------------------------
Sub InsertTextInCell(aDoc as Object, aCell as Object, aScheduleComponent as Object, nDays as Long, _
					 bAMPM as Boolean, bStartTimeOnly as Boolean, bCheckLocation as Boolean, _
					 sPoint as String)

	' Filter und Cursor von StarSchedule erstellen bzw. holen
	' Dim aNames(0 to 4) as String
	aNames = Array("Title", "StartDate", "EndDate", "DayEvent", "Location")

	Dim aConfig as Object, aEventConfig as Object
	Dim aPrintContext as Object
	Dim nValue as Double
	
	aConfig = aScheduleComponent.Configuration

	aEventCursorDescriptor = aConfig.EventCursorDescriptor.createClone
	aEventCursorDescriptor.ContainerType = "Recurring.Client.Rights.Events" ' Alle Instanzen von Wiederholungsterminen zeigen

	aEventCursorDescriptor.PropertyNames = aNames

	aEventCursorDescriptor.Grouping.Clear

	Dim aSort as Object, aFilter as Object
	Dim aTempDate as New com.sun.star.util.DateTime

	aSort = aEventCursorDescriptor.Sorting.insertNewByIndex(0)
	aSort.PropertyName = "DayEvent"
	aSort.Ascending = FALSE
	aSort = aEventCursorDescriptor.Sorting.insertNewByIndex(1)
	aSort.PropertyName = "StartDate"
	aSort = aEventCursorDescriptor.Sorting.insertNewByIndex(2)
	aSort.PropertyName = "Title"

	' 00:00:00 < StartDate
	aTempDate.Day   = Day(nDays + 1)
	aTempDate.Month = Month(nDays + 1)
	aTempDate.Year  = Year(nDays + 1)
	aTempDate.Hours	 = 0
	aTempDate.Minutes = 0
	aTempDate.Seconds = 0
	aTempDate.HundredthSeconds = 0

	aFilter = aEventCursorDescriptor.Filter.insertNewByIndex(0)
	aFilter.PropertyName = "StartDate"
 	aFilter.Value = aTempDate
	aFilter.Operator = _scheduleOperator_LOWER ' com.sun.star.schedule.ScheduleQueryOperator.LOWER

	' 0:00:00 NextDay > EndDate
	aTempDate.Day   = Day(nDays)
	aTempDate.Month = Month(nDays)
	aTempDate.Year  = Year(nDays)
	aTempDate.Hours	 = 0
	aTempDate.Minutes = 0
	aTempDate.Seconds = 0
	aTempDate.HundredthSeconds = 0
	
	aFilter = aEventCursorDescriptor.Filter.insertNewByIndex(1)
	aFilter.PropertyName = "EndDate"
	aFilter.Value = aTempDate
	aFilter.Operator = _scheduleOperator_GREATER ' com.sun.star.schedule.ScheduleQueryOperator.GREATER

	Dim aSession as Object
	aSession = aScheduleComponent.Session

	Dim aCursor as Object
	aCursor = aSession.createCursor( aEventCursorDescriptor, _scheduleCursorType_SNAPSHOT )
	
	' Anzahl der Eintraege
	' aCursor.RecordCount
	Dim aStartDate as Object, aEndDate as Object
	Dim aPrintDate as Date, sStartTime as String, sEndTime as String
	Dim aCellCrsr as Object
	
	aCellCrsr = aCell.createTextCursor

	' Aussehen der Tabelle manipulieren.
	' -----------------------------------------------------
	' PageStyle fuer die Tabelle komplett einstellen
	' !!! GEHT NICHT !!!
	' Deshalb muessen wir fuer jede Celle die PageStyle einstellen
	' -----------------------------------------------------

	aCellCrsr.ParaLeftMargin = 212
	aCellCrsr.ParaFirstLineIndent = -212
	aCellCrsr.ParaBottomMargin = 0
	aCellCrsr.ParaTopMargin = 0

	' DayEvents werden zuerst ausgegeben, soz. am Anfang der Tabelle
	aCursor.MoveToFirst()
	while aCursor.isValid
	' For nCount% = 0 to (aCursor.RecordCount - 1)
	' aCursor.moveToRecord( nCount% )
		If (aCursor.DayEvent = TRUE) then
			sLocation = ""
			if (aCursor.Location <> "" and bCheckLocation = TRUE) Then
				sLocation = aCursor.Location
			EndIf
			SetDayEvent(aCell, aCellCrsr, aCursor.Title, sLocation, sPoint)
		Endif
		aCursor.moveRelative( 1 )
	Wend
	
	aCellCrsr2 = aCell.createTextCursor
	aCellCrsr2.gotoEnd(FALSE)

	' Ausgabe der normalen Termine
	Dim nFormatKey as Long

	aCursor.MoveToFirst()
	while aCursor.isValid
		If aCursor.DayEvent = FALSE then
			'
			' 00:00 - 01:00
			'
			aStartDate = aCursor.StartDate
			aEndDate = aCursor.EndDate

			' Formatkey besorgen aus dem Dokument
			sStartTime = GetTimeAsString(aDoc, aStartDate)
			
			if (bStartTimeOnly = FALSE) then
				sEndTime = GetTimeAsString(aDoc, aEndDate)
			endif
			
			' aCellCrsr.CharPosture = 0       ' Normal (nicht kursiv)
			' aCellCrsr.gotoEnd(FALSE)

			' oldheight = aCellCrsr.CharHeight

			' nValue = 8 * 35
			' aCellCrsr.CharHeight = nValue
			' oldWeight = aCellCrsr.CharWeight
			' aCellCrsr.CharWeight = 8

			sTime = sStartTime
			if (bStartTimeOnly = FALSE) then
				sTime = sTime + " - " + sEndTime
			endif
			sLocation = ""
			if (aCursor.Location <> "" and bCheckLocation = TRUE) Then
				sLocation = aCursor.Location
			EndIf
			SetEvent(aCell, aCellCrsr2, sTime, aCursor.Title, sLocation)
		Endif
		aCursor.MoveRelative(1)
	Wend
End Sub
' ------------------------------------------------------------------------------
Function GetTheMonth(ByVal nDay as Integer, ByVal nMonth as Integer, ByVal nYear as Integer) as Integer
	' POST: Liefert den Monat, der fuer diesen Tag ausgedruckt werden sollte.
	Dim nDays as Long, nStartDays as Long, nWeeks as Integer
	Dim nEndDays as Long, nMonthDays as Long
		
	nDays = DateSerial(nYear, nMonth, nDay)
	aDaysPerMonth = Array(0,31,28,31,30,31,30,31,31,30,31,30,31)

	' An den Anfang des Monats (Wochenweise gesehen.)
	nDay = Day(nDays)
	if (nDay > 1) then
		nDayPerMonth = aDaysPerMonth(nMonth) - 6
		while (nDay < nDayPerMonth and nDay > 1)
			nDays = nDays - 7
			nDay = Day(nDays)
		wend
	endif
	nStartDays = nDays
	nDays = nDays + 28
	nWeeks = 4
	'
	' Anzahl der Wochen zaehlen
	'
	nDay = Day(nDays)
	while nDay > 22
		nDays = nDays + 7
		nWeeks = nWeeks + 1
		nDay = Day(nDays)
	wend
	nEndDays = nDays - 1
	'
	' Den richtigen Monat suchen
	'
	nMonthDays = nStartDays
	nDay = Day(nMonthDays)
	while nDay > 22
		nMonthDays = nMonthDays + 1
		nDay = Day(nMonthDays)
	wend
	GetTheMonth = Month(nMonthDays)
end Function
' ------------------------------------------------------------------------------
Sub CreateExampleEvent(aDoc as Object, aCell as Object, nDay as Long)

	Dim aCellCrsr as Object
	aCellCrsr = aCell.createTextCursor

	' Aussehen der Tabelle manipulieren.
	' -----------------------------------------------------
	' PageStyle fuer die Tabelle komplett einstellen
	' !!! GEHT NICHT !!!
	' Deshalb muessen wir fuer jede Celle die PageStyle einstellen
	' -----------------------------------------------------

	aCellCrsr.ParaLeftMargin = 212
	aCellCrsr.ParaFirstLineIndent = -212
	aCellCrsr.ParaBottomMargin = 0
	aCellCrsr.ParaTopMargin = 0

	Dim sLocation as String
	Dim sDayEvent as String

	if (WeekDay(nDay) = 1 or WeekDay(nDay) = 7) then
		sLocation = ""
		sDayEvent = Sched_TemplateExample2$ ' "Wochenende"
	else
		sLocation = Sched_TemplateLocation$ ' "Ein Ort"
		sDayEvent = Sched_TemplateExample1$ ' "Tagestermin"
	endif
	SetDayEvent(aCell, aCellCrsr, sDayEvent, sLocation, chr$(149))

	Dim sTime as String
	Dim sTitle as String
		
	if (WeekDay(nDay) > 1 and WeekDay(nDay) < 6) then
		sTime = "07:00 - 09:30"
		sTitle = Sched_TemplateExample1$ ' "Beispieltermin"
		SetEvent(aCell, aCellCrsr, sTime, sTitle, sLocation)

		sTime = "12:00 - 12:30"
		sLocation = ""
		sTitle = Sched_TemplateExample2$ ' "Mittagessen mit Freunden"
		SetEvent(aCell, aCellCrsr, sTime, sTitle, sLocation)

		' sTime = "21:45 - 22:15"
		' sTitle = "Heute Journal, alles wichtige vom Tage"
		' SetEvent(aCell, aCellCrsr, sTime, sTitle, sLocation)
	endif
End Sub
' ------------------------------------------------------------------------------
Function GetUserNameFromCalendar(aScheduleComponent as Object) as String
	' POST: Aus der Componente den Calendarnamen extrahieren

	Dim aConfig as Object, aSession as Object
	aConfig = aScheduleComponent.Configuration
	aSession    = aScheduleComponent.Session

	' Dim aNames (0 to 0) as String
	
	aNames = Array("Name")
	Dim aCursorDescriptor as Object
	aCursorDescriptor = aConfig.EventCursorDescriptor.createClone
	aCursorDescriptor.ContainerType = "Rights.Resources"
	aCursorDescriptor.PropertyNames = aNames
			
	Dim aContainerUid as String
	aContainerUid = aCursorDescriptor.ContainerUid
	Dim aFilter as Object
	aFilter = aCursorDescriptor.Filter.insertNewByIndex(0)
	aFilter.PropertyName = "Uid"
 	aFilter.Value = aContainerUid
	aFilter.Operator = _scheduleOperator_EQUAL
	
	Dim aCursor as Object
	aCursor = aSession.createCursor( aCursorDescriptor, _scheduleCursorType_SNAPSHOT )

	aCursor.MoveToFirst()
	if aCursor.isvalid() then
		GetUserNameFromCalendar = aCursor.Name
	endif
End Function
