'SBLLINK:MethodInfo=ReadDirectories0
'SBLLINK:MethodInfo=ShowMetaData0
'SBLLINK:MethodInfo=AddDBElementstoList0
'SBLLINK:MethodInfo=AddFoldertoList0
'SBLLINK:MethodInfo=RunRecursiveConversion0
'SBLLINK:MethodInfo=LoopOverDocuments0
'SBLLINK:MethodInfo=RetrieveDocTitle0
'SBLLINK:MethodInfo=GetRealFileContent0
'SBLLINK:MethodInfo=Main0
'Option explicit
Public oDocument
Public ExecDone as Boolean
Dim sFileArray(2000,1)
Public Chaos as Object
Dim FolderAnchor as Object
Dim oDocInfo as object
Dim oEngine as Object
Dim sDirArray(200)
Dim iDirPointer As Integer
Dim iDirCount as Integer

Sub Main()
Dim LocsfileContent(0) as String
	LocsfileContent(0) = "*"
	ReadDirectories("file:///space", LocsfileContent(), True, False, false)
End Sub


' Prozedur, die die rekursive Auslesefunktion anwirft

Function ReadDirectories(ByVal AnchorDir As String, sFileContent(), bRecursive, bcheckFileType, bGetByTitle As Boolean)

Dim i as integer
Dim AddFile as Boolean
Dim Status as Object
Dim FileCount As Integer
Dim FileCountinDir as Integer
Dim RealFileContent as String
Dim FileName as string
Dim bTitleDefined as Boolean
Dim oUcbObject as Object
Dim DirContent()

	bTitleDefined = False
	' Initialisierung des Verzeichnisarrays
	sFileArray(0,0) = 0
	iDirPointer = 1
	sDirArray(0) = 0
	iDirCount = 1
  ' Todo: Is the last separator valid?
	sDirArray( iDirCount ) = AnchorDir '& "/"
	oDocInfo = CreateUnoService("com.sun.star.document.StandaloneDocumentInfo")
	oUcbObject = createUnoService("com.sun.star.ucb.SimpleFileAccess")
	Do
		AnchorDir = sDirArray(iDirPointer)
		DirContent() = oUcbObject.GetFolderContents(AnchorDir,True)

		If Ubound(DirContent()) <> -1 Then
			FileCountinDir = Ubound(DirContent())+ 1
			For i = 0 to FilecountinDir -1
				Filename = DirContent(i)
				sContentType = oUcbObject.GetContentType(FileName)
				If oUcbObject.IsFolder(FileName) Then
					If brecursive Then
						AddFoldertoList(FileName)
					ElseIf sContentType = "application/sbase" Then
						If FieldinArray(sFileContent(), Ubound(sFileContent),"application/sbase") Then
							' retrieve the Metadata of a Database
							ShowMetaData(sFileArray(), FileName, FileCount)
						End If
					End If
				Else
					AddFile  = False
					If bcheckFileType Then
						RealFileContent  = GetRealFileContent(oDocInfo, FileName)
						If RealFileContent <> "" Then
							AddFile = True
						End If
					Else
						RealFileContent = sContentType
						AddFile = True
					End If

					If AddFile Then
						' Retrieve the Index in the Array, where a Filename is positioned
						FileCount = cInt( sFileArray( 0, 0 ) )

						If (FieldinArray(sFileContent(), Ubound(sFileContent),RealFileContent)) OR (sFileContent(0) = "*") Then
							' The extension of the current file passes the filter and is therefor admitted to the
							' fileList
							FileCount = FileCount + 1
							If bGetByTitle Then
								If Not bTitleDefined Then
									Dim sTitleArray(100,1)
									bTitleDefined = True
								End If
								' Add the documenttitles to the Filearray
								sTitleArray(FileCount,0) = FileName
								sTitleArray(FileCount,1) = RetrieveDocTitle(oDocInfo, FileName)
								sTitleArray(0,0) = cStr(FileCount)
							Else
								sFileArray( FileCount,0) = FileName
							End If
							sFileArray( FileCount,1) = RealFileContent
							sFileArray(0,0) = cStr(FileCount)
						End If
					End If
				End If
			Next i
		End If
	iDirPointer = iDirPointer + 1
	Loop Until iDirPointer > cInt(sDirArray(0))

	If bGetbyTitle Then
		ReadDirectories = sTitleArray()
	Else
		ReadDirectories = sFileArray() 'iDirPointer
	End If
End Function



Sub ShowMetaData(sFileArray(), FilePath as String, fileCount as integer)
Dim i,n as integer
Dim LocArray(100) as String
Dim CurTable, CurForm, CurReport, CurQuery as String
Dim URLList() as String
Dim MaxArrIndex as integer
Dim DatabaseName as String

	' create the Database engine that handles all Data concerning Database interaction
	If IsNull(oEngine) Then
		oEngine = createUnoService("stardiv.one.data.DatabaseEngine")
	End If

	URLList() = ArrayoutofString(FilePath,"/",MaxArrIndex)
	DatabaseName = URLList(MaxArrIndex)
	On Local Error Resume Next
	oDatabase =  oEngine.Workspaces(0).open(FilePath)
	If Err <> 0 Then
		Msgbox " Cannot open Database " & FilePath
	End If
	On Local Error Goto 0
	FileCount = AddDBElementstoList(oDatabase.Queries.createEnumeration, FilePath, "Query", FileCount, sFileArray())
	FileCount = AddDBElementstoList(oDatabase.Forms.createEnumeration, FilePath, "Form", FileCount, sFileArray())
	FileCount = AddDBElementstoList(oDatabase.Tables.createEnumeration, FilePath, "Table", FileCount, sFileArray())
	FileCount = AddDBElementstoList(oDatabase.Reports.createEnumeration, FilePath, "Report", FileCount, sFileArray())

	' Add a notification about the highest index of the Array
	sFileArray(0,0) = cStr( FileCount )
	oEngine.Dispose()
End Sub



Function AddDBElementstoList(oDBEnum as Object, FilePath, sObjectDescr, sFileArray() as String, ByVal FileCount as Integer)
	While oDBEnum.hasmoreElements
		FileCount = FileCount + 1
		sfileArray(FileCount,0) = FilePath & "#db:" & sObjectDescr & ";" & oDBEnum.NextElement.Name
		sfileArray(FileCount,1) = "application/sbase"
	Wend
	AddElementsToList() = FileCount
End Function


Sub AddFoldertoList(sDirURL as String)
	iDirCount = iDirCount + 1
	sDirArray(0) = iDirCount
	sDirArray(iDirCount) = sDirURL
End Sub



Sub RunRecursiveConversion(oDesktop as Object, sFilterName(), Sourcepath, TargetStemDir as String, ConvertMode as Integer, bRecursive, bcheckFileType as Boolean)
Dim SourceFileName as String
Dim AnchorDir as String
Dim oUcbObject as Object
	'	sFilterName = "application/vnd.stardivision.calc"
	'	sFilterName = "application/x-starcalc"
	'	sFilterName = "application/vnd.stardivision.template"
	'Resolve the paths if necessary (" e.g. "FILE:///{...}")
	SourcePath = RetrievePath(SourcePath)
	TargetStemDir = RetrievePath(TargetStemDir)

	TargetStemDir = ConverttoURL(TargetStemDir)
	SourcePath = ConverttoURL(SourcePath)
	oUcbObject = createUnoService("com.sun.star.ucb.SimpleFileAccess")

	If Not oUcbObject.IsFolder(SourcePath) Then
		' a sole document has been selected
		sFileArray(0,0) = "1"
		sFileArray(1,0) = ConverttoURL(SourcePath)
		' extract the filename out of the path
		SourceFileName = FileNameoutofPath(SourcePath,"/")

		' extract the Directoryname out of the path
		SourcePath = DeleteStr(Sourcepath,"/" & SourceFileName)
	Else
		' a directory has been selected
		Call ReadDirectories( Sourcepath, sFilterName(),  bRecursive, bcheckFileType, False )
	End If

	LoopOverDocuments(oDesktop, TargetStemDir, SourcePath, ConvertMode, 1 )
End Sub



Sub LoopOverDocuments(oDesktop as Object, TargetStemDir, AnchorDir as String, ConvertMode, DocuIndex as Integer)
Dim i as Integer
Dim NoArgs()
Dim TargetFile as String
Dim TargetDir as String
Dim TargetFileName as String
Dim iFileCount as Integer

	iFileCount = Int(sFileArray(0,0))
	For i = DocuIndex To iFilecount
		If TargetStemDir <> "file:///" Then
			TargetFile= ReplaceString(sFileArray(i,0),TargetStemDir,AnchorDir)

			' extract the filename out of the path
			TargetFileName = FileNameoutofPath(TargetFile,"/")

			' extract the Directoryname out of the path
			TargetDir = DeleteStr(TargetFile,"/" & TargetFileName)

			If Dir(TargetDir,16) = "" Then
				MkDir TargetDir
			End If
		End If
		Select Case ConvertMode
			Case 1
				' Euro-Converter
		        GoOn = ConvertFile(sFileArray(i,0),TargetFile, sFileArray(0,0)
			Case 2
				' New Spelling
				GoOn = RunNewSpelling(0,sFileArray(i,0),TargetFile, True)
			Case 3
				' Inhouse - tool
				SwitchtoCurStep2(sFileArray())
				exit Sub
		End Select

		If Not GoOn Then
			Exit For
		End If
	Next i
End Sub


Function RetrieveDocTitle(oDocInfo as Object, sFileName as String) As String
Dim sDocTitle as String
	On Local Error Goto NOFILE
	oDocInfo.loadFromURL(sFileName)
	sDocTitle = oDocInfo.Title
	
	NOFILE:
	If Err <> 0 Then
		GetRealFileContent = ""
		resume CLR_ERROR
	End If
	CLR_ERROR:
	If sDocTitle = "" Then
		sDocTitle = Left$(sFileName, (Len(sFileName)-4))
	End If
	RetrieveDocTitle = sDocTitle
End Function


' Retrieves The Filecontent of a Document by extracting the content
' from the Header of the document
Function GetRealFileContent(oDocInfo as Object, FileName as String) As String		
	On Local Error Goto NOFILE
	oDocInfo.loadFromURL(FileName)
	GetRealFileContent = oDocInfo.MIMEType
	NOFILE:
	If Err <> 0 Then
		GetRealFileContent = ""
		resume CLR_ERROR
	End If
	CLR_ERROR:
End Function

